/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Pe=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/errors","vs/base/common/strings","vs/base/common/network","vs/base/common/async","vs/platform/log/common/log","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/path","vs/base/common/platform","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/base/common/severity","vs/workbench/api/common/extHostCommands","vs/base/common/glob","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/lazy","vs/base/common/themables","vs/base/common/extpath","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/common/htmlContent","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/core/position","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/arraysFind","vs/workbench/api/worker/extensionHostWorker"],Ae=function(we){for(var e=[],y=0,T=we.length;y<T;y++)e[y]=Pe[we[y]];return e};define(Pe[66],Ae([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ph=e.$oh=e.$nh=void 0;function y(A){return($,E,f)=>{let C=null,D=null;if(typeof f.value=="function"?(C="value",D=f.value):typeof f.get=="function"&&(C="get",D=f.get),!D)throw new Error("not supported");f[C]=A(D,E)}}function T(A,$,E){let f=null,C=null;if(typeof E.value=="function"?(f="value",C=E.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(f="get",C=E.get),!C)throw new Error("not supported");const D=`$memoize$${$}`;E[f]=function(...u){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,u)}),this[D]}}e.$nh=T;function P(A,$,E){return y((f,C)=>{const D=`$debounce$${C}`,u=`$debounce$result$${C}`;return function(...b){this[u]||(this[u]=E?E():void 0),clearTimeout(this[D]),$&&(this[u]=$(this[u],...b),b=[this[u]]),this[D]=setTimeout(()=>{f.apply(this,b),this[u]=E?E():void 0},A)}})}e.$oh=P;function M(A,$,E){return y((f,C)=>{const D=`$throttle$timer$${C}`,u=`$throttle$result$${C}`,b=`$throttle$lastRun$${C}`,v=`$throttle$pending$${C}`;return function(...g){if(this[u]||(this[u]=E?E():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),$&&(this[u]=$(this[u],...g)),this[v])return;const t=this[b]+A;t<=Date.now()?(this[b]=Date.now(),f.apply(this,[this[u]]),this[u]=E?E():void 0):(this[v]=!0,this[D]=setTimeout(()=>{this[v]=!1,this[b]=Date.now(),f.apply(this,[this[u]]),this[u]=E?E():void 0},t-Date.now()))}})}e.$ph=M}),define(Pe[89],Ae([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GM=e.$FM=void 0;class y{constructor(P){this.a=P,this.b=0}nextId(){return this.a+ ++this.b}}e.$FM=y,e.$GM=new y("id#")}),define(Pe[119],Ae([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var y;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(y||(e.ScanError=y={}));var T;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(T||(e.SyntaxKind=T={}));var P;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var M;(function(n){n.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function A(n,s=!1){let a=0;const d=n.length;let p="",m=0,S=16,k=0;function h(R){let L=0,O=0;for(;L<R;){const Y=n.charCodeAt(a);if(Y>=48&&Y<=57)O=O*16+Y-48;else if(Y>=65&&Y<=70)O=O*16+Y-65+10;else if(Y>=97&&Y<=102)O=O*16+Y-97+10;else break;a++,L++}return L<R&&(O=-1),O}function w(R){a=R,p="",m=0,S=16,k=0}function I(){const R=a;if(n.charCodeAt(a)===48)a++;else for(a++;a<n.length&&f(n.charCodeAt(a));)a++;if(a<n.length&&n.charCodeAt(a)===46)if(a++,a<n.length&&f(n.charCodeAt(a)))for(a++;a<n.length&&f(n.charCodeAt(a));)a++;else return k=3,n.substring(R,a);let L=a;if(a<n.length&&(n.charCodeAt(a)===69||n.charCodeAt(a)===101))if(a++,(a<n.length&&n.charCodeAt(a)===43||n.charCodeAt(a)===45)&&a++,a<n.length&&f(n.charCodeAt(a))){for(a++;a<n.length&&f(n.charCodeAt(a));)a++;L=a}else k=3;return n.substring(R,L)}function F(){let R="",L=a;for(;;){if(a>=d){R+=n.substring(L,a),k=2;break}const O=n.charCodeAt(a);if(O===34){R+=n.substring(L,a),a++;break}if(O===92){if(R+=n.substring(L,a),a++,a>=d){k=2;break}switch(n.charCodeAt(a++)){case 34:R+='"';break;case 92:R+="\\";break;case 47:R+="/";break;case 98:R+="\b";break;case 102:R+="\f";break;case 110:R+=`
`;break;case 114:R+="\r";break;case 116:R+="	";break;case 117:{const he=h(4);he>=0?R+=String.fromCharCode(he):k=4;break}default:k=5}L=a;continue}if(O>=0&&O<=31)if(E(O)){R+=n.substring(L,a),k=2;break}else k=6;a++}return R}function V(){if(p="",k=0,m=a,a>=d)return m=d,S=17;let R=n.charCodeAt(a);if($(R)){do a++,p+=String.fromCharCode(R),R=n.charCodeAt(a);while($(R));return S=15}if(E(R))return a++,p+=String.fromCharCode(R),R===13&&n.charCodeAt(a)===10&&(a++,p+=`
`),S=14;switch(R){case 123:return a++,S=1;case 125:return a++,S=2;case 91:return a++,S=3;case 93:return a++,S=4;case 58:return a++,S=6;case 44:return a++,S=5;case 34:return a++,p=F(),S=10;case 47:{const L=a-1;if(n.charCodeAt(a+1)===47){for(a+=2;a<d&&!E(n.charCodeAt(a));)a++;return p=n.substring(L,a),S=12}if(n.charCodeAt(a+1)===42){a+=2;const O=d-1;let Y=!1;for(;a<O;){if(n.charCodeAt(a)===42&&n.charCodeAt(a+1)===47){a+=2,Y=!0;break}a++}return Y||(a++,k=1),p=n.substring(L,a),S=13}return p+=String.fromCharCode(R),a++,S=16}case 45:if(p+=String.fromCharCode(R),a++,a===d||!f(n.charCodeAt(a)))return S=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return p+=I(),S=11;default:for(;a<d&&Z(R);)a++,R=n.charCodeAt(a);if(m!==a){switch(p=n.substring(m,a),p){case"true":return S=8;case"false":return S=9;case"null":return S=7}return S=16}return p+=String.fromCharCode(R),a++,S=16}}function Z(R){if($(R)||E(R))return!1;switch(R){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function N(){let R;do R=V();while(R>=12&&R<=15);return R}return{setPosition:w,getPosition:()=>a,scan:s?N:V,getToken:()=>S,getTokenValue:()=>p,getTokenOffset:()=>m,getTokenLength:()=>a-m,getTokenError:()=>k}}e.$1m=A;function $(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function E(n){return n===10||n===13||n===8232||n===8233}function f(n){return n>=48&&n<=57}var C;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(C||(C={}));function D(n,s){const a=[],d=new Object;let p;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function k(h,w,I,F){m.value=h,m.offset=w,m.length=I,m.type=F,m.colonOffset=void 0,p=m}try{c(n,{onObjectBegin:(h,w)=>{if(s<=h)throw d;p=void 0,S=s>h,a.push("")},onObjectProperty:(h,w,I)=>{if(s<w||(k(h,w,I,"property"),a[a.length-1]=h,s<=w+I))throw d},onObjectEnd:(h,w)=>{if(s<=h)throw d;p=void 0,a.pop()},onArrayBegin:(h,w)=>{if(s<=h)throw d;p=void 0,a.push(0)},onArrayEnd:(h,w)=>{if(s<=h)throw d;p=void 0,a.pop()},onLiteralValue:(h,w,I)=>{if(s<w||(k(h,w,I,l(h)),s<=w+I))throw d},onSeparator:(h,w,I)=>{if(s<=w)throw d;if(h===":"&&p&&p.type==="property")p.colonOffset=w,S=!1,p=void 0;else if(h===","){const F=a[a.length-1];typeof F=="number"?a[a.length-1]=F+1:(S=!0,a[a.length-1]=""),p=void 0}}})}catch(h){if(h!==d)throw h}return{path:a,previousNode:p,isAtPropertyKey:S,matches:h=>{let w=0;for(let I=0;w<h.length&&I<a.length;I++)if(h[w]===a[I]||h[w]==="*")w++;else if(h[w]!=="**")return!1;return w===h.length}}}e.$2m=D;function u(n,s=[],a=M.DEFAULT){let d=null,p=[];const m=[];function S(h){Array.isArray(p)?p.push(h):d!==null&&(p[d]=h)}return c(n,{onObjectBegin:()=>{const h={};S(h),m.push(p),p=h,d=null},onObjectProperty:h=>{d=h},onObjectEnd:()=>{p=m.pop()},onArrayBegin:()=>{const h=[];S(h),m.push(p),p=h,d=null},onArrayEnd:()=>{p=m.pop()},onLiteralValue:S,onError:(h,w,I)=>{s.push({error:h,offset:w,length:I})}},a),p[0]}e.$3m=u;function b(n,s=[],a=M.DEFAULT){let d={type:"array",offset:-1,length:-1,children:[],parent:void 0};function p(h){d.type==="property"&&(d.length=h-d.offset,d=d.parent)}function m(h){return d.children.push(h),h}c(n,{onObjectBegin:h=>{d=m({type:"object",offset:h,length:-1,parent:d,children:[]})},onObjectProperty:(h,w,I)=>{d=m({type:"property",offset:w,length:-1,parent:d,children:[]}),d.children.push({type:"string",value:h,offset:w,length:I,parent:d})},onObjectEnd:(h,w)=>{d.length=h+w-d.offset,d=d.parent,p(h+w)},onArrayBegin:(h,w)=>{d=m({type:"array",offset:h,length:-1,parent:d,children:[]})},onArrayEnd:(h,w)=>{d.length=h+w-d.offset,d=d.parent,p(h+w)},onLiteralValue:(h,w,I)=>{m({type:l(h),offset:w,length:I,parent:d,value:h}),p(w+I)},onSeparator:(h,w,I)=>{d.type==="property"&&(h===":"?d.colonOffset=w:h===","&&p(w))},onError:(h,w,I)=>{s.push({error:h,offset:w,length:I})}},a);const k=d.children[0];return k&&delete k.parent,k}e.$4m=b;function v(n,s){if(!n)return;let a=n;for(const d of s)if(typeof d=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let p=!1;for(const m of a.children)if(Array.isArray(m.children)&&m.children[0].value===d){a=m.children[1],p=!0;break}if(!p)return}else{const p=d;if(a.type!=="array"||p<0||!Array.isArray(a.children)||p>=a.children.length)return;a=a.children[p]}return a}e.$5m=v;function g(n){if(!n.parent||!n.parent.children)return[];const s=g(n.parent);if(n.parent.type==="property"){const a=n.parent.children[0].value;s.push(a)}else if(n.parent.type==="array"){const a=n.parent.children.indexOf(n);a!==-1&&s.push(a)}return s}e.$6m=g;function t(n){switch(n.type){case"array":return n.children.map(t);case"object":{const s=Object.create(null);for(const a of n.children){const d=a.children[1];d&&(s[a.children[0].value]=t(d))}return s}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.$7m=t;function i(n,s,a=!1){return s>=n.offset&&s<n.offset+n.length||a&&s===n.offset+n.length}e.$8m=i;function r(n,s,a=!1){if(i(n,s,a)){const d=n.children;if(Array.isArray(d))for(let p=0;p<d.length&&d[p].offset<=s;p++){const m=r(d[p],s,a);if(m)return m}return n}}e.$9m=r;function c(n,s,a=M.DEFAULT){const d=A(n,!1);function p(te){return te?()=>te(d.getTokenOffset(),d.getTokenLength()):()=>!0}function m(te){return te?Re=>te(Re,d.getTokenOffset(),d.getTokenLength()):()=>!0}const S=p(s.onObjectBegin),k=m(s.onObjectProperty),h=p(s.onObjectEnd),w=p(s.onArrayBegin),I=p(s.onArrayEnd),F=m(s.onLiteralValue),V=m(s.onSeparator),Z=p(s.onComment),N=m(s.onError),R=a&&a.disallowComments,L=a&&a.allowTrailingComma;function O(){for(;;){const te=d.scan();switch(d.getTokenError()){case 4:Y(14);break;case 5:Y(15);break;case 3:Y(13);break;case 1:R||Y(11);break;case 2:Y(12);break;case 6:Y(16);break}switch(te){case 12:case 13:R?Y(10):Z();break;case 16:Y(1);break;case 15:case 14:break;default:return te}}}function Y(te,Re=[],se=[]){if(N(te),Re.length+se.length>0){let Q=d.getToken();for(;Q!==17;){if(Re.indexOf(Q)!==-1){O();break}else if(se.indexOf(Q)!==-1)break;Q=O()}}}function he(te){const Re=d.getTokenValue();return te?F(Re):k(Re),O(),!0}function $e(){switch(d.getToken()){case 11:{let te=0;try{te=JSON.parse(d.getTokenValue()),typeof te!="number"&&(Y(2),te=0)}catch{Y(2)}F(te);break}case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return O(),!0}function De(){return d.getToken()!==10?(Y(3,[],[2,5]),!1):(he(!1),d.getToken()===6?(V(":"),O(),ve()||Y(4,[],[2,5])):Y(5,[],[2,5]),!0)}function ke(){S(),O();let te=!1;for(;d.getToken()!==2&&d.getToken()!==17;){if(d.getToken()===5){if(te||Y(4,[],[]),V(","),O(),d.getToken()===2&&L)break}else te&&Y(6,[],[]);De()||Y(4,[],[2,5]),te=!0}return h(),d.getToken()!==2?Y(7,[2],[]):O(),!0}function fe(){w(),O();let te=!1;for(;d.getToken()!==4&&d.getToken()!==17;){if(d.getToken()===5){if(te||Y(4,[],[]),V(","),O(),d.getToken()===4&&L)break}else te&&Y(6,[],[]);ve()||Y(4,[],[4,5]),te=!0}return I(),d.getToken()!==4?Y(8,[4],[]):O(),!0}function ve(){switch(d.getToken()){case 3:return fe();case 1:return ke();case 10:return he(!0);default:return $e()}}return O(),d.getToken()===17?a.allowEmptyContent?!0:(Y(4,[],[]),!1):ve()?(d.getToken()!==17&&Y(9,[],[]),!0):(Y(4,[],[]),!1)}e.$0m=c;function o(n,s){const a=A(n),d=[];let p,m=0,S;do switch(S=a.getPosition(),p=a.scan(),p){case 12:case 13:case 17:m!==S&&d.push(n.substring(m,S)),s!==void 0&&d.push(a.getTokenValue().replace(/[^\r\n]/g,s)),m=a.getPosition();break}while(p!==17);return d.join("")}e.$$m=o;function l(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.$_m=l}),function(we,e){typeof define=="function"&&define.amd?define(Pe[120],Ae([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(we=typeof globalThis<"u"?globalThis:we||self,e(we.marked={}))}(this,function(we){"use strict";function e(le,ce){for(var ye=0;ye<ce.length;ye++){var _=ce[ye];_.enumerable=_.enumerable||!1,_.configurable=!0,"value"in _&&(_.writable=!0),Object.defineProperty(le,_.key,_)}}function y(le,ce,ye){return ce&&e(le.prototype,ce),ye&&e(le,ye),Object.defineProperty(le,"prototype",{writable:!1}),le}function T(le,ce){if(le){if(typeof le=="string")return P(le,ce);var ye=Object.prototype.toString.call(le).slice(8,-1);if(ye==="Object"&&le.constructor&&(ye=le.constructor.name),ye==="Map"||ye==="Set")return Array.from(le);if(ye==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ye))return P(le,ce)}}function P(le,ce){(ce==null||ce>le.length)&&(ce=le.length);for(var ye=0,_=new Array(ce);ye<ce;ye++)_[ye]=le[ye];return _}function M(le,ce){var ye=typeof Symbol<"u"&&le[Symbol.iterator]||le["@@iterator"];if(ye)return(ye=ye.call(le)).next.bind(ye);if(Array.isArray(le)||(ye=T(le))||ce&&le&&typeof le.length=="number"){ye&&(le=ye);var _=0;return function(){return _>=le.length?{done:!0}:{done:!1,value:le[_++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}we.defaults=A();function $(le){we.defaults=le}var E=/[&<>"']/,f=/[&<>"']/g,C=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(ce){return u[ce]};function v(le,ce){if(ce){if(E.test(le))return le.replace(f,b)}else if(C.test(le))return le.replace(D,b);return le}var g=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t(le){return le.replace(g,function(ce,ye){return ye=ye.toLowerCase(),ye==="colon"?":":ye.charAt(0)==="#"?ye.charAt(1)==="x"?String.fromCharCode(parseInt(ye.substring(2),16)):String.fromCharCode(+ye.substring(1)):""})}var i=/(^|[^\[])\^/g;function r(le,ce){le=typeof le=="string"?le:le.source,ce=ce||"";var ye={replace:function(de,ie){return ie=ie.source||ie,ie=ie.replace(i,"$1"),le=le.replace(de,ie),ye},getRegex:function(){return new RegExp(le,ce)}};return ye}var c=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function l(le,ce,ye){if(le){var _;try{_=decodeURIComponent(t(ye)).replace(c,"").toLowerCase()}catch{return null}if(_.indexOf("javascript:")===0||_.indexOf("vbscript:")===0||_.indexOf("data:")===0)return null}ce&&!o.test(ye)&&(ye=p(ce,ye));try{ye=encodeURI(ye).replace(/%25/g,"%")}catch{return null}return ye}var n={},s=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,d=/^([^:]+:\/*[^/]*)[\s\S]*$/;function p(le,ce){n[" "+le]||(s.test(le)?n[" "+le]=le+"/":n[" "+le]=h(le,"/",!0)),le=n[" "+le];var ye=le.indexOf(":")===-1;return ce.substring(0,2)==="//"?ye?ce:le.replace(a,"$1")+ce:ce.charAt(0)==="/"?ye?ce:le.replace(d,"$1")+ce:le+ce}var m={exec:function(){}};function S(le){for(var ce=1,ye,_;ce<arguments.length;ce++){ye=arguments[ce];for(_ in ye)Object.prototype.hasOwnProperty.call(ye,_)&&(le[_]=ye[_])}return le}function k(le,ce){var ye=le.replace(/\|/g,function(ie,ae,me){for(var Ie=!1,z=ae;--z>=0&&me[z]==="\\";)Ie=!Ie;return Ie?"|":" |"}),_=ye.split(/ \|/),de=0;if(_[0].trim()||_.shift(),_.length>0&&!_[_.length-1].trim()&&_.pop(),_.length>ce)_.splice(ce);else for(;_.length<ce;)_.push("");for(;de<_.length;de++)_[de]=_[de].trim().replace(/\\\|/g,"|");return _}function h(le,ce,ye){var _=le.length;if(_===0)return"";for(var de=0;de<_;){var ie=le.charAt(_-de-1);if(ie===ce&&!ye)de++;else if(ie!==ce&&ye)de++;else break}return le.slice(0,_-de)}function w(le,ce){if(le.indexOf(ce[1])===-1)return-1;for(var ye=le.length,_=0,de=0;de<ye;de++)if(le[de]==="\\")de++;else if(le[de]===ce[0])_++;else if(le[de]===ce[1]&&(_--,_<0))return de;return-1}function I(le){le&&le.sanitize&&!le.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function F(le,ce){if(ce<1)return"";for(var ye="";ce>1;)ce&1&&(ye+=le),ce>>=1,le+=le;return ye+le}function V(le,ce,ye,_){var de=ce.href,ie=ce.title?v(ce.title):null,ae=le[1].replace(/\\([\[\]])/g,"$1");if(le[0].charAt(0)!=="!"){_.state.inLink=!0;var me={type:"link",raw:ye,href:de,title:ie,text:ae,tokens:_.inlineTokens(ae)};return _.state.inLink=!1,me}return{type:"image",raw:ye,href:de,title:ie,text:v(ae)}}function Z(le,ce){var ye=le.match(/^(\s+)(?:```)/);if(ye===null)return ce;var _=ye[1];return ce.split(`
`).map(function(de){var ie=de.match(/^\s+/);if(ie===null)return de;var ae=ie[0];return ae.length>=_.length?de.slice(_.length):de}).join(`
`)}var N=function(){function le(ye){this.options=ye||we.defaults}var ce=le.prototype;return ce.space=function(_){var de=this.rules.block.newline.exec(_);if(de&&de[0].length>0)return{type:"space",raw:de[0]}},ce.code=function(_){var de=this.rules.block.code.exec(_);if(de){var ie=de[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:de[0],codeBlockStyle:"indented",text:this.options.pedantic?ie:h(ie,`
`)}}},ce.fences=function(_){var de=this.rules.block.fences.exec(_);if(de){var ie=de[0],ae=Z(ie,de[3]||"");return{type:"code",raw:ie,lang:de[2]?de[2].trim():de[2],text:ae}}},ce.heading=function(_){var de=this.rules.block.heading.exec(_);if(de){var ie=de[2].trim();if(/#$/.test(ie)){var ae=h(ie,"#");(this.options.pedantic||!ae||/ $/.test(ae))&&(ie=ae.trim())}return{type:"heading",raw:de[0],depth:de[1].length,text:ie,tokens:this.lexer.inline(ie)}}},ce.hr=function(_){var de=this.rules.block.hr.exec(_);if(de)return{type:"hr",raw:de[0]}},ce.blockquote=function(_){var de=this.rules.block.blockquote.exec(_);if(de){var ie=de[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:de[0],tokens:this.lexer.blockTokens(ie,[]),text:ie}}},ce.list=function(_){var de=this.rules.block.list.exec(_);if(de){var ie,ae,me,Ie,z,W,H,G,q,x,ue,Oe,Ue=de[1].trim(),Ze=Ue.length>1,Je={type:"list",raw:"",ordered:Ze,start:Ze?+Ue.slice(0,-1):"",loose:!1,items:[]};Ue=Ze?"\\d{1,9}\\"+Ue.slice(-1):"\\"+Ue,this.options.pedantic&&(Ue=Ze?Ue:"[*+-]");for(var tt=new RegExp("^( {0,3}"+Ue+")((?:[	 ][^\\n]*)?(?:\\n|$))");_&&(Oe=!1,!(!(de=tt.exec(_))||this.rules.block.hr.test(_)));){if(ie=de[0],_=_.substring(ie.length),G=de[2].split(`
`,1)[0],q=_.split(`
`,1)[0],this.options.pedantic?(Ie=2,ue=G.trimLeft()):(Ie=de[2].search(/[^ ]/),Ie=Ie>4?1:Ie,ue=G.slice(Ie),Ie+=de[1].length),W=!1,!G&&/^ *$/.test(q)&&(ie+=q+`
`,_=_.substring(q.length+1),Oe=!0),!Oe)for(var _e=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),et=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),rt=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:```|~~~)"),nt=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}#");_&&(x=_.split(`
`,1)[0],G=x,this.options.pedantic&&(G=G.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(rt.test(G)||nt.test(G)||_e.test(G)||et.test(_)));){if(G.search(/[^ ]/)>=Ie||!G.trim())ue+=`
`+G.slice(Ie);else if(!W)ue+=`
`+G;else break;!W&&!G.trim()&&(W=!0),ie+=x+`
`,_=_.substring(x.length+1)}Je.loose||(H?Je.loose=!0:/\n *\n *$/.test(ie)&&(H=!0)),this.options.gfm&&(ae=/^\[[ xX]\] /.exec(ue),ae&&(me=ae[0]!=="[ ] ",ue=ue.replace(/^\[[ xX]\] +/,""))),Je.items.push({type:"list_item",raw:ie,task:!!ae,checked:me,loose:!1,text:ue}),Je.raw+=ie}Je.items[Je.items.length-1].raw=ie.trimRight(),Je.items[Je.items.length-1].text=ue.trimRight(),Je.raw=Je.raw.trimRight();var ze=Je.items.length;for(z=0;z<ze;z++){this.lexer.state.top=!1,Je.items[z].tokens=this.lexer.blockTokens(Je.items[z].text,[]);var dt=Je.items[z].tokens.filter(function(J){return J.type==="space"}),X=dt.every(function(J){for(var Ee=J.raw.split(""),Be=0,He=M(Ee),Xe;!(Xe=He()).done;){var st=Xe.value;if(st===`
`&&(Be+=1),Be>1)return!0}return!1});!Je.loose&&dt.length&&X&&(Je.loose=!0,Je.items[z].loose=!0)}return Je}},ce.html=function(_){var de=this.rules.block.html.exec(_);if(de){var ie={type:"html",raw:de[0],pre:!this.options.sanitizer&&(de[1]==="pre"||de[1]==="script"||de[1]==="style"),text:de[0]};if(this.options.sanitize){var ae=this.options.sanitizer?this.options.sanitizer(de[0]):v(de[0]);ie.type="paragraph",ie.text=ae,ie.tokens=this.lexer.inline(ae)}return ie}},ce.def=function(_){var de=this.rules.block.def.exec(_);if(de){de[3]&&(de[3]=de[3].substring(1,de[3].length-1));var ie=de[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ie,raw:de[0],href:de[2],title:de[3]}}},ce.table=function(_){var de=this.rules.block.table.exec(_);if(de){var ie={type:"table",header:k(de[1]).map(function(H){return{text:H}}),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:de[3]&&de[3].trim()?de[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ie.header.length===ie.align.length){ie.raw=de[0];var ae=ie.align.length,me,Ie,z,W;for(me=0;me<ae;me++)/^ *-+: *$/.test(ie.align[me])?ie.align[me]="right":/^ *:-+: *$/.test(ie.align[me])?ie.align[me]="center":/^ *:-+ *$/.test(ie.align[me])?ie.align[me]="left":ie.align[me]=null;for(ae=ie.rows.length,me=0;me<ae;me++)ie.rows[me]=k(ie.rows[me],ie.header.length).map(function(H){return{text:H}});for(ae=ie.header.length,Ie=0;Ie<ae;Ie++)ie.header[Ie].tokens=this.lexer.inline(ie.header[Ie].text);for(ae=ie.rows.length,Ie=0;Ie<ae;Ie++)for(W=ie.rows[Ie],z=0;z<W.length;z++)W[z].tokens=this.lexer.inline(W[z].text);return ie}}},ce.lheading=function(_){var de=this.rules.block.lheading.exec(_);if(de)return{type:"heading",raw:de[0],depth:de[2].charAt(0)==="="?1:2,text:de[1],tokens:this.lexer.inline(de[1])}},ce.paragraph=function(_){var de=this.rules.block.paragraph.exec(_);if(de){var ie=de[1].charAt(de[1].length-1)===`
`?de[1].slice(0,-1):de[1];return{type:"paragraph",raw:de[0],text:ie,tokens:this.lexer.inline(ie)}}},ce.text=function(_){var de=this.rules.block.text.exec(_);if(de)return{type:"text",raw:de[0],text:de[0],tokens:this.lexer.inline(de[0])}},ce.escape=function(_){var de=this.rules.inline.escape.exec(_);if(de)return{type:"escape",raw:de[0],text:v(de[1])}},ce.tag=function(_){var de=this.rules.inline.tag.exec(_);if(de)return!this.lexer.state.inLink&&/^<a /i.test(de[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(de[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(de[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(de[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:de[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):v(de[0]):de[0]}},ce.link=function(_){var de=this.rules.inline.link.exec(_);if(de){var ie=de[2].trim();if(!this.options.pedantic&&/^</.test(ie)){if(!/>$/.test(ie))return;var ae=h(ie.slice(0,-1),"\\");if((ie.length-ae.length)%2===0)return}else{var me=w(de[2],"()");if(me>-1){var Ie=de[0].indexOf("!")===0?5:4,z=Ie+de[1].length+me;de[2]=de[2].substring(0,me),de[0]=de[0].substring(0,z).trim(),de[3]=""}}var W=de[2],H="";if(this.options.pedantic){var G=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(W);G&&(W=G[1],H=G[3])}else H=de[3]?de[3].slice(1,-1):"";return W=W.trim(),/^</.test(W)&&(this.options.pedantic&&!/>$/.test(ie)?W=W.slice(1):W=W.slice(1,-1)),V(de,{href:W&&W.replace(this.rules.inline._escapes,"$1"),title:H&&H.replace(this.rules.inline._escapes,"$1")},de[0],this.lexer)}},ce.reflink=function(_,de){var ie;if((ie=this.rules.inline.reflink.exec(_))||(ie=this.rules.inline.nolink.exec(_))){var ae=(ie[2]||ie[1]).replace(/\s+/g," ");if(ae=de[ae.toLowerCase()],!ae||!ae.href){var me=ie[0].charAt(0);return{type:"text",raw:me,text:me}}return V(ie,ae,ie[0],this.lexer)}},ce.emStrong=function(_,de,ie){ie===void 0&&(ie="");var ae=this.rules.inline.emStrong.lDelim.exec(_);if(ae&&!(ae[3]&&ie.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var me=ae[1]||ae[2]||"";if(!me||me&&(ie===""||this.rules.inline.punctuation.exec(ie))){var Ie=ae[0].length-1,z,W,H=Ie,G=0,q=ae[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(q.lastIndex=0,de=de.slice(-1*_.length+Ie);(ae=q.exec(de))!=null;)if(z=ae[1]||ae[2]||ae[3]||ae[4]||ae[5]||ae[6],!!z){if(W=z.length,ae[3]||ae[4]){H+=W;continue}else if((ae[5]||ae[6])&&Ie%3&&!((Ie+W)%3)){G+=W;continue}if(H-=W,!(H>0)){if(W=Math.min(W,W+H+G),Math.min(Ie,W)%2){var x=_.slice(1,Ie+ae.index+W);return{type:"em",raw:_.slice(0,Ie+ae.index+W+1),text:x,tokens:this.lexer.inlineTokens(x)}}var ue=_.slice(2,Ie+ae.index+W-1);return{type:"strong",raw:_.slice(0,Ie+ae.index+W+1),text:ue,tokens:this.lexer.inlineTokens(ue)}}}}}},ce.codespan=function(_){var de=this.rules.inline.code.exec(_);if(de){var ie=de[2].replace(/\n/g," "),ae=/[^ ]/.test(ie),me=/^ /.test(ie)&&/ $/.test(ie);return ae&&me&&(ie=ie.substring(1,ie.length-1)),ie=v(ie,!0),{type:"codespan",raw:de[0],text:ie}}},ce.br=function(_){var de=this.rules.inline.br.exec(_);if(de)return{type:"br",raw:de[0]}},ce.del=function(_){var de=this.rules.inline.del.exec(_);if(de)return{type:"del",raw:de[0],text:de[2],tokens:this.lexer.inlineTokens(de[2])}},ce.autolink=function(_,de){var ie=this.rules.inline.autolink.exec(_);if(ie){var ae,me;return ie[2]==="@"?(ae=v(this.options.mangle?de(ie[1]):ie[1]),me="mailto:"+ae):(ae=v(ie[1]),me=ae),{type:"link",raw:ie[0],text:ae,href:me,tokens:[{type:"text",raw:ae,text:ae}]}}},ce.url=function(_,de){var ie;if(ie=this.rules.inline.url.exec(_)){var ae,me;if(ie[2]==="@")ae=v(this.options.mangle?de(ie[0]):ie[0]),me="mailto:"+ae;else{var Ie;do Ie=ie[0],ie[0]=this.rules.inline._backpedal.exec(ie[0])[0];while(Ie!==ie[0]);ae=v(ie[0]),ie[1]==="www."?me="http://"+ae:me=ae}return{type:"link",raw:ie[0],text:ae,href:me,tokens:[{type:"text",raw:ae,text:ae}]}}},ce.inlineText=function(_,de){var ie=this.rules.inline.text.exec(_);if(ie){var ae;return this.lexer.state.inRawBlock?ae=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ie[0]):v(ie[0]):ie[0]:ae=v(this.options.smartypants?de(ie[0]):ie[0]),{type:"text",raw:ie[0],text:ae}}},le}(),R={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:m,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};R._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,R._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,R.def=r(R.def).replace("label",R._label).replace("title",R._title).getRegex(),R.bullet=/(?:[*+-]|\d{1,9}[.)])/,R.listItemStart=r(/^( *)(bull) */).replace("bull",R.bullet).getRegex(),R.list=r(R.list).replace(/bull/g,R.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+R.def.source+")").getRegex(),R._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",R._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,R.html=r(R.html,"i").replace("comment",R._comment).replace("tag",R._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),R.paragraph=r(R._paragraph).replace("hr",R.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",R._tag).getRegex(),R.blockquote=r(R.blockquote).replace("paragraph",R.paragraph).getRegex(),R.normal=S({},R),R.gfm=S({},R.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),R.gfm.table=r(R.gfm.table).replace("hr",R.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",R._tag).getRegex(),R.gfm.paragraph=r(R._paragraph).replace("hr",R.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",R.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",R._tag).getRegex(),R.pedantic=S({},R.normal,{html:r(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",R._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:m,paragraph:r(R.normal._paragraph).replace("hr",R.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",R.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var L={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:m,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:m,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};L._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",L.punctuation=r(L.punctuation).replace(/punctuation/g,L._punctuation).getRegex(),L.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,L.escapedEmSt=/\\\*|\\_/g,L._comment=r(R._comment).replace("(?:-->|$)","-->").getRegex(),L.emStrong.lDelim=r(L.emStrong.lDelim).replace(/punct/g,L._punctuation).getRegex(),L.emStrong.rDelimAst=r(L.emStrong.rDelimAst,"g").replace(/punct/g,L._punctuation).getRegex(),L.emStrong.rDelimUnd=r(L.emStrong.rDelimUnd,"g").replace(/punct/g,L._punctuation).getRegex(),L._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,L._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,L._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,L.autolink=r(L.autolink).replace("scheme",L._scheme).replace("email",L._email).getRegex(),L._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,L.tag=r(L.tag).replace("comment",L._comment).replace("attribute",L._attribute).getRegex(),L._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,L._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,L._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,L.link=r(L.link).replace("label",L._label).replace("href",L._href).replace("title",L._title).getRegex(),L.reflink=r(L.reflink).replace("label",L._label).replace("ref",R._label).getRegex(),L.nolink=r(L.nolink).replace("ref",R._label).getRegex(),L.reflinkSearch=r(L.reflinkSearch,"g").replace("reflink",L.reflink).replace("nolink",L.nolink).getRegex(),L.normal=S({},L),L.pedantic=S({},L.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:r(/^!?\[(label)\]\((.*?)\)/).replace("label",L._label).getRegex(),reflink:r(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",L._label).getRegex()}),L.gfm=S({},L.normal,{escape:r(L.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),L.gfm.url=r(L.gfm.url,"i").replace("email",L.gfm._extended_email).getRegex(),L.breaks=S({},L.gfm,{br:r(L.br).replace("{2,}","*").getRegex(),text:r(L.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function O(le){return le.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Y(le){var ce="",ye,_,de=le.length;for(ye=0;ye<de;ye++)_=le.charCodeAt(ye),Math.random()>.5&&(_="x"+_.toString(16)),ce+="&#"+_+";";return ce}var he=function(){function le(ye){this.tokens=[],this.tokens.links=Object.create(null),this.options=ye||we.defaults,this.options.tokenizer=this.options.tokenizer||new N,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var _={block:R.normal,inline:L.normal};this.options.pedantic?(_.block=R.pedantic,_.inline=L.pedantic):this.options.gfm&&(_.block=R.gfm,this.options.breaks?_.inline=L.breaks:_.inline=L.gfm),this.tokenizer.rules=_}le.lex=function(_,de){var ie=new le(de);return ie.lex(_)},le.lexInline=function(_,de){var ie=new le(de);return ie.inlineTokens(_)};var ce=le.prototype;return ce.lex=function(_){_=_.replace(/\r\n|\r/g,`
`),this.blockTokens(_,this.tokens);for(var de;de=this.inlineQueue.shift();)this.inlineTokens(de.src,de.tokens);return this.tokens},ce.blockTokens=function(_,de){var ie=this;de===void 0&&(de=[]),this.options.pedantic?_=_.replace(/\t/g,"    ").replace(/^ +$/gm,""):_=_.replace(/^( *)(\t+)/gm,function(H,G,q){return G+"    ".repeat(q.length)});for(var ae,me,Ie,z;_;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(H){return(ae=H.call({lexer:ie},_,de))?(_=_.substring(ae.raw.length),de.push(ae),!0):!1}))){if(ae=this.tokenizer.space(_)){_=_.substring(ae.raw.length),ae.raw.length===1&&de.length>0?de[de.length-1].raw+=`
`:de.push(ae);continue}if(ae=this.tokenizer.code(_)){_=_.substring(ae.raw.length),me=de[de.length-1],me&&(me.type==="paragraph"||me.type==="text")?(me.raw+=`
`+ae.raw,me.text+=`
`+ae.text,this.inlineQueue[this.inlineQueue.length-1].src=me.text):de.push(ae);continue}if(ae=this.tokenizer.fences(_)){_=_.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.heading(_)){_=_.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.hr(_)){_=_.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.blockquote(_)){_=_.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.list(_)){_=_.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.html(_)){_=_.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.def(_)){_=_.substring(ae.raw.length),me=de[de.length-1],me&&(me.type==="paragraph"||me.type==="text")?(me.raw+=`
`+ae.raw,me.text+=`
`+ae.raw,this.inlineQueue[this.inlineQueue.length-1].src=me.text):this.tokens.links[ae.tag]||(this.tokens.links[ae.tag]={href:ae.href,title:ae.title});continue}if(ae=this.tokenizer.table(_)){_=_.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.lheading(_)){_=_.substring(ae.raw.length),de.push(ae);continue}if(Ie=_,this.options.extensions&&this.options.extensions.startBlock&&function(){var H=1/0,G=_.slice(1),q=void 0;ie.options.extensions.startBlock.forEach(function(x){q=x.call({lexer:this},G),typeof q=="number"&&q>=0&&(H=Math.min(H,q))}),H<1/0&&H>=0&&(Ie=_.substring(0,H+1))}(),this.state.top&&(ae=this.tokenizer.paragraph(Ie))){me=de[de.length-1],z&&me.type==="paragraph"?(me.raw+=`
`+ae.raw,me.text+=`
`+ae.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=me.text):de.push(ae),z=Ie.length!==_.length,_=_.substring(ae.raw.length);continue}if(ae=this.tokenizer.text(_)){_=_.substring(ae.raw.length),me=de[de.length-1],me&&me.type==="text"?(me.raw+=`
`+ae.raw,me.text+=`
`+ae.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=me.text):de.push(ae);continue}if(_){var W="Infinite loop on byte: "+_.charCodeAt(0);if(this.options.silent){console.error(W);break}else throw new Error(W)}}return this.state.top=!0,de},ce.inline=function(_,de){return de===void 0&&(de=[]),this.inlineQueue.push({src:_,tokens:de}),de},ce.inlineTokens=function(_,de){var ie=this;de===void 0&&(de=[]);var ae,me,Ie,z=_,W,H,G;if(this.tokens.links){var q=Object.keys(this.tokens.links);if(q.length>0)for(;(W=this.tokenizer.rules.inline.reflinkSearch.exec(z))!=null;)q.includes(W[0].slice(W[0].lastIndexOf("[")+1,-1))&&(z=z.slice(0,W.index)+"["+F("a",W[0].length-2)+"]"+z.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(W=this.tokenizer.rules.inline.blockSkip.exec(z))!=null;)z=z.slice(0,W.index)+"["+F("a",W[0].length-2)+"]"+z.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(W=this.tokenizer.rules.inline.escapedEmSt.exec(z))!=null;)z=z.slice(0,W.index)+"++"+z.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;_;)if(H||(G=""),H=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ue){return(ae=ue.call({lexer:ie},_,de))?(_=_.substring(ae.raw.length),de.push(ae),!0):!1}))){if(ae=this.tokenizer.escape(_)){_=_.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.tag(_)){_=_.substring(ae.raw.length),me=de[de.length-1],me&&ae.type==="text"&&me.type==="text"?(me.raw+=ae.raw,me.text+=ae.text):de.push(ae);continue}if(ae=this.tokenizer.link(_)){_=_.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.reflink(_,this.tokens.links)){_=_.substring(ae.raw.length),me=de[de.length-1],me&&ae.type==="text"&&me.type==="text"?(me.raw+=ae.raw,me.text+=ae.text):de.push(ae);continue}if(ae=this.tokenizer.emStrong(_,z,G)){_=_.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.codespan(_)){_=_.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.br(_)){_=_.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.del(_)){_=_.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.autolink(_,Y)){_=_.substring(ae.raw.length),de.push(ae);continue}if(!this.state.inLink&&(ae=this.tokenizer.url(_,Y))){_=_.substring(ae.raw.length),de.push(ae);continue}if(Ie=_,this.options.extensions&&this.options.extensions.startInline&&function(){var ue=1/0,Oe=_.slice(1),Ue=void 0;ie.options.extensions.startInline.forEach(function(Ze){Ue=Ze.call({lexer:this},Oe),typeof Ue=="number"&&Ue>=0&&(ue=Math.min(ue,Ue))}),ue<1/0&&ue>=0&&(Ie=_.substring(0,ue+1))}(),ae=this.tokenizer.inlineText(Ie,O)){_=_.substring(ae.raw.length),ae.raw.slice(-1)!=="_"&&(G=ae.raw.slice(-1)),H=!0,me=de[de.length-1],me&&me.type==="text"?(me.raw+=ae.raw,me.text+=ae.text):de.push(ae);continue}if(_){var x="Infinite loop on byte: "+_.charCodeAt(0);if(this.options.silent){console.error(x);break}else throw new Error(x)}}return de},y(le,null,[{key:"rules",get:function(){return{block:R,inline:L}}}]),le}(),$e=function(){function le(ye){this.options=ye||we.defaults}var ce=le.prototype;return ce.code=function(_,de,ie){var ae=(de||"").match(/\S*/)[0];if(this.options.highlight){var me=this.options.highlight(_,ae);me!=null&&me!==_&&(ie=!0,_=me)}return _=_.replace(/\n$/,"")+`
`,ae?'<pre><code class="'+this.options.langPrefix+v(ae,!0)+'">'+(ie?_:v(_,!0))+`</code></pre>
`:"<pre><code>"+(ie?_:v(_,!0))+`</code></pre>
`},ce.blockquote=function(_){return`<blockquote>
`+_+`</blockquote>
`},ce.html=function(_){return _},ce.heading=function(_,de,ie,ae){if(this.options.headerIds){var me=this.options.headerPrefix+ae.slug(ie);return"<h"+de+' id="'+me+'">'+_+"</h"+de+`>
`}return"<h"+de+">"+_+"</h"+de+`>
`},ce.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ce.list=function(_,de,ie){var ae=de?"ol":"ul",me=de&&ie!==1?' start="'+ie+'"':"";return"<"+ae+me+`>
`+_+"</"+ae+`>
`},ce.listitem=function(_){return"<li>"+_+`</li>
`},ce.checkbox=function(_){return"<input "+(_?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ce.paragraph=function(_){return"<p>"+_+`</p>
`},ce.table=function(_,de){return de&&(de="<tbody>"+de+"</tbody>"),`<table>
<thead>
`+_+`</thead>
`+de+`</table>
`},ce.tablerow=function(_){return`<tr>
`+_+`</tr>
`},ce.tablecell=function(_,de){var ie=de.header?"th":"td",ae=de.align?"<"+ie+' align="'+de.align+'">':"<"+ie+">";return ae+_+("</"+ie+`>
`)},ce.strong=function(_){return"<strong>"+_+"</strong>"},ce.em=function(_){return"<em>"+_+"</em>"},ce.codespan=function(_){return"<code>"+_+"</code>"},ce.br=function(){return this.options.xhtml?"<br/>":"<br>"},ce.del=function(_){return"<del>"+_+"</del>"},ce.link=function(_,de,ie){if(_=l(this.options.sanitize,this.options.baseUrl,_),_===null)return ie;var ae='<a href="'+v(_)+'"';return de&&(ae+=' title="'+de+'"'),ae+=">"+ie+"</a>",ae},ce.image=function(_,de,ie){if(_=l(this.options.sanitize,this.options.baseUrl,_),_===null)return ie;var ae='<img src="'+_+'" alt="'+ie+'"';return de&&(ae+=' title="'+de+'"'),ae+=this.options.xhtml?"/>":">",ae},ce.text=function(_){return _},le}(),De=function(){function le(){}var ce=le.prototype;return ce.strong=function(_){return _},ce.em=function(_){return _},ce.codespan=function(_){return _},ce.del=function(_){return _},ce.html=function(_){return _},ce.text=function(_){return _},ce.link=function(_,de,ie){return""+ie},ce.image=function(_,de,ie){return""+ie},ce.br=function(){return""},le}(),ke=function(){function le(){this.seen={}}var ce=le.prototype;return ce.serialize=function(_){return _.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ce.getNextSafeSlug=function(_,de){var ie=_,ae=0;if(this.seen.hasOwnProperty(ie)){ae=this.seen[_];do ae++,ie=_+"-"+ae;while(this.seen.hasOwnProperty(ie))}return de||(this.seen[_]=ae,this.seen[ie]=0),ie},ce.slug=function(_,de){de===void 0&&(de={});var ie=this.serialize(_);return this.getNextSafeSlug(ie,de.dryrun)},le}(),fe=function(){function le(ye){this.options=ye||we.defaults,this.options.renderer=this.options.renderer||new $e,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new De,this.slugger=new ke}le.parse=function(_,de){var ie=new le(de);return ie.parse(_)},le.parseInline=function(_,de){var ie=new le(de);return ie.parseInline(_)};var ce=le.prototype;return ce.parse=function(_,de){de===void 0&&(de=!0);var ie="",ae,me,Ie,z,W,H,G,q,x,ue,Oe,Ue,Ze,Je,tt,_e,et,rt,nt,ze=_.length;for(ae=0;ae<ze;ae++){if(ue=_[ae],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ue.type]&&(nt=this.options.extensions.renderers[ue.type].call({parser:this},ue),nt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ue.type))){ie+=nt||"";continue}switch(ue.type){case"space":continue;case"hr":{ie+=this.renderer.hr();continue}case"heading":{ie+=this.renderer.heading(this.parseInline(ue.tokens),ue.depth,t(this.parseInline(ue.tokens,this.textRenderer)),this.slugger);continue}case"code":{ie+=this.renderer.code(ue.text,ue.lang,ue.escaped);continue}case"table":{for(q="",G="",z=ue.header.length,me=0;me<z;me++)G+=this.renderer.tablecell(this.parseInline(ue.header[me].tokens),{header:!0,align:ue.align[me]});for(q+=this.renderer.tablerow(G),x="",z=ue.rows.length,me=0;me<z;me++){for(H=ue.rows[me],G="",W=H.length,Ie=0;Ie<W;Ie++)G+=this.renderer.tablecell(this.parseInline(H[Ie].tokens),{header:!1,align:ue.align[Ie]});x+=this.renderer.tablerow(G)}ie+=this.renderer.table(q,x);continue}case"blockquote":{x=this.parse(ue.tokens),ie+=this.renderer.blockquote(x);continue}case"list":{for(Oe=ue.ordered,Ue=ue.start,Ze=ue.loose,z=ue.items.length,x="",me=0;me<z;me++)tt=ue.items[me],_e=tt.checked,et=tt.task,Je="",tt.task&&(rt=this.renderer.checkbox(_e),Ze?tt.tokens.length>0&&tt.tokens[0].type==="paragraph"?(tt.tokens[0].text=rt+" "+tt.tokens[0].text,tt.tokens[0].tokens&&tt.tokens[0].tokens.length>0&&tt.tokens[0].tokens[0].type==="text"&&(tt.tokens[0].tokens[0].text=rt+" "+tt.tokens[0].tokens[0].text)):tt.tokens.unshift({type:"text",text:rt}):Je+=rt),Je+=this.parse(tt.tokens,Ze),x+=this.renderer.listitem(Je,et,_e);ie+=this.renderer.list(x,Oe,Ue);continue}case"html":{ie+=this.renderer.html(ue.text);continue}case"paragraph":{ie+=this.renderer.paragraph(this.parseInline(ue.tokens));continue}case"text":{for(x=ue.tokens?this.parseInline(ue.tokens):ue.text;ae+1<ze&&_[ae+1].type==="text";)ue=_[++ae],x+=`
`+(ue.tokens?this.parseInline(ue.tokens):ue.text);ie+=de?this.renderer.paragraph(x):x;continue}default:{var dt='Token with "'+ue.type+'" type was not found.';if(this.options.silent){console.error(dt);return}else throw new Error(dt)}}}return ie},ce.parseInline=function(_,de){de=de||this.renderer;var ie="",ae,me,Ie,z=_.length;for(ae=0;ae<z;ae++){if(me=_[ae],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[me.type]&&(Ie=this.options.extensions.renderers[me.type].call({parser:this},me),Ie!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(me.type))){ie+=Ie||"";continue}switch(me.type){case"escape":{ie+=de.text(me.text);break}case"html":{ie+=de.html(me.text);break}case"link":{ie+=de.link(me.href,me.title,this.parseInline(me.tokens,de));break}case"image":{ie+=de.image(me.href,me.title,me.text);break}case"strong":{ie+=de.strong(this.parseInline(me.tokens,de));break}case"em":{ie+=de.em(this.parseInline(me.tokens,de));break}case"codespan":{ie+=de.codespan(me.text);break}case"br":{ie+=de.br();break}case"del":{ie+=de.del(this.parseInline(me.tokens,de));break}case"text":{ie+=de.text(me.text);break}default:{var W='Token with "'+me.type+'" type was not found.';if(this.options.silent){console.error(W);return}else throw new Error(W)}}}return ie},le}();function ve(le,ce,ye){if(typeof le>"u"||le===null)throw new Error("marked(): input parameter is undefined or null");if(typeof le!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(le)+", string expected");if(typeof ce=="function"&&(ye=ce,ce=null),ce=S({},ve.defaults,ce||{}),I(ce),ye){var _=ce.highlight,de;try{de=he.lex(le,ce)}catch(z){return ye(z)}var ie=function(W){var H;if(!W)try{ce.walkTokens&&ve.walkTokens(de,ce.walkTokens),H=fe.parse(de,ce)}catch(G){W=G}return ce.highlight=_,W?ye(W):ye(null,H)};if(!_||_.length<3||(delete ce.highlight,!de.length))return ie();var ae=0;ve.walkTokens(de,function(z){z.type==="code"&&(ae++,setTimeout(function(){_(z.text,z.lang,function(W,H){if(W)return ie(W);H!=null&&H!==z.text&&(z.text=H,z.escaped=!0),ae--,ae===0&&ie()})},0))}),ae===0&&ie();return}function me(z){if(z.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+v(z.message+"",!0)+"</pre>";throw z}try{var Ie=he.lex(le,ce);if(ce.walkTokens){if(ce.async)return Promise.all(ve.walkTokens(Ie,ce.walkTokens)).then(function(){return fe.parse(Ie,ce)}).catch(me);ve.walkTokens(Ie,ce.walkTokens)}return fe.parse(Ie,ce)}catch(z){me(z)}}ve.options=ve.setOptions=function(le){return S(ve.defaults,le),$(ve.defaults),ve},ve.getDefaults=A,ve.defaults=we.defaults,ve.use=function(){for(var le=arguments.length,ce=new Array(le),ye=0;ye<le;ye++)ce[ye]=arguments[ye];var _=S.apply(void 0,[{}].concat(ce)),de=ve.defaults.extensions||{renderers:{},childTokens:{}},ie;ce.forEach(function(ae){if(ae.extensions&&(ie=!0,ae.extensions.forEach(function(Ie){if(!Ie.name)throw new Error("extension name required");if(Ie.renderer){var z=de.renderers?de.renderers[Ie.name]:null;z?de.renderers[Ie.name]=function(){for(var W=arguments.length,H=new Array(W),G=0;G<W;G++)H[G]=arguments[G];var q=Ie.renderer.apply(this,H);return q===!1&&(q=z.apply(this,H)),q}:de.renderers[Ie.name]=Ie.renderer}if(Ie.tokenizer){if(!Ie.level||Ie.level!=="block"&&Ie.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");de[Ie.level]?de[Ie.level].unshift(Ie.tokenizer):de[Ie.level]=[Ie.tokenizer],Ie.start&&(Ie.level==="block"?de.startBlock?de.startBlock.push(Ie.start):de.startBlock=[Ie.start]:Ie.level==="inline"&&(de.startInline?de.startInline.push(Ie.start):de.startInline=[Ie.start]))}Ie.childTokens&&(de.childTokens[Ie.name]=Ie.childTokens)})),ae.renderer&&function(){var Ie=ve.defaults.renderer||new $e,z=function(G){var q=Ie[G];Ie[G]=function(){for(var x=arguments.length,ue=new Array(x),Oe=0;Oe<x;Oe++)ue[Oe]=arguments[Oe];var Ue=ae.renderer[G].apply(Ie,ue);return Ue===!1&&(Ue=q.apply(Ie,ue)),Ue}};for(var W in ae.renderer)z(W);_.renderer=Ie}(),ae.tokenizer&&function(){var Ie=ve.defaults.tokenizer||new N,z=function(G){var q=Ie[G];Ie[G]=function(){for(var x=arguments.length,ue=new Array(x),Oe=0;Oe<x;Oe++)ue[Oe]=arguments[Oe];var Ue=ae.tokenizer[G].apply(Ie,ue);return Ue===!1&&(Ue=q.apply(Ie,ue)),Ue}};for(var W in ae.tokenizer)z(W);_.tokenizer=Ie}(),ae.walkTokens){var me=ve.defaults.walkTokens;_.walkTokens=function(Ie){var z=[];return z.push(ae.walkTokens.call(this,Ie)),me&&(z=z.concat(me.call(this,Ie))),z}}ie&&(_.extensions=de),ve.setOptions(_)})},ve.walkTokens=function(le,ce){for(var ye=[],_=function(){var me=ie.value;switch(ye=ye.concat(ce.call(ve,me)),me.type){case"table":{for(var Ie=M(me.header),z;!(z=Ie()).done;){var W=z.value;ye=ye.concat(ve.walkTokens(W.tokens,ce))}for(var H=M(me.rows),G;!(G=H()).done;)for(var q=G.value,x=M(q),ue;!(ue=x()).done;){var Oe=ue.value;ye=ye.concat(ve.walkTokens(Oe.tokens,ce))}break}case"list":{ye=ye.concat(ve.walkTokens(me.items,ce));break}default:ve.defaults.extensions&&ve.defaults.extensions.childTokens&&ve.defaults.extensions.childTokens[me.type]?ve.defaults.extensions.childTokens[me.type].forEach(function(Ue){ye=ye.concat(ve.walkTokens(me[Ue],ce))}):me.tokens&&(ye=ye.concat(ve.walkTokens(me.tokens,ce)))}},de=M(le),ie;!(ie=de()).done;)_();return ye},ve.parseInline=function(le,ce){if(typeof le>"u"||le===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof le!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(le)+", string expected");ce=S({},ve.defaults,ce||{}),I(ce);try{var ye=he.lexInline(le,ce);return ce.walkTokens&&ve.walkTokens(ye,ce.walkTokens),fe.parseInline(ye,ce)}catch(_){if(_.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+v(_.message+"",!0)+"</pre>";throw _}},ve.Parser=fe,ve.parser=fe.parse,ve.Renderer=$e,ve.TextRenderer=De,ve.Lexer=he,ve.lexer=he.lex,ve.Tokenizer=N,ve.Slugger=ke,ve.parse=ve;var te=ve.options,Re=ve.setOptions,se=ve.use,Q=ve.walkTokens,B=ve.parseInline,ne=ve,pe=fe.parse,re=he.lex;we.Lexer=he,we.Parser=fe,we.Renderer=$e,we.Slugger=ke,we.TextRenderer=De,we.Tokenizer=N,we.getDefaults=A,we.lexer=re,we.marked=ve,we.options=te,we.parse=ne,we.parseInline=B,we.parser=pe,we.setOptions=Re,we.use=se,we.walkTokens=Q,Object.defineProperty(we,"__esModule",{value:!0})}),define(Pe[121],Ae([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yl=e.$Xl=e.$Wl=e.rot=e.$Ul=void 0;function y($,E,f){return Math.min(Math.max($,E),f)}e.$Ul=y;function T($,E){return(E+$%E)%E}e.rot=T;class P{constructor(){this.a=0}getNext(){return this.a++}}e.$Wl=P;class M{constructor(){this.a=1,this.b=0}update(E){return this.b=this.b+(E-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Xl=M;class A{constructor(E){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(E),this.c.fill(0,0,E)}update(E){const f=this.c[this.d];return this.c[this.d]=E,this.d=(this.d+1)%this.c.length,this.e-=f,this.e+=E,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Yl=A}),function(){function we(P){const M=[];typeof P=="number"&&M.push("code/timeOrigin",P);function A(E){M.push(E,Date.now())}function $(){const E=[];for(let f=0;f<M.length;f+=2)E.push({name:M[f],startTime:M[f+1]});return E}return{mark:A,getMarks:$}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?we():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const A of performance.getEntriesByType("mark"))M.push({name:A.name,startTime:Math.round(P+A.startTime)});return M}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return we(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),we()}function y(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return y(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=y(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=y(T))}(),function(we,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var y=e();for(var T in y)(typeof exports=="object"?exports:we)[T]=y[T]}}(typeof self<"u"?self:this,function(){return function(we){var e={};function y(T){if(e[T])return e[T].exports;var P=e[T]={i:T,l:!1,exports:{}};return we[T].call(P.exports,P,P.exports,y),P.l=!0,P.exports}return y.m=we,y.c=e,y.d=function(T,P,M){y.o(T,P)||Object.defineProperty(T,P,{enumerable:!0,get:M})},y.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},y.t=function(T,P){if(1&P&&(T=y(T)),8&P||4&P&&typeof T=="object"&&T&&T.__esModule)return T;var M=Object.create(null);if(y.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:T}),2&P&&typeof T!="string")for(var A in T)y.d(M,A,function($){return T[$]}.bind(null,A));return M},y.n=function(T){var P=T&&T.__esModule?function(){return T.default}:function(){return T};return y.d(P,"a",P),P},y.o=function(T,P){return Object.prototype.hasOwnProperty.call(T,P)},y.p="",y(y.s=0)}([function(we,e,y){(function(T){var P;e=we.exports=se,P=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var q=Array.prototype.slice.call(arguments,0);q.unshift("SEMVER"),console.log.apply(console,q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,$=e.re=[],E=e.src=[],f=0,C=f++;E[C]="0|[1-9]\\d*";var D=f++;E[D]="[0-9]+";var u=f++;E[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=f++;E[b]="("+E[C]+")\\.("+E[C]+")\\.("+E[C]+")";var v=f++;E[v]="("+E[D]+")\\.("+E[D]+")\\.("+E[D]+")";var g=f++;E[g]="(?:"+E[C]+"|"+E[u]+")";var t=f++;E[t]="(?:"+E[D]+"|"+E[u]+")";var i=f++;E[i]="(?:-("+E[g]+"(?:\\."+E[g]+")*))";var r=f++;E[r]="(?:-?("+E[t]+"(?:\\."+E[t]+")*))";var c=f++;E[c]="[0-9A-Za-z-]+";var o=f++;E[o]="(?:\\+("+E[c]+"(?:\\."+E[c]+")*))";var l=f++,n="v?"+E[b]+E[i]+"?"+E[o]+"?";E[l]="^"+n+"$";var s="[v=\\s]*"+E[v]+E[r]+"?"+E[o]+"?",a=f++;E[a]="^"+s+"$";var d=f++;E[d]="((?:<|>)?=?)";var p=f++;E[p]=E[D]+"|x|X|\\*";var m=f++;E[m]=E[C]+"|x|X|\\*";var S=f++;E[S]="[v=\\s]*("+E[m]+")(?:\\.("+E[m]+")(?:\\.("+E[m]+")(?:"+E[i]+")?"+E[o]+"?)?)?";var k=f++;E[k]="[v=\\s]*("+E[p]+")(?:\\.("+E[p]+")(?:\\.("+E[p]+")(?:"+E[r]+")?"+E[o]+"?)?)?";var h=f++;E[h]="^"+E[d]+"\\s*"+E[S]+"$";var w=f++;E[w]="^"+E[d]+"\\s*"+E[k]+"$";var I=f++;E[I]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var F=f++;E[F]="(?:~>?)";var V=f++;E[V]="(\\s*)"+E[F]+"\\s+",$[V]=new RegExp(E[V],"g");var Z=f++;E[Z]="^"+E[F]+E[S]+"$";var N=f++;E[N]="^"+E[F]+E[k]+"$";var R=f++;E[R]="(?:\\^)";var L=f++;E[L]="(\\s*)"+E[R]+"\\s+",$[L]=new RegExp(E[L],"g");var O=f++;E[O]="^"+E[R]+E[S]+"$";var Y=f++;E[Y]="^"+E[R]+E[k]+"$";var he=f++;E[he]="^"+E[d]+"\\s*("+s+")$|^$";var $e=f++;E[$e]="^"+E[d]+"\\s*("+n+")$|^$";var De=f++;E[De]="(\\s*)"+E[d]+"\\s*("+s+"|"+E[S]+")",$[De]=new RegExp(E[De],"g");var ke=f++;E[ke]="^\\s*("+E[S]+")\\s+-\\s+("+E[S]+")\\s*$";var fe=f++;E[fe]="^\\s*("+E[k]+")\\s+-\\s+("+E[k]+")\\s*$";var ve=f++;E[ve]="(<|>)?=?\\s*\\*";for(var te=0;te<35;te++)P(te,E[te]),$[te]||($[te]=new RegExp(E[te]));function Re(q,x){if(q instanceof se)return q;if(typeof q!="string"||q.length>M||!(x?$[a]:$[l]).test(q))return null;try{return new se(q,x)}catch{return null}}function se(q,x){if(q instanceof se){if(q.loose===x)return q;q=q.version}else if(typeof q!="string")throw new TypeError("Invalid Version: "+q);if(q.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof se))return new se(q,x);P("SemVer",q,x),this.loose=x;var ue=q.trim().match(x?$[a]:$[l]);if(!ue)throw new TypeError("Invalid Version: "+q);if(this.raw=q,this.major=+ue[1],this.minor=+ue[2],this.patch=+ue[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ue[4]?this.prerelease=ue[4].split(".").map(function(Oe){if(/^[0-9]+$/.test(Oe)){var Ue=+Oe;if(Ue>=0&&Ue<A)return Ue}return Oe}):this.prerelease=[],this.build=ue[5]?ue[5].split("."):[],this.format()}e.parse=Re,e.valid=function(q,x){var ue=Re(q,x);return ue?ue.version:null},e.clean=function(q,x){var ue=Re(q.trim().replace(/^[=v]+/,""),x);return ue?ue.version:null},e.SemVer=se,se.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},se.prototype.toString=function(){return this.version},se.prototype.compare=function(q){return P("SemVer.compare",this.version,this.loose,q),q instanceof se||(q=new se(q,this.loose)),this.compareMain(q)||this.comparePre(q)},se.prototype.compareMain=function(q){return q instanceof se||(q=new se(q,this.loose)),B(this.major,q.major)||B(this.minor,q.minor)||B(this.patch,q.patch)},se.prototype.comparePre=function(q){if(q instanceof se||(q=new se(q,this.loose)),this.prerelease.length&&!q.prerelease.length)return-1;if(!this.prerelease.length&&q.prerelease.length)return 1;if(!this.prerelease.length&&!q.prerelease.length)return 0;var x=0;do{var ue=this.prerelease[x],Oe=q.prerelease[x];if(P("prerelease compare",x,ue,Oe),ue===void 0&&Oe===void 0)return 0;if(Oe===void 0)return 1;if(ue===void 0)return-1;if(ue!==Oe)return B(ue,Oe)}while(++x)},se.prototype.inc=function(q,x){switch(q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",x);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",x);break;case"prepatch":this.prerelease.length=0,this.inc("patch",x),this.inc("pre",x);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",x),this.inc("pre",x);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ue=this.prerelease.length;--ue>=0;)typeof this.prerelease[ue]=="number"&&(this.prerelease[ue]++,ue=-2);ue===-1&&this.prerelease.push(0)}x&&(this.prerelease[0]===x?isNaN(this.prerelease[1])&&(this.prerelease=[x,0]):this.prerelease=[x,0]);break;default:throw new Error("invalid increment argument: "+q)}return this.format(),this.raw=this.version,this},e.inc=function(q,x,ue,Oe){typeof ue=="string"&&(Oe=ue,ue=void 0);try{return new se(q,ue).inc(x,Oe).version}catch{return null}},e.diff=function(q,x){if(le(q,x))return null;var ue=Re(q),Oe=Re(x);if(ue.prerelease.length||Oe.prerelease.length){for(var Ue in ue)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&ue[Ue]!==Oe[Ue])return"pre"+Ue;return"prerelease"}for(var Ue in ue)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&ue[Ue]!==Oe[Ue])return Ue},e.compareIdentifiers=B;var Q=/^[0-9]+$/;function B(q,x){var ue=Q.test(q),Oe=Q.test(x);return ue&&Oe&&(q=+q,x=+x),ue&&!Oe?-1:Oe&&!ue?1:q<x?-1:q>x?1:0}function ne(q,x,ue){return new se(q,ue).compare(new se(x,ue))}function pe(q,x,ue){return ne(q,x,ue)>0}function re(q,x,ue){return ne(q,x,ue)<0}function le(q,x,ue){return ne(q,x,ue)===0}function ce(q,x,ue){return ne(q,x,ue)!==0}function ye(q,x,ue){return ne(q,x,ue)>=0}function _(q,x,ue){return ne(q,x,ue)<=0}function de(q,x,ue,Oe){var Ue;switch(x){case"===":typeof q=="object"&&(q=q.version),typeof ue=="object"&&(ue=ue.version),Ue=q===ue;break;case"!==":typeof q=="object"&&(q=q.version),typeof ue=="object"&&(ue=ue.version),Ue=q!==ue;break;case"":case"=":case"==":Ue=le(q,ue,Oe);break;case"!=":Ue=ce(q,ue,Oe);break;case">":Ue=pe(q,ue,Oe);break;case">=":Ue=ye(q,ue,Oe);break;case"<":Ue=re(q,ue,Oe);break;case"<=":Ue=_(q,ue,Oe);break;default:throw new TypeError("Invalid operator: "+x)}return Ue}function ie(q,x){if(q instanceof ie){if(q.loose===x)return q;q=q.value}if(!(this instanceof ie))return new ie(q,x);P("comparator",q,x),this.loose=x,this.parse(q),this.semver===ae?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(q,x){return B(x,q)},e.major=function(q,x){return new se(q,x).major},e.minor=function(q,x){return new se(q,x).minor},e.patch=function(q,x){return new se(q,x).patch},e.compare=ne,e.compareLoose=function(q,x){return ne(q,x,!0)},e.rcompare=function(q,x,ue){return ne(x,q,ue)},e.sort=function(q,x){return q.sort(function(ue,Oe){return e.compare(ue,Oe,x)})},e.rsort=function(q,x){return q.sort(function(ue,Oe){return e.rcompare(ue,Oe,x)})},e.gt=pe,e.lt=re,e.eq=le,e.neq=ce,e.gte=ye,e.lte=_,e.cmp=de,e.Comparator=ie;var ae={};function me(q,x){if(q instanceof me)return q.loose===x?q:new me(q.raw,x);if(q instanceof ie)return new me(q.value,x);if(!(this instanceof me))return new me(q,x);if(this.loose=x,this.raw=q,this.set=q.split(/\s*\|\|\s*/).map(function(ue){return this.parseRange(ue.trim())},this).filter(function(ue){return ue.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+q);this.format()}function Ie(q){return!q||q.toLowerCase()==="x"||q==="*"}function z(q,x,ue,Oe,Ue,Ze,Je,tt,_e,et,rt,nt,ze){return((x=Ie(ue)?"":Ie(Oe)?">="+ue+".0.0":Ie(Ue)?">="+ue+"."+Oe+".0":">="+x)+" "+(tt=Ie(_e)?"":Ie(et)?"<"+(+_e+1)+".0.0":Ie(rt)?"<"+_e+"."+(+et+1)+".0":nt?"<="+_e+"."+et+"."+rt+"-"+nt:"<="+tt)).trim()}function W(q,x){for(var ue=0;ue<q.length;ue++)if(!q[ue].test(x))return!1;if(x.prerelease.length){for(ue=0;ue<q.length;ue++)if(P(q[ue].semver),q[ue].semver!==ae&&q[ue].semver.prerelease.length>0){var Oe=q[ue].semver;if(Oe.major===x.major&&Oe.minor===x.minor&&Oe.patch===x.patch)return!0}return!1}return!0}function H(q,x,ue){try{x=new me(x,ue)}catch{return!1}return x.test(q)}function G(q,x,ue,Oe){var Ue,Ze,Je,tt,_e;switch(q=new se(q,Oe),x=new me(x,Oe),ue){case">":Ue=pe,Ze=_,Je=re,tt=">",_e=">=";break;case"<":Ue=re,Ze=ye,Je=pe,tt="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(H(q,x,Oe))return!1;for(var et=0;et<x.set.length;++et){var rt=x.set[et],nt=null,ze=null;if(rt.forEach(function(dt){dt.semver===ae&&(dt=new ie(">=0.0.0")),nt=nt||dt,ze=ze||dt,Ue(dt.semver,nt.semver,Oe)?nt=dt:Je(dt.semver,ze.semver,Oe)&&(ze=dt)}),nt.operator===tt||nt.operator===_e||(!ze.operator||ze.operator===tt)&&Ze(q,ze.semver)||ze.operator===_e&&Je(q,ze.semver))return!1}return!0}ie.prototype.parse=function(q){var x=this.loose?$[he]:$[$e],ue=q.match(x);if(!ue)throw new TypeError("Invalid comparator: "+q);this.operator=ue[1],this.operator==="="&&(this.operator=""),ue[2]?this.semver=new se(ue[2],this.loose):this.semver=ae},ie.prototype.toString=function(){return this.value},ie.prototype.test=function(q){return P("Comparator.test",q,this.loose),this.semver===ae||(typeof q=="string"&&(q=new se(q,this.loose)),de(q,this.operator,this.semver,this.loose))},ie.prototype.intersects=function(q,x){if(!(q instanceof ie))throw new TypeError("a Comparator is required");var ue;if(this.operator==="")return ue=new me(q.value,x),H(this.value,ue,x);if(q.operator==="")return ue=new me(this.value,x),H(q.semver,ue,x);var Oe=!(this.operator!==">="&&this.operator!==">"||q.operator!==">="&&q.operator!==">"),Ue=!(this.operator!=="<="&&this.operator!=="<"||q.operator!=="<="&&q.operator!=="<"),Ze=this.semver.version===q.semver.version,Je=!(this.operator!==">="&&this.operator!=="<="||q.operator!==">="&&q.operator!=="<="),tt=de(this.semver,"<",q.semver,x)&&(this.operator===">="||this.operator===">")&&(q.operator==="<="||q.operator==="<"),_e=de(this.semver,">",q.semver,x)&&(this.operator==="<="||this.operator==="<")&&(q.operator===">="||q.operator===">");return Oe||Ue||Ze&&Je||tt||_e},e.Range=me,me.prototype.format=function(){return this.range=this.set.map(function(q){return q.join(" ").trim()}).join("||").trim(),this.range},me.prototype.toString=function(){return this.range},me.prototype.parseRange=function(q){var x=this.loose;q=q.trim(),P("range",q,x);var ue=x?$[fe]:$[ke];q=q.replace(ue,z),P("hyphen replace",q),q=q.replace($[De],"$1$2$3"),P("comparator trim",q,$[De]),q=(q=(q=q.replace($[V],"$1~")).replace($[L],"$1^")).split(/\s+/).join(" ");var Oe=x?$[he]:$[$e],Ue=q.split(" ").map(function(Ze){return function(Je,tt){return P("comp",Je),Je=function(_e,et){return _e.trim().split(/\s+/).map(function(rt){return function(nt,ze){P("caret",nt,ze);var dt=ze?$[Y]:$[O];return nt.replace(dt,function(X,J,Ee,Be,He){var Xe;return P("caret",nt,X,J,Ee,Be,He),Ie(J)?Xe="":Ie(Ee)?Xe=">="+J+".0.0 <"+(+J+1)+".0.0":Ie(Be)?Xe=J==="0"?">="+J+"."+Ee+".0 <"+J+"."+(+Ee+1)+".0":">="+J+"."+Ee+".0 <"+(+J+1)+".0.0":He?(P("replaceCaret pr",He),He.charAt(0)!=="-"&&(He="-"+He),Xe=J==="0"?Ee==="0"?">="+J+"."+Ee+"."+Be+He+" <"+J+"."+Ee+"."+(+Be+1):">="+J+"."+Ee+"."+Be+He+" <"+J+"."+(+Ee+1)+".0":">="+J+"."+Ee+"."+Be+He+" <"+(+J+1)+".0.0"):(P("no pr"),Xe=J==="0"?Ee==="0"?">="+J+"."+Ee+"."+Be+" <"+J+"."+Ee+"."+(+Be+1):">="+J+"."+Ee+"."+Be+" <"+J+"."+(+Ee+1)+".0":">="+J+"."+Ee+"."+Be+" <"+(+J+1)+".0.0"),P("caret return",Xe),Xe})}(rt,et)}).join(" ")}(Je,tt),P("caret",Je),Je=function(_e,et){return _e.trim().split(/\s+/).map(function(rt){return function(nt,ze){var dt=ze?$[N]:$[Z];return nt.replace(dt,function(X,J,Ee,Be,He){var Xe;return P("tilde",nt,X,J,Ee,Be,He),Ie(J)?Xe="":Ie(Ee)?Xe=">="+J+".0.0 <"+(+J+1)+".0.0":Ie(Be)?Xe=">="+J+"."+Ee+".0 <"+J+"."+(+Ee+1)+".0":He?(P("replaceTilde pr",He),He.charAt(0)!=="-"&&(He="-"+He),Xe=">="+J+"."+Ee+"."+Be+He+" <"+J+"."+(+Ee+1)+".0"):Xe=">="+J+"."+Ee+"."+Be+" <"+J+"."+(+Ee+1)+".0",P("tilde return",Xe),Xe})}(rt,et)}).join(" ")}(Je,tt),P("tildes",Je),Je=function(_e,et){return P("replaceXRanges",_e,et),_e.split(/\s+/).map(function(rt){return function(nt,ze){nt=nt.trim();var dt=ze?$[w]:$[h];return nt.replace(dt,function(X,J,Ee,Be,He,Xe){P("xRange",nt,X,J,Ee,Be,He,Xe);var st=Ie(Ee),vt=st||Ie(Be),Dt=vt||Ie(He);return J==="="&&Dt&&(J=""),st?X=J===">"||J==="<"?"<0.0.0":"*":J&&Dt?(vt&&(Be=0),Dt&&(He=0),J===">"?(J=">=",vt?(Ee=+Ee+1,Be=0,He=0):Dt&&(Be=+Be+1,He=0)):J==="<="&&(J="<",vt?Ee=+Ee+1:Be=+Be+1),X=J+Ee+"."+Be+"."+He):vt?X=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Dt&&(X=">="+Ee+"."+Be+".0 <"+Ee+"."+(+Be+1)+".0"),P("xRange return",X),X})}(rt,et)}).join(" ")}(Je,tt),P("xrange",Je),Je=function(_e,et){return P("replaceStars",_e,et),_e.trim().replace($[ve],"")}(Je,tt),P("stars",Je),Je}(Ze,x)}).join(" ").split(/\s+/);return this.loose&&(Ue=Ue.filter(function(Ze){return!!Ze.match(Oe)})),Ue=Ue.map(function(Ze){return new ie(Ze,x)})},me.prototype.intersects=function(q,x){if(!(q instanceof me))throw new TypeError("a Range is required");return this.set.some(function(ue){return ue.every(function(Oe){return q.set.some(function(Ue){return Ue.every(function(Ze){return Oe.intersects(Ze,x)})})})})},e.toComparators=function(q,x){return new me(q,x).set.map(function(ue){return ue.map(function(Oe){return Oe.value}).join(" ").trim().split(" ")})},me.prototype.test=function(q){if(!q)return!1;typeof q=="string"&&(q=new se(q,this.loose));for(var x=0;x<this.set.length;x++)if(W(this.set[x],q))return!0;return!1},e.satisfies=H,e.maxSatisfying=function(q,x,ue){var Oe=null,Ue=null;try{var Ze=new me(x,ue)}catch{return null}return q.forEach(function(Je){Ze.test(Je)&&(Oe&&Ue.compare(Je)!==-1||(Ue=new se(Oe=Je,ue)))}),Oe},e.minSatisfying=function(q,x,ue){var Oe=null,Ue=null;try{var Ze=new me(x,ue)}catch{return null}return q.forEach(function(Je){Ze.test(Je)&&(Oe&&Ue.compare(Je)!==1||(Ue=new se(Oe=Je,ue)))}),Oe},e.validRange=function(q,x){try{return new me(q,x).range||"*"}catch{return null}},e.ltr=function(q,x,ue){return G(q,x,"<",ue)},e.gtr=function(q,x,ue){return G(q,x,">",ue)},e.outside=G,e.prerelease=function(q,x){var ue=Re(q,x);return ue&&ue.prerelease.length?ue.prerelease:null},e.intersects=function(q,x,ue){return q=new me(q,ue),x=new me(x,ue),q.intersects(x)},e.coerce=function(q){if(q instanceof se)return q;if(typeof q!="string")return null;var x=q.match($[I]);return x==null?null:Re((x[1]||"0")+"."+(x[2]||"0")+"."+(x[3]||"0"))}}).call(this,y(1))},function(we,e){var y,T,P=we.exports={};function M(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function $(t){if(y===setTimeout)return setTimeout(t,0);if((y===M||!y)&&setTimeout)return y=setTimeout,setTimeout(t,0);try{return y(t,0)}catch{try{return y.call(null,t,0)}catch{return y.call(this,t,0)}}}(function(){try{y=typeof setTimeout=="function"?setTimeout:M}catch{y=M}try{T=typeof clearTimeout=="function"?clearTimeout:A}catch{T=A}})();var E,f=[],C=!1,D=-1;function u(){C&&E&&(C=!1,E.length?f=E.concat(f):D=-1,f.length&&b())}function b(){if(!C){var t=$(u);C=!0;for(var i=f.length;i;){for(E=f,f=[];++D<i;)E&&E[D].run();D=-1,i=f.length}E=null,C=!1,function(r){if(T===clearTimeout)return clearTimeout(r);if((T===A||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(r);try{T(r)}catch{try{return T.call(null,r)}catch{return T.call(this,r)}}}(t)}}function v(t,i){this.fun=t,this.array=i}function g(){}P.nextTick=function(t){var i=new Array(arguments.length-1);if(arguments.length>1)for(var r=1;r<arguments.length;r++)i[r-1]=arguments[r];f.push(new v(t,i)),f.length!==1||C||$(b)},v.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=g,P.addListener=g,P.once=g,P.off=g,P.removeListener=g,P.removeAllListeners=g,P.emit=g,P.prependListener=g,P.prependOnceListener=g,P.listeners=function(t){return[]},P.binding=function(t){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(t){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Pe[122],Ae([1,0,11,6]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=void 0;function P(o){const l=o;return l?typeof l.read=="function":!1}e.$3d=P;function M(o){const l=o;return l?[l.on,l.pause,l.resume,l.destroy].every(n=>typeof n=="function"):!1}e.$4d=M;function A(o){const l=o;return l?M(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.$5d=A;function $(o,l){return new E(o,l)}e.$6d=$;class E{constructor(l,n){this.e=l,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(l){if(!this.a.destroyed){if(this.a.flowing)this.g(l);else if(this.b.data.push(l),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(l){this.a.destroyed||(this.a.flowing?this.h(l):this.b.error.push(l))}end(l){this.a.destroyed||(typeof l<"u"&&this.write(l),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(l){this.c.data.slice(0).forEach(n=>n(l))}h(l){this.c.error.length===0?(0,y.$Z)(l):this.c.error.slice(0).forEach(n=>n(l))}i(){this.c.end.slice(0).forEach(l=>l())}on(l,n){if(!this.a.destroyed)switch(l){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(l,n){if(this.a.destroyed)return;let s;switch(l){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const a=s.indexOf(n);a>=0&&s.splice(a,1)}}j(){if(this.b.data.length>0){const l=this.e(this.b.data);this.g(l),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const l of this.b.error)this.h(l);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function f(o,l){const n=[];let s;for(;(s=o.read())!==null;)n.push(s);return l(n)}e.$7d=f;function C(o,l,n){const s=[];let a;for(;(a=o.read())!==null&&s.length<n;)s.push(a);return a===null&&s.length>0?l(s):{read:()=>{if(s.length>0)return s.shift();if(typeof a<"u"){const d=a;return a=void 0,d}return o.read()}}}e.$8d=C;function D(o,l){return new Promise((n,s)=>{const a=[];u(o,{onData:d=>{l&&a.push(d)},onError:d=>{l?s(d):n(void 0)},onEnd:()=>{n(l?l(a):void 0)}})})}e.$9d=D;function u(o,l,n){o.on("error",s=>{n?.isCancellationRequested||l.onError(s)}),o.on("end",()=>{n?.isCancellationRequested||l.onEnd()}),o.on("data",s=>{n?.isCancellationRequested||l.onData(s)})}e.$0d=u;function b(o,l){return new Promise((n,s)=>{const a=new T.$Qc,d=[],p=k=>{if(d.push(k),d.length>l)return a.dispose(),o.pause(),n({stream:o,buffer:d,ended:!1})},m=k=>(a.dispose(),s(k)),S=()=>(a.dispose(),n({stream:o,buffer:d,ended:!0}));a.add((0,T.$Pc)(()=>o.removeListener("error",m))),o.on("error",m),a.add((0,T.$Pc)(()=>o.removeListener("end",S))),o.on("end",S),a.add((0,T.$Pc)(()=>o.removeListener("data",p))),o.on("data",p)})}e.$$d=b;function v(o,l){const n=$(l);return n.end(o),n}e.$_d=v;function g(){const o=$(()=>{throw new Error("not supported")});return o.end(),o}e.$ae=g;function t(o){let l=!1;return{read:()=>l?null:(l=!0,o)}}e.$be=t;function i(o,l,n){const s=$(n);return u(o,{onData:a=>s.write(l.data(a)),onError:a=>s.error(l.error?l.error(a):a),onEnd:()=>s.end()}),s}e.$ce=i;function r(o,l,n){let s=!1;return{read:()=>{const a=l.read();return s?a:(s=!0,a!==null?n([o,a]):o)}}}e.$de=r;function c(o,l,n){let s=!1;const a=$(n);return u(l,{onData:d=>s?a.write(d):(s=!0,a.write(n([o,d]))),onError:d=>a.error(d),onEnd:()=>{s||(s=!0,a.write(o)),a.end()}}),a}e.$ee=c}),define(Pe[24],Ae([1,0,44,122]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=void 0;const P=typeof Buffer<"u",M=new y.$U(()=>new Uint8Array(256));let A,$;class E{static alloc(I){return P?new E(Buffer.allocUnsafe(I)):new E(new Uint8Array(I))}static wrap(I){return P&&!Buffer.isBuffer(I)&&(I=Buffer.from(I.buffer,I.byteOffset,I.byteLength)),new E(I)}static fromString(I,F){return!(F?.dontUseNodeBuffer||!1)&&P?new E(Buffer.from(I)):(A||(A=new TextEncoder),new E(A.encode(I)))}static fromByteArray(I){const F=E.alloc(I.length);for(let V=0,Z=I.length;V<Z;V++)F.buffer[V]=I[V];return F}static concat(I,F){if(typeof F>"u"){F=0;for(let N=0,R=I.length;N<R;N++)F+=I[N].byteLength}const V=E.alloc(F);let Z=0;for(let N=0,R=I.length;N<R;N++){const L=I[N];V.set(L,Z),Z+=L.byteLength}return V}constructor(I){this.buffer=I,this.byteLength=this.buffer.byteLength}clone(){const I=E.alloc(this.byteLength);return I.set(this),I}toString(){return P?this.buffer.toString():($||($=new TextDecoder),$.decode(this.buffer))}slice(I,F){return new E(this.buffer.subarray(I,F))}set(I,F){if(I instanceof E)this.buffer.set(I.buffer,F);else if(I instanceof Uint8Array)this.buffer.set(I,F);else if(I instanceof ArrayBuffer)this.buffer.set(new Uint8Array(I),F);else if(ArrayBuffer.isView(I))this.buffer.set(new Uint8Array(I.buffer,I.byteOffset,I.byteLength),F);else throw new Error("Unknown argument 'array'")}readUInt32BE(I){return u(this.buffer,I)}writeUInt32BE(I,F){b(this.buffer,I,F)}readUInt32LE(I){return v(this.buffer,I)}writeUInt32LE(I,F){g(this.buffer,I,F)}readUInt8(I){return t(this.buffer,I)}writeUInt8(I,F){i(this.buffer,I,F)}indexOf(I,F=0){return f(this.buffer,I instanceof E?I.buffer:I,F)}}e.$fe=E;function f(w,I,F=0){const V=I.byteLength,Z=w.byteLength;if(V===0)return 0;if(V===1)return w.indexOf(I[0]);if(V>Z-F)return-1;const N=M.value;N.fill(I.length);for(let Y=0;Y<I.length;Y++)N[I[Y]]=I.length-Y-1;let R=F+I.length-1,L=R,O=-1;for(;R<Z;)if(w[R]===I[L]){if(L===0){O=R;break}R--,L--}else R+=Math.max(I.length-L,N[w[R]]),L=I.length-1;return O}e.$ge=f;function C(w,I){return w[I+0]<<0>>>0|w[I+1]<<8>>>0}e.$he=C;function D(w,I,F){w[F+0]=I&255,I=I>>>8,w[F+1]=I&255}e.$ie=D;function u(w,I){return w[I]*2**24+w[I+1]*2**16+w[I+2]*2**8+w[I+3]}e.$je=u;function b(w,I,F){w[F+3]=I,I=I>>>8,w[F+2]=I,I=I>>>8,w[F+1]=I,I=I>>>8,w[F]=I}e.$ke=b;function v(w,I){return w[I+0]<<0>>>0|w[I+1]<<8>>>0|w[I+2]<<16>>>0|w[I+3]<<24>>>0}e.$le=v;function g(w,I,F){w[F+0]=I&255,I=I>>>8,w[F+1]=I&255,I=I>>>8,w[F+2]=I&255,I=I>>>8,w[F+3]=I&255}e.$me=g;function t(w,I){return w[I]}e.$ne=t;function i(w,I,F){w[F]=I}e.$oe=i;function r(w){return T.$7d(w,I=>E.concat(I))}e.$pe=r;function c(w){return T.$be(w)}e.$qe=c;function o(w){return T.$9d(w,I=>E.concat(I))}e.$re=o;async function l(w){return w.ended?E.concat(w.buffer):E.concat([...w.buffer,await o(w.stream)])}e.$se=l;function n(w){return T.$_d(w,I=>E.concat(I))}e.$te=n;function s(w){return T.$ce(w,{data:I=>typeof I=="string"?E.fromString(I):E.wrap(I)},I=>E.concat(I))}e.$ue=s;function a(w){return T.$6d(I=>E.concat(I),w)}e.$ve=a;function d(w,I){return T.$de(w,I,F=>E.concat(F))}e.$we=d;function p(w,I){return T.$ee(w,I,F=>E.concat(F))}e.$xe=p;function m(w){let I=0,F=0,V=0;const Z=new Uint8Array(Math.floor(w.length/4*3)),N=L=>{switch(F){case 3:Z[V++]=I|L,F=0;break;case 2:Z[V++]=I|L>>>2,I=L<<6,F=3;break;case 1:Z[V++]=I|L>>>4,I=L<<4,F=2;break;default:I=L<<2,F=1}};for(let L=0;L<w.length;L++){const O=w.charCodeAt(L);if(O>=65&&O<=90)N(O-65);else if(O>=97&&O<=122)N(O-97+26);else if(O>=48&&O<=57)N(O-48+52);else if(O===43||O===45)N(62);else if(O===47||O===95)N(63);else{if(O===61)break;throw new SyntaxError(`Unexpected base64 character ${w[L]}`)}}const R=V;for(;F>0;)N(0);return E.wrap(Z).slice(0,R)}e.$ye=m;const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function h({buffer:w},I=!0,F=!1){const V=F?k:S;let Z="";const N=w.byteLength%3;let R=0;for(;R<w.byteLength-N;R+=3){const L=w[R+0],O=w[R+1],Y=w[R+2];Z+=V[L>>>2],Z+=V[(L<<4|O>>>4)&63],Z+=V[(O<<2|Y>>>6)&63],Z+=V[Y&63]}if(N===1){const L=w[R+0];Z+=V[L>>>2],Z+=V[L<<4&63],I&&(Z+="==")}else if(N===2){const L=w[R+0],O=w[R+1];Z+=V[L>>>2],Z+=V[(L<<4|O>>>4)&63],Z+=V[O<<2&63],I&&(Z+="=")}return Z}e.$ze=h}),define(Pe[123],Ae([1,0,28,12]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.FuzzyScore=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.or=void 0;function P(...ie){return function(ae,me){for(let Ie=0,z=ie.length;Ie<z;Ie++){const W=ie[Ie](ae,me);if(W)return W}return null}}e.or=P,e.$Ij=M.bind(void 0,!1),e.$Jj=M.bind(void 0,!0);function M(ie,ae,me){if(!me||me.length<ae.length)return null;let Ie;return ie?Ie=T.$7e(me,ae):Ie=me.indexOf(ae)===0,Ie?ae.length>0?[{start:0,end:ae.length}]:[]:null}function A(ie,ae){const me=ae.toLowerCase().indexOf(ie.toLowerCase());return me===-1?null:[{start:me,end:me+ie.length}]}e.$Kj=A;function $(ie,ae){return E(ie.toLowerCase(),ae.toLowerCase(),0,0)}e.$Lj=$;function E(ie,ae,me,Ie){if(me===ie.length)return[];if(Ie===ae.length)return null;if(ie[me]===ae[Ie]){let z=null;return(z=E(ie,ae,me+1,Ie+1))?i({start:Ie,end:Ie+1},z):null}return E(ie,ae,me,Ie+1)}function f(ie){return 97<=ie&&ie<=122}function C(ie){return 65<=ie&&ie<=90}e.$Mj=C;function D(ie){return 48<=ie&&ie<=57}function u(ie){return ie===32||ie===9||ie===10||ie===13}const b=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ie=>b.add(ie.charCodeAt(0)));function v(ie){return u(ie)||b.has(ie)}function g(ie,ae){return ie===ae||v(ie)&&v(ae)}function t(ie){return f(ie)||C(ie)||D(ie)}function i(ie,ae){return ae.length===0?ae=[ie]:ie.end===ae[0].start?ae[0].start=ie.start:ae.unshift(ie),ae}function r(ie,ae){for(let me=ae;me<ie.length;me++){const Ie=ie.charCodeAt(me);if(C(Ie)||D(Ie)||me>0&&!t(ie.charCodeAt(me-1)))return me}return ie.length}function c(ie,ae,me,Ie){if(me===ie.length)return[];if(Ie===ae.length)return null;if(ie[me]!==ae[Ie].toLowerCase())return null;{let z=null,W=Ie+1;for(z=c(ie,ae,me+1,Ie+1);!z&&(W=r(ae,W))<ae.length;)z=c(ie,ae,me+1,W),W++;return z===null?null:i({start:Ie,end:Ie+1},z)}}function o(ie){let ae=0,me=0,Ie=0,z=0,W=0;for(let ue=0;ue<ie.length;ue++)W=ie.charCodeAt(ue),C(W)&&ae++,f(W)&&me++,t(W)&&Ie++,D(W)&&z++;const H=ae/ie.length,G=me/ie.length,q=Ie/ie.length,x=z/ie.length;return{upperPercent:H,lowerPercent:G,alphaPercent:q,numericPercent:x}}function l(ie){const{upperPercent:ae,lowerPercent:me}=ie;return me===0&&ae>.6}function n(ie){const{upperPercent:ae,lowerPercent:me,alphaPercent:Ie,numericPercent:z}=ie;return me>.2&&ae<.8&&Ie>.6&&z<.2}function s(ie){let ae=0,me=0,Ie=0,z=0;for(let W=0;W<ie.length;W++)Ie=ie.charCodeAt(W),C(Ie)&&ae++,f(Ie)&&me++,u(Ie)&&z++;return(ae===0||me===0)&&z===0?ie.length<=30:ae<=5}function a(ie,ae){if(!ae||(ae=ae.trim(),ae.length===0)||!s(ie)||ae.length>60)return null;const me=o(ae);if(!n(me)){if(!l(me))return null;ae=ae.toLowerCase()}let Ie=null,z=0;for(ie=ie.toLowerCase();z<ae.length&&(Ie=c(ie,ae,0,z))===null;)z=r(ae,z+1);return Ie}e.$Nj=a;function d(ie,ae,me=!1){if(!ae||ae.length===0)return null;let Ie=null,z=0;for(ie=ie.toLowerCase(),ae=ae.toLowerCase();z<ae.length&&(Ie=p(ie,ae,0,z,me))===null;)z=m(ae,z+1);return Ie}e.$Oj=d;function p(ie,ae,me,Ie,z){if(me===ie.length)return[];if(Ie===ae.length)return null;if(g(ie.charCodeAt(me),ae.charCodeAt(Ie))){let W=null,H=Ie+1;if(W=p(ie,ae,me+1,Ie+1,z),!z)for(;!W&&(H=m(ae,H))<ae.length;)W=p(ie,ae,me+1,H,z),H++;return W?ie.charCodeAt(me)!==ae.charCodeAt(Ie)?W:i({start:Ie,end:Ie+1},W):null}else return null}function m(ie,ae){for(let me=ae;me<ie.length;me++)if(v(ie.charCodeAt(me))||me>0&&v(ie.charCodeAt(me-1)))return me;return ie.length}const S=P(e.$Jj,a,A),k=P(e.$Jj,a,$),h=new y.$Cc(1e4);function w(ie,ae,me=!1){if(typeof ie!="string"||typeof ae!="string")return null;let Ie=h.get(ie);Ie||(Ie=new RegExp(T.$Pe(ie),"i"),h.set(ie,Ie));const z=Ie.exec(ae);return z?[{start:z.index,end:z.index+z[0].length}]:me?k(ie,ae):S(ie,ae)}e.$Pj=w;function I(ie,ae){const me=pe(ie,ie.toLowerCase(),0,ae,ae.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return me?V(me):null}e.$Qj=I;function F(ie,ae,me,Ie,z,W){const H=Math.min(13,ie.length);for(;me<H;me++){const G=pe(ie,ae,me,Ie,z,W,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(G)return G}return[0,W]}e.$Rj=F;function V(ie){if(typeof ie>"u")return[];const ae=[],me=ie[1];for(let Ie=ie.length-1;Ie>1;Ie--){const z=ie[Ie]+me,W=ae[ae.length-1];W&&W.end===z?W.end=z+1:ae.push({start:z,end:z+1})}return ae}e.$Sj=V;const Z=128;function N(){const ie=[],ae=[];for(let me=0;me<=Z;me++)ae[me]=0;for(let me=0;me<=Z;me++)ie.push(ae.slice(0));return ie}function R(ie){const ae=[];for(let me=0;me<=ie;me++)ae[me]=0;return ae}const L=R(2*Z),O=R(2*Z),Y=N(),he=N(),$e=N(),De=!1;function ke(ie,ae,me,Ie,z){function W(G,q,x=" "){for(;G.length<q;)G=x+G;return G}let H=` |   |${Ie.split("").map(G=>W(G,3)).join("|")}
`;for(let G=0;G<=me;G++)G===0?H+=" |":H+=`${ae[G-1]}|`,H+=ie[G].slice(0,z+1).map(q=>W(q.toString(),3)).join("|")+`
`;return H}function fe(ie,ae,me,Ie){ie=ie.substr(ae),me=me.substr(Ie),console.log(ke(he,ie,ie.length,me,me.length)),console.log(ke($e,ie,ie.length,me,me.length)),console.log(ke(Y,ie,ie.length,me,me.length))}function ve(ie,ae){if(ae<0||ae>=ie.length)return!1;const me=ie.codePointAt(ae);switch(me){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!T.$mf(me)}}function te(ie,ae){if(ae<0||ae>=ie.length)return!1;switch(ie.charCodeAt(ae)){case 32:case 9:return!0;default:return!1}}function Re(ie,ae,me){return ae[ie]!==me[ie]}function se(ie,ae,me,Ie,z,W,H=!1){for(;ae<me&&z<W;)ie[ae]===Ie[z]&&(H&&(L[ae]=z),ae+=1),z+=1;return ae===me}e.$Tj=se;var Q;(function(ie){ie[ie.Diag=1]="Diag",ie[ie.Left=2]="Left",ie[ie.LeftLeft=3]="LeftLeft"})(Q||(Q={}));var B;(function(ie){ie.Default=[-100,0];function ae(me){return!me||me.length===2&&me[0]===-100&&me[1]===0}ie.isDefault=ae})(B||(e.FuzzyScore=B={}));class ne{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(ae,me){this.firstMatchCanBeWeak=ae,this.boostFullMatch=me}}e.$Uj=ne;function pe(ie,ae,me,Ie,z,W,H=ne.default){const G=ie.length>Z?Z:ie.length,q=Ie.length>Z?Z:Ie.length;if(me>=G||W>=q||G-me>q-W||!se(ae,me,G,z,W,q,!0))return;re(G,q,me,W,ae,z);let x=1,ue=1,Oe=me,Ue=W;const Ze=[!1];for(x=1,Oe=me;Oe<G;x++,Oe++){const rt=L[Oe],nt=O[Oe],ze=Oe+1<G?O[Oe+1]:q;for(ue=rt-W+1,Ue=rt;Ue<ze;ue++,Ue++){let dt=Number.MIN_SAFE_INTEGER,X=!1;Ue<=nt&&(dt=le(ie,ae,Oe,me,Ie,z,Ue,q,W,Y[x-1][ue-1]===0,Ze));let J=0;dt!==Number.MAX_SAFE_INTEGER&&(X=!0,J=dt+he[x-1][ue-1]);const Ee=Ue>rt,Be=Ee?he[x][ue-1]+(Y[x][ue-1]>0?-5:0):0,He=Ue>rt+1&&Y[x][ue-1]>0,Xe=He?he[x][ue-2]+(Y[x][ue-2]>0?-5:0):0;if(He&&(!Ee||Xe>=Be)&&(!X||Xe>=J))he[x][ue]=Xe,$e[x][ue]=3,Y[x][ue]=0;else if(Ee&&(!X||Be>=J))he[x][ue]=Be,$e[x][ue]=2,Y[x][ue]=0;else if(X)he[x][ue]=J,$e[x][ue]=1,Y[x][ue]=Y[x-1][ue-1]+1;else throw new Error("not possible")}}if(De&&fe(ie,me,Ie,W),!Ze[0]&&!H.firstMatchCanBeWeak)return;x--,ue--;const Je=[he[x][ue],W];let tt=0,_e=0;for(;x>=1;){let rt=ue;do{const nt=$e[x][rt];if(nt===3)rt=rt-2;else if(nt===2)rt=rt-1;else break}while(rt>=1);tt>1&&ae[me+x-1]===z[W+ue-1]&&!Re(rt+W-1,Ie,z)&&tt+1>Y[x][rt]&&(rt=ue),rt===ue?tt++:tt=1,_e||(_e=rt),x--,ue=rt-1,Je.push(ue)}q===G&&H.boostFullMatch&&(Je[0]+=2);const et=_e-G;return Je[0]-=et,Je}e.$Vj=pe;function re(ie,ae,me,Ie,z,W){let H=ie-1,G=ae-1;for(;H>=me&&G>=Ie;)z[H]===W[G]&&(O[H]=G,H--),G--}function le(ie,ae,me,Ie,z,W,H,G,q,x,ue){if(ae[me]!==W[H])return Number.MIN_SAFE_INTEGER;let Oe=1,Ue=!1;return H===me-Ie?Oe=ie[me]===z[H]?7:5:Re(H,z,W)&&(H===0||!Re(H-1,z,W))?(Oe=ie[me]===z[H]?7:5,Ue=!0):ve(W,H)&&(H===0||!ve(W,H-1))?Oe=5:(ve(W,H-1)||te(W,H-1))&&(Oe=5,Ue=!0),Oe>1&&me===Ie&&(ue[0]=!0),Ue||(Ue=Re(H,z,W)||ve(W,H-1)||te(W,H-1)),me===Ie?H>q&&(Oe-=Ue?3:5):x?Oe+=Ue?2:0:Oe+=Ue?0:1,H+1===G&&(Oe-=Ue?3:5),Oe}function ce(ie,ae,me,Ie,z,W,H){return _(ie,ae,me,Ie,z,W,!0,H)}e.$Wj=ce;function ye(ie,ae,me,Ie,z,W,H){return _(ie,ae,me,Ie,z,W,!1,H)}e.$Xj=ye;function _(ie,ae,me,Ie,z,W,H,G){let q=pe(ie,ae,me,Ie,z,W,G);if(q&&!H)return q;if(ie.length>=3){const x=Math.min(7,ie.length-1);for(let ue=me+1;ue<x;ue++){const Oe=de(ie,ue);if(Oe){const Ue=pe(Oe,Oe.toLowerCase(),me,Ie,z,W,G);Ue&&(Ue[0]-=3,(!q||Ue[0]>q[0])&&(q=Ue))}}}return q}function de(ie,ae){if(ae+1>=ie.length)return;const me=ie[ae],Ie=ie[ae+1];if(me!==Ie)return ie.slice(0,ae)+Ie+me+ie.slice(ae+2)}}),define(Pe[31],Ae([1,0,12]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(T||(T={})),function(P){const M="error",A="warning",$="warn",E="info",f="ignore";function C(u){return u?y.$6e(M,u)?P.Error:y.$6e(A,u)||y.$6e($,u)?P.Warning:y.$6e(E,u)?P.Info:P.Ignore:P.Ignore}P.fromValue=C;function D(u){switch(u){case P.Error:return M;case P.Warning:return A;case P.Info:return E;default:return f}}P.toString=D}(T||(T={})),e.default=T}),define(Pe[124],Ae([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Od=void 0,e.$Od=Symbol("MicrotaskDelay")}),define(Pe[50],Ae([1,0,18,12]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=void 0;class P{constructor(){this.b="",this.c=0}reset(b){return this.b=b,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(b){const v=b.charCodeAt(0),g=this.b.charCodeAt(this.c);return v-g}value(){return this.b[this.c]}}e.$Xh=P;class M{constructor(b=!0){this.e=b}reset(b){return this.b=b,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let b=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(b)this.c++;else break;else b=!1;return this}cmp(b){return this.e?(0,T.$Ze)(b,this.b,0,b.length,this.c,this.d):(0,T.$2e)(b,this.b,0,b.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Yh=M;class A{constructor(b=!0,v=!0){this.f=b,this.g=v}reset(b){this.d=0,this.e=0,this.b=b,this.c=b.length;for(let v=b.length-1;v>=0;v--,this.c--){const g=this.b.charCodeAt(v);if(!(g===47||this.f&&g===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let b=!0;for(;this.e<this.c;this.e++){const v=this.b.charCodeAt(this.e);if(v===47||this.f&&v===92)if(b)this.d++;else break;else b=!1}return this}cmp(b){return this.g?(0,T.$Ze)(b,this.b,0,b.length,this.d,this.e):(0,T.$2e)(b,this.b,0,b.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Zh=A;var $;(function(u){u[u.Scheme=1]="Scheme",u[u.Authority=2]="Authority",u[u.Path=3]="Path",u[u.Query=4]="Query",u[u.Fragment=5]="Fragment"})($||($={}));class E{constructor(b,v){this.f=b,this.g=v,this.d=[],this.e=0}reset(b){return this.c=b,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(b)),this.b.reset(b.path),this.b.value()&&this.d.push(3)),this.g(b)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(b){if(this.d[this.e]===1)return(0,T.$1e)(b,this.c.scheme);if(this.d[this.e]===2)return(0,T.$1e)(b,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(b);if(this.d[this.e]===4)return(0,T.$Ye)(b,this.c.query);if(this.d[this.e]===5)return(0,T.$Ye)(b,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$1h=E;class f{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const b=this.right;return this.right=b.left,b.left=this,this.updateHeight(),b.updateHeight(),b}rotateRight(){const b=this.left;return this.left=b.right,b.right=this,this.updateHeight(),b.updateHeight(),b}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var C;(function(u){u[u.Left=-1]="Left",u[u.Mid=0]="Mid",u[u.Right=1]="Right"})(C||(C={}));class D{static forUris(b=()=>!1,v=()=>!1){return new D(new E(b,v))}static forPaths(b=!1){return new D(new A(void 0,!b))}static forStrings(){return new D(new P)}static forConfigKeys(){return new D(new M)}constructor(b){this.b=b}clear(){this.c=void 0}fill(b,v){if(v){const g=v.slice(0);(0,y.$Wb)(g);for(const t of g)this.set(t,b)}else{const g=b.slice(0);(0,y.$Wb)(g);for(const t of g)this.set(t[0],t[1])}}set(b,v){const g=this.b.reset(b);let t;this.c||(this.c=new f,this.c.segment=g.value());const i=[];for(t=this.c;;){const c=g.cmp(t.segment);if(c>0)t.left||(t.left=new f,t.left.segment=g.value()),i.push([-1,t]),t=t.left;else if(c<0)t.right||(t.right=new f,t.right.segment=g.value()),i.push([1,t]),t=t.right;else if(g.hasNext())g.next(),t.mid||(t.mid=new f,t.mid.segment=g.value()),i.push([0,t]),t=t.mid;else break}const r=t.value;t.value=v,t.key=b;for(let c=i.length-1;c>=0;c--){const o=i[c][1];o.updateHeight();const l=o.balanceFactor();if(l<-1||l>1){const n=i[c][0],s=i[c+1][0];if(n===1&&s===1)i[c][1]=o.rotateLeft();else if(n===-1&&s===-1)i[c][1]=o.rotateRight();else if(n===1&&s===-1)o.right=i[c+1][1]=i[c+1][1].rotateRight(),i[c][1]=o.rotateLeft();else if(n===-1&&s===1)o.left=i[c+1][1]=i[c+1][1].rotateLeft(),i[c][1]=o.rotateRight();else throw new Error;if(c>0)switch(i[c-1][0]){case-1:i[c-1][1].left=i[c][1];break;case 1:i[c-1][1].right=i[c][1];break;case 0:i[c-1][1].mid=i[c][1];break}else this.c=i[0][1]}}return r}get(b){return this.d(b)?.value}d(b){const v=this.b.reset(b);let g=this.c;for(;g;){const t=v.cmp(g.segment);if(t>0)g=g.left;else if(t<0)g=g.right;else if(v.hasNext())v.next(),g=g.mid;else break}return g}has(b){const v=this.d(b);return!(v?.value===void 0&&v?.mid===void 0)}delete(b){return this.e(b,!1)}deleteSuperstr(b){return this.e(b,!0)}e(b,v){const g=this.b.reset(b),t=[];let i=this.c;for(;i;){const r=g.cmp(i.segment);if(r>0)t.push([-1,i]),i=i.left;else if(r<0)t.push([1,i]),i=i.right;else if(g.hasNext())g.next(),t.push([0,i]),i=i.mid;else break}if(i){if(v?(i.left=void 0,i.mid=void 0,i.right=void 0,i.height=1):(i.key=void 0,i.value=void 0),!i.mid&&!i.value)if(i.left&&i.right){const r=this.f(i.right);if(r.key){const{key:c,value:o,segment:l}=r;this.e(r.key,!1),i.key=c,i.value=o,i.segment=l}}else{const r=i.left??i.right;if(t.length>0){const[c,o]=t[t.length-1];switch(c){case-1:o.left=r;break;case 0:o.mid=r;break;case 1:o.right=r;break}}else this.c=r}for(let r=t.length-1;r>=0;r--){const c=t[r][1];c.updateHeight();const o=c.balanceFactor();if(o>1?(c.right.balanceFactor()>=0||(c.right=c.right.rotateRight()),t[r][1]=c.rotateLeft()):o<-1&&(c.left.balanceFactor()<=0||(c.left=c.left.rotateLeft()),t[r][1]=c.rotateRight()),r>0)switch(t[r-1][0]){case-1:t[r-1][1].left=t[r][1];break;case 1:t[r-1][1].right=t[r][1];break;case 0:t[r-1][1].mid=t[r][1];break}else this.c=t[0][1]}}}f(b){for(;b.left;)b=b.left;return b}findSubstr(b){const v=this.b.reset(b);let g=this.c,t;for(;g;){const i=v.cmp(g.segment);if(i>0)g=g.left;else if(i<0)g=g.right;else if(v.hasNext())v.next(),t=g.value||t,g=g.mid;else break}return g&&g.value||t}findSuperstr(b){return this.g(b,!1)}g(b,v){const g=this.b.reset(b);let t=this.c;for(;t;){const i=g.cmp(t.segment);if(i>0)t=t.left;else if(i<0)t=t.right;else if(g.hasNext())g.next(),t=t.mid;else return t.mid?this.h(t.mid):v?t.value:void 0}}hasElementOrSubtree(b){return this.g(b,!0)!==void 0}forEach(b){for(const[v,g]of this)b(g,v)}*[Symbol.iterator](){yield*this.h(this.c)}h(b){const v=[];return this.j(b,v),v[Symbol.iterator]()}j(b,v){b&&(b.left&&this.j(b.left,v),b.value&&v.push([b.key,b.value]),b.mid&&this.j(b.mid,v),b.right&&this.j(b.right,v))}_isBalanced(){const b=v=>{if(!v)return!0;const g=v.balanceFactor();return g<-1||g>1?!1:b(v.left)&&b(v.right)};return b(this.c)}}e.$2h=D}),define(Pe[45],Ae([1,0,90]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$2j=e.ThemeColor=void 0;var T;(function(A){function $(E){return E&&typeof E=="object"&&typeof E.id=="string"}A.isThemeColor=$})(T||(e.ThemeColor=T={}));function P(A){return{id:A}}e.$2j=P;var M;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const $=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function E(r){const c=$.exec(r.id);if(!c)return E(y.$1j.error);const[,o,l]=c,n=["codicon","codicon-"+o];return l&&n.push("codicon-modifier-"+l.substring(1)),n}A.asClassNameArray=E;function f(r){return E(r).join(" ")}A.asClassName=f;function C(r){return"."+E(r).join(".")}A.asCSSSelector=C;function D(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color>"u"||T.isThemeColor(r.color))}A.isThemeIcon=D;const u=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function b(r){const c=u.exec(r);if(!c)return;const[,o]=c;return{id:o}}A.fromString=b;function v(r){return{id:r}}A.fromId=v;function g(r,c){let o=r.id;const l=o.lastIndexOf("~");return l!==-1&&(o=o.substring(0,l)),c&&(o=`${o}~${c}`),{id:o}}A.modify=g;function t(r){const c=r.id.lastIndexOf("~");if(c!==-1)return r.id.substring(c+1)}A.getModifier=t;function i(r,c){return r.id===c.id&&r.color?.id===c.color?.id}A.isEqual=i})(M||(e.ThemeIcon=M={}))}),define(Pe[125],Ae([1,0,123,12,45]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=void 0;const M="$(",A=new RegExp(`\\$\\(${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?\\)`,"g"),$=new RegExp(`(\\\\)?${A.source}`,"g");function E(i){return i.replace($,(r,c)=>c?r:`\\${r}`)}e.$3j=E;const f=new RegExp(`\\\\${A.source}`,"g");function C(i){return i.replace(f,r=>`\\${r}`)}e.$4j=C;const D=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function u(i){return i.indexOf(M)===-1?i:i.replace(D,(r,c,o,l)=>o?r:c||l||"")}e.$5j=u;function b(i){return i?i.replace(/\$\((.*?)\)/g,(r,c)=>` ${c} `).trim():""}e.$6j=b;const v=new RegExp(`\\$\\(${P.ThemeIcon.iconNameCharacter}+\\)`,"g");function g(i){v.lastIndex=0;let r="";const c=[];let o=0;for(;;){const l=v.lastIndex,n=v.exec(i),s=i.substring(l,n?.index);if(s.length>0){r+=s;for(let a=0;a<s.length;a++)c.push(o)}if(!n)break;o+=n[0].length}return{text:r,iconOffsets:c}}e.$7j=g;function t(i,r,c=!1){const{text:o,iconOffsets:l}=r;if(!l||l.length===0)return(0,y.$Pj)(i,o,c);const n=(0,T.$Ne)(o," "),s=o.length-n.length,a=(0,y.$Pj)(i,n,c);if(a)for(const d of a){const p=l[d.start+s]+s;d.start+=p,d.end+=p}return a}e.$8j=t}),define(Pe[38],Ae([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ig=e.$hg=void 0;const y=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(P){return y.test(P)}e.$hg=T,e.$ig=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function($){for(let E=0;E<$.length;E++)$[E]=Math.floor(Math.random()*256);return $};const M=new Uint8Array(16),A=[];for(let $=0;$<256;$++)A.push($.toString(16).padStart(2,"0"));return function(){P(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let E=0,f="";return f+=A[M[E++]],f+=A[M[E++]],f+=A[M[E++]],f+=A[M[E++]],f+="-",f+=A[M[E++]],f+=A[M[E++]],f+="-",f+=A[M[E++]],f+=A[M[E++]],f+="-",f+=A[M[E++]],f+=A[M[E++]],f+="-",f+=A[M[E++]],f+=A[M[E++]],f+=A[M[E++]],f+=A[M[E++]],f+=A[M[E++]],f+=A[M[E++]],f}}()}),define(Pe[126],Ae([1,0,18,67,38]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9s=e.$8s=e.$7s=e.$6s=e.$5s=void 0;function M(D){return{asString:async()=>D,asFile:()=>{},value:typeof D=="string"?D:void 0}}e.$5s=M;function A(D,u,b){const v={id:(0,P.$ig)(),name:D,uri:u,data:b};return{asString:async()=>"",asFile:()=>v,value:void 0}}e.$6s=A;class ${constructor(){this.a=new Map}get size(){let u=0;for(const b of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const b=[...this.a.keys()];return T.Iterable.some(this,([v,g])=>g.asFile())&&b.push("files"),C(E(u),b)}get(u){return this.a.get(this.b(u))?.[0]}append(u,b){const v=this.a.get(u);v?v.push(b):this.a.set(this.b(u),[b])}replace(u,b){this.a.set(this.b(u),[b])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,b]of this.a)for(const v of b)yield[u,v]}b(u){return E(u)}}e.$7s=$;function E(D){return D.toLowerCase()}function f(D,u){return C(E(D),u.map(E))}e.$8s=f;function C(D,u){if(D==="*/*")return u.length>0;if(u.includes(D))return!0;const b=D.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!b)return!1;const[v,g,t]=b;return t==="*"?u.some(i=>i.startsWith(g+"/")):!1}e.$9s=Object.freeze({create:D=>(0,y.$Lb)(D.map(u=>u.toString())).join(`\r
`),split:D=>D.split(`\r
`),parse:D=>e.$9s.split(D).filter(u=>!u.startsWith("#"))})}),define(Pe[127],Ae([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_s=e.StringEOL=void 0;var y;(function(P){P[P.Unknown=0]="Unknown",P[P.Invalid=3]="Invalid",P[P.LF=1]="LF",P[P.CRLF=2]="CRLF"})(y||(e.StringEOL=y={}));function T(P){let M=0,A=0,$=0,E=0;for(let f=0,C=P.length;f<C;f++){const D=P.charCodeAt(f);D===13?(M===0&&(A=f),M++,f+1<C&&P.charCodeAt(f+1)===10?(E|=2,f++):E|=3,$=f+1):D===10&&(E|=1,M===0&&(A=f),M++,$=f+1)}return M===0&&(A=P.length),[M,A,P.length-$,E]}e.$_s=T}),define(Pe[128],Ae([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9r=void 0,e.$9r={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Pe[129],Ae([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wt=e.$vt=e.IndentAction=void 0;var y;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(y||(e.IndentAction=y={}));class T{constructor($){if(this.e=null,this.f=!1,this.open=$.open,this.close=$.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray($.notIn))for(let E=0,f=$.notIn.length;E<f;E++)switch($.notIn[E]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK($){switch($){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose($,E){if($.getTokenCount()===0)return!0;const f=$.findTokenIndexAtOffset(E-2),C=$.getStandardTokenType(f);return this.isOK(C)}g($,E){for(let f=$;f<=E;f++){const C=String.fromCharCode(f);if(!this.open.includes(C)&&!this.close.includes(C))return C}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$vt=T;class P{constructor($){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of $)M(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),M(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),M(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),M(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&M(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.$wt=P;function M(A,$,E){A.has($)?A.get($).push(E):A.set($,[E])}}),define(Pe[130],Ae([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AB=e.$zB=e.$yB=e.$xB=e.$wB=e.$vB=e.$uB=e.$tB=e.$sB=e.NodeColor=e.$rB=void 0;class y{constructor(t,i){this.piece=t,this.color=i,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$sB)return P(this.right);let t=this;for(;t.parent!==e.$sB&&t.parent.left!==t;)t=t.parent;return t.parent===e.$sB?e.$sB:t.parent}prev(){if(this.left!==e.$sB)return M(this.left);let t=this;for(;t.parent!==e.$sB&&t.parent.right!==t;)t=t.parent;return t.parent===e.$sB?e.$sB:t.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$rB=y;var T;(function(g){g[g.Black=0]="Black",g[g.Red=1]="Red"})(T||(e.NodeColor=T={})),e.$sB=new y(null,0),e.$sB.parent=e.$sB,e.$sB.left=e.$sB,e.$sB.right=e.$sB,e.$sB.color=0;function P(g){for(;g.left!==e.$sB;)g=g.left;return g}e.$tB=P;function M(g){for(;g.right!==e.$sB;)g=g.right;return g}e.$uB=M;function A(g){return g===e.$sB?0:g.size_left+g.piece.length+A(g.right)}function $(g){return g===e.$sB?0:g.lf_left+g.piece.lineFeedCnt+$(g.right)}function E(){e.$sB.parent=e.$sB}function f(g,t){const i=t.right;i.size_left+=t.size_left+(t.piece?t.piece.length:0),i.lf_left+=t.lf_left+(t.piece?t.piece.lineFeedCnt:0),t.right=i.left,i.left!==e.$sB&&(i.left.parent=t),i.parent=t.parent,t.parent===e.$sB?g.root=i:t.parent.left===t?t.parent.left=i:t.parent.right=i,i.left=t,t.parent=i}e.$vB=f;function C(g,t){const i=t.left;t.left=i.right,i.right!==e.$sB&&(i.right.parent=t),i.parent=t.parent,t.size_left-=i.size_left+(i.piece?i.piece.length:0),t.lf_left-=i.lf_left+(i.piece?i.piece.lineFeedCnt:0),t.parent===e.$sB?g.root=i:t===t.parent.right?t.parent.right=i:t.parent.left=i,i.right=t,t.parent=i}e.$wB=C;function D(g,t){let i,r;if(t.left===e.$sB?(r=t,i=r.right):t.right===e.$sB?(r=t,i=r.left):(r=P(t.right),i=r.right),r===g.root){g.root=i,i.color=0,t.detach(),E(),g.root.parent=e.$sB;return}const c=r.color===1;if(r===r.parent.left?r.parent.left=i:r.parent.right=i,r===t?(i.parent=r.parent,v(g,i)):(r.parent===t?i.parent=r:i.parent=r.parent,v(g,i),r.left=t.left,r.right=t.right,r.parent=t.parent,r.color=t.color,t===g.root?g.root=r:t===t.parent.left?t.parent.left=r:t.parent.right=r,r.left!==e.$sB&&(r.left.parent=r),r.right!==e.$sB&&(r.right.parent=r),r.size_left=t.size_left,r.lf_left=t.lf_left,v(g,r)),t.detach(),i.parent.left===i){const l=A(i),n=$(i);if(l!==i.parent.size_left||n!==i.parent.lf_left){const s=l-i.parent.size_left,a=n-i.parent.lf_left;i.parent.size_left=l,i.parent.lf_left=n,b(g,i.parent,s,a)}}if(v(g,i.parent),c){E();return}let o;for(;i!==g.root&&i.color===0;)i===i.parent.left?(o=i.parent.right,o.color===1&&(o.color=0,i.parent.color=1,f(g,i.parent),o=i.parent.right),o.left.color===0&&o.right.color===0?(o.color=1,i=i.parent):(o.right.color===0&&(o.left.color=0,o.color=1,C(g,o),o=i.parent.right),o.color=i.parent.color,i.parent.color=0,o.right.color=0,f(g,i.parent),i=g.root)):(o=i.parent.left,o.color===1&&(o.color=0,i.parent.color=1,C(g,i.parent),o=i.parent.left),o.left.color===0&&o.right.color===0?(o.color=1,i=i.parent):(o.left.color===0&&(o.right.color=0,o.color=1,f(g,o),o=i.parent.left),o.color=i.parent.color,i.parent.color=0,o.left.color=0,C(g,i.parent),i=g.root));i.color=0,E()}e.$xB=D;function u(g,t){for(v(g,t);t!==g.root&&t.parent.color===1;)if(t.parent===t.parent.parent.left){const i=t.parent.parent.right;i.color===1?(t.parent.color=0,i.color=0,t.parent.parent.color=1,t=t.parent.parent):(t===t.parent.right&&(t=t.parent,f(g,t)),t.parent.color=0,t.parent.parent.color=1,C(g,t.parent.parent))}else{const i=t.parent.parent.left;i.color===1?(t.parent.color=0,i.color=0,t.parent.parent.color=1,t=t.parent.parent):(t===t.parent.left&&(t=t.parent,C(g,t)),t.parent.color=0,t.parent.parent.color=1,f(g,t.parent.parent))}g.root.color=0}e.$yB=u;function b(g,t,i,r){for(;t!==g.root&&t!==e.$sB;)t.parent.left===t&&(t.parent.size_left+=i,t.parent.lf_left+=r),t=t.parent}e.$zB=b;function v(g,t){let i=0,r=0;if(t!==g.root){for(;t!==g.root&&t===t.parent.right;)t=t.parent;if(t!==g.root)for(t=t.parent,i=A(t.left)-t.size_left,r=$(t.left)-t.lf_left,t.size_left+=i,t.lf_left+=r;t!==g.root&&(i!==0||r!==0);)t.parent.left===t&&(t.parent.size_left+=i,t.parent.lf_left+=r),t=t.parent}}e.$AB=v}),define(Pe[91],Ae([1,0,131,29,92,130,93]),function(we,e,y,T,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LB=e.$KB=e.$JB=e.$IB=e.$HB=void 0;const $=65535;function E(i){let r;return i[i.length-1]<65536?r=new Uint16Array(i.length):r=new Uint32Array(i.length),r.set(i,0),r}class f{constructor(r,c,o,l,n){this.lineStarts=r,this.cr=c,this.lf=o,this.crlf=l,this.isBasicASCII=n}}function C(i,r=!0){const c=[0];let o=1;for(let l=0,n=i.length;l<n;l++){const s=i.charCodeAt(l);s===13?l+1<n&&i.charCodeAt(l+1)===10?(c[o++]=l+2,l++):c[o++]=l+1:s===10&&(c[o++]=l+1)}return r?E(c):c}e.$HB=C;function D(i,r){i.length=0,i[0]=0;let c=1,o=0,l=0,n=0,s=!0;for(let d=0,p=r.length;d<p;d++){const m=r.charCodeAt(d);m===13?d+1<p&&r.charCodeAt(d+1)===10?(n++,i[c++]=d+2,d++):(o++,i[c++]=d+1):m===10?(l++,i[c++]=d+1):s&&m!==9&&(m<32||m>126)&&(s=!1)}const a=new f(E(i),o,l,n,s);return i.length=0,a}e.$IB=D;class u{constructor(r,c,o,l,n){this.bufferIndex=r,this.start=c,this.end=o,this.lineFeedCnt=l,this.length=n}}e.$JB=u;class b{constructor(r,c){this.buffer=r,this.lineStarts=c}}e.$KB=b;class v{constructor(r,c){this.a=[],this.c=r,this.d=c,this.b=0,r.root!==M.$sB&&r.iterate(r.root,o=>(o!==M.$sB&&this.a.push(o.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class g{constructor(r){this.a=r,this.b=[]}get(r){for(let c=this.b.length-1;c>=0;c--){const o=this.b[c];if(o.nodeStartOffset<=r&&o.nodeStartOffset+o.node.piece.length>=r)return o}return null}get2(r){for(let c=this.b.length-1;c>=0;c--){const o=this.b[c];if(o.nodeStartLineNumber&&o.nodeStartLineNumber<r&&o.nodeStartLineNumber+o.node.piece.lineFeedCnt>=r)return o}return null}set(r){this.b.length>=this.a&&this.b.shift(),this.b.push(r)}validate(r){let c=!1;const o=this.b;for(let l=0;l<o.length;l++){const n=o[l];if(n.node.parent===null||n.nodeStartOffset>=r){o[l]=null,c=!0;continue}}if(c){const l=[];for(const n of o)n!==null&&l.push(n);this.b=l}}}class t{constructor(r,c,o){this.create(r,c,o)}create(r,c,o){this.a=[new b("",[0])],this.g={line:0,column:0},this.root=M.$sB,this.b=1,this.c=0,this.d=c,this.e=c.length,this.f=o;let l=null;for(let n=0,s=r.length;n<s;n++)if(r[n].buffer.length>0){r[n].lineStarts||(r[n].lineStarts=C(r[n].buffer));const a=new u(n+1,{line:0,column:0},{line:r[n].lineStarts.length-1,column:r[n].buffer.length-r[n].lineStarts[r[n].lineStarts.length-1]},r[n].lineStarts.length-1,r[n].buffer.length);this.a.push(r[n]),l=this.S(l,a)}this.h=new g(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(r){const c=$,o=c-Math.floor(c/3),l=o*2;let n="",s=0;const a=[];if(this.iterate(this.root,d=>{const p=this.R(d),m=p.length;if(s<=o||s+m<l)return n+=p,s+=m,!0;const S=n.replace(/\r\n|\r|\n/g,r);return a.push(new b(S,C(S))),n=p,s=m,!0}),s>0){const d=n.replace(/\r\n|\r|\n/g,r);a.push(new b(d,C(d)))}this.create(a,r,!0)}getEOL(){return this.d}setEOL(r){this.d=r,this.e=this.d.length,this.normalizeEOL(r)}createSnapshot(r){return new v(this,r)}equal(r){if(this.getLength()!==r.getLength()||this.getLineCount()!==r.getLineCount())return!1;let c=0;return this.iterate(this.root,l=>{if(l===M.$sB)return!0;const n=this.R(l),s=n.length,a=r.G(c),d=r.G(c+s),p=r.getValueInRange2(a,d);return c+=s,n===p})}getOffsetAt(r,c){let o=0,l=this.root;for(;l!==M.$sB;)if(l.left!==M.$sB&&l.lf_left+1>=r)l=l.left;else if(l.lf_left+l.piece.lineFeedCnt+1>=r){o+=l.size_left;const n=this.B(l,r-l.lf_left-2);return o+=n+c-1}else r-=l.lf_left+l.piece.lineFeedCnt,o+=l.size_left+l.piece.length,l=l.right;return o}getPositionAt(r){r=Math.floor(r),r=Math.max(0,r);let c=this.root,o=0;const l=r;for(;c!==M.$sB;)if(c.size_left!==0&&c.size_left>=r)c=c.left;else if(c.size_left+c.piece.length>=r){const n=this.A(c,r-c.size_left);if(o+=c.lf_left+n.index,n.index===0){const s=this.getOffsetAt(o+1,1),a=l-s;return new y.$ys(o+1,a+1)}return new y.$ys(o+1,n.remainder+1)}else if(r-=c.size_left+c.piece.length,o+=c.lf_left+c.piece.lineFeedCnt,c.right===M.$sB){const n=this.getOffsetAt(o+1,1),s=l-r-n;return new y.$ys(o+1,s+1)}else c=c.right;return new y.$ys(1,1)}getValueInRange(r,c){if(r.startLineNumber===r.endLineNumber&&r.startColumn===r.endColumn)return"";const o=this.H(r.startLineNumber,r.startColumn),l=this.H(r.endLineNumber,r.endColumn),n=this.getValueInRange2(o,l);return c?c!==this.d||!this.f?n.replace(/\r\n|\r|\n/g,c):c===this.getEOL()&&this.f?n:n.replace(/\r\n|\r|\n/g,c):n}getValueInRange2(r,c){if(r.node===c.node){const a=r.node,d=this.a[a.piece.bufferIndex].buffer,p=this.u(a.piece.bufferIndex,a.piece.start);return d.substring(p+r.remainder,p+c.remainder)}let o=r.node;const l=this.a[o.piece.bufferIndex].buffer,n=this.u(o.piece.bufferIndex,o.piece.start);let s=l.substring(n+r.remainder,n+o.piece.length);for(o=o.next();o!==M.$sB;){const a=this.a[o.piece.bufferIndex].buffer,d=this.u(o.piece.bufferIndex,o.piece.start);if(o===c.node){s+=a.substring(d,d+c.remainder);break}else s+=a.substr(d,o.piece.length);o=o.next()}return s}getLinesContent(){const r=[];let c=0,o="",l=!1;return this.iterate(this.root,n=>{if(n===M.$sB)return!0;const s=n.piece;let a=s.length;if(a===0)return!0;const d=this.a[s.bufferIndex].buffer,p=this.a[s.bufferIndex].lineStarts,m=s.start.line,S=s.end.line;let k=p[m]+s.start.column;if(l&&(d.charCodeAt(k)===10&&(k++,a--),r[c++]=o,o="",l=!1,a===0))return!0;if(m===S)return!this.f&&d.charCodeAt(k+a-1)===13?(l=!0,o+=d.substr(k,a-1)):o+=d.substr(k,a),!0;o+=this.f?d.substring(k,Math.max(k,p[m+1]-this.e)):d.substring(k,p[m+1]).replace(/(\r\n|\r|\n)$/,""),r[c++]=o;for(let h=m+1;h<S;h++)o=this.f?d.substring(p[h],p[h+1]-this.e):d.substring(p[h],p[h+1]).replace(/(\r\n|\r|\n)$/,""),r[c++]=o;return!this.f&&d.charCodeAt(p[S]+s.end.column-1)===13?(l=!0,s.end.column===0?c--:o=d.substr(p[S],s.end.column-1)):o=d.substr(p[S],s.end.column),!0}),l&&(r[c++]=o,o=""),r[c++]=o,r}getLength(){return this.c}getLineCount(){return this.b}getLineContent(r){return this.j.lineNumber===r?this.j.value:(this.j.lineNumber=r,r===this.b?this.j.value=this.getLineRawContent(r):this.f?this.j.value=this.getLineRawContent(r,this.e):this.j.value=this.getLineRawContent(r).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(r){if(r.remainder===r.node.piece.length){const c=r.node.next();if(!c)return 0;const o=this.a[c.piece.bufferIndex],l=this.u(c.piece.bufferIndex,c.piece.start);return o.buffer.charCodeAt(l)}else{const c=this.a[r.node.piece.bufferIndex],l=this.u(r.node.piece.bufferIndex,r.node.piece.start)+r.remainder;return c.buffer.charCodeAt(l)}}getLineCharCode(r,c){const o=this.H(r,c+1);return this.l(o)}getLineLength(r){if(r===this.getLineCount()){const c=this.getOffsetAt(r,1);return this.getLength()-c}return this.getOffsetAt(r+1,1)-this.getOffsetAt(r,1)-this.e}getCharCode(r){const c=this.G(r);return this.l(c)}findMatchesInNode(r,c,o,l,n,s,a,d,p,m,S){const k=this.a[r.piece.bufferIndex],h=this.u(r.piece.bufferIndex,r.piece.start),w=this.u(r.piece.bufferIndex,n),I=this.u(r.piece.bufferIndex,s);let F;const V={line:0,column:0};let Z,N;c._wordSeparators?(Z=k.buffer.substring(w,I),N=R=>R+w,c.reset(0)):(Z=k.buffer,N=R=>R,c.reset(w));do if(F=c.next(Z),F){if(N(F.index)>=I)return m;this.s(r,N(F.index)-h,V);const R=this.t(r.piece.bufferIndex,n,V),L=V.line===n.line?V.column-n.column+l:V.column+1,O=L+F[0].length;if(S[m++]=(0,A.$DB)(new T.$zs(o+R,L,o+R,O),F,d),N(F.index)+F[0].length>=I||m>=p)return m}while(F);return m}findMatchesLineByLine(r,c,o,l){const n=[];let s=0;const a=new A.$GB(c.wordSeparators,c.regex);let d=this.H(r.startLineNumber,r.startColumn);if(d===null)return[];const p=this.H(r.endLineNumber,r.endColumn);if(p===null)return[];let m=this.s(d.node,d.remainder);const S=this.s(p.node,p.remainder);if(d.node===p.node)return this.findMatchesInNode(d.node,a,r.startLineNumber,r.startColumn,m,S,c,o,l,s,n),n;let k=r.startLineNumber,h=d.node;for(;h!==p.node;){const I=this.t(h.piece.bufferIndex,m,h.piece.end);if(I>=1){const V=this.a[h.piece.bufferIndex].lineStarts,Z=this.u(h.piece.bufferIndex,h.piece.start),N=V[m.line+I],R=k===r.startLineNumber?r.startColumn:1;if(s=this.findMatchesInNode(h,a,k,R,m,this.s(h,N-Z),c,o,l,s,n),s>=l)return n;k+=I}const F=k===r.startLineNumber?r.startColumn-1:0;if(k===r.endLineNumber){const V=this.getLineContent(k).substring(F,r.endColumn-1);return s=this.n(c,a,V,r.endLineNumber,F,s,n,o,l),n}if(s=this.n(c,a,this.getLineContent(k).substr(F),k,F,s,n,o,l),s>=l)return n;k++,d=this.H(k,1),h=d.node,m=this.s(d.node,d.remainder)}if(k===r.endLineNumber){const I=k===r.startLineNumber?r.startColumn-1:0,F=this.getLineContent(k).substring(I,r.endColumn-1);return s=this.n(c,a,F,r.endLineNumber,I,s,n,o,l),n}const w=k===r.startLineNumber?r.startColumn:1;return s=this.findMatchesInNode(p.node,a,k,w,m,S,c,o,l,s,n),n}n(r,c,o,l,n,s,a,d,p){const m=r.wordSeparators;if(!d&&r.simpleSearch){const k=r.simpleSearch,h=k.length,w=o.length;let I=-h;for(;(I=o.indexOf(k,I+h))!==-1;)if((!m||(0,A.$FB)(m,o,w,I,h))&&(a[s++]=new P.$Qu(new T.$zs(l,I+1+n,l,I+1+h+n),null),s>=p))return s;return s}let S;c.reset(0);do if(S=c.next(o),S&&(a[s++]=(0,A.$DB)(new T.$zs(l,S.index+1+n,l,S.index+1+S[0].length+n),S,d),s>=p))return s;while(S);return s}insert(r,c,o=!1){if(this.f=this.f&&o,this.j.lineNumber=0,this.j.value="",this.root!==M.$sB){const{node:l,remainder:n,nodeStartOffset:s}=this.G(r),a=l.piece,d=a.bufferIndex,p=this.s(l,n);if(l.piece.bufferIndex===0&&a.end.line===this.g.line&&a.end.column===this.g.column&&s+a.length===r&&c.length<$){this.F(l,c),this.y();return}if(s===r)this.o(c,l),this.h.validate(r);else if(s+l.piece.length>r){const m=[];let S=new u(a.bufferIndex,p,a.end,this.t(a.bufferIndex,p,a.end),this.u(d,a.end)-this.u(d,p));if(this.K()&&this.M(c)&&this.I(l,n)===10){const I={line:S.start.line+1,column:0};S=new u(S.bufferIndex,I,S.end,this.t(S.bufferIndex,I,S.end),S.length-1),c+=`
`}if(this.K()&&this.L(c))if(this.I(l,n-1)===13){const I=this.s(l,n-1);this.C(l,I),c="\r"+c,l.piece.length===0&&m.push(l)}else this.C(l,p);else this.C(l,p);const k=this.w(c);S.length>0&&this.S(l,S);let h=l;for(let w=0;w<k.length;w++)h=this.S(h,k[w]);this.v(m)}else this.q(c,l)}else{const l=this.w(c);let n=this.T(null,l[0]);for(let s=1;s<l.length;s++)n=this.S(n,l[s])}this.y()}delete(r,c){if(this.j.lineNumber=0,this.j.value="",c<=0||this.root===M.$sB)return;const o=this.G(r),l=this.G(r+c),n=o.node,s=l.node;if(n===s){const k=this.s(n,o.remainder),h=this.s(n,l.remainder);if(o.nodeStartOffset===r){if(c===n.piece.length){const w=n.next();(0,M.$xB)(this,n),this.N(w),this.y();return}this.D(n,h),this.h.validate(r),this.N(n),this.y();return}if(o.nodeStartOffset+n.piece.length===r+c){this.C(n,k),this.O(n),this.y();return}this.E(n,k,h),this.y();return}const a=[],d=this.s(n,o.remainder);this.C(n,d),this.h.validate(r),n.piece.length===0&&a.push(n);const p=this.s(s,l.remainder);this.D(s,p),s.piece.length===0&&a.push(s);const m=n.next();for(let k=m;k!==M.$sB&&k!==s;k=k.next())a.push(k);const S=n.piece.length===0?n.prev():n;this.v(a),this.O(S),this.y()}o(r,c){const o=[];if(this.K()&&this.M(r)&&this.L(c)){const s=c.piece,a={line:s.start.line+1,column:0},d=new u(s.bufferIndex,a,s.end,this.t(s.bufferIndex,a,s.end),s.length-1);c.piece=d,r+=`
`,(0,M.$zB)(this,c,-1,-1),c.piece.length===0&&o.push(c)}const l=this.w(r);let n=this.T(c,l[l.length-1]);for(let s=l.length-2;s>=0;s--)n=this.T(n,l[s]);this.N(n),this.v(o)}q(r,c){this.Q(r,c)&&(r+=`
`);const o=this.w(r),l=this.S(c,o[0]);let n=l;for(let s=1;s<o.length;s++)n=this.S(n,o[s]);this.N(l)}s(r,c,o){const l=r.piece,n=r.piece.bufferIndex,s=this.a[n].lineStarts,d=s[l.start.line]+l.start.column+c;let p=l.start.line,m=l.end.line,S=0,k=0,h=0;for(;p<=m&&(S=p+(m-p)/2|0,h=s[S],S!==m);)if(k=s[S+1],d<h)m=S-1;else if(d>=k)p=S+1;else break;return o?(o.line=S,o.column=d-h,null):{line:S,column:d-h}}t(r,c,o){if(o.column===0)return o.line-c.line;const l=this.a[r].lineStarts;if(o.line===l.length-1)return o.line-c.line;const n=l[o.line+1],s=l[o.line]+o.column;if(n>s+1)return o.line-c.line;const a=s-1;return this.a[r].buffer.charCodeAt(a)===13?o.line-c.line+1:o.line-c.line}u(r,c){return this.a[r].lineStarts[c.line]+c.column}v(r){for(let c=0;c<r.length;c++)(0,M.$xB)(this,r[c])}w(r){if(r.length>$){const m=[];for(;r.length>$;){const k=r.charCodeAt($-1);let h;k===13||k>=55296&&k<=56319?(h=r.substring(0,$-1),r=r.substring($-1)):(h=r.substring(0,$),r=r.substring($));const w=C(h);m.push(new u(this.a.length,{line:0,column:0},{line:w.length-1,column:h.length-w[w.length-1]},w.length-1,h.length)),this.a.push(new b(h,w))}const S=C(r);return m.push(new u(this.a.length,{line:0,column:0},{line:S.length-1,column:r.length-S[S.length-1]},S.length-1,r.length)),this.a.push(new b(r,S)),m}let c=this.a[0].buffer.length;const o=C(r,!1);let l=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===c&&c!==0&&this.L(r)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},l=this.g;for(let m=0;m<o.length;m++)o[m]+=c+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(o.slice(1)),this.a[0].buffer+="_"+r,c+=1}else{if(c!==0)for(let m=0;m<o.length;m++)o[m]+=c;this.a[0].lineStarts=this.a[0].lineStarts.concat(o.slice(1)),this.a[0].buffer+=r}const n=this.a[0].buffer.length,s=this.a[0].lineStarts.length-1,a=n-this.a[0].lineStarts[s],d={line:s,column:a},p=new u(0,l,d,this.t(0,l,d),n-c);return this.g=d,[p]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(r,c=0){let o=this.root,l="";const n=this.h.get2(r);if(n){o=n.node;const s=this.B(o,r-n.nodeStartLineNumber-1),a=this.a[o.piece.bufferIndex].buffer,d=this.u(o.piece.bufferIndex,o.piece.start);if(n.nodeStartLineNumber+o.piece.lineFeedCnt===r)l=a.substring(d+s,d+o.piece.length);else{const p=this.B(o,r-n.nodeStartLineNumber);return a.substring(d+s,d+p-c)}}else{let s=0;const a=r;for(;o!==M.$sB;)if(o.left!==M.$sB&&o.lf_left>=r-1)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt>r-1){const d=this.B(o,r-o.lf_left-2),p=this.B(o,r-o.lf_left-1),m=this.a[o.piece.bufferIndex].buffer,S=this.u(o.piece.bufferIndex,o.piece.start);return s+=o.size_left,this.h.set({node:o,nodeStartOffset:s,nodeStartLineNumber:a-(r-1-o.lf_left)}),m.substring(S+d,S+p-c)}else if(o.lf_left+o.piece.lineFeedCnt===r-1){const d=this.B(o,r-o.lf_left-2),p=this.a[o.piece.bufferIndex].buffer,m=this.u(o.piece.bufferIndex,o.piece.start);l=p.substring(m+d,m+o.piece.length);break}else r-=o.lf_left+o.piece.lineFeedCnt,s+=o.size_left+o.piece.length,o=o.right}for(o=o.next();o!==M.$sB;){const s=this.a[o.piece.bufferIndex].buffer;if(o.piece.lineFeedCnt>0){const a=this.B(o,0),d=this.u(o.piece.bufferIndex,o.piece.start);return l+=s.substring(d,d+a-c),l}else{const a=this.u(o.piece.bufferIndex,o.piece.start);l+=s.substr(a,o.piece.length)}o=o.next()}return l}y(){let r=this.root,c=1,o=0;for(;r!==M.$sB;)c+=r.lf_left+r.piece.lineFeedCnt,o+=r.size_left+r.piece.length,r=r.right;this.b=c,this.c=o,this.h.validate(this.c)}A(r,c){const o=r.piece,l=this.s(r,c),n=l.line-o.start.line;if(this.u(o.bufferIndex,o.end)-this.u(o.bufferIndex,o.start)===c){const s=this.t(r.piece.bufferIndex,o.start,l);if(s!==n)return{index:s,remainder:0}}return{index:n,remainder:l.column}}B(r,c){if(c<0)return 0;const o=r.piece,l=this.a[o.bufferIndex].lineStarts,n=o.start.line+c+1;return n>o.end.line?l[o.end.line]+o.end.column-l[o.start.line]-o.start.column:l[n]-l[o.start.line]-o.start.column}C(r,c){const o=r.piece,l=o.lineFeedCnt,n=this.u(o.bufferIndex,o.end),s=c,a=this.u(o.bufferIndex,s),d=this.t(o.bufferIndex,o.start,s),p=d-l,m=a-n,S=o.length+m;r.piece=new u(o.bufferIndex,o.start,s,d,S),(0,M.$zB)(this,r,m,p)}D(r,c){const o=r.piece,l=o.lineFeedCnt,n=this.u(o.bufferIndex,o.start),s=c,a=this.t(o.bufferIndex,s,o.end),d=this.u(o.bufferIndex,s),p=a-l,m=n-d,S=o.length+m;r.piece=new u(o.bufferIndex,s,o.end,a,S),(0,M.$zB)(this,r,m,p)}E(r,c,o){const l=r.piece,n=l.start,s=l.end,a=l.length,d=l.lineFeedCnt,p=c,m=this.t(l.bufferIndex,l.start,p),S=this.u(l.bufferIndex,c)-this.u(l.bufferIndex,n);r.piece=new u(l.bufferIndex,l.start,p,m,S),(0,M.$zB)(this,r,S-a,m-d);const k=new u(l.bufferIndex,o,s,this.t(l.bufferIndex,o,s),this.u(l.bufferIndex,s)-this.u(l.bufferIndex,o)),h=this.S(r,k);this.N(h)}F(r,c){this.Q(c,r)&&(c+=`
`);const o=this.K()&&this.L(c)&&this.M(r),l=this.a[0].buffer.length;this.a[0].buffer+=c;const n=C(c,!1);for(let h=0;h<n.length;h++)n[h]+=l;if(o){const h=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:l-h}}this.a[0].lineStarts=this.a[0].lineStarts.concat(n.slice(1));const s=this.a[0].lineStarts.length-1,a=this.a[0].buffer.length-this.a[0].lineStarts[s],d={line:s,column:a},p=r.piece.length+c.length,m=r.piece.lineFeedCnt,S=this.t(0,r.piece.start,d),k=S-m;r.piece=new u(r.piece.bufferIndex,r.piece.start,d,S,p),this.g=d,(0,M.$zB)(this,r,c.length,k)}G(r){let c=this.root;const o=this.h.get(r);if(o)return{node:o.node,nodeStartOffset:o.nodeStartOffset,remainder:r-o.nodeStartOffset};let l=0;for(;c!==M.$sB;)if(c.size_left>r)c=c.left;else if(c.size_left+c.piece.length>=r){l+=c.size_left;const n={node:c,remainder:r-c.size_left,nodeStartOffset:l};return this.h.set(n),n}else r-=c.size_left+c.piece.length,l+=c.size_left+c.piece.length,c=c.right;return null}H(r,c){let o=this.root,l=0;for(;o!==M.$sB;)if(o.left!==M.$sB&&o.lf_left>=r-1)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt>r-1){const n=this.B(o,r-o.lf_left-2),s=this.B(o,r-o.lf_left-1);return l+=o.size_left,{node:o,remainder:Math.min(n+c-1,s),nodeStartOffset:l}}else if(o.lf_left+o.piece.lineFeedCnt===r-1){const n=this.B(o,r-o.lf_left-2);if(n+c-1<=o.piece.length)return{node:o,remainder:n+c-1,nodeStartOffset:l};c-=o.piece.length-n;break}else r-=o.lf_left+o.piece.lineFeedCnt,l+=o.size_left+o.piece.length,o=o.right;for(o=o.next();o!==M.$sB;){if(o.piece.lineFeedCnt>0){const n=this.B(o,0),s=this.J(o);return{node:o,remainder:Math.min(c-1,n),nodeStartOffset:s}}else if(o.piece.length>=c-1){const n=this.J(o);return{node:o,remainder:c-1,nodeStartOffset:n}}else c-=o.piece.length;o=o.next()}return null}I(r,c){if(r.piece.lineFeedCnt<1)return-1;const o=this.a[r.piece.bufferIndex],l=this.u(r.piece.bufferIndex,r.piece.start)+c;return o.buffer.charCodeAt(l)}J(r){if(!r)return 0;let c=r.size_left;for(;r!==this.root;)r.parent.right===r&&(c+=r.parent.size_left+r.parent.piece.length),r=r.parent;return c}K(){return!(this.f&&this.d===`
`)}L(r){if(typeof r=="string")return r.charCodeAt(0)===10;if(r===M.$sB||r.piece.lineFeedCnt===0)return!1;const c=r.piece,o=this.a[c.bufferIndex].lineStarts,l=c.start.line,n=o[l]+c.start.column;return l===o.length-1||o[l+1]>n+1?!1:this.a[c.bufferIndex].buffer.charCodeAt(n)===10}M(r){return typeof r=="string"?r.charCodeAt(r.length-1)===13:r===M.$sB||r.piece.lineFeedCnt===0?!1:this.I(r,r.piece.length-1)===13}N(r){if(this.K()&&this.L(r)){const c=r.prev();this.M(c)&&this.P(c,r)}}O(r){if(this.K()&&this.M(r)){const c=r.next();this.L(c)&&this.P(r,c)}}P(r,c){const o=[],l=this.a[r.piece.bufferIndex].lineStarts;let n;r.piece.end.column===0?n={line:r.piece.end.line-1,column:l[r.piece.end.line]-l[r.piece.end.line-1]-1}:n={line:r.piece.end.line,column:r.piece.end.column-1};const s=r.piece.length-1,a=r.piece.lineFeedCnt-1;r.piece=new u(r.piece.bufferIndex,r.piece.start,n,a,s),(0,M.$zB)(this,r,-1,-1),r.piece.length===0&&o.push(r);const d={line:c.piece.start.line+1,column:0},p=c.piece.length-1,m=this.t(c.piece.bufferIndex,d,c.piece.end);c.piece=new u(c.piece.bufferIndex,d,c.piece.end,m,p),(0,M.$zB)(this,c,-1,-1),c.piece.length===0&&o.push(c);const S=this.w(`\r
`);this.S(r,S[0]);for(let k=0;k<o.length;k++)(0,M.$xB)(this,o[k])}Q(r,c){if(this.K()&&this.M(r)){const o=c.next();if(this.L(o)){if(r+=`
`,o.piece.length===1)(0,M.$xB)(this,o);else{const l=o.piece,n={line:l.start.line+1,column:0},s=l.length-1,a=this.t(l.bufferIndex,n,l.end);o.piece=new u(l.bufferIndex,n,l.end,a,s),(0,M.$zB)(this,o,-1,-1)}return!0}}return!1}iterate(r,c){if(r===M.$sB)return c(M.$sB);const o=this.iterate(r.left,c);return o&&c(r)&&this.iterate(r.right,c)}R(r){if(r===M.$sB)return"";const c=this.a[r.piece.bufferIndex],o=r.piece,l=this.u(o.bufferIndex,o.start),n=this.u(o.bufferIndex,o.end);return c.buffer.substring(l,n)}getPieceContent(r){const c=this.a[r.bufferIndex],o=this.u(r.bufferIndex,r.start),l=this.u(r.bufferIndex,r.end);return c.buffer.substring(o,l)}S(r,c){const o=new M.$rB(c,1);if(o.left=M.$sB,o.right=M.$sB,o.parent=M.$sB,o.size_left=0,o.lf_left=0,this.root===M.$sB)this.root=o,o.color=0;else if(r.right===M.$sB)r.right=o,o.parent=r;else{const n=(0,M.$tB)(r.right);n.left=o,o.parent=n}return(0,M.$yB)(this,o),o}T(r,c){const o=new M.$rB(c,1);if(o.left=M.$sB,o.right=M.$sB,o.parent=M.$sB,o.size_left=0,o.lf_left=0,this.root===M.$sB)this.root=o,o.color=0;else if(r.left===M.$sB)r.left=o,o.parent=r;else{const l=(0,M.$uB)(r.left);l.right=o,o.parent=l}return(0,M.$yB)(this,o),o}U(r){let c="";return this.iterate(r,o=>(c+=this.R(o),!0)),c}}e.$LB=t}),define(Pe[132],Ae([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T7=e.$S7=void 0;class y{constructor(){this.a=new Map}removeDragOperationTransfer(M){if(M&&this.a.has(M)){const A=this.a.get(M);return this.a.delete(M),A}}addDragOperationTransfer(M,A){this.a.set(M,A)}}e.$S7=y;class T{constructor(M){this.identifier=M}}e.$T7=T}),define(Pe[133],Ae([9,10]),function(we,e){return we.create("vs/base/common/actions",e)}),define(Pe[134],Ae([1,0,5,6,133]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=void 0;class M extends T.$Rc{constructor(u,b="",v="",g=!0,t){super(),this.h=this.B(new y.$Rd),this.onDidChange=this.h.event,this.w=!0,this.j=u,this.m=b,this.u=v,this.w=g,this.C=t}get id(){return this.j}get label(){return this.m}set label(u){this.D(u)}D(u){this.m!==u&&(this.m=u,this.h.fire({label:u}))}get tooltip(){return this.n||""}set tooltip(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.h.fire({tooltip:u}))}get class(){return this.u}set class(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.h.fire({class:u}))}get enabled(){return this.w}set enabled(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.h.fire({enabled:u}))}get checked(){return this.z}set checked(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.h.fire({checked:u}))}async run(u,b){this.C&&await this.C(u)}}e.$Ai=M;class A extends T.$Rc{constructor(){super(...arguments),this.f=this.B(new y.$Rd),this.onWillRun=this.f.event,this.m=this.B(new y.$Rd),this.onDidRun=this.m.event}async run(u,b){if(!u.enabled)return;this.f.fire({action:u});let v;try{await this.u(u,b)}catch(g){v=g}this.m.fire({action:u,error:v})}async u(u,b){await u.run(b)}}e.$Bi=A;class ${constructor(){this.id=$.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let b=[];for(const v of u)v.length&&(b.length?b=[...b,new $,...v]:b=v);return b}static{this.ID="vs.actions.separator"}async run(){}}e.$Ci=$;class E{get actions(){return this.a}constructor(u,b,v,g){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=b,this.class=g,this.a=v}async run(){}}e.$Di=E;class f extends M{static{this.ID="vs.actions.empty"}constructor(){super(f.ID,P.localize(0,null),void 0,!1)}}e.$Ei=f;function C(D){return{id:D.id,label:D.label,class:void 0,enabled:D.enabled??!0,checked:D.checked??!1,run:async(...u)=>D.run(...u),tooltip:D.label}}e.$Fi=C}),define(Pe[135],Ae([9,10]),function(we,e){return we.create("vs/base/common/date",e)}),define(Pe[136],Ae([1,0,135]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$km=e.$jm=void 0;const T=60,P=T*60,M=P*24,A=M*7,$=M*30,E=M*365;function f(D,u,b,v){typeof D!="number"&&(D=D.getTime());const g=Math.round((new Date().getTime()-D)/1e3);if(g<-30)return(0,y.localize)(0,null,f(new Date().getTime()+g*1e3,!1));if(!v&&g<30)return(0,y.localize)(1,null);let t;return g<T?(t=g,u?t===1?b?(0,y.localize)(2,null,t):(0,y.localize)(3,null,t):b?(0,y.localize)(4,null,t):(0,y.localize)(5,null,t):t===1?b?(0,y.localize)(6,null,t):(0,y.localize)(7,null,t):b?(0,y.localize)(8,null,t):(0,y.localize)(9,null,t)):g<P?(t=Math.floor(g/T),u?t===1?b?(0,y.localize)(10,null,t):(0,y.localize)(11,null,t):b?(0,y.localize)(12,null,t):(0,y.localize)(13,null,t):t===1?b?(0,y.localize)(14,null,t):(0,y.localize)(15,null,t):b?(0,y.localize)(16,null,t):(0,y.localize)(17,null,t)):g<M?(t=Math.floor(g/P),u?t===1?b?(0,y.localize)(18,null,t):(0,y.localize)(19,null,t):b?(0,y.localize)(20,null,t):(0,y.localize)(21,null,t):t===1?b?(0,y.localize)(22,null,t):(0,y.localize)(23,null,t):b?(0,y.localize)(24,null,t):(0,y.localize)(25,null,t)):g<A?(t=Math.floor(g/M),u?t===1?(0,y.localize)(26,null,t):(0,y.localize)(27,null,t):t===1?(0,y.localize)(28,null,t):(0,y.localize)(29,null,t)):g<$?(t=Math.floor(g/A),u?t===1?b?(0,y.localize)(30,null,t):(0,y.localize)(31,null,t):b?(0,y.localize)(32,null,t):(0,y.localize)(33,null,t):t===1?b?(0,y.localize)(34,null,t):(0,y.localize)(35,null,t):b?(0,y.localize)(36,null,t):(0,y.localize)(37,null,t)):g<E?(t=Math.floor(g/$),u?t===1?b?(0,y.localize)(38,null,t):(0,y.localize)(39,null,t):b?(0,y.localize)(40,null,t):(0,y.localize)(41,null,t):t===1?b?(0,y.localize)(42,null,t):(0,y.localize)(43,null,t):b?(0,y.localize)(44,null,t):(0,y.localize)(45,null,t)):(t=Math.floor(g/E),u?t===1?b?(0,y.localize)(46,null,t):(0,y.localize)(47,null,t):b?(0,y.localize)(48,null,t):(0,y.localize)(49,null,t):t===1?b?(0,y.localize)(50,null,t):(0,y.localize)(51,null,t):b?(0,y.localize)(52,null,t):(0,y.localize)(53,null,t))}e.$jm=f;function C(D){return D.getFullYear()+"-"+String(D.getMonth()+1).padStart(2,"0")+"-"+String(D.getDate()).padStart(2,"0")+"T"+String(D.getHours()).padStart(2,"0")+":"+String(D.getMinutes()).padStart(2,"0")+":"+String(D.getSeconds()).padStart(2,"0")+"."+(D.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$km=C}),define(Pe[137],Ae([9,10]),function(we,e){return we.create("vs/base/common/errorMessage",e)}),define(Pe[39],Ae([1,0,18,16,137]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=e.$Gi=void 0;function M(D,u){return u&&(D.stack||D.stacktrace)?P.localize(0,null,$(D),A(D.stack)||A(D.stacktrace)):$(D)}function A(D){return Array.isArray(D)?D.join(`
`):D}function $(D){return D.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${D.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?P.localize(1,null,D.message):D.message||P.localize(2,null)}function E(D=null,u=!1){if(!D)return P.localize(3,null);if(Array.isArray(D)){const b=y.$Gb(D),v=E(b[0],u);return b.length>1?P.localize(4,null,v,b.length):v}if(T.$Cf(D))return D;if(D.detail){const b=D.detail;if(b.error)return M(b.error,u);if(b.exception)return M(b.exception,u)}return D.stack?M(D,u):D.message?D.message:P.localize(5,null)}e.$Gi=E;function f(D){const u=D;return u instanceof Error&&Array.isArray(u.actions)}e.$Hi=f;function C(D,u){let b;return typeof D=="string"?b=new Error(D):b=D,b.actions=u,b}e.$Ii=C}),define(Pe[138],Ae([1,0,44,20]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=e.$yq=e.$xq=e.$wq=e.$vq=e.$uq=e.$tq=e.$sq=e.$rq=e.$qq=e.$pq=e.$oq=e.$nq=void 0;const P=new y.$U(()=>{const k=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:k,collatorIsNumeric:k.resolvedOptions().numeric}}),M=new y.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new y.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function $(k,h,w=!1){const I=k||"",F=h||"",V=P.value.collator.compare(I,F);return P.value.collatorIsNumeric&&V===0&&I!==F?I<F?-1:1:V}e.$nq=$;function E(k,h){const w=M.value.collator;return k=k||"",h=h||"",o(w,k,h)}e.$oq=E;function f(k,h){const w=M.value.collator;return k=k||"",h=h||"",a(k,h)||o(w,k,h)}e.$pq=f;function C(k,h){const w=M.value.collator;return k=k||"",h=h||"",s(k,h)||o(w,k,h)}e.$qq=C;function D(k,h){return k=k||"",h=h||"",k===h?0:k<h?-1:1}e.$rq=D;function u(k,h){const[w,I]=r(k),[F,V]=r(h);let Z=P.value.collator.compare(I,V);if(Z===0){if(P.value.collatorIsNumeric&&I!==V)return I<V?-1:1;if(Z=P.value.collator.compare(w,F),P.value.collatorIsNumeric&&Z===0&&w!==F)return w<F?-1:1}return Z}e.$sq=u;function b(k,h){k=k||"",h=h||"";const w=c(k),I=c(h),F=M.value.collator,V=A.value.collator;return o(V,w,I)||o(F,k,h)}e.$tq=b;function v(k,h){k=k||"",h=h||"";const w=c(k),I=c(h),F=M.value.collator,V=A.value.collator;return o(V,w,I)||a(k,h)||o(F,k,h)}e.$uq=v;function g(k,h){k=k||"",h=h||"";const w=c(k),I=c(h),F=M.value.collator,V=A.value.collator;return o(V,w,I)||s(k,h)||o(F,k,h)}e.$vq=g;function t(k,h){k=k||"",h=h||"";const w=c(k).toLowerCase(),I=c(h).toLowerCase();return w!==I?w<I?-1:1:k!==h?k<h?-1:1:0}e.$wq=t;const i=/^(.*?)(\.([^.]*))?$/;function r(k,h=!1){const w=k?i.exec(k):[];let I=[w&&w[1]||"",w&&w[3]||""];return h&&(!I[0]&&I[1]||I[0]&&I[0].charAt(0)===".")&&(I=[I[0]+"."+I[1],""]),I}function c(k){const h=k?i.exec(k):[];return h&&h[1]&&h[1].charAt(0)!=="."&&h[3]||""}function o(k,h,w){const I=k.compare(h,w);return I!==0?I:h.length!==w.length?h.length<w.length?-1:1:0}function l(k){const h=k.charAt(0);return h.toLocaleUpperCase()!==h}function n(k){const h=k.charAt(0);return h.toLocaleLowerCase()!==h}function s(k,h){return l(k)&&n(h)?-1:n(k)&&l(h)?1:0}function a(k,h){return n(k)&&l(h)?-1:l(k)&&n(h)?1:0}function d(k,h,w=!1){return w||(k=k&&k.toLowerCase(),h=h&&h.toLowerCase()),k===h?0:k<h?-1:1}function p(k,h,w=!1){const I=k.split(T.sep),F=h.split(T.sep),V=I.length-1,Z=F.length-1;let N,R;for(let L=0;;L++){if(N=V===L,R=Z===L,N&&R)return $(I[L],F[L],w);if(N)return-1;if(R)return 1;const O=d(I[L],F[L],w);if(O!==0)return O}}e.$xq=p;function m(k,h,w){const I=k.toLowerCase(),F=h.toLowerCase(),V=S(k,h,w);if(V)return V;const Z=I.endsWith(w),N=F.endsWith(w);if(Z!==N)return Z?-1:1;const R=$(I,F);return R!==0?R:I.localeCompare(F)}e.$yq=m;function S(k,h,w){const I=k.toLowerCase(),F=h.toLowerCase(),V=I.startsWith(w),Z=F.startsWith(w);if(V!==Z)return V?-1:1;if(V&&Z){if(I.length<F.length)return-1;if(I.length>F.length)return 1}return 0}e.$zq=S}),define(Pe[46],Ae([1,0,20,21,12,16]),function(we,e,y,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=void 0;function A(m){return m===47||m===92}e.$Uf=A;function $(m){return m.replace(/[\\/]/g,y.$fc.sep)}e.$Vf=$;function E(m){return m.indexOf("/")===-1&&(m=$(m)),/^[a-zA-Z]:(\/|$)/.test(m)&&(m="/"+m),m}e.$Wf=E;function f(m,S=y.$fc.sep){if(!m)return"";const k=m.length,h=m.charCodeAt(0);if(A(h)){if(A(m.charCodeAt(1))&&!A(m.charCodeAt(2))){let I=3;const F=I;for(;I<k&&!A(m.charCodeAt(I));I++);if(F!==I&&!A(m.charCodeAt(I+1))){for(I+=1;I<k;I++)if(A(m.charCodeAt(I)))return m.slice(0,I+1).replace(/[\\/]/g,S)}}return S}else if(i(h)&&m.charCodeAt(1)===58)return A(m.charCodeAt(2))?m.slice(0,2)+S:m.slice(0,2);let w=m.indexOf("://");if(w!==-1){for(w+=3;w<k;w++)if(A(m.charCodeAt(w)))return m.slice(0,w+1)}return""}e.$Xf=f;function C(m){if(!T.$i||!m||m.length<5)return!1;let S=m.charCodeAt(0);if(S!==92||(S=m.charCodeAt(1),S!==92))return!1;let k=2;const h=k;for(;k<m.length&&(S=m.charCodeAt(k),S!==92);k++);return!(h===k||(S=m.charCodeAt(k+1),isNaN(S)||S===92))}e.$Yf=C;const D=/[\\/:\*\?"<>\|]/g,u=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(m,S=T.$i){const k=S?D:u;return!(!m||m.length===0||/^\s+$/.test(m)||(k.lastIndex=0,k.test(m))||S&&b.test(m)||m==="."||m===".."||S&&m[m.length-1]==="."||S&&m.length!==m.trim().length||m.length>255)}e.$Zf=v;function g(m,S,k){const h=m===S;return!k||h?h:!m||!S?!1:(0,P.$6e)(m,S)}e.$1f=g;function t(m,S,k,h=y.sep){if(m===S)return!0;if(!m||!S||S.length>m.length)return!1;if(k){if(!(0,P.$7e)(m,S))return!1;if(S.length===m.length)return!0;let I=S.length;return S.charAt(S.length-1)===h&&I--,m.charAt(I)===h}return S.charAt(S.length-1)!==h&&(S+=h),m.indexOf(S)===0}e.$2f=t;function i(m){return m>=65&&m<=90||m>=97&&m<=122}e.$3f=i;function r(m,S){return T.$i&&m.endsWith(":")&&(m+=y.sep),(0,y.$hc)(m)||(m=(0,y.$ic)(S,m)),m=(0,y.$gc)(m),T.$i?(m=(0,P.$Oe)(m,y.sep),m.endsWith(":")&&(m+=y.sep)):(m=(0,P.$Oe)(m,y.sep),m||(m=y.sep)),m}e.$4f=r;function c(m){const S=(0,y.$gc)(m);return T.$i?m.length>3?!1:o(S)&&(m.length===2||S.charCodeAt(2)===92):S===y.$fc.sep}e.$5f=c;function o(m,S=T.$i){return S?i(m.charCodeAt(0))&&m.charCodeAt(1)===58:!1}e.$6f=o;function l(m,S=T.$i){return o(m,S)?m[0]:void 0}e.$7f=l;function n(m,S,k){return S.length>m.length?-1:m===S?0:(k&&(m=m.toLowerCase(),S=S.toLowerCase()),m.indexOf(S))}e.$8f=n;function s(m){const S=m.split(":");let k,h,w;for(const I of S){const F=Number(I);(0,M.$Gf)(F)?h===void 0?h=F:w===void 0&&(w=F):k=k?[k,I].join(":"):I}if(!k)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:k,line:h!==void 0?h:void 0,column:w!==void 0?w:h!==void 0?1:void 0}}e.$9f=s;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",d="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function p(m,S,k=8){let h="";for(let I=0;I<k;I++){let F;I===0&&T.$i&&!S&&(k===3||k===4)?F=d:F=a,h+=F.charAt(Math.floor(Math.random()*F.length))}let w;return S?w=`${S}-${h}`:w=h,m?(0,y.$ic)(m,w):w}e.$0f=p}),define(Pe[68],Ae([1,0,20]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zr=e.$Yr=e.$Xr=e.$Wr=e.$Vr=void 0,e.$Vr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(C){const D=(0,y.$nc)(C),u=T[D.toLowerCase()];return u!==void 0?u:A(C)}e.$Wr=M;function A(C){const D=(0,y.$nc)(C);return P[D.toLowerCase()]}e.$Xr=A;function $(C){for(const D in P)if(P[D]===C)return D}e.$Yr=$;const E=/^(.+)\/(.+?)(;.+)?$/;function f(C,D){const u=E.exec(C);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:D?void 0:C}e.$Zr=f}),define(Pe[51],Ae([1,0,24,2]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sh=e.$rh=e.$qh=void 0;function P(E){return JSON.stringify(E,A)}e.$qh=P;function M(E){let f=JSON.parse(E);return f=$(f),f}e.$rh=M;function A(E,f){return f instanceof RegExp?{$mid:2,source:f.source,flags:f.flags}:f}function $(E,f=0){if(!E||f>200)return E;if(typeof E=="object"){switch(E.$mid){case 1:return T.URI.revive(E);case 2:return new RegExp(E.source,E.flags);case 17:return new Date(E.source)}if(E instanceof y.$fe||E instanceof Uint8Array)return E;if(Array.isArray(E))for(let C=0;C<E.length;++C)E[C]=$(E[C],f+1);else for(const C in E)Object.hasOwnProperty.call(E,C)&&(E[C]=$(E[C],f+1))}return E}e.$sh=$}),define(Pe[13],Ae([1,0,11,21,2]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.Schemas=void 0;var M;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeManagedRemoteResource="vscode-managed-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.vscodeChatSesssion="vscode-chat-editor",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm"})(M||(e.Schemas=M={})),e.$$f="vscode-tkn",e.$_f="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(C){this.d=C}setDelegate(C){this.e=C}setServerRootPath(C){this.f=`${C}/${M.vscodeRemoteResource}`}set(C,D,u){this.a[C]=D,this.b[C]=u}setConnectionToken(C,D){this.c[C]=D}getPreferredWebSchema(){return this.d}rewrite(C){if(this.e)try{return this.e(C)}catch(t){return y.$Z(t),C}const D=C.authority;let u=this.a[D];u&&u.indexOf(":")!==-1&&u.indexOf("[")===-1&&(u=`[${u}]`);const b=this.b[D],v=this.c[D];let g=`path=${encodeURIComponent(C.path)}`;return typeof v=="string"&&(g+=`&${e.$_f}=${encodeURIComponent(v)}`),P.URI.from({scheme:T.$o?this.d:M.vscodeRemoteResource,authority:`${u}:${b}`,path:this.f,query:g})}}e.$ag=new A,e.$bg="vs/../../extensions",e.$cg="vs/../../node_modules",e.$dg="vs/../../node_modules.asar",e.$eg="vs/../../node_modules.asar.unpacked",e.$fg="vscode-app";class ${static{this.a=e.$fg}asBrowserUri(C){const D=this.b(C,we);return this.uriToBrowserUri(D)}uriToBrowserUri(C){return C.scheme===M.vscodeRemote?e.$ag.rewrite(C):C.scheme===M.file&&(T.$m||T.$q===`${M.vscodeFileResource}://${$.a}`)?C.with({scheme:M.vscodeFileResource,authority:C.authority||$.a,query:null,fragment:null}):C}asFileUri(C){const D=this.b(C,we);return this.uriToFileUri(D)}uriToFileUri(C){return C.scheme===M.vscodeFileResource?C.with({scheme:M.file,authority:C.authority!==$.a?C.authority:null,query:null,fragment:null}):C}b(C,D){return P.URI.isUri(C)?C:P.URI.parse(D.toUrl(C))}}e.$gg=new $;var E;(function(f){const C=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(C.get("3"));const D="vscode-coi";function u(v){let g;typeof v=="string"?g=new URL(v).searchParams:v instanceof URL?g=v.searchParams:P.URI.isUri(v)&&(g=new URL(v.toString(!0)).searchParams);const t=g?.get(D);if(t)return C.get(t)}f.getHeadersFromQuery=u;function b(v,g,t){if(!globalThis.crossOriginIsolated)return;const i=g&&t?"3":t?"2":"1";v instanceof URLSearchParams?v.set(D,i):v[D]=i}f.addSearchParam=b})(E||(e.COI=E={}))}),define(Pe[25],Ae([1,0,46,13,20,21,12,2]),function(we,e,y,T,P,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jg=e.DataUri=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=void 0;function E(b){return(0,$.$vc)(b,!0)}e.$ng=E;class f{constructor(v){this.a=v}compare(v,g,t=!1){return v===g?0:(0,A.$Ye)(this.getComparisonKey(v,t),this.getComparisonKey(g,t))}isEqual(v,g,t=!1){return v===g?!0:!v||!g?!1:this.getComparisonKey(v,t)===this.getComparisonKey(g,t)}getComparisonKey(v,g=!1){return v.with({path:this.a(v)?v.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(v){return this.a(v)}isEqualOrParent(v,g,t=!1){if(v.scheme===g.scheme){if(v.scheme===T.Schemas.file)return y.$2f(E(v),E(g),this.a(v))&&v.query===g.query&&(t||v.fragment===g.fragment);if((0,e.$Eg)(v.authority,g.authority))return y.$2f(v.path,g.path,this.a(v),"/")&&v.query===g.query&&(t||v.fragment===g.fragment)}return!1}joinPath(v,...g){return $.URI.joinPath(v,...g)}basenameOrAuthority(v){return(0,e.$wg)(v)||v.authority}basename(v){return P.$fc.basename(v.path)}extname(v){return P.$fc.extname(v.path)}dirname(v){if(v.path.length===0)return v;let g;return v.scheme===T.Schemas.file?g=$.URI.file(P.$lc(E(v))).path:(g=P.$fc.dirname(v.path),v.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),g="/")),v.with({path:g})}normalizePath(v){if(!v.path.length)return v;let g;return v.scheme===T.Schemas.file?g=$.URI.file(P.$gc(E(v))).path:g=P.$fc.normalize(v.path),v.with({path:g})}relativePath(v,g){if(v.scheme!==g.scheme||!(0,e.$Eg)(v.authority,g.authority))return;if(v.scheme===T.Schemas.file){const r=P.$kc(E(v),E(g));return M.$i?y.$Vf(r):r}let t=v.path||"/";const i=g.path||"/";if(this.a(v)){let r=0;for(const c=Math.min(t.length,i.length);r<c&&!(t.charCodeAt(r)!==i.charCodeAt(r)&&t.charAt(r).toLowerCase()!==i.charAt(r).toLowerCase());r++);t=i.substr(0,r)+t.substr(r)}return P.$fc.relative(t,i)}resolvePath(v,g){if(v.scheme===T.Schemas.file){const t=$.URI.file(P.$jc(E(v),g));return v.with({authority:t.authority,path:t.path})}return g=y.$Wf(g),v.with({path:P.$fc.resolve(v.path,g)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,g){return v===g||v!==void 0&&g!==void 0&&(0,A.$6e)(v,g)}hasTrailingPathSeparator(v,g=P.sep){if(v.scheme===T.Schemas.file){const t=E(v);return t.length>y.$Xf(t).length&&t[t.length-1]===g}else{const t=v.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,g=P.sep){return(0,e.$Fg)(v,g)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,g=P.sep){let t=!1;if(v.scheme===T.Schemas.file){const i=E(v);t=i!==void 0&&i.length===y.$Xf(i).length&&i[i.length-1]===g}else{g="/";const i=v.path;t=i.length===1&&i.charCodeAt(i.length-1)===47}return!t&&!(0,e.$Fg)(v,g)?v.with({path:v.path+"/"}):v}}e.$og=f,e.$pg=new f(()=>!1),e.$qg=new f(b=>b.scheme===T.Schemas.file?!M.$k:!0),e.$rg=new f(b=>!0),e.$sg=e.$pg.isEqual.bind(e.$pg),e.$tg=e.$pg.isEqualOrParent.bind(e.$pg),e.$ug=e.$pg.getComparisonKey.bind(e.$pg),e.$vg=e.$pg.basenameOrAuthority.bind(e.$pg),e.$wg=e.$pg.basename.bind(e.$pg),e.$xg=e.$pg.extname.bind(e.$pg),e.$yg=e.$pg.dirname.bind(e.$pg),e.$zg=e.$pg.joinPath.bind(e.$pg),e.$Ag=e.$pg.normalizePath.bind(e.$pg),e.$Bg=e.$pg.relativePath.bind(e.$pg),e.$Cg=e.$pg.resolvePath.bind(e.$pg),e.$Dg=e.$pg.isAbsolutePath.bind(e.$pg),e.$Eg=e.$pg.isEqualAuthority.bind(e.$pg),e.$Fg=e.$pg.hasTrailingPathSeparator.bind(e.$pg),e.$Gg=e.$pg.removeTrailingPathSeparator.bind(e.$pg),e.$Hg=e.$pg.addTrailingPathSeparator.bind(e.$pg);function C(b,v){const g=[];for(let t=0;t<b.length;t++){const i=v(b[t]);b.some((r,c)=>c===t?!1:(0,e.$tg)(i,v(r)))||g.push(b[t])}return g}e.$Ig=C;var D;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function v(g){const t=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(c=>{const[o,l]=c.split(":");o&&l&&t.set(o,l)});const r=g.path.substring(0,g.path.indexOf(";"));return r&&t.set(b.META_DATA_MIME,r),t}b.parseMetaData=v})(D||(e.DataUri=D={}));function u(b,v,g){if(v){let t=b.path;return t&&t[0]!==P.$fc.sep&&(t=P.$fc.sep+t),b.with({scheme:g,authority:v,path:t})}return b.with({scheme:g})}e.$Jg=u}),define(Pe[14],Ae([1,0,19,11,5,6,25,21,124]),function(we,e,y,T,P,M,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=e.$lh=e.$kh=e.$jh=e.Promises=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=void 0;function f(pe){return!!pe&&typeof pe.then=="function"}e.$Kg=f;function C(pe){const re=new y.$2d,le=pe(re.token),ce=new Promise((ye,_)=>{const de=re.token.onCancellationRequested(()=>{de.dispose(),re.dispose(),_(new T.$4)});Promise.resolve(le).then(ie=>{de.dispose(),re.dispose(),ye(ie)},ie=>{de.dispose(),re.dispose(),_(ie)})});return new class{cancel(){re.cancel()}then(ye,_){return ce.then(ye,_)}catch(ye){return this.then(void 0,ye)}finally(ye){return ce.finally(ye)}}}e.$Lg=C;function D(pe,re,le){return new Promise((ce,ye)=>{const _=re.onCancellationRequested(()=>{_.dispose(),ce(le)});pe.then(ce,ye).finally(()=>_.dispose())})}e.$Mg=D;function u(pe,re){return new Promise((le,ce)=>{const ye=re.onCancellationRequested(()=>{ye.dispose(),ce(new T.$4)});pe.then(le,ce).finally(()=>ye.dispose())})}e.$Ng=u;async function b(pe){let re=-1;const le=pe.map((ce,ye)=>ce.then(_=>(re=ye,_)));try{return await Promise.race(le)}finally{pe.forEach((ce,ye)=>{ye!==re&&ce.cancel()})}}e.$Og=b;function v(pe,re,le){let ce;const ye=setTimeout(()=>{ce?.(void 0),le?.()},re);return Promise.race([pe.finally(()=>clearTimeout(ye)),new Promise(_=>ce=_)])}e.$Pg=v;function g(pe){return new Promise((re,le)=>{const ce=pe();f(ce)?ce.then(re,le):re(ce)})}e.$Qg=g;class t{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(re){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=re,!this.b){const le=()=>{if(this.b=null,this.f)return;const ce=this.queue(this.d);return this.d=null,ce};this.b=new Promise(ce=>{this.a.then(le,le).then(ce)})}return new Promise((le,ce)=>{this.b.then(le,ce)})}return this.a=re(),new Promise((le,ce)=>{this.a.then(ye=>{this.a=null,le(ye)},ye=>{this.a=null,ce(ye)})})}dispose(){this.f=!0}}e.$Rg=t;class i{constructor(){this.a=Promise.resolve(null)}queue(re){return this.a=this.a.then(()=>re(),()=>re())}}e.$Sg=i;class r{constructor(){this.a=new Map}queue(re,le){const ye=(this.a.get(re)??Promise.resolve()).catch(()=>{}).then(le).finally(()=>{this.a.get(re)===ye&&this.a.delete(re)});return this.a.set(re,ye),ye}}e.$Tg=r;const c=(pe,re)=>{let le=!0;const ce=setTimeout(()=>{le=!1,re()},pe);return{isTriggered:()=>le,dispose:()=>{clearTimeout(ce),le=!1}}},o=pe=>{let re=!0;return queueMicrotask(()=>{re&&(re=!1,pe())}),{isTriggered:()=>re,dispose:()=>{re=!1}}};class l{constructor(re){this.defaultDelay=re,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(re,le=this.defaultDelay){this.g=re,this.h(),this.b||(this.b=new Promise((ye,_)=>{this.d=ye,this.f=_}).then(()=>{if(this.b=null,this.d=null,this.g){const ye=this.g;return this.g=null,ye()}}));const ce=()=>{this.a=null,this.d?.(null)};return this.a=le===E.$Od?o(ce):c(le,ce),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Ug=l;class n{constructor(re){this.a=new l(re),this.b=new t}trigger(re,le){return this.a.trigger(()=>this.b.queue(re),le)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Vg=n;class s{constructor(){this.a=!1,this.b=new Promise((re,le)=>{this.d=re})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Wg=s;class a extends s{constructor(re){super(),this.f=setTimeout(()=>this.open(),re)}open(){clearTimeout(this.f),super.open()}}e.$Xg=a;function d(pe,re){return re?new Promise((le,ce)=>{const ye=setTimeout(()=>{_.dispose(),le()},pe),_=re.onCancellationRequested(()=>{clearTimeout(ye),_.dispose(),ce(new T.$4)})}):C(le=>d(pe,le))}e.$Yg=d;function p(pe,re=0,le){const ce=setTimeout(()=>{pe(),le&&ye.dispose()},re),ye=(0,M.$Pc)(()=>{clearTimeout(ce),le?.deleteAndLeak(ye)});return le?.add(ye),ye}e.$Zg=p;function m(pe){const re=[];let le=0;const ce=pe.length;function ye(){return le<ce?pe[le++]():null}function _(de){de!=null&&re.push(de);const ie=ye();return ie?ie.then(_):Promise.resolve(re)}return Promise.resolve(null).then(_)}e.$1g=m;function S(pe,re=ce=>!!ce,le=null){let ce=0;const ye=pe.length,_=()=>{if(ce>=ye)return Promise.resolve(le);const de=pe[ce++];return Promise.resolve(de()).then(ae=>re(ae)?Promise.resolve(ae):_())};return _()}e.$2g=S;function k(pe,re=ce=>!!ce,le=null){if(pe.length===0)return Promise.resolve(le);let ce=pe.length;const ye=()=>{ce=-1;for(const _ of pe)_.cancel?.()};return new Promise((_,de)=>{for(const ie of pe)ie.then(ae=>{--ce>=0&&re(ae)?(ye(),_(ae)):ce===0&&_(le)}).catch(ae=>{--ce>=0&&(ye(),de(ae))})})}e.$3g=k;class h{constructor(re){this.a=0,this.d=re,this.f=[],this.b=0,this.g=new P.$Rd}get onDrained(){return this.g.event}get size(){return this.a}queue(re){return this.a++,new Promise((le,ce)=>{this.f.push({factory:re,c:le,e:ce}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const re=this.f.shift();this.b++;const le=re.factory();le.then(re.c,re.e),le.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$4g=h;class w extends h{constructor(){super(1)}}e.$5g=w;class I{constructor(){this.a=new De,this.b=0}queue(re){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,re())):this.a.run(this.b++,re())}}e.$6g=I;class F{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const re=new ve;return this.b.add(re),re.p}g(){for(const[,re]of this.a)if(re.size>0)return!1;return!0}queueFor(re,le=A.$pg){const ce=le.getComparisonKey(re);let ye=this.a.get(ce);if(!ye){ye=new w;const _=this.f++,de=P.Event.once(ye.onDrained)(()=>{ye?.dispose(),this.a.delete(ce),this.h(),this.d?.deleteAndDispose(_),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$1c),this.d.set(_,de),this.a.set(ce,ye)}return ye}h(){this.g()&&this.j()}j(){for(const re of this.b)re.complete();this.b.clear()}dispose(){for(const[,re]of this.a)re.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$7g=F;class V{constructor(re,le){this.a=-1,typeof re=="function"&&typeof le=="number"&&this.setIfNotSet(re,le)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(re,le){this.cancel(),this.a=setTimeout(()=>{this.a=-1,re()},le)}setIfNotSet(re,le){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,re()},le))}}e.$8g=V;class Z{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(re,le,ce=globalThis){this.cancel();const ye=ce.setInterval(()=>{re()},le);this.d=(0,M.$Pc)(()=>{ce.clearInterval(ye),this.d=void 0})}dispose(){this.cancel()}}e.$9g=Z;class N{constructor(re,le){this.b=-1,this.a=re,this.d=le,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(re=this.d){this.cancel(),this.b=setTimeout(this.f,re)}get delay(){return this.d}set delay(re){this.d=re}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$0g=N;class R{constructor(re,le){le%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${le}ms is not a multiple of 1000ms.`),this.a=re,this.b=le,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(re=this.b){re%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${re}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(re/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$$g=R;class L extends N{constructor(re,le){super(re,le),this.j=[]}work(re){this.j.push(re),this.isScheduled()||this.schedule()}h(){const re=this.j;this.j=[],this.a?.(re)}dispose(){this.j=[],super.dispose()}}e.$_g=L;class O extends M.$Rc{constructor(re,le){super(),this.g=re,this.h=le,this.a=[],this.b=this.B(new M.$Sc),this.f=!1}get pending(){return this.a.length}work(re){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+re.length>this.g.maxBufferedWork)return!1}else if(this.pending+re.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const le of re)this.a.push(le);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new N(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$ah=O,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$ch=(pe,re)=>{(0,$.$B)(()=>{if(le)return;const ce=Date.now()+15;re(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ce-Date.now())}}))});let le=!1;return{dispose(){le||(le=!0)}}}:e.$ch=(pe,re,le)=>{const ce=pe.requestIdleCallback(re,typeof le=="number"?{timeout:le}:void 0);let ye=!1;return{dispose(){ye||(ye=!0,pe.cancelIdleCallback(ce))}}},e.$bh=pe=>(0,e.$ch)(globalThis,pe)}();class Y{constructor(re,le){this.g=!1,this.d=()=>{try{this.j=le()}catch(ce){this.l=ce}finally{this.g=!0}},this.f=(0,e.$ch)(re,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$dh=Y;class he extends Y{constructor(re){super(globalThis,re)}}e.$eh=he;async function $e(pe,re,le){let ce;for(let ye=0;ye<le;ye++)try{return await pe()}catch(_){ce=_,await d(re)}throw ce}e.$fh=$e;class De{isRunning(re){return typeof re=="number"?this.a?.taskId===re:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(re,le,ce){return this.a={taskId:re,cancel:()=>ce?.(),promise:le},le.then(()=>this.d(re),()=>this.d(re)),le}d(re){this.a&&re===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const re=this.b;this.b=void 0,re.run().then(re.promiseResolve,re.promiseReject)}}queue(re){if(this.b)this.b.run=re;else{let le,ce;const ye=new Promise((_,de)=>{le=_,ce=de});this.b={run:re,promise:ye,promiseResolve:le,promiseReject:ce}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$gh=De;class ke{constructor(re,le=()=>Date.now()){this.d=re,this.f=le,this.a=0,this.b=0}increment(){const re=this.f();return re-this.a>this.d&&(this.a=re,this.b=0),this.b++,this.b}}e.$hh=ke;var fe;(function(pe){pe[pe.Resolved=0]="Resolved",pe[pe.Rejected=1]="Rejected"})(fe||(fe={}));class ve{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((re,le)=>{this.a=re,this.b=le})}complete(re){return new Promise(le=>{this.a(re),this.d={outcome:0,value:re},le()})}error(re){return new Promise(le=>{this.b(re),this.d={outcome:1,value:re},le()})}cancel(){return this.error(new T.$4)}}e.$ih=ve;var te;(function(pe){async function re(ce){let ye;const _=await Promise.all(ce.map(de=>de.then(ie=>ie,ie=>{ye||(ye=ie)})));if(typeof ye<"u")throw ye;return _}pe.settled=re;function le(ce){return new Promise(async(ye,_)=>{try{await ce(ye,_)}catch(de){_(de)}})}pe.withAsyncBody=le})(te||(e.Promises=te={}));var Re;(function(pe){pe[pe.Initial=0]="Initial",pe[pe.DoneOK=1]="DoneOK",pe[pe.DoneError=2]="DoneError"})(Re||(Re={}));class se{static fromArray(re){return new se(le=>{le.emitMany(re)})}static fromPromise(re){return new se(async le=>{le.emitMany(await re)})}static fromPromises(re){return new se(async le=>{await Promise.all(re.map(async ce=>le.emitOne(await ce)))})}static merge(re){return new se(async le=>{await Promise.all(re.map(async ce=>{for await(const ye of ce)le.emitOne(ye)}))})}static{this.EMPTY=se.fromArray([])}constructor(re){this.a=0,this.b=[],this.d=null,this.f=new P.$Rd,queueMicrotask(async()=>{const le={emitOne:ce=>this.g(ce),emitMany:ce=>this.h(ce),reject:ce=>this.k(ce)};try{await Promise.resolve(re(le)),this.j()}catch(ce){this.k(ce)}finally{le.emitOne=void 0,le.emitMany=void 0,le.reject=void 0}})}[Symbol.asyncIterator](){let re=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(re<this.b.length)return{done:!1,value:this.b[re++]};if(this.a===1)return{done:!0,value:void 0};await P.Event.toPromise(this.f.event)}while(!0)}}}static map(re,le){return new se(async ce=>{for await(const ye of re)ce.emitOne(le(ye))})}map(re){return se.map(this,re)}static filter(re,le){return new se(async ce=>{for await(const ye of re)le(ye)&&ce.emitOne(ye)})}filter(re){return se.filter(this,re)}static coalesce(re){return se.filter(re,le=>!!le)}coalesce(){return se.coalesce(this)}static async toPromise(re){const le=[];for await(const ce of re)le.push(ce);return le}toPromise(){return se.toPromise(this)}g(re){this.a===0&&(this.b.push(re),this.f.fire())}h(re){this.a===0&&(this.b=this.b.concat(re),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(re){this.a===0&&(this.a=2,this.d=re,this.f.fire())}}e.$jh=se;class Q extends se{constructor(re,le){super(le),this.l=re}cancel(){this.l.cancel()}}e.$kh=Q;function B(pe){const re=new y.$2d,le=pe(re.token);return new Q(re,async ce=>{const ye=re.token.onCancellationRequested(()=>{ye.dispose(),re.dispose(),ce.reject(new T.$4)});try{for await(const _ of le){if(re.token.isCancellationRequested)return;ce.emitOne(_)}ye.dispose(),re.dispose()}catch(_){ye.dispose(),re.dispose(),ce.reject(_)}})}e.$lh=B;class ne{constructor(){this.a=new ve,this.b=new se(ce=>{if(re){ce.reject(re);return}return le&&ce.emitMany(le),this.d=ye=>ce.reject(ye),this.f=ye=>ce.emitOne(ye),this.a.p});let re,le;this.f=ce=>{le||(le=[]),le.push(ce)},this.d=ce=>{re||(re=ce)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(re){this.d(re),this.a.complete()}emitOne(re){this.f(re)}}e.$mh=ne}),define(Pe[33],Ae([1,0,18,14,46,28,20,21,12]),function(we,e,y,T,P,M,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=void 0;function f(){return Object.create(null)}e.$xj=f,e.$yj="**",e.$zj="/";const C="[/\\\\]",D="[^/\\\\]",u=/\//g;function b($e,De){switch($e){case 0:return"";case 1:return`${D}*?`;default:return`(?:${C}|${D}+${C}${De?`|${C}${D}+`:""})*?`}}function v($e,De){if(!$e)return[];const ke=[];let fe=!1,ve=!1,te="";for(const Re of $e){switch(Re){case De:if(!fe&&!ve){ke.push(te),te="";continue}break;case"{":fe=!0;break;case"}":fe=!1;break;case"[":ve=!0;break;case"]":ve=!1;break}te+=Re}return te&&ke.push(te),ke}e.$Aj=v;function g($e){if(!$e)return"";let De="";const ke=v($e,e.$zj);if(ke.every(fe=>fe===e.$yj))De=".*";else{let fe=!1;ke.forEach((ve,te)=>{if(ve===e.$yj){if(fe)return;De+=b(2,te===ke.length-1)}else{let Re=!1,se="",Q=!1,B="";for(const ne of ve){if(ne!=="}"&&Re){se+=ne;continue}if(Q&&(ne!=="]"||!B)){let pe;ne==="-"?pe=ne:(ne==="^"||ne==="!")&&!B?pe="^":ne===e.$zj?pe="":pe=(0,E.$Je)(ne),B+=pe;continue}switch(ne){case"{":Re=!0;continue;case"[":Q=!0;continue;case"}":{const re=`(?:${v(se,",").map(le=>g(le)).join("|")})`;De+=re,Re=!1,se="";break}case"]":{De+="["+B+"]",Q=!1,B="";break}case"?":De+=D;continue;case"*":De+=b(1);continue;default:De+=(0,E.$Je)(ne)}}te<ke.length-1&&(ke[te+1]!==e.$yj||te+2<ke.length)&&(De+=C)}fe=ve===e.$yj})}return De}const t=/^\*\*\/\*\.[\w\.-]+$/,i=/^\*\*\/([\w\.-]+)\/?$/,r=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,c=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new M.$Cc(1e4),s=function(){return!1},a=function(){return null};function d($e,De){if(!$e)return a;let ke;typeof $e!="string"?ke=$e.pattern:ke=$e,ke=ke.trim();const fe=`${ke}_${!!De.trimForExclusions}`;let ve=n.get(fe);if(ve)return p(ve,$e);let te;return t.test(ke)?ve=S(ke.substr(4),ke):(te=i.exec(m(ke,De)))?ve=k(te[1],ke):(De.trimForExclusions?c:r).test(ke)?ve=h(ke,De):(te=o.exec(m(ke,De)))?ve=w(te[1].substr(1),ke,!0):(te=l.exec(m(ke,De)))?ve=w(te[1],ke,!1):ve=I(ke),n.set(fe,ve),p(ve,$e)}function p($e,De){if(typeof De=="string")return $e;const ke=function(fe,ve){return(0,P.$2f)(fe,De.base,!$.$k)?$e((0,E.$Ne)(fe.substr(De.base.length),A.sep),ve):null};return ke.allBasenames=$e.allBasenames,ke.allPaths=$e.allPaths,ke.basenames=$e.basenames,ke.patterns=$e.patterns,ke}function m($e,De){return De.trimForExclusions&&$e.endsWith("/**")?$e.substr(0,$e.length-2):$e}function S($e,De){return function(ke,fe){return typeof ke=="string"&&ke.endsWith($e)?De:null}}function k($e,De){const ke=`/${$e}`,fe=`\\${$e}`,ve=function(Re,se){return typeof Re!="string"?null:se?se===$e?De:null:Re===$e||Re.endsWith(ke)||Re.endsWith(fe)?De:null},te=[$e];return ve.basenames=te,ve.patterns=[De],ve.allBasenames=te,ve}function h($e,De){const ke=Y($e.slice(1,-1).split(",").map(se=>d(se,De)).filter(se=>se!==a),$e),fe=ke.length;if(!fe)return a;if(fe===1)return ke[0];const ve=function(se,Q){for(let B=0,ne=ke.length;B<ne;B++)if(ke[B](se,Q))return $e;return null},te=ke.find(se=>!!se.allBasenames);te&&(ve.allBasenames=te.allBasenames);const Re=ke.reduce((se,Q)=>Q.allPaths?se.concat(Q.allPaths):se,[]);return Re.length&&(ve.allPaths=Re),ve}function w($e,De,ke){const fe=A.sep===A.$fc.sep,ve=fe?$e:$e.replace(u,A.sep),te=A.sep+ve,Re=A.$fc.sep+$e;let se;return ke?se=function(Q,B){return typeof Q=="string"&&(Q===ve||Q.endsWith(te)||!fe&&(Q===$e||Q.endsWith(Re)))?De:null}:se=function(Q,B){return typeof Q=="string"&&(Q===ve||!fe&&Q===$e)?De:null},se.allPaths=[(ke?"*/":"./")+$e],se}function I($e){try{const De=new RegExp(`^${g($e)}$`);return function(ke){return De.lastIndex=0,typeof ke=="string"&&De.test(ke)?$e:null}}catch{return a}}function F($e,De,ke){return!$e||typeof De!="string"?!1:V($e)(De,void 0,ke)}e.$Bj=F;function V($e,De={}){if(!$e)return s;if(typeof $e=="string"||Z($e)){const ke=d($e,De);if(ke===a)return s;const fe=function(ve,te){return!!ke(ve,te)};return ke.allBasenames&&(fe.allBasenames=ke.allBasenames),ke.allPaths&&(fe.allPaths=ke.allPaths),fe}return L($e,De)}e.$Cj=V;function Z($e){const De=$e;return De?typeof De.base=="string"&&typeof De.pattern=="string":!1}e.$Dj=Z;function N($e){return $e.allBasenames||[]}e.$Ej=N;function R($e){return $e.allPaths||[]}e.$Fj=R;function L($e,De){const ke=Y(Object.getOwnPropertyNames($e).map(se=>O(se,$e[se],De)).filter(se=>se!==a)),fe=ke.length;if(!fe)return a;if(!ke.some(se=>!!se.requiresSiblings)){if(fe===1)return ke[0];const se=function(ne,pe){let re;for(let le=0,ce=ke.length;le<ce;le++){const ye=ke[le](ne,pe);if(typeof ye=="string")return ye;(0,T.$Kg)(ye)&&(re||(re=[]),re.push(ye))}return re?(async()=>{for(const le of re){const ce=await le;if(typeof ce=="string")return ce}return null})():null},Q=ke.find(ne=>!!ne.allBasenames);Q&&(se.allBasenames=Q.allBasenames);const B=ke.reduce((ne,pe)=>pe.allPaths?ne.concat(pe.allPaths):ne,[]);return B.length&&(se.allPaths=B),se}const ve=function(se,Q,B){let ne,pe;for(let re=0,le=ke.length;re<le;re++){const ce=ke[re];ce.requiresSiblings&&B&&(Q||(Q=(0,A.$mc)(se)),ne||(ne=Q.substr(0,Q.length-(0,A.$nc)(se).length)));const ye=ce(se,Q,ne,B);if(typeof ye=="string")return ye;(0,T.$Kg)(ye)&&(pe||(pe=[]),pe.push(ye))}return pe?(async()=>{for(const re of pe){const le=await re;if(typeof le=="string")return le}return null})():null},te=ke.find(se=>!!se.allBasenames);te&&(ve.allBasenames=te.allBasenames);const Re=ke.reduce((se,Q)=>Q.allPaths?se.concat(Q.allPaths):se,[]);return Re.length&&(ve.allPaths=Re),ve}function O($e,De,ke){if(De===!1)return a;const fe=d($e,ke);if(fe===a)return a;if(typeof De=="boolean")return fe;if(De){const ve=De.when;if(typeof ve=="string"){const te=(Re,se,Q,B)=>{if(!B||!fe(Re,se))return null;const ne=ve.replace("$(basename)",()=>Q),pe=B(ne);return(0,T.$Kg)(pe)?pe.then(re=>re?$e:null):pe?$e:null};return te.requiresSiblings=!0,te}}return fe}function Y($e,De){const ke=$e.filter(se=>!!se.basenames);if(ke.length<2)return $e;const fe=ke.reduce((se,Q)=>{const B=Q.basenames;return B?se.concat(B):se},[]);let ve;if(De){ve=[];for(let se=0,Q=fe.length;se<Q;se++)ve.push(De)}else ve=ke.reduce((se,Q)=>{const B=Q.patterns;return B?se.concat(B):se},[]);const te=function(se,Q){if(typeof se!="string")return null;if(!Q){let ne;for(ne=se.length;ne>0;ne--){const pe=se.charCodeAt(ne-1);if(pe===47||pe===92)break}Q=se.substr(ne)}const B=fe.indexOf(Q);return B!==-1?ve[B]:null};te.basenames=fe,te.patterns=ve,te.allBasenames=fe;const Re=$e.filter(se=>!se.basenames);return Re.push(te),Re}function he($e,De){return(0,y.$tb)($e,De,(ke,fe)=>typeof ke=="string"&&typeof fe=="string"?ke===fe:typeof ke!="string"&&typeof fe!="string"?ke.base===fe.base&&ke.pattern===fe.pattern:!1)}e.$Gj=he}),define(Pe[52],Ae([1,0,11,125,25,12,2]),function(we,e,y,T,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.MarkdownStringTextNewlineStyle=void 0;var $;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})($||(e.MarkdownStringTextNewlineStyle=$={}));class E{constructor(i="",r=!1){if(this.value=i,typeof this.value!="string")throw(0,y.$6)("value");typeof r=="boolean"?(this.isTrusted=r,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=r.isTrusted??void 0,this.supportThemeIcons=r.supportThemeIcons??!1,this.supportHtml=r.supportHtml??!1)}appendText(i,r=0){return this.value+=u(this.supportThemeIcons?(0,T.$3j)(i):i).replace(/([ \t]+)/g,(c,o)=>"&nbsp;".repeat(o.length)).replace(/\>/gm,"\\>").replace(/\n/g,r===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,r){return this.value+="\n```",this.value+=i,this.value+=`
`,this.value+=r,this.value+="\n```\n",this}appendLink(i,r,c){return this.value+="[",this.value+=this.c(r,"]"),this.value+="](",this.value+=this.c(String(i),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(i,r){const c=new RegExp((0,M.$Je)(r),"g");return i.replace(c,(o,l)=>i.charAt(l-1)!=="\\"?`\\${o}`:o)}}e.$9j=E;function f(t){return C(t)?!t.value:Array.isArray(t)?t.every(f):!0}e.$0j=f;function C(t){return t instanceof E?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.$$j=C;function D(t,i){return t===i?!0:!t||!i?!1:t.value===i.value&&t.isTrusted===i.isTrusted&&t.supportThemeIcons===i.supportThemeIcons&&t.supportHtml===i.supportHtml&&(t.baseUri===i.baseUri||!!t.baseUri&&!!i.baseUri&&(0,P.$sg)(A.URI.from(t.baseUri),A.URI.from(i.baseUri)))}e.$_j=D;function u(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$ak=u;function b(t){return t.replace(/"/g,"&quot;")}e.$bk=b;function v(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$ck=v;function g(t){const i=[],r=t.split("|").map(o=>o.trim());t=r[0];const c=r[1];if(c){const o=/height=(\d+)/.exec(c),l=/width=(\d+)/.exec(c),n=o?o[1]:"",s=l?l[1]:"",a=isFinite(parseInt(s)),d=isFinite(parseInt(n));a&&i.push(`width="${s}"`),d&&i.push(`height="${n}"`)}return{href:t,dimensions:i}}e.$dk=g}),define(Pe[94],Ae([1,0,18,46,20,21,25,12]),function(we,e,y,T,P,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hv=e.$Gv=e.$Fv=e.$Ev=e.$Dv=e.$Cv=e.$Bv=e.$Av=e.$zv=e.$yv=void 0;function E(d,p){const{os:m,tildify:S,relative:k}=p;if(k){const I=f(d,k,m);if(typeof I=="string")return I}let h=d.fsPath;if(m===1&&!M.$i?h=h.replace(/\//g,"\\"):m!==1&&M.$i&&(h=h.replace(/\\/g,"/")),m!==1&&S?.userHome){const I=S.userHome.fsPath;let F;d.scheme!==S.userHome.scheme&&d.path[0]===P.$fc.sep&&d.path[1]!==P.$fc.sep?F=S.userHome.with({path:d.path}).fsPath:F=h,h=u(F,I,m)}return(m===1?P.$ec:P.$fc).normalize(C(h,m===1))}e.$yv=E;function f(d,p,m){const S=m===1?P.$ec:P.$fc,k=m===3?A.$pg:A.$rg,h=p.getWorkspace(),w=(0,y.$Nb)(h.folders);if(!w)return;d.scheme!==w.uri.scheme&&d.path[0]===P.$fc.sep&&d.path[1]!==P.$fc.sep&&(d=w.uri.with({path:d.path}));const I=p.getWorkspaceFolder(d);if(!I)return;let F;if(k.isEqual(I.uri,d)?F="":F=k.relativePath(I.uri,d)??"",F&&(F=S.normalize(F)),h.folders.length>1&&!p.noPrefix){const V=I.name?I.name:k.basenameOrAuthority(I.uri);F=F?`${V} \u2022 ${F}`:V}return F}function C(d,p=M.$i){return(0,T.$6f)(d,p)?d.charAt(0).toUpperCase()+d.slice(1):d}e.$zv=C;let D=Object.create(null);function u(d,p,m=M.OS){if(m===1||!d||!p)return d;let S=D.original===p?D.normalized:void 0;S||(S=p,M.$i&&(S=(0,T.$Vf)(S)),S=`${(0,$.$Oe)(S,P.$fc.sep)}${P.$fc.sep}`,D={original:p,normalized:S});let k=d;return M.$i&&(k=(0,T.$Vf)(k)),(m===3?k.startsWith(S):(0,$.$7e)(k,S))?`~/${k.substr(S.length)}`:d}e.$Av=u;function b(d,p){return d.replace(/^~($|\/|\\)/,`${p}$1`)}e.$Bv=b;const v="\u2026",g="\\\\",t="~";function i(d,p=P.sep){const m=new Array(d.length);let S=!1;for(let k=0;k<d.length;k++){const h=d[k];if(h===""){m[k]=`.${p}`;continue}if(!h){m[k]=h;continue}S=!0;let w="",I=h;I.indexOf(g)===0?(w=I.substr(0,I.indexOf(g)+g.length),I=I.substr(I.indexOf(g)+g.length)):I.indexOf(p)===0?(w=I.substr(0,I.indexOf(p)+p.length),I=I.substr(I.indexOf(p)+p.length)):I.indexOf(t)===0&&(w=I.substr(0,I.indexOf(t)+t.length),I=I.substr(I.indexOf(t)+t.length));const F=I.split(p);for(let V=1;S&&V<=F.length;V++)for(let Z=F.length-V;S&&Z>=0;Z--){S=!1;let N=F.slice(Z,Z+V).join(p);for(let R=0;!S&&R<d.length;R++)if(R!==k&&d[R]&&d[R].indexOf(N)>-1){const L=Z+V===F.length,O=Z>0&&d[R].indexOf(p)>-1?p+N:N,Y=d[R].endsWith(O);S=!L||Y}if(!S){let R="";(F[0].endsWith(":")||w!=="")&&(Z===1&&(Z=0,V++,N=F[0]+p+N),Z>0&&(R=F[0]+p),R=w+R),Z>0&&(R=R+v+p),R=R+N,Z+V<F.length&&(R=R+p+v),m[k]=R}}S&&(m[k]=h)}return m}e.$Cv=i;var r;(function(d){d[d.TEXT=0]="TEXT",d[d.VARIABLE=1]="VARIABLE",d[d.SEPARATOR=2]="SEPARATOR"})(r||(r={}));function c(d,p=Object.create(null)){const m=[];let S=!1,k="";for(const h of d)if(h==="$"||S&&h==="{")k&&m.push({value:k,type:r.TEXT}),k="",S=!0;else if(h==="}"&&S){const w=p[k];if(typeof w=="string")w.length&&m.push({value:w,type:r.VARIABLE});else if(w){const I=m[m.length-1];(!I||I.type!==r.SEPARATOR)&&m.push({value:w.label,type:r.SEPARATOR})}k="",S=!1}else k+=h;return k&&!S&&m.push({value:k,type:r.TEXT}),m.filter((h,w)=>{if(h.type===r.SEPARATOR){const I=m[w-1],F=m[w+1];return[I,F].every(V=>V&&(V.type===r.VARIABLE||V.type===r.TEXT)&&V.value.length>0)}return!0}).map(h=>h.value).join("")}e.$Dv=c;function o(d,p){return M.$j||p?d.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$j?"&":"&&"):d.replace(/&&|&/g,m=>m==="&"?"&&":"&")}e.$Ev=o;function l(d,p){return M.$j||p?d.replace(/\(&&\w\)|&&/g,""):M.$i?d.replace(/&&|&/g,m=>m==="&"?"&&":"&"):d.replace(/&&/g,"_")}e.$Fv=l;function n(d){return d.replace(/&/g,"&&")}e.$Gv=n;function s(d){if(d.endsWith("]")){const p=d.lastIndexOf(" [",d.length-2);if(p!==-1){const m=a(d.substring(0,p));return{name:m.name,parentPath:m.parentPath+d.substring(p)}}}return a(d)}e.$Hv=s;function a(d){const p=d.indexOf("/")!==-1?P.$fc:P.$ec,m=p.basename(d),S=p.dirname(d);return m.length?{name:m,parentPath:S}:{name:S,parentPath:""}}}),define(Pe[139],Ae([1,0,24,2]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=e.$Um=e.$Tm=e.$Sm=e.$Rm=void 0;function P(D){return D.toJSON()}class M{constructor(u){this.a=u}transformIncoming(u){const b=this.a.transformIncoming(u);return b===u?u:P(T.URI.from(b))}transformOutgoing(u){const b=this.a.transformOutgoing(u);return b===u?u:P(T.URI.from(b))}transformOutgoingURI(u){const b=this.a.transformOutgoing(u);return b===u?u:T.URI.from(b)}transformOutgoingScheme(u){return this.a.transformOutgoingScheme(u)}}e.$Rm=M,e.$Sm=new class{transformIncoming(D){return D}transformOutgoing(D){return D}transformOutgoingURI(D){return D}transformOutgoingScheme(D){return D}};function A(D,u,b){if(!D||b>200)return null;if(typeof D=="object"){if(D instanceof T.URI)return u.transformOutgoing(D);for(const v in D)if(Object.hasOwnProperty.call(D,v)){const g=A(D[v],u,b+1);g!==null&&(D[v]=g)}}return null}function $(D,u){const b=A(D,u,0);return b===null?D:b}e.$Tm=$;function E(D,u,b,v){if(!D||v>200)return null;if(typeof D=="object"){if(D.$mid===1)return b?T.URI.revive(u.transformIncoming(D)):u.transformIncoming(D);if(D instanceof y.$fe)return null;for(const g in D)if(Object.hasOwnProperty.call(D,g)){const t=E(D[g],u,b,v+1);t!==null&&(D[g]=t)}}return null}function f(D,u){const b=E(D,u,!1,0);return b===null?D:b}e.$Um=f;function C(D,u){const b=E(D,u,!0,0);return b===null?D:b}e.$Vm=C}),define(Pe[140],Ae([1,0,12,21,24]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ts=e.$Ss=e.$Rs=void 0;let M;function A(){return M||(M=new TextDecoder("UTF-16LE")),M}let $;function E(){return $||($=new TextDecoder("UTF-16BE")),$}let f;function C(){return f||(f=T.$D()?A():E()),f}e.$Rs=C;function D(v,g,t){const i=new Uint16Array(v.buffer,g,t);return t>0&&(i[0]===65279||i[0]===65534)?u(v,g,t):A().decode(i)}e.$Ss=D;function u(v,g,t){const i=[];let r=0;for(let c=0;c<t;c++){const o=P.$he(v,g);g+=2,i[r++]=String.fromCharCode(o)}return i.join("")}class b{constructor(g){this.a=g|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const g=new Uint16Array(this.b.buffer,0,this.d);return C().decode(g)}f(){const g=this.e();this.d=0,this.c===null?this.c=[g]:this.c[this.c.length]=g}appendCharCode(g){const t=this.a-this.d;t<=1&&(t===0||y.$0e(g))&&this.f(),this.b[this.d++]=g}appendASCIICharCode(g){this.d===this.a&&this.f(),this.b[this.d++]=g}appendString(g){const t=g.length;if(this.d+t>=this.a){this.f(),this.c[this.c.length]=g;return}for(let i=0;i<t;i++)this.b[this.d++]=g.charCodeAt(i)}}e.$Ts=b}),define(Pe[141],Ae([1,0,24,140]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vs=e.$Us=void 0;function P(E){return E.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class M{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(f,C,D,u){this.oldPosition=f,this.oldText=C,this.newPosition=D,this.newText=u}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${P(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${P(this.oldText)}")`:`(replace@${this.oldPosition} "${P(this.oldText)}" with "${P(this.newText)}")`}static a(f){return 4+2*f.length}static c(f,C,D){const u=C.length;y.$ke(f,u,D),D+=4;for(let b=0;b<u;b++)y.$ie(f,C.charCodeAt(b),D),D+=2;return D}static d(f,C){const D=y.$je(f,C);return C+=4,(0,T.$Ss)(f,C,D)}writeSize(){return 4+4+M.a(this.oldText)+M.a(this.newText)}write(f,C){return y.$ke(f,this.oldPosition,C),C+=4,y.$ke(f,this.newPosition,C),C+=4,C=M.c(f,this.oldText,C),C=M.c(f,this.newText,C),C}static read(f,C,D){const u=y.$je(f,C);C+=4;const b=y.$je(f,C);C+=4;const v=M.d(f,C);C+=M.a(v);const g=M.d(f,C);return C+=M.a(g),D.push(new M(u,v,b,g)),C}}e.$Us=M;function A(E,f){return E===null||E.length===0?f:new $(E,f).compress()}e.$Vs=A;class ${constructor(f,C){this.a=f,this.c=C,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let f=0,C=0,D=this.n(f),u=this.l(C);for(;f<this.f||C<this.h;){if(D===null){this.k(u),u=this.l(++C);continue}if(u===null){this.m(D),D=this.n(++f);continue}if(u.oldEnd<=D.newPosition){this.k(u),u=this.l(++C);continue}if(D.newEnd<=u.oldPosition){this.m(D),D=this.n(++f);continue}if(u.oldPosition<D.newPosition){const[i,r]=$.r(u,D.newPosition-u.oldPosition);this.k(i),u=r;continue}if(D.newPosition<u.oldPosition){const[i,r]=$.q(D,u.oldPosition-D.newPosition);this.m(i),D=r;continue}let g,t;if(u.oldEnd===D.newEnd)g=D,t=u,D=this.n(++f),u=this.l(++C);else if(u.oldEnd<D.newEnd){const[i,r]=$.q(D,u.oldLength);g=i,t=u,D=r,u=this.l(++C)}else{const[i,r]=$.r(u,D.newLength);g=D,t=i,D=this.n(++f),u=r}this.d[this.e++]=new M(g.oldPosition,g.oldText,t.newPosition,t.newText),this.g+=g.newLength-g.oldLength,this.j+=t.newLength-t.oldLength}const b=$.s(this.d);return $.t(b)}k(f){this.d[this.e++]=$.o(this.g,f),this.j+=f.newLength-f.oldLength}l(f){return f<this.h?this.c[f]:null}m(f){this.d[this.e++]=$.p(this.j,f),this.g+=f.newLength-f.oldLength}n(f){return f<this.f?this.a[f]:null}static o(f,C){return new M(C.oldPosition-f,C.oldText,C.newPosition,C.newText)}static p(f,C){return new M(C.oldPosition,C.oldText,C.newPosition+f,C.newText)}static q(f,C){const D=f.newText.substr(0,C),u=f.newText.substr(C);return[new M(f.oldPosition,f.oldText,f.newPosition,D),new M(f.oldEnd,"",f.newPosition+C,u)]}static r(f,C){const D=f.oldText.substr(0,C),u=f.oldText.substr(C);return[new M(f.oldPosition,D,f.newPosition,f.newText),new M(f.oldPosition+C,u,f.newEnd,"")]}static s(f){if(f.length===0)return f;const C=[];let D=0,u=f[0];for(let b=1;b<f.length;b++){const v=f[b];u.oldEnd===v.oldPosition?u=new M(u.oldPosition,u.oldText+v.oldText,u.newPosition,u.newText+v.newText):(C[D++]=u,u=v)}return C[D++]=u,C}static t(f){if(f.length===0)return f;const C=[];let D=0;for(let u=0;u<f.length;u++){const b=f[u];b.oldText!==b.newText&&(C[D++]=b)}return C}}}),define(Pe[142],Ae([1,0,33,20]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LE=void 0;function P(M,A,$,E,f,C){if(Array.isArray(M)){let D=0;for(const u of M){const b=P(u,A,$,E,f,C);if(b===10)return b;b>D&&(D=b)}return D}else{if(typeof M=="string")return E?M==="*"?5:M===$?10:0:0;if(M){const{language:D,pattern:u,scheme:b,hasAccessToAllModels:v,notebookType:g}=M;if(!E&&!v)return 0;g&&f&&(A=f);let t=0;if(b)if(b===A.scheme)t=10;else if(b==="*")t=5;else return 0;if(D)if(D===$)t=10;else if(D==="*")t=Math.max(t,5);else return 0;if(g)if(g===C)t=10;else if(g==="*"&&C!==void 0)t=Math.max(t,5);else return 0;if(u){let i;if(typeof u=="string"?i=u:i={...u,base:(0,T.$gc)(u.base)},i===A.fsPath||(0,y.$Bj)(i,A.fsPath))t=10;else return 0}return t}else return 0}}e.$LE=P}),define(Pe[143],Ae([1,0,5,12,29,92,91,127,141,6]),function(we,e,y,T,P,M,A,$,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MB=void 0;class C extends f.$Rc{constructor(u,b,v,g,t,i,r){super(),this.m=this.B(new y.$Rd),this.onDidChangeContent=this.m.event,this.f=b,this.j=!i,this.g=g,this.h=t,this.c=new A.$LB(u,v,r)}equals(u){return!(u instanceof C)||this.f!==u.f||this.getEOL()!==u.getEOL()?!1:this.c.equal(u.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(u){return this.c.createSnapshot(u?this.f:"")}getOffsetAt(u,b){return this.c.getOffsetAt(u,b)}getPositionAt(u){return this.c.getPositionAt(u)}getRangeAt(u,b){const v=u+b,g=this.getPositionAt(u),t=this.getPositionAt(v);return new P.$zs(g.lineNumber,g.column,t.lineNumber,t.column)}getValueInRange(u,b=0){if(u.isEmpty())return"";const v=this.n(b);return this.c.getValueInRange(u,v)}getValueLengthInRange(u,b=0){if(u.isEmpty())return 0;if(u.startLineNumber===u.endLineNumber)return u.endColumn-u.startColumn;const v=this.getOffsetAt(u.startLineNumber,u.startColumn),g=this.getOffsetAt(u.endLineNumber,u.endColumn);let t=0;const i=this.n(b),r=this.getEOL();if(i.length!==r.length){const c=i.length-r.length,o=u.endLineNumber-u.startLineNumber;t=c*o}return g-v+t}getCharacterCountInRange(u,b=0){if(this.j){let v=0;const g=u.startLineNumber,t=u.endLineNumber;for(let i=g;i<=t;i++){const r=this.getLineContent(i),c=i===g?u.startColumn-1:0,o=i===t?u.endColumn-1:r.length;for(let l=c;l<o;l++)T.$0e(r.charCodeAt(l))?(v=v+1,l=l+1):v=v+1}return v+=this.n(b).length*(t-g),v}return this.getValueLengthInRange(u,b)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(u){return this.c.getLineContent(u)}getLineCharCode(u,b){return this.c.getLineCharCode(u,b)}getCharCode(u){return this.c.getCharCode(u)}getLineLength(u){return this.c.getLineLength(u)}getLineMinColumn(u){return 1}getLineMaxColumn(u){return this.getLineLength(u)+1}getLineFirstNonWhitespaceColumn(u){const b=T.$Ue(this.getLineContent(u));return b===-1?0:b+1}getLineLastNonWhitespaceColumn(u){const b=T.$We(this.getLineContent(u));return b===-1?0:b+2}n(u){switch(u){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(u){this.c.setEOL(u)}applyEdits(u,b,v){let g=this.g,t=this.h,i=this.j,r=!0,c=[];for(let p=0;p<u.length;p++){const m=u[p];r&&m._isTracked&&(r=!1);const S=m.range;if(m.text){let F=!0;i||(F=!T.$if(m.text),i=F),!g&&F&&(g=T.$hf(m.text)),!t&&F&&(t=T.$kf(m.text))}let k="",h=0,w=0,I=0;if(m.text){let F;[h,w,I,F]=(0,$.$_s)(m.text);const V=this.getEOL();F===0||F===(V===`\r
`?2:1)?k=m.text:k=m.text.replace(/\r\n|\r|\n/g,V)}c[p]={sortIndex:p,identifier:m.identifier||null,range:S,rangeOffset:this.getOffsetAt(S.startLineNumber,S.startColumn),rangeLength:this.getValueLengthInRange(S),text:k,eolCount:h,firstLineLength:w,lastLineLength:I,forceMoveMarkers:!!m.forceMoveMarkers,isAutoWhitespaceEdit:m.isAutoWhitespaceEdit||!1}}c.sort(C.u);let o=!1;for(let p=0,m=c.length-1;p<m;p++){const S=c[p].range.getEndPosition(),k=c[p+1].range.getStartPosition();if(k.isBeforeOrEqual(S)){if(k.isBefore(S))throw new Error("Overlapping ranges are not allowed!");o=!0}}r&&(c=this.s(c));const l=v||b?C._getInverseEditRanges(c):[],n=[];if(b)for(let p=0;p<c.length;p++){const m=c[p],S=l[p];if(m.isAutoWhitespaceEdit&&m.range.isEmpty())for(let k=S.startLineNumber;k<=S.endLineNumber;k++){let h="";k===S.startLineNumber&&(h=this.getLineContent(m.range.startLineNumber),T.$Ue(h)!==-1)||n.push({lineNumber:k,oldContent:h})}}let s=null;if(v){let p=0;s=[];for(let m=0;m<c.length;m++){const S=c[m],k=l[m],h=this.getValueInRange(S.range),w=S.rangeOffset+p;p+=S.text.length-h.length,s[m]={sortIndex:S.sortIndex,identifier:S.identifier,range:k,text:h,textChange:new E.$Us(S.rangeOffset,h,w,S.text)}}o||s.sort((m,S)=>m.sortIndex-S.sortIndex)}this.g=g,this.h=t,this.j=i;const a=this.t(c);let d=null;if(b&&n.length>0){n.sort((p,m)=>m.lineNumber-p.lineNumber),d=[];for(let p=0,m=n.length;p<m;p++){const S=n[p].lineNumber;if(p>0&&n[p-1].lineNumber===S)continue;const k=n[p].oldContent,h=this.getLineContent(S);h.length===0||h===k||T.$Ue(h)!==-1||d.push(S)}}return this.m.fire(),new M.$Uu(s,a,d)}s(u){return u.length<1e3?u:[this._toSingleEditOperation(u)]}_toSingleEditOperation(u){let b=!1;const v=u[0].range,g=u[u.length-1].range,t=new P.$zs(v.startLineNumber,v.startColumn,g.endLineNumber,g.endColumn);let i=v.startLineNumber,r=v.startColumn;const c=[];for(let a=0,d=u.length;a<d;a++){const p=u[a],m=p.range;b=b||p.forceMoveMarkers,c.push(this.getValueInRange(new P.$zs(i,r,m.startLineNumber,m.startColumn))),p.text.length>0&&c.push(p.text),i=m.endLineNumber,r=m.endColumn}const o=c.join(""),[l,n,s]=(0,$.$_s)(o);return{sortIndex:0,identifier:u[0].identifier,range:t,rangeOffset:this.getOffsetAt(t.startLineNumber,t.startColumn),rangeLength:this.getValueLengthInRange(t,0),text:o,eolCount:l,firstLineLength:n,lastLineLength:s,forceMoveMarkers:b,isAutoWhitespaceEdit:!1}}t(u){u.sort(C.w);const b=[];for(let v=0;v<u.length;v++){const g=u[v],t=g.range.startLineNumber,i=g.range.startColumn,r=g.range.endLineNumber,c=g.range.endColumn;if(t===r&&i===c&&g.text.length===0)continue;g.text?(this.c.delete(g.rangeOffset,g.rangeLength),this.c.insert(g.rangeOffset,g.text,!0)):this.c.delete(g.rangeOffset,g.rangeLength);const o=new P.$zs(t,i,r,c);b.push({range:o,rangeLength:g.rangeLength,text:g.text,rangeOffset:g.rangeOffset,forceMoveMarkers:g.forceMoveMarkers})}return b}findMatchesLineByLine(u,b,v,g){return this.c.findMatchesLineByLine(u,b,v,g)}getPieceTree(){return this.c}static _getInverseEditRange(u,b){const v=u.startLineNumber,g=u.startColumn,[t,i,r]=(0,$.$_s)(b);let c;if(b.length>0){const o=t+1;o===1?c=new P.$zs(v,g,v,g+i):c=new P.$zs(v,g,v+o-1,r+1)}else c=new P.$zs(v,g,v,g);return c}static _getInverseEditRanges(u){const b=[];let v=0,g=0,t=null;for(let i=0,r=u.length;i<r;i++){const c=u[i];let o,l;t?t.range.endLineNumber===c.range.startLineNumber?(o=v,l=g+(c.range.startColumn-t.range.endColumn)):(o=v+(c.range.startLineNumber-t.range.endLineNumber),l=c.range.startColumn):(o=c.range.startLineNumber,l=c.range.startColumn);let n;if(c.text.length>0){const s=c.eolCount+1;s===1?n=new P.$zs(o,l,o,l+c.firstLineLength):n=new P.$zs(o,l,o+s-1,c.lastLineLength+1)}else n=new P.$zs(o,l,o,l);v=n.endLineNumber,g=n.endColumn,b.push(n),t=c}return b}static u(u,b){const v=P.$zs.compareRangesUsingEnds(u.range,b.range);return v===0?u.sortIndex-b.sortIndex:v}static w(u,b){const v=P.$zs.compareRangesUsingEnds(u.range,b.range);return v===0?b.sortIndex-u.sortIndex:-v}}e.$MB=C}),define(Pe[144],Ae([1,0,12,91,143]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NB=void 0;class M{constructor(E,f,C,D,u,b,v,g,t){this.a=E,this.b=f,this.c=C,this.d=D,this.e=u,this.f=b,this.g=v,this.h=g,this.j=t}k(E){const f=this.c+this.d+this.e,C=this.c+this.e;return f===0?E===1?`
`:`\r
`:C>f/2?`\r
`:`
`}create(E){const f=this.k(E),C=this.a;if(this.j&&(f===`\r
`&&(this.c>0||this.d>0)||f===`
`&&(this.c>0||this.e>0)))for(let u=0,b=C.length;u<b;u++){const v=C[u].buffer.replace(/\r\n|\r|\n/g,f),g=(0,T.$HB)(v);C[u]=new T.$KB(v,g)}const D=new P.$MB(C,this.b,f,this.f,this.g,this.h,this.j);return{textBuffer:D,disposable:D}}getFirstLineText(E){return this.a[0].buffer.substr(0,E).split(/\r\n|\r|\n/)[0]}}class A{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(E){if(E.length===0)return;this.a.length===0&&y.$qf(E)&&(this.b=y.$pf,E=E.substr(1));const f=E.charCodeAt(E.length-1);f===13||f>=55296&&f<=56319?(this.m(E.substr(0,E.length-1),!1),this.c=!0,this.d=f):(this.m(E,!1),this.c=!1,this.d=f)}m(E,f){!f&&E.length===0||(this.c?this.n(String.fromCharCode(this.d)+E):this.n(E))}n(E){const f=(0,T.$IB)(this.e,E);this.a.push(new T.$KB(E,f.lineStarts)),this.f+=f.cr,this.g+=f.lf,this.h+=f.crlf,f.isBasicASCII||(this.l=!1,this.j||(this.j=y.$hf(E)),this.k||(this.k=y.$kf(E)))}finish(E=!0){return this.o(),new M(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,E)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const E=this.a[this.a.length-1];E.buffer+=String.fromCharCode(this.d);const f=(0,T.$HB)(E.buffer);E.lineStarts=f,this.d===13&&this.f++}}}e.$NB=A}),define(Pe[95],Ae([1,0,24,21]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$30=e.$20=void 0;var P;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(P||(P={}));function M(D){for(let u=0,b=D.length;u<b;u+=4){const v=D[u+0],g=D[u+1],t=D[u+2],i=D[u+3];D[u+0]=i,D[u+1]=t,D[u+2]=g,D[u+3]=v}}function A(D){const u=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return T.$D()||M(u),y.$fe.wrap(u)}function $(D){const u=D.buffer;if(T.$D()||M(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const b=new Uint8Array(u.byteLength);return b.set(u),new Uint32Array(b.buffer,b.byteOffset,b.length/4)}}function E(D){const u=new Uint32Array(f(D));let b=0;if(u[b++]=D.id,D.type==="full")u[b++]=1,u[b++]=D.data.length,u.set(D.data,b),b+=D.data.length;else{u[b++]=2,u[b++]=D.deltas.length;for(const v of D.deltas)u[b++]=v.start,u[b++]=v.deleteCount,v.data?(u[b++]=v.data.length,u.set(v.data,b),b+=v.data.length):u[b++]=0}return A(u)}e.$20=E;function f(D){let u=0;if(u+=1+1,D.type==="full")u+=1+D.data.length;else{u+=1,u+=(1+1+1)*D.deltas.length;for(const b of D.deltas)b.data&&(u+=b.data.length)}return u}function C(D){const u=$(D);let b=0;const v=u[b++];if(u[b++]===1){const r=u[b++],c=u.subarray(b,b+r);return b+=r,{id:v,type:"full",data:c}}const t=u[b++],i=[];for(let r=0;r<t;r++){const c=u[b++],o=u[b++],l=u[b++];let n;l>0&&(n=u.subarray(b,b+l),b+=l),i[r]={start:c,deleteCount:o,data:n}}return{id:v,type:"delta",deltas:i}}e.$30=C}),define(Pe[145],Ae([9,10]),function(we,e){return we.create("vs/editor/common/config/editorOptions",e)}),define(Pe[146],Ae([1,0,18,26,21,128,147,145]),function(we,e,y,T,P,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var E;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(E||(e.EditorAutoIndentStrategy=E={})),e.MINIMAP_GUTTER_WIDTH=8;class f{constructor(J){this.c=J}hasChanged(J){return this.c[J]}}e.ConfigurationChangedEvent=f;class C{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=C;class D{constructor(J,Ee,Be,He){this.id=J,this.name=Ee,this.defaultValue=Be,this.schema=He}applyUpdate(J,Ee){return b(J,Ee)}compute(J,Ee,Be){return Be}}class u{constructor(J,Ee){this.newValue=J,this.didChange=Ee}}e.ApplyUpdateResult=u;function b(X,J){if(typeof X!="object"||typeof J!="object"||!X||!J)return new u(J,X!==J);if(Array.isArray(X)||Array.isArray(J)){const Be=Array.isArray(X)&&Array.isArray(J)&&y.$tb(X,J);return new u(J,!Be)}let Ee=!1;for(const Be in J)if(J.hasOwnProperty(Be)){const He=b(X[Be],J[Be]);He.didChange&&(X[Be]=He.newValue,Ee=!0)}return new u(X,Ee)}class v{constructor(J){this.schema=void 0,this.id=J,this.name="_never_",this.defaultValue=void 0}applyUpdate(J,Ee){return b(J,Ee)}validate(J){return this.defaultValue}}class g{constructor(J,Ee,Be,He){this.id=J,this.name=Ee,this.defaultValue=Be,this.schema=He}applyUpdate(J,Ee){return b(J,Ee)}validate(J){return typeof J>"u"?this.defaultValue:J}compute(J,Ee,Be){return Be}}function t(X,J){return typeof X>"u"?J:X==="false"?!1:!!X}e.boolean=t;class i extends g{constructor(J,Ee,Be,He=void 0){typeof He<"u"&&(He.type="boolean",He.default=Be),super(J,Ee,Be,He)}validate(J){return t(J,this.defaultValue)}}function r(X,J,Ee,Be){if(typeof X>"u")return J;let He=parseInt(X,10);return isNaN(He)?J:(He=Math.max(Ee,He),He=Math.min(Be,He),He|0)}e.clampedInt=r;class c extends g{static clampedInt(J,Ee,Be,He){return r(J,Ee,Be,He)}constructor(J,Ee,Be,He,Xe,st=void 0){typeof st<"u"&&(st.type="integer",st.default=Be,st.minimum=He,st.maximum=Xe),super(J,Ee,Be,st),this.minimum=He,this.maximum=Xe}validate(J){return c.clampedInt(J,this.defaultValue,this.minimum,this.maximum)}}function o(X,J,Ee,Be){if(typeof X>"u")return J;const He=l.float(X,J);return l.clamp(He,Ee,Be)}e.clampedFloat=o;class l extends g{static clamp(J,Ee,Be){return J<Ee?Ee:J>Be?Be:J}static float(J,Ee){if(typeof J=="number")return J;if(typeof J>"u")return Ee;const Be=parseFloat(J);return isNaN(Be)?Ee:Be}constructor(J,Ee,Be,He,Xe){typeof Xe<"u"&&(Xe.type="number",Xe.default=Be),super(J,Ee,Be,Xe),this.validationFn=He}validate(J){return this.validationFn(l.float(J,this.defaultValue))}}class n extends g{static string(J,Ee){return typeof J!="string"?Ee:J}constructor(J,Ee,Be,He=void 0){typeof He<"u"&&(He.type="string",He.default=Be),super(J,Ee,Be,He)}validate(J){return n.string(J,this.defaultValue)}}function s(X,J,Ee,Be){return typeof X!="string"?J:Be&&X in Be?Be[X]:Ee.indexOf(X)===-1?J:X}e.stringSet=s;class a extends g{constructor(J,Ee,Be,He,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.enum=He,Xe.default=Be),super(J,Ee,Be,Xe),this.c=He}validate(J){return s(J,this.defaultValue,this.c)}}class d extends D{constructor(J,Ee,Be,He,Xe,st,vt=void 0){typeof vt<"u"&&(vt.type="string",vt.enum=Xe,vt.default=He),super(J,Ee,Be,vt),this.c=Xe,this.d=st}validate(J){return typeof J!="string"?this.defaultValue:this.c.indexOf(J)===-1?this.defaultValue:this.d(J)}}function p(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class m extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[$.localize(0,null),$.localize(1,null),$.localize(2,null)],default:"auto",tags:["accessibility"],description:$.localize(3,null)})}validate(J){switch(J){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(J,Ee,Be){return Be===0?J.accessibilitySupport:Be}}class S extends D{constructor(){const J={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",J,{"editor.comments.insertSpace":{type:"boolean",default:J.insertSpace,description:$.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:J.ignoreEmptyLines,description:$.localize(5,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Ee=J;return{insertSpace:t(Ee.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(Ee.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var k;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(k||(e.TextEditorCursorBlinkingStyle=k={}));function h(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var w;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(w||(e.TextEditorCursorStyle=w={}));function I(X){switch(X){case w.Line:return"line";case w.Block:return"block";case w.Underline:return"underline";case w.LineThin:return"line-thin";case w.BlockOutline:return"block-outline";case w.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=I;function F(X){switch(X){case"line":return w.Line;case"block":return w.Block;case"underline":return w.Underline;case"line-thin":return w.LineThin;case"block-outline":return w.BlockOutline;case"underline-thin":return w.UnderlineThin}}class V extends v{constructor(){super(140)}compute(J,Ee,Be){const He=["monaco-editor"];return Ee.get(39)&&He.push(Ee.get(39)),J.extraEditorClassName&&He.push(J.extraEditorClassName),Ee.get(73)==="default"?He.push("mouse-default"):Ee.get(73)==="copy"&&He.push("mouse-copy"),Ee.get(110)&&He.push("showUnused"),Ee.get(138)&&He.push("showDeprecated"),He.join(" ")}}class Z extends i{constructor(){super(37,"emptySelectionClipboard",!0,{description:$.localize(6,null)})}compute(J,Ee,Be){return Be&&J.emptySelectionClipboard}}class N extends D{constructor(){const J={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",J,{"editor.find.cursorMoveOnType":{type:"boolean",default:J.cursorMoveOnType,description:$.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:J.seedSearchStringFromSelection,enumDescriptions:[$.localize(8,null),$.localize(9,null),$.localize(10,null)],description:$.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:J.autoFindInSelection,enumDescriptions:[$.localize(12,null),$.localize(13,null),$.localize(14,null)],description:$.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:J.globalFindClipboard,description:$.localize(16,null),included:P.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:J.addExtraSpaceOnTop,description:$.localize(17,null)},"editor.find.loop":{type:"boolean",default:J.loop,description:$.localize(18,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Ee=J;return{cursorMoveOnType:t(Ee.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof J.seedSearchStringFromSelection=="boolean"?J.seedSearchStringFromSelection?"always":"never":s(Ee.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof J.autoFindInSelection=="boolean"?J.autoFindInSelection?"always":"never":s(Ee.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(Ee.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(Ee.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(Ee.loop,this.defaultValue.loop)}}}class R extends D{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",R.OFF,{anyOf:[{type:"boolean",description:$.localize(19,null)},{type:"string",description:$.localize(20,null)}],description:$.localize(21,null),default:!1})}validate(J){return typeof J>"u"?this.defaultValue:typeof J=="string"?J==="false"?R.OFF:J==="true"?R.ON:J:J?R.ON:R.OFF}}e.EditorFontLigatures=R;class L extends D{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",L.OFF,{anyOf:[{type:"boolean",description:$.localize(22,null)},{type:"string",description:$.localize(23,null)}],description:$.localize(24,null),default:!1})}validate(J){return typeof J>"u"?this.defaultValue:typeof J=="string"?J==="false"?L.OFF:J==="true"?L.TRANSLATE:J:J?L.TRANSLATE:L.OFF}compute(J,Ee,Be){return J.fontInfo.fontVariationSettings}}e.EditorFontVariations=L;class O extends v{constructor(){super(50)}compute(J,Ee,Be){return J.fontInfo}}class Y extends g{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:$.localize(25,null)})}validate(J){const Ee=l.float(J,this.defaultValue);return Ee===0?e.EDITOR_FONT_DEFAULTS.fontSize:l.clamp(Ee,6,100)}compute(J,Ee,Be){return J.fontInfo.fontSize}}class he extends D{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:he.d,maximum:he.e,errorMessage:$.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:he.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:$.localize(27,null)})}validate(J){return J==="normal"||J==="bold"?J:String(c.clampedInt(J,e.EDITOR_FONT_DEFAULTS.fontWeight,he.d,he.e))}}class $e extends D{constructor(){const J={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ee={type:"string",enum:["peek","gotoAndPeek","goto"],default:J.multiple,enumDescriptions:[$.localize(28,null),$.localize(29,null),$.localize(30,null)]},Be=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",J,{"editor.gotoLocation.multiple":{deprecationMessage:$.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:$.localize(32,null),...Ee},"editor.gotoLocation.multipleTypeDefinitions":{description:$.localize(33,null),...Ee},"editor.gotoLocation.multipleDeclarations":{description:$.localize(34,null),...Ee},"editor.gotoLocation.multipleImplementations":{description:$.localize(35,null),...Ee},"editor.gotoLocation.multipleReferences":{description:$.localize(36,null),...Ee},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:J.alternativeDefinitionCommand,enum:Be,description:$.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:J.alternativeTypeDefinitionCommand,enum:Be,description:$.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:J.alternativeDeclarationCommand,enum:Be,description:$.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:J.alternativeImplementationCommand,enum:Be,description:$.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:J.alternativeReferenceCommand,enum:Be,description:$.localize(41,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Ee=J;return{multiple:s(Ee.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ee.multipleDefinitions??s(Ee.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ee.multipleTypeDefinitions??s(Ee.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ee.multipleDeclarations??s(Ee.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ee.multipleImplementations??s(Ee.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ee.multipleReferences??s(Ee.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:n.string(Ee.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:n.string(Ee.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:n.string(Ee.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:n.string(Ee.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:n.string(Ee.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class De extends D{constructor(){const J={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",J,{"editor.hover.enabled":{type:"boolean",default:J.enabled,description:$.localize(42,null)},"editor.hover.delay":{type:"number",default:J.delay,minimum:0,maximum:1e4,description:$.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:J.sticky,description:$.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:J.hidingDelay,description:$.localize(45,null)},"editor.hover.above":{type:"boolean",default:J.above,description:$.localize(46,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Ee=J;return{enabled:t(Ee.enabled,this.defaultValue.enabled),delay:c.clampedInt(Ee.delay,this.defaultValue.delay,0,1e4),sticky:t(Ee.sticky,this.defaultValue.sticky),hidingDelay:c.clampedInt(Ee.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:t(Ee.above,this.defaultValue.above)}}}var ke;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(ke||(e.RenderMinimap=ke={}));class fe extends v{constructor(){super(143)}compute(J,Ee,Be){return fe.computeLayout(Ee,{memory:J.memory,outerWidth:J.outerWidth,outerHeight:J.outerHeight,isDominatedByLongLines:J.isDominatedByLongLines,lineHeight:J.fontInfo.lineHeight,viewLineCount:J.viewLineCount,lineNumbersDigitCount:J.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:J.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:J.fontInfo.maxDigitWidth,pixelRatio:J.pixelRatio,glyphMarginDecorationLaneCount:J.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(J){const Ee=J.height/J.lineHeight,Be=Math.floor(J.paddingTop/J.lineHeight);let He=Math.floor(J.paddingBottom/J.lineHeight);J.scrollBeyondLastLine&&(He=Math.max(He,Ee-1));const Xe=(Be+J.viewLineCount+He)/(J.pixelRatio*J.height),st=Math.floor(J.viewLineCount/Xe);return{typicalViewportLineCount:Ee,extraLinesBeforeFirstLine:Be,extraLinesBeyondLastLine:He,desiredRatio:Xe,minimapLineCount:st}}static c(J,Ee){const Be=J.outerWidth,He=J.outerHeight,Xe=J.pixelRatio;if(!J.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Xe*He),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:He};const st=Ee.stableMinimapLayoutInput,vt=st&&J.outerHeight===st.outerHeight&&J.lineHeight===st.lineHeight&&J.typicalHalfwidthCharacterWidth===st.typicalHalfwidthCharacterWidth&&J.pixelRatio===st.pixelRatio&&J.scrollBeyondLastLine===st.scrollBeyondLastLine&&J.paddingTop===st.paddingTop&&J.paddingBottom===st.paddingBottom&&J.minimap.enabled===st.minimap.enabled&&J.minimap.side===st.minimap.side&&J.minimap.size===st.minimap.size&&J.minimap.showSlider===st.minimap.showSlider&&J.minimap.renderCharacters===st.minimap.renderCharacters&&J.minimap.maxColumn===st.minimap.maxColumn&&J.minimap.scale===st.minimap.scale&&J.verticalScrollbarWidth===st.verticalScrollbarWidth&&J.isViewportWrapping===st.isViewportWrapping,Dt=J.lineHeight,Ne=J.typicalHalfwidthCharacterWidth,Kt=J.scrollBeyondLastLine,Ht=J.minimap.renderCharacters;let yt=Xe>=2?Math.round(J.minimap.scale*2):J.minimap.scale;const jt=J.minimap.maxColumn,Nt=J.minimap.size,Gt=J.minimap.side,Bt=J.verticalScrollbarWidth,St=J.viewLineCount,Lt=J.remainingWidth,Vt=J.isViewportWrapping,Ye=Ht?2:3;let Wt=Math.floor(Xe*He);const qt=Wt/Xe;let ct=!1,gt=!1,Ot=Ye*yt,Pt=yt/Xe,At=1;if(Nt==="fill"||Nt==="fit"){const{typicalViewportLineCount:Jt,extraLinesBeforeFirstLine:Ce,extraLinesBeyondLastLine:Me,desiredRatio:be,minimapLineCount:K}=fe.computeContainedMinimapLineCount({viewLineCount:St,scrollBeyondLastLine:Kt,paddingTop:J.paddingTop,paddingBottom:J.paddingBottom,height:He,lineHeight:Dt,pixelRatio:Xe});if(St/K>1)ct=!0,gt=!0,yt=1,Ot=1,Pt=yt/Xe;else{let je=!1,Qe=yt+1;if(Nt==="fit"){const qe=Math.ceil((Ce+St+Me)*Ot);Vt&&vt&&Lt<=Ee.stableFitRemainingWidth?(je=!0,Qe=Ee.stableFitMaxMinimapScale):je=qe>Wt}if(Nt==="fill"||je){ct=!0;const qe=yt;Ot=Math.min(Dt*Xe,Math.max(1,Math.floor(1/be))),Vt&&vt&&Lt<=Ee.stableFitRemainingWidth&&(Qe=Ee.stableFitMaxMinimapScale),yt=Math.min(Qe,Math.max(1,Math.floor(Ot/Ye))),yt>qe&&(At=Math.min(2,yt/qe)),Pt=yt/Xe/At,Wt=Math.ceil(Math.max(Jt,Ce+St+Me)*Ot),Vt?(Ee.stableMinimapLayoutInput=J,Ee.stableFitRemainingWidth=Lt,Ee.stableFitMaxMinimapScale=yt):(Ee.stableMinimapLayoutInput=null,Ee.stableFitRemainingWidth=0)}}}const ft=Math.floor(jt*Pt),kt=Math.min(ft,Math.max(0,Math.floor((Lt-Bt-2)*Pt/(Ne+Pt)))+e.MINIMAP_GUTTER_WIDTH);let Rt=Math.floor(Xe*kt);const Ct=Rt/Xe;Rt=Math.floor(Rt*At);const We=Ht?1:2,zt=Gt==="left"?0:Be-kt-Bt;return{renderMinimap:We,minimapLeft:zt,minimapWidth:kt,minimapHeightIsEditorHeight:ct,minimapIsSampling:gt,minimapScale:yt,minimapLineHeight:Ot,minimapCanvasInnerWidth:Rt,minimapCanvasInnerHeight:Wt,minimapCanvasOuterWidth:Ct,minimapCanvasOuterHeight:qt}}static computeLayout(J,Ee){const Be=Ee.outerWidth|0,He=Ee.outerHeight|0,Xe=Ee.lineHeight|0,st=Ee.lineNumbersDigitCount|0,vt=Ee.typicalHalfwidthCharacterWidth,Dt=Ee.maxDigitWidth,Ne=Ee.pixelRatio,Kt=Ee.viewLineCount,Ht=J.get(135),yt=Ht==="inherit"?J.get(134):Ht,jt=yt==="inherit"?J.get(130):yt,Nt=J.get(133),Gt=Ee.isDominatedByLongLines,Bt=J.get(57),St=J.get(67).renderType!==0,Lt=J.get(68),Vt=J.get(104),Ye=J.get(83),Wt=J.get(72),qt=J.get(102),ct=qt.verticalScrollbarSize,gt=qt.verticalHasArrows,Ot=qt.arrowSize,Pt=qt.horizontalScrollbarSize,At=J.get(43),ft=J.get(109)!=="never";let kt=J.get(65);At&&ft&&(kt+=16);let Rt=0;if(St){const pt=Math.max(st,Lt);Rt=Math.round(pt*Dt)}let Ct=0;Bt&&(Ct=Xe*Ee.glyphMarginDecorationLaneCount);let We=0,zt=We+Ct,Jt=zt+Rt,Ce=Jt+kt;const Me=Be-Ct-Rt-kt;let be=!1,K=!1,Le=-1;yt==="inherit"&&Gt?(be=!0,K=!0):jt==="on"||jt==="bounded"?K=!0:jt==="wordWrapColumn"&&(Le=Nt);const je=fe.c({outerWidth:Be,outerHeight:He,lineHeight:Xe,typicalHalfwidthCharacterWidth:vt,pixelRatio:Ne,scrollBeyondLastLine:Vt,paddingTop:Ye.top,paddingBottom:Ye.bottom,minimap:Wt,verticalScrollbarWidth:ct,viewLineCount:Kt,remainingWidth:Me,isViewportWrapping:K},Ee.memory||new C);je.renderMinimap!==0&&je.minimapLeft===0&&(We+=je.minimapWidth,zt+=je.minimapWidth,Jt+=je.minimapWidth,Ce+=je.minimapWidth);const Qe=Me-je.minimapWidth,qe=Math.max(1,Math.floor((Qe-ct-2)/vt)),it=gt?Ot:0;return K&&(Le=Math.max(1,qe),jt==="bounded"&&(Le=Math.min(Le,Nt))),{width:Be,height:He,glyphMarginLeft:We,glyphMarginWidth:Ct,glyphMarginDecorationLaneCount:Ee.glyphMarginDecorationLaneCount,lineNumbersLeft:zt,lineNumbersWidth:Rt,decorationsLeft:Jt,decorationsWidth:kt,contentLeft:Ce,contentWidth:Qe,minimap:je,viewportColumn:qe,isWordWrapMinified:be,isViewportWrapping:K,wrappingColumn:Le,verticalScrollbarWidth:ct,horizontalScrollbarHeight:Pt,overviewRuler:{top:it,width:ct,height:He-2*it,right:0}}}}e.EditorLayoutInfoComputer=fe;class ve extends D{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[$.localize(47,null),$.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:$.localize(49,null)}})}validate(J){return s(J,"simple",["simple","advanced"])}compute(J,Ee,Be){return Ee.get(2)===2?"advanced":Be}}class te extends D{constructor(){const J={enabled:!0};super(64,"lightbulb",J,{"editor.lightbulb.enabled":{type:"boolean",default:J.enabled,description:$.localize(50,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:t(J.enabled,this.defaultValue.enabled)}}}class Re extends D{constructor(){const J={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",J,{"editor.stickyScroll.enabled":{type:"boolean",default:J.enabled,description:$.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:J.maxLineCount,minimum:1,maximum:10,description:$.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:J.defaultModel,description:$.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:J.scrollWithEditor,description:$.localize(54,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Ee=J;return{enabled:t(Ee.enabled,this.defaultValue.enabled),maxLineCount:c.clampedInt(Ee.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:s(Ee.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:t(Ee.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class se extends D{constructor(){const J={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",J,{"editor.inlayHints.enabled":{type:"string",default:J.enabled,description:$.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[$.localize(56,null),$.localize(57,null,P.$j?"Ctrl+Option":"Ctrl+Alt"),$.localize(58,null,P.$j?"Ctrl+Option":"Ctrl+Alt"),$.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:J.fontSize,markdownDescription:$.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:J.fontFamily,markdownDescription:$.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:J.padding,description:$.localize(62,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Ee=J;return typeof Ee.enabled=="boolean"&&(Ee.enabled=Ee.enabled?"on":"off"),{enabled:s(Ee.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:c.clampedInt(Ee.fontSize,this.defaultValue.fontSize,0,100),fontFamily:n.string(Ee.fontFamily,this.defaultValue.fontFamily),padding:t(Ee.padding,this.defaultValue.padding)}}}class Q extends D{constructor(){super(65,"lineDecorationsWidth",10)}validate(J){return typeof J=="string"&&/^\d+(\.\d+)?ch$/.test(J)?-parseFloat(J.substring(0,J.length-2)):c.clampedInt(J,this.defaultValue,0,1e3)}compute(J,Ee,Be){return Be<0?c.clampedInt(-Be*J.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Be}}class B extends l{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,J=>l.clamp(J,0,150),{markdownDescription:$.localize(63,null)})}compute(J,Ee,Be){return J.fontInfo.lineHeight}}class ne extends D{constructor(){const J={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",J,{"editor.minimap.enabled":{type:"boolean",default:J.enabled,description:$.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:J.autohide,description:$.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[$.localize(66,null),$.localize(67,null),$.localize(68,null)],default:J.size,description:$.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:J.side,description:$.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:J.showSlider,description:$.localize(71,null)},"editor.minimap.scale":{type:"number",default:J.scale,minimum:1,maximum:3,enum:[1,2,3],description:$.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:J.renderCharacters,description:$.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:J.maxColumn,description:$.localize(74,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Ee=J;return{enabled:t(Ee.enabled,this.defaultValue.enabled),autohide:t(Ee.autohide,this.defaultValue.autohide),size:s(Ee.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(Ee.side,this.defaultValue.side,["right","left"]),showSlider:s(Ee.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(Ee.renderCharacters,this.defaultValue.renderCharacters),scale:c.clampedInt(Ee.scale,1,1,3),maxColumn:c.clampedInt(Ee.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function pe(X){return X==="ctrlCmd"?P.$j?"metaKey":"ctrlKey":"altKey"}class re extends D{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(76,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Ee=J;return{top:c.clampedInt(Ee.top,0,0,1e3),bottom:c.clampedInt(Ee.bottom,0,0,1e3)}}}class le extends D{constructor(){const J={enabled:!0,cycle:!0};super(85,"parameterHints",J,{"editor.parameterHints.enabled":{type:"boolean",default:J.enabled,description:$.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:J.cycle,description:$.localize(78,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Ee=J;return{enabled:t(Ee.enabled,this.defaultValue.enabled),cycle:t(Ee.cycle,this.defaultValue.cycle)}}}class ce extends v{constructor(){super(141)}compute(J,Ee,Be){return J.pixelRatio}}class ye extends D{constructor(){const J={other:"on",comments:"off",strings:"off"},Ee=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[$.localize(79,null),$.localize(80,null),$.localize(81,null)]}];super(88,"quickSuggestions",J,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ee,default:J.strings,description:$.localize(82,null)},comments:{anyOf:Ee,default:J.comments,description:$.localize(83,null)},other:{anyOf:Ee,default:J.other,description:$.localize(84,null)}},default:J,markdownDescription:$.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=J}validate(J){if(typeof J=="boolean"){const Ne=J?"on":"off";return{comments:Ne,strings:Ne,other:Ne}}if(!J||typeof J!="object")return this.defaultValue;const{other:Ee,comments:Be,strings:He}=J,Xe=["on","inline","off"];let st,vt,Dt;return typeof Ee=="boolean"?st=Ee?"on":"off":st=s(Ee,this.defaultValue.other,Xe),typeof Be=="boolean"?vt=Be?"on":"off":vt=s(Be,this.defaultValue.comments,Xe),typeof He=="boolean"?Dt=He?"on":"off":Dt=s(He,this.defaultValue.strings,Xe),{other:st,comments:vt,strings:Dt}}}var _;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(_||(e.RenderLineNumbersType=_={}));class de extends D{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[$.localize(86,null),$.localize(87,null),$.localize(88,null),$.localize(89,null)],default:"on",description:$.localize(90,null)})}validate(J){let Ee=this.defaultValue.renderType,Be=this.defaultValue.renderFn;return typeof J<"u"&&(typeof J=="function"?(Ee=4,Be=J):J==="interval"?Ee=3:J==="relative"?Ee=2:J==="on"?Ee=1:Ee=0),{renderType:Ee,renderFn:Be}}}function ie(X){const J=X.get(97);return J==="editable"?X.get(90):J!=="on"}e.filterValidationDecorations=ie;class ae extends D{constructor(){const J=[],Ee={type:"number",description:$.localize(91,null)};super(101,"rulers",J,{type:"array",items:{anyOf:[Ee,{type:["object"],properties:{column:Ee,color:{type:"string",description:$.localize(92,null),format:"color-hex"}}}]},default:J,description:$.localize(93,null)})}validate(J){if(Array.isArray(J)){const Ee=[];for(const Be of J)if(typeof Be=="number")Ee.push({column:c.clampedInt(Be,0,0,1e4),color:null});else if(Be&&typeof Be=="object"){const He=Be;Ee.push({column:c.clampedInt(He.column,0,0,1e4),color:He.color})}return Ee.sort((Be,He)=>Be.column-He.column),Ee}return this.defaultValue}}class me extends D{constructor(){super(91,"readOnlyMessage",void 0)}validate(J){return!J||typeof J!="object"?this.defaultValue:J}}function Ie(X,J){if(typeof X!="string")return J;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class z extends D{constructor(){const J={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",J,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(94,null),$.localize(95,null),$.localize(96,null)],default:"auto",description:$.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(98,null),$.localize(99,null),$.localize(100,null)],default:"auto",description:$.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:J.verticalScrollbarSize,description:$.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:J.horizontalScrollbarSize,description:$.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:J.scrollByPage,description:$.localize(104,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:J.ignoreHorizontalScrollbarInContentHeight,description:$.localize(105,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Ee=J,Be=c.clampedInt(Ee.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),He=c.clampedInt(Ee.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:c.clampedInt(Ee.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ie(Ee.vertical,this.defaultValue.vertical),horizontal:Ie(Ee.horizontal,this.defaultValue.horizontal),useShadows:t(Ee.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(Ee.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(Ee.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(Ee.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(Ee.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Be,horizontalSliderSize:c.clampedInt(Ee.horizontalSliderSize,Be,0,1e3),verticalScrollbarSize:He,verticalSliderSize:c.clampedInt(Ee.verticalSliderSize,He,0,1e3),scrollByPage:t(Ee.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:t(Ee.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class W extends D{constructor(){const J={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",J,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:J.nonBasicASCII,description:$.localize(106,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:J.invisibleCharacters,description:$.localize(107,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:J.ambiguousCharacters,description:$.localize(108,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:J.includeComments,description:$.localize(109,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:J.includeStrings,description:$.localize(110,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:J.allowedCharacters,description:$.localize(111,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:J.allowedLocales,description:$.localize(112,null)}})}applyUpdate(J,Ee){let Be=!1;Ee.allowedCharacters&&J&&(T.$en(J.allowedCharacters,Ee.allowedCharacters)||(J={...J,allowedCharacters:Ee.allowedCharacters},Be=!0)),Ee.allowedLocales&&J&&(T.$en(J.allowedLocales,Ee.allowedLocales)||(J={...J,allowedLocales:Ee.allowedLocales},Be=!0));const He=super.applyUpdate(J,Ee);return Be?new u(He.newValue,!0):He}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Ee=J;return{nonBasicASCII:x(Ee.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(Ee.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(Ee.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:x(Ee.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:x(Ee.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(J.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(J.allowedLocales,this.defaultValue.allowedLocales)}}c(J,Ee){if(typeof J!="object"||!J)return Ee;const Be={};for(const[He,Xe]of Object.entries(J))Xe===!0&&(Be[He]=!0);return Be}}class H extends D{constructor(){const J={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",J,{"editor.inlineSuggest.enabled":{type:"boolean",default:J.enabled,description:$.localize(113,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:J.showToolbar,enum:["always","onHover","never"],enumDescriptions:[$.localize(114,null),$.localize(115,null),$.localize(116,null)],description:$.localize(117,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:J.suppressSuggestions,description:$.localize(118,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Ee=J;return{enabled:t(Ee.enabled,this.defaultValue.enabled),mode:s(Ee.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:s(Ee.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:t(Ee.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:t(Ee.keepOnBlur,this.defaultValue.keepOnBlur)}}}class G extends D{constructor(){const J={enabled:M.$9r.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:M.$9r.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",J,{"editor.bracketPairColorization.enabled":{type:"boolean",default:J.enabled,markdownDescription:$.localize(119,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:J.independentColorPoolPerBracketType,description:$.localize(120,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Ee=J;return{enabled:t(Ee.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(Ee.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class q extends D{constructor(){const J={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",J,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(121,null),$.localize(122,null),$.localize(123,null)],default:J.bracketPairs,description:$.localize(124,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(125,null),$.localize(126,null),$.localize(127,null)],default:J.bracketPairsHorizontal,description:$.localize(128,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:J.highlightActiveBracketPair,description:$.localize(129,null)},"editor.guides.indentation":{type:"boolean",default:J.indentation,description:$.localize(130,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[$.localize(131,null),$.localize(132,null),$.localize(133,null)],default:J.highlightActiveIndentation,description:$.localize(134,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Ee=J;return{bracketPairs:x(Ee.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:x(Ee.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(Ee.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(Ee.indentation,this.defaultValue.indentation),highlightActiveIndentation:x(Ee.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function x(X,J,Ee){const Be=Ee.indexOf(X);return Be===-1?J:Ee[Be]}class ue extends D{constructor(){const J={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",J,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[$.localize(135,null),$.localize(136,null)],default:J.insertMode,description:$.localize(137,null)},"editor.suggest.filterGraceful":{type:"boolean",default:J.filterGraceful,description:$.localize(138,null)},"editor.suggest.localityBonus":{type:"boolean",default:J.localityBonus,description:$.localize(139,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:J.shareSuggestSelections,markdownDescription:$.localize(140,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[$.localize(141,null),$.localize(142,null),$.localize(143,null),$.localize(144,null)],default:J.selectionMode,markdownDescription:$.localize(145,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:J.snippetsPreventQuickSuggestions,description:$.localize(146,null)},"editor.suggest.showIcons":{type:"boolean",default:J.showIcons,description:$.localize(147,null)},"editor.suggest.showStatusBar":{type:"boolean",default:J.showStatusBar,description:$.localize(148,null)},"editor.suggest.preview":{type:"boolean",default:J.preview,description:$.localize(149,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:J.showInlineDetails,description:$.localize(150,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:$.localize(151,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:$.localize(152,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:$.localize(153,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:$.localize(154,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:$.localize(155,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:$.localize(156,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:$.localize(157,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:$.localize(158,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:$.localize(159,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:$.localize(160,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:$.localize(161,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:$.localize(162,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:$.localize(163,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:$.localize(164,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:$.localize(165,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:$.localize(166,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:$.localize(167,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:$.localize(168,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:$.localize(169,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:$.localize(170,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:$.localize(171,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:$.localize(172,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:$.localize(173,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:$.localize(174,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:$.localize(175,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:$.localize(176,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:$.localize(177,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:$.localize(178,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:$.localize(179,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:$.localize(180,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:$.localize(181,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:$.localize(182,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Ee=J;return{insertMode:s(Ee.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(Ee.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(Ee.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(Ee.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(Ee.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:s(Ee.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(Ee.showIcons,this.defaultValue.showIcons),showStatusBar:t(Ee.showStatusBar,this.defaultValue.showStatusBar),preview:t(Ee.preview,this.defaultValue.preview),previewMode:s(Ee.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(Ee.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(Ee.showMethods,this.defaultValue.showMethods),showFunctions:t(Ee.showFunctions,this.defaultValue.showFunctions),showConstructors:t(Ee.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(Ee.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(Ee.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(Ee.showFields,this.defaultValue.showFields),showVariables:t(Ee.showVariables,this.defaultValue.showVariables),showClasses:t(Ee.showClasses,this.defaultValue.showClasses),showStructs:t(Ee.showStructs,this.defaultValue.showStructs),showInterfaces:t(Ee.showInterfaces,this.defaultValue.showInterfaces),showModules:t(Ee.showModules,this.defaultValue.showModules),showProperties:t(Ee.showProperties,this.defaultValue.showProperties),showEvents:t(Ee.showEvents,this.defaultValue.showEvents),showOperators:t(Ee.showOperators,this.defaultValue.showOperators),showUnits:t(Ee.showUnits,this.defaultValue.showUnits),showValues:t(Ee.showValues,this.defaultValue.showValues),showConstants:t(Ee.showConstants,this.defaultValue.showConstants),showEnums:t(Ee.showEnums,this.defaultValue.showEnums),showEnumMembers:t(Ee.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(Ee.showKeywords,this.defaultValue.showKeywords),showWords:t(Ee.showWords,this.defaultValue.showWords),showColors:t(Ee.showColors,this.defaultValue.showColors),showFiles:t(Ee.showFiles,this.defaultValue.showFiles),showReferences:t(Ee.showReferences,this.defaultValue.showReferences),showFolders:t(Ee.showFolders,this.defaultValue.showFolders),showTypeParameters:t(Ee.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(Ee.showSnippets,this.defaultValue.showSnippets),showUsers:t(Ee.showUsers,this.defaultValue.showUsers),showIssues:t(Ee.showIssues,this.defaultValue.showIssues)}}}class Oe extends D{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:$.localize(183,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:$.localize(184,null),default:!0,type:"boolean"}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(J.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:t(J.selectSubwords,this.defaultValue.selectSubwords)}}}var Ue;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(Ue||(e.WrappingIndent=Ue={}));class Ze extends D{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[$.localize(185,null),$.localize(186,null),$.localize(187,null),$.localize(188,null)],description:$.localize(189,null),default:"same"}})}validate(J){switch(J){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(J,Ee,Be){return Ee.get(2)===2?0:Be}}class Je extends v{constructor(){super(144)}compute(J,Ee,Be){const He=Ee.get(143);return{isDominatedByLongLines:J.isDominatedByLongLines,isWordWrapMinified:He.isWordWrapMinified,isViewportWrapping:He.isViewportWrapping,wrappingColumn:He.wrappingColumn}}}class tt extends D{constructor(){const J={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",J,{"editor.dropIntoEditor.enabled":{type:"boolean",default:J.enabled,markdownDescription:$.localize(190,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:$.localize(191,null),enum:["afterDrop","never"],enumDescriptions:[$.localize(192,null),$.localize(193,null)],default:"afterDrop"}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Ee=J;return{enabled:t(Ee.enabled,this.defaultValue.enabled),showDropSelector:s(Ee.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class _e extends D{constructor(){const J={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",J,{"editor.pasteAs.enabled":{type:"boolean",default:J.enabled,markdownDescription:$.localize(194,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:$.localize(195,null),enum:["afterPaste","never"],enumDescriptions:[$.localize(196,null),$.localize(197,null)],default:"afterPaste"}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Ee=J;return{enabled:t(Ee.enabled,this.defaultValue.enabled),showPasteSelector:s(Ee.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const et="Consolas, 'Courier New', monospace",rt="Menlo, Monaco, 'Courier New', monospace",nt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:P.$j?rt:P.$k?nt:et,fontWeight:"normal",fontSize:P.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ze(X){return e.editorOptionsRegistry[X.id]=X,X}var dt;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.ariaRequired=5]="ariaRequired",X[X.autoClosingBrackets=6]="autoClosingBrackets",X[X.autoClosingComments=7]="autoClosingComments",X[X.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",X[X.autoClosingDelete=9]="autoClosingDelete",X[X.autoClosingOvertype=10]="autoClosingOvertype",X[X.autoClosingQuotes=11]="autoClosingQuotes",X[X.autoIndent=12]="autoIndent",X[X.automaticLayout=13]="automaticLayout",X[X.autoSurround=14]="autoSurround",X[X.bracketPairColorization=15]="bracketPairColorization",X[X.guides=16]="guides",X[X.codeLens=17]="codeLens",X[X.codeLensFontFamily=18]="codeLensFontFamily",X[X.codeLensFontSize=19]="codeLensFontSize",X[X.colorDecorators=20]="colorDecorators",X[X.colorDecoratorsLimit=21]="colorDecoratorsLimit",X[X.columnSelection=22]="columnSelection",X[X.comments=23]="comments",X[X.contextmenu=24]="contextmenu",X[X.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",X[X.cursorBlinking=26]="cursorBlinking",X[X.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",X[X.cursorStyle=28]="cursorStyle",X[X.cursorSurroundingLines=29]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",X[X.cursorWidth=31]="cursorWidth",X[X.disableLayerHinting=32]="disableLayerHinting",X[X.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",X[X.domReadOnly=34]="domReadOnly",X[X.dragAndDrop=35]="dragAndDrop",X[X.dropIntoEditor=36]="dropIntoEditor",X[X.emptySelectionClipboard=37]="emptySelectionClipboard",X[X.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",X[X.extraEditorClassName=39]="extraEditorClassName",X[X.fastScrollSensitivity=40]="fastScrollSensitivity",X[X.find=41]="find",X[X.fixedOverflowWidgets=42]="fixedOverflowWidgets",X[X.folding=43]="folding",X[X.foldingStrategy=44]="foldingStrategy",X[X.foldingHighlight=45]="foldingHighlight",X[X.foldingImportsByDefault=46]="foldingImportsByDefault",X[X.foldingMaximumRegions=47]="foldingMaximumRegions",X[X.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=49]="fontFamily",X[X.fontInfo=50]="fontInfo",X[X.fontLigatures=51]="fontLigatures",X[X.fontSize=52]="fontSize",X[X.fontWeight=53]="fontWeight",X[X.fontVariations=54]="fontVariations",X[X.formatOnPaste=55]="formatOnPaste",X[X.formatOnType=56]="formatOnType",X[X.glyphMargin=57]="glyphMargin",X[X.gotoLocation=58]="gotoLocation",X[X.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",X[X.hover=60]="hover",X[X.inDiffEditor=61]="inDiffEditor",X[X.inlineSuggest=62]="inlineSuggest",X[X.letterSpacing=63]="letterSpacing",X[X.lightbulb=64]="lightbulb",X[X.lineDecorationsWidth=65]="lineDecorationsWidth",X[X.lineHeight=66]="lineHeight",X[X.lineNumbers=67]="lineNumbers",X[X.lineNumbersMinChars=68]="lineNumbersMinChars",X[X.linkedEditing=69]="linkedEditing",X[X.links=70]="links",X[X.matchBrackets=71]="matchBrackets",X[X.minimap=72]="minimap",X[X.mouseStyle=73]="mouseStyle",X[X.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=75]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",X[X.multiCursorModifier=77]="multiCursorModifier",X[X.multiCursorPaste=78]="multiCursorPaste",X[X.multiCursorLimit=79]="multiCursorLimit",X[X.occurrencesHighlight=80]="occurrencesHighlight",X[X.overviewRulerBorder=81]="overviewRulerBorder",X[X.overviewRulerLanes=82]="overviewRulerLanes",X[X.padding=83]="padding",X[X.pasteAs=84]="pasteAs",X[X.parameterHints=85]="parameterHints",X[X.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",X[X.quickSuggestions=88]="quickSuggestions",X[X.quickSuggestionsDelay=89]="quickSuggestionsDelay",X[X.readOnly=90]="readOnly",X[X.readOnlyMessage=91]="readOnlyMessage",X[X.renameOnType=92]="renameOnType",X[X.renderControlCharacters=93]="renderControlCharacters",X[X.renderFinalNewline=94]="renderFinalNewline",X[X.renderLineHighlight=95]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=97]="renderValidationDecorations",X[X.renderWhitespace=98]="renderWhitespace",X[X.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",X[X.roundedSelection=100]="roundedSelection",X[X.rulers=101]="rulers",X[X.scrollbar=102]="scrollbar",X[X.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=104]="scrollBeyondLastLine",X[X.scrollPredominantAxis=105]="scrollPredominantAxis",X[X.selectionClipboard=106]="selectionClipboard",X[X.selectionHighlight=107]="selectionHighlight",X[X.selectOnLineNumbers=108]="selectOnLineNumbers",X[X.showFoldingControls=109]="showFoldingControls",X[X.showUnused=110]="showUnused",X[X.snippetSuggestions=111]="snippetSuggestions",X[X.smartSelect=112]="smartSelect",X[X.smoothScrolling=113]="smoothScrolling",X[X.stickyScroll=114]="stickyScroll",X[X.stickyTabStops=115]="stickyTabStops",X[X.stopRenderingLineAfter=116]="stopRenderingLineAfter",X[X.suggest=117]="suggest",X[X.suggestFontSize=118]="suggestFontSize",X[X.suggestLineHeight=119]="suggestLineHeight",X[X.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",X[X.suggestSelection=121]="suggestSelection",X[X.tabCompletion=122]="tabCompletion",X[X.tabIndex=123]="tabIndex",X[X.unicodeHighlighting=124]="unicodeHighlighting",X[X.unusualLineTerminators=125]="unusualLineTerminators",X[X.useShadowDOM=126]="useShadowDOM",X[X.useTabStops=127]="useTabStops",X[X.wordBreak=128]="wordBreak",X[X.wordSeparators=129]="wordSeparators",X[X.wordWrap=130]="wordWrap",X[X.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=133]="wordWrapColumn",X[X.wordWrapOverride1=134]="wordWrapOverride1",X[X.wordWrapOverride2=135]="wordWrapOverride2",X[X.wrappingIndent=136]="wrappingIndent",X[X.wrappingStrategy=137]="wrappingStrategy",X[X.showDeprecated=138]="showDeprecated",X[X.inlayHints=139]="inlayHints",X[X.editorClassName=140]="editorClassName",X[X.pixelRatio=141]="pixelRatio",X[X.tabFocusMode=142]="tabFocusMode",X[X.layoutInfo=143]="layoutInfo",X[X.wrappingInfo=144]="wrappingInfo",X[X.defaultColorDecorators=145]="defaultColorDecorators",X[X.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",X[X.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(dt||(e.EditorOption=dt={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ze(new i(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:$.localize(198,null)})),acceptSuggestionOnEnter:ze(new a(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",$.localize(199,null),""],markdownDescription:$.localize(200,null)})),accessibilitySupport:ze(new m),accessibilityPageSize:ze(new c(3,"accessibilityPageSize",10,1,1073741824,{description:$.localize(201,null),tags:["accessibility"]})),ariaLabel:ze(new n(4,"ariaLabel",$.localize(202,null))),ariaRequired:ze(new i(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:ze(new i(8,"screenReaderAnnounceInlineSuggestion",!0,{description:$.localize(203,null),tags:["accessibility"]})),autoClosingBrackets:ze(new a(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(204,null),$.localize(205,null),""],description:$.localize(206,null)})),autoClosingComments:ze(new a(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(207,null),$.localize(208,null),""],description:$.localize(209,null)})),autoClosingDelete:ze(new a(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",$.localize(210,null),""],description:$.localize(211,null)})),autoClosingOvertype:ze(new a(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",$.localize(212,null),""],description:$.localize(213,null)})),autoClosingQuotes:ze(new a(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(214,null),$.localize(215,null),""],description:$.localize(216,null)})),autoIndent:ze(new d(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],p,{enumDescriptions:[$.localize(217,null),$.localize(218,null),$.localize(219,null),$.localize(220,null),$.localize(221,null)],description:$.localize(222,null)})),automaticLayout:ze(new i(13,"automaticLayout",!1)),autoSurround:ze(new a(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[$.localize(223,null),$.localize(224,null),$.localize(225,null),""],description:$.localize(226,null)})),bracketPairColorization:ze(new G),bracketPairGuides:ze(new q),stickyTabStops:ze(new i(115,"stickyTabStops",!1,{description:$.localize(227,null)})),codeLens:ze(new i(17,"codeLens",!0,{description:$.localize(228,null)})),codeLensFontFamily:ze(new n(18,"codeLensFontFamily","",{description:$.localize(229,null)})),codeLensFontSize:ze(new c(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:$.localize(230,null)})),colorDecorators:ze(new i(20,"colorDecorators",!0,{description:$.localize(231,null)})),colorDecoratorActivatedOn:ze(new a(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[$.localize(232,null),$.localize(233,null),$.localize(234,null)],description:$.localize(235,null)})),colorDecoratorsLimit:ze(new c(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:$.localize(236,null)})),columnSelection:ze(new i(22,"columnSelection",!1,{description:$.localize(237,null)})),comments:ze(new S),contextmenu:ze(new i(24,"contextmenu",!0)),copyWithSyntaxHighlighting:ze(new i(25,"copyWithSyntaxHighlighting",!0,{description:$.localize(238,null)})),cursorBlinking:ze(new d(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],h,{description:$.localize(239,null)})),cursorSmoothCaretAnimation:ze(new a(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[$.localize(240,null),$.localize(241,null),$.localize(242,null)],description:$.localize(243,null)})),cursorStyle:ze(new d(28,"cursorStyle",w.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],F,{description:$.localize(244,null)})),cursorSurroundingLines:ze(new c(29,"cursorSurroundingLines",0,0,1073741824,{description:$.localize(245,null)})),cursorSurroundingLinesStyle:ze(new a(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[$.localize(246,null),$.localize(247,null)],markdownDescription:$.localize(248,null)})),cursorWidth:ze(new c(31,"cursorWidth",0,0,1073741824,{markdownDescription:$.localize(249,null)})),disableLayerHinting:ze(new i(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:ze(new i(33,"disableMonospaceOptimizations",!1)),domReadOnly:ze(new i(34,"domReadOnly",!1)),dragAndDrop:ze(new i(35,"dragAndDrop",!0,{description:$.localize(250,null)})),emptySelectionClipboard:ze(new Z),dropIntoEditor:ze(new tt),stickyScroll:ze(new Re),experimentalWhitespaceRendering:ze(new a(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[$.localize(251,null),$.localize(252,null),$.localize(253,null)],description:$.localize(254,null)})),extraEditorClassName:ze(new n(39,"extraEditorClassName","")),fastScrollSensitivity:ze(new l(40,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:$.localize(255,null)})),find:ze(new N),fixedOverflowWidgets:ze(new i(42,"fixedOverflowWidgets",!1)),folding:ze(new i(43,"folding",!0,{description:$.localize(256,null)})),foldingStrategy:ze(new a(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[$.localize(257,null),$.localize(258,null)],description:$.localize(259,null)})),foldingHighlight:ze(new i(45,"foldingHighlight",!0,{description:$.localize(260,null)})),foldingImportsByDefault:ze(new i(46,"foldingImportsByDefault",!1,{description:$.localize(261,null)})),foldingMaximumRegions:ze(new c(47,"foldingMaximumRegions",5e3,10,65e3,{description:$.localize(262,null)})),unfoldOnClickAfterEndOfLine:ze(new i(48,"unfoldOnClickAfterEndOfLine",!1,{description:$.localize(263,null)})),fontFamily:ze(new n(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:$.localize(264,null)})),fontInfo:ze(new O),fontLigatures2:ze(new R),fontSize:ze(new Y),fontWeight:ze(new he),fontVariations:ze(new L),formatOnPaste:ze(new i(55,"formatOnPaste",!1,{description:$.localize(265,null)})),formatOnType:ze(new i(56,"formatOnType",!1,{description:$.localize(266,null)})),glyphMargin:ze(new i(57,"glyphMargin",!0,{description:$.localize(267,null)})),gotoLocation:ze(new $e),hideCursorInOverviewRuler:ze(new i(59,"hideCursorInOverviewRuler",!1,{description:$.localize(268,null)})),hover:ze(new De),inDiffEditor:ze(new i(61,"inDiffEditor",!1)),letterSpacing:ze(new l(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>l.clamp(X,-5,20),{description:$.localize(269,null)})),lightbulb:ze(new te),lineDecorationsWidth:ze(new Q),lineHeight:ze(new B),lineNumbers:ze(new de),lineNumbersMinChars:ze(new c(68,"lineNumbersMinChars",5,1,300)),linkedEditing:ze(new i(69,"linkedEditing",!1,{description:$.localize(270,null)})),links:ze(new i(70,"links",!0,{description:$.localize(271,null)})),matchBrackets:ze(new a(71,"matchBrackets","always",["always","near","never"],{description:$.localize(272,null)})),minimap:ze(new ne),mouseStyle:ze(new a(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ze(new l(74,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:$.localize(273,null)})),mouseWheelZoom:ze(new i(75,"mouseWheelZoom",!1,{markdownDescription:$.localize(274,null)})),multiCursorMergeOverlapping:ze(new i(76,"multiCursorMergeOverlapping",!0,{description:$.localize(275,null)})),multiCursorModifier:ze(new d(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],pe,{markdownEnumDescriptions:[$.localize(276,null),$.localize(277,null)],markdownDescription:$.localize(278,null)})),multiCursorPaste:ze(new a(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[$.localize(279,null),$.localize(280,null)],markdownDescription:$.localize(281,null)})),multiCursorLimit:ze(new c(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:$.localize(282,null)})),occurrencesHighlight:ze(new a(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[$.localize(283,null),$.localize(284,null),$.localize(285,null)],markdownDescription:$.localize(286,null)})),overviewRulerBorder:ze(new i(81,"overviewRulerBorder",!0,{description:$.localize(287,null)})),overviewRulerLanes:ze(new c(82,"overviewRulerLanes",3,0,3)),padding:ze(new re),pasteAs:ze(new _e),parameterHints:ze(new le),peekWidgetDefaultFocus:ze(new a(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[$.localize(288,null),$.localize(289,null)],description:$.localize(290,null)})),definitionLinkOpensInPeek:ze(new i(87,"definitionLinkOpensInPeek",!1,{description:$.localize(291,null)})),quickSuggestions:ze(new ye),quickSuggestionsDelay:ze(new c(89,"quickSuggestionsDelay",10,0,1073741824,{description:$.localize(292,null)})),readOnly:ze(new i(90,"readOnly",!1)),readOnlyMessage:ze(new me),renameOnType:ze(new i(92,"renameOnType",!1,{description:$.localize(293,null),markdownDeprecationMessage:$.localize(294,null)})),renderControlCharacters:ze(new i(93,"renderControlCharacters",!0,{description:$.localize(295,null),restricted:!0})),renderFinalNewline:ze(new a(94,"renderFinalNewline",P.$k?"dimmed":"on",["off","on","dimmed"],{description:$.localize(296,null)})),renderLineHighlight:ze(new a(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",$.localize(297,null)],description:$.localize(298,null)})),renderLineHighlightOnlyWhenFocus:ze(new i(96,"renderLineHighlightOnlyWhenFocus",!1,{description:$.localize(299,null)})),renderValidationDecorations:ze(new a(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ze(new a(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",$.localize(300,null),$.localize(301,null),$.localize(302,null),""],description:$.localize(303,null)})),revealHorizontalRightPadding:ze(new c(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:ze(new i(100,"roundedSelection",!0,{description:$.localize(304,null)})),rulers:ze(new ae),scrollbar:ze(new z),scrollBeyondLastColumn:ze(new c(103,"scrollBeyondLastColumn",4,0,1073741824,{description:$.localize(305,null)})),scrollBeyondLastLine:ze(new i(104,"scrollBeyondLastLine",!0,{description:$.localize(306,null)})),scrollPredominantAxis:ze(new i(105,"scrollPredominantAxis",!0,{description:$.localize(307,null)})),selectionClipboard:ze(new i(106,"selectionClipboard",!0,{description:$.localize(308,null),included:P.$k})),selectionHighlight:ze(new i(107,"selectionHighlight",!0,{description:$.localize(309,null)})),selectOnLineNumbers:ze(new i(108,"selectOnLineNumbers",!0)),showFoldingControls:ze(new a(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[$.localize(310,null),$.localize(311,null),$.localize(312,null)],description:$.localize(313,null)})),showUnused:ze(new i(110,"showUnused",!0,{description:$.localize(314,null)})),showDeprecated:ze(new i(138,"showDeprecated",!0,{description:$.localize(315,null)})),inlayHints:ze(new se),snippetSuggestions:ze(new a(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[$.localize(316,null),$.localize(317,null),$.localize(318,null),$.localize(319,null)],description:$.localize(320,null)})),smartSelect:ze(new Oe),smoothScrolling:ze(new i(113,"smoothScrolling",!1,{description:$.localize(321,null)})),stopRenderingLineAfter:ze(new c(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ze(new ue),inlineSuggest:ze(new H),inlineCompletionsAccessibilityVerbose:ze(new i(147,"inlineCompletionsAccessibilityVerbose",!1,{description:$.localize(322,null)})),suggestFontSize:ze(new c(118,"suggestFontSize",0,0,1e3,{markdownDescription:$.localize(323,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ze(new c(119,"suggestLineHeight",0,0,1e3,{markdownDescription:$.localize(324,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ze(new i(120,"suggestOnTriggerCharacters",!0,{description:$.localize(325,null)})),suggestSelection:ze(new a(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[$.localize(326,null),$.localize(327,null),$.localize(328,null)],description:$.localize(329,null)})),tabCompletion:ze(new a(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[$.localize(330,null),$.localize(331,null),$.localize(332,null)],description:$.localize(333,null)})),tabIndex:ze(new c(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:ze(new W),unusualLineTerminators:ze(new a(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[$.localize(334,null),$.localize(335,null),$.localize(336,null)],description:$.localize(337,null)})),useShadowDOM:ze(new i(126,"useShadowDOM",!0)),useTabStops:ze(new i(127,"useTabStops",!0,{description:$.localize(338,null)})),wordBreak:ze(new a(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[$.localize(339,null),$.localize(340,null)],description:$.localize(341,null)})),wordSeparators:ze(new n(129,"wordSeparators",A.$0r,{description:$.localize(342,null)})),wordWrap:ze(new a(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[$.localize(343,null),$.localize(344,null),$.localize(345,null),$.localize(346,null)],description:$.localize(347,null)})),wordWrapBreakAfterCharacters:ze(new n(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ze(new n(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ze(new c(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:$.localize(348,null)})),wordWrapOverride1:ze(new a(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ze(new a(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:ze(new V),defaultColorDecorators:ze(new i(145,"defaultColorDecorators",!1,{markdownDescription:$.localize(349,null)})),pixelRatio:ze(new ce),tabFocusMode:ze(new i(142,"tabFocusMode",!1,{markdownDescription:$.localize(350,null)})),layoutInfo:ze(new fe),wrappingInfo:ze(new Je),wrappingIndent:ze(new Ze),wrappingStrategy:ze(new ve)}}),define(Pe[148],Ae([9,10]),function(we,e){return we.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Pe[149],Ae([9,10]),function(we,e){return we.create("vs/platform/contextkey/common/contextkey",e)}),define(Pe[150],Ae([9,10]),function(we,e){return we.create("vs/platform/contextkey/common/scanner",e)}),define(Pe[151],Ae([9,10]),function(we,e){return we.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Pe[152],Ae([9,10]),function(we,e){return we.create("vs/platform/extensions/common/extensionValidator",e)}),define(Pe[153],Ae([9,10]),function(we,e){return we.create("vs/platform/files/common/files",e)}),define(Pe[154],Ae([9,10]),function(we,e){return we.create("vs/platform/markers/common/markers",e)}),define(Pe[155],Ae([9,10]),function(we,e){return we.create("vs/platform/theme/common/iconRegistry",e)}),define(Pe[156],Ae([9,10]),function(we,e){return we.create("vs/platform/workspace/common/workspace",e)}),define(Pe[157],Ae([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Pe[158],Ae([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Pe[159],Ae([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Pe[160],Ae([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Pe[161],Ae([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostLogService",e)}),define(Pe[162],Ae([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostNotebook",e)}),define(Pe[163],Ae([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostProgress",e)}),define(Pe[164],Ae([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Pe[165],Ae([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Pe[166],Ae([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Pe[167],Ae([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Pe[168],Ae([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Pe[169],Ae([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Pe[170],Ae([9,10]),function(we,e){return we.create("vs/workbench/common/configuration",e)}),define(Pe[171],Ae([9,10]),function(we,e){return we.create("vs/workbench/common/editor",e)}),define(Pe[172],Ae([9,10]),function(we,e){return we.create("vs/workbench/common/views",e)}),define(Pe[173],Ae([9,10]),function(we,e){return we.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Pe[174],Ae([9,10]),function(we,e){return we.create("vs/workbench/contrib/debug/common/debug",e)}),define(Pe[175],Ae([9,10]),function(we,e){return we.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Pe[176],Ae([9,10]),function(we,e){return we.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Pe[177],Ae([9,10]),function(we,e){return we.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Pe[178],Ae([9,10]),function(we,e){return we.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Pe[179],Ae([9,10]),function(we,e){return we.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Pe[180],Ae([9,10]),function(we,e){return we.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Pe[181],Ae([1,0,11,150]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.TokenType=void 0;var P;(function(f){f[f.LParen=0]="LParen",f[f.RParen=1]="RParen",f[f.Neg=2]="Neg",f[f.Eq=3]="Eq",f[f.NotEq=4]="NotEq",f[f.Lt=5]="Lt",f[f.LtEq=6]="LtEq",f[f.Gt=7]="Gt",f[f.GtEq=8]="GtEq",f[f.RegexOp=9]="RegexOp",f[f.RegexStr=10]="RegexStr",f[f.True=11]="True",f[f.False=12]="False",f[f.In=13]="In",f[f.Not=14]="Not",f[f.And=15]="And",f[f.Or=16]="Or",f[f.Str=17]="Str",f[f.QuotedStr=18]="QuotedStr",f[f.Error=19]="Error",f[f.EOF=20]="EOF"})(P||(e.TokenType=P={}));function M(...f){switch(f.length){case 1:return(0,T.localize)(0,null,f[0]);case 2:return(0,T.localize)(1,null,f[0],f[1]);case 3:return(0,T.localize)(2,null,f[0],f[1],f[2]);default:return}}const A=(0,T.localize)(3,null),$=(0,T.localize)(4,null);class E{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(C){switch(C.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return C.isTripleEq?"===":"==";case 4:return C.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return C.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return C.lexeme;case 18:return C.lexeme;case 19:return C.lexeme;case 20:return"EOF";default:throw(0,y.$7)(`unhandled token type: ${JSON.stringify(C)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(C=>C.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(C){return this.c=C,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const D=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:D})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const D=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:D})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(C){return this.r()||this.c.charCodeAt(this.e)!==C?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(C){this.f.push({type:C,offset:this.d})}l(C){const D=this.d,u=this.c.substring(this.d,this.e),b={type:19,offset:this.d,lexeme:u};this.g.push({offset:D,lexeme:u,additionalInfo:C}),this.f.push(b)}n(){this.m.lastIndex=this.d;const C=this.m.exec(this.c);if(C){this.e=this.d+C[0].length;const D=this.c.substring(this.d,this.e),u=E.b.get(D);u?this.k(u):this.f.push({type:17,lexeme:D,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let C=this.e,D=!1,u=!1;for(;;){if(C>=this.c.length){this.e=C,this.l($);return}const v=this.c.charCodeAt(C);if(D)D=!1;else if(v===47&&!u){C++;break}else v===91?u=!0:v===92?D=!0:v===93&&(u=!1);C++}for(;C<this.c.length&&E.a.has(this.c.charCodeAt(C));)C++;this.e=C;const b=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:b,offset:this.d})}r(){return this.e>=this.c.length}}e.$Qi=E}),define(Pe[182],Ae([1,0,25,31,152,294]),function(we,e,y,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,$=/^-(\d{4})(\d{2})(\d{2})$/;function E(i){return i=i.trim(),i==="*"||A.test(i)}e.$Ro=E;function f(i){if(!E(i))return null;if(i=i.trim(),i==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const r=i.match(A);return r?{hasCaret:r[1]==="^",hasGreaterEquals:r[1]===">=",majorBase:r[2]==="x"?0:parseInt(r[2],10),majorMustEqual:r[2]!=="x",minorBase:r[4]==="x"?0:parseInt(r[4],10),minorMustEqual:r[4]!=="x",patchBase:r[6]==="x"?0:parseInt(r[6],10),patchMustEqual:r[6]!=="x",preRelease:r[8]||null}:null}e.$So=f;function C(i){if(!i)return null;const r=i.majorBase,c=i.majorMustEqual,o=i.minorBase;let l=i.minorMustEqual;const n=i.patchBase;let s=i.patchMustEqual;i.hasCaret&&(r===0||(l=!1),s=!1);let a=0;if(i.preRelease){const d=$.exec(i.preRelease);if(d){const[,p,m,S]=d;a=Date.UTC(Number(p),Number(m)-1,Number(S))}}return{majorBase:r,majorMustEqual:c,minorBase:o,minorMustEqual:l,patchBase:n,patchMustEqual:s,isMinimum:i.hasGreaterEquals,notBefore:a}}e.$To=C;function D(i,r,c){let o;typeof i=="string"?o=C(f(i)):o=i;let l;r instanceof Date?l=r.getTime():typeof r=="string"&&(l=new Date(r).getTime());let n;if(typeof c=="string"?n=C(f(c)):n=c,!o||!n)return!1;const s=o.majorBase,a=o.minorBase,d=o.patchBase;let p=n.majorBase,m=n.minorBase,S=n.patchBase;const k=n.notBefore;let h=n.majorMustEqual,w=n.minorMustEqual,I=n.patchMustEqual;return n.isMinimum?s>p?!0:s<p?!1:a>m?!0:a<m||l&&l<k?!1:d>=S:(s===1&&p===0&&(!h||!w||!I)&&(p=1,m=0,S=0,h=!0,w=!1,I=!1),s<p?!1:s>p?!h:a<m?!1:a>m?!w:d<S?!1:d>S?!I:!(l&&l<k))}e.$Uo=D;function u(i,r,c,o,l){const n=[];if(typeof o.publisher<"u"&&typeof o.publisher!="string")return n.push([T.default.Error,P.localize(0,null)]),n;if(typeof o.name!="string")return n.push([T.default.Error,P.localize(1,null,"name")]),n;if(typeof o.version!="string")return n.push([T.default.Error,P.localize(2,null,"version")]),n;if(!o.engines)return n.push([T.default.Error,P.localize(3,null,"engines")]),n;if(typeof o.engines.vscode!="string")return n.push([T.default.Error,P.localize(4,null,"engines.vscode")]),n;if(typeof o.extensionDependencies<"u"&&!t(o.extensionDependencies))return n.push([T.default.Error,P.localize(5,null,"extensionDependencies")]),n;if(typeof o.activationEvents<"u"){if(!t(o.activationEvents))return n.push([T.default.Error,P.localize(6,null,"activationEvents")]),n;if(typeof o.main>"u"&&typeof o.browser>"u")return n.push([T.default.Error,P.localize(7,null,"activationEvents","main","browser")]),n}if(typeof o.extensionKind<"u"&&typeof o.main>"u"&&n.push([T.default.Warning,P.localize(8,null,"extensionKind")]),typeof o.main<"u"){if(typeof o.main!="string")return n.push([T.default.Error,P.localize(9,null,"main")]),n;{const d=(0,y.$zg)(c,o.main);(0,y.$tg)(d,c)||n.push([T.default.Warning,P.localize(10,null,d.path,c.path)])}}if(typeof o.browser<"u"){if(typeof o.browser!="string")return n.push([T.default.Error,P.localize(11,null,"browser")]),n;{const d=(0,y.$zg)(c,o.browser);(0,y.$tg)(d,c)||n.push([T.default.Warning,P.localize(12,null,d.path,c.path)])}}if(!M.valid(o.version))return n.push([T.default.Error,P.localize(13,null)]),n;const s=[];if(!b(i,r,o,l,s))for(const d of s)n.push([T.default.Error,d]);return n}e.$Vo=u;function b(i,r,c,o,l){return o||typeof c.main>"u"&&typeof c.browser>"u"?!0:g(i,r,c.engines.vscode,l)}e.$Wo=b;function v(i,r,c){return i==="*"||g(r,c,i)}e.$Xo=v;function g(i,r,c,o=[]){const l=C(f(c));if(!l)return o.push(P.localize(14,null,c)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return o.push(P.localize(15,null,c)),!1}else if(!l.majorMustEqual)return o.push(P.localize(16,null,c)),!1;return D(i,r,l)?!0:(o.push(P.localize(17,null,i,c)),!1)}function t(i){if(!Array.isArray(i))return!1;for(let r=0,c=i.length;r<c;r++)if(typeof i[r]!="string")return!1;return!0}}),define(Pe[69],Ae([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sh=void 0;class y{constructor(P,M=[],A=!1){this.ctor=P,this.staticArguments=M,this.supportsDelayedInstantiation=A}}e.$Sh=y}),define(Pe[70],Ae([1,0,69]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=e.$Cr=e.InstantiationType=void 0;const T=[];var P;(function($){$[$.Eager=0]="Eager",$[$.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function M($,E,f){E instanceof y.$Sh||(E=new y.$Sh(E,[],!!f)),T.push([$,E])}e.$Cr=M;function A(){return T}e.$Dr=A}),define(Pe[183],Ae([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=e.$hq=void 0;class y{constructor(M,A){this.key=M,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$hq=y;class T{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const A of this.a.values())A.outgoing.size===0&&M.push(A);return M}insertEdge(M,A){const $=this.lookupOrInsertNode(M),E=this.lookupOrInsertNode(A);$.outgoing.set(E.key,E),E.incoming.set($.key,$)}removeNode(M){const A=this.b(M);this.a.delete(A);for(const $ of this.a.values())$.outgoing.delete(A),$.incoming.delete(A)}lookupOrInsertNode(M){const A=this.b(M);let $=this.a.get(A);return $||($=new y(A,M),this.a.set(A,$)),$}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[A,$]of this.a)M.push(`${A}
	(-> incoming)[${[...$.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...$.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,A]of this.a){const $=new Set([M]),E=this.c(A,$);if(E)return E}}c(M,A){for(const[$,E]of M.outgoing){if(A.has($))return[...A,$].join(" -> ");A.add($);const f=this.c(E,A);if(f)return f;A.delete($)}}}e.$iq=T}),define(Pe[4],Ae([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wh=e.$Vh=e.$Uh=e._util=void 0;var y;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function $(E){return E[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=$})(y||(e._util=y={})),e.$Uh=P("instantiationService");function T(A,$,E){$[y.DI_TARGET]===$?$[y.DI_DEPENDENCIES].push({id:A,index:E}):($[y.DI_DEPENDENCIES]=[{id:A,index:E}],$[y.DI_TARGET]=$)}function P(A){if(y.serviceIds.has(A))return y.serviceIds.get(A);const $=function(E,f,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T($,E,C)};return $.toString=()=>A,y.serviceIds.set(A,$),$}e.$Vh=P;function M(A){return A}e.$Wh=M}),define(Pe[40],Ae([1,0,16,2,4]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.ConfigurationTarget=e.$ri=e.$qi=e.$pi=void 0,e.$pi=(0,P.$Vh)("configurationService");function M(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof T.URI)}e.$qi=M;function A(i){return i&&typeof i=="object"&&(!i.overrideIdentifiers||Array.isArray(i.overrideIdentifiers))&&!i.overrideIdentifier&&(!i.resource||i.resource instanceof T.URI)}e.$ri=A;var $;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.USER=2]="USER",i[i.USER_LOCAL=3]="USER_LOCAL",i[i.USER_REMOTE=4]="USER_REMOTE",i[i.WORKSPACE=5]="WORKSPACE",i[i.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",i[i.DEFAULT=7]="DEFAULT",i[i.MEMORY=8]="MEMORY"})($||(e.ConfigurationTarget=$={}));function E(i){switch(i){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$si=E;function f(i){return i.applicationValue!==void 0||i.userValue!==void 0||i.userLocalValue!==void 0||i.userRemoteValue!==void 0||i.workspaceValue!==void 0||i.workspaceFolderValue!==void 0}e.$ti=f;function C(i,r){const c=Object.create(null);for(const o in i)D(c,o,i[o],r);return c}e.$ui=C;function D(i,r,c,o){const l=r.split("."),n=l.pop();let s=i;for(let a=0;a<l.length;a++){const d=l[a];let p=s[d];switch(typeof p){case"undefined":p=s[d]=Object.create(null);break;case"object":break;default:o(`Ignoring ${r} as ${l.slice(0,a+1).join(".")} is ${JSON.stringify(p)}`);return}s=p}if(typeof s=="object"&&s!==null)try{s[n]=c}catch{o(`Ignoring ${r} as ${l.join(".")} is ${JSON.stringify(s)}`)}else o(`Ignoring ${r} as ${l.join(".")} is ${JSON.stringify(s)}`)}e.$vi=D;function u(i,r){const c=r.split(".");b(i,c)}e.$wi=u;function b(i,r){const c=r.shift();if(r.length===0){delete i[c];return}if(Object.keys(i).indexOf(c)!==-1){const o=i[c];typeof o=="object"&&!Array.isArray(o)&&(b(o,r),Object.keys(o).length===0&&delete i[c])}}function v(i,r,c){function o(s,a){let d=s;for(const p of a){if(typeof d!="object"||d===null)return;d=d[p]}return d}const l=r.split("."),n=o(i,l);return typeof n>"u"?c:n}e.$xi=v;function g(i,r,c){Object.keys(r).forEach(o=>{o!=="__proto__"&&(o in i?y.$Ef(i[o])&&y.$Ef(r[o])?g(i[o],r[o],c):c&&(i[o]=r[o]):i[o]=r[o])})}e.$yi=g;function t(i){return i.replace(/[\[\]]/g,"")}e.$zi=t}),define(Pe[34],Ae([1,0,21,12,181,4,149,11]),function(we,e,y,T,P,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.ContextKeyExprType=e.$Ri=void 0;const E=new Map;E.set("false",!1),E.set("true",!0),E.set("isMac",y.$j),E.set("isLinux",y.$k),E.set("isWindows",y.$i),E.set("isWeb",y.$o),E.set("isMacNative",y.$j&&!y.$o),E.set("isEdge",y.$H),E.set("isFirefox",y.$F),E.set("isChrome",y.$E),E.set("isSafari",y.$G);function f(Q,B){if(E.get(Q)!==void 0)throw(0,$.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");E.set(Q,B)}e.$Ri=f;const C=Object.prototype.hasOwnProperty;var D;(function(Q){Q[Q.False=0]="False",Q[Q.True=1]="True",Q[Q.Defined=2]="Defined",Q[Q.Not=3]="Not",Q[Q.Equals=4]="Equals",Q[Q.NotEquals=5]="NotEquals",Q[Q.And=6]="And",Q[Q.Regex=7]="Regex",Q[Q.NotRegex=8]="NotRegex",Q[Q.Or=9]="Or",Q[Q.In=10]="In",Q[Q.NotIn=11]="NotIn",Q[Q.Greater=12]="Greater",Q[Q.GreaterEquals=13]="GreaterEquals",Q[Q.Smaller=14]="Smaller",Q[Q.SmallerEquals=15]="SmallerEquals"})(D||(e.ContextKeyExprType=D={}));const u={regexParsingWithErrorRecovery:!0},b=(0,A.localize)(0,null),v=(0,A.localize)(1,null),g=(0,A.localize)(2,null),t=(0,A.localize)(3,null),i=(0,A.localize)(4,null),r=(0,A.localize)(5,null),c=(0,A.localize)(6,null),o=(0,A.localize)(7,null);class l{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(B=u){this.k=B,this.d=new P.$Qi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(B){if(B===""){this.h.push({message:b,offset:0,lexeme:"",additionalInfo:v});return}this.f=this.d.reset(B).scan(),this.g=0,this.h=[];try{const ne=this.l();if(!this.E()){const pe=this.D(),re=pe.type===17?r:void 0;throw this.h.push({message:i,offset:pe.offset,lexeme:P.$Qi.getLexeme(pe),additionalInfo:re}),l.c}return ne}catch(ne){if(ne!==l.c)throw ne;return}}l(){return this.m()}m(){const B=[this.o()];for(;this.y(16);){const ne=this.o();B.push(ne)}return B.length===1?B[0]:n.or(...B)}o(){const B=[this.s()];for(;this.y(15);){const ne=this.s();B.push(ne)}return B.length===1?B[0]:n.and(...B)}s(){if(this.y(2)){const B=this.D();switch(B.type){case 11:return this.z(),p.INSTANCE;case 12:return this.z(),m.INSTANCE;case 0:{this.z();const ne=this.l();return this.A(1,t),ne?.negate()}case 17:return this.z(),F.create(B.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",B)}}return this.t()}t(){const B=this.D();switch(B.type){case 11:return this.z(),n.true();case 12:return this.z(),n.false();case 0:{this.z();const ne=this.l();return this.A(1,t),ne}case 17:{const ne=B.lexeme;if(this.z(),this.y(9)){const re=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),re.type!==10)throw this.B("REGEX",re);const le=re.lexeme,ce=le.lastIndexOf("/"),ye=ce===le.length-1?void 0:this.w(le.substring(ce+1));let _;try{_=new RegExp(le.substring(1,ce),ye)}catch{throw this.B("REGEX",re)}return O.create(ne,_)}switch(re.type){case 10:case 19:{const le=[re.lexeme];this.z();let ce=this.D(),ye=0;for(let me=0;me<re.lexeme.length;me++)re.lexeme.charCodeAt(me)===40?ye++:re.lexeme.charCodeAt(me)===41&&ye--;for(;!this.E()&&ce.type!==15&&ce.type!==16;){switch(ce.type){case 0:ye++;break;case 1:ye--;break;case 10:case 18:for(let me=0;me<ce.lexeme.length;me++)ce.lexeme.charCodeAt(me)===40?ye++:re.lexeme.charCodeAt(me)===41&&ye--}if(ye<0)break;le.push(P.$Qi.getLexeme(ce)),this.z(),ce=this.D()}const _=le.join(""),de=_.lastIndexOf("/"),ie=de===_.length-1?void 0:this.w(_.substring(de+1));let ae;try{ae=new RegExp(_.substring(1,de),ie)}catch{throw this.B("REGEX",re)}return n.regex(ne,ae)}case 18:{const le=re.lexeme;this.z();let ce=null;if(!(0,T.$Fe)(le)){const ye=le.indexOf("/"),_=le.lastIndexOf("/");if(ye!==_&&ye>=0){const de=le.slice(ye+1,_),ie=le[_+1]==="i"?"i":"";try{ce=new RegExp(de,ie)}catch{throw this.B("REGEX",re)}}}if(ce===null)throw this.B("REGEX",re);return O.create(ne,ce)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,g);const re=this.u();return n.notIn(ne,re)}switch(this.D().type){case 3:{this.z();const re=this.u();if(this.x().type===18)return n.equals(ne,re);switch(re){case"true":return n.has(ne);case"false":return n.not(ne);default:return n.equals(ne,re)}}case 4:{this.z();const re=this.u();if(this.x().type===18)return n.notEquals(ne,re);switch(re){case"true":return n.not(ne);case"false":return n.has(ne);default:return n.notEquals(ne,re)}}case 5:return this.z(),R.create(ne,this.u());case 6:return this.z(),L.create(ne,this.u());case 7:return this.z(),Z.create(ne,this.u());case 8:return this.z(),N.create(ne,this.u());case 13:return this.z(),n.in(ne,this.u());default:return n.has(ne)}}case 20:throw this.h.push({message:c,offset:B.offset,lexeme:"",additionalInfo:o}),l.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const B=this.D();switch(B.type){case 17:case 18:return this.z(),B.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(B){return B.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(B){return this.C(B)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(B,ne){if(this.C(B))return this.z();throw this.B(ne,this.D())}B(B,ne,pe){const re=(0,A.localize)(8,null,B,P.$Qi.getLexeme(ne)),le=ne.offset,ce=P.$Qi.getLexeme(ne);return this.h.push({message:re,offset:le,lexeme:ce,additionalInfo:pe}),l.c}C(B){return this.D().type===B}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Si=l;class n{static false(){return p.INSTANCE}static true(){return m.INSTANCE}static has(B){return S.create(B)}static equals(B,ne){return k.create(B,ne)}static notEquals(B,ne){return I.create(B,ne)}static regex(B,ne){return O.create(B,ne)}static in(B,ne){return h.create(B,ne)}static notIn(B,ne){return w.create(B,ne)}static not(B){return F.create(B)}static and(...B){return $e.create(B,null,!0)}static or(...B){return De.create(B,null,!0)}static greater(B,ne){return Z.create(B,ne)}static greaterEquals(B,ne){return N.create(B,ne)}static smaller(B,ne){return R.create(B,ne)}static smallerEquals(B,ne){return L.create(B,ne)}static{this.c=new l({regexParsingWithErrorRecovery:!1})}static deserialize(B){return B==null?void 0:this.c.parse(B)}}e.$Ti=n;function s(Q){const B=new l({regexParsingWithErrorRecovery:!1});return Q.map(ne=>(B.parse(ne),B.lexingErrors.length>0?B.lexingErrors.map(pe=>({errorMessage:pe.additionalInfo?(0,A.localize)(9,null,pe.additionalInfo):(0,A.localize)(10,null),offset:pe.offset,length:pe.lexeme.length})):B.parsingErrors.length>0?B.parsingErrors.map(pe=>({errorMessage:pe.additionalInfo?`${pe.message}. ${pe.additionalInfo}`:pe.message,offset:pe.offset,length:pe.lexeme.length})):[]))}e.$Ui=s;function a(Q,B){const ne=Q?Q.substituteConstants():void 0,pe=B?B.substituteConstants():void 0;return!ne&&!pe?!0:!ne||!pe?!1:ne.equals(pe)}e.$Vi=a;function d(Q,B){return Q.cmp(B)}class p{static{this.INSTANCE=new p}constructor(){this.type=0}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!1}serialize(){return"false"}keys(){return[]}map(B){return this}negate(){return m.INSTANCE}}e.$Wi=p;class m{static{this.INSTANCE=new m}constructor(){this.type=1}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!0}serialize(){return"true"}keys(){return[]}map(B){return this}negate(){return p.INSTANCE}}e.$Xi=m;class S{static create(B,ne=null){const pe=E.get(B);return typeof pe=="boolean"?pe?m.INSTANCE:p.INSTANCE:new S(B,ne)}constructor(B,ne){this.key=B,this.c=ne,this.type=2}cmp(B){return B.type!==this.type?this.type-B.type:fe(this.key,B.key)}equals(B){return B.type===this.type?this.key===B.key:!1}substituteConstants(){const B=E.get(this.key);return typeof B=="boolean"?B?m.INSTANCE:p.INSTANCE:this}evaluate(B){return!!B.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(B){return B.mapDefined(this.key)}negate(){return this.c||(this.c=F.create(this.key,this)),this.c}}e.$Yi=S;class k{static create(B,ne,pe=null){if(typeof ne=="boolean")return ne?S.create(B,pe):F.create(B,pe);const re=E.get(B);return typeof re=="boolean"?ne===(re?"true":"false")?m.INSTANCE:p.INSTANCE:new k(B,ne,pe)}constructor(B,ne,pe){this.c=B,this.d=ne,this.f=pe,this.type=4}cmp(B){return B.type!==this.type?this.type-B.type:ve(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=E.get(this.c);if(typeof B=="boolean"){const ne=B?"true":"false";return this.d===ne?m.INSTANCE:p.INSTANCE}return this}evaluate(B){return B.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(B){return B.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$Zi=k;class h{static create(B,ne){return new h(B,ne)}constructor(B,ne){this.d=B,this.f=ne,this.type=10,this.c=null}cmp(B){return B.type!==this.type?this.type-B.type:ve(this.d,this.f,B.d,B.f)}equals(B){return B.type===this.type?this.d===B.d&&this.f===B.f:!1}substituteConstants(){return this}evaluate(B){const ne=B.getValue(this.f),pe=B.getValue(this.d);return Array.isArray(ne)?ne.includes(pe):typeof pe=="string"&&typeof ne=="object"&&ne!==null?C.call(ne,pe):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(B){return B.mapIn(this.d,this.f)}negate(){return this.c||(this.c=w.create(this.d,this.f)),this.c}}e.$1i=h;class w{static create(B,ne){return new w(B,ne)}constructor(B,ne){this.d=B,this.f=ne,this.type=11,this.c=h.create(B,ne)}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(B){return B.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$2i=w;class I{static create(B,ne,pe=null){if(typeof ne=="boolean")return ne?F.create(B,pe):S.create(B,pe);const re=E.get(B);return typeof re=="boolean"?ne===(re?"true":"false")?p.INSTANCE:m.INSTANCE:new I(B,ne,pe)}constructor(B,ne,pe){this.c=B,this.d=ne,this.f=pe,this.type=5}cmp(B){return B.type!==this.type?this.type-B.type:ve(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=E.get(this.c);if(typeof B=="boolean"){const ne=B?"true":"false";return this.d===ne?p.INSTANCE:m.INSTANCE}return this}evaluate(B){return B.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(B){return B.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$3i=I;class F{static create(B,ne=null){const pe=E.get(B);return typeof pe=="boolean"?pe?p.INSTANCE:m.INSTANCE:new F(B,ne)}constructor(B,ne){this.c=B,this.d=ne,this.type=3}cmp(B){return B.type!==this.type?this.type-B.type:fe(this.c,B.c)}equals(B){return B.type===this.type?this.c===B.c:!1}substituteConstants(){const B=E.get(this.c);return typeof B=="boolean"?B?p.INSTANCE:m.INSTANCE:this}evaluate(B){return!B.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(B){return B.mapNot(this.c)}negate(){return this.d||(this.d=S.create(this.c,this)),this.d}}e.$4i=F;function V(Q,B){if(typeof Q=="string"){const ne=parseFloat(Q);isNaN(ne)||(Q=ne)}return typeof Q=="string"||typeof Q=="number"?B(Q):p.INSTANCE}class Z{static create(B,ne,pe=null){return V(ne,re=>new Z(B,re,pe))}constructor(B,ne,pe){this.c=B,this.d=ne,this.f=pe,this.type=12}cmp(B){return B.type!==this.type?this.type-B.type:ve(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$5i=Z;class N{static create(B,ne,pe=null){return V(ne,re=>new N(B,re,pe))}constructor(B,ne,pe){this.c=B,this.d=ne,this.f=pe,this.type=13}cmp(B){return B.type!==this.type?this.type-B.type:ve(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$6i=N;class R{static create(B,ne,pe=null){return V(ne,re=>new R(B,re,pe))}constructor(B,ne,pe){this.c=B,this.d=ne,this.f=pe,this.type=14}cmp(B){return B.type!==this.type?this.type-B.type:ve(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$7i=R;class L{static create(B,ne,pe=null){return V(ne,re=>new L(B,re,pe))}constructor(B,ne,pe){this.c=B,this.d=ne,this.f=pe,this.type=15}cmp(B){return B.type!==this.type?this.type-B.type:ve(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=Z.create(this.c,this.d,this)),this.f}}e.$8i=L;class O{static create(B,ne){return new O(B,ne)}constructor(B,ne){this.d=B,this.f=ne,this.type=7,this.c=null}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.d<B.d)return-1;if(this.d>B.d)return 1;const ne=this.f?this.f.source:"",pe=B.f?B.f.source:"";return ne<pe?-1:ne>pe?1:0}equals(B){if(B.type===this.type){const ne=this.f?this.f.source:"",pe=B.f?B.f.source:"";return this.d===B.d&&ne===pe}return!1}substituteConstants(){return this}evaluate(B){const ne=B.getValue(this.d);return this.f?this.f.test(ne):!1}serialize(){const B=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${B}`}keys(){return[this.d]}map(B){return B.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=Y.create(this)),this.c}}e.$9i=O;class Y{static create(B){return new Y(B)}constructor(B){this.c=B,this.type=8}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(B){return new Y(this.c.map(B))}negate(){return this.c}}e.$0i=Y;function he(Q){let B=null;for(let ne=0,pe=Q.length;ne<pe;ne++){const re=Q[ne].substituteConstants();if(Q[ne]!==re&&B===null){B=[];for(let le=0;le<ne;le++)B[le]=Q[le]}B!==null&&(B[ne]=re)}return B===null?Q:B}class $e{static create(B,ne,pe){return $e.d(B,ne,pe)}constructor(B,ne){this.expr=B,this.c=ne,this.type=6}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let ne=0,pe=this.expr.length;ne<pe;ne++){const re=d(this.expr[ne],B.expr[ne]);if(re!==0)return re}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let ne=0,pe=this.expr.length;ne<pe;ne++)if(!this.expr[ne].equals(B.expr[ne]))return!1;return!0}return!1}substituteConstants(){const B=he(this.expr);return B===this.expr?this:$e.create(B,this.c,!1)}evaluate(B){for(let ne=0,pe=this.expr.length;ne<pe;ne++)if(!this.expr[ne].evaluate(B))return!1;return!0}static d(B,ne,pe){const re=[];let le=!1;for(const ce of B)if(ce){if(ce.type===1){le=!0;continue}if(ce.type===0)return p.INSTANCE;if(ce.type===6){re.push(...ce.expr);continue}re.push(ce)}if(re.length===0&&le)return m.INSTANCE;if(re.length!==0){if(re.length===1)return re[0];re.sort(d);for(let ce=1;ce<re.length;ce++)re[ce-1].equals(re[ce])&&(re.splice(ce,1),ce--);if(re.length===1)return re[0];for(;re.length>1;){const ce=re[re.length-1];if(ce.type!==9)break;re.pop();const ye=re.pop(),_=re.length===0,de=De.create(ce.expr.map(ie=>$e.create([ie,ye],null,pe)),null,_);de&&(re.push(de),re.sort(d))}if(re.length===1)return re[0];if(pe){for(let ce=0;ce<re.length;ce++)for(let ye=ce+1;ye<re.length;ye++)if(re[ce].negate().equals(re[ye]))return p.INSTANCE;if(re.length===1)return re[0]}return new $e(re,ne)}}serialize(){return this.expr.map(B=>B.serialize()).join(" && ")}keys(){const B=[];for(const ne of this.expr)B.push(...ne.keys());return B}map(B){return new $e(this.expr.map(ne=>ne.map(B)),null)}negate(){if(!this.c){const B=[];for(const ne of this.expr)B.push(ne.negate());this.c=De.create(B,this,!0)}return this.c}}e.$$i=$e;class De{static create(B,ne,pe){return De.d(B,ne,pe)}constructor(B,ne){this.expr=B,this.c=ne,this.type=9}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let ne=0,pe=this.expr.length;ne<pe;ne++){const re=d(this.expr[ne],B.expr[ne]);if(re!==0)return re}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let ne=0,pe=this.expr.length;ne<pe;ne++)if(!this.expr[ne].equals(B.expr[ne]))return!1;return!0}return!1}substituteConstants(){const B=he(this.expr);return B===this.expr?this:De.create(B,this.c,!1)}evaluate(B){for(let ne=0,pe=this.expr.length;ne<pe;ne++)if(this.expr[ne].evaluate(B))return!0;return!1}static d(B,ne,pe){let re=[],le=!1;if(B){for(let ce=0,ye=B.length;ce<ye;ce++){const _=B[ce];if(_){if(_.type===0){le=!0;continue}if(_.type===1)return m.INSTANCE;if(_.type===9){re=re.concat(_.expr);continue}re.push(_)}}if(re.length===0&&le)return p.INSTANCE;re.sort(d)}if(re.length!==0){if(re.length===1)return re[0];for(let ce=1;ce<re.length;ce++)re[ce-1].equals(re[ce])&&(re.splice(ce,1),ce--);if(re.length===1)return re[0];if(pe){for(let ce=0;ce<re.length;ce++)for(let ye=ce+1;ye<re.length;ye++)if(re[ce].negate().equals(re[ye]))return m.INSTANCE;if(re.length===1)return re[0]}return new De(re,ne)}}serialize(){return this.expr.map(B=>B.serialize()).join(" || ")}keys(){const B=[];for(const ne of this.expr)B.push(...ne.keys());return B}map(B){return new De(this.expr.map(ne=>ne.map(B)),null)}negate(){if(!this.c){const B=[];for(const ne of this.expr)B.push(ne.negate());for(;B.length>1;){const ne=B.shift(),pe=B.shift(),re=[];for(const le of se(ne))for(const ce of se(pe))re.push($e.create([le,ce],null,!1));B.unshift(De.create(re,null,!1))}this.c=De.create(B,this,!0)}return this.c}}e.$_i=De;class ke extends S{static{this.d=[]}static all(){return ke.d.values()}constructor(B,ne,pe){super(B,null),this.f=ne,typeof pe=="object"?ke.d.push({...pe,key:B}):pe!==!0&&ke.d.push({key:B,description:pe,type:ne!=null?typeof ne:void 0})}bindTo(B){return B.createKey(this.key,this.f)}getValue(B){return B.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(B){return k.create(this.key,B)}notEqualsTo(B){return I.create(this.key,B)}}e.$aj=ke,e.$bj=(0,M.$Vh)("contextKeyService");function fe(Q,B){return Q<B?-1:Q>B?1:0}function ve(Q,B,ne,pe){return Q<ne?-1:Q>ne?1:B<pe?-1:B>pe?1:0}function te(Q,B){if(Q.type===0||B.type===1)return!0;if(Q.type===9)return B.type===9?Re(Q.expr,B.expr):!1;if(B.type===9){for(const ne of B.expr)if(te(Q,ne))return!0;return!1}if(Q.type===6){if(B.type===6)return Re(B.expr,Q.expr);for(const ne of Q.expr)if(te(ne,B))return!0;return!1}return Q.equals(B)}e.$cj=te;function Re(Q,B){let ne=0,pe=0;for(;ne<Q.length&&pe<B.length;){const re=Q[ne].cmp(B[pe]);if(re<0)return!1;re===0&&ne++,pe++}return ne===Q.length}function se(Q){return Q.type===9?Q.expr:[Q]}}),define(Pe[184],Ae([1,0,4]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.$3h=void 0,e.$3h=(0,y.$Vh)("environmentService"),e.$4h=(0,y.$Wh)(e.$3h)}),define(Pe[96],Ae([1,0,151,4]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$do=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=void 0,e.$4n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$5n=new RegExp(e.$4n),e.$6n="__web_extension",e.$7n="skipWalkthrough",e.$8n="extensionsSync",e.$9n="dependecyOrPackExtensionInstall";function P(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$0n=P;function M(i){switch(i){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$$n=M;function A(i,r){switch(i){case 3:return r==="x64"?"win32-x64":r==="arm64"?"win32-arm64":"unknown";case 2:return r==="x64"?"linux-x64":r==="arm64"?"linux-arm64":r==="arm"?"linux-armhf":"unknown";case"alpine":return r==="x64"?"alpine-x64":r==="arm64"?"alpine-arm64":"unknown";case 1:return r==="x64"?"darwin-x64":r==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$_n=A;function $(i,r){return r==="web"&&!i.includes("web")}e.$ao=$;function E(i,r,c){return $(r,c)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===c}e.$bo=E;function f(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.$co=f;var C;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(C||(e.SortBy=C={}));var D;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(D||(e.SortOrder=D={}));var u;(function(i){i.Install="install",i.Uninstall="uninstall"})(u||(e.StatisticType=u={}));var b;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(b||(e.InstallOperation=b={})),e.$do=(0,T.$Vh)("extensionGalleryService");var v;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.Extract="Extract",i.Delete="Delete",i.Rename="Rename",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));var g;(function(i){i.UnknownError="UnknownError",i.PackageIsInvalidZip="PackageIsInvalidZip",i.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(g||(e.ExtensionSignaturetErrorCode=g={}));class t extends Error{constructor(r,c){super(r),this.code=c,this.name=c}}e.$eo=t,e.$fo=(0,T.$Vh)("extensionManagementService"),e.$go="extensionsIdentifiers/disabled",e.$ho="extensionsIdentifiers/enabled",e.$io=(0,T.$Vh)("IGlobalExtensionEnablementService"),e.$jo=(0,T.$Vh)("IExtensionTipsService"),e.$ko=(0,y.localize)(0,null),e.$lo={value:e.$ko,original:"Extensions"},e.$mo={value:(0,y.localize)(1,null),original:"Preferences"}}),define(Pe[41],Ae([1,0,50,20,12,16,2,153,4,21,13,44]),function(we,e,y,T,P,M,A,$,E,f,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.FileKind=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.FileOperationResult=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.FileChangeType=e.$wk=e.FileOperation=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.FileSystemProviderErrorCode=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.FileSystemProviderCapabilities=e.$gk=e.FilePermission=e.FileType=e.$fk=e.$ek=void 0,e.$ek=(0,E.$Vh)("fileService");function u(te){return te.create===!0}e.$fk=u;var b;(function(te){te[te.Unknown=0]="Unknown",te[te.File=1]="File",te[te.Directory=2]="Directory",te[te.SymbolicLink=64]="SymbolicLink"})(b||(e.FileType=b={}));var v;(function(te){te[te.Readonly=1]="Readonly",te[te.Locked=2]="Locked"})(v||(e.FilePermission=v={}));function g(te){const Re=te;return!!Re&&typeof Re.onDidChange=="function"}e.$gk=g;var t;(function(te){te[te.None=0]="None",te[te.FileReadWrite=2]="FileReadWrite",te[te.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",te[te.FileReadStream=16]="FileReadStream",te[te.FileFolderCopy=8]="FileFolderCopy",te[te.PathCaseSensitive=1024]="PathCaseSensitive",te[te.Readonly=2048]="Readonly",te[te.Trash=4096]="Trash",te[te.FileWriteUnlock=8192]="FileWriteUnlock",te[te.FileAtomicRead=16384]="FileAtomicRead",te[te.FileAtomicWrite=32768]="FileAtomicWrite",te[te.FileAtomicDelete=65536]="FileAtomicDelete",te[te.FileClone=131072]="FileClone"})(t||(e.FileSystemProviderCapabilities=t={}));function i(te){return!!(te.capabilities&2)}e.$hk=i;function r(te){return!!(te.capabilities&8)}e.$ik=r;function c(te){return!!(te.capabilities&131072)}e.$jk=c;function o(te){return!!(te.capabilities&4)}e.$kk=o;function l(te){return!!(te.capabilities&16)}e.$lk=l;function n(te){return i(te)?!!(te.capabilities&16384):!1}e.$mk=n;function s(te){return i(te)?!!(te.capabilities&32768):!1}e.$nk=s;function a(te){return!!(te.capabilities&65536)}e.$ok=a;function d(te){return!!(te.capabilities&2048)}e.$pk=d;var p;(function(te){te.FileExists="EntryExists",te.FileNotFound="EntryNotFound",te.FileNotADirectory="EntryNotADirectory",te.FileIsADirectory="EntryIsADirectory",te.FileExceedsStorageQuota="EntryExceedsStorageQuota",te.FileTooLarge="EntryTooLarge",te.FileWriteLocked="EntryWriteLocked",te.NoPermissions="NoPermissions",te.Unavailable="Unavailable",te.Unknown="Unknown"})(p||(e.FileSystemProviderErrorCode=p={}));class m extends Error{static create(Re,se){const Q=new m(Re.toString(),se);return h(Q,se),Q}constructor(Re,se){super(Re),this.code=se}}e.$qk=m;function S(te,Re){return m.create(te,Re)}e.$rk=S;function k(te){return te||S((0,$.localize)(0,null),p.Unknown)}e.$sk=k;function h(te,Re){return te.name=Re?`${Re} (FileSystemError)`:"FileSystemError",te}e.$tk=h;function w(te){if(!te)return p.Unknown;if(te instanceof m)return te.code;const Re=/^(.+) \(FileSystemError\)$/.exec(te.name);if(!Re)return p.Unknown;switch(Re[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}e.$uk=w;function I(te){if(te instanceof L)return te.fileOperationResult;switch(w(te)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 9;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileTooLarge:return 7;default:return 10}}e.$vk=I;var F;(function(te){te[te.CREATE=0]="CREATE",te[te.DELETE=1]="DELETE",te[te.MOVE=2]="MOVE",te[te.COPY=3]="COPY",te[te.WRITE=4]="WRITE"})(F||(e.FileOperation=F={}));class V{constructor(Re,se,Q){this.resource=Re,this.operation=se,this.target=Q}isOperation(Re){return this.operation===Re}}e.$wk=V;var Z;(function(te){te[te.UPDATED=0]="UPDATED",te[te.ADDED=1]="ADDED",te[te.DELETED=2]="DELETED"})(Z||(e.FileChangeType=Z={}));class N{static{this.a=null}constructor(Re,se){this.c=se,this.b=void 0,this.d=new D.$U(()=>{const Q=y.$2h.forUris(()=>this.c);return Q.fill(this.rawAdded.map(B=>[B,!0])),Q}),this.f=new D.$U(()=>{const Q=y.$2h.forUris(()=>this.c);return Q.fill(this.rawUpdated.map(B=>[B,!0])),Q}),this.g=new D.$U(()=>{const Q=y.$2h.forUris(()=>this.c);return Q.fill(this.rawDeleted.map(B=>[B,!0])),Q}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Q of Re){switch(Q.type){case 1:this.rawAdded.push(Q.resource);break;case 0:this.rawUpdated.push(Q.resource);break;case 2:this.rawDeleted.push(Q.resource);break}this.b!==N.a&&(typeof Q.cId=="number"?this.b===void 0?this.b=Q.cId:this.b!==Q.cId&&(this.b=N.a):this.b!==void 0&&(this.b=N.a))}}contains(Re,...se){return this.h(Re,{includeChildren:!1},...se)}affects(Re,...se){return this.h(Re,{includeChildren:!0},...se)}h(Re,se,...Q){if(!Re)return!1;const B=Q.length>0;return!!((!B||Q.includes(1))&&(this.d.value.get(Re)||se.includeChildren&&this.d.value.findSuperstr(Re))||(!B||Q.includes(0))&&(this.f.value.get(Re)||se.includeChildren&&this.f.value.findSuperstr(Re))||(!B||Q.includes(2))&&(this.g.value.findSubstr(Re)||se.includeChildren&&this.g.value.findSuperstr(Re)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Re){return this.b===Re}hasCorrelation(){return typeof this.b=="number"}}e.$xk=N;function R(te,Re,se){return!te||!Re||te===Re||Re.length>te.length?!1:(Re.charAt(Re.length-1)!==T.sep&&(Re+=T.sep),se?(0,P.$7e)(te,Re):te.indexOf(Re)===0)}e.$yk=R;class L extends Error{constructor(Re,se,Q){super(Re),this.fileOperationResult=se,this.options=Q}}e.$zk=L;class O extends L{constructor(Re,se,Q,B){super(Re,se,B),this.fileOperationResult=se,this.size=Q}}e.$Ak=O;class Y extends L{constructor(Re,se,Q){super(Re,2,Q),this.stat=se}}e.$Bk=Y;var he;(function(te){te[te.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",te[te.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",te[te.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",te[te.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",te[te.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",te[te.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",te[te.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",te[te.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",te[te.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",te[te.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",te[te.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(he||(e.FileOperationResult=he={})),e.$Ck={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Dk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Ek="files.associations",e.$Fk="files.exclude",e.$Gk="files.readonlyInclude",e.$Hk="files.readonlyExclude",e.$Ik="files.readonlyFromPermissions";var $e;(function(te){te[te.FILE=0]="FILE",te[te.FOLDER=1]="FOLDER",te[te.ROOT_FOLDER=2]="ROOT_FOLDER"})($e||(e.FileKind=$e={})),e.$Jk="";function De(te){if(!(typeof te.size!="number"||typeof te.mtime!="number"))return te.mtime.toString(29)+te.size.toString(31)}e.$Kk=De;async function ke(te,Re){if(!Re.hasProvider(A.URI.from({scheme:te.scheme})))return new Promise(se=>{const Q=Re.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===te.scheme&&B.added&&(Q.dispose(),se())})})}e.$Lk=ke;class fe{static{this.KB=1024}static{this.MB=fe.KB*fe.KB}static{this.GB=fe.MB*fe.KB}static{this.TB=fe.GB*fe.KB}static formatSize(Re){return(0,M.$Gf)(Re)||(Re=0),Re<fe.KB?(0,$.localize)(1,null,Re.toFixed(0)):Re<fe.MB?(0,$.localize)(2,null,(Re/fe.KB).toFixed(2)):Re<fe.GB?(0,$.localize)(3,null,(Re/fe.MB).toFixed(2)):Re<fe.TB?(0,$.localize)(4,null,(Re/fe.GB).toFixed(2)):(0,$.localize)(5,null,(Re/fe.TB).toFixed(2))}}e.$Mk=fe;function ve(te){const Re=typeof te=="string"||te?.scheme===C.Schemas.vscodeRemote;return typeof te!="string"&&te?.scheme===C.Schemas.file?1024*fe.MB:Re?10*fe.MB:f.$o?50*fe.MB:1024*fe.MB}e.$Nk=ve}),define(Pe[71],Ae([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=void 0;class y{constructor(...P){this.a=new Map;for(const[M,A]of P)this.set(M,A)}set(P,M){const A=this.a.get(P);return this.a.set(P,M),A}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.$Th=y}),define(Pe[185],Ae([1,0,14,11,6,69,183,4,71,186]),function(we,e,y,T,P,M,A,$,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=e.$jq=void 0;const C=!1;class D extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class u{constructor(t=new E.$Th,i=!1,r,c=C){this.f=t,this.g=i,this.h=r,this.i=c,this.o=new Set,this.f.set($.$Uh,this),this._globalGraph=c?r?._globalGraph??new A.$iq(o=>o):void 0}createChild(t){return new u(t,this.g,this,this.i)}invokeFunction(t,...i){const r=v.traceInvocation(this.i,t);let c=!1;try{return t({get:l=>{if(c)throw(0,T.$7)("service accessor is only valid during the invocation of its target method");const n=this.m(l,r);if(!n)throw new Error(`[invokeFunction] unknown service '${l}'`);return n}},...i)}finally{c=!0,r.stop()}}createInstance(t,...i){let r,c;return t instanceof M.$Sh?(r=v.traceCreation(this.i,t.ctor),c=this.j(t.ctor,t.staticArguments.concat(i),r)):(r=v.traceCreation(this.i,t),c=this.j(t,i,r)),r.stop(),c}j(t,i=[],r){const c=$._util.getServiceDependencies(t).sort((n,s)=>n.index-s.index),o=[];for(const n of c){const s=this.m(n.id,r);s||this.u(`[createInstance] ${t.name} depends on UNKNOWN service ${n.id}.`,!1),o.push(s)}const l=c.length>0?c[0].index:i.length;if(i.length!==l){console.trace(`[createInstance] First service dependency of ${t.name} at position ${l+1} conflicts with ${i.length} static arguments`);const n=l-i.length;n>0?i=i.concat(new Array(n)):i=i.slice(0,l)}return Reflect.construct(t,i.concat(o))}k(t,i){if(this.f.get(t)instanceof M.$Sh)this.f.set(t,i);else if(this.h)this.h.k(t,i);else throw new Error("illegalState - setting UNKNOWN service instance")}l(t){const i=this.f.get(t);return!i&&this.h?this.h.l(t):i}m(t,i){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(t));const r=this.l(t);return r instanceof M.$Sh?this.q(t,r,i.branch(t,!0)):(i.branch(t,!1),r)}q(t,i,r){if(this.o.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this.o.add(t);try{return this.r(t,i,r)}finally{this.o.delete(t)}}r(t,i,r){const c=new A.$iq(n=>n.id.toString());let o=0;const l=[{id:t,desc:i,_trace:r}];for(;l.length;){const n=l.pop();if(c.lookupOrInsertNode(n),o++>1e3)throw new D(c);for(const s of $._util.getServiceDependencies(n.desc.ctor)){const a=this.l(s.id);if(a||this.u(`[createInstance] ${t} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(s.id)),a instanceof M.$Sh){const d={id:s.id,desc:a,_trace:n._trace.branch(s.id,!0)};c.insertEdge(n,d),l.push(d)}}}for(;;){const n=c.roots();if(n.length===0){if(!c.isEmpty())throw new D(c);break}for(const{data:s}of n){if(this.l(s.id)instanceof M.$Sh){const d=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,d)}c.removeNode(s)}}return this.l(t)}s(t,i,r=[],c,o){if(this.f.get(t)instanceof M.$Sh)return this.t(t,i,r,c,o);if(this.h)return this.h.s(t,i,r,c,o);throw new Error(`illegalState - creating UNKNOWN service instance ${i.name}`)}t(t,i,r=[],c,o){if(c){const l=new u(void 0,this.g,this,this.i);l.c=String(t);const n=new Map,s=new y.$eh(()=>{const a=l.j(i,r,o);for(const[d,p]of n){const m=a[d];if(typeof m=="function")for(const S of p)m.apply(a,S)}return n.clear(),a});return new Proxy(Object.create(null),{get(a,d){if(!s.isInitialized&&typeof d=="string"&&(d.startsWith("onDid")||d.startsWith("onWill"))){let S=n.get(d);return S||(S=new f.$2c,n.set(d,S)),(h,w,I)=>{const F=S.push([h,w,I]);return(0,P.$Pc)(F)}}if(d in a)return a[d];const p=s.value;let m=p[d];return typeof m!="function"||(m=m.bind(p),a[d]=m),m},set(a,d,p){return s.value[d]=p,!0},getPrototypeOf(a){return i.prototype}})}else return this.j(i,r,o)}u(t,i){if(i&&console.warn(t),this.g)throw new Error(t)}}e.$jq=u;var b;(function(g){g[g.None=0]="None",g[g.Creation=1]="Creation",g[g.Invocation=2]="Invocation",g[g.Branch=3]="Branch"})(b||(b={}));class v{static{this.all=new Set}static{this.c=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(t,i){return t?new v(2,i.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(t,i){return t?new v(1,i.name):v.c}static{this.f=0}constructor(t,i){this.type=t,this.name=i,this.g=Date.now(),this.h=[]}branch(t,i){const r=new v(3,t.toString());return this.h.push([t,i,r]),r}stop(){const t=Date.now()-this.g;v.f+=t;let i=!1;function r(o,l){const n=[],s=new Array(o+1).join("	");for(const[a,d,p]of l.h)if(d&&p){i=!0,n.push(`${s}CREATES -> ${a}`);const m=r(o+1,p);m&&n.push(m)}else n.push(`${s}uses -> ${a}`);return n.join(`
`)}const c=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${r(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(t>2||i)&&v.all.add(c.join(`
`))}}e.$kq=v}),define(Pe[15],Ae([1,0,39,5,97,6,28,21,25,16,2,34,4]),function(we,e,y,T,P,M,A,$,E,f,C,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.log=e.$gj=e.LogLevel=e.$fj=e.$ej=e.$dj=void 0,e.$dj=(0,u.$Vh)("logService"),e.$ej=(0,u.$Vh)("loggerService");function b(){return new Date().toISOString()}function v(h){return(0,f.$Gf)(h)}e.$fj=v;var g;(function(h){h[h.Off=0]="Off",h[h.Trace=1]="Trace",h[h.Debug=2]="Debug",h[h.Info=3]="Info",h[h.Warning=4]="Warning",h[h.Error=5]="Error"})(g||(e.LogLevel=g={})),e.$gj=g.Info;function t(h,w,I){switch(w){case g.Trace:h.trace(I);break;case g.Debug:h.debug(I);break;case g.Info:h.info(I);break;case g.Warning:h.warn(I);break;case g.Error:h.error(I);break;case g.Off:break;default:throw new Error(`Invalid log level ${w}`)}}e.log=t;function i(h,w=!1){let I="";for(let F=0;F<h.length;F++){let V=h[F];if(V instanceof Error&&(V=(0,y.$Gi)(V,w)),typeof V=="object")try{V=JSON.stringify(V)}catch{}I+=(F>0?" ":"")+V}return I}class r extends M.$Rc{constructor(){super(...arguments),this.b=e.$gj,this.c=this.B(new T.$Rd),this.onDidChangeLogLevel=this.c.event}setLevel(w){this.b!==w&&(this.b=w,this.c.fire(this.b))}getLevel(){return this.b}f(w){return this.b!==g.Off&&this.b<=w}}e.$ij=r;class c extends r{constructor(w){super(),this.h=w}f(w){return this.h||super.f(w)}trace(w,...I){this.f(g.Trace)&&this.g(g.Trace,i([w,...I],!0))}debug(w,...I){this.f(g.Debug)&&this.g(g.Debug,i([w,...I]))}info(w,...I){this.f(g.Info)&&this.g(g.Info,i([w,...I]))}warn(w,...I){this.f(g.Warning)&&this.g(g.Warning,i([w,...I]))}error(w,...I){if(this.f(g.Error))if(w instanceof Error){const F=Array.prototype.slice.call(arguments);F[0]=w.stack,this.g(g.Error,i(F))}else this.g(g.Error,i([w,...I]))}flush(){}}e.$jj=c;class o extends r{constructor(w=e.$gj){super(),this.setLevel(w),this.g=!$.$i}trace(w,...I){this.f(g.Trace)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,w,...I):console.log(`[main ${b()}]`,w,...I))}debug(w,...I){this.f(g.Debug)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,w,...I):console.log(`[main ${b()}]`,w,...I))}info(w,...I){this.f(g.Info)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,w,...I):console.log(`[main ${b()}]`,w,...I))}warn(w,...I){this.f(g.Warning)&&(this.g?console.warn(`\x1B[93m[main ${b()}]\x1B[0m`,w,...I):console.warn(`[main ${b()}]`,w,...I))}error(w,...I){this.f(g.Error)&&(this.g?console.error(`\x1B[91m[main ${b()}]\x1B[0m`,w,...I):console.error(`[main ${b()}]`,w,...I))}dispose(){}flush(){}}e.$kj=o;class l extends r{constructor(w=e.$gj,I=!0){super(),this.g=I,this.setLevel(w)}trace(w,...I){this.f(g.Trace)&&(this.g?console.log("%cTRACE","color: #888",w,...I):console.log(w,...I))}debug(w,...I){this.f(g.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",w,...I):console.log(w,...I))}info(w,...I){this.f(g.Info)&&(this.g?console.log("%c INFO","color: #33f",w,...I):console.log(w,...I))}warn(w,...I){this.f(g.Warning)&&(this.g?console.log("%c WARN","color: #993",w,...I):console.log(w,...I))}error(w,...I){this.f(g.Error)&&(this.g?console.log("%c  ERR","color: #f33",w,...I):console.error(w,...I))}dispose(){}flush(){}}e.$lj=l;class n extends r{constructor(w,I=e.$gj){super(),this.g=w,this.setLevel(I)}trace(w,...I){this.f(g.Trace)&&this.g.log(g.Trace,[this.h(w),...I])}debug(w,...I){this.f(g.Debug)&&this.g.log(g.Debug,[this.h(w),...I])}info(w,...I){this.f(g.Info)&&this.g.log(g.Info,[this.h(w),...I])}warn(w,...I){this.f(g.Warning)&&this.g.log(g.Warning,[this.h(w),...I])}error(w,...I){this.f(g.Error)&&this.g.log(g.Error,[this.h(w),...I])}h(w){return typeof w=="string"?w:(0,y.$Gi)(w,this.f(g.Trace))}dispose(){}flush(){}}e.$mj=n;class s extends r{constructor(w){super(),this.g=w,w.length&&this.setLevel(w[0].getLevel())}setLevel(w){for(const I of this.g)I.setLevel(w);super.setLevel(w)}trace(w,...I){for(const F of this.g)F.trace(w,...I)}debug(w,...I){for(const F of this.g)F.debug(w,...I)}info(w,...I){for(const F of this.g)F.info(w,...I)}warn(w,...I){for(const F of this.g)F.warn(w,...I)}error(w,...I){for(const F of this.g)F.error(w,...I)}flush(){for(const w of this.g)w.flush()}dispose(){for(const w of this.g)w.dispose()}}e.$nj=s;class a extends M.$Rc{constructor(w,I,F){if(super(),this.h=w,this.j=I,this.b=new A.$zc,this.c=this.B(new T.$Rd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new T.$Rd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new T.$Rd),this.onDidChangeVisibility=this.g.event,F)for(const V of F)this.b.set(V.resource,{logger:void 0,info:V})}m(w){return(0,f.$Cf)(w)?[...this.b.values()].find(I=>I.info.id===w):this.b.get(w)}getLogger(w){return this.m(w)?.logger}createLogger(w,I){const F=this.n(w),V=(0,f.$Cf)(w)?w:I?.id??(0,P.$Ji)(F.toString()).toString(16);let Z=this.b.get(F)?.logger;const N=I?.logLevel==="always"?g.Trace:I?.logLevel;Z||(Z=this.s(F,N??this.getLogLevel(F)??this.h,{...I,id:V}));const R={logger:Z,info:{resource:F,id:V,logLevel:N,name:I?.name,hidden:I?.hidden,extensionId:I?.extensionId,when:I?.when}};return this.registerLogger(R.info),this.b.set(F,R),Z}n(w){return(0,f.$Cf)(w)?(0,E.$zg)(this.j,`${w}.log`):w}setLogLevel(w,I){if(C.URI.isUri(w)){const F=w,V=I,Z=this.b.get(F);Z&&V!==Z.info.logLevel&&(Z.info.logLevel=V===this.h?void 0:V,Z.logger?.setLevel(V),this.b.set(Z.info.resource,Z),this.f.fire([F,V]))}else{this.h=w;for(const[F,V]of this.b.entries())this.b.get(F)?.info.logLevel===void 0&&V.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(w,I){const F=this.m(w);F&&I!==!F.info.hidden&&(F.info.hidden=!I,this.b.set(F.info.resource,F),this.g.fire([F.info.resource,I]))}getLogLevel(w){let I;return w&&(I=this.b.get(w)?.info.logLevel),I??this.h}registerLogger(w){const I=this.b.get(w.resource);I?I.info.hidden!==w.hidden&&this.setVisibility(w.resource,!w.hidden):(this.b.set(w.resource,{info:w,logger:void 0}),this.c.fire({added:[w],removed:[]}))}deregisterLogger(w){const I=this.b.get(w);I&&(I.logger&&I.logger.dispose(),this.b.delete(w),this.c.fire({added:[],removed:[I.info]}))}*getRegisteredLoggers(){for(const w of this.b.values())yield w.info}getRegisteredLogger(w){return this.b.get(w)?.info}dispose(){this.b.forEach(w=>w.logger?.dispose()),this.b.clear(),super.dispose()}}e.$oj=a;class d{constructor(){this.onDidChangeLogLevel=new T.$Rd().event}setLevel(w){}getLevel(){return g.Info}trace(w,...I){}debug(w,...I){}info(w,...I){}warn(w,...I){}error(w,...I){}critical(w,...I){}dispose(){}flush(){}}e.$pj=d;class p extends d{}e.$qj=p;function m(h){if(h.verbose)return g.Trace;if(typeof h.logLevel=="string"){const w=k(h.logLevel.toLowerCase());if(w!==void 0)return w}return e.$gj}e.$rj=m;function S(h){switch(h){case g.Trace:return"trace";case g.Debug:return"debug";case g.Info:return"info";case g.Warning:return"warn";case g.Error:return"error";case g.Off:return"off"}}e.$sj=S;function k(h){switch(h){case"trace":return g.Trace;case"debug":return g.Debug;case"info":return g.Info;case"warn":return g.Warning;case"error":return g.Error;case"critical":return g.Error;case"off":return g.Off}}e.$tj=k,e.$uj=new D.$aj("logLevel",S(g.Info))}),define(Pe[187],Ae([1,0,6,15]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XN=void 0;class P extends y.$Rc{constructor(A,$=[]){super(),this.a=new T.$nj([A,...$]),this.B(A.onDidChangeLogLevel(E=>this.setLevel(E)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...$){this.a.trace(A,...$)}debug(A,...$){this.a.debug(A,...$)}info(A,...$){this.a.info(A,...$)}warn(A,...$){this.a.warn(A,...$)}error(A,...$){this.a.error(A,...$)}flush(){this.a.flush()}}e.$XN=P}),define(Pe[98],Ae([1,0,31,154,4]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ft=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(M||(e.MarkerTag=M={}));var A;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(E){function f(v,g){return g-v}E.compare=f;const C=Object.create(null);C[E.Error]=(0,T.localize)(0,null),C[E.Warning]=(0,T.localize)(1,null),C[E.Info]=(0,T.localize)(2,null);function D(v){return C[v]||""}E.toString=D;function u(v){switch(v){case y.default.Error:return E.Error;case y.default.Warning:return E.Warning;case y.default.Info:return E.Info;case y.default.Ignore:return E.Hint}}E.fromSeverity=u;function b(v){switch(v){case E.Error:return y.default.Error;case E.Warning:return y.default.Warning;case E.Info:return y.default.Info;case E.Hint:return y.default.Ignore}}E.toSeverity=b}(A||(e.MarkerSeverity=A={}));var $;(function(E){const f="";function C(u){return D(u,!0)}E.makeKey=C;function D(u,b){const v=[f];return u.source?v.push(u.source.replace("\xA6","\\\xA6")):v.push(f),u.code?typeof u.code=="string"?v.push(u.code.replace("\xA6","\\\xA6")):v.push(u.code.value.replace("\xA6","\\\xA6")):v.push(f),u.severity!==void 0&&u.severity!==null?v.push(A.toString(u.severity)):v.push(f),u.message&&b?v.push(u.message.replace("\xA6","\\\xA6")):v.push(f),u.startLineNumber!==void 0&&u.startLineNumber!==null?v.push(u.startLineNumber.toString()):v.push(f),u.startColumn!==void 0&&u.startColumn!==null?v.push(u.startColumn.toString()):v.push(f),u.endLineNumber!==void 0&&u.endLineNumber!==null?v.push(u.endLineNumber.toString()):v.push(f),u.endColumn!==void 0&&u.endColumn!==null?v.push(u.endColumn.toString()):v.push(f),v.push(f),v.join("\xA6")}E.makeKeyOptionalMessage=D})($||(e.IMarkerData=$={})),e.$ft=(0,P.$Vh)("markerService")}),define(Pe[188],Ae([1,0,5,31,4]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8u=e.$7u=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$6u=e.Severity=void 0,e.Severity=T.default,e.$6u=(0,P.$Vh)("notificationService");var M;(function(C){C[C.DEFAULT=0]="DEFAULT",C[C.SILENT=1]="SILENT",C[C.URGENT=2]="URGENT"})(M||(e.NotificationPriority=M={}));var A;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.PROFILE=1]="PROFILE",C[C.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));var $;(function(C){C[C.OFF=0]="OFF",C[C.SILENT=1]="SILENT",C[C.ERROR=2]="ERROR"})($||(e.NotificationsFilter=$={}));class E{constructor(){this.progress=new f,this.onDidClose=y.Event.None,this.onDidChangeVisibility=y.Event.None}updateSeverity(D){}updateMessage(D){}updateActions(D){}close(){}}e.$7u=E;class f{infinite(){}done(){}total(D){}worked(D){}}e.$8u=f}),define(Pe[99],Ae([1,0,12,2,4]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UU=e.$TU=e.$SU=e.$RU=e.$QU=void 0,e.$QU=(0,P.$Vh)("openerService");function M(f,C){return T.URI.isUri(f)?(0,y.$6e)(f.scheme,C):(0,y.$7e)(f,C+":")}e.$RU=M;function A(f,...C){return C.some(D=>M(f,D))}e.$SU=A;function $(f,C){return f.with({fragment:`${C.startLineNumber},${C.startColumn}${C.endLineNumber?`-${C.endLineNumber}${C.endColumn?`,${C.endColumn}`:""}`:""}`})}e.$TU=$;function E(f){let C;const D=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(f.fragment);return D&&(C={startLineNumber:parseInt(D[1]),startColumn:D[2]?parseInt(D[2]):1,endLineNumber:D[4]?parseInt(D[4]):void 0,endColumn:D[4]?D[5]?parseInt(D[5]):1:void 0},f=f.with({fragment:""})),{selection:C,uri:f}}e.$UU=E}),define(Pe[189],Ae([1,0,4]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wj=e.$vj=void 0,e.$vj=(0,y.$Vh)("productService"),e.$wj="vscode://schemas/vscode-product"});var Ke=this&&this.__decorate||function(we,e,y,T){var P=arguments.length,M=P<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,y):T,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(we,e,y,T);else for(var $=we.length-1;$>=0;$--)(A=we[$])&&(M=(P<3?A(M):P>3?A(e,y,M):A(e,y))||M);return P>3&&M&&Object.defineProperty(e,y,M),M},Ve=this&&this.__param||function(we,e){return function(y,T){e(y,T,we)}};define(Pe[72],Ae([1,0,14,19,6,4]),function(we,e,y,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cv=e.$bv=e.$av=e.$_u=e.$$u=e.$0u=e.ProgressLocation=e.$9u=void 0,e.$9u=(0,M.$Vh)("progressService");var A;(function(D){D[D.Explorer=1]="Explorer",D[D.Scm=3]="Scm",D[D.Extensions=5]="Extensions",D[D.Window=10]="Window",D[D.Notification=15]="Notification",D[D.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$0u=Object.freeze({total(){},worked(){},done(){}});class ${static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(u){this.b=u}report(u){this.a=u,this.b(this.a)}}e.$$u=$;class E{get value(){return this.a}constructor(u){this.e=u}report(u){this.b?this.b.push(u):this.b=[u],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const u=this.b.shift();this.a=u,await this.e(this.a)}}finally{this.c=!1;const u=this.d;this.d=void 0,u?.()}}drain(){return this.c?new Promise(u=>{const b=this.d;this.d=()=>{b?.(),u()}}):Promise.resolve()}}e.$_u=E;let f=class extends P.$Rc{constructor(u,b){super(),this.a=new y.$ih,b.withProgress(u,v=>(this.b=v,this.c&&v.report(this.c),this.a.p)),this.B((0,P.$Pc)(()=>this.a.complete()))}report(u){this.b?this.b.report(u):this.c=u}};e.$av=f,e.$av=f=Ke([Ve(1,e.$9u)],f);class C extends P.$Rc{constructor(u){super(),this.g=u,this.a=0,this.b=this.B(new P.$Qc)}start(u){this.stop();const b=++this.a,v=new T.$2d;return this.f=setTimeout(()=>{b===this.a&&(this.c=this.g.show(!0))},u),this.b.add((0,P.$Pc)(()=>clearTimeout(this.f))),this.b.add((0,P.$Pc)(()=>v.cancel())),this.b.add((0,P.$Pc)(()=>this.c?this.c.done():void 0)),{id:b,token:v.token,stop:()=>this.h(b),isCurrent:()=>this.a===b}}stop(){this.h(this.a)}h(u){this.a===u&&this.b.clear()}}e.$bv=C,e.$cv=(0,M.$Vh)("editorProgressService")}),define(Pe[30],Ae([1,0,53,16]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mn=void 0;class P{constructor(){this.a=new Map}add(A,$){y.ok(T.$Cf(A)),y.ok(T.$Ef($)),y.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,$)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$mn=new P}),define(Pe[73],Ae([1,0,5,30]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nn=void 0,e.$nn={JSONContribution:"base.contributions.json"};function P($){return $.length>0&&$.charAt($.length-1)==="#"?$.substring(0,$.length-1):$}class M{constructor(){this.b=new y.$Rd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(E,f){this.a[P(E)]=f,this.b.fire(E)}notifySchemaChanged(E){this.b.fire(E)}getSchemaContributions(){return{schemas:this.a}}}const A=new M;T.$mn.add(e.$nn.JSONContribution,A)}),define(Pe[54],Ae([1,0,18,5,16,148,40,73,30]),function(we,e,y,T,P,M,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.ConfigurationScope=e.$rn=e.EditPresentationTypes=void 0;var f;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(f||(e.EditPresentationTypes=f={})),e.$rn={Configuration:"base.contributions.configuration"};var C;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C||(e.ConfigurationScope=C={})),e.$sn={properties:{},patternProperties:{}},e.$tn={properties:{},patternProperties:{}},e.$un={properties:{},patternProperties:{}},e.$vn={properties:{},patternProperties:{}},e.$wn={properties:{},patternProperties:{}},e.$xn={properties:{},patternProperties:{}},e.$yn="vscode://schemas/settings/resourceLanguage",e.$zn="vscode://schemas/settings/configurationDefaults";const D=E.$mn.as($.$nn.JSONContribution);class u{constructor(){this.h=new Set,this.i=new T.$Rd,this.onDidSchemaChange=this.i.event,this.j=new T.$Rd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},D.registerSchema(e.$yn,this.g),this.v()}registerConfiguration(n,s=!0){this.registerConfigurations([n],s)}registerConfigurations(n,s=!0){const a=new Set;this.n(n,s,a),D.registerSchema(e.$yn,this.g),this.i.fire(),this.j.fire({properties:a})}deregisterConfigurations(n){const s=new Set;this.o(n,s),D.registerSchema(e.$yn,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:n,remove:s}){const a=new Set;this.o(s,a),this.n(n,!1,a),D.registerSchema(e.$yn,this.g),this.i.fire(),this.j.fire({properties:a})}registerDefaultConfigurations(n){const s=new Set;this.k(n,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(n,s){const a=[];for(const{overrides:d,source:p}of n)for(const m in d)if(s.add(m),e.$Bn.test(m)){const S=this.a.get(m),k=S?.valuesSources??new Map;if(p)for(const F of Object.keys(d[m]))k.set(F,p);const h={...S?.value||{},...d[m]};this.a.set(m,{source:p,value:h,valuesSources:k});const w=(0,A.$zi)(m),I={type:"object",default:h,description:M.localize(1,null,w),$ref:e.$yn,defaultDefaultValue:h,source:P.$Cf(p)?void 0:p,defaultValueSource:p};a.push(...g(m)),this.d[m]=I,this.b.properties[m]=I}else{this.a.set(m,{value:d[m],source:p});const S=this.d[m];S&&(this.w(m,S),this.r(m,S))}this.m(a)}deregisterDefaultConfigurations(n){const s=new Set;this.l(n,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(n,s){for(const{overrides:a,source:d}of n)for(const p in a){const m=this.a.get(p),S=P.$Cf(d)?d:d?.id,k=P.$Cf(m?.source)?m?.source:m?.source?.id;if(S===k)if(s.add(p),this.a.delete(p),e.$Bn.test(p))delete this.d[p],delete this.b.properties[p];else{const h=this.d[p];h&&(this.w(p,h),this.r(p,h))}}this.u()}deltaConfiguration(n){let s=!1;const a=new Set;n.removedDefaults&&(this.l(n.removedDefaults,a),s=!0),n.addedDefaults&&(this.k(n.addedDefaults,a),s=!0),n.removedConfigurations&&this.o(n.removedConfigurations,a),n.addedConfigurations&&this.n(n.addedConfigurations,!1,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){this.m(n),this.i.fire()}m(n){for(const s of n)this.h.add(s);this.u()}n(n,s,a){n.forEach(d=>{this.p(d,s,d.extensionInfo,d.restrictedProperties,void 0,a),this.c.push(d),this.q(d)})}o(n,s){const a=d=>{if(d.properties)for(const p in d.properties){s.add(p);const m=this.d[p];m?.policy?.name&&this.e.delete(m.policy.name),delete this.d[p],this.s(p,d.properties[p])}d.allOf?.forEach(p=>a(p))};for(const d of n){a(d);const p=this.c.indexOf(d);p!==-1&&this.c.splice(p,1)}}p(n,s=!0,a,d,p=3,m){p=P.$Lf(n.scope)?p:n.scope;const S=n.properties;if(S)for(const h in S){const w=S[h];if(s&&c(h,w)){delete S[h];continue}if(w.source=a,w.defaultDefaultValue=S[h].default,this.w(h,w),e.$Bn.test(h)?w.scope=void 0:(w.scope=P.$Lf(w.scope)?p:w.scope,w.restricted=P.$Lf(w.restricted)?!!d?.includes(h):w.restricted),S[h].hasOwnProperty("included")&&!S[h].included){this.f[h]=S[h],delete S[h];continue}else this.d[h]=S[h],S[h].policy?.name&&this.e.set(S[h].policy.name,h);!S[h].deprecationMessage&&S[h].markdownDeprecationMessage&&(S[h].deprecationMessage=S[h].markdownDeprecationMessage),m.add(h)}const k=n.allOf;if(k)for(const h of k)this.p(h,s,a,d,p,m)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(n){const s=a=>{const d=a.properties;if(d)for(const m in d)this.r(m,d[m]);a.allOf?.forEach(s)};s(n)}r(n,s){switch(e.$sn.properties[n]=s,s.scope){case 1:e.$tn.properties[n]=s;break;case 2:e.$un.properties[n]=s;break;case 6:e.$vn.properties[n]=s;break;case 3:e.$wn.properties[n]=s;break;case 4:e.$xn.properties[n]=s;break;case 5:e.$xn.properties[n]=s,this.g.properties[n]=s;break}}s(n,s){switch(delete e.$sn.properties[n],s.scope){case 1:delete e.$tn.properties[n];break;case 2:delete e.$un.properties[n];break;case 6:delete e.$vn.properties[n];break;case 3:delete e.$wn.properties[n];break;case 4:case 5:delete e.$xn.properties[n],delete this.g.properties[n];break}}u(){for(const n of this.h.values()){const s=`[${n}]`,a={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$yn};this.w(s,a),e.$sn.properties[s]=a,e.$tn.properties[s]=a,e.$un.properties[s]=a,e.$vn.properties[s]=a,e.$wn.properties[s]=a,e.$xn.properties[s]=a}}v(){const n={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$yn};e.$sn.patternProperties[e.$An]=n,e.$tn.patternProperties[e.$An]=n,e.$un.patternProperties[e.$An]=n,e.$vn.patternProperties[e.$An]=n,e.$wn.patternProperties[e.$An]=n,e.$xn.patternProperties[e.$An]=n,this.i.fire()}w(n,s){const a=this.a.get(n);let d=a?.value,p=a?.source;P.$Jf(d)&&(d=s.defaultDefaultValue,p=void 0),P.$Jf(d)&&(d=i(s.type)),s.default=d,s.defaultValueSource=p}}const b="\\[([^\\]]+)\\]",v=new RegExp(b,"g");e.$An=`^(${b})+$`,e.$Bn=new RegExp(e.$An);function g(l){const n=[];if(e.$Bn.test(l)){let s=v.exec(l);for(;s?.length;){const a=s[1].trim();a&&n.push(a),s=v.exec(l)}}return(0,y.$Lb)(n)}e.$Cn=g;function t(l){return l.reduce((n,s)=>`${n}[${s}]`,"")}e.$Dn=t;function i(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$En=i;const r=new u;E.$mn.add(e.$rn.Configuration,r);function c(l,n){return l.trim()?e.$Bn.test(l)?M.localize(7,null,l):r.getConfigurationProperties()[l]!==void 0?M.localize(8,null,l):n.policy?.name&&r.getPolicyConfigurations().get(n.policy?.name)!==void 0?M.localize(9,null,l,n.policy?.name,r.getPolicyConfigurations().get(n.policy?.name)):null:M.localize(6,null)}e.$Fn=c;function o(){const l=[],n=r.getConfigurationProperties();for(const s of Object.keys(n))l.push([s,n[s].scope]);return l.push(["launch",4]),l.push(["task",4]),l}e.$Gn=o}),define(Pe[190],Ae([1,0,18,5,119,6,28,26,16,2,40,54,30]),function(we,e,y,T,P,M,A,$,E,f,C,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=void 0;function b(s){return Object.isFrozen(s)?s:$.$bn(s)}class v{constructor(a={},d=[],p=[],m){this.b=a,this.c=d,this.d=p,this.raw=m,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const a=this.raw.map(d=>{if(d instanceof v)return d;const p=new g("");return p.parseRaw(d),p.configurationModel});this.f=a.reduce((d,p)=>p===d?p:d.merge(p),a[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(a){return a?(0,C.$xi)(this.contents,a):this.contents}inspect(a,d){const p=this.rawConfiguration.getValue(a),m=d?this.rawConfiguration.getOverrideValue(a,d):void 0,S=d?this.rawConfiguration.override(d).getValue(a):p;return{value:p,override:m,merged:S}}getOverrideValue(a,d){const p=this.i(d);return p?a?(0,C.$xi)(p,a):p:void 0}getKeysForOverrideIdentifier(a){const d=[];for(const p of this.overrides)p.identifiers.includes(a)&&d.push(...p.keys);return y.$Lb(d)}getAllOverrideIdentifiers(){const a=[];for(const d of this.overrides)a.push(...d.identifiers);return y.$Lb(a)}override(a){let d=this.a.get(a);return d||(d=this.g(a),this.a.set(a,d)),d}merge(...a){const d=$.$an(this.contents),p=$.$an(this.overrides),m=[...this.keys],S=this.raw?.length?[...this.raw]:[this];for(const k of a)if(S.push(...k.raw?.length?k.raw:[k]),!k.isEmpty()){this.h(d,k.contents);for(const h of k.overrides){const[w]=p.filter(I=>y.$tb(I.identifiers,h.identifiers));w?(this.h(w.contents,h.contents),w.keys.push(...h.keys),w.keys=y.$Lb(w.keys)):p.push($.$an(h))}for(const h of k.keys)m.indexOf(h)===-1&&m.push(h)}return new v(d,m,p,S.every(k=>k instanceof v)?void 0:S)}g(a){const d=this.i(a);if(!d||typeof d!="object"||!Object.keys(d).length)return this;const p={};for(const m of y.$Lb([...Object.keys(this.contents),...Object.keys(d)])){let S=this.contents[m];const k=d[m];k&&(typeof S=="object"&&typeof k=="object"?(S=$.$an(S),this.h(S,k)):S=k),p[m]=S}return new v(p,this.keys,this.overrides)}h(a,d){for(const p of Object.keys(d)){if(p in a&&E.$Ef(a[p])&&E.$Ef(d[p])){this.h(a[p],d[p]);continue}a[p]=$.$an(d[p])}}i(a){let d=null,p=null;const m=S=>{S&&(p?this.h(p,S):p=$.$an(S))};for(const S of this.overrides)S.identifiers.length===1&&S.identifiers[0]===a?d=S.contents:S.identifiers.includes(a)&&m(S.contents);return m(d),p}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(a,d){this.j(a,d,!0)}setValue(a,d){this.j(a,d,!1)}removeValue(a){const d=this.keys.indexOf(a);d!==-1&&(this.keys.splice(d,1),(0,C.$wi)(this.contents,a),D.$Bn.test(a)&&this.overrides.splice(this.overrides.findIndex(p=>y.$tb(p.identifiers,(0,D.$Cn)(a))),1))}j(a,d,p){(0,C.$vi)(this.contents,a,d,m=>console.error(m)),p=p||this.keys.indexOf(a)===-1,p&&this.keys.push(a),D.$Bn.test(a)&&this.overrides.push({identifiers:(0,D.$Cn)(a),keys:Object.keys(this.contents[a]),contents:(0,C.$ui)(this.contents[a],m=>console.error(m))})}}e.$Hn=v;class g{constructor(a){this.f=a,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new v}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(a,d){if(!E.$Lf(a)){const p=this.g(a);this.parseRaw(p,d)}}reparse(a){this.a&&this.parseRaw(this.a,a)}parseRaw(a,d){this.a=a;const{contents:p,keys:m,overrides:S,restricted:k,hasExcludedProperties:h}=this.h(a,d);this.b=new v(p,m,S,h?[a]:void 0),this.c=k||[]}g(a){let d={},p=null,m=[];const S=[],k=[];function h(I){Array.isArray(m)?m.push(I):p!==null&&(m[p]=I)}const w={onObjectBegin:()=>{const I={};h(I),S.push(m),m=I,p=null},onObjectProperty:I=>{p=I},onObjectEnd:()=>{m=S.pop()},onArrayBegin:()=>{const I=[];h(I),S.push(m),m=I,p=null},onArrayEnd:()=>{m=S.pop()},onLiteralValue:h,onError:(I,F,V)=>{k.push({error:I,offset:F,length:V})}};if(a)try{P.$0m(a,w),d=m[0]||{}}catch(I){console.error(`Error while parsing settings file ${this.f}: ${I}`),this.d=[I]}return d}h(a,d){const p=u.$mn.as(D.$rn.Configuration).getConfigurationProperties(),m=this.i(a,p,!0,d);a=m.raw;const S=(0,C.$ui)(a,w=>console.error(`Conflict in settings file ${this.f}: ${w}`)),k=Object.keys(a),h=this.j(a,w=>console.error(`Conflict in settings file ${this.f}: ${w}`));return{contents:S,keys:k,overrides:h,restricted:m.restricted,hasExcludedProperties:m.hasExcludedProperties}}i(a,d,p,m){let S=!1;if(!m?.scopes&&!m?.skipRestricted&&!m?.exclude?.length)return{raw:a,restricted:[],hasExcludedProperties:S};const k={},h=[];for(const w in a)if(D.$Bn.test(w)&&p){const I=this.i(a[w],d,!1,m);k[w]=I.raw,S=S||I.hasExcludedProperties,h.push(...I.restricted)}else{const I=d[w],F=I?typeof I.scope<"u"?I.scope:3:void 0;I?.restricted&&h.push(w),!m.exclude?.includes(w)&&(m.include?.includes(w)||(F===void 0||m.scopes===void 0||m.scopes.includes(F))&&!(m.skipRestricted&&I?.restricted))?k[w]=a[w]:S=!0}return{raw:k,restricted:h,hasExcludedProperties:S}}j(a,d){const p=[];for(const m of Object.keys(a))if(D.$Bn.test(m)){const S={};for(const k in a[m])S[k]=a[m][k];p.push({identifiers:(0,D.$Cn)(m),keys:Object.keys(S),contents:(0,C.$ui)(S,d)})}return p}}e.$In=g;class t extends M.$Rc{constructor(a,d,p,m){super(),this.c=a,this.f=d,this.g=m,this.b=this.B(new T.$Rd),this.onDidChange=this.b.event,this.a=new g(this.c.toString()),this.B(this.g.watch(p.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(T.Event.any(T.Event.filter(this.g.onDidFilesChange,S=>S.contains(this.c)),T.Event.filter(this.g.onDidRunOperation,S=>(S.isOperation(0)||S.isOperation(3)||S.isOperation(1)||S.isOperation(4))&&p.isEqual(S.resource,a)))(()=>this.b.fire()))}async loadConfiguration(){try{const a=await this.g.readFile(this.c);return this.a.parse(a.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new v}}reparse(a){return a&&(this.f=a),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Jn=t;class i{constructor(a,d,p,m,S,k,h,w,I,F,V,Z,N){this.a=a,this.b=d,this.c=p,this.overrideIdentifiers=m,this.d=S,this.f=k,this.g=h,this.h=w,this.i=I,this.j=F,this.k=V,this.l=Z,this.m=N}get value(){return b(this.c)}n(a,d,p){const m=a.inspect(d,p);return{get value(){return b(m.value)},get override(){return b(m.override)},get merged(){return b(m.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class r{constructor(a,d,p,m,S=new v,k=new v,h=new A.$zc,w=new v,I=new A.$zc){this.c=a,this.d=d,this.f=p,this.g=m,this.h=S,this.i=k,this.j=h,this.l=w,this.m=I,this.a=null,this.b=new A.$zc,this.n=null}getValue(a,d,p){return this.p(a,d,p).getValue(a)}updateValue(a,d,p={}){let m;p.resource?(m=this.m.get(p.resource),m||(m=new v,this.m.set(p.resource,m))):m=this.l,d===void 0?m.removeValue(a):m.setValue(a,d),p.resource||(this.a=null)}inspect(a,d,p){const m=this.p(a,d,p),S=this.t(d.resource,p),k=d.resource?this.m.get(d.resource)||this.l:this.l,h=new Set;for(const w of m.overrides)for(const I of w.identifiers)m.getOverrideValue(a,I)!==void 0&&h.add(I);return new i(a,d,m.getValue(a),h.size?[...h]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,p?this.i:void 0,S||void 0,k)}keys(a){const d=this.t(void 0,a);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:d?d.keys.slice(0):[]}}updateDefaultConfiguration(a){this.c=a,this.a=null,this.b.clear()}updatePolicyConfiguration(a){this.d=a}updateApplicationConfiguration(a){this.f=a,this.a=null,this.b.clear()}updateLocalUserConfiguration(a){this.g=a,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(a){this.h=a,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(a){this.i=a,this.a=null,this.b.clear()}updateFolderConfiguration(a,d){this.j.set(a,d),this.b.delete(a)}deleteFolderConfiguration(a){this.folderConfigurations.delete(a),this.b.delete(a)}compareAndUpdateDefaultConfiguration(a,d){const p=[];if(!d){const{added:m,updated:S,removed:k}=l(this.c,a);d=[...m,...S,...k]}for(const m of d)for(const S of(0,D.$Cn)(m)){const k=this.c.getKeysForOverrideIdentifier(S),h=a.getKeysForOverrideIdentifier(S),w=[...h.filter(I=>k.indexOf(I)===-1),...k.filter(I=>h.indexOf(I)===-1),...k.filter(I=>!$.$en(this.c.override(S).getValue(I),a.override(S).getValue(I)))];p.push([S,w])}return this.updateDefaultConfiguration(a),{keys:d,overrides:p}}compareAndUpdatePolicyConfiguration(a){const{added:d,updated:p,removed:m}=l(this.d,a),S=[...d,...p,...m];return S.length&&this.updatePolicyConfiguration(a),{keys:S,overrides:[]}}compareAndUpdateApplicationConfiguration(a){const{added:d,updated:p,removed:m,overrides:S}=l(this.applicationConfiguration,a),k=[...d,...p,...m];return k.length&&this.updateApplicationConfiguration(a),{keys:k,overrides:S}}compareAndUpdateLocalUserConfiguration(a){const{added:d,updated:p,removed:m,overrides:S}=l(this.localUserConfiguration,a),k=[...d,...p,...m];return k.length&&this.updateLocalUserConfiguration(a),{keys:k,overrides:S}}compareAndUpdateRemoteUserConfiguration(a){const{added:d,updated:p,removed:m,overrides:S}=l(this.remoteUserConfiguration,a),k=[...d,...p,...m];return k.length&&this.updateRemoteUserConfiguration(a),{keys:k,overrides:S}}compareAndUpdateWorkspaceConfiguration(a){const{added:d,updated:p,removed:m,overrides:S}=l(this.workspaceConfiguration,a),k=[...d,...p,...m];return k.length&&this.updateWorkspaceConfiguration(a),{keys:k,overrides:S}}compareAndUpdateFolderConfiguration(a,d){const p=this.folderConfigurations.get(a),{added:m,updated:S,removed:k,overrides:h}=l(p,d),w=[...m,...S,...k];return(w.length||!p)&&this.updateFolderConfiguration(a,d),{keys:w,overrides:h}}compareAndDeleteFolderConfiguration(a){const d=this.folderConfigurations.get(a);if(!d)throw new Error("Unknown folder");this.deleteFolderConfiguration(a);const{added:p,updated:m,removed:S,overrides:k}=l(d,void 0);return{keys:[...p,...m,...S],overrides:k}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(a,d,p){let m=this.q(d,p);return d.overrideIdentifier&&(m=m.override(d.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(a)!==void 0&&(m=m.merge(this.d)),m}q({resource:a},d){let p=this.r();if(d&&a){const m=d.getFolder(a);m&&(p=this.s(m.uri)||p);const S=this.m.get(a);S&&(p=p.merge(S))}return p}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(a){let d=this.b.get(a);if(!d){const p=this.r(),m=this.j.get(a);m?(d=p.merge(m),this.b.set(a,d)):d=p}return d}t(a,d){if(d&&a){const p=d.getFolder(a);if(p)return this.j.get(p.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((a,d)=>{const{contents:p,overrides:m,keys:S}=this.j.get(d);return a.push([d,{contents:p,overrides:m,keys:S}]),a},[])}}allKeys(){const a=new Set;return this.c.keys.forEach(d=>a.add(d)),this.userConfiguration.keys.forEach(d=>a.add(d)),this.i.keys.forEach(d=>a.add(d)),this.j.forEach(d=>d.keys.forEach(p=>a.add(p))),[...a.values()]}u(){const a=new Set;return this.c.getAllOverrideIdentifiers().forEach(d=>a.add(d)),this.userConfiguration.getAllOverrideIdentifiers().forEach(d=>a.add(d)),this.i.getAllOverrideIdentifiers().forEach(d=>a.add(d)),this.j.forEach(d=>d.getAllOverrideIdentifiers().forEach(p=>a.add(p))),[...a.values()]}v(a){const d=new Set;return this.c.getKeysForOverrideIdentifier(a).forEach(p=>d.add(p)),this.userConfiguration.getKeysForOverrideIdentifier(a).forEach(p=>d.add(p)),this.i.getKeysForOverrideIdentifier(a).forEach(p=>d.add(p)),this.j.forEach(p=>p.getKeysForOverrideIdentifier(a).forEach(m=>d.add(m))),[...d.values()]}static parse(a){const d=this.w(a.defaults),p=this.w(a.policy),m=this.w(a.application),S=this.w(a.user),k=this.w(a.workspace),h=a.folders.reduce((w,I)=>(w.set(f.URI.revive(I[0]),this.w(I[1])),w),new A.$zc);return new r(d,p,m,S,new v,k,h,new v,new A.$zc)}static w(a){return new v(a.contents,a.keys,a.overrides)}}e.$Kn=r;function c(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const a=new Set,d=new Map;for(const m of s)m.keys.forEach(S=>a.add(S)),m.overrides.forEach(([S,k])=>{const h=(0,A.$wc)(d,S,new Set);k.forEach(w=>h.add(w))});const p=[];return d.forEach((m,S)=>p.push([S,[...m.values()]])),{keys:[...a.values()],overrides:p}}e.$Ln=c;class o{constructor(a,d,p,m){this.change=a,this.f=d,this.g=p,this.h=m,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const S of a.keys)this.affectedKeys.add(S);for(const[,S]of a.overrides)for(const k of S)this.affectedKeys.add(k);this.d=this.a;for(const S of this.affectedKeys)this.d+=S+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=r.parse(this.f.data)),this.i}affectsConfiguration(a,d){const p=this.a+a,m=this.d.indexOf(p);if(m<0)return!1;const S=m+p.length;if(S>=this.d.length)return!1;const k=this.d.charCodeAt(S);if(k!==this.b&&k!==this.c)return!1;if(d){const h=this.previousConfiguration?this.previousConfiguration.getValue(a,d,this.f?.workspace):void 0,w=this.g.getValue(a,d,this.h);return!$.$en(h,w)}return!0}}e.$Mn=o;function l(s,a){const{added:d,removed:p,updated:m}=n(a?.rawConfiguration,s?.rawConfiguration),S=[],k=s?.getAllOverrideIdentifiers()||[],h=a?.getAllOverrideIdentifiers()||[];if(a){const w=h.filter(I=>!k.includes(I));for(const I of w)S.push([I,a.getKeysForOverrideIdentifier(I)])}if(s){const w=k.filter(I=>!h.includes(I));for(const I of w)S.push([I,s.getKeysForOverrideIdentifier(I)])}if(a&&s){for(const w of k)if(h.includes(w)){const I=n({contents:s.getOverrideValue(void 0,w)||{},keys:s.getKeysForOverrideIdentifier(w)},{contents:a.getOverrideValue(void 0,w)||{},keys:a.getKeysForOverrideIdentifier(w)});S.push([w,[...I.added,...I.removed,...I.updated]])}}return{added:d,removed:p,updated:m,overrides:S}}function n(s,a){const d=s?a?s.keys.filter(S=>a.keys.indexOf(S)===-1):[...s.keys]:[],p=a?s?a.keys.filter(S=>s.keys.indexOf(S)===-1):[...a.keys]:[],m=[];if(s&&a){for(const S of a.keys)if(s.keys.indexOf(S)!==-1){const k=(0,C.$xi)(a.contents,S),h=(0,C.$xi)(s.contents,S);$.$en(k,h)||m.push(S)}}return{added:d,removed:p,updated:m}}}),define(Pe[100],Ae([1,0,11,4]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=e.$Yk=e.RemoteAuthorityResolverErrorCode=e.$Xk=e.$Wk=e.RemoteConnectionType=e.$Vk=void 0,e.$Vk=(0,T.$Vh)("remoteAuthorityResolverService");var P;(function(C){C[C.WebSocket=0]="WebSocket",C[C.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class M{constructor(D){this.id=D,this.type=1}toString(){return`Managed(${this.id})`}}e.$Wk=M;class A{constructor(D,u){this.host=D,this.port=u,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Xk=A;var $;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound",C.InvalidAuthority="InvalidAuthority"})($||(e.RemoteAuthorityResolverErrorCode=$={}));class E extends y.$ab{static isNotAvailable(D){return D instanceof E&&D._code===$.NotAvailable}static isTemporarilyNotAvailable(D){return D instanceof E&&D._code===$.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof E&&D._code===$.NoResolverFound}static isInvalidAuthority(D){return D instanceof E&&D._code===$.InvalidAuthority}static isHandled(D){return D instanceof E&&D.isHandled}constructor(D,u=$.Unknown,b){super(D),this._message=D,this._code=u,this._detail=b,this.isHandled=u===$.NotAvailable&&b===!0,Object.setPrototypeOf(this,E.prototype)}}e.$Yk=E;function f(C){const D=C.indexOf("+");return D===-1?C:C.substring(0,D)}e.$Zk=f}),define(Pe[55],Ae([1,0,13]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=void 0;function T(f){return f.scheme===y.Schemas.vscodeRemote?f.authority:void 0}e.$1k=T;function P(f){if(!f)return;const C=f.indexOf("+");return C<0?f:f.substr(0,C)}e.$2k=P;function M(f){return`/${f.quality??"oss"}-${f.commit??"dev"}`}e.$3k=M;function A(f){const{host:C,port:D}=E(f);if(typeof D>"u")throw new Error("Remote authority doesn't contain a port!");return{host:C,port:D}}e.$4k=A;function $(f,C){let{host:D,port:u}=E(f);return typeof u>"u"&&(u=C),{host:D,port:u}}e.$5k=$;function E(f){const C=f.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(C)return{host:C[1],port:parseInt(C[2],10)};const D=f.match(/^(\[[0-9a-z:]+\])$/);if(D)return{host:D[1],port:void 0};const u=f.match(/(.*):(\d+)$/);return u?{host:u[1],port:parseInt(u[2],10)}:{host:f,port:void 0}}}),define(Pe[22],Ae([1,0,12,4,55]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.TargetPlatform=e.ExtensionType=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=void 0,e.$6l="extensions.user.cache",e.$7l="extensions.builtin.cache",e.$8l="undefined_publisher",e.$9l=["ui","workspace","web"];function M(g){if(typeof g=="object"&&g!==null&&g.supported!==!0)return g.description}e.$0l=M,e.$$l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(A||(e.ExtensionType=A={}));var $;(function(g){g.WIN32_X64="win32-x64",g.WIN32_ARM64="win32-arm64",g.LINUX_X64="linux-x64",g.LINUX_ARM64="linux-arm64",g.LINUX_ARMHF="linux-armhf",g.ALPINE_X64="alpine-x64",g.ALPINE_ARM64="alpine-arm64",g.DARWIN_X64="darwin-x64",g.DARWIN_ARM64="darwin-arm64",g.WEB="web",g.UNIVERSAL="universal",g.UNKNOWN="unknown",g.UNDEFINED="undefined"})($||(e.TargetPlatform=$={}));class E{constructor(t){this.value=t,this._lower=t.toLowerCase()}static equals(t,i){if(typeof t>"u"||t===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof t=="string"||typeof i=="string"){const r=typeof t=="string"?t:t.value,c=typeof i=="string"?i:i.value;return y.$6e(r,c)}return t._lower===i._lower}static toKey(t){return typeof t=="string"?t.toLowerCase():t._lower}}e.$_l=E;class f{get size(){return this.c.size}constructor(t){if(this.c=new Set,t)for(const i of t)this.add(i)}add(t){this.c.add(E.toKey(t))}delete(t){return this.c.delete(E.toKey(t))}has(t){return this.c.has(E.toKey(t))}}e.$am=f;class C{constructor(){this.c=new Map}clear(){this.c.clear()}delete(t){this.c.delete(E.toKey(t))}get(t){return this.c.get(E.toKey(t))}has(t){return this.c.has(E.toKey(t))}set(t,i){this.c.set(E.toKey(t),i)}values(){return this.c.values()}forEach(t){this.c.forEach(t)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$bm=C;function D(g){return u(g)}e.$cm=D;function u(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}e.$dm=u;function b(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}e.$em=b;function v(g,t){if(t){const i=`onResolveRemoteAuthority:${(0,P.$2k)(t)}`;return!!g.activationEvents?.includes(i)}return!1}e.$fm=v,e.$gm=(0,T.$Vh)("IBuiltinExtensionsScannerService")}),define(Pe[101],Ae([1,0,11,22]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xF=e.$wF=void 0;class P{constructor(){this.a=new Map,this.b=new WeakMap}register(A,$){this.a.set(A,$)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const $=Object.create(null);for(const E of A){const f=this.readActivationEvents(E);f.length>0&&($[T.$_l.toKey(E.identifier)]=f)}return $}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const $=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];for(let E=0;E<$.length;E++)$[E]==="onUri"&&($[E]=`onUri:${T.$_l.toKey(A.identifier)}`);if(!A.contributes)return $;for(const E in A.contributes){const f=this.a.get(E);if(!f)continue;const C=A.contributes[E],D=Array.isArray(C)?C:[C];try{f(D,$)}catch(u){(0,y.$Z)(u)}}return $}}e.$wF=P,e.$xF=new P}),define(Pe[191],Ae([1,0,21,74,38]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$no=void 0;function M(E){if(y.$u===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}function A(E,f,C,D,u,b,v,g,t){const i=Object.create(null);i["common.machineId"]=b,i["common.sqmId"]=v,i.sessionID=(0,P.$ig)()+Date.now(),i.commitHash=D,i.version=u,i["common.platformVersion"]=(E||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),i["common.platform"]=(0,y.$h)(y.$u),i["common.nodePlatform"]=T.$cc,i["common.nodeArch"]=C,i["common.product"]=t||"desktop",g&&(i["common.msftInternal"]=g);let r=0;const c=Date.now();Object.defineProperties(i,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>r++,enumerable:!0}}),y.$l&&(i["common.snap"]="true");const o=M(f);return o&&(i["common.platformDetail"]=o),i}e.$no=A;function $(E){const f=T.env.USERDNSDOMAIN;if(!f)return!1;const C=f.toLowerCase();return E.some(D=>C===D)}e.$oo=$}),define(Pe[192],Ae([1,0,4]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=void 0,e.$il=(0,y.$Vh)("telemetryService"),e.$jl=(0,y.$Vh)("customEndpointTelemetryService"),e.$kl="telemetry.currentSessionDate",e.$ll="telemetry.firstSessionDate",e.$ml="telemetry.lastSessionDate",e.$nl="telemetry.machineId",e.$ol="telemetry.sqmId",e.$pl="telemetry",e.$ql="telemetry.telemetryLevel",e.$rl="telemetry.enableCrashReporter",e.$sl="telemetry.enableTelemetry";var T;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(T||(e.TelemetryLevel=T={}));var P;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(Pe[56],Ae([1,0,26,16,5,40,55,191,192]),function(we,e,y,T,P,M,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=void 0;class f{constructor(p){this.value=p,this.isTrustedTelemetryValue=!0}}e.$po=f;class C{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$qo=C,e.$ro=new C;class D{async publicLog(p,m,S){}async publicLogError(p,m,S){}}e.$so=D,e.$to="telemetry",e.$uo="extensionTelemetryLog",e.$vo={log:()=>null,flush:()=>Promise.resolve(null)};function u(d,p){return P.Event.debounce(p.onDidChangeConfiguration,(S,k)=>{const h=S?new Set([...S.affectedKeys,...k.affectedKeys]):k.affectedKeys;return{...k,affectedKeys:h}},1e3,!0)(S=>{S.source!==7&&d.publicLog2("updateConfiguration",{configurationSource:(0,M.$si)(S.source),configurationKeys:Array.from(S.affectedKeys)})})}e.$wo=u;function b(d,p){return!p.isBuilt&&!p.disableTelemetry?!0:!(p.disableTelemetry||!d.enableTelemetry)}e.$xo=b;function v(d,p){return p.extensionTestsLocationURI?!0:!(p.isBuilt||p.disableTelemetry||d.enableTelemetry&&d.aiConfig?.ariaKey)}e.$yo=v;function g(d){const p=d.getValue(E.$ql),m=d.getValue(E.$rl);if(d.getValue(E.$sl)===!1||m===!1)return 0;switch(p??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$zo=g;function t(d){const p={},m={},S={};c(d,S);for(let k in S){k=k.length>150?k.substr(k.length-149):k;const h=S[k];typeof h=="number"?m[k]=h:typeof h=="boolean"?m[k]=h?1:0:typeof h=="string"?(h.length>8192&&console.warn(`Telemetry property: ${k} has been trimmed to 8192, the original length is ${h.length}`),p[k]=h.substring(0,8191)):typeof h<"u"&&h!==null&&(p[k]=h)}return{properties:p,measurements:m}}e.$Ao=t;const i=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(d){if(!d)return"none";const p=(0,A.$2k)(d);return i.has(p)?p:"other"}e.$Bo=r;function c(d,p,m=0,S){if(d)for(const k of Object.getOwnPropertyNames(d)){const h=d[k],w=S?S+k:k;Array.isArray(h)?p[w]=(0,y.$fn)(h):h instanceof Date?p[w]=h.toISOString():(0,T.$Ef)(h)?m<2?c(h,p,m+1,w+"."):p[w]=(0,y.$fn)(h):p[w]=h}}function o(d,p){const m=d.msftInternalDomains||[],S=p.getValue("telemetry.internalTesting");return(0,$.$oo)(m)||S}e.$Co=o;function l(d){return[d.appRoot,d.extensionsPath,d.userHome.fsPath,d.tmpDir.fsPath,d.userDataPath]}e.$Do=l;function n(d,p){if(!d||!d.includes("/")&&!d.includes("\\"))return d;let m=d;const S=[];for(const I of p)for(;;){const F=I.exec(d);if(!F)break;S.push([F.index,I.lastIndex])}const k=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,h=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let w=0;for(m="";;){const I=h.exec(d);if(!I)break;const F=S.some(([V,Z])=>I.index<Z&&V<h.lastIndex);!k.test(I[0])&&!F&&(m+=d.substring(w,I.index)+"<REDACTED: user-file-path>",w=h.lastIndex)}return w<d.length&&(m+=d.substr(w)),m}function s(d){if(!d)return d;const p=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const m of p)if(m.regex.test(d))return`<REDACTED: ${m.label}>`;return d}function a(d,p){return(0,y.$cn)(d,m=>{if(m instanceof f||Object.hasOwnProperty.call(m,"isTrustedTelemetryValue"))return m.value;if(typeof m=="string"){let S=m.replaceAll("%20"," ");S=n(S,p);for(const k of p)S=S.replace(k,"");return S=s(S),S}})}e.$Eo=a}),define(Pe[193],Ae([1,0,12,96,22,21,2,11,74,56]),function(we,e,y,T,P,M,A,$,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=void 0;function C(a,d){return a.uuid&&d.uuid?a.uuid===d.uuid:a.id===d.id?!0:(0,y.$1e)(a.id,d.id)===0}e.$Fo=C;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(d){const p=d.manifest?d.manifest.version:d.version,m=d.manifest?d.targetPlatform:d.properties.targetPlatform;return new u(d.identifier,p,m)}static parse(d){const p=D.exec(d);return p&&p[1]&&p[2]?new u({id:p[1]},p[2],p[4]||void 0):null}constructor(d,p,m="undefined"){this.version=p,this.targetPlatform=m,this.id=d.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(d){return d instanceof u?C(this,d)&&this.version===d.version&&this.targetPlatform===d.targetPlatform:!1}}e.$Go=u;const b=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(a){const d=b.exec(a);return d&&d[1]?[t(d[1]),d[2]]:[t(a),void 0]}e.$Ho=v;function g(a,d){return`${a}.${d}`}e.$Io=g;function t(a){return a.toLowerCase()}e.$Jo=t;function i(a,d){return t(g(a??P.$8l,d))}e.$Ko=i;function r(a,d){const p=[],m=S=>{for(const k of p)if(k.some(h=>C(d(h),d(S))))return k;return null};for(const S of a){const k=m(S);k?k.push(S):p.push([S])}return p}e.$Lo=r;function c(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}e.$Mo=c;function o(a){return{id:new f.$po(a.identifier.id),name:new f.$po(a.name),galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,isPreReleaseVersion:a.properties.isPreReleaseVersion,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),isSigned:a.isSigned,...a.telemetryData}}e.$No=o,e.$Oo=new P.$_l("pprice.better-merge");function l(a,d){const p=[],m=d.manifest.extensionDependencies?.slice(0)??[];for(;m.length;){const S=m.shift();if(S&&p.every(k=>!C(k.identifier,{id:S}))){const k=a.filter(h=>C(h.identifier,{id:S}));k.length===1&&(p.push(k[0]),m.push(...k[0].manifest.extensionDependencies?.slice(0)??[]))}}return p}e.$Po=l;async function n(a,d){if(!M.$k)return!1;let p;try{p=(await a.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{p=(await a.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(S){d.debug("Error while getting the os-release file.",(0,$.$9)(S))}}return!!p&&(p.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(a,d){const p=await n(a,d),m=(0,T.$_n)(p?"alpine":M.$u,E.$dc);return d.debug("ComputeTargetPlatform:",m),m}e.$Qo=s}),define(Pe[194],Ae([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=e.$ur=e.$tr=e.$sr=e.$rr=e.$qr=void 0;function y(E){return[...E.entries()]}e.$qr=y;function T(E){return E?[...E.entries()]:[]}e.$rr=T;function P(E){return new Map(E)}e.$sr=P;function M(E){return new Map(E??[])}e.$tr=M;function A(E){return Array.from(E.entries()).map(f=>[f[0],y(f[1].map),T(f[1].descriptionMap)])}e.$ur=A;function $(E){return new Map(E.map(f=>[f[0],{map:P(f[1]),descriptionMap:M(f[2])}]))}e.$vr=$}),define(Pe[195],Ae([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nqb=void 0;class y{constructor(P){this.b=P,this.a=new Map}dispose(){for(const P of this.a.values())P.dispose()}startBuffering(P,M,A=5){const $=M(E=>{const f=typeof E=="string"?E:E.data;let C=this.a.get(P);if(C){C.data.push(f);return}const D=setTimeout(()=>this.flushBuffer(P),A);C={data:[f],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(P),$.dispose()}},this.a.set(P,C)});return $}stopBuffering(P){this.a.get(P)?.dispose()}flushBuffer(P){const M=this.a.get(P);M&&(this.a.delete(P),this.b(P,M.data.join("")))}}e.$nqb=y}),define(Pe[196],Ae([1,0,14,90,45,5,16,2,155,73,30]),function(we,e,y,T,P,M,A,$,E,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hw=e.$gw=e.$fw=e.$ew=e.$dw=e.$cw=e.$bw=e.$aw=e.IconFontDefinition=e.IconContribution=e.$_v=void 0,e.$_v={IconContribution:"base.contributions.icons"};var D;(function(o){function l(n,s){let a=n.defaults;for(;P.ThemeIcon.isThemeIcon(a);){const d=v.getIcon(a.id);if(!d)return;a=d.defaults}return a}o.getDefinition=l})(D||(e.IconContribution=D={}));var u;(function(o){function l(s){return{weight:s.weight,style:s.style,src:s.src.map(a=>({format:a.format,location:a.location.toString()}))}}o.toJSONObject=l;function n(s){const a=d=>(0,A.$Cf)(d)?d:void 0;if(s&&Array.isArray(s.src)&&s.src.every(d=>(0,A.$Cf)(d.format)&&(0,A.$Cf)(d.location)))return{weight:a(s.weight),style:a(s.style),src:s.src.map(d=>({format:d.format,location:$.URI.parse(d.location)}))}}o.fromJSONObject=n})(u||(e.IconFontDefinition=u={}));class b{constructor(){this.a=new M.$Rd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${P.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(l,n,s,a){const d=this.b[l];if(d){if(s&&!d.description){d.description=s,this.d.properties[l].markdownDescription=`${s} $(${l})`;const S=this.e.enum.indexOf(l);S!==-1&&(this.e.enumDescriptions[S]=s),this.a.fire()}return d}const p={id:l,description:s,defaults:n,deprecationMessage:a};this.b[l]=p;const m={$ref:"#/definitions/icons"};return a&&(m.deprecationMessage=a),s&&(m.markdownDescription=`${s}: $(${l})`),this.d.properties[l]=m,this.e.enum.push(l),this.e.enumDescriptions.push(s||""),this.a.fire(),{id:l}}deregisterIcon(l){delete this.b[l],delete this.d.properties[l];const n=this.e.enum.indexOf(l);n!==-1&&(this.e.enum.splice(n,1),this.e.enumDescriptions.splice(n,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(l=>this.b[l])}getIcon(l){return this.b[l]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(l,n){const s=this.f[l];return s||(this.f[l]=n,this.a.fire(),n)}deregisterIconFont(l){delete this.f[l]}getIconFont(l){return this.f[l]}toString(){const l=(d,p)=>d.id.localeCompare(p.id),n=d=>{for(;P.ThemeIcon.isThemeIcon(d.defaults);)d=this.b[d.defaults.id];return`codicon codicon-${d?d.id:""}`},s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const a=Object.keys(this.b).map(d=>this.b[d]);for(const d of a.filter(p=>!!p.description).sort(l))s.push(`|<i class="${n(d)}"></i>|${d.id}|${P.ThemeIcon.isThemeIcon(d.defaults)?d.defaults.id:d.id}|${d.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const d of a.filter(p=>!P.ThemeIcon.isThemeIcon(p.defaults)).sort(l))s.push(`|<i class="${n(d)}"></i>|${d.id}|`);return s.join(`
`)}}const v=new b;C.$mn.add(e.$_v.IconContribution,v);function g(o,l,n,s){return v.registerIcon(o,l,n,s)}e.$aw=g;function t(){return v}e.$bw=t;function i(){const o=(0,T.$Yj)();for(const l in o){const n="\\"+o[l].toString(16);v.registerIcon(l,{fontCharacter:n})}}i(),e.$cw="vscode://schemas/icons";const r=C.$mn.as(f.$nn.JSONContribution);r.registerSchema(e.$cw,v.getIconSchema());const c=new y.$0g(()=>r.notifySchemaChanged(e.$cw),200);v.onDidChange(()=>{c.isScheduled()||c.schedule()}),e.$dw=g("widget-close",T.$1j.close,(0,E.localize)(2,null)),e.$ew=g("goto-previous-location",T.$1j.arrowUp,(0,E.localize)(3,null)),e.$fw=g("goto-next-location",T.$1j.arrowDown,(0,E.localize)(4,null)),e.$gw=P.ThemeIcon.modify(T.$1j.sync,"spin"),e.$hw=P.ThemeIcon.modify(T.$1j.loading,"spin")}),define(Pe[197],Ae([1,0,5,40,4,15]),function(we,e,y,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nv=e.$mv=e.$lv=e.$kv=e.$jv=e.$iv=e.$hv=e.$gv=e.ProvidedOnAutoForward=e.$fv=e.TunnelPrivacyId=e.TunnelProtocol=e.$ev=e.$dv=void 0,e.$dv=(0,P.$Vh)("tunnelService"),e.$ev=(0,P.$Vh)("sharedTunnelsService");var A;(function(t){t.Http="http",t.Https="https"})(A||(e.TunnelProtocol=A={}));var $;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})($||(e.TunnelPrivacyId=$={}));function E(t){return!!t.forwardPort}e.$fv=E;var f;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(f||(e.ProvidedOnAutoForward=f={}));function C(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(i)return{address:i[1],port:+i[2]}}e.$gv=C,e.$hv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function D(t){return e.$hv.indexOf(t)>=0}e.$iv=D,e.$jv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function u(t){return e.$jv.indexOf(t)>=0}e.$kv=u;function b(t,i,r,c){if(r===1)return!1;if(r===2&&u(i)){const o=/(\d+)\.(\d+)\.(\d+)/g.exec(c);if(o?.length===4&&parseInt(o[1])>=18)return!1}return t<1024}e.$lv=b;class v{constructor(i,r,c){this.remoteAddress=i,this.localAddress=r,this.b=c,this.a=new y.$Rd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$mv=v;let g=class{constructor(i,r){this.j=i,this.k=r,this.a=new y.$Rd,this.onTunnelOpened=this.a.event,this.b=new y.$Rd,this.onTunnelClosed=this.b.event,this.c=new y.$Rd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const i=this.k.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.h=i.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const i=[],r=Array.from(this.e.values());for(const c of r){const o=Array.from(c.values());for(const l of o){const n=await l.value;n&&typeof n!="string"&&i.push(n)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:r}of i.values())await r.then(c=>typeof c!="string"?c?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,r,c,o,l){this.p(i,r,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:r,localAddress:c,privacy:o,protocol:l,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,r){(u(i)||D(i))&&(i=e.$hv[0]);const c=this.r(i,r);if(c)return++c.refcount,c.value}openTunnel(i,r,c,o,l,n=!1,s,a){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${r}:${c} on local port ${l}.`);const d=this.f??i;if(!d)return;if(r||(r="localhost"),o||(o=this.l),this.f&&this.i.has(c)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const p=this.s(d,r,c,o,l,n,s,a);return p?p.then(m=>{if(m){if(typeof m=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(r,c),m}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(r,c);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const S=this.n(m);return(m.tunnelRemoteHost!==r||m.tunnelRemotePort!==c)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),s&&m.privacy!==s&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(S),S}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),p)}n(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const r=this.e.get(i.tunnelRemoteHost);if(r){const c=r.get(i.tunnelRemotePort);c&&(c.refcount--,await this.o(i.tunnelRemoteHost,i.tunnelRemotePort,c))}}}}async o(i,r,c){if(c.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${r}.`);const o=c.value.then(async l=>{l&&typeof l!="string"&&(await l.dispose(!0),this.b.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(r),o}}async closeTunnel(i,r){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${r} `);const c=this.e.get(i);if(c&&c.has(r)){const o=c.get(r);o.refcount=0,await this.o(i,r,o)}}p(i,r,c){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(r,{refcount:1,value:c})}async q(i,r){const c=this.e.get(i);if(c){const o=c.get(r),l=o?await o.value:void 0;(!l||typeof l=="string")&&c.delete(r),c.size===0&&this.e.delete(i)}}r(i,r){const c=[i];D(i)?(c.push(...e.$hv),c.push(...e.$jv)):u(i)&&c.push(...e.$jv);const o=c.map(l=>this.e.get(l));for(const l of o){const n=l?.get(r);if(n)return n}}canTunnel(i){return!!C(i)}t(i,r,c,o,l,n,s){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${r}:${c} on local port ${o}.`);const a=c;this.i.add(a);const d=o===void 0?c:o,p={elevationRequired:l?this.isPortPrivileged(d):!1},m={remoteAddress:{host:r,port:c},localAddressPort:o,privacy:n,public:n?n!==$.Private:void 0,protocol:s},S=i.forwardPort(m,p);return S?(this.p(r,c,S),S.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(a)})):this.i.delete(a),S}};e.$nv=g,e.$nv=g=Ke([Ve(0,M.$dj),Ve(1,T.$pi)],g)}),define(Pe[198],Ae([1,0,4]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$ov=void 0,e.$ov=(0,y.$Vh)("editSessionIdentityService");var T;(function(P){P[P.Complete=100]="Complete",P[P.Partial=50]="Partial",P[P.None=0]="None"})(T||(e.EditSessionIdentityMatch=T={}))}),define(Pe[199],Ae([1,0,13]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_J=e.$$J=e.$0J=e.$9J=e.$8J=void 0;function T(E){return E.scheme!==y.Schemas.file&&E.scheme!==y.Schemas.vscodeRemote}e.$8J=T;function P(E){if(E.folders.length)return E.folders.every(f=>T(f.uri))?E.folders[0].uri:void 0;if(E.configuration&&T(E.configuration))return E.configuration}e.$9J=P;function M(E){return P(E)?.scheme}e.$0J=M;function A(E){return P(E)?.authority}e.$$J=A;function $(E){return P(E)!==void 0}e.$_J=$}),define(Pe[47],Ae([1,0,156,20,50,25,2,4,13]),function(we,e,y,T,P,M,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.WorkbenchState=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=void 0,e.$5h=(0,$.$Vh)("contextService");function f(d){const p=d;return typeof p?.id=="string"&&A.URI.isUri(p.uri)}e.$6h=f;function C(d){return typeof d?.id=="string"&&!f(d)&&!u(d)}e.$7h=C,e.$8h={id:"ext-dev"},e.$9h={id:"empty-window"};function D(d,p){if(typeof d=="string"||typeof d>"u")return typeof d=="string"?{id:(0,T.$mc)(d)}:p?e.$8h:e.$9h;const m=d;return m.configuration?{id:m.id,configPath:m.configuration}:m.folders.length===1?{id:m.id,uri:m.folders[0].uri}:{id:m.id}}e.$0h=D;function u(d){const p=d;return typeof p?.id=="string"&&A.URI.isUri(p.configPath)}e.$$h=u;function b(d){const p=d;if(p?.uri)return{id:p.id,uri:A.URI.revive(p.uri)};const m=d;if(m?.configPath)return{id:m.id,configPath:A.URI.revive(m.configPath)};if(d?.id)return{id:d.id}}e.$_h=b;var v;(function(d){d[d.EMPTY=1]="EMPTY",d[d.FOLDER=2]="FOLDER",d[d.WORKSPACE=3]="WORKSPACE"})(v||(e.WorkbenchState=v={}));function g(d){const p=d;return!!(p&&typeof p=="object"&&typeof p.id=="string"&&Array.isArray(p.folders))}e.$ai=g;function t(d){const p=d;return!!(p&&typeof p=="object"&&A.URI.isUri(p.uri)&&typeof p.name=="string"&&typeof p.toResource=="function")}e.$bi=t;class i{constructor(p,m,S,k,h){this.h=p,this.j=S,this.k=k,this.l=h,this.c=P.$2h.forUris(this.l,()=>!0),this.folders=m}update(p){this.h=p.id,this.k=p.configuration,this.j=p.transient,this.l=p.l,this.folders=p.folders}get folders(){return this.g}set folders(p){this.g=p,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(p){this.k=p}getFolder(p){return p&&this.c.findSubstr(p)||null}n(){this.c=P.$2h.forUris(this.l,()=>!0);for(const p of this.folders)this.c.set(p.uri,p)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$ci=i;class r{constructor(p,m){this.raw=m,this.uri=p.uri,this.index=p.index,this.name=p.name}toResource(p){return(0,M.$zg)(this.uri,p)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$di=r;function c(d){return new r({uri:d,index:0,name:(0,M.$vg)(d)},{uri:d.toString()})}e.$ei=c,e.$fi="code-workspace",e.$gi=`.${e.$fi}`,e.$hi=[{name:(0,y.localize)(0,null),extensions:[e.$fi]}],e.$ii="workspace.json";function o(d,p){return M.$qg.isEqualOrParent(d,p.untitledWorkspacesHome)}e.$ji=o;function l(d){let p;return A.URI.isUri(d)?p=d:p=d.configuration,p?.scheme===E.Schemas.tmp}e.$ki=l,e.$li="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function n(d){return d.id===e.$li}e.$mi=n;function s(d,p){return!o(d,p)&&!l(d)}e.$ni=s;function a(d){return(typeof d=="string"?(0,T.$nc)(d):(0,M.$xg)(d))===e.$gi}e.$oi=a}),define(Pe[75],Ae([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rdc=void 0;class y{static{this.a=!1}constructor(P){this.d=P,this.b=new Map,this.c=1}add(P){const M=this.c++;return this.b.set(M,P),this.e(),M}get(P,M){return this.b.has(P)?this.b.get(P)[M]:void 0}delete(P){this.b.delete(P),this.e()}e(){y.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Rdc=y}),define(Pe[42],Ae([1,0,13,25,4]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vdc=e.$Udc=void 0;class M{constructor(){this.a=new Set(Object.keys(y.Schemas)),this.b=new Map,this.extUri=new T.$og($=>{const E=this.b.get($.scheme);return!(E===void 0||E&1024)})}$acceptProviderInfos($,E){E===null?this.b.delete($.scheme):this.b.set($.scheme,E)}isFreeScheme($){return!this.b.has($)&&!this.a.has($)}getCapabilities($){return this.b.get($)}}e.$Udc=M,e.$Vdc=(0,P.$Vh)("IExtHostFileSystemInfo")}),define(Pe[27],Ae([1,0,4]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QM=void 0,e.$QM=(0,y.$Vh)("IExtHostInitDataService")}),define(Pe[200],Ae([1,0,161,15,187,27]),function(we,e,y,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2fc=void 0;let A=class extends P.$XN{constructor(E,f,C){const D=C.remote.isRemote?"remoteexthost":E?"workerexthost":"exthost",u=C.remote.isRemote?(0,y.localize)(0,null):E?(0,y.localize)(1,null):(0,y.localize)(2,null);super(f.createLogger(D,{name:u}))}};e.$2fc=A,e.$2fc=A=Ke([Ve(1,T.$ej),Ve(2,M.$QM)],A)}),define(Pe[201],Ae([1,0,14]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eec=e.$Dec=void 0;class T{constructor(A,$,E){this.h=new Map,this.a=A,this.b=$,this.c=E,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(f=>(this.f=f,this)),this.g=this.c.onDidChangeStorage(f=>{f.shared===this.b&&f.key===this.a&&(this.f=f.value)}),this.i=new y.$0g(()=>{const f=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const C of f.values())C.complete()}catch(C){for(const D of f.values())D.error(C)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,$){let E=this.f[A];return typeof E>"u"&&(E=$),E}update(A,$){this.f[A]=$;const E=this.h.get(A);if(E!==void 0)return E.p;const f=new y.$ih;return this.h.set(A,f),this.i.isScheduled()||this.i.schedule(),f.p}dispose(){this.g.dispose()}}e.$Dec=T;class P extends T{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,$){super(A.identifier.value,!0,$),this.j=A}}e.$Eec=P}),define(Pe[202],Ae([1,0,5,2]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rfc=void 0;class P{constructor(A){this.c=A,this.a=new y.$Rd,this.onDidSaveNotebookDocument=this.a.event,this.b=new y.$Rd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,$,E,f){const D=this.c.getNotebookDocument(T.URI.revive(A)).acceptModelChanged($.value,E,f);this.b.fire(D)}$acceptDirtyStateChanged(A,$){this.c.getNotebookDocument(T.URI.revive(A)).acceptDirty($)}$acceptModelSaved(A){const $=this.c.getNotebookDocument(T.URI.revive(A));this.a.fire($.apiNotebook)}}e.$rfc=P}),define(Pe[17],Ae([1,0,4]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BM=e.$AM=void 0,e.$AM=(0,y.$Vh)("IExtHostRpcService");class T{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.$BM=T}),define(Pe[203],Ae([1,0,22,5]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lec=void 0;class P{#e;constructor(A,$){this.b=new T.$Rd,this.onDidChange=this.b.event,this.a=y.$_l.toKey(A.identifier),this.#e=$,this.#e.onDidChangePassword(E=>{E.extensionId===this.a&&this.b.fire({key:E.key})})}get(A){return this.#e.get(this.a,A)}store(A,$){return this.#e.store(this.a,A,$)}delete(A){return this.#e.delete(this.a,A)}}e.$Lec=P}),define(Pe[57],Ae([1,0,4]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cec=e.$bec=void 0,e.$bec=(0,y.$Vh)("IURITransformerService");class T{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$cec=T}),define(Pe[204],Ae([1,0,24]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gcb=e.$Fcb=void 0;class T{constructor(){this.buffers=[]}add(E){let f=this.buffers.indexOf(E);return f<0&&(f=this.buffers.length,this.buffers.push(E)),f}}function P($,E){if(E.serializeBuffersForPostMessage){const f=new T,D=JSON.stringify($,(b,v)=>{if(v instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:f.add(v)};if(ArrayBuffer.isView(v)){const g=M(v);if(g)return{$$vscode_array_buffer_reference$$:!0,index:f.add(v.buffer),view:{type:g,byteLength:v.byteLength,byteOffset:v.byteOffset}}}return v}),u=f.buffers.map(b=>{const v=new Uint8Array(b);return y.$fe.wrap(v)});return{message:D,buffers:u}}else return{message:JSON.stringify($),buffers:[]}}e.$Fcb=P;function M($){switch($.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A($,E){const f=E.map(u=>{const b=new ArrayBuffer(u.byteLength);return new Uint8Array(b).set(u.buffer),b}),C=E.length?(u,b)=>{if(b&&typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const v=b,{index:g}=v,t=f[g];if(v.view)switch(v.view.type){case 1:return new Int8Array(t,v.view.byteOffset,v.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,v.view.byteOffset,v.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,v.view.byteOffset,v.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,v.view.byteOffset,v.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,v.view.byteOffset,v.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,v.view.byteOffset,v.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,v.view.byteOffset,v.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,v.view.byteOffset,v.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,v.view.byteOffset,v.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,v.view.byteOffset,v.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,v.view.byteOffset,v.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return b}:void 0;return{message:JSON.parse($,C),arrayBuffers:f}}e.$Gcb=A}),define(Pe[102],Ae([1,0,171,16,2,6,4,30,41,13,39,134,31]),function(we,e,y,T,P,M,A,$,E,f,C,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BE=e.$AE=e.$zE=e.EditorsOrder=e.$yE=e.CloseDirection=e.$xE=e.$wE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$vE=e.$uE=e.$tE=e.$sE=e.$rE=e.$qE=e.$pE=e.$oE=e.EditorInputCapabilities=e.$nE=e.SaveReason=e.Verbosity=e.$mE=e.$lE=e.$kE=e.$jE=e.$iE=e.$hE=e.$gE=e.$fE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$eE=e.$dE=e.$cE=e.$bE=e.$aE=void 0,e.$aE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$bE={id:"default",displayName:(0,y.localize)(0,null),providerDisplayName:(0,y.localize)(1,null)},e.$cE="workbench.editor.sidebysideEditor",e.$dE="workbench.editors.textDiffEditor",e.$eE="workbench.editors.binaryResourceDiffEditor";var b;(function(se){se[se.PROGRAMMATIC=1]="PROGRAMMATIC",se[se.USER=2]="USER",se[se.EDIT=3]="EDIT",se[se.NAVIGATION=4]="NAVIGATION",se[se.JUMP=5]="JUMP"})(b||(e.EditorPaneSelectionChangeReason=b={}));var v;(function(se){se[se.IDENTICAL=1]="IDENTICAL",se[se.SIMILAR=2]="SIMILAR",se[se.DIFFERENT=3]="DIFFERENT"})(v||(e.EditorPaneSelectionCompareResult=v={}));function g(se){const Q=se;return!!Q&&typeof Q.getSelection=="function"&&!!Q.onDidChangeSelection}e.$fE=g;function t(se,Q,B){for(const ne of B.visibleEditorPanes)if(ne.group.id===Q&&se.matches(ne.input))return ne.getViewState()}e.$gE=t;function i(se){if(S(se))return!1;const Q=se;return P.URI.isUri(Q?.resource)}e.$hE=i;function r(se){if(S(se))return!1;const Q=se;return Q?.original!==void 0&&Q.modified!==void 0}e.$iE=r;function c(se){if(S(se))return!1;const Q=se;return Array.isArray(Q?.resources)}e.$jE=c;function o(se){if(S(se)||r(se))return!1;const Q=se;return Q?.primary!==void 0&&Q.secondary!==void 0}e.$kE=o;function l(se){if(S(se))return!1;const Q=se;return Q?Q.resource===void 0||Q.resource.scheme===f.Schemas.untitled||Q.forceUntitled===!0:!1}e.$lE=l;function n(se){if(S(se))return!1;const Q=se;return P.URI.isUri(Q?.base?.resource)&&P.URI.isUri(Q?.input1?.resource)&&P.URI.isUri(Q?.input2?.resource)&&P.URI.isUri(Q?.result?.resource)}e.$mE=n;var s;(function(se){se[se.SHORT=0]="SHORT",se[se.MEDIUM=1]="MEDIUM",se[se.LONG=2]="LONG"})(s||(e.Verbosity=s={}));var a;(function(se){se[se.EXPLICIT=1]="EXPLICIT",se[se.AUTO=2]="AUTO",se[se.FOCUS_CHANGE=3]="FOCUS_CHANGE",se[se.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(a||(e.SaveReason=a={}));class d{constructor(){this.a=new Map}registerSource(Q,B){let ne=this.a.get(Q);return ne||(ne={source:Q,label:B},this.a.set(Q,ne)),ne.source}getSourceLabel(Q){return this.a.get(Q)?.label??Q}}e.$nE=new d;var p;(function(se){se[se.None=0]="None",se[se.Readonly=2]="Readonly",se[se.Untitled=4]="Untitled",se[se.Singleton=8]="Singleton",se[se.RequiresTrust=16]="RequiresTrust",se[se.CanSplitInGroup=32]="CanSplitInGroup",se[se.ForceDescription=64]="ForceDescription",se[se.CanDropIntoEditor=128]="CanDropIntoEditor",se[se.MultipleEditors=256]="MultipleEditors",se[se.Scratchpad=512]="Scratchpad",se[se.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(p||(e.EditorInputCapabilities=p={}));class m extends M.$Rc{}e.$oE=m;function S(se){return se instanceof m}e.$pE=S;function k(se){const Q=se;return P.URI.isUri(Q?.preferredResource)}function h(se){const Q=se;return S(Q?.primary)&&S(Q?.secondary)}e.$qE=h;function w(se){const Q=se;return S(Q?.modified)&&S(Q?.original)}e.$rE=w;function I(se,Q,B,ne,pe){return Re(ne,[(0,D.$Fi)({id:"workbench.action.openLargeFile",label:(0,y.localize)(2,null),run:()=>{const re={...B,limits:{size:Number.MAX_VALUE}};se.openEditor(Q,re)}}),(0,D.$Fi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,y.localize)(3,null),run:()=>pe.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}e.$sE=I;function F(se){return S(se?.editor)}e.$tE=F;function V(se){const Q=se;return F(se)&&Q?.group!==void 0}e.$uE=V;function Z(se){const Q=se;return typeof Q?.groupId=="number"&&S(Q.editor)}e.$vE=Z;var N;(function(se){se[se.UNKNOWN=0]="UNKNOWN",se[se.REPLACE=1]="REPLACE",se[se.MOVE=2]="MOVE",se[se.UNPIN=3]="UNPIN"})(N||(e.EditorCloseContext=N={}));var R;(function(se){se[se.GROUP_ACTIVE=0]="GROUP_ACTIVE",se[se.GROUP_INDEX=1]="GROUP_INDEX",se[se.GROUP_LABEL=2]="GROUP_LABEL",se[se.GROUP_LOCKED=3]="GROUP_LOCKED",se[se.EDITOR_OPEN=4]="EDITOR_OPEN",se[se.EDITOR_CLOSE=5]="EDITOR_CLOSE",se[se.EDITOR_MOVE=6]="EDITOR_MOVE",se[se.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",se[se.EDITOR_LABEL=8]="EDITOR_LABEL",se[se.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",se[se.EDITOR_PIN=10]="EDITOR_PIN",se[se.EDITOR_STICKY=11]="EDITOR_STICKY",se[se.EDITOR_DIRTY=12]="EDITOR_DIRTY",se[se.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(R||(e.GroupModelChangeKind=R={}));var L;(function(se){se[se.PRIMARY=1]="PRIMARY",se[se.SECONDARY=2]="SECONDARY",se[se.BOTH=3]="BOTH",se[se.ANY=4]="ANY"})(L||(e.SideBySideEditor=L={}));class O{getOriginalUri(Q,B){if(!Q)return;if(n(Q))return e.$xE.getOriginalUri(Q.result,B);if(B?.supportSideBySide){const{primary:pe,secondary:re}=this.a(Q);if(pe&&re){if(B?.supportSideBySide===L.BOTH)return{primary:this.getOriginalUri(pe,{filterByScheme:B.filterByScheme}),secondary:this.getOriginalUri(re,{filterByScheme:B.filterByScheme})};if(B?.supportSideBySide===L.ANY)return this.getOriginalUri(pe,{filterByScheme:B.filterByScheme})??this.getOriginalUri(re,{filterByScheme:B.filterByScheme});Q=B.supportSideBySide===L.PRIMARY?pe:re}}if(r(Q)||c(Q)||o(Q)||n(Q))return;const ne=k(Q)?Q.preferredResource:Q.resource;return!ne||!B||!B.filterByScheme?ne:this.b(ne,B.filterByScheme)}a(Q){return h(Q)||o(Q)?{primary:Q.primary,secondary:Q.secondary}:w(Q)||r(Q)?{primary:Q.modified,secondary:Q.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(Q,B){if(!Q)return;if(n(Q))return e.$xE.getCanonicalUri(Q.result,B);if(B?.supportSideBySide){const{primary:pe,secondary:re}=this.a(Q);if(pe&&re){if(B?.supportSideBySide===L.BOTH)return{primary:this.getCanonicalUri(pe,{filterByScheme:B.filterByScheme}),secondary:this.getCanonicalUri(re,{filterByScheme:B.filterByScheme})};if(B?.supportSideBySide===L.ANY)return this.getCanonicalUri(pe,{filterByScheme:B.filterByScheme})??this.getCanonicalUri(re,{filterByScheme:B.filterByScheme});Q=B.supportSideBySide===L.PRIMARY?pe:re}}if(r(Q)||c(Q)||o(Q)||n(Q))return;const ne=Q.resource;return!ne||!B||!B.filterByScheme?ne:this.b(ne,B.filterByScheme)}b(Q,B){if(Array.isArray(B)){if(B.some(ne=>Q.scheme===ne))return Q}else if(B===Q.scheme)return Q}}var Y;(function(se){se[se.UNKNOWN=0]="UNKNOWN",se[se.KEYBOARD=1]="KEYBOARD",se[se.MOUSE=2]="MOUSE"})(Y||(e.EditorCloseMethod=Y={}));function he(se,Q,B,ne){if(!se.isSticky(Q))return!1;switch(ne.preventPinnedEditorClose){case"keyboardAndMouse":return B===Y.MOUSE||B===Y.KEYBOARD;case"mouse":return B===Y.MOUSE;case"keyboard":return B===Y.KEYBOARD}return!1}e.$wE=he,e.$xE=new O;var $e;(function(se){se[se.LEFT=0]="LEFT",se[se.RIGHT=1]="RIGHT"})($e||(e.CloseDirection=$e={}));class De{constructor(){this.c=new Map,this.d=new Map}start(Q){const B=this.a=Q.get(A.$Uh);for(const[ne,pe]of this.c)this.e(ne,pe,B);this.c.clear()}e(Q,B,ne){const pe=ne.createInstance(B);this.d.set(Q,pe)}registerFileEditorFactory(Q){if(this.b)throw new Error("Can only register one file editor factory.");this.b=Q}getFileEditorFactory(){return(0,T.$Nf)(this.b)}registerEditorSerializer(Q,B){if(this.c.has(Q)||this.d.has(Q))throw new Error(`A editor serializer with type ID '${Q}' was already registered.`);return this.a?this.e(Q,B,this.a):this.c.set(Q,B),(0,M.$Pc)(()=>{this.c.delete(Q),this.d.delete(Q)})}getEditorSerializer(Q){return this.d.get(typeof Q=="string"?Q:Q.typeId)}}$.$mn.add(e.$aE.EditorFactory,new De);async function ke(se,Q,B){return!se||!se.length?[]:await Promise.all(se.map(async ne=>{const pe=P.URI.revive(ne.fileUri);if(!pe){B.info("Cannot resolve the path because it is not valid.",ne);return}if(!await Q.canHandleResource(pe)){B.info("Cannot resolve the path because it cannot be handled",ne);return}let le=ne.exists,ce=ne.type;if(typeof le!="boolean"||typeof ce!="number")try{ce=(await Q.stat(pe)).isDirectory?E.FileType.Directory:E.FileType.Unknown,le=!0}catch(_){B.error(_),le=!1}if(!le&&ne.openOnlyIfExists){B.info("Cannot resolve the path because it does not exist",ne);return}if(ce===E.FileType.Directory){B.info("Cannot resolve the path because it is a directory",ne);return}const ye={...ne.options,pinned:!0};return le?{resource:pe,options:ye}:{resource:pe,options:ye,forceUntitled:!0}}))}e.$yE=ke;var fe;(function(se){se[se.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",se[se.SEQUENTIAL=1]="SEQUENTIAL"})(fe||(e.EditorsOrder=fe={}));function ve(se){const Q=se;if(!Q)return!1;const B=Q;if(B.modified)return ve(B.modified);const ne=Q;return!!(ne.contributionsState&&ne.viewState&&Array.isArray(ne.cursorState))}e.$zE=ve;function te(se){return(0,C.$Hi)(se)}e.$AE=te;function Re(se,Q,B){const ne=(0,C.$Ii)(se,Q);return ne.forceMessage=B?.forceMessage,ne.forceSeverity=B?.forceSeverity,ne.allowDialog=B?.allowDialog,ne}e.$BE=Re}),define(Pe[205],Ae([1,0,5,172,4,6,28,30,18,26,90,196]),function(we,e,y,T,P,M,A,$,E,f,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KE=e.$JE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$IE=e.$HE=e.ViewContentGroups=e.$GE=e.$FE=e.ViewContainerLocation=e.Extensions=e.$EE=e.$DE=e.$CE=void 0,e.$CE="views",e.$DE=(0,T.localize)(0,null),e.$EE=(0,D.$aw)("default-view-icon",C.$1j.window,(0,T.localize)(1,null));var u;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(u||(e.Extensions=u={}));var b;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})(b||(e.ViewContainerLocation=b={})),e.$FE=[0,1,2];function v(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$GE=v;class g extends M.$Rc{constructor(){super(...arguments),this.c=this.B(new y.$Rd),this.onDidRegister=this.c.event,this.f=this.B(new y.$Rd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,E.$Qb)([...this.g.values()])}registerViewContainer(a,d,p){const m=this.get(a.id);if(m)return m;const S=a;return S.openCommandActionDescriptor=p?.doNotRegisterOpenCommand?void 0:S.openCommandActionDescriptor??{id:S.id},(0,A.$wc)(this.g,d,[]).push(S),p?.isDefault&&this.h.push(S),this.c.fire({viewContainer:S,viewContainerLocation:d}),S}deregisterViewContainer(a){for(const d of this.g.keys()){const p=this.g.get(d),m=p?.indexOf(a);if(m!==-1){p?.splice(m,1),p.length===0&&this.g.delete(d),this.f.fire({viewContainer:a,viewContainerLocation:d});return}}}get(a){return this.all.filter(d=>d.id===a)[0]}getViewContainers(a){return[...this.g.get(a)||[]]}getViewContainerLocation(a){return[...this.g.keys()].filter(d=>this.getViewContainers(d).filter(p=>p?.id===a.id).length>0)[0]}getDefaultViewContainer(a){return this.h.find(d=>this.getViewContainerLocation(d)===a)}}$.$mn.add(u.ViewContainersRegistry,new g);var t;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(t||(e.ViewContentGroups=t={}));function i(s,a){const d=s.group??t.More,p=a.group??t.More;return d!==p?d.localeCompare(p):(s.order??5)-(a.order??5)}class r extends M.$Rc{constructor(){super(...arguments),this.c=this.B(new y.$Rd),this.onViewsRegistered=this.c.event,this.f=this.B(new y.$Rd),this.onViewsDeregistered=this.f.event,this.g=this.B(new y.$Rd),this.onDidChangeContainer=this.g.event,this.h=this.B(new y.$Rd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Fc}registerViews(a,d){this.registerViews2([{views:a,viewContainer:d}])}registerViews2(a){a.forEach(({views:d,viewContainer:p})=>this.r(d,p)),this.c.fire(a)}deregisterViews(a,d){const p=this.s(a,d);p.length&&this.f.fire({views:p,viewContainer:d})}moveViews(a,d){for(const p of this.m.keys())if(p!==d){const m=this.s(a,p);m.length&&(this.r(m,d),this.g.fire({views:m,from:p,to:d}))}}getViews(a){return this.m.get(a)||[]}getView(a){for(const d of this.j){const p=(this.m.get(d)||[]).filter(m=>m.id===a)[0];if(p)return p}return null}getViewContainer(a){for(const d of this.j)if((this.m.get(d)||[]).filter(m=>m.id===a)[0])return d;return null}registerViewWelcomeContent(a,d){return this.n.add(a,d),this.h.fire(a),(0,M.$Pc)(()=>{this.n.delete(a,d),this.h.fire(a)})}registerViewWelcomeContent2(a,d){const p=new Map;for(const[m,S]of d)this.n.add(a,S),p.set(m,(0,M.$Pc)(()=>{this.n.delete(a,S),this.h.fire(a)}));return this.h.fire(a),p}getViewWelcomeContent(a){const d=[];return this.n.forEach(a,p=>d.push(p)),d.sort(i)}r(a,d){let p=this.m.get(d);p||(p=[],this.m.set(d,p),this.j.push(d));for(const m of a){if(this.getView(m.id)!==null)throw new Error((0,T.localize)(2,null,m.id));p.push(m)}}s(a,d){const p=this.m.get(d);if(!p)return[];const m=[],S=[];for(const k of p)a.includes(k)?m.push(k):S.push(k);return m.length&&(S.length?this.m.set(d,S):(this.m.delete(d),this.j.splice(this.j.indexOf(d),1))),m}}$.$mn.add(u.ViewsRegistry,new r),e.$HE=(0,P.$Vh)("viewsService"),e.$IE=(0,P.$Vh)("viewDescriptorService");var c;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(c||(e.ViewVisibilityState=c={}));var o;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(o||(e.TreeItemCollapsibleState=o={}));class l{constructor(a,d){this.c=!1,this.d=!1,(0,f.$dn)(this,a),this.d=!!d,this.resolve=async p=>{if(d&&!this.c){const m=await d(p);m&&(this.tooltip=this.tooltip??m.tooltip,this.command=this.command??m.command)}p.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$JE=l;class n extends Error{constructor(a){super((0,T.localize)(3,null,a)),this.name="NoTreeViewError"}static is(a){return a.name==="NoTreeViewError"}}e.$KE=n}),define(Pe[206],Ae([1,0,2,29,4]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_E=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$$E=e.$0E=void 0;function M(f){return!!f&&typeof f=="object"&&"uri"in f&&f.uri instanceof y.URI&&"version"in f&&typeof f.version=="number"&&"ranges"in f&&Array.isArray(f.ranges)&&f.ranges.every(T.$zs.isIRange)}e.$0E=M;function A(f){return!!f&&typeof f=="object"&&"documents"in f&&Array.isArray(f.documents)&&f.documents.every(M)}e.$$E=A;var $;(function(f){f[f.Down=0]="Down",f[f.Up=1]="Up"})($||(e.InteractiveSessionVoteDirection=$={}));var E;(function(f){f[f.Action=1]="Action",f[f.Toolbar=2]="Toolbar"})(E||(e.InteractiveSessionCopyKind=E={})),e.$_E=(0,P.$Vh)("IChatService")}),define(Pe[207],Ae([1,0,5,14,173]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_cb=void 0;class M{constructor(){this.f=new Map,this.k=[],this.m=new y.$Rd,this.n=new y.$Rd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage($){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=$}onEvent($){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=$}onRequest($){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=$}sendResponse($){$.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${$.command}`)):this.s("response",$)}sendRequest($,E,f,C){const D={command:$};if(E&&Object.keys(E).length>0&&(D.arguments=E),this.s("request",D),typeof C=="number"){const u=setTimeout(()=>{clearTimeout(u);const b=this.f.get(D.seq);if(b){this.f.delete(D.seq);const v={type:"response",seq:0,request_seq:D.seq,success:!1,command:$,message:(0,P.localize)(0,null,C,$)};b(v)}},C)}return f&&this.f.set(D.seq,f),D.seq}acceptMessage($){this.j?this.j($):(this.k.push($),this.k.length===1&&this.q())}o($,E){return $.type!=="event"||E.type!=="event"}async q(){let $;for(;this.k.length;){if((!$||this.o(this.k[0],$))&&await(0,T.$Yg)(0),$=this.k.shift(),!$)return;switch($.type){case"event":this.i?.($);break;case"request":this.g?.($);break;case"response":{const E=$,f=this.f.get(E.request_seq);f&&(this.f.delete(E.request_seq),f(E));break}}}}s($,E){E.type=$,E.seq=this.d++,this.sendMessage(E)}async u(){if(this.f.size===0)return Promise.resolve();const $=new Map;this.f.forEach((E,f)=>$.set(f,E)),await(0,T.$Yg)(500),$.forEach((E,f)=>{E({type:"response",seq:0,request_seq:f,success:!1,command:"canceled",message:"canceled"}),this.f.delete(f)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$_cb=M}),define(Pe[208],Ae([1,0,174,34,4]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$kH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$jH=e.MemoryRangeType=e.$iH=e.State=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=void 0,e.$fG="workbench.view.debug",e.$gG="workbench.debug.variablesView",e.$hG="workbench.debug.watchExpressionsView",e.$iG="workbench.debug.callStackView",e.$jG="workbench.debug.loadedScriptsView",e.$kG="workbench.debug.breakPointsView",e.$lG="workbench.debug.disassemblyView",e.$mG="workbench.panel.repl",e.$nG="workbench.panel.repl.view",e.$oG=new T.$aj("debugType",void 0,{type:"string",description:y.localize(0,null)}),e.$pG=new T.$aj("debugConfigurationType",void 0,{type:"string",description:y.localize(1,null)}),e.$qG=new T.$aj("debugState","inactive",{type:"string",description:y.localize(2,null)}),e.$rG="debugUx",e.$sG=new T.$aj(e.$rG,"default",{type:"string",description:y.localize(3,null)}),e.$tG=new T.$aj("hasDebugged",!1,{type:"boolean",description:y.localize(4,null)}),e.$uG=new T.$aj("inDebugMode",!1,{type:"boolean",description:y.localize(5,null)}),e.$vG=new T.$aj("inDebugRepl",!1,{type:"boolean",description:y.localize(6,null)}),e.$wG=new T.$aj("breakpointWidgetVisible",!1,{type:"boolean",description:y.localize(7,null)}),e.$xG=new T.$aj("inBreakpointWidget",!1,{type:"boolean",description:y.localize(8,null)}),e.$yG=new T.$aj("breakpointsFocused",!0,{type:"boolean",description:y.localize(9,null)}),e.$zG=new T.$aj("watchExpressionsFocused",!0,{type:"boolean",description:y.localize(10,null)}),e.$AG=new T.$aj("watchExpressionsExist",!1,{type:"boolean",description:y.localize(11,null)}),e.$BG=new T.$aj("variablesFocused",!0,{type:"boolean",description:y.localize(12,null)}),e.$CG=new T.$aj("expressionSelected",!1,{type:"boolean",description:y.localize(13,null)}),e.$DG=new T.$aj("breakpointInputFocused",!1,{type:"boolean",description:y.localize(14,null)}),e.$EG=new T.$aj("callStackItemType",void 0,{type:"string",description:y.localize(15,null)}),e.$FG=new T.$aj("callStackSessionIsAttach",!1,{type:"boolean",description:y.localize(16,null)}),e.$GG=new T.$aj("callStackItemStopped",!1,{type:"boolean",description:y.localize(17,null)}),e.$HG=new T.$aj("callStackSessionHasOneThread",!1,{type:"boolean",description:y.localize(18,null)}),e.$IG=new T.$aj("watchItemType",void 0,{type:"string",description:y.localize(19,null)}),e.$JG=new T.$aj("canViewMemory",void 0,{type:"boolean",description:y.localize(20,null)}),e.$KG=new T.$aj("breakpointItemType",void 0,{type:"string",description:y.localize(21,null)}),e.$LG=new T.$aj("breakpointSupportsCondition",!1,{type:"boolean",description:y.localize(22,null)}),e.$MG=new T.$aj("loadedScriptsSupported",!1,{type:"boolean",description:y.localize(23,null)}),e.$NG=new T.$aj("loadedScriptsItemType",void 0,{type:"string",description:y.localize(24,null)}),e.$OG=new T.$aj("focusedSessionIsAttach",!1,{type:"boolean",description:y.localize(25,null)}),e.$PG=new T.$aj("focusedSessionIsNoDebug",!1,{type:"boolean",description:y.localize(26,null)}),e.$QG=new T.$aj("stepBackSupported",!1,{type:"boolean",description:y.localize(27,null)}),e.$RG=new T.$aj("restartFrameSupported",!1,{type:"boolean",description:y.localize(28,null)}),e.$SG=new T.$aj("stackFrameSupportsRestart",!1,{type:"boolean",description:y.localize(29,null)}),e.$TG=new T.$aj("jumpToCursorSupported",!1,{type:"boolean",description:y.localize(30,null)}),e.$UG=new T.$aj("stepIntoTargetsSupported",!1,{type:"boolean",description:y.localize(31,null)}),e.$VG=new T.$aj("breakpointsExist",!1,{type:"boolean",description:y.localize(32,null)}),e.$WG=new T.$aj("debuggersAvailable",!1,{type:"boolean",description:y.localize(33,null)}),e.$XG=new T.$aj("debugExtensionAvailable",!0,{type:"boolean",description:y.localize(34,null)}),e.$YG=new T.$aj("debugProtocolVariableMenuContext",void 0,{type:"string",description:y.localize(35,null)}),e.$ZG=new T.$aj("debugSetVariableSupported",!1,{type:"boolean",description:y.localize(36,null)}),e.$1G=new T.$aj("debugSetExpressionSupported",!1,{type:"boolean",description:y.localize(37,null)}),e.$2G=new T.$aj("breakWhenValueChangesSupported",!1,{type:"boolean",description:y.localize(38,null)}),e.$3G=new T.$aj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:y.localize(39,null)}),e.$4G=new T.$aj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:y.localize(40,null)}),e.$5G=new T.$aj("terminateDebuggeeSupported",!1,{type:"boolean",description:y.localize(41,null)}),e.$6G=new T.$aj("suspendDebuggeeSupported",!1,{type:"boolean",description:y.localize(42,null)}),e.$7G=new T.$aj("variableEvaluateNamePresent",!1,{type:"boolean",description:y.localize(43,null)}),e.$8G=new T.$aj("variableIsReadonly",!1,{type:"boolean",description:y.localize(44,null)}),e.$9G=new T.$aj("exceptionWidgetVisible",!1,{type:"boolean",description:y.localize(45,null)}),e.$0G=new T.$aj("multiSessionRepl",!1,{type:"boolean",description:y.localize(46,null)}),e.$$G=new T.$aj("multiSessionDebug",!1,{type:"boolean",description:y.localize(47,null)}),e.$_G=new T.$aj("disassembleRequestSupported",!1,{type:"boolean",description:y.localize(48,null)}),e.$aH=new T.$aj("disassemblyViewFocus",!1,{type:"boolean",description:y.localize(49,null)}),e.$bH=new T.$aj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:y.localize(50,null)}),e.$cH=new T.$aj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:y.localize(51,null)});const M=u=>y.localize(52,null,u);e.$dH=M,e.$eH="editor.contrib.debug",e.$fH="editor.contrib.breakpoint",e.$gH="debug",e.$hH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:y.localize(53,null)};var A;(function(u){u[u.Inactive=0]="Inactive",u[u.Initializing=1]="Initializing",u[u.Stopped=2]="Stopped",u[u.Running=3]="Running"})(A||(e.State=A={}));function $(u){switch(u){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$iH=$;var E;(function(u){u[u.Valid=0]="Valid",u[u.Unreadable=1]="Unreadable",u[u.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$jH="vscode-debug-memory";var f;(function(u){u[u.Initial=1]="Initial",u[u.Dynamic=2]="Dynamic"})(f||(e.DebugConfigurationProviderTriggerKind=f={}));var C;(function(u){u.UnverifiedBreakpoints="unverifiedBreakpoints"})(C||(e.DebuggerString=C={})),e.$kH=(0,P.$Vh)("debugService");var D;(function(u){u[u.CONDITION=0]="CONDITION",u[u.HIT_COUNT=1]="HIT_COUNT",u[u.LOG_MESSAGE=2]="LOG_MESSAGE"})(D||(e.BreakpointWidgetContext=D={}))}),define(Pe[209],Ae([1,0,12,2,20,26,13,29,19,18]),function(we,e,y,T,P,M,A,$,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qF=e.$pF=e.$oF=e.$nF=e.$mF=e.$lF=e.$kF=e.$jF=e.$iF=e.$hF=e.$gF=e.$fF=e.$eF=void 0;const C=/{([^}]+)}/g;function D(k,h,w){return k.replace(C,function(I,F){return h&&F.length>0&&F[0]!=="_"?I:w&&w.hasOwnProperty(F)?w[F]:I})}e.$eF=D;function u(k){const h={};for(const w of Object.keys(k))w.startsWith("!")||(h[w]=k[w]);return h}e.$fF=u;function b(k){return k.configuration.request==="attach"&&!v(k)&&(!k.parentSession||b(k.parentSession))}e.$gF=b;function v(k){let h=k.configuration.type;if(h)return h==="vslsShare"&&(h=k.configuration.adapterProxy.configuration.type),(0,y.$6e)(h,"extensionhost")||(0,y.$6e)(h,"pwa-extensionhost")?k:k.parentSession?v(k.parentSession):void 0}e.$hF=v;function g(k){return k.type&&(k.label||k.program||k.runtime)}e.$iF=g;function t(k,h,w){let I,F=0;const V=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let Z=null;for(;Z=V.exec(k);){const N=Z.index+1,R=N+Z[0].length;if(N<=h&&R>=w){I=Z[0],F=N;break}}if(I){const N=/\w+/g;let R=null;for(;(R=N.exec(I))&&!(R.index+1+F+R[0].length>=w););R&&(I=I.substring(0,N.lastIndex))}return I?{start:F,end:F+I.length-1}:{start:0,end:0}}e.$jF=t;async function i(k,h,w,I){if(k.evaluatableExpressionProvider.has(h)){const F=k.evaluatableExpressionProvider.ordered(h),V=(0,f.$Gb)(await Promise.all(F.map(async Z=>{try{return await Z.provideEvaluatableExpression(h,w,I??E.CancellationToken.None)}catch{return}})));if(V.length>0){let Z=V[0].expression;const N=V[0].range;return Z||(Z=h.getLineContent(w.lineNumber).substring(N.startColumn-1,N.endColumn-1)),{range:N,matchingExpression:Z}}}else{const F=h.getLineContent(w.lineNumber),{start:V,end:Z}=t(F,w.column,w.column),N=F.substring(V-1,Z);return{matchingExpression:N,range:new $.$zs(w.lineNumber,V,w.lineNumber,V+N.length)}}return null}e.$kF=i;const r=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function c(k){return!!(k&&k.match(r))}e.$lF=c;function o(k){if(typeof k.path=="string"&&!(typeof k.sourceReference=="number"&&k.sourceReference>0)){if(c(k.path))return T.URI.parse(k.path);if((0,P.$hc)(k.path))return T.URI.file(k.path)}return k.path}function l(k){if(typeof k.path=="object"){const h=T.URI.revive(k.path);if(h)return h.scheme===A.Schemas.file?h.fsPath:h.toString()}return k.path}function n(k,h){const w=h?o:l,I=(0,M.$an)(k);return a(I,(F,V)=>{F&&V&&(V.path=w(V))}),I}e.$mF=n;function s(k,h){const w=h?o:l,I=(0,M.$an)(k);return a(I,(F,V)=>{!F&&V&&(V.path=w(V))}),I}e.$nF=s;function a(k,h){switch(k.type){case"event":{const w=k;switch(w.event){case"output":h(!1,w.body.source);break;case"loadedSource":h(!1,w.body.source);break;case"breakpoint":h(!1,w.body.breakpoint.source);break;default:break}break}case"request":{const w=k;switch(w.command){case"setBreakpoints":h(!0,w.arguments.source);break;case"breakpointLocations":h(!0,w.arguments.source);break;case"source":h(!0,w.arguments.source);break;case"gotoTargets":h(!0,w.arguments.source);break;case"launchVSCode":w.arguments.args.forEach(I=>h(!1,I));break;default:break}break}case"response":{const w=k;if(w.success&&w.body)switch(w.command){case"stackTrace":w.body.stackFrames.forEach(I=>h(!1,I.source));break;case"loadedSources":w.body.sources.forEach(I=>h(!1,I));break;case"scopes":w.body.scopes.forEach(I=>h(!1,I.source));break;case"setFunctionBreakpoints":w.body.breakpoints.forEach(I=>h(!1,I.source));break;case"setBreakpoints":w.body.breakpoints.forEach(I=>h(!1,I.source));break;case"disassemble":w.body?.instructions.forEach(F=>h(!1,F.location));break;default:break}break}}}function d(k){return k.filter(h=>!h.presentation?.hidden).sort((h,w)=>h.presentation?w.presentation?h.presentation.group?w.presentation.group?h.presentation.group!==w.presentation.group?h.presentation.group.localeCompare(w.presentation.group):p(h.presentation.order,w.presentation.order):-1:w.presentation.group?1:p(h.presentation.order,w.presentation.order):-1:w.presentation?1:0)}e.$oF=d;function p(k,h){return typeof k!="number"?typeof h!="number"?0:1:typeof h!="number"?-1:k-h}async function m(k,h){const w=k.getValue("debug.saveBeforeStart",{overrideIdentifier:h.activeTextEditorLanguageId});if(w!=="none"&&(await h.saveAll(),w==="allEditorsInActiveGroup")){const I=h.activeEditorPane;I&&I.input.resource?.scheme===A.Schemas.untitled&&await h.save({editor:I.input,groupId:I.group.id})}await k.reloadConfiguration()}e.$pF=m;const S=(k,h)=>!k||!h?k===h:k.name===h.name&&k.path===h.path&&k.sourceReference===h.sourceReference;e.$qF=S}),define(Pe[76],Ae([1,0,24,33,67,68,13,20,21,34]),function(we,e,y,T,P,M,A,$,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EI=e.$DI=e.$CI=e.$BI=e.CellStatusbarAlignment=e.$AI=e.$zI=e.$yI=e.NotebookEditorPriority=e.$xI=e.$wI=e.$vI=e.$uI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$tI=e.$sI=e.$rI=e.$qI=e.CellKind=e.$pI=e.$oI=e.$nI=void 0,e.$nI="workbench.editor.notebook",e.$oI="workbench.editor.notebookTextDiffEditor",e.$pI="workbench.editor.interactive";var C;(function(O){O[O.Markup=1]="Markup",O[O.Code=2]="Code"})(C||(e.CellKind=C={})),e.$qI=["application/json","application/javascript","text/html","image/svg+xml",M.$Vr.latex,M.$Vr.markdown,"image/png","image/jpeg",M.$Vr.text],e.$rI=[M.$Vr.latex,M.$Vr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",M.$Vr.text],e.$sI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$tI="_notAvailable";var D;(function(O){O[O.Running=1]="Running",O[O.Idle=2]="Idle"})(D||(e.NotebookRunState=D={}));var u;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(u||(e.NotebookCellExecutionState=u={}));var b;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(b||(e.NotebookExecutionState=b={}));var v;(function(O){O[O.WithHardKernelDependency=0]="WithHardKernelDependency",O[O.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",O[O.Pure=2]="Pure",O[O.Never=3]="Never"})(v||(e.NotebookRendererMatch=v={}));var g;(function(O){O.Always="always",O.Never="never",O.Optional="optional"})(g||(e.RendererMessagingSpec=g={}));var t;(function(O){O[O.ModelChange=1]="ModelChange",O[O.Move=2]="Move",O[O.ChangeCellLanguage=5]="ChangeCellLanguage",O[O.Initialize=6]="Initialize",O[O.ChangeCellMetadata=7]="ChangeCellMetadata",O[O.Output=8]="Output",O[O.OutputItem=9]="OutputItem",O[O.ChangeCellContent=10]="ChangeCellContent",O[O.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",O[O.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",O[O.ChangeCellMime=13]="ChangeCellMime",O[O.Unknown=100]="Unknown"})(t||(e.NotebookCellsChangeType=t={}));var i;(function(O){O[O.Handle=0]="Handle",O[O.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var r;(function(O){O[O.Replace=1]="Replace",O[O.Output=2]="Output",O[O.Metadata=3]="Metadata",O[O.CellLanguage=4]="CellLanguage",O[O.DocumentMetadata=5]="DocumentMetadata",O[O.Move=6]="Move",O[O.OutputItems=7]="OutputItems",O[O.PartialMetadata=8]="PartialMetadata",O[O.PartialInternalMetadata=9]="PartialInternalMetadata"})(r||(e.CellEditType=r={}));var c;(function(O){O.scheme=A.Schemas.vscodeNotebookCell;const Y=["W","X","Y","Z","a","b","c","d","e","f"],he=new RegExp(`^[${Y.join("")}]+`),$e=7;function De(se,Q){const B=Q.toString($e),pe=`${B.length<Y.length?Y[B.length-1]:"z"}${B}s${(0,y.$ze)(y.$fe.fromString(se.scheme),!0,!0)}`;return se.with({scheme:O.scheme,fragment:pe})}O.generate=De;function ke(se){if(se.scheme!==O.scheme)return;const Q=se.fragment.indexOf("s");if(Q<0)return;const B=parseInt(se.fragment.substring(0,Q).replace(he,""),$e),ne=(0,y.$ye)(se.fragment.substring(Q+1)).toString();if(!isNaN(B))return{handle:B,notebook:se.with({scheme:ne,fragment:null})}}O.parse=ke;function fe(se,Q){return se.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${Q??""},${se.scheme!==A.Schemas.file?se.scheme:""}`})}O.generateCellOutputUri=fe;function ve(se){if(se.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const Q=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(se.fragment);if(!Q)return;const B=Q[1]&&Q[1]!==""?Q[1]:void 0,ne=Q[2];return{outputId:B,notebook:se.with({scheme:ne||A.Schemas.file,fragment:null})}}O.parseCellOutputUri=ve;function te(se,Q,B){return O.generate(se,Q).with({scheme:B})}O.generateCellPropertyUri=te;function Re(se,Q){if(se.scheme===Q)return O.parse(se.with({scheme:O.scheme}))}O.parseCellPropertyUri=Re})(c||(e.CellUri=c={}));const o=O=>E.$i?O.replace(/\//g,"\\"):O;class l{constructor(Y=[],he=e.$qI){this.e=he,this.d=[...new Set(Y)].map($e=>({pattern:$e,matches:T.$Cj(o($e))}))}sort(Y){const he=new Map(P.Iterable.map(Y,De=>[De,o(De)]));let $e=[];for(const{matches:De}of this.d)for(const[ke,fe]of he)if(De(fe)){$e.push(ke),he.delete(ke);break}return he.size&&($e=$e.concat([...he.keys()].sort((De,ke)=>this.e.indexOf(De)-this.e.indexOf(ke)))),$e}prioritize(Y,he){const $e=this.f(Y);if($e===-1){this.d.unshift({pattern:Y,matches:T.$Cj(o(Y))});return}const De=new Set(he.map(fe=>this.f(fe,$e)));De.delete(-1);const ke=Array.from(De).sort();this.d.splice($e+1,0,...ke.map(fe=>this.d[fe]));for(let fe=ke.length-1;fe>=0;fe--)this.d.splice(ke[fe],1)}toArray(){return this.d.map(Y=>Y.pattern)}f(Y,he=this.d.length){const $e=o(Y);for(let De=0;De<he;De++)if(this.d[De].matches($e))return De;return-1}}e.$uI=l;function n(O,Y,he,$e=(De,ke)=>De===ke){const De=[];function ke(te,Re,se){if(Re===0&&se.length===0)return;const Q=De[De.length-1];Q&&Q.start+Q.deleteCount===te?(Q.deleteCount+=Re,Q.toInsert.push(...se)):De.push({start:te,deleteCount:Re,toInsert:se})}let fe=0,ve=0;for(;;){if(fe===O.length){ke(fe,0,Y.slice(ve));break}if(ve===Y.length){ke(fe,O.length-fe,[]);break}const te=O[fe],Re=Y[ve];if($e(te,Re)){fe+=1,ve+=1;continue}he(Re)?(ke(fe,1,[]),fe+=1):(ke(fe,0,[Re]),ve+=1)}return De}e.$vI=n,e.$wI=new f.$aj("notebookEditorCursorAtBoundary","none"),e.$xI=new f.$aj("notebookEditorCursorAtLineBoundary","none");var s;(function(O){O.default="default",O.option="option"})(s||(e.NotebookEditorPriority=s={}));function a(O){const Y=O;return!!((typeof Y.include=="string"||T.$Dj(Y.include))&&(typeof Y.exclude=="string"||T.$Dj(Y.exclude)))}e.$yI=a;function d(O,Y,he){if(Array.isArray(O.viewType)&&O.viewType.indexOf(Y)>=0||O.viewType===Y)return!0;if(O.filenamePattern){const $e=a(O.filenamePattern)?O.filenamePattern.include:O.filenamePattern,De=a(O.filenamePattern)?O.filenamePattern.exclude:void 0;if(T.$Bj($e,(0,$.$mc)(he.fsPath).toLowerCase()))return!(De&&T.$Bj(De,(0,$.$mc)(he.fsPath).toLowerCase()))}return!1}e.$zI=d,e.$AI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat"};var p;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(p||(e.CellStatusbarAlignment=p={}));class m{static{this.d="notebook/"}static create(Y){return`${m.d}${Y}`}static parse(Y){if(Y.startsWith(m.d))return Y.substring(m.d.length)}}e.$BI=m;function S(O){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(O)}e.$CI=S;const k=new TextDecoder;function h(O){const Y=[];let he=!1;for(const fe of O)(Y.length===0||he)&&(Y.push(fe),he=!0);let $e=F(Y);const De=y.$fe.concat(Y.map(fe=>y.$fe.wrap(fe))),ke=L(De);return $e=$e||ke.byteLength!==De.byteLength,{data:ke,didCompression:$e}}e.$DI=h,e.$EI=`${String.fromCharCode(27)}[A`;const w=e.$EI.split("").map(O=>O.charCodeAt(0)),I=10;function F(O){let Y=!1;return O.forEach((he,$e)=>{if($e===0||he.length<e.$EI.length)return;const De=O[$e-1],ke=he.subarray(0,e.$EI.length);if(ke[0]===w[0]&&ke[1]===w[1]&&ke[2]===w[2]){const fe=De.lastIndexOf(I);if(fe===-1)return;Y=!0,O[$e-1]=De.subarray(0,fe),O[$e]=he.subarray(e.$EI.length)}}),Y}function V(O){let Y=O;do O=Y,Y=O.replace(/[^\n]\x08/gm,"");while(Y.length<O.length);return O}function Z(O){for(O=O.replace(/\r+\n/gm,`
`);O.search(/\r[^$]/g)>-1;){const Y=O.match(/^(.*)\r+/m)[1];let he=O.match(/\r+(.*)$/m)[1];he=he+Y.slice(he.length,Y.length),O=O.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,he)}return O}const N="\b".charCodeAt(0),R="\r".charCodeAt(0);function L(O){return!O.buffer.includes(N)&&!O.buffer.includes(R)?O:y.$fe.fromString(Z(V(k.decode(O.buffer))))}}),define(Pe[7],Ae([1,0,18,11,52,28,68,12,16,2,38,22,41,100,76]),function(we,e,y,T,P,M,A,$,E,f,C,D,u,b,v){"use strict";var g,t,i,r,c,o,l,n,s,a,d,p,m,S,k,h,w,I;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$pM=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=e.$jM=e.$iM=e.$hM=e.$gM=e.$fM=e.$eM=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$dM=e.$cM=e.$bM=e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=e.TestRunProfileKind=e.TestResultState=e.$8L=e.$7L=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$6L=e.$5L=e.$4L=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$3L=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$2L=e.$1L=e.$ZL=e.$YL=e.$XL=e.ColorThemeKind=e.$WL=e.$VL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$UL=e.DebugConsoleMode=e.$TL=e.$SL=e.$RL=e.$QL=e.$PL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$OL=e.$NL=e.FileChangeType=e.$ML=e.$LL=e.$KL=e.$JL=e.InlineCompletionTriggerKind=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=e.ConfigurationTarget=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=e.$qL=e.$pL=e.$oL=e.$nL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$mL=e.ViewBadge=e.ProgressLocation=e.$lL=e.$kL=e.TaskScope=e.ShellQuoting=e.$jL=e.$iL=e.$hL=e.TaskPanelKind=e.TaskRevealKind=e.$gL=e.TerminalLocation=e.$fL=e.$eL=e.$dL=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$cL=e.$bL=e.$aL=e.$_K=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$$K=e.StatusBarAlignment=e.ViewColumn=e.$0K=e.$9K=e.$8K=e.$7K=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$6K=e.$5K=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$4K=e.$3K=e.$2K=e.$1K=e.$ZK=e.LanguageStatusSeverity=e.$YK=e.$XK=e.$WK=e.$VK=e.$UK=e.$TK=e.CodeActionTriggerKind=e.$SK=e.$RK=e.SymbolTag=e.SymbolKind=e.$QK=e.DocumentHighlightKind=e.$PK=e.$OK=e.$NK=e.$MK=e.DiagnosticSeverity=e.DiagnosticTag=e.$LK=e.$KK=e.FileEditType=e.$JK=e.$IK=e.$HK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function F(j){return Object.assign(j,{apply:function(...oe){if(oe.length===0)return Reflect.construct(j,[]);{const Se=oe.length===1?[]:oe[1];return Reflect.construct(j,Se,oe[0].constructor)}},call:function(...oe){if(oe.length===0)return Reflect.construct(j,[]);{const[Se,...Ge]=oe;return Reflect.construct(j,Ge,Se.constructor)}}})}var V;(function(j){j[j.Top=0]="Top",j[j.Bottom=1]="Bottom"})(V||(e.TerminalOutputAnchor=V={}));var Z;(function(j){j[j.TerminalCommand=0]="TerminalCommand",j[j.Opener=1]="Opener",j[j.Command=3]="Command"})(Z||(e.TerminalQuickFixType=Z={}));let N=g=class{static from(...U){let oe=U;return new g(function(){if(oe){for(const Se of oe)Se&&typeof Se.dispose=="function"&&Se.dispose();oe=void 0}})}#e;constructor(U){this.#e=U}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$AK=N,e.$AK=N=g=Ke([F],N);let R=t=class{static Min(...U){if(U.length===0)throw new TypeError;let oe=U[0];for(let Se=1;Se<U.length;Se++){const Ge=U[Se];Ge.isBefore(oe)&&(oe=Ge)}return oe}static Max(...U){if(U.length===0)throw new TypeError;let oe=U[0];for(let Se=1;Se<U.length;Se++){const Ge=U[Se];Ge.isAfter(oe)&&(oe=Ge)}return oe}static isPosition(U){if(!U)return!1;if(U instanceof t)return!0;const{line:oe,character:Se}=U;return typeof oe=="number"&&typeof Se=="number"}static of(U){if(U instanceof t)return U;if(this.isPosition(U))return new t(U.line,U.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(U,oe){if(U<0)throw(0,T.$6)("line must be non-negative");if(oe<0)throw(0,T.$6)("character must be non-negative");this.c=U,this.e=oe}isBefore(U){return this.c<U.c?!0:U.c<this.c?!1:this.e<U.e}isBeforeOrEqual(U){return this.c<U.c?!0:U.c<this.c?!1:this.e<=U.e}isAfter(U){return!this.isBeforeOrEqual(U)}isAfterOrEqual(U){return!this.isBefore(U)}isEqual(U){return this.c===U.c&&this.e===U.e}compareTo(U){return this.c<U.c?-1:this.c>U.line?1:this.e<U.e?-1:this.e>U.e?1:0}translate(U,oe=0){if(U===null||oe===null)throw(0,T.$6)();let Se;return typeof U>"u"?Se=0:typeof U=="number"?Se=U:(Se=typeof U.lineDelta=="number"?U.lineDelta:0,oe=typeof U.characterDelta=="number"?U.characterDelta:0),Se===0&&oe===0?this:new t(this.line+Se,this.character+oe)}with(U,oe=this.character){if(U===null||oe===null)throw(0,T.$6)();let Se;return typeof U>"u"?Se=this.line:typeof U=="number"?Se=U:(Se=typeof U.line=="number"?U.line:this.line,oe=typeof U.character=="number"?U.character:this.character),Se===this.line&&oe===this.character?this:new t(Se,oe)}toJSON(){return{line:this.line,character:this.character}}};e.$BK=R,e.$BK=R=t=Ke([F],R);let L=i=class{static isRange(U){return U instanceof i?!0:U?R.isPosition(U.start)&&R.isPosition(U.end):!1}static of(U){if(U instanceof i)return U;if(this.isRange(U))return new i(U.start,U.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(U,oe,Se,Ge){let xe,at;if(typeof U=="number"&&typeof oe=="number"&&typeof Se=="number"&&typeof Ge=="number"?(xe=new R(U,oe),at=new R(Se,Ge)):R.isPosition(U)&&R.isPosition(oe)&&(xe=R.of(U),at=R.of(oe)),!xe||!at)throw new Error("Invalid arguments");xe.isBefore(at)?(this.c=xe,this.e=at):(this.c=at,this.e=xe)}contains(U){return i.isRange(U)?this.contains(U.start)&&this.contains(U.end):R.isPosition(U)?!(R.of(U).isBefore(this.c)||this.e.isBefore(U)):!1}isEqual(U){return this.c.isEqual(U.c)&&this.e.isEqual(U.e)}intersection(U){const oe=R.Max(U.start,this.c),Se=R.Min(U.end,this.e);if(!oe.isAfter(Se))return new i(oe,Se)}union(U){if(this.contains(U))return this;if(U.contains(this))return U;const oe=R.Min(U.start,this.c),Se=R.Max(U.end,this.end);return new i(oe,Se)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(U,oe=this.end){if(U===null||oe===null)throw(0,T.$6)();let Se;return U?R.isPosition(U)?Se=U:(Se=U.start||this.start,oe=U.end||this.end):Se=this.start,Se.isEqual(this.c)&&oe.isEqual(this.end)?this:new i(Se,oe)}toJSON(){return[this.start,this.end]}};e.$CK=L,e.$CK=L=i=Ke([F],L);let O=r=class extends L{static isSelection(U){return U instanceof r?!0:U?L.isRange(U)&&R.isPosition(U.anchor)&&R.isPosition(U.active)&&typeof U.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(U,oe,Se,Ge){let xe,at;if(typeof U=="number"&&typeof oe=="number"&&typeof Se=="number"&&typeof Ge=="number"?(xe=new R(U,oe),at=new R(Se,Ge)):R.isPosition(U)&&R.isPosition(oe)&&(xe=R.of(U),at=R.of(oe)),!xe||!at)throw new Error("Invalid arguments");super(xe,at),this.f=xe,this.g=at}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$DK=O,e.$DK=O=r=Ke([F],O);const Y=j=>{if(typeof j!="string"||j.length===0||!/^[0-9A-Za-z_\-]+$/.test(j))throw(0,T.$6)("connectionToken")};class he{static isResolvedAuthority(U){return U&&typeof U=="object"&&typeof U.host=="string"&&typeof U.port=="number"&&(U.connectionToken===void 0||typeof U.connectionToken=="string")}constructor(U,oe,Se){if(typeof U!="string"||U.length===0)throw(0,T.$6)("host");if(typeof oe!="number"||oe===0||Math.round(oe)!==oe)throw(0,T.$6)("port");typeof Se<"u"&&Y(Se),this.host=U,this.port=Math.round(oe),this.connectionToken=Se}}e.$EK=he;class $e{static isManagedResolvedAuthority(U){return U&&typeof U=="object"&&typeof U.makeConnection=="function"&&(U.connectionToken===void 0||typeof U.connectionToken=="string")}constructor(U,oe){this.makeConnection=U,this.connectionToken=oe,typeof oe<"u"&&Y(oe)}}e.$FK=$e;class De extends Error{static NotAvailable(U,oe){return new De(U,b.RemoteAuthorityResolverErrorCode.NotAvailable,oe)}static TemporarilyNotAvailable(U){return new De(U,b.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(U,oe=b.RemoteAuthorityResolverErrorCode.Unknown,Se){super(U),this._message=U,this._code=oe,this._detail=Se,Object.setPrototypeOf(this,De.prototype)}}e.$GK=De;var ke;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(ke||(e.EndOfLine=ke={}));var fe;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(fe||(e.EnvironmentVariableMutatorType=fe={}));let ve=c=class{static isTextEdit(U){return U instanceof c?!0:U?L.isRange(U)&&typeof U.newText=="string":!1}static replace(U,oe){return new c(U,oe)}static insert(U,oe){return c.replace(new L(U,U),oe)}static delete(U){return c.replace(U,"")}static setEndOfLine(U){const oe=new c(new L(new R(0,0),new R(0,0)),"");return oe.newEol=U,oe}get range(){return this.c}set range(U){if(U&&!L.isRange(U))throw(0,T.$6)("range");this.c=U}get newText(){return this.e||""}set newText(U){if(U&&typeof U!="string")throw(0,T.$6)("newText");this.e=U}get newEol(){return this.f}set newEol(U){if(U&&typeof U!="number")throw(0,T.$6)("newEol");this.f=U}constructor(U,oe){this.c=U,this.e=oe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$HK=ve,e.$HK=ve=c=Ke([F],ve);let te=o=class{static isNotebookCellEdit(U){return U instanceof o?!0:U?_t.isNotebookRange(U)&&Array.isArray(U.newCells):!1}static replaceCells(U,oe){return new o(U,oe)}static insertCells(U,oe){return new o(new _t(U,U),oe)}static deleteCells(U){return new o(U,[])}static updateCellMetadata(U,oe){const Se=new o(new _t(U,U),[]);return Se.newCellMetadata=oe,Se}static updateNotebookMetadata(U){const oe=new o(new _t(0,0),[]);return oe.newNotebookMetadata=U,oe}constructor(U,oe){this.range=U,this.newCells=oe}};e.$IK=te,e.$IK=te=o=Ke([F],te);class Re{static isSnippetTextEdit(U){return U instanceof Re?!0:U?L.isRange(U.range)&&B.isSnippetString(U.snippet):!1}static replace(U,oe){return new Re(U,oe)}static insert(U,oe){return Re.replace(new L(U,U),oe)}constructor(U,oe){this.range=U,this.snippet=oe}}e.$JK=Re;var se;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})(se||(e.FileEditType=se={}));let Q=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(U,oe,Se,Ge){this.c.push({_type:1,from:U,to:oe,options:Se,metadata:Ge})}createFile(U,oe,Se){this.c.push({_type:1,from:void 0,to:U,options:oe,metadata:Se})}deleteFile(U,oe,Se){this.c.push({_type:1,from:U,to:void 0,options:oe,metadata:Se})}e(U,oe,Se){this.c.push({_type:3,metadata:Se,uri:U,edit:{editType:5,metadata:oe},notebookMetadata:oe})}f(U,oe,Se,Ge){const xe=oe.start,at=oe.end;(xe!==at||Se.length>0)&&this.c.push({_type:5,uri:U,index:xe,count:at-xe,cells:Se,metadata:Ge})}g(U,oe,Se,Ge){this.c.push({_type:3,metadata:Ge,uri:U,edit:{editType:3,index:oe,metadata:Se}})}replace(U,oe,Se,Ge){this.c.push({_type:2,uri:U,edit:new ve(oe,Se),metadata:Ge})}insert(U,oe,Se,Ge){this.replace(U,new L(oe,oe),Se,Ge)}delete(U,oe,Se){this.replace(U,oe,"",Se)}has(U){return this.c.some(oe=>oe._type===2&&oe.uri.toString()===U.toString())}set(U,oe){if(oe)for(const Se of oe){if(!Se)continue;let Ge,xe;Array.isArray(Se)?(Ge=Se[0],xe=Se[1]):Ge=Se,te.isNotebookCellEdit(Ge)?Ge.newCellMetadata?this.g(U,Ge.range.start,Ge.newCellMetadata,xe):Ge.newNotebookMetadata?this.e(U,Ge.newNotebookMetadata,xe):this.f(U,Ge.range,Ge.newCells,xe):Re.isSnippetTextEdit(Ge)?this.c.push({_type:6,uri:U,range:Ge.range,edit:Ge.snippet,metadata:xe}):this.c.push({_type:2,uri:U,edit:Ge,metadata:xe})}else{for(let Se=0;Se<this.c.length;Se++){const Ge=this.c[Se];switch(Ge._type){case 2:case 6:case 3:case 5:Ge.uri.toString()===U.toString()&&(this.c[Se]=void 0);break}}(0,y.$Hb)(this.c)}}get(U){const oe=[];for(const Se of this.c)Se._type===2&&Se.uri.toString()===U.toString()&&oe.push(Se.edit);return oe}entries(){const U=new M.$zc;for(const oe of this.c)if(oe._type===2){let Se=U.get(oe.uri);Se||(Se=[oe.uri,[]],U.set(oe.uri,Se)),Se[1].push(oe.edit)}return[...U.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$KK=Q,e.$KK=Q=Ke([F],Q);let B=l=class{static isSnippetString(U){return U instanceof l?!0:U?typeof U.value=="string":!1}static c(U){return U.replace(/\$|}|\\/g,"\\$&")}constructor(U){this.e=1,this.value=U||""}appendText(U){return this.value+=l.c(U),this}appendTabstop(U=this.e++){return this.value+="$",this.value+=U,this}appendPlaceholder(U,oe=this.e++){if(typeof U=="function"){const Se=new l;Se.e=this.e,U(Se),this.e=Se.e,U=Se.value}else U=l.c(U);return this.value+="${",this.value+=oe,this.value+=":",this.value+=U,this.value+="}",this}appendChoice(U,oe=this.e++){const Se=U.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=oe,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(U,oe){if(typeof oe=="function"){const Se=new l;Se.e=this.e,oe(Se),this.e=Se.e,oe=Se.value}else typeof oe=="string"&&(oe=oe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=U,oe&&(this.value+=":",this.value+=oe),this.value+="}",this}};e.$LK=B,e.$LK=B=l=Ke([F],B);var ne;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(ne||(e.DiagnosticTag=ne={}));var pe;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(pe||(e.DiagnosticSeverity=pe={}));let re=n=class{static isLocation(U){return U instanceof n?!0:U?L.isRange(U.range)&&f.URI.isUri(U.uri):!1}constructor(U,oe){if(this.uri=U,oe)if(L.isRange(oe))this.range=L.of(oe);else if(R.isPosition(oe))this.range=new L(oe,oe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$MK=re,e.$MK=re=n=Ke([F],re);let le=class{static is(U){return U?typeof U.message=="string"&&U.location&&L.isRange(U.location.range)&&f.URI.isUri(U.location.uri):!1}constructor(U,oe){this.location=U,this.message=oe}static isEqual(U,oe){return U===oe?!0:!U||!oe?!1:U.message===oe.message&&U.location.range.isEqual(oe.location.range)&&U.location.uri.toString()===oe.location.uri.toString()}};e.$NK=le,e.$NK=le=Ke([F],le);let ce=class{constructor(U,oe,Se=pe.Error){if(!L.isRange(U))throw new TypeError("range must be set");if(!oe)throw new TypeError("message must be set");this.range=U,this.message=oe,this.severity=Se}toJSON(){return{severity:pe[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(U,oe){return U===oe?!0:!U||!oe?!1:U.message===oe.message&&U.severity===oe.severity&&U.code===oe.code&&U.severity===oe.severity&&U.source===oe.source&&U.range.isEqual(oe.range)&&(0,y.$tb)(U.tags,oe.tags)&&(0,y.$tb)(U.relatedInformation,oe.relatedInformation,le.isEqual)}};e.$OK=ce,e.$OK=ce=Ke([F],ce);let ye=class{constructor(U,oe){if(!U)throw new Error("Illegal argument, contents must be defined");Array.isArray(U)?this.contents=U:this.contents=[U],this.range=oe}};e.$PK=ye,e.$PK=ye=Ke([F],ye);var _;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(_||(e.DocumentHighlightKind=_={}));let de=class{constructor(U,oe=_.Text){this.range=U,this.kind=oe}toJSON(){return{range:this.range,kind:_[this.kind]}}};e.$QK=de,e.$QK=de=Ke([F],de);var ie;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(ie||(e.SymbolKind=ie={}));var ae;(function(j){j[j.Deprecated=1]="Deprecated"})(ae||(e.SymbolTag=ae={}));let me=s=class{static validate(U){if(!U.name)throw new Error("name must not be falsy")}constructor(U,oe,Se,Ge,xe){this.name=U,this.kind=oe,this.containerName=xe,typeof Se=="string"&&(this.containerName=Se),Ge instanceof re?this.location=Ge:Se instanceof L&&(this.location=new re(Ge,Se)),s.validate(this)}toJSON(){return{name:this.name,kind:ie[this.kind],location:this.location,containerName:this.containerName}}};e.$RK=me,e.$RK=me=s=Ke([F],me);let Ie=a=class{static validate(U){if(!U.name)throw new Error("name must not be falsy");if(!U.range.contains(U.selectionRange))throw new Error("selectionRange must be contained in fullRange");U.children?.forEach(a.validate)}constructor(U,oe,Se,Ge,xe){this.name=U,this.detail=oe,this.kind=Se,this.range=Ge,this.selectionRange=xe,this.children=[],a.validate(this)}};e.$SK=Ie,e.$SK=Ie=a=Ke([F],Ie);var z;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(z||(e.CodeActionTriggerKind=z={}));let W=class{constructor(U,oe){this.title=U,this.kind=oe}};e.$TK=W,e.$TK=W=Ke([F],W);let H=class{static{d=this}static{this.c="."}constructor(U){this.value=U}append(U){return new d(this.value?this.value+d.c+U:U)}intersects(U){return this.contains(U)||U.contains(this)}contains(U){return this.value===U.value||U.value.startsWith(this.value+d.c)}};e.$UK=H,e.$UK=H=d=Ke([F],H),H.Empty=new H(""),H.QuickFix=H.Empty.append("quickfix"),H.Refactor=H.Empty.append("refactor"),H.RefactorExtract=H.Refactor.append("extract"),H.RefactorInline=H.Refactor.append("inline"),H.RefactorMove=H.Refactor.append("move"),H.RefactorRewrite=H.Refactor.append("rewrite"),H.Source=H.Empty.append("source"),H.SourceOrganizeImports=H.Source.append("organizeImports"),H.SourceFixAll=H.Source.append("fixAll"),H.Notebook=H.Empty.append("notebook");let G=class{constructor(U,oe){if(this.range=U,this.parent=oe,oe&&!oe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$VK=G,e.$VK=G=Ke([F],G);class q{constructor(U,oe,Se,Ge,xe,at){this.kind=U,this.name=oe,this.detail=Se,this.uri=Ge,this.range=xe,this.selectionRange=at}}e.$WK=q;class x{constructor(U,oe){this.fromRanges=oe,this.from=U}}e.$XK=x;class ue{constructor(U,oe){this.fromRanges=oe,this.to=U}}e.$YK=ue;var Oe;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(Oe||(e.LanguageStatusSeverity=Oe={}));let Ue=class{constructor(U,oe){this.range=U,this.command=oe}get isResolved(){return!!this.command}};e.$ZK=Ue,e.$ZK=Ue=Ke([F],Ue);let Ze=p=class{#e;static isMarkdownString(U){return U instanceof p?!0:U&&U.appendCodeblock&&U.appendMarkdown&&U.appendText&&U.value!==void 0}constructor(U,oe=!1){this.#e=new P.$9j(U,{supportThemeIcons:oe})}get value(){return this.#e.value}set value(U){this.#e.value=U}get isTrusted(){return this.#e.isTrusted}set isTrusted(U){this.#e.isTrusted=U}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(U){this.#e.supportThemeIcons=U}get supportHtml(){return this.#e.supportHtml}set supportHtml(U){this.#e.supportHtml=U}get baseUri(){return this.#e.baseUri}set baseUri(U){this.#e.baseUri=U}appendText(U){return this.#e.appendText(U),this}appendMarkdown(U){return this.#e.appendMarkdown(U),this}appendCodeblock(U,oe){return this.#e.appendCodeblock(oe??"",U),this}};e.$1K=Ze,e.$1K=Ze=p=Ke([F],Ze);let Je=class{constructor(U,oe){this.label=U,this.documentation=oe}};e.$2K=Je,e.$2K=Je=Ke([F],Je);let tt=class{constructor(U,oe){this.label=U,this.documentation=oe,this.parameters=[]}};e.$3K=tt,e.$3K=tt=Ke([F],tt);let _e=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$4K=_e,e.$4K=_e=Ke([F],_e);var et;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(et||(e.SignatureHelpTriggerKind=et={}));var rt;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(rt||(e.InlayHintKind=rt={}));let nt=class{constructor(U){this.value=U}};e.$5K=nt,e.$5K=nt=Ke([F],nt);let ze=class{constructor(U,oe,Se){this.position=U,this.label=oe,this.kind=Se}};e.$6K=ze,e.$6K=ze=Ke([F],ze);var dt;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(dt||(e.CompletionTriggerKind=dt={}));var X;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(X||(e.CompletionItemKind=X={}));var J;(function(j){j[j.Deprecated=1]="Deprecated"})(J||(e.CompletionItemTag=J={}));let Ee=class{constructor(U,oe){this.label=U,this.kind=oe}toJSON(){return{label:this.label,kind:this.kind&&X[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$7K=Ee,e.$7K=Ee=Ke([F],Ee);let Be=class{constructor(U=[],oe=!1){this.items=U,this.isIncomplete=oe}};e.$8K=Be,e.$8K=Be=Ke([F],Be);let He=class{constructor(U,oe,Se){this.insertText=U,this.range=oe,this.command=Se}};e.$9K=He,e.$9K=He=Ke([F],He);let Xe=class{constructor(U){this.commands=void 0,this.suppressSuggestions=void 0,this.items=U}};e.$0K=Xe,e.$0K=Xe=Ke([F],Xe);var st;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(st||(e.ViewColumn=st={}));var vt;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(vt||(e.StatusBarAlignment=vt={}));function Dt(j,U){return`${D.$_l.toKey(j)}.${U}`}e.$$K=Dt;var Ne;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(Ne||(e.TextEditorLineNumbersStyle=Ne={}));var Kt;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(Kt||(e.TextDocumentSaveReason=Kt={}));var Ht;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Ht||(e.TextEditorRevealType=Ht={}));var yt;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(yt||(e.TextEditorSelectionChangeKind=yt={}));var jt;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(jt||(e.TextDocumentChangeReason=jt={}));var Nt;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(Nt||(e.DecorationRangeBehavior=Nt={})),function(j){function U(oe){switch(oe){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=U}(yt||(e.TextEditorSelectionChangeKind=yt={}));var Gt;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(Gt||(e.SyntaxTokenType=Gt={})),function(j){function U(oe){switch(oe){case j.Other:return"other";case j.Comment:return"comment";case j.String:return"string";case j.RegEx:return"regex"}return"other"}j.toString=U}(Gt||(e.SyntaxTokenType=Gt={}));let Bt=class{constructor(U,oe){if(oe&&!f.URI.isUri(oe))throw(0,T.$6)("target");if(!L.isRange(U)||U.isEmpty)throw(0,T.$6)("range");this.range=U,this.target=oe}};e.$_K=Bt,e.$_K=Bt=Ke([F],Bt);let St=class{constructor(U,oe,Se,Ge){this.red=U,this.green=oe,this.blue=Se,this.alpha=Ge}};e.$aL=St,e.$aL=St=Ke([F],St);let Lt=class{constructor(U,oe){if(oe&&!(oe instanceof St))throw(0,T.$6)("color");if(!L.isRange(U)||U.isEmpty)throw(0,T.$6)("range");this.range=U,this.color=oe}};e.$bL=Lt,e.$bL=Lt=Ke([F],Lt);let Vt=class{constructor(U){if(!U||typeof U!="string")throw(0,T.$6)("label");this.label=U}};e.$cL=Vt,e.$cL=Vt=Ke([F],Vt);var Ye;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(Ye||(e.ColorFormat=Ye={}));var Wt;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(Wt||(e.SourceControlInputBoxValidationType=Wt={}));var qt;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})(qt||(e.TerminalExitReason=qt={}));class ct{constructor(U,oe,Se){if(this.startIndex=U,this.length=oe,this.tooltip=Se,typeof U!="number"||U<0)throw(0,T.$6)("startIndex");if(typeof oe!="number"||oe<1)throw(0,T.$6)("length");if(Se!==void 0&&typeof Se!="string")throw(0,T.$6)("tooltip")}}e.$dL=ct;class gt{constructor(U){this.uri=U}}e.$eL=gt;class Ot{constructor(U){this.terminalCommand=U}}e.$fL=Ot;var Pt;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(Pt||(e.TerminalLocation=Pt={}));class At{constructor(U){if(this.options=U,typeof U!="object")throw(0,T.$6)("options")}}e.$gL=At;var ft;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(ft||(e.TaskRevealKind=ft={}));var kt;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(kt||(e.TaskPanelKind=kt={}));let Rt=class{static{m=this}static{this.Clean=new m("clean","Clean")}static{this.Build=new m("build","Build")}static{this.Rebuild=new m("rebuild","Rebuild")}static{this.Test=new m("test","Test")}static from(U){switch(U){case"clean":return m.Clean;case"build":return m.Build;case"rebuild":return m.Rebuild;case"test":return m.Test;default:return}}constructor(U,oe){if(this.label=oe,typeof U!="string"||typeof oe!="string")throw(0,T.$6)("name");this.c=U}get id(){return this.c}};e.$hL=Rt,e.$hL=Rt=m=Ke([F],Rt);function Ct(j){let U="";for(let oe=0;oe<j.length;oe++)U+=j[oe].replace(/,/g,",,")+",";return U}let We=class{constructor(U,oe,Se){if(typeof U!="string")throw(0,T.$6)("process");this.e=[],this.c=U,oe!==void 0&&(Array.isArray(oe)?(this.e=oe,this.f=Se):this.f=oe)}get process(){return this.c}set process(U){if(typeof U!="string")throw(0,T.$6)("process");this.c=U}get args(){return this.e}set args(U){Array.isArray(U)||(U=[]),this.e=U}get options(){return this.f}set options(U){this.f=U}computeId(){const U=[];if(U.push("process"),this.c!==void 0&&U.push(this.c),this.e&&this.e.length>0)for(const oe of this.e)U.push(oe);return Ct(U)}};e.$iL=We,e.$iL=We=Ke([F],We);let zt=class{constructor(U,oe,Se){if(this.f=[],Array.isArray(oe)){if(!U)throw(0,T.$6)("command can't be undefined or null");if(typeof U!="string"&&typeof U.value!="string")throw(0,T.$6)("command");this.e=U,this.f=oe,this.g=Se}else{if(typeof U!="string")throw(0,T.$6)("commandLine");this.c=U,this.g=oe}}get commandLine(){return this.c}set commandLine(U){if(typeof U!="string")throw(0,T.$6)("commandLine");this.c=U}get command(){return this.e?this.e:""}set command(U){if(typeof U!="string"&&typeof U.value!="string")throw(0,T.$6)("command");this.e=U}get args(){return this.f}set args(U){this.f=U||[]}get options(){return this.g}set options(U){this.g=U}computeId(){const U=[];if(U.push("shell"),this.c!==void 0&&U.push(this.c),this.e!==void 0&&U.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const oe of this.f)U.push(typeof oe=="string"?oe:oe.value);return Ct(U)}};e.$jL=zt,e.$jL=zt=Ke([F],zt);var Jt;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(Jt||(e.ShellQuoting=Jt={}));var Ce;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(Ce||(e.TaskScope=Ce={}));class Me{constructor(U){this.c=U}computeId(){return"customExecution"+(0,C.$ig)()}set callback(U){this.c=U}get callback(){return this.c}}e.$kL=Me;let be=class{static{S=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(U,oe,Se,Ge,xe,at){this.j=!1,this.k=this.definition=U;let ht;typeof oe=="string"?(this.m=this.name=oe,this.t=this.source=Se,this.execution=Ge,ht=xe,this.j=!0):oe===Ce.Global||oe===Ce.Workspace?(this.target=oe,this.m=this.name=Se,this.t=this.source=Ge,this.execution=xe,ht=at):(this.target=oe,this.m=this.name=Se,this.t=this.source=Ge,this.execution=xe,ht=at),typeof ht=="string"?(this.o=[ht],this.q=!0):Array.isArray(ht)?(this.o=ht,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(U){this.h=U}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof We?this.k={type:S.e,id:this.n.computeId()}:this.n instanceof zt?this.k={type:S.f,id:this.n.computeId()}:this.n instanceof Me?this.k={type:S.c,id:this.n.computeId()}:this.k={type:S.g,id:(0,C.$ig)()}}get definition(){return this.k}set definition(U){if(U==null)throw(0,T.$6)("Kind can't be undefined or null");this.z(),this.k=U}get scope(){return this.l}set target(U){this.z(),this.l=U}get name(){return this.m}set name(U){if(typeof U!="string")throw(0,T.$6)("name");this.z(),this.m=U}get execution(){return this.n}set execution(U){U===null&&(U=void 0),this.z(),this.n=U;const oe=this.k.type;(S.g===oe||S.e===oe||S.f===oe||S.c===oe)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(U){if(Array.isArray(U))this.z(),this.o=U,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(U){U!==!0&&U!==!1&&(U=!1),this.z(),this.r=U}get source(){return this.t}set source(U){if(typeof U!="string"||U.length===0)throw(0,T.$6)("source must be a string of length > 0");this.z(),this.t=U}get group(){return this.u}set group(U){U===null&&(U=void 0),this.z(),this.u=U}get detail(){return this.y}set detail(U){U===null&&(U=void 0),this.y=U}get presentationOptions(){return this.w}set presentationOptions(U){U==null&&(U=Object.create(null)),this.z(),this.w=U}get runOptions(){return this.x}set runOptions(U){U==null&&(U=Object.create(null)),this.z(),this.x=U}};e.$lL=be,e.$lL=be=S=Ke([F],be);var K;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(K||(e.ProgressLocation=K={}));var Le;(function(j){function U(oe){const Se=oe;return(0,E.$Gf)(Se.value)?Se.tooltip&&!(0,E.$Cf)(Se.tooltip)?(console.log("INVALID view badge, invalid tooltip",Se.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Se.value),!1)}j.isViewBadge=U})(Le||(e.ViewBadge=Le={}));let je=k=class{static isTreeItem(U,oe){const Se=U;if(Se.checkboxState!==void 0){const Ge=(0,E.$Gf)(Se.checkboxState)?Se.checkboxState:(0,E.$Ef)(Se.checkboxState)&&(0,E.$Gf)(Se.checkboxState.state)?Se.checkboxState.state:void 0,xe=!(0,E.$Gf)(Se.checkboxState)&&(0,E.$Ef)(Se.checkboxState)?Se.checkboxState.tooltip:void 0;if(Ge===void 0||Ge!==qe.Checked&&Ge!==qe.Unchecked||xe!==void 0&&!(0,E.$Cf)(xe))return console.log("INVALID tree item, invalid checkboxState",Se.checkboxState),!1}if(U instanceof k)return!0;if(Se.label!==void 0&&!(0,E.$Cf)(Se.label)&&!Se.label?.label)return console.log("INVALID tree item, invalid label",Se.label),!1;if(Se.id!==void 0&&!(0,E.$Cf)(Se.id))return console.log("INVALID tree item, invalid id",Se.id),!1;if(Se.iconPath!==void 0&&!(0,E.$Cf)(Se.iconPath)&&!f.URI.isUri(Se.iconPath)&&(!Se.iconPath||!(0,E.$Cf)(Se.iconPath.id))){const Ge=Se.iconPath;if(!Ge||!(0,E.$Cf)(Ge.light)&&!f.URI.isUri(Ge.light)&&!(0,E.$Cf)(Ge.dark)&&!f.URI.isUri(Ge.dark))return console.log("INVALID tree item, invalid iconPath",Se.iconPath),!1}return Se.description!==void 0&&!(0,E.$Cf)(Se.description)&&typeof Se.description!="boolean"?(console.log("INVALID tree item, invalid description",Se.description),!1):Se.resourceUri!==void 0&&!f.URI.isUri(Se.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Se.resourceUri),!1):Se.tooltip!==void 0&&!(0,E.$Cf)(Se.tooltip)&&!(Se.tooltip instanceof Ze)?(console.log("INVALID tree item, invalid tooltip",Se.tooltip),!1):Se.command!==void 0&&!Se.command.command?(console.log("INVALID tree item, invalid command",Se.command),!1):Se.collapsibleState!==void 0&&Se.collapsibleState<Qe.None&&Se.collapsibleState>Qe.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Se.collapsibleState),!1):Se.contextValue!==void 0&&!(0,E.$Cf)(Se.contextValue)?(console.log("INVALID tree item, invalid contextValue",Se.contextValue),!1):Se.accessibilityInformation!==void 0&&!Se.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Se.accessibilityInformation),!1):!0}constructor(U,oe=Qe.None){this.collapsibleState=oe,f.URI.isUri(U)?this.resourceUri=U:this.label=U}};e.$mL=je,e.$mL=je=k=Ke([F],je);var Qe;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(Qe||(e.TreeItemCollapsibleState=Qe={}));var qe;(function(j){j[j.Unchecked=0]="Unchecked",j[j.Checked=1]="Checked"})(qe||(e.TreeItemCheckboxState=qe={}));let it=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(U){this.value=U}};e.$nL=it,e.$nL=it=Ke([F],it);class pt extends it{}e.$oL=pt;class $t extends pt{#e;constructor(U){super(""),this.#e=U}asFile(){return this.#e}}e.$pL=$t;class bt{constructor(U,oe,Se,Ge){this.name=U,this.uri=oe,this._itemId=Se,this.c=Ge}data(){return this.c()}}e.$qL=bt;let ut=class{#e=new Map;constructor(U){for(const[oe,Se]of U??[]){const Ge=this.#e.get(this.#t(oe));Ge?Ge.push(Se):this.#e.set(this.#t(oe),[Se])}}get(U){return this.#e.get(this.#t(U))?.[0]}set(U,oe){this.#e.set(this.#t(U),[oe])}forEach(U,oe){for(const[Se,Ge]of this.#e)for(const xe of Ge)U.call(oe,xe,Se,this)}*[Symbol.iterator](){for(const[U,oe]of this.#e)for(const Se of oe)yield[U,Se]}#t(U){return U.toLowerCase()}};e.$rL=ut,e.$rL=ut=Ke([F],ut);let Mt=class{constructor(U){this.insertText=U}};e.$sL=Mt,e.$sL=Mt=Ke([F],Mt);let Qt=class{constructor(U,oe){this.label=oe,this.insertText=U}};e.$tL=Qt,e.$tL=Qt=Ke([F],Qt);let Xt=class{constructor(U,oe){this.id=U,this.color=oe}static isThemeIcon(U){return typeof U.id!="string"?(console.log("INVALID ThemeIcon, invalid id",U.id),!1):!0}};e.$uL=Xt,e.$uL=Xt=Ke([F],Xt),Xt.File=new Xt("file"),Xt.Folder=new Xt("folder");let si=class{constructor(U){this.id=U}};e.$vL=si,e.$vL=si=Ke([F],si);var ki;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(ki||(e.ConfigurationTarget=ki={}));let It=class{get base(){return this.c}set base(U){this.c=U,this.e=f.URI.file(U)}get baseUri(){return this.e}set baseUri(U){this.e=U,this.c=U.fsPath}constructor(U,oe){if(typeof U!="string"&&(!U||!f.URI.isUri(U)&&!f.URI.isUri(U.uri)))throw(0,T.$6)("base");if(typeof oe!="string")throw(0,T.$6)("pattern");typeof U=="string"?this.baseUri=f.URI.file(U):f.URI.isUri(U)?this.baseUri=U:this.baseUri=U.uri,this.pattern=oe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$wL=It,e.$wL=It=Ke([F],It);const Zi=new WeakMap;function ln(j,U){Zi.set(j,U)}e.$xL=ln;let Et=class{constructor(U,oe,Se,Ge){this.enabled=typeof U=="boolean"?U:!0,typeof oe=="string"&&(this.condition=oe),typeof Se=="string"&&(this.hitCondition=Se),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this.c||(this.c=Zi.get(this)??(0,C.$ig)()),this.c}};e.$yL=Et,e.$yL=Et=Ke([F],Et);let mi=class extends Et{constructor(U,oe,Se,Ge,xe){if(super(oe,Se,Ge,xe),U===null)throw(0,T.$6)("location");this.location=U}};e.$zL=mi,e.$zL=mi=Ke([F],mi);let $i=class extends Et{constructor(U,oe,Se,Ge,xe){super(oe,Se,Ge,xe),this.functionName=U}};e.$AL=$i,e.$AL=$i=Ke([F],$i);let oi=class extends Et{constructor(U,oe,Se,Ge,xe,at,ht){if(super(Ge,xe,at,ht),!oe)throw(0,T.$6)("dataId");this.label=U,this.dataId=oe,this.canPersist=Se}};e.$BL=oi,e.$BL=oi=Ke([F],oi);let Si=class{constructor(U,oe,Se){this.command=U,this.args=oe||[],this.options=Se}};e.$CL=Si,e.$CL=Si=Ke([F],Si);let Ii=class{constructor(U,oe){this.port=U,this.host=oe}};e.$DL=Ii,e.$DL=Ii=Ke([F],Ii);let Ft=class{constructor(U){this.path=U}};e.$EL=Ft,e.$EL=Ft=Ke([F],Ft);let pi=class{constructor(U){this.implementation=U}};e.$FL=pi,e.$FL=pi=Ke([F],pi);let Ci=class{constructor(U,oe,Se){this.session=U,this.threadId=oe,this.frameId=Se}};e.$GL=Ci,e.$GL=Ci=Ke([F],Ci);let ai=class{constructor(U,oe){this.session=U,this.threadId=oe}};e.$HL=ai,e.$HL=ai=Ke([F],ai);let ci=class{constructor(U,oe){this.range=U,this.expression=oe}};e.$IL=ci,e.$IL=ci=Ke([F],ci);var lt;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(lt||(e.InlineCompletionTriggerKind=lt={}));let Pi=class{constructor(U,oe){this.range=U,this.text=oe}};e.$JL=Pi,e.$JL=Pi=Ke([F],Pi);let xt=class{constructor(U,oe,Se=!0){this.range=U,this.variableName=oe,this.caseSensitiveLookup=Se}};e.$KL=xt,e.$KL=xt=Ke([F],xt);let ni=class{constructor(U,oe){this.range=U,this.expression=oe}};e.$LL=ni,e.$LL=ni=Ke([F],ni);let hi=class{constructor(U,oe){this.frameId=U,this.stoppedLocation=oe}};e.$ML=hi,e.$ML=hi=Ke([F],hi);var Xi;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Xi||(e.FileChangeType=Xi={}));let Ai=h=class extends Error{static FileExists(U){return new h(U,u.FileSystemProviderErrorCode.FileExists,h.FileExists)}static FileNotFound(U){return new h(U,u.FileSystemProviderErrorCode.FileNotFound,h.FileNotFound)}static FileNotADirectory(U){return new h(U,u.FileSystemProviderErrorCode.FileNotADirectory,h.FileNotADirectory)}static FileIsADirectory(U){return new h(U,u.FileSystemProviderErrorCode.FileIsADirectory,h.FileIsADirectory)}static NoPermissions(U){return new h(U,u.FileSystemProviderErrorCode.NoPermissions,h.NoPermissions)}static Unavailable(U){return new h(U,u.FileSystemProviderErrorCode.Unavailable,h.Unavailable)}constructor(U,oe=u.FileSystemProviderErrorCode.Unknown,Se){super(f.URI.isUri(U)?U.toString(!0):U),this.code=Se?.name??"Unknown",(0,u.$tk)(this,oe),Object.setPrototypeOf(this,h.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}};e.$NL=Ai,e.$NL=Ai=h=Ke([F],Ai);let Ri=class{constructor(U,oe,Se){this.start=U,this.end=oe,this.kind=Se}};e.$OL=Ri,e.$OL=Ri=Ke([F],Ri);var Mi;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(Mi||(e.FoldingRangeKind=Mi={}));var xi;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(xi||(e.CommentThreadCollapsibleState=xi={}));var Li;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(Li||(e.CommentMode=Li={}));var ui;(function(j){j[j.Published=0]="Published",j[j.Draft=1]="Draft"})(ui||(e.CommentState=ui={}));var _i;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(_i||(e.CommentThreadState=_i={}));class Fi{constructor(U,oe=[]){this.tokenTypes=U,this.tokenModifiers=oe}}e.$PL=Fi;function Ti(j){return typeof j>"u"||(0,E.$Df)(j)}class Oi{constructor(U){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,U){this.l=!0;for(let oe=0,Se=U.tokenTypes.length;oe<Se;oe++)this.j.set(U.tokenTypes[oe],oe);for(let oe=0,Se=U.tokenModifiers.length;oe<Se;oe++)this.k.set(U.tokenModifiers[oe],oe)}}push(U,oe,Se,Ge,xe){if(typeof U=="number"&&typeof oe=="number"&&typeof Se=="number"&&typeof Ge=="number"&&(typeof xe=="number"||typeof xe>"u"))return typeof xe>"u"&&(xe=0),this.n(U,oe,Se,Ge,xe);if(L.isRange(U)&&typeof oe=="string"&&Ti(Se))return this.m(U,oe,Se);throw(0,T.$6)()}m(U,oe,Se){if(!this.l)throw new Error("Legend must be provided in constructor");if(U.start.line!==U.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(oe))throw new Error("`tokenType` is not in the provided legend");const Ge=U.start.line,xe=U.start.character,at=U.end.character-U.start.character,ht=this.j.get(oe);let Ut=0;if(Se)for(const Zt of Se){if(!this.k.has(Zt))throw new Error("`tokenModifier` is not in the provided legend");const ei=this.k.get(Zt);Ut|=1<<ei>>>0}this.n(Ge,xe,at,ht,Ut)}n(U,oe,Se,Ge,xe){if(this.f&&(U<this.c||U===this.c&&oe<this.e)){this.f=!1;const Ut=this.g.length/5|0;let Zt=0,ei=0;for(let ii=0;ii<Ut;ii++){let ri=this.g[5*ii],Qi=this.g[5*ii+1];ri===0?(ri=Zt,Qi+=ei):ri+=Zt,this.g[5*ii]=ri,this.g[5*ii+1]=Qi,Zt=ri,ei=Qi}}let at=U,ht=oe;this.f&&this.h>0&&(at-=this.c,at===0&&(ht-=this.e)),this.g[this.h++]=at,this.g[this.h++]=ht,this.g[this.h++]=Se,this.g[this.h++]=Ge,this.g[this.h++]=xe,this.c=U,this.e=oe}static o(U){const oe=[],Se=U.length/5|0;for(let ht=0;ht<Se;ht++)oe[ht]=ht;oe.sort((ht,Ut)=>{const Zt=U[5*ht],ei=U[5*Ut];if(Zt===ei){const ii=U[5*ht+1],ri=U[5*Ut+1];return ii-ri}return Zt-ei});const Ge=new Uint32Array(U.length);let xe=0,at=0;for(let ht=0;ht<Se;ht++){const Ut=5*oe[ht],Zt=U[Ut+0],ei=U[Ut+1],ii=U[Ut+2],ri=U[Ut+3],Qi=U[Ut+4],Sn=Zt-xe,Tn=Sn===0?ei-at:ei,Yi=5*ht;Ge[Yi+0]=Sn,Ge[Yi+1]=Tn,Ge[Yi+2]=ii,Ge[Yi+3]=ri,Ge[Yi+4]=Qi,xe=Zt,at=ei}return Ge}build(U){return this.f?new Ni(new Uint32Array(this.g),U):new Ni(Oi.o(this.g),U)}}e.$QL=Oi;class Ni{constructor(U,oe){this.resultId=oe,this.data=U}}e.$RL=Ni;class di{constructor(U,oe,Se){this.start=U,this.deleteCount=oe,this.data=Se}}e.$SL=di;class hn{constructor(U,oe){this.resultId=oe,this.edits=U}}e.$TL=hn;var en;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(en||(e.DebugConsoleMode=en={}));let zi=class{static{this.Back={iconPath:new Xt("arrow-left")}}constructor(){}};e.$UL=zi,e.$UL=zi=Ke([F],zi);var vi;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(vi||(e.QuickPickItemKind=vi={}));var tn;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(tn||(e.InputBoxValidationSeverity=tn={}));var nn;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(nn||(e.ExtensionKind=nn={}));class bi{static validate(U){if(typeof U.badge=="string"){let oe=(0,$.$df)(U.badge,0);if(oe<U.badge.length&&(oe+=(0,$.$df)(U.badge,oe)),U.badge.length>oe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(U.badge&&!Xt.isThemeIcon(U.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!U.color&&!U.badge&&!U.tooltip)throw new Error("The decoration is empty");return!0}constructor(U,oe,Se){this.badge=U,this.tooltip=oe,this.color=Se}}e.$VL=bi;let wi=class{constructor(U){this.kind=U}};e.$WL=wi,e.$WL=wi=Ke([F],wi);var rn;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(rn||(e.ColorThemeKind=rn={}));class _t{static isNotebookRange(U){return U instanceof _t?!0:U?typeof U.start=="number"&&typeof U.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(U,oe){if(U<0)throw(0,T.$6)("start must be positive");if(oe<0)throw(0,T.$6)("end must be positive");U<=oe?(this.c=U,this.e=oe):(this.c=oe,this.e=U)}with(U){let oe=this.c,Se=this.e;return U.start!==void 0&&(oe=U.start),U.end!==void 0&&(Se=U.end),oe===this.c&&Se===this.e?this:new _t(oe,Se)}}e.$XL=_t;class fi{static validate(U){if(typeof U.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof U.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof U.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(U){return Array.isArray(U)&&U.every(oe=>fi.isNotebookCellData(oe))}static isNotebookCellData(U){return!0}constructor(U,oe,Se,Ge,xe,at,ht){this.kind=U,this.value=oe,this.languageId=Se,this.mime=Ge,this.outputs=xe??[],this.metadata=at,this.executionSummary=ht,fi.validate(this)}}e.$YL=fi;class dn{constructor(U){this.cells=U}}e.$ZL=dn;class Yt{static isNotebookCellOutputItem(U){return U instanceof Yt?!0:U?typeof U.mime=="string"&&U.data instanceof Uint8Array:!1}static error(U){const oe={name:U.name,message:U.message,stack:U.stack};return Yt.json(oe,"application/vnd.code.notebook.error")}static stdout(U){return Yt.text(U,"application/vnd.code.notebook.stdout")}static stderr(U){return Yt.text(U,"application/vnd.code.notebook.stderr")}static bytes(U,oe="application/octet-stream"){return new Yt(U,oe)}static#e=new TextEncoder;static text(U,oe=A.$Vr.text){const Se=Yt.#e.encode(String(U));return new Yt(Se,oe)}static json(U,oe="text/x-json"){const Se=JSON.stringify(U,void 0,"	");return Yt.text(Se,oe)}constructor(U,oe){this.data=U,this.mime=oe;const Se=(0,A.$Zr)(oe,!0);if(!Se)throw new Error(`INVALID mime type: ${oe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}}e.$1L=Yt;class yi{static isNotebookCellOutput(U){return U instanceof yi?!0:!U||typeof U!="object"?!1:typeof U.id=="string"&&Array.isArray(U.items)}static ensureUniqueMimeTypes(U,oe=!1){const Se=new Set,Ge=new Set;for(let xe=0;xe<U.length;xe++){const at=U[xe],ht=(0,A.$Zr)(at.mime);if(!Se.has(ht)||(0,v.$CI)(ht)){Se.add(ht);continue}Ge.add(xe),oe&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ge.size===0?U:U.filter((xe,at)=>!Ge.has(at))}constructor(U,oe,Se){this.items=yi.ensureUniqueMimeTypes(U,!0),typeof oe=="string"?(this.id=oe,this.metadata=Se):(this.id=(0,C.$ig)(),this.metadata=oe??Se)}}e.$2L=yi;var sn;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(sn||(e.NotebookCellKind=sn={}));var Ei;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(Ei||(e.NotebookCellExecutionState=Ei={}));var Ui;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Ui||(e.NotebookCellStatusBarAlignment=Ui={}));var Te;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Te||(e.NotebookEditorRevealType=Te={}));class ti{constructor(U,oe){this.text=U,this.alignment=oe}}e.$3L=ti;var ji;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(ji||(e.NotebookControllerAffinity=ji={}));var mt;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred",j[j.Hidden=-1]="Hidden"})(mt||(e.NotebookControllerAffinity2=mt={}));class fn{constructor(U,oe=[]){this.uri=U,this.provides=(0,y.$2b)(oe)}}e.$4L=fn;class gn{constructor(U){this.label=U}}e.$5L=gn;let Di=class{constructor(U,oe){this.label=U,this.timestamp=oe}};e.$6L=Di,e.$6L=Di=Ke([F],Di);var on;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(on||(e.ExtensionMode=on={}));var gi;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(gi||(e.ExtensionRuntime=gi={}));var an;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(an||(e.StandardTokenType=an={}));class mn{constructor(U,oe){this.ranges=U,this.wordPattern=oe}}e.$7L=mn;class $n{constructor(U){this.c=U}get autoForwardAction(){return this.c}}e.$8L=$n;var Bi;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(Bi||(e.TestResultState=Bi={}));var cn;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(cn||(e.TestRunProfileKind=cn={}));let Vi=class{constructor(U=void 0,oe=void 0,Se=void 0,Ge=!1){this.include=U,this.exclude=oe,this.profile=Se,this.continuous=Ge}};e.$9L=Vi,e.$9L=Vi=Ke([F],Vi);let Wi=w=class{static diff(U,oe,Se){const Ge=new w(U);return Ge.expectedOutput=oe,Ge.actualOutput=Se,Ge}constructor(U){this.message=U}};e.$0L=Wi,e.$0L=Wi=w=Ke([F],Wi);let qi=class{constructor(U){this.id=U}};e.$$L=qi,e.$$L=qi=Ke([F],qi);let li=class{constructor(U,oe){this.covered=U,this.total=oe}};e.$_L=li,e.$_L=li=Ke([F],li);let Ki=I=class{static fromDetails(U,oe){const Se=new li(0,0),Ge=new li(0,0),xe=new li(0,0);for(const ht of oe)if("branches"in ht){Se.total+=1,Se.covered+=ht.executionCount>0?1:0;for(const Ut of ht.branches)Ge.total+=1,Ge.covered+=Ut.executionCount>0?1:0}else xe.total+=1,xe.covered+=ht.executionCount>0?1:0;const at=new I(U,Se,Ge.total>0?Ge:void 0,xe.total>0?xe:void 0);return at.detailedCoverage=oe,at}constructor(U,oe,Se,Ge){this.uri=U,this.statementCoverage=oe,this.branchCoverage=Se,this.functionCoverage=Ge}};e.$aM=Ki,e.$aM=Ki=I=Ke([F],Ki);let Hi=class{constructor(U,oe,Se=[]){this.executionCount=U,this.location=oe,this.branches=Se}};e.$bM=Hi,e.$bM=Hi=Ke([F],Hi);let Gi=class{constructor(U,oe){this.executionCount=U,this.location=oe}};e.$cM=Gi,e.$cM=Gi=Ke([F],Gi);let Ji=class{constructor(U,oe){this.executionCount=U,this.location=oe}};e.$dM=Ji,e.$dM=Ji=Ke([F],Ji);var un;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(un||(e.ExternalUriOpenerPriority=un={}));var ee;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(ee||(e.WorkspaceTrustState=ee={}));var ge;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(ge||(e.PortAutoForwardAction=ge={}));class Fe{constructor(U,oe,Se,Ge,xe,at){this.kind=U,this.name=oe,this.detail=Se,this.uri=Ge,this.range=xe,this.selectionRange=at}}e.$eM=Fe;class ot{constructor(U){this.uri=U}}e.$fM=ot;class wt{constructor(U,oe){this.original=U,this.modified=oe}}e.$gM=wt;class Tt{constructor(U,oe,Se,Ge){this.base=U,this.input1=oe,this.input2=Se,this.result=Ge}}e.$hM=Tt;class In{constructor(U,oe){this.uri=U,this.viewType=oe}}e.$iM=In;class Cn{constructor(U){this.viewType=U}}e.$jM=Cn;class Pn{constructor(U,oe){this.uri=U,this.notebookType=oe}}e.$kM=Pn;class An{constructor(U,oe,Se){this.original=U,this.modified=oe,this.notebookType=Se}}e.$lM=An;class Rn{constructor(){}}e.$mM=Rn;class Mn{constructor(U,oe){this.uri=U,this.inputBoxUri=oe}}e.$nM=Mn;class Ln{constructor(U){this.providerId=U}}e.$oM=Ln;var pn;(function(j){j[j.Down=0]="Down",j[j.Up=1]="Up"})(pn||(e.InteractiveSessionVoteDirection=pn={}));var vn;(function(j){j[j.Action=1]="Action",j[j.Toolbar=2]="Toolbar"})(vn||(e.InteractiveSessionCopyKind=vn={}));var bn;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful",j[j.Undone=2]="Undone",j[j.Accepted=3]="Accepted",j[j.Bug=4]="Bug"})(bn||(e.InteractiveEditorResponseFeedbackKind=bn={}));var wn;(function(j){j[j.System=0]="System",j[j.User=1]="User",j[j.Assistant=2]="Assistant",j[j.Function=3]="Function"})(wn||(e.ChatMessageRole=wn={}));var yn;(function(j){j[j.Short=1]="Short",j[j.Medium=2]="Medium",j[j.Full=3]="Full"})(yn||(e.ChatVariableLevel=yn={}));class Fn{constructor(U,oe){this.role=U,this.content=oe}}e.$pM=Fn;var En;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful"})(En||(e.ChatAgentResultFeedbackKind=En={}));var Dn;(function(j){j[j.SymbolInformation=1]="SymbolInformation",j[j.CommandInformation=2]="CommandInformation",j[j.SearchInformation=3]="SearchInformation",j[j.SettingInformation=4]="SettingInformation"})(Dn||(e.RelatedInformationType=Dn={}));var kn;(function(j){j[j.Started=1]="Started",j[j.Recognizing=2]="Recognizing",j[j.Recognized=3]="Recognized",j[j.Stopped=4]="Stopped"})(kn||(e.SpeechToTextStatus=kn={}))}),define(Pe[103],Ae([1,0,53,13,12,295,147,7,18]),function(we,e,y,T,P,M,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EM=e.$DM=e.$CM=void 0;const f=new Map;function C(v,g){g?f.set(v,g):f.delete(v)}e.$CM=C;function D(v){return f.get(v)}class u extends M.$2u{constructor(g,t,i,r,c,o,l,n){super(t,i,r,c),this.c=g,this.m=o,this.q=l,this.notebook=n,this.b=!1}dispose(){(0,y.ok)(!this.b),this.b=!0,this.q=!1}equalLines(g){return(0,E.$tb)(this.f,g)}get document(){if(!this.a){const g=this;this.a={get uri(){return g.d},get fileName(){return g.d.fsPath},get isUntitled(){return g.d.scheme===T.Schemas.untitled},get languageId(){return g.m},get version(){return g.h},get isClosed(){return g.b},get isDirty(){return g.q},save(){return g.r()},getText(t){return t?g.s(t):g.getText()},get eol(){return g.g===`
`?$.EndOfLine.LF:$.EndOfLine.CRLF},get lineCount(){return g.f.length},lineAt(t){return g.t(t)},offsetAt(t){return g.u(t)},positionAt(t){return g.v(t)},validateRange(t){return g.w(t)},validatePosition(t){return g.x(t)},getWordRangeAtPosition(t,i){return g.y(t,i)}}}return Object.freeze(this.a)}_acceptLanguageId(g){(0,y.ok)(!this.b),this.m=g}_acceptIsDirty(g){(0,y.ok)(!this.b),this.q=g}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(g){const t=this.w(g);if(t.isEmpty)return"";if(t.isSingleLine)return this.f[t.start.line].substring(t.start.character,t.end.character);const i=this.g,r=t.start.line,c=t.end.line,o=[];o.push(this.f[r].substring(t.start.character));for(let l=r+1;l<c;l++)o.push(this.f[l]);return o.push(this.f[c].substring(0,t.end.character)),o.join(i)}t(g){let t;if(g instanceof $.$BK?t=g.line:typeof g=="number"&&(t=g),typeof t!="number"||t<0||t>=this.f.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new b(t,this.f[t],t===this.f.length-1)}u(g){return g=this.x(g),this.l(),this.j.getPrefixSum(g.line-1)+g.character}v(g){g=Math.floor(g),g=Math.max(0,g),this.l();const t=this.j.getIndexOf(g),i=this.f[t.index].length;return new $.$BK(t.index,Math.min(t.remainder,i))}w(g){if(!(g instanceof $.$CK))throw new Error("Invalid argument");const t=this.x(g.start),i=this.x(g.end);return t===g.start&&i===g.end?g:new $.$CK(t.line,t.character,i.line,i.character)}x(g){if(!(g instanceof $.$BK))throw new Error("Invalid argument");if(this.f.length===0)return g.with(0,0);let{line:t,character:i}=g,r=!1;if(t<0)t=0,i=0,r=!0;else if(t>=this.f.length)t=this.f.length-1,i=this.f[t].length,r=!0;else{const c=this.f[t].length;i<0?(i=0,r=!0):i>c&&(i=c,r=!0)}return r?new $.$BK(t,i):g}y(g,t){const i=this.x(g);if(!t)t=D(this.m);else if((0,P.$Se)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const r=(0,A.$bs)(i.character+1,(0,A.$_r)(t),this.f[i.line],0);if(r)return new $.$CK(i.line,r.startColumn-1,i.line,r.endColumn-1)}}e.$DM=u;class b{constructor(g,t,i){this.a=g,this.b=t,this.c=i}get lineNumber(){return this.a}get text(){return this.b}get range(){return new $.$CK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new $.$CK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$EM=b}),define(Pe[210],Ae([1,0,7,17,5]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pfc=void 0;let M=class{constructor($){this.a=new y.$WL(y.ColorThemeKind.Dark),this.b=new P.$Rd}get activeColorTheme(){return this.a}$onColorThemeChange($){let E;switch($){case"light":E=y.ColorThemeKind.Light;break;case"hcDark":E=y.ColorThemeKind.HighContrast;break;case"hcLight":E=y.ColorThemeKind.HighContrastLight;break;default:E=y.ColorThemeKind.Dark}this.a=new y.$WL(E),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Pfc=M,e.$Pfc=M=Ke([Ve(0,T.$AM)],M)}),define(Pe[211],Ae([1,0,4]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GI=e.CellExecutionUpdateType=void 0;var T;(function(P){P[P.Output=1]="Output",P[P.OutputItems=2]="OutputItems",P[P.ExecutionState=3]="ExecutionState"})(T||(e.CellExecutionUpdateType=T={})),e.$GI=(0,y.$Vh)("INotebookExecutionService")}),define(Pe[212],Ae([1,0,6,29,144,93]),function(we,e,y,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1Ob=void 0;class A extends y.$Rc{constructor(E,f,C){super(),this._source=E,this.b=f,this.c=C,this.a=void 0}f(E){const f=E.getLineCount();return new T.$zs(1,1,f,this.g(E,f))}g(E,f){if(f<1||f>E.getLineCount())throw new Error("Illegal value for lineNumber");return E.getLineLength(f)+1}get inputTextBuffer(){if(!this.b){const E=new P.$NB;E.acceptChunk(this._source);const f=E.finish(!0),{textBuffer:C,disposable:D}=f.create(1);this.b=C,this.B(D)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(E=>{const f=new P.$NB;f.acceptChunk(E);const C=f.finish(!0),{textBuffer:D,disposable:u}=C.create(1);return this.B(u),D})),this.a}findInInputs(E){const C=new M.$BB(E,!1,!1,null).parseSearchRequest();if(!C)return[];const D=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(D,C,!0,5e3)}findInOutputs(E){const C=new M.$BB(E,!1,!1,null).parseSearchRequest();return C?this.outputTextBuffers.map(D=>{const u=D.findMatchesLineByLine(this.f(D),C,!0,5e3);if(u.length!==0)return{textBuffer:D,matches:u}}).filter(D=>!!D):[]}}e.$1Ob=A}),define(Pe[48],Ae([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rJ=e.TestPosition=e.TestIdPathParts=void 0;var y;(function(M){M.Delimiter="\0"})(y||(e.TestIdPathParts=y={}));var T;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(T||(e.TestPosition=T={}));class P{static fromExtHostTestItem(A,$,E=A.parent){if(A._isRoot)return new P([$]);const f=[A.id];for(let C=E;C&&C.id!==$;C=C.parent)f.push(C.id);return f.push($),new P(f.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const $=A.indexOf("\0");return $===-1?A:A.slice(0,$)}static fromString(A){return new P(A.split("\0"))}static join(A,$){return new P([...A.path,$])}static joinToString(A,$){return A.toString()+"\0"+$}static parentId(A){const $=A.lastIndexOf("\0");return $===-1?void 0:A.slice(0,$)}static localId(A){const $=A.lastIndexOf("\0");return $===-1?A:A.slice($+1)}static isChild(A,$){return $.startsWith(A)&&$[A.length]==="\0"}static compare(A,$){return A===$?0:P.isChild(A,$)?2:P.isChild($,A)?3:1}constructor(A,$=A.length){if(this.path=A,this.d=$,A.length===0||$<1)throw new Error("cannot create test with empty path")}get rootId(){return new P(this.path,1)}get parentId(){return this.d>1?new P(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new P(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new P(this.path,A)}compare(A){if(typeof A=="string")return P.compare(this.toString(),A);for(let $=0;$<A.d&&$<this.d;$++)if(A.path[$]!==this.path[$])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$rJ=P}),define(Pe[58],Ae([1,0,2,29,48]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yJ=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$xJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$wJ=e.$vJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$uJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$tJ=e.$sJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var M;(function(k){k[k.Unset=0]="Unset",k[k.Queued=1]="Queued",k[k.Running=2]="Running",k[k.Passed=3]="Passed",k[k.Failed=4]="Failed",k[k.Skipped=5]="Skipped",k[k.Errored=6]="Errored"})(M||(e.TestResultState=M={}));var A;(function(k){k[k.Run=1]="Run",k[k.Debug=2]="Debug",k[k.Coverage=3]="Coverage"})(A||(e.ExtTestRunProfileKind=A={}));var $;(function(k){k[k.Run=2]="Run",k[k.Debug=4]="Debug",k[k.Coverage=8]="Coverage",k[k.HasNonDefaultProfile=16]="HasNonDefaultProfile",k[k.HasConfigurable=32]="HasConfigurable",k[k.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$sJ=[2,4,8,16,32,64];const E=k=>"runId"in k;e.$tJ=E;var f;(function(k){k.serialize=h=>({range:h.range.toJSON(),uri:h.uri.toJSON()}),k.deserialize=h=>({range:T.$zs.lift(h.range),uri:y.URI.revive(h.uri)})})(f||(e.IRichLocation=f={}));var C;(function(k){k[k.Error=0]="Error",k[k.Output=1]="Output"})(C||(e.TestMessageType=C={}));var D;(function(k){k.serialize=h=>({message:h.message,type:0,expected:h.expected,actual:h.actual,contextValue:h.contextValue,location:h.location&&f.serialize(h.location)}),k.deserialize=h=>({message:h.message,type:0,expected:h.expected,actual:h.actual,contextValue:h.contextValue,location:h.location&&f.deserialize(h.location)})})(D||(e.ITestErrorMessage=D={}));const u=(k,h)=>`${h?"s":"e"}${k}`;e.$uJ=u;var b;(function(k){k.serialize=h=>({message:h.message,type:1,offset:h.offset,length:h.length,location:h.location&&f.serialize(h.location)}),k.deserialize=h=>({message:h.message,type:1,offset:h.offset,length:h.length,location:h.location&&f.deserialize(h.location)})})(b||(e.ITestOutputMessage=b={}));var v;(function(k){k.serialize=h=>h.type===0?D.serialize(h):b.serialize(h),k.deserialize=h=>h.type===0?D.deserialize(h):b.deserialize(h)})(v||(e.ITestMessage=v={}));var g;(function(k){k.serializeWithoutMessages=h=>({state:h.state,duration:h.duration,messages:[]}),k.serialize=h=>({state:h.state,duration:h.duration,messages:h.messages.map(v.serialize)}),k.deserialize=h=>({state:h.state,duration:h.duration,messages:h.messages.map(v.deserialize)})})(g||(e.ITestTaskState=g={}));const t="\0",i=(k,h)=>k+t+h;e.$vJ=i;const r=k=>{const h=k.indexOf(t);return{ctrlId:k.slice(0,h),tagId:k.slice(h+1)}};e.$wJ=r;var c;(function(k){k.serialize=h=>({extId:h.extId,label:h.label,tags:h.tags,busy:h.busy,children:void 0,uri:h.uri?.toJSON(),range:h.range?.toJSON()||null,description:h.description,error:h.error,sortText:h.sortText}),k.deserialize=h=>({extId:h.extId,label:h.label,tags:h.tags,busy:h.busy,children:void 0,uri:h.uri?y.URI.revive(h.uri):void 0,range:h.range?T.$zs.lift(h.range):null,description:h.description,error:h.error,sortText:h.sortText})})(c||(e.ITestItem=c={}));var o;(function(k){k[k.NotExpandable=0]="NotExpandable",k[k.Expandable=1]="Expandable",k[k.BusyExpanding=2]="BusyExpanding",k[k.Expanded=3]="Expanded"})(o||(e.TestItemExpandState=o={}));var l;(function(k){k.serialize=h=>({expand:h.expand,item:c.serialize(h.item)}),k.deserialize=h=>({controllerId:P.$rJ.root(h.item.extId),expand:h.expand,item:c.deserialize(h.item)})})(l||(e.InternalTestItem=l={}));var n;(function(k){k.serialize=h=>{let w;return h.item&&(w={},h.item.label!==void 0&&(w.label=h.item.label),h.item.tags!==void 0&&(w.tags=h.item.tags),h.item.busy!==void 0&&(w.busy=h.item.busy),h.item.uri!==void 0&&(w.uri=h.item.uri?.toJSON()),h.item.range!==void 0&&(w.range=h.item.range?.toJSON()),h.item.description!==void 0&&(w.description=h.item.description),h.item.error!==void 0&&(w.error=h.item.error),h.item.sortText!==void 0&&(w.sortText=h.item.sortText)),{extId:h.extId,expand:h.expand,item:w}},k.deserialize=h=>{let w;return h.item&&(w={},h.item.label!==void 0&&(w.label=h.item.label),h.item.tags!==void 0&&(w.tags=h.item.tags),h.item.busy!==void 0&&(w.busy=h.item.busy),h.item.range!==void 0&&(w.range=h.item.range?T.$zs.lift(h.item.range):null),h.item.description!==void 0&&(w.description=h.item.description),h.item.error!==void 0&&(w.error=h.item.error),h.item.sortText!==void 0&&(w.sortText=h.item.sortText)),{extId:h.extId,expand:h.expand,item:w}}})(n||(e.ITestItemUpdate=n={}));const s=(k,h)=>{h.expand!==void 0&&(k.expand=h.expand),h.item!==void 0&&(k.item=k.item?Object.assign(k.item,h.item):h.item)};e.$xJ=s;var a;(function(k){k.serializeWithoutMessages=h=>({...l.serialize(h),ownComputedState:h.ownComputedState,computedState:h.computedState,tasks:h.tasks.map(g.serializeWithoutMessages)}),k.serialize=h=>({...l.serialize(h),ownComputedState:h.ownComputedState,computedState:h.computedState,tasks:h.tasks.map(g.serialize)}),k.deserialize=h=>({...l.deserialize(h),ownComputedState:h.ownComputedState,computedState:h.computedState,tasks:h.tasks.map(g.deserialize),retired:!0})})(a||(e.TestResultItem=a={}));var d;(function(k){k[k.Function=0]="Function",k[k.Statement=1]="Statement"})(d||(e.DetailType=d={}));var p;(function(k){k[k.Add=0]="Add",k[k.Update=1]="Update",k[k.DocumentSynced=2]="DocumentSynced",k[k.Remove=3]="Remove",k[k.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",k[k.Retire=5]="Retire",k[k.AddTag=6]="AddTag",k[k.RemoveTag=7]="RemoveTag"})(p||(e.TestDiffOpType=p={}));var m;(function(k){k.deserialize=h=>h.op===0?{op:h.op,item:l.deserialize(h.item)}:h.op===1?{op:h.op,item:n.deserialize(h.item)}:h.op===2?{op:h.op,uri:y.URI.revive(h.uri),docv:h.docv}:h,k.serialize=h=>h.op===0?{op:h.op,item:l.serialize(h.item)}:h.op===1?{op:h.op,item:n.serialize(h.item)}:h})(m||(e.TestsDiffOp=m={}));class S{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(h){const w=this.o();for(const I of h)switch(I.op){case 0:this.j(l.deserialize(I.item),w);break;case 1:this.k(n.deserialize(I.item),w);break;case 3:this.l(I.itemId,w);break;case 5:this.m(I.itemId);break;case 4:this.updatePendingRoots(I.amount);break;case 6:this.c.set(I.tag.id,I.tag);break;case 7:this.c.delete(I.id);break}w.complete?.()}j(h,w){const I=P.$rJ.parentId(h.item.extId)?.toString();let F;if(!I)F=this.p(h),this.f.add(F),this.d.set(h.item.extId,F);else if(this.d.has(I)){const V=this.d.get(I);V.children.add(h.item.extId),F=this.p(h,V),this.d.set(h.item.extId,F)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(h)}`);return}return w.add?.(F),h.expand===2&&this.g++,F}k(h,w){const I=this.d.get(h.extId);if(I)return h.expand!==void 0&&(I.expand===2&&this.g--,h.expand===2&&this.g++),(0,e.$xJ)(I,h),w.update?.(I),I}l(h,w){const I=this.d.get(h);if(!I)return;const F=P.$rJ.parentId(I.item.extId)?.toString();F?this.d.get(F).children.delete(I.item.extId):this.f.delete(I);const V=[[h]];for(;V.length;)for(const Z of V.pop()){const N=this.d.get(Z);N&&(V.push(N.children),this.d.delete(Z),w.remove?.(N,N!==I),N.expand===2&&this.g--)}}m(h){}updatePendingRoots(h){this.h+=h}o(){return{}}}e.$yJ=S}),define(Pe[77],Ae([1,0,14,5,6,53,58,48]),function(we,e,y,T,P,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uM=e.$tM=e.$sM=e.$rM=e.$qM=e.TestItemEventOp=void 0;var E;(function(r){r[r.Upsert=0]="Upsert",r[r.SetTags=1]="SetTags",r[r.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",r[r.RemoveChild=3]="RemoveChild",r[r.SetProp=4]="SetProp",r[r.Bulk=5]="Bulk",r[r.DocumentSynced=6]="DocumentSynced"})(E||(e.TestItemEventOp=E={}));const f=(r,c)=>r===c,D=Object.entries({range:(r,c)=>r===c?!0:!r||!c?!1:r.equalsRange(c),busy:f,label:f,description:f,error:f,sortText:f,tags:(r,c)=>!(r.length!==c.length||r.some(o=>!c.includes(o)))}),u=(r,c)=>{let o;for(const[l,n]of D)n(r[l],c[l])||(o?o[l]=c[l]:o={[l]:c[l]});return o};class b extends P.$Rc{get root(){return this.s.root}constructor(c){super(),this.s=c,this.f=this.B(new y.$0g(()=>this.flushDiff(),200)),this.g=this.B(new T.$Rd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(c){this.h=c;for(const o of this.tree.values())this.I(o)}get resolveHandler(){return this.h}collectDiff(){const c=this.m;return this.m=[],c}pushDiff(c){switch(c.op){case 2:{for(const o of this.m)if(o.op===2&&o.uri===c.uri){o.docv=c.docv;return}break}case 1:{const o=this.m[this.m.length-1];if(o){if(o.op===1&&o.item.extId===c.item.extId){(0,A.$xJ)(o.item,c.item);return}if(o.op===0&&o.item.item.extId===c.item.extId){(0,A.$xJ)(o.item,c.item);return}}break}}this.m.push(c),this.f.isScheduled()||this.f.schedule()}expand(c,o){const l=this.tree.get(c);if(l){if((l.expandLevels===void 0||o>l.expandLevels)&&(l.expandLevels=o),l.expand===1){const n=this.L(l);return n.isOpen()?this.J(l,o-1):n.wait().then(()=>this.J(l,o-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.J(l,o-1)):this.J(l,o-1)}}dispose(){for(const c of this.tree.values())this.s.getApiFor(c.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(c,o){switch(o.op){case 3:this.N($.$rJ.joinToString(c.fullId,o.id));break;case 0:this.y(o.item,c);break;case 5:for(const l of o.ops)this.u(c,l);break;case 1:this.z(o.new,o.old,c.fullId.toString());break;case 2:this.I(c);break;case 4:this.pushDiff({op:1,item:{extId:c.fullId.toString(),item:o.update}});break;case 6:this.w(c.actual.uri);break;default:(0,M.$4c)(o)}}w(c){c&&this.pushDiff({op:2,uri:c,docv:this.s.getDocumentVersion(c)})}y(c,o){const l=$.$rJ.fromExtHostTestItem(c,this.root.id,o?.actual),n=this.s.getApiFor(c);n.parent&&n.parent!==o?.actual&&this.s.getChildren(n.parent).delete(c.id);let s=this.tree.get(l.toString());if(!s){s={fullId:l,actual:c,expandLevels:o?.expandLevels?o.expandLevels-1:void 0,expand:0},c.tags.forEach(this.C,this),this.tree.set(s.fullId.toString(),s),this.F(c,o),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:s.expand,item:this.s.toITestItem(c)}}),this.H(c,s,o);return}if(s.actual===c){this.G(c,s,o);return}if(s.actual.uri?.toString()!==c.uri?.toString())return this.N(l.toString()),this.y(c,o);const a=this.s.getChildren(s.actual),d=s.actual,p=u(this.s.toITestItem(d),this.s.toITestItem(c));this.s.getApiFor(d).listener=void 0,s.actual=c,s.expand=0,p&&(p.hasOwnProperty("tags")&&(this.z(c.tags,d.tags,l.toString()),delete p.tags),this.u(s,{op:4,update:p})),this.H(c,s,o);for(const[m,S]of a)this.s.getChildren(c).get(S.id)||this.N($.$rJ.joinToString(l,S.id));this.w(s.actual.uri)}z(c,o,l){const n=new Set(o.map(s=>s.id));for(const s of c)n.delete(s.id)||this.C(s);this.pushDiff({op:1,item:{extId:l,item:{tags:c.map(s=>(0,A.$vJ)(this.s.controllerId,s.id))}}}),n.forEach(this.D,this)}C(c){const o=this.j.get(c.id);o?o.refCount++:(this.j.set(c.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$vJ)(this.s.controllerId,c.id)}}))}D(c){const o=this.j.get(c);o&&!--o.refCount&&(this.j.delete(c),this.pushDiff({op:7,id:(0,A.$vJ)(this.s.controllerId,c)}))}F(c,o){this.s.getApiFor(c).parent=o&&o.actual!==this.root?o.actual:void 0}G(c,o,l){this.F(c,l);const n=this.s.getApiFor(c);n.parent=l?.actual,n.listener=s=>this.u(o,s),this.I(o)}H(c,o,l){this.G(c,o,l);for(const[n,s]of this.s.getChildren(c))this.y(s,o)}I(c){let o;this.h?c.resolveBarrier?o=c.resolveBarrier.isOpen()?3:2:o=c.actual.canResolveChildren?1:0:o=0,o!==c.expand&&(c.expand=o,this.pushDiff({op:1,item:{extId:c.fullId.toString(),expand:o}}),o===1&&c.expandLevels!==void 0&&this.L(c))}J(c,o){if(o<0)return;const l=[];for(const[n,s]of this.s.getChildren(c.actual)){const a=this.expand($.$rJ.joinToString(c.fullId,s.id),o);(0,y.$Kg)(a)&&l.push(a)}if(l.length)return Promise.all(l).then(()=>{})}L(c){if(c.resolveBarrier)return c.resolveBarrier;if(!this.h){const s=new y.$Wg;return s.open(),s}c.expand=2,this.M(c);const o=c.resolveBarrier=new y.$Wg,l=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,s)};let n;try{n=this.h(c.actual===this.root?void 0:c.actual)}catch(s){l(s)}return(0,y.$Kg)(n)?n.catch(l).then(()=>{o.open(),this.I(c)}):(o.open(),this.I(c)),c.resolveBarrier}M(c){this.pushDiff({op:1,item:{extId:c.fullId.toString(),expand:c.expand}})}N(c){const o=this.tree.get(c);if(!o)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:c});const l=[o];for(;l.length;){const n=l.pop();if(n){this.s.getApiFor(n.actual).listener=void 0;for(const s of n.actual.tags)this.D(s.id);this.tree.delete(n.fullId.toString());for(const[s,a]of this.s.getChildren(n.actual))l.push(this.tree.get($.$rJ.joinToString(n.fullId,a.id)))}}}flushDiff(){const c=this.collectDiff();c.length&&this.g.fire(c)}}e.$qM=b;class v extends Error{constructor(c){super(`Attempted to insert a duplicate test item ID ${c}`)}}e.$rM=v;class g extends Error{constructor(c){super(`TestItem with ID "${c}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$sM=g;class t extends Error{constructor(c,o,l){super(`TestItem with ID "${c}" is from controller "${o}" and cannot be added as a child of an item from controller "${l}".`)}}e.$tM=t;const i=(r,c,o)=>{let l=new Map;return{get size(){return l.size},forEach(n,s){for(const a of l.values())n.call(s,a,this)},[Symbol.iterator](){return l.entries()},replace(n){const s=new Map,a=new Set(l.keys()),d={op:5,ops:[]};for(const p of n){if(!(p instanceof o))throw new g(p.id);const m=c(p).controllerId;if(m!==r.controllerId)throw new t(p.id,m,r.controllerId);if(s.has(p.id))throw new v(p.id);s.set(p.id,p),a.delete(p.id),d.ops.push({op:0,item:p})}for(const p of a.keys())d.ops.push({op:3,id:p});r.listener?.(d),l=s},add(n){if(!(n instanceof o))throw new g(n.id);l.set(n.id,n),r.listener?.({op:0,item:n})},delete(n){l.delete(n)&&r.listener?.({op:3,id:n})},get(n){return l.get(n)},toJSON(){return Array.from(l.values())}}};e.$uM=i}),define(Pe[104],Ae([1,0,77]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wM=e.$vM=void 0;const T=new WeakMap,P=(A,$)=>{const E={controllerId:$};return T.set(A,E),E};e.$vM=P;const M=A=>{const $=T.get(A);if(!$)throw new y.$sM(A?.id||"<unknown>");return $};e.$wM=M}),define(Pe[78],Ae([1,0,13,2]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_tb=e.$$tb=e.$0tb=e.$9tb=e.$8tb=void 0,e.$8tb="vscode-cdn.net",e.$9tb=`vscode-resource.${e.$8tb}`,e.$0tb=`'self' https://*.${e.$8tb}`;function P($,E){return $.scheme===y.Schemas.http||$.scheme===y.Schemas.https?$:(E&&E.authority&&E.isRemote&&$.scheme===y.Schemas.file&&($=T.URI.from({scheme:y.Schemas.vscodeRemote,authority:E.authority,path:$.path})),T.URI.from({scheme:y.Schemas.https,authority:`${$.scheme}+${M($.authority)}.${e.$9tb}`,path:$.path,fragment:$.fragment,query:$.query}))}e.$$tb=P;function M($){return $.replace(/./g,E=>{const f=E.charCodeAt(0);return f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57?E:"-"+f.toString(16).padStart(4,"0")})}function A($){return $.replace(/-([0-9a-f]{4})/g,(E,f)=>String.fromCharCode(parseInt(f,16)))}e.$_tb=A}),define(Pe[213],Ae([1,0,5,6,78]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_dc=void 0;class M{constructor($,E,f){this.d=$,this.e=E,this.f=f,this.a=0,this.b=new T.$Qc,this.c=new Map,this.b.add(E.onDidChangeVisibleTextEditors(()=>{const C=E.getVisibleTextEditors();for(const D of this.c.values())C.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this.c.forEach($=>$.inset.dispose()),this.b.dispose()}createWebviewEditorInset($,E,f,C,D){let u;for(const c of this.e.getVisibleTextEditors(!0))if(c.value===$){u=c;break}if(!u)throw new Error("not a visible editor");const b=this,v=this.a++,g=new y.$Rd,t=new y.$Rd,i=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(c){return(0,P.$$tb)(c,b.f)}get cspSource(){return P.$0tb}set options(c){this.b=c,b.d.$setOptions(v,c)}get options(){return this.b}set html(c){this.a=c,b.d.$setHtml(v,c)}get html(){return this.a}get onDidReceiveMessage(){return g.event}postMessage(c){return b.d.$postMessage(v,c)}},r=new class{constructor(){this.editor=$,this.line=E,this.height=f,this.webview=i,this.onDidDispose=t.event}dispose(){b.c.has(v)&&(b.c.delete(v),b.d.$disposeEditorInset(v),t.fire(),t.dispose(),g.dispose())}};return this.d.$createEditorInset(v,u.id,u.value.document.uri,E+1,f,C||{},D.identifier,D.extensionLocation),this.c.set(v,{editor:$,inset:r,onDidReceiveMessage:g}),r}$onDidDispose($){const E=this.c.get($);E&&E.inset.dispose()}$onDidReceiveMessage($,E){this.c.get($)?.onDidReceiveMessage.fire(E)}}e.$_dc=M}),define(Pe[214],Ae([1,0,4]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nN=e.VariableKind=e.$mN=void 0,e.$mN=(0,y.$Vh)("configurationResolverService");var T;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator"})(T||(e.VariableKind=T={}));class P extends Error{constructor(A,$){super($),this.variable=A}}e.$nN=P}),define(Pe[215],Ae([1,0,20,74,16,26,21,94,177,214,12]),function(we,e,y,T,P,M,A,$,E,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BN=void 0;class D{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(b,v,g,t){this.h=new Map,this.a=b,this.b=v,this.g=g,t&&(this.c=t.then(i=>this.i(i)))}i(b){if(A.$i){const v=Object.create(null);return Object.keys(b).forEach(g=>{v[g.toLowerCase()]=b[g]}),v}return b}resolveWithEnvironment(b,v,g){return this.l({env:this.i(b),userHome:void 0},v?v.uri:void 0,g)}async resolveAsync(b,v){const g={env:await this.c,userHome:await this.g};return this.l(g,b?b.uri:void 0,v)}async j(b,v,g,t){const i=M.$an(v);A.$i&&i.windows?Object.keys(i.windows).forEach(c=>i[c]=i.windows[c]):A.$j&&i.osx?Object.keys(i.osx).forEach(c=>i[c]=i.osx[c]):A.$k&&i.linux&&Object.keys(i.linux).forEach(c=>i[c]=i.linux[c]),delete i.windows,delete i.osx,delete i.linux;const r={env:await this.c,userHome:await this.g};return this.l(r,b?b.uri:void 0,i,g,t)}async resolveAnyAsync(b,v,g){return this.j(b,v,g)}async resolveAnyMap(b,v,g){const t=new Map;return{newConfig:await this.j(b,v,g,t),resolvedVariables:t}}resolveWithInteractionReplace(b,v,g,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(b,v,g,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(b,v){if(this.h.has(b))throw new Error("Variable "+b+" is contributed twice.");this.h.set(b,v)}async l(b,v,g,t,i){if(P.$Cf(g))return this.m(b,v,g,t,i);if(Array.isArray(g))return Promise.all(g.map(r=>this.l(b,v,r,t,i)));if(P.$Ef(g)){const r=Object.create(null),c=await Promise.all(Object.keys(g).map(async o=>[await this.m(b,v,o,t,i),await this.l(b,v,g[o],t,i)]));for(const[o,l]of c)r[o]=l;return r}return g}m(b,v,g,t,i){return(0,C.$Xe)(g,D.VARIABLE_REGEXP,async(r,c)=>{if(c.includes(D.VARIABLE_LHS))return r;let o=await this.o(b,r,c,v,t);return i?.set(c,o),o!==r&&P.$Cf(o)&&o.match(D.VARIABLE_REGEXP)&&(o=await this.m(b,v,o,t,i)),o})}n(b){return this.b?this.b.getUriLabel(b,{noPrefix:!0}):b.fsPath}async o(b,v,g,t,i){let r;const c=g.split(":");c.length>1&&(g=c[0],r=c[1]);const o=s=>{const a=this.a.getFilePath();if(a)return(0,$.$zv)(a);throw new f.$nN(s,(0,E.localize)(0,null,v))},l=s=>{const a=o(s);if(this.a.getWorkspaceFolderPathForFile){const d=this.a.getWorkspaceFolderPathForFile();if(d)return(0,$.$zv)(d)}throw new f.$nN(s,(0,E.localize)(1,null,v,y.$mc(a)))},n=s=>{if(r){const a=this.a.getFolderUri(r);if(a)return a;throw new f.$nN(s,(0,E.localize)(2,null,v,r))}if(t)return t;throw this.a.getWorkspaceFolderCount()>1?new f.$nN(s,(0,E.localize)(3,null,v)):new f.$nN(s,(0,E.localize)(4,null,v))};switch(g){case"env":if(r){if(b.env){const s=b.env[A.$i?r.toLowerCase():r];if(P.$Cf(s))return s}return""}throw new f.$nN(f.VariableKind.Env,(0,E.localize)(5,null,v));case"config":if(r){const s=this.a.getConfigurationValue(t,r);if(P.$Lf(s))throw new f.$nN(f.VariableKind.Config,(0,E.localize)(6,null,v,r));if(P.$Ef(s))throw new f.$nN(f.VariableKind.Config,(0,E.localize)(7,null,v,r));return s}throw new f.$nN(f.VariableKind.Config,(0,E.localize)(8,null,v));case"command":return this.p(f.VariableKind.Command,v,r,i,"command");case"input":return this.p(f.VariableKind.Input,v,r,i,"input");case"extensionInstallFolder":if(r){const s=await this.a.getExtension(r);if(!s)throw new f.$nN(f.VariableKind.ExtensionInstallFolder,(0,E.localize)(9,null,v,r));return this.n(s.extensionLocation)}throw new f.$nN(f.VariableKind.ExtensionInstallFolder,(0,E.localize)(10,null,v));default:switch(g){case"workspaceRoot":case"workspaceFolder":return(0,$.$zv)(this.n(n(f.VariableKind.WorkspaceFolder)));case"cwd":return t||r?(0,$.$zv)(this.n(n(f.VariableKind.Cwd))):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,$.$zv)(y.$mc(this.n(n(f.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(b.userHome)return b.userHome;throw new f.$nN(f.VariableKind.UserHome,(0,E.localize)(11,null,v))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new f.$nN(f.VariableKind.LineNumber,(0,E.localize)(12,null,v))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new f.$nN(f.VariableKind.SelectedText,(0,E.localize)(13,null,v))}case"file":return o(f.VariableKind.File);case"fileWorkspaceFolder":return l(f.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return y.$mc(l(f.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return t||r?y.$kc(this.n(n(f.VariableKind.RelativeFile)),o(f.VariableKind.RelativeFile)):o(f.VariableKind.RelativeFile);case"relativeFileDirname":{const s=y.$lc(o(f.VariableKind.RelativeFileDirname));if(t||r){const a=y.$kc(this.n(n(f.VariableKind.RelativeFileDirname)),s);return a.length===0?".":a}return s}case"fileDirname":return y.$lc(o(f.VariableKind.FileDirname));case"fileExtname":return y.$nc(o(f.VariableKind.FileExtname));case"fileBasename":return y.$mc(o(f.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=y.$mc(o(f.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-y.$nc(s).length)}case"fileDirnameBasename":return y.$mc(y.$lc(o(f.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||v}case"execInstallFolder":{const s=this.a.getAppRoot();return s||v}case"pathSeparator":return y.sep;default:try{const s=r?`${g}:${r}`:g;return this.p(f.VariableKind.Unknown,v,s,i,void 0)}catch{return v}}}}p(b,v,g,t,i){if(g&&t){const r=i===void 0?t[g]:t[i+":"+g];if(typeof r=="string")return r;throw new f.$nN(b,(0,E.localize)(14,null,v))}return v}}e.$BN=D}),define(Pe[105],Ae([1,0,4,102]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JC=e.$IC=e.OpenEditorContext=e.GroupsOrder=e.$HC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$GC=void 0,e.$GC=(0,y.$Vh)("editorGroupsService");var P;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(P||(e.GroupDirection=P={}));var M;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(M||(e.GroupOrientation=M={}));var A;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var $;(function(v){v[v.MAXIMIZE=0]="MAXIMIZE",v[v.EXPAND=1]="EXPAND",v[v.EVEN=2]="EVEN"})($||(e.GroupsArrangement=$={}));var E;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})(E||(e.MergeGroupMode=E={}));function f(v){const g=v;return(0,T.$pE)(g?.editor)&&(0,T.$pE)(g?.replacement)}e.$HC=f;var C;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(C||(e.GroupsOrder=C={}));var D;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(D||(e.OpenEditorContext=D={}));function u(v){const g=v;return!!g&&typeof g.id=="number"&&Array.isArray(g.editors)}e.$IC=u;function b(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$JC=b}),define(Pe[216],Ae([1,0,4,105]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NC=e.$MC=e.$LC=e.$KC=void 0,e.$KC=(0,y.$Vh)("editorService"),e.$LC=-1,e.$MC=-2;function P(M){const A=M;return typeof M=="number"||(0,T.$IC)(A)}e.$NC=P}),define(Pe[217],Ae([1,0,4,184]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VJ=void 0,e.$VJ=(0,y.$Wh)(T.$3h)}),define(Pe[106],Ae([1,0,22,5,20,6]),function(we,e,y,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$05b=e.$95b=e.$85b=e.$75b=e.$65b=void 0;class A{constructor(i,r){this.versionId=i,this.removedDueToLooping=r}}e.$65b=A;class ${static isHostExtension(i,r,c){if(r.getExtensionDescription(i))return!1;const o=c.getExtensionDescription(i);return o?!!((o.main||o.browser)&&o.api==="none"):!1}constructor(i,r){this.j=i,this.c=new T.$Rd,this.onDidChange=this.c.event,this.d=0,this.e=r,this.k()}k(){this.e.sort(v),this.f=new y.$bm,this.g=[],this.h=new Map;for(const i of this.e){if(this.f.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this.f.set(i.identifier,i),this.g.push(i);const r=this.j.readActivationEvents(i);for(const c of r)this.h.has(c)||this.h.set(c,[]),this.h.get(c).push(i)}}set(i){return this.e=i,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(i,r){this.e=g(this.e,r),this.e=this.e.concat(i);const c=$.l(this.e);return this.e=g(this.e,c.map(o=>o.identifier)),this.k(),this.d++,this.c.fire(void 0),new A(this.d,c)}static l(i){const r=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(s){this.d.has(s)||(this.d.add(s),this.e.push(s))}addArc(s,a){this.addNode(s),this.addNode(a),this.c.has(s)?this.c.get(s).push(a):this.c.set(s,[a])}getArcs(s){return this.c.has(s)?this.c.get(s):[]}hasOnlyGoodArcs(s,a){const d=r.getArcs(s);for(let p=0;p<d.length;p++)if(!a.has(d[p]))return!1;return!0}getNodes(){return this.e}},c=new y.$bm;for(const s of i)if(c.set(s.identifier,s),s.extensionDependencies)for(const a of s.extensionDependencies)r.addArc(y.$_l.toKey(s.identifier),y.$_l.toKey(a));const o=new Set;r.getNodes().filter(s=>r.getArcs(s).length===0).forEach(s=>o.add(s));const l=r.getNodes().filter(s=>!o.has(s));let n;do{n=!1;for(let s=0;s<l.length;s++){const a=l[s];r.hasOnlyGoodArcs(a,o)&&(l.splice(s,1),s--,o.add(a),n=!0)}}while(n);return l.map(s=>c.get(s))}containsActivationEvent(i){return this.h.has(i)}containsExtension(i){return this.f.has(i)}getExtensionDescriptionsForActivationEvent(i){const r=this.h.get(i);return r?r.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new E(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(i){const r=this.f.get(i);return r||void 0}getExtensionDescriptionByUUID(i){for(const r of this.g)if(r.uuid===i)return r}getExtensionDescriptionByIdOrUUID(i,r){return this.getExtensionDescription(i)??(r?this.getExtensionDescriptionByUUID(r):void 0)}}e.$75b=$;class E{constructor(i,r){this.versionId=i,this.extensions=r}}e.$85b=E;class f{constructor(i){this.d=new u,this.c=new $(i,[])}async acquireLock(i){const r=await this.d.acquire(i);return new C(this,r)}deltaExtensions(i,r,c){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(r,c)}containsActivationEvent(i){return this.c.containsActivationEvent(i)}containsExtension(i){return this.c.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this.c.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(i){return this.c.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this.c.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,r){return this.c.getExtensionDescriptionByIdOrUUID(i,r)}}e.$95b=f;class C extends M.$Rc{constructor(i,r){super(),this.f=i,this.c=!1,this.B(r)}isAcquiredFor(i){return!this.c&&this.f===i}}e.$05b=C;class D{constructor(i){this.name=i,this.promise=new Promise((r,c)=>{this.c=r})}resolve(i){this.c(i)}}class u{constructor(){this.c=[],this.d=!1}async acquire(i){const r=new D(i);return this.c.push(r),this.e(),r.promise}e(){if(this.d||this.c.length===0)return;const i=this.c.shift();this.d=!0;let r=!0;const c=setTimeout(()=>{r&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),o=()=>{r&&(clearTimeout(c),r=!1,this.d=!1,this.e())};i.resolve((0,M.$Pc)(o))}}var b;(function(t){t[t.Builtin=0]="Builtin",t[t.User=1]="User",t[t.Dev=2]="Dev"})(b||(b={}));function v(t,i){const r=t.isBuiltin?0:t.isUnderDevelopment?2:1,c=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(r!==c)return r-c;const o=P.$fc.basename(t.extensionLocation.path),l=P.$fc.basename(i.extensionLocation.path);return o<l?-1:o>l?1:0}function g(t,i){const r=new y.$am(i);return t.filter(c=>!r.has(c.identifier))}}),define(Pe[79],Ae([1,0,24]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$im=e.$hm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var T;(function(f){f[f.Desktop=1]="Desktop",f[f.Web=2]="Web"})(T||(e.UIKind=T={}));var P;(function(f){f[f.VersionMismatch=55]="VersionMismatch",f[f.UnexpectedError=81]="UnexpectedError"})(P||(e.ExtensionHostExitCode=P={}));var M;(function(f){f[f.Initialized=0]="Initialized",f[f.Ready=1]="Ready",f[f.Terminate=2]="Terminate"})(M||(e.MessageType=M={}));function A(f){const C=y.$fe.alloc(1);switch(f){case 0:C.writeUInt8(1,0);break;case 1:C.writeUInt8(2,0);break;case 2:C.writeUInt8(3,0);break}return C}e.$hm=A;function $(f,C){if(f.byteLength!==1)return!1;switch(f.readUInt8(0)){case 1:return C===0;case 2:return C===1;case 3:return C===2;default:return!1}}e.$im=$;var E;(function(f){f.Start="START_NATIVE_LOG",f.End="END_NATIVE_LOG"})(E||(e.NativeLogMarkers=E={}))}),define(Pe[59],Ae([1,0,4,5,15,27,79,55,56,26,2,6,165]),function(we,e,y,T,P,M,A,$,E,f,C,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UM=e.$TM=e.$SM=e.$RM=void 0;let b=class extends D.$Rc{constructor(i,r){super(),this.s=i,this.t=r,this.a=this.B(new T.$Rd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new T.$Rd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=C.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=r.createLogger(this.m,{id:E.$uo,name:(0,u.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(r.onDidChangeLogLevel(c=>{(0,P.$fj)(c)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===P.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(i,r,c){const o=this.getTelemetryDetails(),l=new v(r,c,i,this.n,this.j,this.getBuiltInCommonProperties(i),{isUsageEnabled:o.isUsageEnabled,isErrorsEnabled:o.isErrorsEnabled}),n=this.r.get(i.identifier.value)??[];return this.r.set(i.identifier.value,[...n,l]),l.apiTelemetryLogger}$initializeTelemetryLevel(i,r,c){this.f=i,this.g=r,this.c=c??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(i){const r=Object.create(null);switch(r["common.extname"]=`${i.publisher}.${i.name}`,r["common.extversion"]=i.version,r["common.vscodemachineid"]=this.s.telemetryInfo.machineId,r["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,r["common.vscodeversion"]=this.s.version,r["common.isnewappinstall"]=g(this.s.telemetryInfo.firstSessionDate),r["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:r["common.uikind"]="web";break;case A.UIKind.Desktop:r["common.uikind"]="desktop";break;default:r["common.uikind"]="unknown"}return r["common.remotename"]=(0,$.$2k)((0,E.$Bo)(this.s.remote.authority)),r}$onDidChangeTelemetryLevel(i){this.h=this.getTelemetryConfiguration(),this.f=i;const r=this.getTelemetryDetails();this.r.forEach((c,o)=>{const l=c.filter(n=>!n.isDisposed);l.length===0?this.r.delete(o):this.r.set(o,l)}),this.r.forEach(c=>{for(const o of c)o.updateTelemetryEnablements(r.isUsageEnabled,r.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(i,r){const o=this.r.get(i.value)?.filter(n=>!n.isDisposed);if(!o)return this.r.delete(i.value),!1;let l=!1;for(const n of o)n.ignoreUnhandledExtHostErrors||(n.logError(r),l=!0);return l}};e.$RM=b,e.$RM=b=Ke([Ve(0,M.$QM),Ve(1,P.$ej)],b);class v{static validateSender(i){if(typeof i!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof i.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof i.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof i.flush<"u"&&typeof i.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(i,r,c,o,l,n,s){this.g=c,this.h=o,this.i=l,this.j=n,this.a=new T.$Rd,this.ignoreUnhandledExtHostErrors=r?.ignoreUnhandledErrors??!1,this.b=r?.ignoreBuiltInCommonProperties??!1,this.c=r?.additionalCommonProperties,this.f=i,this.d={isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}}updateTelemetryEnablements(i,r){this.e&&(this.d={isUsageEnabled:i,isErrorsEnabled:r},this.a.fire(this.e))}mixInCommonPropsAndCleanData(i){let r="properties"in i?i.properties??{}:i;return r=(0,E.$Eo)(r,[]),this.c&&(r=(0,f.$dn)(r,this.c)),this.b||(r=(0,f.$dn)(r,this.j)),"properties"in i?i.properties=r:i=r,i}k(i,r){this.f&&(this.g.publisher==="vscode"?i=this.g.name+"/"+i:i=this.g.identifier.value+"/"+i,r=this.mixInCommonPropsAndCleanData(r||{}),this.i||this.f?.sendEventData(i,r),this.h.trace(i,r))}logUsage(i,r){this.d.isUsageEnabled&&this.k(i,r)}logError(i,r){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof i=="string")this.k(i,r);else{const c={name:i.name,message:i.message,stack:i.stack,cause:i.cause},o=(0,E.$Eo)(c,[]),l=new Error(o.message,{cause:o.cause});l.stack=o.stack,l.name=o.name,r=this.mixInCommonPropsAndCleanData(r||{}),this.i||this.f.sendErrorData(l,r),this.h.trace("exception",r)}}get apiTelemetryLogger(){if(!this.e){const i=this,r={logUsage:i.logUsage.bind(i),get isUsageEnabled(){return i.d.isUsageEnabled},get isErrorsEnabled(){return i.d.isErrorsEnabled},logError:i.logError.bind(i),dispose:i.dispose.bind(i),onDidChangeEnableStates:i.a.event.bind(i)};this.e=Object.freeze(r)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let i=this.f;this.f=void 0,Promise.resolve(i.flush()).then(i=void 0),this.e=void 0}else this.f=void 0}}e.$SM=v;function g(t){const i=Date.now()-new Date(t).getTime();return isNaN(i)?!1:i<1e3*60*60*24}e.$TM=g,e.$UM=(0,y.$Vh)("IExtHostTelemetry")}),define(Pe[23],Ae([1,0,5,2,193,101,22,4]),function(we,e,y,T,P,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RF=e.$QF=e.$PF=e.ActivationKind=e.$OF=e.$NF=e.$MF=e.$LF=e.$KF=e.ExtensionHostStartup=e.$JF=e.$IF=e.$HF=e.$GF=void 0,e.$GF=Object.freeze({identifier:new A.$_l("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$HF="extensions.webWorker",e.$IF=(0,$.$Vh)("extensionService");class E{constructor(l){this.dependency=l}}e.$JF=E;var f;(function(o){o[o.EagerAutoStart=1]="EagerAutoStart",o[o.EagerManualStart=2]="EagerManualStart",o[o.Lazy=3]="Lazy"})(f||(e.ExtensionHostStartup=f={}));class C{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(l,n,s){this.c=l,this.d=n.slice(0),this.e=s.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:M.$xF.createActivationEventsMap(this.d)}}set(l,n,s){if(this.c>l)throw new Error(`ExtensionHostExtensions: invalid versionId ${l} (current: ${this.c})`);const a=[],d=[],p=[],m=[],S=D(this.d),k=D(n),h=(Z,N)=>Z.extensionLocation.toString()===N.extensionLocation.toString()||Z.isBuiltin===N.isBuiltin||Z.isUserBuiltin===N.isUserBuiltin||Z.isUnderDevelopment===N.isUnderDevelopment;for(const Z of this.d){const N=k.get(Z.identifier);if(!N){a.push(Z.identifier),S.delete(Z.identifier);continue}if(!h(Z,N)){a.push(Z.identifier),S.delete(Z.identifier);continue}}for(const Z of n){const N=S.get(Z.identifier);if(!N){d.push(Z);continue}if(!h(N,Z)){a.push(N.identifier),S.delete(N.identifier);continue}}const w=new A.$am(this.e),I=new A.$am(s);for(const Z of this.e)I.has(Z)||p.push(Z);for(const Z of s)w.has(Z)||m.push(Z);const F=M.$xF.createActivationEventsMap(d),V={versionId:l,toRemove:a,toAdd:d,addActivationEvents:F,myToRemove:p,myToAdd:m};return this.delta(V),V}delta(l){if(this.c>=l.versionId)return null;const{toRemove:n,toAdd:s,myToRemove:a,myToAdd:d}=l,p=new A.$am(n),m=new A.$am(a);for(let S=0;S<this.d.length;S++)p.has(this.d[S].identifier)&&(this.d.splice(S,1),S--);for(let S=0;S<this.e.length;S++)m.has(this.e[S])&&(this.e.splice(S,1),S--);for(const S of s)this.d.push(S);for(const S of d)this.e.push(S);return this.f=null,l}containsExtension(l){for(const n of this.e)if(A.$_l.equals(n,l))return!0;return!1}containsActivationEvent(l){return this.f||(this.f=this.g()),this.f.has(l)}g(){const l=new Set;for(const n of this.d){if(!this.containsExtension(n.identifier))continue;const s=M.$xF.readActivationEvents(n);for(const a of s)l.add(a)}return l}}e.$KF=C;function D(o){const l=new A.$bm;for(const n of o)l.set(n.identifier,n);return l}function u(o,l){return o.enabledApiProposals?o.enabledApiProposals.includes(l):!1}e.$LF=u;function b(o,l){if(!u(o,l))throw new Error(`Extension '${o.identifier.value}' CANNOT use API proposal: ${l}.
Its package.json#enabledApiProposals-property declares: ${o.enabledApiProposals?.join(", ")??"[]"} but NOT ${l}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${o.identifier.value}`)}e.$MF=b;class v{constructor(l,n,s,a){this.codeLoadingTime=l,this.activateCallTime=n,this.activateResolvedTime=s,this.activationReason=a}}e.$NF=v;class g{constructor(l,n){this.description=l,this.value=n}}e.$OF=g;var t;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(t||(e.ActivationKind=t={}));function i(o){return{type:o.isBuiltin?0:1,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,P.$Ko)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation,targetPlatform:o.targetPlatform,validations:[],isValid:!0}}e.$PF=i;function r(o,l){return{identifier:new A.$_l((0,P.$Io)(o.manifest.publisher,o.manifest.name)),isBuiltin:o.type===0,isUserBuiltin:o.type===1&&o.isBuiltin,isUnderDevelopment:!!l,extensionLocation:o.location,...o.manifest,uuid:o.identifier.uuid,targetPlatform:o.targetPlatform}}e.$QF=r;class c{constructor(){this.onDidRegisterExtensions=y.Event.None,this.onDidChangeExtensionsStatus=y.Event.None,this.onDidChangeExtensions=y.Event.None,this.onWillActivateByEvent=y.Event.None,this.onDidChangeResponsiveChange=y.Event.None,this.onWillStop=y.Event.None,this.extensions=[]}activateByEvent(l){return Promise.resolve(void 0)}activateById(l,n){return Promise.resolve(void 0)}activationEventIsDone(l){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(l){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(l,n){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(l){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$RF=c}),define(Pe[218],Ae([1,0,11,106,22,23,15,14]),function(we,e,y,T,P,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aec=e.$zec=e.$yec=e.$xec=e.$wec=e.$vec=void 0;class E{static{this.NONE=new E(!1,-1,-1,-1)}constructor(i,r,c,o){this.startup=i,this.codeLoadingTime=r,this.activateCallTime=c,this.activateResolvedTime=o}}e.$vec=E;class f{constructor(i){this.a=i,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(i,r){return i===-1||r===-1?-1:r-i}build(){return new E(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$wec=f;class C{constructor(i,r,c,o,l,n){this.activationFailed=i,this.activationFailedError=r,this.activationTimes=c,this.module=o,this.exports=l,this.subscriptions=n}}e.$xec=C;class D extends C{constructor(i){super(!1,null,i,{activate:void 0,deactivate:void 0},void 0,[])}}e.$yec=D;class u extends C{constructor(){super(!1,null,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$zec=u;class b extends C{constructor(i){super(!0,i,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let v=class{constructor(i,r,c,o){this.g=o,this.a=i,this.b=r,this.c=c,this.d=new P.$bm,this.f=Object.create(null)}dispose(){for(const[i,r]of this.d)r.dispose()}async waitForActivatingExtensions(){const i=[];for(const[r,c]of this.d)i.push(c.wait());await Promise.all(i)}isActivated(i){const r=this.d.get(i);return!!(r&&r.value)}getActivatedExtension(i){const r=this.d.get(i);if(!r||!r.value)throw new Error(`Extension '${i.value}' is not known or not activated`);return r.value}async activateByEvent(i,r){if(this.f[i])return;const c=this.a.getExtensionDescriptionsForActivationEvent(i);await this.h(c.map(o=>({id:o.identifier,reason:{startup:r,extensionId:o.identifier,activationEvent:i}}))),this.f[i]=!0}activateById(i,r){const c=this.a.getExtensionDescription(i);if(!c)throw new Error(`Extension '${i}' is not known`);return this.h([{id:c.identifier,reason:r}])}async h(i){const r=i.filter(c=>!this.isActivated(c.id)).map(c=>this.j(c));await Promise.all(r.map(c=>c.wait()))}j(i){if(this.d.has(i.id))return this.d.get(i.id);if(this.l(i.id))return this.k(i,null,[],null);const r=this.a.getExtensionDescription(i.id);if(!r){const l=new Error(`Cannot activate unknown extension '${i.id.value}'`),n=this.k(i,null,[],new b(l));return this.c.onExtensionActivationError(i.id,l,new M.$JF(i.id.value)),n}const c=[],o=typeof r.extensionDependencies>"u"?[]:r.extensionDependencies;for(const l of o){if(this.m(l))continue;const n=this.d.get(l);if(n){c.push(n);continue}if(this.l(l)){c.push(this.j({id:this.b.getExtensionDescription(l).identifier,reason:i.reason}));continue}const s=this.a.getExtensionDescription(l);if(s){if(!s.main&&!s.browser)continue;c.push(this.j({id:s.identifier,reason:i.reason}));continue}const a=r.displayName||r.identifier.value,d=new Error(`Cannot activate the '${a}' extension because it depends on unknown extension '${l}'`),p=this.k(i,r.displayName,[],new b(d));return this.c.onExtensionActivationError(r.identifier,d,new M.$JF(l)),p}return this.k(i,r.displayName,c,null)}k(i,r,c,o){const l=new g(i.id,r,i.reason,c,o,this.c,this.g);return this.d.set(i.id,l),l}l(i){return T.$75b.isHostExtension(i,this.a,this.b)}m(i){const r=this.b.getExtensionDescription(i);return r?!r.main&&!r.browser:!1}};e.$Aec=v,e.$Aec=v=Ke([Ve(3,A.$dj)],v);let g=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(i,r,c,o,l,n,s){this.c=i,this.d=r,this.f=c,this.g=o,this.h=l,this.j=n,this.k=s,this.a=new $.$Wg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let i=0;i<this.g.length;i++){const r=this.g[i];if(r.value&&!r.value.activationFailed){this.g.splice(i,1),i--;continue}if(r.value&&r.value.activationFailed){const c=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${r.friendlyName}' failed to activate`);c.detail=r.value.activationFailedError,this.h=new b(c),this.j.onExtensionActivationError(this.c,c,null);return}}this.g.length>0&&await Promise.race(this.g.map(i=>i.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(i){const r=new Error;if(i&&i.name&&(r.name=i.name),i&&i.message?r.message=`Activating extension '${this.c.value}' failed: ${i.message}.`:r.message=`Activating extension '${this.c.value}' failed: ${i}.`,i&&i.stack&&(r.stack=i.stack),this.h=new b(r),this.b&&y.$3(i))return;this.j.onExtensionActivationError(this.c,r,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(i)}}};g=Ke([Ve(6,A.$dj)],g)}),define(Pe[8],Ae([1,0,18,24,126,219,52,28,120,51,68,26,16,2,29,80,98,104,102,76,48,58,216,7,23]),function(we,e,y,T,P,M,A,$,E,f,C,D,u,b,v,g,t,i,r,c,o,l,n,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$zM=e.$yM=e.MarkdownString=e.$xM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var d;(function(Ce){function Me(K){const{selectionStartLineNumber:Le,selectionStartColumn:je,positionLineNumber:Qe,positionColumn:qe}=K,it=new s.$BK(Le-1,je-1),pt=new s.$BK(Qe-1,qe-1);return new s.$DK(it,pt)}Ce.to=Me;function be(K){const{anchor:Le,active:je}=K;return{selectionStartLineNumber:Le.line+1,selectionStartColumn:Le.character+1,positionLineNumber:je.line+1,positionColumn:je.character+1}}Ce.from=be})(d||(e.Selection=d={}));var p;(function(Ce){function Me(K){if(!K)return;const{start:Le,end:je}=K;return{startLineNumber:Le.line+1,startColumn:Le.character+1,endLineNumber:je.line+1,endColumn:je.character+1}}Ce.from=Me;function be(K){if(!K)return;const{startLineNumber:Le,startColumn:je,endLineNumber:Qe,endColumn:qe}=K;return new s.$CK(Le-1,je-1,Qe-1,qe-1)}Ce.to=be})(p||(e.Range=p={}));var m;(function(Ce){function Me(be){switch(be){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Ce.to=Me})(m||(e.TokenType=m={}));var S;(function(Ce){function Me(K){return new s.$BK(K.lineNumber-1,K.column-1)}Ce.to=Me;function be(K){return{lineNumber:K.line+1,column:K.character+1}}Ce.from=be})(S||(e.Position=S={}));var k;(function(Ce){function Me(Le,je,Qe){return(0,y.$Gb)((0,y.$2b)(Le).map(qe=>be(qe,je,Qe)))}Ce.from=Me;function be(Le,je,Qe){if(typeof Le=="string")return{$serialized:!0,language:Le,isBuiltin:Qe?.isBuiltin};if(Le)return{$serialized:!0,language:Le.language,scheme:K(Le.scheme,je),pattern:X.from(Le.pattern)??void 0,exclusive:Le.exclusive,notebookType:Le.notebookType,isBuiltin:Qe?.isBuiltin}}function K(Le,je){return je&&typeof Le=="string"?je.transformOutgoingScheme(Le):Le}})(k||(e.DocumentSelector=k={}));var h;(function(Ce){function Me(K){switch(K){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Ce.from=Me;function be(K){switch(K){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Ce.to=be})(h||(e.DiagnosticTag=h={}));var w;(function(Ce){function Me(K){let Le;return K.code&&((0,u.$Cf)(K.code)||(0,u.$Gf)(K.code)?Le=String(K.code):Le={value:String(K.code.value),target:K.code.target}),{...p.from(K.range),message:K.message,source:K.source,code:Le,severity:F.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(I.from),tags:Array.isArray(K.tags)?(0,y.$Gb)(K.tags.map(h.from)):void 0}}Ce.from=Me;function be(K){const Le=new s.$OK(p.to(K),K.message,F.to(K.severity));return Le.source=K.source,Le.code=(0,u.$Cf)(K.code)?K.code:K.code?.value,Le.relatedInformation=K.relatedInformation&&K.relatedInformation.map(I.to),Le.tags=K.tags&&(0,y.$Gb)(K.tags.map(h.to)),Le}Ce.to=be})(w||(e.Diagnostic=w={}));var I;(function(Ce){function Me(K){return{...p.from(K.location.range),message:K.message,resource:K.location.uri}}Ce.from=Me;function be(K){return new s.$NK(new s.$MK(K.resource,p.to(K)),K.message)}Ce.to=be})(I||(e.DiagnosticRelatedInformation=I={}));var F;(function(Ce){function Me(K){switch(K){case s.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Ce.from=Me;function be(K){switch(K){case t.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Ce.to=be})(F||(e.DiagnosticSeverity=F={}));var V;(function(Ce){function Me(K){return typeof K=="number"&&K>=s.ViewColumn.One?K-1:K===s.ViewColumn.Beside?n.$MC:n.$LC}Ce.from=Me;function be(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}Ce.to=be})(V||(e.ViewColumn=V={}));function Z(Ce){return typeof Ce.range<"u"}function N(Ce){return Ce.length===0?!0:!!Z(Ce[0])}e.$xM=N;var R;(function(Ce){function Me(qe){return qe.map(Ce.from)}Ce.fromMany=Me;function be(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function K(qe){let it;if(be(qe)){const{language:ut,value:Mt}=qe;it={value:"```"+ut+`
`+Mt+"\n```\n"}}else s.$1K.isMarkdownString(qe)?it={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml,baseUri:qe.baseUri}:typeof qe=="string"?it={value:qe}:it={value:""};const pt=Object.create(null);it.uris=pt;const $t=ut=>{try{let Mt=b.URI.parse(ut,!0);Mt=Mt.with({query:Le(Mt.query,pt)}),pt[ut]=Mt}catch{}return""},bt=new E.marked.Renderer;return bt.link=$t,bt.image=ut=>typeof ut=="string"?$t(A.$dk(ut).href):"",(0,E.marked)(it.value,{renderer:bt}),it}Ce.from=K;function Le(qe,it){if(!qe)return qe;let pt;try{pt=(0,f.$rh)(qe)}catch{}if(!pt)return qe;let $t=!1;return pt=(0,D.$cn)(pt,bt=>{if(b.URI.isUri(bt)){const ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return it[ut]=bt,$t=!0,ut}else return}),$t?JSON.stringify(pt):qe}function je(qe){const it=new s.$1K(qe.value,qe.supportThemeIcons);return it.isTrusted=qe.isTrusted,it.supportHtml=qe.supportHtml,it.baseUri=qe.baseUri?b.URI.from(qe.baseUri):void 0,it}Ce.to=je;function Qe(qe){if(qe)return typeof qe=="string"?qe:Ce.from(qe)}Ce.fromStrict=Qe})(R||(e.MarkdownString=R={}));function L(Ce){return N(Ce)?Ce.map(Me=>({range:p.from(Me.range),hoverMessage:Array.isArray(Me.hoverMessage)?R.fromMany(Me.hoverMessage):Me.hoverMessage?R.from(Me.hoverMessage):void 0,renderOptions:Me.renderOptions})):Ce.map(Me=>({range:p.from(Me)}))}e.$yM=L;function O(Ce){return typeof Ce>"u"?Ce:typeof Ce=="string"?b.URI.file(Ce):Ce}e.$zM=O;var Y;(function(Ce){function Me(be){return typeof be>"u"?be:{contentText:be.contentText,contentIconPath:be.contentIconPath?O(be.contentIconPath):void 0,border:be.border,borderColor:be.borderColor,fontStyle:be.fontStyle,fontWeight:be.fontWeight,textDecoration:be.textDecoration,color:be.color,backgroundColor:be.backgroundColor,margin:be.margin,width:be.width,height:be.height}}Ce.from=Me})(Y||(e.ThemableDecorationAttachmentRenderOptions=Y={}));var he;(function(Ce){function Me(be){return typeof be>"u"?be:{backgroundColor:be.backgroundColor,outline:be.outline,outlineColor:be.outlineColor,outlineStyle:be.outlineStyle,outlineWidth:be.outlineWidth,border:be.border,borderColor:be.borderColor,borderRadius:be.borderRadius,borderSpacing:be.borderSpacing,borderStyle:be.borderStyle,borderWidth:be.borderWidth,fontStyle:be.fontStyle,fontWeight:be.fontWeight,textDecoration:be.textDecoration,cursor:be.cursor,color:be.color,opacity:be.opacity,letterSpacing:be.letterSpacing,gutterIconPath:be.gutterIconPath?O(be.gutterIconPath):void 0,gutterIconSize:be.gutterIconSize,overviewRulerColor:be.overviewRulerColor,before:be.before?Y.from(be.before):void 0,after:be.after?Y.from(be.after):void 0}}Ce.from=Me})(he||(e.ThemableDecorationRenderOptions=he={}));var $e;(function(Ce){function Me(be){if(typeof be>"u")return be;switch(be){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Ce.from=Me})($e||(e.DecorationRangeBehavior=$e={}));var De;(function(Ce){function Me(be){return{isWholeLine:be.isWholeLine,rangeBehavior:be.rangeBehavior?$e.from(be.rangeBehavior):void 0,overviewRulerLane:be.overviewRulerLane,light:be.light?he.from(be.light):void 0,dark:be.dark?he.from(be.dark):void 0,backgroundColor:be.backgroundColor,outline:be.outline,outlineColor:be.outlineColor,outlineStyle:be.outlineStyle,outlineWidth:be.outlineWidth,border:be.border,borderColor:be.borderColor,borderRadius:be.borderRadius,borderSpacing:be.borderSpacing,borderStyle:be.borderStyle,borderWidth:be.borderWidth,fontStyle:be.fontStyle,fontWeight:be.fontWeight,textDecoration:be.textDecoration,cursor:be.cursor,color:be.color,opacity:be.opacity,letterSpacing:be.letterSpacing,gutterIconPath:be.gutterIconPath?O(be.gutterIconPath):void 0,gutterIconSize:be.gutterIconSize,overviewRulerColor:be.overviewRulerColor,before:be.before?Y.from(be.before):void 0,after:be.after?Y.from(be.after):void 0}}Ce.from=Me})(De||(e.DecorationRenderOptions=De={}));var ke;(function(Ce){function Me(K){return{text:K.newText,eol:K.newEol&&et.from(K.newEol),range:p.from(K.range)}}Ce.from=Me;function be(K){const Le=new s.$HK(p.to(K.range),K.text);return Le.newEol=typeof K.eol>"u"?void 0:et.to(K.eol),Le}Ce.to=be})(ke||(e.TextEdit=ke={}));var fe;(function(Ce){function Me(K,Le){const je={edits:[]};if(K instanceof s.$KK){const Qe=new $.$Ac;for(const qe of K._allEntries())qe._type===1&&b.URI.isUri(qe.to)&&qe.from===void 0&&Qe.add(qe.to);for(const qe of K._allEntries())if(qe._type===1){let it;qe.options?.contents&&(ArrayBuffer.isView(qe.options.contents)?it={type:"base64",value:(0,T.$ze)(T.$fe.wrap(qe.options.contents))}:it={type:"dataTransferItem",id:qe.options.contents._itemId}),je.edits.push({oldResource:qe.from,newResource:qe.to,options:{...qe.options,contents:it},metadata:qe.metadata})}else qe._type===2?je.edits.push({resource:qe.uri,textEdit:ke.from(qe.edit),versionId:Qe.has(qe.uri)?void 0:Le?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===6?je.edits.push({resource:qe.uri,textEdit:{range:p.from(qe.range),text:qe.edit.value,insertAsSnippet:!0},versionId:Qe.has(qe.uri)?void 0:Le?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===3?je.edits.push({metadata:qe.metadata,resource:qe.uri,cellEdit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:Le?.getNotebookDocumentVersion(qe.uri)}):qe._type===5&&je.edits.push({metadata:qe.metadata,resource:qe.uri,notebookVersionId:Le?.getNotebookDocumentVersion(qe.uri),cellEdit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(Dt.from)}})}return je}Ce.from=Me;function be(K){const Le=new s.$KK,je=new $.$zc;for(const Qe of K.edits)if(Qe.textEdit){const qe=Qe,it=b.URI.revive(qe.resource),pt=p.to(qe.textEdit.range),$t=qe.textEdit.text,bt=qe.textEdit.insertAsSnippet;let ut;bt?ut=s.$JK.replace(pt,new s.$LK($t)):ut=s.$HK.replace(pt,$t);const Mt=je.get(it);Mt?Mt.push(ut):je.set(it,[ut])}else Le.renameFile(b.URI.revive(Qe.oldResource),b.URI.revive(Qe.newResource),Qe.options);for(const[Qe,qe]of je)Le.set(Qe,qe);return Le}Ce.to=be})(fe||(e.WorkspaceEdit=fe={}));var ve;(function(Ce){const Me=Object.create(null);Me[s.SymbolKind.File]=0,Me[s.SymbolKind.Module]=1,Me[s.SymbolKind.Namespace]=2,Me[s.SymbolKind.Package]=3,Me[s.SymbolKind.Class]=4,Me[s.SymbolKind.Method]=5,Me[s.SymbolKind.Property]=6,Me[s.SymbolKind.Field]=7,Me[s.SymbolKind.Constructor]=8,Me[s.SymbolKind.Enum]=9,Me[s.SymbolKind.Interface]=10,Me[s.SymbolKind.Function]=11,Me[s.SymbolKind.Variable]=12,Me[s.SymbolKind.Constant]=13,Me[s.SymbolKind.String]=14,Me[s.SymbolKind.Number]=15,Me[s.SymbolKind.Boolean]=16,Me[s.SymbolKind.Array]=17,Me[s.SymbolKind.Object]=18,Me[s.SymbolKind.Key]=19,Me[s.SymbolKind.Null]=20,Me[s.SymbolKind.EnumMember]=21,Me[s.SymbolKind.Struct]=22,Me[s.SymbolKind.Event]=23,Me[s.SymbolKind.Operator]=24,Me[s.SymbolKind.TypeParameter]=25;function be(Le){return typeof Me[Le]=="number"?Me[Le]:6}Ce.from=be;function K(Le){for(const je in Me)if(Me[je]===Le)return Number(je);return s.SymbolKind.Property}Ce.to=K})(ve||(e.SymbolKind=ve={}));var te;(function(Ce){function Me(K){switch(K){case s.SymbolTag.Deprecated:return 1}}Ce.from=Me;function be(K){switch(K){case 1:return s.SymbolTag.Deprecated}}Ce.to=be})(te||(e.SymbolTag=te={}));var Re;(function(Ce){function Me(K){return{name:K.name,kind:ve.from(K.kind),tags:K.tags&&K.tags.map(te.from),containerName:K.containerName,location:pe.from(K.location)}}Ce.from=Me;function be(K){const Le=new s.$RK(K.name,ve.to(K.kind),K.containerName,pe.to(K.location));return Le.tags=K.tags&&K.tags.map(te.to),Le}Ce.to=be})(Re||(e.WorkspaceSymbol=Re={}));var se;(function(Ce){function Me(K){const Le={name:K.name||"!!MISSING: name!!",detail:K.detail,range:p.from(K.range),selectionRange:p.from(K.selectionRange),kind:ve.from(K.kind),tags:K.tags?.map(te.from)??[]};return K.children&&(Le.children=K.children.map(Me)),Le}Ce.from=Me;function be(K){const Le=new s.$SK(K.name,K.detail,ve.to(K.kind),p.to(K.range),p.to(K.selectionRange));return(0,y.$Kb)(K.tags)&&(Le.tags=K.tags.map(te.to)),K.children&&(Le.children=K.children.map(be)),Le}Ce.to=be})(se||(e.DocumentSymbol=se={}));var Q;(function(Ce){function Me(K){const Le=new s.$WK(ve.to(K.kind),K.name,K.detail||"",b.URI.revive(K.uri),p.to(K.range),p.to(K.selectionRange));return Le._sessionId=K._sessionId,Le._itemId=K._itemId,Le}Ce.to=Me;function be(K,Le,je){if(Le=Le??K._sessionId,je=je??K._itemId,Le===void 0||je===void 0)throw new Error("invalid item");return{_sessionId:Le,_itemId:je,name:K.name,detail:K.detail,kind:ve.from(K.kind),uri:K.uri,range:p.from(K.range),selectionRange:p.from(K.selectionRange),tags:K.tags?.map(te.from)}}Ce.from=be})(Q||(e.CallHierarchyItem=Q={}));var B;(function(Ce){function Me(be){return new s.$XK(Q.to(be.from),be.fromRanges.map(K=>p.to(K)))}Ce.to=Me})(B||(e.CallHierarchyIncomingCall=B={}));var ne;(function(Ce){function Me(be){return new s.$YK(Q.to(be.to),be.fromRanges.map(K=>p.to(K)))}Ce.to=Me})(ne||(e.CallHierarchyOutgoingCall=ne={}));var pe;(function(Ce){function Me(K){return{range:K.range&&p.from(K.range),uri:K.uri}}Ce.from=Me;function be(K){return new s.$MK(b.URI.revive(K.uri),p.to(K.range))}Ce.to=be})(pe||(e.location=pe={}));var re;(function(Ce){function Me(K){const Le=K,je=K;return{originSelectionRange:Le.originSelectionRange?p.from(Le.originSelectionRange):void 0,uri:Le.targetUri?Le.targetUri:je.uri,range:p.from(Le.targetRange?Le.targetRange:je.range),targetSelectionRange:Le.targetSelectionRange?p.from(Le.targetSelectionRange):void 0}}Ce.from=Me;function be(K){return{targetUri:b.URI.revive(K.uri),targetRange:p.to(K.range),targetSelectionRange:K.targetSelectionRange?p.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?p.to(K.originSelectionRange):void 0}}Ce.to=be})(re||(e.DefinitionLink=re={}));var le;(function(Ce){function Me(K){return{range:p.from(K.range),contents:R.fromMany(K.contents)}}Ce.from=Me;function be(K){return new s.$PK(K.contents.map(R.to),p.to(K.range))}Ce.to=be})(le||(e.Hover=le={}));var ce;(function(Ce){function Me(K){return{range:p.from(K.range),expression:K.expression}}Ce.from=Me;function be(K){return new s.$IL(p.to(K.range),K.expression)}Ce.to=be})(ce||(e.EvaluatableExpression=ce={}));var ye;(function(Ce){function Me(K){if(K instanceof s.$JL)return{type:"text",range:p.from(K.range),text:K.text};if(K instanceof s.$KL)return{type:"variable",range:p.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof s.$LL)return{type:"expression",range:p.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}Ce.from=Me;function be(K){switch(K.type){case"text":return{range:p.to(K.range),text:K.text};case"variable":return{range:p.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:p.to(K.range),expression:K.expression}}}Ce.to=be})(ye||(e.InlineValue=ye={}));var _;(function(Ce){function Me(K){return{frameId:K.frameId,stoppedLocation:p.from(K.stoppedLocation)}}Ce.from=Me;function be(K){return new s.$ML(K.frameId,p.to(K.stoppedLocation))}Ce.to=be})(_||(e.InlineValueContext=_={}));var de;(function(Ce){function Me(K){return{range:p.from(K.range),kind:K.kind}}Ce.from=Me;function be(K){return new s.$QK(p.to(K.range),K.kind)}Ce.to=be})(de||(e.DocumentHighlight=de={}));var ie;(function(Ce){function Me(be){switch(be){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Ce.to=Me})(ie||(e.CompletionTriggerKind=ie={}));var ae;(function(Ce){function Me(be){return{triggerKind:ie.to(be.triggerKind),triggerCharacter:be.triggerCharacter}}Ce.to=Me})(ae||(e.CompletionContext=ae={}));var me;(function(Ce){function Me(K){switch(K){case s.CompletionItemTag.Deprecated:return 1}}Ce.from=Me;function be(K){switch(K){case 1:return s.CompletionItemTag.Deprecated}}Ce.to=be})(me||(e.CompletionItemTag=me={}));var Ie;(function(Ce){const Me=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function be(je){return Me.get(je)??9}Ce.from=be;const K=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Le(je){return K.get(je)??s.CompletionItemKind.Property}Ce.to=Le})(Ie||(e.CompletionItemKind=Ie={}));var z;(function(Ce){function Me(be,K){const Le=new s.$7K(be.label);return Le.insertText=be.insertText,Le.kind=Ie.to(be.kind),Le.tags=be.tags?.map(me.to),Le.detail=be.detail,Le.documentation=A.$$j(be.documentation)?R.to(be.documentation):be.documentation,Le.sortText=be.sortText,Le.filterText=be.filterText,Le.preselect=be.preselect,Le.commitCharacters=be.commitCharacters,v.$zs.isIRange(be.range)?Le.range=p.to(be.range):typeof be.range=="object"&&(Le.range={inserting:p.to(be.range.insert),replacing:p.to(be.range.replace)}),Le.keepWhitespace=typeof be.insertTextRules>"u"?!1:!!(be.insertTextRules&1),typeof be.insertTextRules<"u"&&be.insertTextRules&4?Le.insertText=new s.$LK(be.insertText):(Le.insertText=be.insertText,Le.textEdit=Le.range instanceof s.$CK?new s.$HK(Le.range,Le.insertText):void 0),be.additionalTextEdits&&be.additionalTextEdits.length>0&&(Le.additionalTextEdits=be.additionalTextEdits.map(je=>ke.to(je))),Le.command=K&&be.command?K.fromInternal(be.command):void 0,Le}Ce.to=Me})(z||(e.CompletionItem=z={}));var W;(function(Ce){function Me(K){if(typeof K.label!="string"&&!Array.isArray(K.label))throw new TypeError("Invalid label");return{label:K.label,documentation:R.fromStrict(K.documentation)}}Ce.from=Me;function be(K){return{label:K.label,documentation:A.$$j(K.documentation)?R.to(K.documentation):K.documentation}}Ce.to=be})(W||(e.ParameterInformation=W={}));var H;(function(Ce){function Me(K){return{label:K.label,documentation:R.fromStrict(K.documentation),parameters:Array.isArray(K.parameters)?K.parameters.map(W.from):[],activeParameter:K.activeParameter}}Ce.from=Me;function be(K){return{label:K.label,documentation:A.$$j(K.documentation)?R.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(W.to):[],activeParameter:K.activeParameter}}Ce.to=be})(H||(e.SignatureInformation=H={}));var G;(function(Ce){function Me(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(H.from):[]}}Ce.from=Me;function be(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(H.to):[]}}Ce.to=be})(G||(e.SignatureHelp=G={}));var q;(function(Ce){function Me(be,K){const Le=new s.$6K(S.to(K.position),typeof K.label=="string"?K.label:K.label.map(x.to.bind(void 0,be)),K.kind&&ue.to(K.kind));return Le.textEdits=K.textEdits&&K.textEdits.map(ke.to),Le.tooltip=A.$$j(K.tooltip)?R.to(K.tooltip):K.tooltip,Le.paddingLeft=K.paddingLeft,Le.paddingRight=K.paddingRight,Le}Ce.to=Me})(q||(e.InlayHint=q={}));var x;(function(Ce){function Me(be,K){const Le=new s.$5K(K.label);return Le.tooltip=A.$$j(K.tooltip)?R.to(K.tooltip):K.tooltip,g.Command.is(K.command)&&(Le.command=be.fromInternal(K.command)),K.location&&(Le.location=pe.to(K.location)),Le}Ce.to=Me})(x||(e.InlayHintLabelPart=x={}));var ue;(function(Ce){function Me(K){return K}Ce.from=Me;function be(K){return K}Ce.to=be})(ue||(e.InlayHintKind=ue={}));var Oe;(function(Ce){function Me(K){return{range:p.from(K.range),url:K.target,tooltip:K.tooltip}}Ce.from=Me;function be(K){let Le;if(K.url)try{Le=typeof K.url=="string"?b.URI.parse(K.url,!0):b.URI.revive(K.url)}catch{}return new s.$_K(p.to(K.range),Le)}Ce.to=be})(Oe||(e.DocumentLink=Oe={}));var Ue;(function(Ce){function Me(K){const Le=new s.$cL(K.label);return K.textEdit&&(Le.textEdit=ke.to(K.textEdit)),K.additionalTextEdits&&(Le.additionalTextEdits=K.additionalTextEdits.map(je=>ke.to(je))),Le}Ce.to=Me;function be(K){return{label:K.label,textEdit:K.textEdit?ke.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Le=>ke.from(Le)):void 0}}Ce.from=be})(Ue||(e.ColorPresentation=Ue={}));var Ze;(function(Ce){function Me(K){return new s.$aL(K[0],K[1],K[2],K[3])}Ce.to=Me;function be(K){return[K.red,K.green,K.blue,K.alpha]}Ce.from=be})(Ze||(e.Color=Ze={}));var Je;(function(Ce){function Me(K){return{range:p.from(K.range)}}Ce.from=Me;function be(K){return new s.$VK(p.to(K.range))}Ce.to=be})(Je||(e.SelectionRange=Je={}));var tt;(function(Ce){function Me(be){switch(be){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Ce.to=Me})(tt||(e.TextDocumentSaveReason=tt={}));var _e;(function(Ce){function Me(K){switch(K){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}Ce.from=Me;function be(K){switch(K){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}Ce.to=be})(_e||(e.TextEditorLineNumbersStyle=_e={}));var et;(function(Ce){function Me(K){if(K===s.EndOfLine.CRLF)return 1;if(K===s.EndOfLine.LF)return 0}Ce.from=Me;function be(K){if(K===1)return s.EndOfLine.CRLF;if(K===0)return s.EndOfLine.LF}Ce.to=be})(et||(e.EndOfLine=et={}));var rt;(function(Ce){function Me(be){if(typeof be=="object")return be.viewId;switch(be){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ce.from=Me})(rt||(e.ProgressLocation=rt={}));var nt;(function(Ce){function Me(K){const Le={start:K.start+1,end:K.end+1};return K.kind&&(Le.kind=ze.from(K.kind)),Le}Ce.from=Me;function be(K){const Le={start:K.start-1,end:K.end-1};return K.kind&&(Le.kind=ze.to(K.kind)),Le}Ce.to=be})(nt||(e.FoldingRange=nt={}));var ze;(function(Ce){function Me(K){if(K)switch(K){case s.FoldingRangeKind.Comment:return g.$ot.Comment;case s.FoldingRangeKind.Imports:return g.$ot.Imports;case s.FoldingRangeKind.Region:return g.$ot.Region}}Ce.from=Me;function be(K){if(K)switch(K.value){case g.$ot.Comment.value:return s.FoldingRangeKind.Comment;case g.$ot.Imports.value:return s.FoldingRangeKind.Imports;case g.$ot.Region.value:return s.FoldingRangeKind.Region}}Ce.to=be})(ze||(e.FoldingRangeKind=ze={}));var dt;(function(Ce){function Me(be){if(be)return{pinned:typeof be.preview=="boolean"?!be.preview:void 0,inactive:be.background,preserveFocus:be.preserveFocus,selection:typeof be.selection=="object"?p.from(be.selection):void 0,override:typeof be.override=="boolean"?r.$bE.id:void 0}}Ce.from=Me})(dt||(e.TextEditorOpenOptions=dt={}));var X;(function(Ce){function Me(je){return je instanceof s.$wL?je.toJSON():typeof je=="string"?je:be(je)||K(je)?new s.$wL(je.baseUri??je.base,je.pattern).toJSON():je}Ce.from=Me;function be(je){const Qe=je;return Qe?b.URI.isUri(Qe.baseUri)&&typeof Qe.pattern=="string":!1}function K(je){const Qe=je;return Qe?typeof Qe.base=="string"&&typeof Qe.pattern=="string":!1}function Le(je){return typeof je=="string"?je:new s.$wL(b.URI.revive(je.baseUri),je.pattern)}Ce.to=Le})(X||(e.GlobPattern=X={}));var J;(function(Ce){function Me(be){if(be){if(Array.isArray(be))return be.map(Me);if(typeof be=="string")return be;{const K=be;return{language:K.language,scheme:K.scheme,pattern:X.from(K.pattern),exclusive:K.exclusive,notebookType:K.notebookType}}}else return}Ce.from=Me})(J||(e.LanguageSelector=J={}));var Ee;(function(Ce){function Me(K){return!!K&&typeof K=="object"&&"documents"in K&&Array.isArray(K.documents)&&K.documents.every(Le=>Array.isArray(Le)&&Le.every(je=>je&&typeof je=="object"&&"uri"in je&&b.URI.isUri(je.uri)&&"version"in je&&typeof je.version=="number"&&"ranges"in je&&Array.isArray(je.ranges)&&je.ranges.every(Qe=>Qe instanceof s.$CK)))}Ce.is=Me;function be(K){return{documents:K.documents.map(Le=>Le.map(je=>({uri:b.URI.from(je.uri),version:je.version,ranges:je.ranges.map(Qe=>p.from(Qe))})))}}Ce.from=be})(Ee||(e.MappedEditsContext=Ee={}));var Be;(function(Ce){function Me(K){return{start:K.start,end:K.end}}Ce.from=Me;function be(K){return new s.$XL(K.start,K.end)}Ce.to=be})(Be||(e.NotebookRange=Be={}));var He;(function(Ce){function Me(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}Ce.to=Me;function be(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}Ce.from=be})(He||(e.NotebookCellExecutionSummary=He={}));var Xe;(function(Ce){function Me(be){if(be===c.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(be===c.NotebookCellExecutionState.Pending)return;if(be===c.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${be}`)}Ce.to=Me})(Xe||(e.NotebookCellExecutionState=Xe={}));var st;(function(Ce){function Me(K){switch(K){case s.NotebookCellKind.Markup:return c.CellKind.Markup;case s.NotebookCellKind.Code:default:return c.CellKind.Code}}Ce.from=Me;function be(K){switch(K){case c.CellKind.Markup:return s.NotebookCellKind.Markup;case c.CellKind.Code:default:return s.NotebookCellKind.Code}}Ce.to=be})(st||(e.NotebookCellKind=st={}));var vt;(function(Ce){function Me(K){const Le={metadata:K.metadata??Object.create(null),cells:[]};for(const je of K.cells)s.$YL.validate(je),Le.cells.push(Dt.from(je));return Le}Ce.from=Me;function be(K){const Le=new s.$ZL(K.cells.map(Dt.to));return(0,u.$Pf)(K.metadata)||(Le.metadata=K.metadata),Le}Ce.to=be})(vt||(e.NotebookData=vt={}));var Dt;(function(Ce){function Me(K){return{cellKind:st.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:He.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(Kt.from):[]}}Ce.from=Me;function be(K){return new s.$YL(st.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(Kt.to):void 0,K.metadata,K.internalMetadata?He.to(K.internalMetadata):void 0)}Ce.to=be})(Dt||(e.NotebookCellData=Dt={}));var Ne;(function(Ce){function Me(K){return{mime:K.mime,valueBytes:T.$fe.wrap(K.data)}}Ce.from=Me;function be(K){return new s.$1L(K.valueBytes.buffer,K.mime)}Ce.to=be})(Ne||(e.NotebookCellOutputItem=Ne={}));var Kt;(function(Ce){function Me(K){return{outputId:K.id,items:K.items.map(Ne.from),metadata:K.metadata}}Ce.from=Me;function be(K){const Le=K.items.map(Ne.to);return new s.$2L(Le,K.outputId,K.metadata)}Ce.to=be})(Kt||(e.NotebookCellOutput=Kt={}));var Ht;(function(Ce){function Me(Le){return K(Le)?{include:X.from(Le.include)??void 0,exclude:X.from(Le.exclude)??void 0}:X.from(Le)??void 0}Ce.from=Me;function be(Le){return K(Le)?{include:X.to(Le.include),exclude:X.to(Le.exclude)}:X.to(Le)}Ce.to=be;function K(Le){const je=Le;return je?!(0,u.$Lf)(je.include)&&!(0,u.$Lf)(je.exclude):!1}})(Ht||(e.NotebookExclusiveDocumentPattern=Ht={}));var yt;(function(Ce){function Me(be,K,Le){const je=typeof be.command=="string"?{title:"",command:be.command}:be.command;return{alignment:be.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(je,Le),text:be.text,tooltip:be.tooltip,accessibilityInformation:be.accessibilityInformation,priority:be.priority}}Ce.from=Me})(yt||(e.NotebookStatusBarItem=yt={}));var jt;(function(Ce){function Me(be,K,Le){const je=typeof be.command=="string"?{title:"",command:be.command}:be.command;return{command:K.toInternal(je,Le),label:be.label,description:be.description,detail:be.detail,documentation:be.documentation}}Ce.from=Me})(jt||(e.NotebookKernelSourceAction=jt={}));var Nt;(function(Ce){function Me(be){return{transientOutputs:be?.transientOutputs??!1,transientCellMetadata:be?.transientCellMetadata??{},transientDocumentMetadata:be?.transientDocumentMetadata??{},cellContentMetadata:be?.cellContentMetadata??{}}}Ce.from=Me})(Nt||(e.NotebookDocumentContentOptions=Nt={}));var Gt;(function(Ce){function Me(K){return{uri:K.uri,provides:K.provides}}Ce.from=Me;function be(K){return new s.$4L(b.URI.revive(K.uri),K.provides)}Ce.to=be})(Gt||(e.NotebookRendererScript=Gt={}));var Bt;(function(Ce){function Me(K){return{message:R.fromStrict(K.message)||"",type:0,expected:K.expectedOutput,actual:K.actualOutput,contextValue:K.contextValue,location:K.location&&{range:p.from(K.location.range),uri:K.location.uri}}}Ce.from=Me;function be(K){const Le=new s.$0L(typeof K.message=="string"?K.message:R.to(K.message));return Le.actualOutput=K.actual,Le.expectedOutput=K.expected,Le.contextValue=K.contextValue,Le.location=K.location?pe.to(K.location):void 0,Le}Ce.to=be})(Bt||(e.TestMessage=Bt={}));var St;(function(Ce){Ce.namespace=l.$vJ,Ce.denamespace=l.$wJ})(St||(e.TestTag=St={}));var Lt;(function(Ce){function Me(K){const Le=(0,i.$wM)(K).controllerId;return{extId:o.$rJ.fromExtHostTestItem(K,Le).toString(),label:K.label,uri:b.URI.revive(K.uri),busy:K.busy,tags:K.tags.map(je=>St.namespace(Le,je.id)),range:v.$zs.lift(p.from(K.range)),description:K.description||null,sortText:K.sortText||null,error:K.error&&R.fromStrict(K.error)||null}}Ce.from=Me;function be(K){return{parent:void 0,error:void 0,id:o.$rJ.fromString(K.extId).localId,label:K.label,uri:b.URI.revive(K.uri),tags:(K.tags||[]).map(Le=>{const{tagId:je}=St.denamespace(Le);return new s.$$L(je)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:p.to(K.range||void 0),canResolveChildren:!1,busy:K.busy,description:K.description||void 0,sortText:K.sortText||void 0}}Ce.toPlain=be})(Lt||(e.TestItem=Lt={})),function(Ce){function Me(K){return{id:K.id}}Ce.from=Me;function be(K){return new s.$$L(K.id)}Ce.to=be}(St||(e.TestTag=St={}));var Vt;(function(Ce){const Me=(K,Le)=>{const je=[];for(const[qe,it]of Le)o.$rJ.compare(it.item.extId,qe)===2&&(Le.delete(qe),je.push(it));const Qe={...Lt.toPlain(K.item),parent:void 0,taskStates:K.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(it=>it.type===0).map(Bt.to)})),children:je.map(qe=>Me(qe,Le))};for(const qe of Qe.children)qe.parent=Qe;return Qe};function be(K){const Le=[],je=new Map;for(const Qe of K.items){je.set(Qe.item.extId,Qe);const qe=o.$rJ.root(Qe.item.extId);K.request.targets.some(it=>it.controllerId===qe&&it.testIds.includes(Qe.item.extId))&&Le.push(Qe)}return{completedAt:K.completedAt,results:Le.map(Qe=>Me(Qe,je))}}Ce.to=be})(Vt||(e.TestResults=Vt={}));var Ye;(function(Ce){function Me(je){return{covered:je.covered,total:je.covered}}function be(je){return"line"in je?S.from(je):p.from(je)}function K(je){return"branches"in je?{count:je.executionCount,location:be(je.location),type:1,branches:je.branches.length?je.branches.map(Qe=>({count:Qe.executionCount,location:Qe.location&&be(Qe.location)})):void 0}:{type:0,count:je.executionCount,location:be(je.location)}}Ce.fromDetailed=K;function Le(je){return{uri:je.uri,statement:Me(je.statementCoverage),branch:je.branchCoverage&&Me(je.branchCoverage),function:je.functionCoverage&&Me(je.functionCoverage),details:je.detailedCoverage?.map(K)}}Ce.fromFile=Le})(Ye||(e.TestCoverage=Ye={}));var Wt;(function(Ce){function Me(be){switch(be){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Ce.to=Me})(Wt||(e.CodeActionTriggerKind=Wt={}));var qt;(function(Ce){function Me(K){const Le=new s.$eM(ve.to(K.kind),K.name,K.detail||"",b.URI.revive(K.uri),p.to(K.range),p.to(K.selectionRange));return Le._sessionId=K._sessionId,Le._itemId=K._itemId,Le}Ce.to=Me;function be(K,Le,je){if(Le=Le??K._sessionId,je=je??K._itemId,Le===void 0||je===void 0)throw new Error("invalid item");return{_sessionId:Le,_itemId:je,kind:ve.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:p.from(K.range),selectionRange:p.from(K.selectionRange),tags:K.tags?.map(te.from)}}Ce.from=be})(qt||(e.TypeHierarchyItem=qt={}));var ct;(function(Ce){function Me(be){if(be)return{value:be.value,tooltip:be.tooltip}}Ce.from=Me})(ct||(e.ViewBadge=ct={}));var gt;(function(Ce){function Me(je,Qe,qe){const it=Qe.fileData;return it?new s.$pL(new s.$qL(it.name,b.URI.revive(it.uri),it.id,(0,M.$cb)(()=>qe(it.id)))):je===C.$Vr.uriList&&Qe.uriListData?new s.$oL(Le(Qe.uriListData)):new s.$oL(Qe.asString)}Ce.to=Me;async function be(je,Qe){const qe=await Qe.asString();if(je===C.$Vr.uriList)return{asString:qe,fileData:void 0,uriListData:K(qe)};const it=Qe.asFile();return{asString:qe,fileData:it?{name:it.name,uri:it.uri,id:it._itemId??it.id}:void 0}}Ce.from=be;function K(je){return P.$9s.split(je).map(Qe=>{if(Qe.startsWith("#"))return Qe;try{return b.URI.parse(Qe)}catch{}return Qe})}function Le(je){return P.$9s.create(je.map(Qe=>typeof Qe=="string"?Qe:b.URI.revive(Qe)))}})(gt||(e.DataTransferItem=gt={}));var Ot;(function(Ce){function Me(K,Le){const je=K.items.map(([Qe,qe])=>[Qe,gt.to(Qe,qe,Le)]);return new s.$rL(je)}Ce.toDataTransfer=Me;async function be(K){const Le={items:[]},je=[];for(const[Qe,qe]of K)je.push((async()=>{Le.items.push([Qe,await gt.from(Qe,qe)])})());return await Promise.all(je),Le}Ce.from=be})(Ot||(e.DataTransfer=Ot={}));var Pt;(function(Ce){function Me(be){return{kind:"reply",message:be.message,title:be.title,tooltip:be.tooltip}}Ce.from=Me})(Pt||(e.ChatReplyFollowup=Pt={}));var At;(function(Ce){function Me(be){return typeof be=="string"?{title:be,message:be,kind:"reply"}:"commandId"in be?{kind:"command",title:be.title??"",commandId:be.commandId??"",when:be.when??"",args:be.args}:Pt.from(be)}Ce.from=Me})(At||(e.ChatFollowup=At={}));var ft;(function(Ce){function Me(K){const Le=new s.$pM(kt.to(K.role),K.content);return Le.name=K.name,Le}Ce.to=Me;function be(K){return{role:kt.from(K.role),content:K.content,name:K.name}}Ce.from=be})(ft||(e.ChatMessage=ft={}));var kt;(function(Ce){function Me(K){switch(K){case 0:return s.ChatMessageRole.System;case 1:return s.ChatMessageRole.User;case 2:return s.ChatMessageRole.Assistant;case 3:return s.ChatMessageRole.Function}}Ce.to=Me;function be(K){switch(K){case s.ChatMessageRole.System:return 0;case s.ChatMessageRole.Assistant:return 2;case s.ChatMessageRole.Function:return 3;case s.ChatMessageRole.User:default:return 1}}Ce.from=be})(kt||(e.ChatMessageRole=kt={}));var Rt;(function(Ce){function Me(Le){const je={};for(const Qe of Object.keys(Le))je[Qe]=Le[Qe].map(Ce.to);return je}Ce.objectTo=Me;function be(Le){return{level:Ct.to(Le.level),value:Le.value,description:Le.description}}Ce.to=be;function K(Le){return{level:Ct.from(Le.level),value:Le.value,description:Le.description}}Ce.from=K})(Rt||(e.ChatVariable=Rt={}));var Ct;(function(Ce){function Me(K){switch(K){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}Ce.to=Me;function be(K){switch(K){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}Ce.from=be})(Ct||(e.ChatVariableLevel=Ct={}));var We;(function(Ce){function Me(be){switch(be){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return s.InteractiveEditorResponseFeedbackKind.Bug}}Ce.to=Me})(We||(e.InteractiveEditorResponseFeedbackKind=We={}));var zt;(function(Ce){function Me(be,K){return"placeholder"in K&&"resolvedContent"in K?{content:K.placeholder,kind:"asyncContent"}:"markdownContent"in K?((0,a.$MF)(be,"chatAgents2Additions"),{content:R.from(K.markdownContent),kind:"markdownContent"}):"content"in K?typeof K.content=="string"?{content:K.content,kind:"content"}:((0,a.$MF)(be,"chatAgents2Additions"),{content:R.from(K.content),kind:"markdownContent"}):"documents"in K?{documents:K.documents.map(Le=>({uri:Le.uri,version:Le.version,ranges:Le.ranges.map(je=>p.from(je))})),kind:"usedContext"}:"reference"in K?{reference:"uri"in K.reference?{uri:K.reference.uri,range:p.from(K.reference.range)}:K.reference,kind:"reference"}:"inlineReference"in K?{inlineReference:"uri"in K.inlineReference?{uri:K.inlineReference.uri,range:p.from(K.inlineReference.range)}:K.inlineReference,name:K.title,kind:"inlineReference"}:"agentName"in K?((0,a.$MF)(be,"chatAgents2Additions"),{agentName:K.agentName,command:K.command,kind:"agentDetection"}):{treeData:K.treeData,kind:"treeData"}}Ce.from=Me})(zt||(e.ChatResponseProgress=zt={}));var Jt;(function(Ce){function Me(be,K,Le){return"terminalCommand"in be?{terminalCommand:be.terminalCommand}:"uri"in be?{uri:be.uri}:K.toInternal(be,Le)}Ce.from=Me})(Jt||(e.TerminalQuickFix=Jt={}))}),define(Pe[220],Ae([1,0,2,11,7,8,186]),function(we,e,y,T,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ec=void 0;class ${constructor(f,C,D,u={timeout:1500,errors:3}){this.c=f,this.d=C,this.f=D,this.g=u,this.a=new A.$2c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(f){return(C,D,u)=>{const v={dispose:this.a.push([C,D,f])};return Array.isArray(u)&&u.push(v),v}}async $participateInSave(f,C){const D=y.URI.revive(f);let u=!1;const b=setTimeout(()=>u=!0,this.g.timeout),v=[];try{for(const g of[...this.a]){if(u)break;const t=this.d.getDocument(D),i=await this.h(g,{document:t,reason:M.TextDocumentSaveReason.to(C)});v.push(i)}}finally{clearTimeout(b)}return v}h([f,C,D],u){const b=this.b.get(f);return typeof b=="number"&&b>this.g.errors?Promise.resolve(!1):this.i(D,f,C,u).then(()=>!0,v=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' threw ERROR`),this.c.error(v),!(v instanceof Error)||v.message!=="concurrent_edits"){const g=this.b.get(f);this.b.set(f,g?g+1:1),typeof g=="number"&&g>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(f,C,D,u){const b=[],v=Date.now(),{document:g,reason:t}=u,{version:i}=g,r=Object.freeze({document:g,reason:t,waitUntil(c){if(Object.isFrozen(b))throw(0,T.$7)("waitUntil can not be called async");b.push(Promise.resolve(c))}});try{C.apply(D,[r])}catch(c){return Promise.reject(c)}return Object.freeze(b),new Promise((c,o)=>{const l=setTimeout(()=>o(new Error("timeout")),this.g.timeout);return Promise.all(b).then(n=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${f.identifier.value}' finished after ${Date.now()-v}ms`),clearTimeout(l),c(n)}).catch(n=>{clearTimeout(l),o(n)})}).then(c=>{const o={edits:[]};for(const l of c)if(Array.isArray(l)&&l.every(n=>n instanceof P.$HK))for(const{newText:n,newEol:s,range:a}of l)o.edits.push({resource:g.uri,versionId:void 0,textEdit:{range:a&&M.Range.from(a),text:n,eol:s&&M.EndOfLine.from(s)}});if(o.edits.length!==0)return i===g.version?this.f.$tryApplyWorkspaceEdit(o):Promise.reject(new Error("concurrent_edits"))})}}e.$7ec=$}),define(Pe[221],Ae([1,0,13,2,8,7,76]),function(we,e,y,T,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$afc=e.$_ec=void 0;class ${constructor(D,u,b,v){this.start=D,this.deletedCount=u,this.deletedItems=b,this.items=v}asApiEvent(){return{range:new M.$XL(this.start,this.start+this.deletedCount),addedCells:this.items.map(D=>D.apiCell),removedCells:this.deletedItems}}}class E{static asModelAddData(D,u){return{EOL:u.eol,lines:u.source,languageId:u.language,uri:u.uri,isDirty:!1,versionId:1,notebook:D}}constructor(D,u,b){this.notebook=D,this.h=u,this.j=b,this.handle=b.handle,this.uri=T.URI.revive(b.uri),this.cellKind=b.cellKind,this.a=b.outputs.map(P.NotebookCellOutput.to),this.e=b.internalMetadata??{},this.b=Object.freeze(b.metadata??{}),this.d=Object.freeze(P.NotebookCellExecutionSummary.to(b.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const D=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const b={get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:P.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return D.g},set mime(v){D.g=v},get outputs(){return D.a.slice(0)},get metadata(){return D.b},get executionSummary(){return D.d}};this.f=Object.freeze(b)}return this.f}setOutputs(D){this.a=D.map(P.NotebookCellOutput.to)}setOutputItems(D,u,b){const v=b.map(P.NotebookCellOutputItem.to),g=this.a.find(t=>t.id===D);if(g&&(u||(g.items.length=0),g.items.push(...v),g.items.length>1&&g.items.every(t=>A.$CI(t.mime)))){const t=new Map,i=[];g.items.forEach(r=>{let c;t.has(r.mime)?c=t.get(r.mime):(c=[],t.set(r.mime,c),i.push(r.mime)),c.push(r.data)}),g.items.length=0,i.forEach(r=>{const c=A.$DI(t.get(r));g.items.push({mime:r,data:c.data.buffer})})}}setMetadata(D){this.b=Object.freeze(D)}setInternalMetadata(D){this.e=D,this.d=Object.freeze(P.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.$_ec=E;class f{static{this.a=0}constructor(D,u,b,v,g){this.k=D,this.l=u,this.m=b,this.uri=v,this.handle=f.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=g.viewType,this.f=Object.freeze(g.metadata??Object.create(null)),this.r([[0,0,g.cells]],!0,void 0),this.g=g.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const D=this,u={get uri(){return D.uri},get version(){return D.g},get notebookType(){return D.d},get isDirty(){return D.h},get isUntitled(){return D.uri.scheme===y.Schemas.untitled},get isClosed(){return D.j},get metadata(){return D.f},get cellCount(){return D.b.length},cellAt(b){return b=D.n(b),D.b[b].apiCell},getCells(b){return(b?D.p(b):D.b).map(g=>g.apiCell)},save(){return D.q()}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(D){D.metadata&&(this.f=Object.freeze({...this.f,...D.metadata}))}acceptDirty(D){this.h=D}acceptModelChanged(D,u,b){this.g=D.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:b});const v={notebook:this.apiNotebook,metadata:b,cellChanges:[],contentChanges:[]},g=[];for(const i of D.rawEvents)i.kind===A.NotebookCellsChangeType.ModelChange?this.r(i.changes,!1,v.contentChanges):i.kind===A.NotebookCellsChangeType.Move?this.s(i.index,i.length,i.newIdx,v.contentChanges):i.kind===A.NotebookCellsChangeType.Output?(this.t(i.index,i.outputs),g.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===A.NotebookCellsChangeType.OutputItem?(this.u(i.index,i.outputId,i.append,i.outputItems),g.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(i.index,i.language),g.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document})):i.kind===A.NotebookCellsChangeType.ChangeCellContent?g.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document}):i.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(i.index,i.mime):i.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(i.index,i.metadata),g.push({cell:this.b[i.index].apiCell,metadata:this.b[i.index].apiCell.metadata})):i.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(i.index,i.internalMetadata),g.push({cell:this.b[i.index].apiCell,executionSummary:this.b[i.index].apiCell.executionSummary}));const t=new Map;for(let i=0;i<g.length;i++){const r=g[i],c=t.get(r.cell);if(c===void 0){const o=v.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...r});t.set(r.cell,o-1)}else v.cellChanges[c]={...v.cellChanges[c],...r}}return Object.freeze(v),Object.freeze(v.cellChanges),Object.freeze(v.contentChanges),v}n(D){return D=D|0,D<0?0:D>=this.b.length?this.b.length-1:D}o(D){let u=D.start|0,b=D.end|0;return u<0&&(u=0),b>this.b.length&&(b=this.b.length),D.with({start:u,end:b})}p(D){D=this.o(D);const u=[];for(let b=D.start;b<D.end;b++)u.push(this.b[b]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(D,u,b){if(this.j)return;const v=[],g=[],t=[];if(D.reverse().forEach(i=>{const c=i[2].map(n=>{const s=new E(this,this.l,n);return u||g.push(E.asModelAddData(this.apiNotebook,n)),s}),o=new $(i[0],i[1],[],c),l=this.b.splice(i[0],i[1],...c);for(const n of l)t.push(n.uri),o.deletedItems.push(n.apiCell);v.push(o)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:g,removedDocuments:t}),b)for(const i of v)b.push(i.asApiEvent())}s(D,u,b,v){const g=this.b.splice(D,u);this.b.splice(b,0,...g);const t=[new $(D,u,g.map(i=>i.apiCell),[]),new $(b,0,[],g)];for(const i of t)v.push(i.asApiEvent())}t(D,u){this.b[D].setOutputs(u)}u(D,u,b,v){this.b[D].setOutputItems(u,b,v)}v(D,u){const b=this.b[D];b.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(b.uri,u)}w(D,u){const b=this.b[D];b.apiCell.mime=u}x(D,u){this.b[D].setMetadata(u)}y(D,u){this.b[D].setInternalMetadata(u)}getCellFromApiCell(D){return this.b.find(u=>u.apiCell===D)}getCellFromIndex(D){return this.b[D]}getCell(D){return this.b.find(u=>u.handle===D)}getCellIndex(D){return this.b.indexOf(D)}}e.$afc=f}),define(Pe[222],Ae([1,0,5,2,8,7]),function(we,e,y,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qfc=void 0;class A{constructor(E,f,C,D={timeout:1500,errors:3}){this.b=E,this.c=f,this.d=C,this.f=D,this.a=new y.$Td}dispose(){}getOnWillSaveNotebookDocumentEvent(E){return(f,C,D)=>{const u=function(v){f.call(C,v)};return u.extension=E,this.a.event(u,void 0,D)}}async $participateInSave(E,f,C){const D=T.URI.revive(E),u=this.c.getNotebookDocument(D);if(!u)throw new Error("Unable to resolve notebook document");const b=[];if(await this.a.fireAsync({notebook:u.apiNotebook,reason:P.TextDocumentSaveReason.to(f)},C,async(g,t)=>{const i=Date.now(),r=await await Promise.resolve(g);Date.now()-i>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier),!C.isCancellationRequested&&r&&(r instanceof M.$KK?b.push(r):this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier,"ignored due to invalid data"))}),C.isCancellationRequested)return!1;if(b.length===0)return!0;const v={edits:[]};for(const g of b){const{edits:t}=P.WorkspaceEdit.from(g);v.edits=v.edits.concat(t)}return this.d.$tryApplyWorkspaceEdit(v)}}e.$qfc=A}),define(Pe[107],Ae([1,0,11,8,7]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bfc=void 0;class M{static{this.apiEditorsToExtHost=new WeakMap}constructor($,E,f,C,D,u){this.id=$,this.f=E,this.notebookData=f,this.a=[],this.b=[],this.d=!1,this.a=D,this.b=C,this.c=u}get apiEditor(){if(!this.e){const $=this;this.e={get notebook(){return $.notebookData.apiNotebook},get selection(){return $.a[0]},set selection(E){this.selections=[E]},get selections(){return $.a},set selections(E){if(!Array.isArray(E)||!E.every(P.$XL.isNotebookRange))throw(0,y.$6)("selections");$.a=E,$.g(E)},get visibleRanges(){return $.b},revealRange(E,f){$.f.$tryRevealRange($.id,T.NotebookRange.from(E),f??P.NotebookEditorRevealType.Default)},get viewColumn(){return $.c}},M.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility($){this.d=$}_acceptVisibleRanges($){this.b=$}_acceptSelections($){this.a=$}g($){this.f.$trySetSelections(this.id,$.map(T.NotebookRange.from))}_acceptViewColumn($){this.c=$}}e.$bfc=M}),define(Pe[223],Ae([1,0,11,5,15,8]),function(we,e,y,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sfc=void 0;let A=class{constructor(E,f){this.c=E,this.d=f,this.a=new T.$Rd({onListenerError:y.$1}),this.b=new T.$Rd({onListenerError:y.$1}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(E,f){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",E,f);const C=this.d.getEditorById(E);f.visibleRanges&&C._acceptVisibleRanges(f.visibleRanges.ranges.map(M.NotebookRange.to)),f.selections&&C._acceptSelections(f.selections.selections.map(M.NotebookRange.to)),f.visibleRanges&&this.b.fire({notebookEditor:C.apiEditor,visibleRanges:C.apiEditor.visibleRanges}),f.selections&&this.a.fire(Object.freeze({notebookEditor:C.apiEditor,selections:C.apiEditor.selections}))}$acceptEditorViewColumns(E){for(const f in E)this.d.getEditorById(f)._acceptViewColumn(M.ViewColumn.to(E[f]))}};e.$sfc=A,e.$sfc=A=Ke([Ve(0,P.$dj)],A)}),define(Pe[224],Ae([1,0,8,72,163,19,66,11]),function(we,e,y,T,P,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zfc=void 0;class E{constructor(u){this.b=0,this.c=new Map,this.a=u}async withProgress(u,b,v){const g=this.b++,{title:t,location:i,cancellable:r}=b,c={label:(0,P.localize)(0,null,u.displayName||u.name),id:u.identifier.value};return this.a.$startProgress(g,{location:y.ProgressLocation.from(i),title:t,source:c,cancellable:r},u.isUnderDevelopment?void 0:u.identifier.value).catch($.$1),this.d(g,v,!!r)}d(u,b,v){let g;v&&(g=new M.$2d,this.c.set(u,g));const t=r=>{this.a.$progressEnd(r),this.c.delete(r),g?.dispose()};let i;try{i=b(new C(this.a,u),v&&g?g.token:M.CancellationToken.None)}catch(r){throw t(u),r}return i.then(r=>t(u),r=>t(u)),i}$acceptProgressCanceled(u){const b=this.c.get(u);b&&(b.cancel(),this.c.delete(u))}}e.$zfc=E;function f(D,u){return D.message=u.message,typeof u.increment=="number"&&(typeof D.increment=="number"?D.increment+=u.increment:D.increment=u.increment),D}class C extends T.$$u{constructor(u,b){super(v=>this.throttledReport(v)),this.c=u,this.d=b}throttledReport(u){this.c.$progressReport(this.d,u)}}Ke([(0,A.$ph)(100,(D,u)=>f(D,u),()=>Object.create(null))],C.prototype,"throttledReport",null)}),define(Pe[108],Ae([1,0,29,104,48,77,58,8,2]),function(we,e,y,T,P,M,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PM=e.$OM=e.$NM=e.$MM=void 0;const f=(c,o,l,n)=>{let s=o;return{enumerable:!0,configurable:!1,get(){return s},set(a){if(!l(s,a)){const d=s;s=a,c.listener?.(n(a,d))}}}},C=(c,o)=>c===o,D={range:(c,o)=>c===o?!0:!c||!o?!1:c.isEqual(o),label:C,description:C,sortText:C,busy:C,error:C,canResolveChildren:C,tags:(c,o)=>!(c.length!==o.length||c.some(l=>!o.find(n=>l.id===n.id)))},u=c=>o=>({op:4,update:c(o)}),b=(c,o)=>({range:(()=>{let l;const n=u(s=>({range:y.$zs.lift($.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return l},set(s){c.listener?.({op:6}),D.range(l,s)||(l=s,c.listener?.(n(s)))}}})(),label:f(c,o,D.label,u(l=>({label:l}))),description:f(c,void 0,D.description,u(l=>({description:l}))),sortText:f(c,void 0,D.sortText,u(l=>({sortText:l}))),canResolveChildren:f(c,!1,D.canResolveChildren,l=>({op:2,state:l})),busy:f(c,!1,D.busy,u(l=>({busy:l}))),error:f(c,void 0,D.error,u(l=>({error:$.MarkdownString.fromStrict(l)||null}))),tags:f(c,[],D.tags,(l,n)=>({op:1,new:l.map($.TestTag.from),old:n.map($.TestTag.from)}))}),v=c=>{const o=P.$rJ.fromString(c.extId),l=new t(o.controllerId,o.localId,c.label,E.URI.revive(c.uri)||void 0);return l.range=$.Range.to(c.range||void 0),l.description=c.description||void 0,l.sortText=c.sortText||void 0,l.tags=c.tags.map(n=>$.TestTag.to({id:(0,A.$wJ)(n).tagId})),l},g=c=>{let o;for(const l of c.tests){const n=v(l.item);(0,T.$wM)(n).parent=o,o=n}return o};e.$MM=g;class t{constructor(o,l,n,s){if(l.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(l)} symbol`);const a=(0,T.$vM)(this,o);Object.defineProperties(this,{id:{value:l,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof i?void 0:a.parent}},children:{value:(0,M.$uM)(a,T.$wM,t),enumerable:!0,writable:!1},...b(a,n)})}}e.$NM=t;class i extends t{constructor(o,l){super(o,o,l,void 0),this._isRoot=!0}}e.$OM=i;class r extends M.$qM{constructor(o,l,n){super({controllerId:o,getDocumentVersion:s=>s&&n.getDocument(s)?.version,getApiFor:T.$wM,getChildren:s=>s.children,root:new i(o,l),toITestItem:$.TestItem.from})}}e.$PM=r}),define(Pe[109],Ae([1,0,53,11,89,8,7]),function(we,e,y,T,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JM=e.$IM=e.$HM=void 0;class ${static{this.c=new P.$FM("TextEditorDecorationType")}constructor(u,b,v){const g=$.c.nextId();u.$registerTextEditorDecorationType(b.identifier,g,M.DecorationRenderOptions.from(v)),this.value=Object.freeze({key:g,dispose(){u.$removeTextEditorDecorationType(g)}})}}e.$HM=$;class E{constructor(u,b){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=b.undoStopBefore,this.f=b.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,b){this.k();let v=null;if(u instanceof A.$BK)v=new A.$CK(u,u);else if(u instanceof A.$CK)v=u;else throw new Error("Unrecognized location");this.l(v,b,!1)}insert(u,b){this.k(),this.l(new A.$CK(u,u),b,!0)}delete(u){this.k();let b=null;if(u instanceof A.$CK)b=u;else throw new Error("Unrecognized location");this.l(b,null,!0)}l(u,b,v){const g=this.c.validateRange(u);this.g.push({range:g,text:b,forceMoveMarkers:v})}setEndOfLine(u){if(this.k(),u!==A.EndOfLine.LF&&u!==A.EndOfLine.CRLF)throw(0,T.$6)("endOfLine");this.h=u}}class f{constructor(u,b,v,g){this.c=u,this.d=b,this._accept(v),this.e=g;const t=this;this.value={get tabSize(){return t.f},set tabSize(i){t.m(i)},get indentSize(){return t.g},set indentSize(i){t.o(i)},get insertSpaces(){return t.h},set insertSpaces(i){t.q(i)},get cursorStyle(){return t.j},set cursorStyle(i){t.s(i)},get lineNumbers(){return t.k},set lineNumbers(i){t.t(i)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.insertSpaces,this.j=u.cursorStyle,this.k=M.TextEditorLineNumbersStyle.to(u.lineNumbers)}l(u){if(u==="auto")return"auto";if(typeof u=="number"){const b=Math.floor(u);return b>0?b:null}if(typeof u=="string"){const b=parseInt(u,10);return isNaN(b)?null:b>0?b:null}return null}m(u){const b=this.l(u);if(b!==null){if(typeof b=="number"){if(this.f===b)return;this.f=b}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:b}))}}n(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const b=Math.floor(u);return b>0?b:null}if(typeof u=="string"){const b=parseInt(u,10);return isNaN(b)?null:b>0?b:null}return null}o(u){const b=this.n(u);if(b!==null){if(typeof b=="number"){if(this.g===b)return;this.g=b}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:b}))}}p(u){return u==="auto"?"auto":u==="false"?!1:!!u}q(u){const b=this.p(u);if(typeof b=="boolean"){if(this.h===b)return;this.h=b}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:b}))}s(u){this.j!==u&&(this.j=u,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}t(u){this.k!==u&&(this.k=u,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:M.TextEditorLineNumbersStyle.from(u)})))}assign(u){const b={};let v=!1;if(typeof u.tabSize<"u"){const g=this.l(u.tabSize);g==="auto"?(v=!0,b.tabSize=g):typeof g=="number"&&this.f!==g&&(this.f=g,v=!0,b.tabSize=g)}if(typeof u.indentSize<"u"){const g=this.n(u.indentSize);g==="tabSize"?(v=!0,b.indentSize=g):typeof g=="number"&&this.g!==g&&(this.g=g,v=!0,b.indentSize=g)}if(typeof u.insertSpaces<"u"){const g=this.p(u.insertSpaces);g==="auto"?(v=!0,b.insertSpaces=g):this.h!==g&&(this.h=g,v=!0,b.insertSpaces=g)}typeof u.cursorStyle<"u"&&this.j!==u.cursorStyle&&(this.j=u.cursorStyle,v=!0,b.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.k!==u.lineNumbers&&(this.k=u.lineNumbers,v=!0,b.lineNumbers=M.TextEditorLineNumbersStyle.from(u.lineNumbers)),v&&this.u("setOptions",this.c.$trySetOptions(this.d,b))}u(u,b){b.catch(v=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn(v)})}}e.$IM=f;class C{constructor(u,b,v,g,t,i,r,c){this.id=u,this.j=b,this.k=v,this.g=!1,this.h=new Set,this.c=t,this.d=new f(this.j,this.id,i,v),this.e=r,this.f=c;const o=this;this.value=Object.freeze({get document(){return g.value},set document(l){throw new T.$8("document")},get selection(){return o.c&&o.c[0]},set selection(l){if(!(l instanceof A.$DK))throw(0,T.$6)("selection");o.c=[l],o.l()},get selections(){return o.c},set selections(l){if(!Array.isArray(l)||l.some(n=>!(n instanceof A.$DK)))throw(0,T.$6)("selections");o.c=l,o.l()},get visibleRanges(){return o.e},set visibleRanges(l){throw new T.$8("visibleRanges")},get options(){return o.d.value},set options(l){o.g||o.d.assign(l)},get viewColumn(){return o.f},set viewColumn(l){throw new T.$8("viewColumn")},edit(l,n={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new E(g.value,n);return l(s),o.m(s)},insertSnippet(l,n,s={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!n||Array.isArray(n)&&n.length===0)a=o.c.map(d=>M.Range.from(d));else if(n instanceof A.$BK){const{lineNumber:d,column:p}=M.Position.from(n);a=[{startLineNumber:d,startColumn:p,endLineNumber:d,endColumn:p}]}else if(n instanceof A.$CK)a=[M.Range.from(n)];else{a=[];for(const d of n)if(d instanceof A.$CK)a.push(M.Range.from(d));else{const{lineNumber:p,column:m}=M.Position.from(d);a.push({startLineNumber:p,startColumn:m,endLineNumber:p,endColumn:m})}}return b.$tryInsertSnippet(u,g.value.version,l.value,a,s)},setDecorations(l,n){const s=n.length===0;s&&!o.h.has(l.key)||(s?o.h.delete(l.key):o.h.add(l.key),o.n(()=>{if(M.$xM(n))return b.$trySetDecorations(u,l.key,M.$yM(n));{const a=new Array(4*n.length);for(let d=0,p=n.length;d<p;d++){const m=n[d];a[4*d]=m.start.line+1,a[4*d+1]=m.start.character+1,a[4*d+2]=m.end.line+1,a[4*d+3]=m.end.character+1}return b.$trySetDecorationsFast(u,l.key,a)}}))},revealRange(l,n){o.n(()=>b.$tryRevealRange(u,M.Range.from(l),n||A.TextEditorRevealType.Default))},show(l){b.$tryShowEditor(u,M.ViewColumn.from(l))},hide(){b.$tryHideEditor(u)}})}dispose(){(0,y.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,y.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,y.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,y.ok)(!this.g),this.f=u}_acceptSelections(u){(0,y.ok)(!this.g),this.c=u}async l(){const u=this.c.map(M.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const b=u.finalize();if(b.edits.length===0&&!b.setEndOfLine)return Promise.resolve(!0);const v=b.edits.map(t=>t.range);v.sort((t,i)=>t.end.line===i.end.line?t.end.character===i.end.character?t.start.line===i.start.line?t.start.character-i.start.character:t.start.line-i.start.line:t.end.character-i.end.character:t.end.line-i.end.line);for(let t=0,i=v.length-1;t<i;t++){const r=v[t].end;if(v[t+1].start.isBefore(r))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const g=b.edits.map(t=>({range:M.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,b.documentVersionId,g,{setEndOfLine:typeof b.setEndOfLine=="number"?M.EndOfLine.from(b.setEndOfLine):void 0,undoStopBefore:b.undoStopBefore,undoStopAfter:b.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,b=>(b instanceof Error&&b.name==="DISPOSED"||this.k.warn(b),null))}}e.$JM=C}),define(Pe[225],Ae([1,0,167,25,2,5,6,205,14,7,16,18,8,52,19,132,23]),function(we,e,y,T,P,M,A,$,E,f,C,D,u,b,v,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sfc=void 0;function i(o,l){if((0,C.$Cf)(o))return{label:o};if(o&&typeof o=="object"&&typeof o.label=="string"){let n;return Array.isArray(o.highlights)&&(n=o.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),n=n.length?n:void 0),{label:o.label,highlights:n}}}class r extends A.$Rc{constructor(l,n,s){super(),this.f=l,this.g=n,this.h=s,this.a=new Map,this.b=new g.$S7;function a(d){return d&&d.$treeViewId&&(d.$treeItemHandle||d.$selectedTreeItems||d.$focusedTreeItem)}n.registerArgumentProcessor({processArgument:d=>a(d)?this.r(d):Array.isArray(d)&&d.length>0?d.map(p=>a(p)?this.r(p):p):d})}registerTreeDataProvider(l,n,s){const a=this.createTreeView(l,{treeDataProvider:n},s);return{dispose:()=>a.dispose()}}createTreeView(l,n,s){if(!n||!n.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const a=n.dragAndDropController?.dropMimeTypes??[],d=n.dragAndDropController?.dragMimeTypes??[],p=!!n.dragAndDropController?.handleDrag,m=!!n.dragAndDropController?.handleDrop,S=this.m(l,n,s),k={showCollapseAll:!!n.showCollapseAll,canSelectMany:!!n.canSelectMany,dropMimeTypes:a,dragMimeTypes:d,hasHandleDrag:p,hasHandleDrop:m,manuallyManageCheckboxes:!!n.manageCheckboxStateManually},h=this.f.$registerTreeViewDataProvider(l,k),w={get onDidCollapseElement(){return S.onDidCollapseElement},get onDidExpandElement(){return S.onDidExpandElement},get selection(){return S.selectedElements},get onDidChangeSelection(){return S.onDidChangeSelection},get activeItem(){return(0,t.$MF)(s,"treeViewActiveItem"),S.focusedElement},get onDidChangeActiveItem(){return(0,t.$MF)(s,"treeViewActiveItem"),S.onDidChangeActiveItem},get visible(){return S.visible},get onDidChangeVisibility(){return S.onDidChangeVisibility},get onDidChangeCheckboxState(){return S.onDidChangeCheckboxState},get message(){return S.message},set message(I){(0,b.$$j)(I)&&(0,t.$MF)(s,"treeViewMarkdownMessage"),S.message=I},get title(){return S.title},set title(I){S.title=I},get description(){return S.description},set description(I){S.description=I},get badge(){return S.badge},set badge(I){I!==void 0&&f.ViewBadge.isViewBadge(I)?S.badge={value:Math.floor(Math.abs(I.value)),tooltip:I.tooltip}:I===void 0&&(S.badge=void 0)},reveal:(I,F)=>S.reveal(I,F),dispose:async()=>{await h,this.a.delete(l),S.dispose()}};return this.B(w),w}$getChildren(l,n){const s=this.a.get(l);return s?s.getChildren(n):Promise.reject(new $.$KE(l))}async $handleDrop(l,n,s,a,d,p,m,S){const k=this.a.get(l);if(!k)return Promise.reject(new $.$KE(l));const h=u.DataTransfer.toDataTransfer(s,async w=>(await this.f.$resolveDropFileData(l,n,w)).buffer);return m===l&&S&&await this.j(h,k,S,d,p),k.onDrop(h,a,d)}async j(l,n,s,a,d){const p=this.b.removeDragOperationTransfer(d);if(p)(await p)?.forEach((m,S)=>{m&&l.set(S,m)});else if(d&&n.handleDrag){const m=n.handleDrag(s,l,a);this.b.addDragOperationTransfer(d,m),await m}return l}async $handleDrag(l,n,s,a){const d=this.a.get(l);if(!d)return Promise.reject(new $.$KE(l));const p=await this.j(new f.$rL,d,n,a,s);if(!(!p||a.isCancellationRequested))return u.DataTransfer.from(p)}async $hasResolve(l){const n=this.a.get(l);if(!n)throw new $.$KE(l);return n.hasResolve}$resolve(l,n,s){const a=this.a.get(l);if(!a)throw new $.$KE(l);return a.resolveTreeItem(n,s)}$setExpanded(l,n,s){const a=this.a.get(l);if(!a)throw new $.$KE(l);a.setExpanded(n,s)}$setSelectionAndFocus(l,n,s){const a=this.a.get(l);if(!a)throw new $.$KE(l);a.setSelectionAndFocus(n,s)}$setVisible(l,n){const s=this.a.get(l);if(!s){if(!n)return;throw new $.$KE(l)}s.setVisible(n)}$changeCheckboxState(l,n){const s=this.a.get(l);if(!s)throw new $.$KE(l);s.setCheckboxState(n)}m(l,n,s){const a=this.B(new c(l,n,this.f,this.g.converter,this.h,s));return this.a.set(l,a),a}r(l){const n=this.a.get(l.$treeViewId);return n&&"$treeItemHandle"in l?n.getExtensionElement(l.$treeItemHandle):n&&"$focusedTreeItem"in l&&l.$focusedTreeItem?n.focusedElement:null}}e.$Sfc=r;class c extends A.$Rc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(l=>this.getExtensionElement(l)).filter(l=>!(0,C.$Lf)(l))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(l,n,s,a,d,p){if(super(),this.I=l,this.J=s,this.L=a,this.M=d,this.N=p,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new M.$Rd),this.onDidExpandElement=this.u.event,this.w=this.B(new M.$Rd),this.onDidCollapseElement=this.w.event,this.y=this.B(new M.$Rd),this.onDidChangeSelection=this.y.event,this.z=this.B(new M.$Rd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new M.$Rd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new M.$Rd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new M.$Rd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new v.$2d,p.contributes&&p.contributes.views)for(const h in p.contributes.views)for(const w of p.contributes.views[h])w.id===l&&(this.P=w.name);this.f=n.treeDataProvider,this.g=n.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(h=>this.F.fire({message:!1,element:h})));let m,S;const k=M.Event.debounce(this.F.event,(h,w)=>(h||(h={message:!1,elements:[]}),w.element!==!1&&(m||(m=new Promise(I=>S=I),this.G=this.G.then(()=>m)),Array.isArray(w.element)?h.elements.push(...w.element):h.elements.push(w.element)),w.message&&(h.message=!0),h),200,!0);this.B(k(({message:h,elements:w})=>{w.length&&(this.H=this.H.then(()=>{const I=S;return m=null,this.$(w).then(()=>I())})),h&&this.J.$setMessage(this.I,u.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(l){const n=l?this.getExtensionElement(l):void 0;if(l&&!n)return this.M.error(`No tree item with id '${l}' found.`),Promise.resolve([]);let s=this.X(l);return s||(s=await this.Y(n)),s?s.map(a=>a.item):void 0}getExtensionElement(l){return this.j.get(l)}reveal(l,n){n=n||{select:!0,focus:!1};const s=(0,C.$Lf)(n.select)?!0:n.select,a=(0,C.$Lf)(n.focus)?!1:n.focus,d=(0,C.$Lf)(n.expand)?!1:n.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):l?this.G.then(()=>this.S(l)).then(p=>this.W(l,p[p.length-1]).then(m=>this.J.$reveal(this.I,{item:m.item,parentChain:p.map(S=>S.item)},{select:s,focus:a,expand:d})),p=>this.M.error(p)):this.J.$reveal(this.I,void 0,{select:s,focus:a,expand:d})}get message(){return this.O}set message(l){this.O=l,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(l){this.P=l,this.J.$setTitle(this.I,l,this.Q)}get description(){return this.Q}set description(l){this.Q=l,this.J.$setTitle(this.I,this.P,l)}get badge(){return this.R}set badge(l){this.R?.value===l?.value&&this.R?.tooltip===l?.tooltip||(this.R=u.ViewBadge.from(l),this.J.$setBadge(this.I,l))}setExpanded(l,n){const s=this.getExtensionElement(l);s&&(n?this.u.fire(Object.freeze({element:s})):this.w.fire(Object.freeze({element:s})))}setSelectionAndFocus(l,n){const s=!(0,D.$tb)(this.s,l);this.s=l;const a=this.t!==n;this.t=n,s&&this.y.fire(Object.freeze({selection:this.selectedElements})),a&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(l){l!==this.r&&(this.r=l,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(l){const n=(await Promise.all(l.map(async s=>{const a=this.getExtensionElement(s.treeItemHandle);return a?{extensionItem:a,treeItem:await this.f.getTreeItem(a),newState:s.newState?f.TreeItemCheckboxState.Checked:f.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);n.forEach(s=>{s.treeItem.checkboxState=s.newState?f.TreeItemCheckboxState.Checked:f.TreeItemCheckboxState.Unchecked}),this.D.fire({items:n.map(s=>[s.extensionItem,s.newState])})}async handleDrag(l,n,s){const a=[];for(const d of l){const p=this.getExtensionElement(d);p&&a.push(p)}if(!(!this.g?.handleDrag||a.length===0))return await this.g.handleDrag(a,n,s),n}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(l,n,s){const a=n?this.getExtensionElement(n):void 0;if(!(!a&&n||!this.g?.handleDrop))return(0,E.$Qg)(()=>this.g?.handleDrop?this.g.handleDrop(a,l,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(l,n){if(!this.f.resolveTreeItem)return;const s=this.j.get(l);if(s){const a=this.m.get(s);if(a){const d=await this.f.resolveTreeItem(a.extensionItem,s,n)??a.extensionItem;return this.hb(d),a.item.tooltip=this.eb(d.tooltip),a.item.command=this.fb(a.disposableStore,d.command),a.item}}}S(l){return this.U(l).then(n=>n?this.S(n).then(s=>this.W(n,s[s.length-1]).then(a=>(s.push(a),s))):Promise.resolve([]))}U(l){const n=this.m.get(l);return n?Promise.resolve(n.parent?this.j.get(n.parent.item.handle):void 0):(0,E.$Qg)(()=>this.f.getParent(l))}W(l,n){const s=this.m.get(l);return s?Promise.resolve(s):(0,E.$Qg)(()=>this.f.getTreeItem(l)).then(a=>this.kb(l,a,n,!0)).then(a=>this.getChildren(n?n.item.handle:void 0).then(()=>{const d=this.getExtensionElement(a);if(d){const p=this.m.get(d);if(p)return Promise.resolve(p)}throw new Error(`Cannot resolve tree item for element ${a} from extension ${this.N.identifier.value}`)}))}X(l){if(l){let n;if(typeof l=="string"){const s=this.getExtensionElement(l);n=s?this.m.get(s):void 0}else n=l;return n&&n.children||void 0}return this.h}async Y(l){this.rb(l);const n=new v.$2d(this.Z.token);try{const s=l?this.m.get(l):void 0,a=await this.f.getChildren(l);if(n.token.isCancellationRequested)return;const d=await Promise.all((0,D.$Gb)(a||[]).map(async p=>{const m=await this.f.getTreeItem(p);return m&&!n.token.isCancellationRequested?this.db(p,m,s):null}));return n.token.isCancellationRequested?void 0:(0,D.$Gb)(d)}finally{n.dispose()}}$(l){if(l.some(s=>!s))return this.Z.dispose(!0),this.Z=new v.$2d,this.tb(),this.J.$refresh(this.I);{const s=this.ab(l);if(s.length)return this.bb(s)}return Promise.resolve(void 0)}ab(l){const n=new Set,s=l.map(d=>this.m.get(d));for(const d of s)if(d&&!n.has(d.item.handle)){let p=d;for(;p&&p.parent&&s.findIndex(m=>p&&p.parent&&m&&m.item.handle===p.parent.item.handle)===-1;){const m=this.j.get(p.parent.item.handle);p=m?this.m.get(m):void 0}p&&!p.parent&&n.add(d.item.handle)}const a=[];return n.forEach(d=>{const p=this.j.get(d);if(p){const m=this.m.get(p);m&&(!m.parent||!n.has(m.parent.item.handle))&&a.push(d)}}),a}bb(l){const n={};return Promise.all(l.map(s=>this.cb(s).then(a=>{a&&(n[s]=a.item)}))).then(()=>Object.keys(n).length?this.J.$refresh(this.I,n):void 0)}cb(l){const n=this.getExtensionElement(l);if(n){const s=this.m.get(n);if(s)return this.rb(n),(0,E.$Qg)(()=>this.f.getTreeItem(n)).then(a=>{if(a){const d=this.ib(n,a,s.parent);return this.pb(n,d,s,s.parent),s.dispose(),d}return null})}return Promise.resolve(null)}db(l,n,s){const a=this.ib(l,n,s);if(n.id&&this.j.has(a.item.handle))throw new Error((0,y.localize)(0,null,n.id));return this.ob(l,a),this.qb(a,s),a}eb(l){return f.$1K.isMarkdownString(l)?u.MarkdownString.from(l):l}fb(l,n){return n?{...this.L.toInternal(n,l),originalId:n.command}:void 0}gb(l){if(l.checkboxState===void 0)return;let n,s,a;return typeof l.checkboxState=="number"?n=l.checkboxState:(n=l.checkboxState.state,s=l.checkboxState.tooltip,a=l.checkboxState.accessibilityInformation),{isChecked:n===f.TreeItemCheckboxState.Checked,tooltip:s,accessibilityInformation:a}}hb(l){if(!f.$mL.isTreeItem(l,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(l,n,s){this.hb(n);const a=this.B(new A.$Qc),d=this.kb(l,n,s),p=this.lb(n);return{item:{handle:d,parentHandle:s?s.item.handle:void 0,label:i(n.label,this.N),description:n.description,resourceUri:n.resourceUri,tooltip:this.eb(n.tooltip),command:this.fb(a,n.command),contextValue:n.contextValue,icon:p,iconDark:this.mb(n)||p,themeIcon:this.jb(n),collapsibleState:(0,C.$Lf)(n.collapsibleState)?f.TreeItemCollapsibleState.None:n.collapsibleState,accessibilityInformation:n.accessibilityInformation,checkbox:this.gb(n)},extensionItem:n,parent:s,children:void 0,disposableStore:a,dispose(){a.dispose()}}}jb(l){return l.iconPath instanceof f.$uL?l.iconPath:void 0}kb(l,{id:n,label:s,resourceUri:a},d,p){if(n)return`${c.b}/${n}`;const m=i(s,this.N),S=d?d.item.handle:c.a;let k=m?m.label:a?(0,T.$wg)(a):"";k=k.indexOf("/")!==-1?k.replace("/","//"):k;const h=this.m.has(l)?this.m.get(l).item.handle:void 0,w=this.X(d)||[];let I,F=0;do{if(I=`${S}/${F}:${k}`,p||!this.j.has(I)||h===I)break;F++}while(F<=w.length);return I}lb(l){if(l.iconPath&&!(l.iconPath instanceof f.$uL))return typeof l.iconPath=="string"||P.URI.isUri(l.iconPath)?this.nb(l.iconPath):this.nb(l.iconPath.light)}mb(l){if(l.iconPath&&!(l.iconPath instanceof f.$uL)&&l.iconPath.dark)return this.nb(l.iconPath.dark)}nb(l){return P.URI.isUri(l)?l:P.URI.file(l)}ob(l,n){this.j.set(n.item.handle,l),this.m.set(l,n)}pb(l,n,s,a){this.j.delete(n.item.handle),this.m.delete(l),n.item.handle!==s.item.handle&&this.j.delete(s.item.handle),this.ob(l,n);const d=this.X(a)||[],p=d.filter(m=>m.item.handle===s.item.handle)[0];p&&d.splice(d.indexOf(p),1,n)}qb(l,n){n?(n.children||(n.children=[]),n.children.push(l)):(this.h||(this.h=[]),this.h.push(l))}rb(l){if(l){const n=this.m.get(l);if(n){if(n.children)for(const s of n.children){const a=this.j.get(s.item.handle);a&&this.sb(a)}n.children=void 0}}else this.tb()}sb(l){const n=this.m.get(l);if(n){if(n.children)for(const s of n.children){const a=this.j.get(s.item.handle);a&&this.sb(a)}this.m.delete(l),this.j.delete(n.item.handle),n.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(l=>l.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Pe[226],Ae([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmInputBoxActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxActionButton.d.ts",scmInputBoxValueProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxValueProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testingActiveProfile:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testingActiveProfile.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Pe[227],Ae([1,0,179,11,31,96,73,30,22,226,189,101]),function(we,e,y,T,P,M,A,$,E,f,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=e.$SF=void 0;const u=$.$mn.as(A.$nn.JSONContribution);class b{constructor(l,n,s){this.a=l,this.b=n,this.c=s}d(l,n){this.a({type:l,message:n,extensionId:this.b.identifier,extensionPointId:this.c})}error(l){this.d(P.default.Error,l)}warn(l){this.d(P.default.Warning,l)}info(l){this.d(P.default.Info,l)}}e.$SF=b;class v{static a(l){const n=new E.$am;for(let s=0,a=l.length;s<a;s++)n.add(l[s].description.identifier);return n}static compute(l,n){if(!l||!l.length)return new v(n,[]);if(!n||!n.length)return new v([],l);const s=this.a(l),a=this.a(n),d=n.filter(m=>!s.has(m.description.identifier)),p=l.filter(m=>!a.has(m.description.identifier));return new v(d,p)}constructor(l,n){this.added=l,this.removed=n}}e.$TF=v;class g{constructor(l,n){this.name=l,this.defaultExtensionKind=n,this.a=null,this.b=null,this.c=null}setHandler(l){if(this.a!==null)throw new Error("Handler already set!");this.a=l,this.d()}acceptUsers(l){this.c=v.compute(this.b,l),this.b=l,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(l){(0,T.$Z)(l)}}}e.$UF=g;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[y.localize(0,null),y.localize(1,null)]},i="vscode://schemas/vscode-extensions";e.$VF={properties:{engines:{type:"object",description:y.localize(2,null),properties:{vscode:{type:"string",description:y.localize(3,null),default:"^1.22.0"}}},publisher:{description:y.localize(4,null),type:"string"},displayName:{description:y.localize(5,null),type:"string"},categories:{description:y.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:E.$$l},{type:"string",const:"Languages",deprecationMessage:y.localize(7,null)}]}},galleryBanner:{type:"object",description:y.localize(8,null),properties:{color:{description:y.localize(9,null),type:"string"},theme:{description:y.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:y.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:y.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:y.localize(13,null)},enabledApiProposals:{markdownDescription:y.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(f.allApiProposals),markdownEnumDescriptions:Object.values(f.allApiProposals)}},api:{markdownDescription:y.localize(15,null),type:"string",enum:["none"],enumDescriptions:[y.localize(16,null)]},activationEvents:{description:y.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:y.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:y.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:y.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:y.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:y.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:y.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:y.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:y.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:y.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:y.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:y.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:y.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:y.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:y.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:y.localize(32,null)},{label:"onUri",body:"onUri",description:y.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:y.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:y.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:y.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:y.localize(37,null)},{label:"onRenderer",description:y.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:y.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:y.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:y.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:y.localize(42,null)},{label:"*",description:y.localize(43,null),body:"*"}]}},badges:{type:"array",description:y.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:y.localize(45,null)},href:{type:"string",description:y.localize(46,null)},description:{type:"string",description:y.localize(47,null)}}}},markdown:{type:"string",description:y.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:y.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:y.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$4n}},extensionPack:{description:y.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$4n}},extensionKind:{description:y.localize(52,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:y.localize(53,null)},{body:["workspace"],description:y.localize(54,null)},{body:["ui","workspace"],description:y.localize(55,null)},{body:["workspace","ui"],description:y.localize(56,null)},{body:[],description:y.localize(57,null)}]},capabilities:{description:y.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:y.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:y.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[y.localize(61,null),y.localize(62,null),y.localize(63,null)]},description:{type:"string",markdownDescription:y.localize(64,null)}}},untrustedWorkspaces:{description:y.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:y.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[y.localize(67,null),y.localize(68,null),y.localize(69,null)]},restrictedConfigurations:{description:y.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:y.localize(71,null)}}}}},sponsor:{description:y.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:y.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:y.localize(74,null),type:"string"},"vscode:uninstall":{description:y.localize(75,null),type:"string"}}},icon:{type:"string",description:y.localize(76,null)},l10n:{type:"string",description:y.localize(77,null)},pricing:{type:"string",markdownDescription:y.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class r{constructor(){this.a=new Map}registerExtensionPoint(l){if(this.a.has(l.extensionPoint))throw new Error("Duplicate extension point: "+l.extensionPoint);const n=new g(l.extensionPoint,l.defaultExtensionKind);return this.a.set(l.extensionPoint,n),l.activationEventsGenerator&&D.$xF.register(l.extensionPoint,l.activationEventsGenerator),e.$VF.properties.contributes.properties[l.extensionPoint]=l.jsonSchema,u.registerSchema(i,e.$VF),n}getExtensionPoints(){return Array.from(this.a.values())}}e.$WF=r;const c={ExtensionsRegistry:"ExtensionsRegistry"};$.$mn.add(c.ExtensionsRegistry,new r),e.$XF=$.$mn.as(c.ExtensionsRegistry),u.registerSchema(i,e.$VF),u.registerSchema(C.$wj,{properties:{extensionEnabledApiProposals:{description:y.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(f.allApiProposals),markdownEnumDescriptions:Object.values(f.allApiProposals)}}]}}}})}),define(Pe[228],Ae([1,0,175,16,26,227,34,5]),function(we,e,y,T,P,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7F=void 0;const E={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:y.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:y.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:y.localize(2,null),default:""}}};var f;(function(u){function b(v,g,t){if(!v)return;const i=T.$Cf(v.type)?v.type:void 0;if(!i||i.length===0){t.error(y.localize(3,null));return}const r=[];if(Array.isArray(v.required))for(const c of v.required)T.$Cf(c)&&r.push(c);return{extensionId:g.value,taskType:i,required:r,properties:v.properties?P.$an(v.properties):{},when:v.when?A.$Ti.deserialize(v.when):void 0}}u.from=b})(f||(f={}));const C=M.$XF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,b)=>{for(const v of u)v.type&&b.push(`onTaskType:${v.type}`)},jsonSchema:{description:y.localize(4,null),type:"array",items:E}});class D{constructor(){this.d=new $.$Rd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((b,v)=>{C.setHandler((g,t)=>{this.c=void 0;try{for(const i of t.removed){const r=i.value;for(const c of r)this.a&&c.type&&this.a[c.type]&&delete this.a[c.type]}for(const i of t.added){const r=i.value;for(const c of r){const o=f.from(c,i.description.identifier,i.collector);o&&(this.a[o.taskType]=o)}}(t.removed.length>0||t.added.length>0)&&this.d.fire()}catch{}b(void 0)})})}onReady(){return this.b}get(b){return this.a[b]}all(){return Object.keys(this.a).map(b=>this.a[b])}getJsonSchema(){if(this.c===void 0){const b=[];for(const v of this.all()){const g={type:"object",additionalProperties:!1};v.required.length>0&&(g.required=v.required.slice(0)),v.properties!==void 0?g.properties=P.$an(v.properties):g.properties=Object.create(null),g.properties.type={type:"string",enum:[v.taskType]},b.push(g)}this.c={oneOf:b}}return this.c}}e.$7F=new D}),define(Pe[229],Ae([1,0,176,16,25,26,34,228]),function(we,e,y,T,P,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$eG=e.JsonSchemaVersion=e.ExecutionEngine=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$$F=e.ShellQuoting=e.$0F=e.$9F=e.$8F=void 0,e.$8F="settings",e.$9F=new A.$aj("taskRunning",!1,y.localize(0,null)),e.$0F={value:y.localize(1,null),original:"Tasks"};var E;(function(L){L[L.Escape=1]="Escape",L[L.Strong=2]="Strong",L[L.Weak=3]="Weak"})(E||(e.ShellQuoting=E={})),e.$$F="$customized",function(L){function O(Y){if(!Y)return L.Strong;switch(Y.toLowerCase()){case"escape":return L.Escape;case"strong":return L.Strong;case"weak":return L.Weak;default:return L.Strong}}L.from=O}(E||(e.ShellQuoting=E={}));var f;(function(L){L.defaults={cwd:"${workspaceFolder}"}})(f||(e.CommandOptions=f={}));var C;(function(L){L[L.Always=1]="Always",L[L.Silent=2]="Silent",L[L.Never=3]="Never"})(C||(e.RevealKind=C={})),function(L){function O(Y){switch(Y.toLowerCase()){case"always":return L.Always;case"silent":return L.Silent;case"never":return L.Never;default:return L.Always}}L.fromString=O}(C||(e.RevealKind=C={}));var D;(function(L){L[L.Never=1]="Never",L[L.OnProblem=2]="OnProblem",L[L.Always=3]="Always"})(D||(e.RevealProblemKind=D={})),function(L){function O(Y){switch(Y.toLowerCase()){case"always":return L.Always;case"never":return L.Never;case"onproblem":return L.OnProblem;default:return L.OnProblem}}L.fromString=O}(D||(e.RevealProblemKind=D={}));var u;(function(L){L[L.Shared=1]="Shared",L[L.Dedicated=2]="Dedicated",L[L.New=3]="New"})(u||(e.PanelKind=u={})),function(L){function O(Y){switch(Y.toLowerCase()){case"shared":return L.Shared;case"dedicated":return L.Dedicated;case"new":return L.New;default:return L.Shared}}L.fromString=O}(u||(e.PanelKind=u={}));var b;(function(L){L.defaults={echo:!0,reveal:C.Always,revealProblems:D.Never,focus:!1,panel:u.Shared,showReuseMessage:!0,clear:!1}})(b||(e.PresentationOptions=b={}));var v;(function(L){L[L.Shell=1]="Shell",L[L.Process=2]="Process",L[L.CustomExecution=3]="CustomExecution"})(v||(e.RuntimeType=v={})),function(L){function O(he){switch(he.toLowerCase()){case"shell":return L.Shell;case"process":return L.Process;case"customExecution":return L.CustomExecution;default:return L.Process}}L.fromString=O;function Y(he){switch(he){case L.Shell:return"shell";case L.Process:return"process";case L.CustomExecution:return"customExecution";default:return"process"}}L.toString=Y}(v||(e.RuntimeType=v={}));var g;(function(L){function O(Y){return T.$Cf(Y)?Y:Y.value}L.value=O})(g||(e.CommandString=g={}));var t;(function(L){L.Clean={_id:"clean",isDefault:!1},L.Build={_id:"build",isDefault:!1},L.Rebuild={_id:"rebuild",isDefault:!1},L.Test={_id:"test",isDefault:!1};function O(he){return he===L.Clean._id||he===L.Build._id||he===L.Rebuild._id||he===L.Test._id}L.is=O;function Y(he){if(he!==void 0)return T.$Cf(he)?O(he)?{_id:he,isDefault:!1}:void 0:he}L.from=Y})(t||(e.TaskGroup=t={}));var i;(function(L){L[L.Global=1]="Global",L[L.Workspace=2]="Workspace",L[L.Folder=3]="Folder"})(i||(e.TaskScope=i={}));var r;(function(L){L.Workspace="workspace",L.Extension="extension",L.InMemory="inMemory",L.WorkspaceFile="workspaceFile",L.User="user";function O(Y){switch(Y){case L.User:return 2;case L.WorkspaceFile:return 5;default:return 6}}L.toConfigurationTarget=O})(r||(e.TaskSourceKind=r={}));var c;(function(L){L.parallel="parallel",L.sequence="sequence"})(c||(e.DependsOrder=c={}));var o;(function(L){L[L.default=1]="default",L[L.folderOpen=2]="folderOpen"})(o||(e.RunOnOptions=o={}));var l;(function(L){L.defaults={reevaluateOnRerun:!0,runOn:o.default,instanceLimit:1}})(l||(e.RunOptions=l={}));class n{constructor(O,Y,he,$e,De,ke){this._label="",this._id=O,Y&&(this._label=Y),he&&(this.type=he),this.runOptions=$e,this.configurationProperties=De,this._source=ke}getDefinition(O){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const O={folder:this.d(),id:this._id};return JSON.stringify(O)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(O,Y=!1){if(O===void 0)return!1;if(T.$Cf(O))return O===this._label||O===this.configurationProperties.identifier||Y&&O===this._id;const he=this.getDefinition(!0);return he!==void 0&&he._key===O._key}getQualifiedLabel(){const O=this.getWorkspaceFolder();return O?`${this._label} (${O.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(O){this.c===void 0&&(this.c=[]),O&&(this.c=this.c.concat(O))}get taskLoadMessages(){return this.c}}e.$_F=n;class s extends n{constructor(O,Y,he,$e,De,ke,fe,ve){super(O,he,void 0,fe,ve,Y),this.command={},this._source=Y,this.hasDefinedMatchers=ke,De&&(this.command=De)}clone(){return new s(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(O=!1){if(O&&this._source.customizes!==void 0)return this._source.customizes;{let Y;switch(this.command?this.command.runtime:void 0){case v.Shell:Y="shell";break;case v.Process:Y="process";break;case v.CustomExecution:Y="customExecution";break;case void 0:Y="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:Y,_key:this._id,id:this._id}}}static is(O){return O instanceof s}getMapKey(){const O=this._source.config.workspaceFolder;return O?`${O.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===r.User?e.$8F:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const O=this.d();if(!O)return;let Y=this.configurationProperties.identifier;this._source.kind!==r.Workspace&&(Y+=this._source.kind);const he={type:e.$$F,folder:O,id:Y};return JSON.stringify(he)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$wg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(O){return new s(O._id,O._source,O._label,O.type,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$aG=s;class a extends n{constructor(O,Y,he,$e,De,ke,fe){super(O,he,$e,ke,fe,Y),this._source=Y,this.configures=De}static is(O){return O instanceof a}f(O){return O}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$wg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===r.User?e.$8F:this._source.config.workspaceFolder?.uri.toString()}getKey(){const O=this.d();if(!O)return;let Y=this.configurationProperties.identifier;this._source.kind!==r.Workspace&&(Y+=this._source.kind);const he={type:e.$$F,folder:O,id:Y};return JSON.stringify(he)}}e.$bG=a;class d extends n{constructor(O,Y,he,$e,De,ke,fe,ve,te){super(O,he,$e,ve,te,Y),this.defines=De,this.hasDefinedMatchers=fe,this.command=ke,this.icon=te.icon,this.hide=te.hide}clone(){return new d(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(O){return O instanceof d}getMapKey(){const O=this._source.workspaceFolder;return O?`${this._source.scope.toString()}|${O.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const O={type:"contributed",scope:this._source.scope,id:this._id};return O.folder=this.d(),JSON.stringify(O)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(O){return new d(O._id,O._source,O._label,O.type,O.defines,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$cG=d;class p extends n{constructor(O,Y,he,$e,De,ke){super(O,he,$e,De,ke,Y),this._source=Y}clone(){return new p(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(O){return O instanceof p}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(O){return new p(O._id,O._source,O._label,O.type,O.runOptions,O.configurationProperties)}}e.$dG=p;var m;(function(L){L[L.Process=1]="Process",L[L.Terminal=2]="Terminal"})(m||(e.ExecutionEngine=m={})),function(L){L._default=L.Terminal}(m||(e.ExecutionEngine=m={}));var S;(function(L){L[L.V0_1_0=1]="V0_1_0",L[L.V2_0_0=2]="V2_0_0"})(S||(e.JsonSchemaVersion=S={}));class k{constructor(O){this.c=new Map;for(let Y=0;Y<O.length;Y++)this.c.set(O[Y].uri.toString(),Y)}compare(O,Y){const he=O.getWorkspaceFolder(),$e=Y.getWorkspaceFolder();if(he&&$e){let De=this.c.get(he.uri.toString());De=De===void 0?0:De+1;let ke=this.c.get($e.uri.toString());return ke=ke===void 0?0:ke+1,De===ke?O._label.localeCompare(Y._label):De-ke}else return!he&&$e?-1:he&&!$e?1:0}}e.$eG=k;var h;(function(L){L.DependsOnStarted="dependsOnStarted",L.AcquiredInput="acquiredInput",L.Start="start",L.ProcessStarted="processStarted",L.Active="active",L.Inactive="inactive",L.Changed="changed",L.Terminated="terminated",L.ProcessEnded="processEnded",L.End="end"})(h||(e.TaskEventKind=h={}));var w;(function(L){L.SingleRun="singleRun",L.Background="background"})(w||(e.TaskRunType=w={}));var I;(function(L){L[L.System=0]="System",L[L.User=1]="User",L[L.FolderOpen=2]="FolderOpen",L[L.ConfigurationChange=3]="ConfigurationChange",L[L.Reconnect=4]="Reconnect"})(I||(e.TaskRunSource=I={}));var F;(function(L){function O(ve){return{taskId:ve._id,taskName:ve.configurationProperties.name,runType:ve.configurationProperties.isBackground?"background":"singleRun",group:ve.configurationProperties.group,__task:ve}}function Y(ve,te,Re){return{...O(ve),kind:"start",terminalId:te,resolvedVariables:Re}}L.start=Y;function he(ve,te,Re){return{...O(ve),kind:"processStarted",terminalId:te,processId:Re}}L.processStarted=he;function $e(ve,te,Re){return{...O(ve),kind:"processEnded",terminalId:te,exitCode:Re}}L.processEnded=$e;function De(ve,te,Re){return{...O(ve),kind:"terminated",exitReason:Re,terminalId:te}}L.terminated=De;function ke(ve,te,Re){return{...O(te),kind:ve,terminalId:Re}}L.general=ke;function fe(){return{kind:"changed"}}L.changed=fe})(F||(e.TaskEvent=F={}));var V;(function(L){function O(he){const $e=Object.keys(he).sort();let De="";for(const ke of $e){let fe=he[ke];fe instanceof Object?fe=O(fe):typeof fe=="string"&&(fe=fe.replace(/,/g,",,")),De+=ke+","+fe+","}return De}function Y(he){const De={_key:O(he),type:he.taskType};return Object.assign(De,he),De}L.create=Y})(V||(e.KeyedTaskIdentifier=V={}));var Z;(function(L){L.AutoDetect="task.autoDetect",L.SaveBeforeRun="task.saveBeforeRun",L.ShowDecorations="task.showDecorations",L.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",L.SlowProviderWarning="task.slowProviderWarning",L.QuickOpenHistory="task.quickOpen.history",L.QuickOpenDetail="task.quickOpen.detail",L.QuickOpenSkip="task.quickOpen.skip",L.QuickOpenShowAll="task.quickOpen.showAll",L.AllowAutomaticTasks="task.allowAutomaticTasks",L.Reconnection="task.reconnection",L.VerboseLogging="task.verboseLogging"})(Z||(e.TaskSettingId=Z={}));var N;(function(L){L.Tasks="tasks",L.SuppressTaskName="tasks.suppressTaskName",L.Windows="tasks.windows",L.Osx="tasks.osx",L.Linux="tasks.linux",L.ShowOutput="tasks.showOutput",L.IsShellCommand="tasks.isShellCommand",L.ServiceTestSetting="tasks.service.testSetting"})(N||(e.TasksSchemaProperties=N={}));var R;(function(L){function O(Y,he){const $e=$.$7F.get(Y.type);if($e===void 0){const ve=M.$an(Y);return delete ve._key,V.create(ve)}const De=Object.create(null);De.type=$e.taskType;const ke=new Set;$e.required.forEach(ve=>ke.add(ve));const fe=$e.properties;for(const ve of Object.keys(fe)){const te=Y[ve];if(te!=null)De[ve]=te;else if(ke.has(ve)){const Re=fe[ve];if(Re.default!==void 0)De[ve]=M.$an(Re.default);else switch(Re.type){case"boolean":De[ve]=!1;break;case"number":case"integer":De[ve]=0;break;case"string":De[ve]="";break;default:he.error(y.localize(2,null,JSON.stringify(Y,void 0,0),ve));return}}}return V.create(De)}L.createTaskIdentifier=O})(R||(e.TaskDefinition=R={}))}),define(Pe[230],Ae([1,0,11]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_5b=e.$$5b=void 0;class T{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,$)=>{this.b=A,this.d=$,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,y.$Z)(A))}then(A,$){return this.j().then(A,$)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$$5b=T;class P extends T{constructor(){super(),this.h=!0,this.i=new y.$4}}e.$_5b=P}),define(Pe[49],Ae([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wv=e.$vv=e.$uv=e.$tv=void 0;class y{static{this.count=0}constructor(E){this._proxyIdentifierBrand=void 0,this.sid=E,this.nid=++y.count}}e.$tv=y;const T=[];function P($){const E=new y($);return T[E.nid]=E,E}e.$uv=P;function M($){return T[$].sid}e.$vv=M;class A{constructor(E){this.value=E}}e.$wv=A}),define(Pe[3],Ae([1,0,49]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zK=e.$yK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$xK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var T;(function(g){g[g.Default=0]="Default",g[g.InCenter=1]="InCenter",g[g.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",g[g.AtTop=3]="AtTop"})(T||(e.TextEditorRevealType=T={}));var P;(function(g){g[g.UnknownInput=0]="UnknownInput",g[g.TextInput=1]="TextInput",g[g.TextDiffInput=2]="TextDiffInput",g[g.TextMergeInput=3]="TextMergeInput",g[g.NotebookInput=4]="NotebookInput",g[g.NotebookDiffInput=5]="NotebookDiffInput",g[g.CustomEditorInput=6]="CustomEditorInput",g[g.WebviewEditorInput=7]="WebviewEditorInput",g[g.TerminalEditorInput=8]="TerminalEditorInput",g[g.InteractiveEditorInput=9]="InteractiveEditorInput",g[g.ChatEditorInput=10]="ChatEditorInput"})(P||(e.TabInputKind=P={}));var M;(function(g){g[g.TAB_OPEN=0]="TAB_OPEN",g[g.TAB_CLOSE=1]="TAB_CLOSE",g[g.TAB_UPDATE=2]="TAB_UPDATE",g[g.TAB_MOVE=3]="TAB_MOVE"})(M||(e.TabModelOperationKind=M={}));var A;(function(g){g[g.Editable=0]="Editable",g[g.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var $;(function(g){g[g.Int8Array=1]="Int8Array",g[g.Uint8Array=2]="Uint8Array",g[g.Uint8ClampedArray=3]="Uint8ClampedArray",g[g.Int16Array=4]="Int16Array",g[g.Uint16Array=5]="Uint16Array",g[g.Int32Array=6]="Int32Array",g[g.Uint32Array=7]="Uint32Array",g[g.Float32Array=8]="Float32Array",g[g.Float64Array=9]="Float64Array",g[g.BigInt64Array=10]="BigInt64Array",g[g.BigUint64Array=11]="BigUint64Array"})($||(e.WebviewMessageArrayBufferViewType=$={}));var E;(function(g){g[g.Text=1]="Text",g[g.Error=2]="Error",g[g.Rich=3]="Rich"})(E||(e.CellOutputKind=E={}));var f;(function(g){g[g.Default=0]="Default",g[g.InCenter=1]="InCenter",g[g.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",g[g.AtTop=3]="AtTop"})(f||(e.NotebookEditorRevealType=f={}));var C;(function(g){g[g.None=0]="None",g[g.Process=1]="Process",g[g.Output=2]="Output"})(C||(e.CandidatePortSource=C={}));class D{static{this.a=0}static mixin(t){return t._id=D.a++,t}}e.$xK=D;var u;(function(g){g.label="a",g.kind="b",g.detail="c",g.documentation="d",g.sortText="e",g.filterText="f",g.preselect="g",g.insertText="h",g.insertTextRules="i",g.range="j",g.commitCharacters="k",g.additionalTextEdits="l",g.kindModifier="m",g.commandIdent="n",g.commandId="o",g.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var b;(function(g){g.defaultRanges="a",g.completions="b",g.isIncomplete="c",g.duration="d"})(b||(e.ISuggestResultDtoField=b={}));var v;(function(g){g[g.Workspace=0]="Workspace",g[g.TextDocument=1]="TextDocument"})(v||(e.ExtHostTestingResource=v={})),e.$yK={MainThreadAuthentication:(0,y.$uv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,y.$uv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,y.$uv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,y.$uv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,y.$uv)("MainThreadChatVariables"),MainThreadClipboard:(0,y.$uv)("MainThreadClipboard"),MainThreadCommands:(0,y.$uv)("MainThreadCommands"),MainThreadComments:(0,y.$uv)("MainThreadComments"),MainThreadConfiguration:(0,y.$uv)("MainThreadConfiguration"),MainThreadConsole:(0,y.$uv)("MainThreadConsole"),MainThreadDebugService:(0,y.$uv)("MainThreadDebugService"),MainThreadDecorations:(0,y.$uv)("MainThreadDecorations"),MainThreadDiagnostics:(0,y.$uv)("MainThreadDiagnostics"),MainThreadDialogs:(0,y.$uv)("MainThreadDiaglogs"),MainThreadDocuments:(0,y.$uv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,y.$uv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,y.$uv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,y.$uv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,y.$uv)("MainThreadEditorTabs"),MainThreadErrors:(0,y.$uv)("MainThreadErrors"),MainThreadTreeViews:(0,y.$uv)("MainThreadTreeViews"),MainThreadDownloadService:(0,y.$uv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,y.$uv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,y.$uv)("MainThreadLanguages"),MainThreadLogger:(0,y.$uv)("MainThreadLogger"),MainThreadMessageService:(0,y.$uv)("MainThreadMessageService"),MainThreadOutputService:(0,y.$uv)("MainThreadOutputService"),MainThreadProgress:(0,y.$uv)("MainThreadProgress"),MainThreadQuickDiff:(0,y.$uv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,y.$uv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,y.$uv)("MainThreadStatusBar"),MainThreadSecretState:(0,y.$uv)("MainThreadSecretState"),MainThreadStorage:(0,y.$uv)("MainThreadStorage"),MainThreadSpeech:(0,y.$uv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,y.$uv)("MainThreadTelemetry"),MainThreadTerminalService:(0,y.$uv)("MainThreadTerminalService"),MainThreadWebviews:(0,y.$uv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,y.$uv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,y.$uv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,y.$uv)("MainThreadCustomEditors"),MainThreadUrls:(0,y.$uv)("MainThreadUrls"),MainThreadUriOpeners:(0,y.$uv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,y.$uv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,y.$uv)("MainThreadWorkspace"),MainThreadFileSystem:(0,y.$uv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,y.$uv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,y.$uv)("MainThreadExtensionService"),MainThreadSCM:(0,y.$uv)("MainThreadSCM"),MainThreadSearch:(0,y.$uv)("MainThreadSearch"),MainThreadShare:(0,y.$uv)("MainThreadShare"),MainThreadTask:(0,y.$uv)("MainThreadTask"),MainThreadWindow:(0,y.$uv)("MainThreadWindow"),MainThreadLabelService:(0,y.$uv)("MainThreadLabelService"),MainThreadNotebook:(0,y.$uv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,y.$uv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,y.$uv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,y.$uv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,y.$uv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,y.$uv)("MainThreadInteractive"),MainThreadChat:(0,y.$uv)("MainThreadChat"),MainThreadInlineChat:(0,y.$uv)("MainThreadInlineChatShape"),MainThreadTheming:(0,y.$uv)("MainThreadTheming"),MainThreadTunnelService:(0,y.$uv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,y.$uv)("MainThreadManagedSockets"),MainThreadTimeline:(0,y.$uv)("MainThreadTimeline"),MainThreadTesting:(0,y.$uv)("MainThreadTesting"),MainThreadLocalization:(0,y.$uv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,y.$uv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,y.$uv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,y.$uv)("MainThreadIssueReporter")},e.$zK={ExtHostCommands:(0,y.$uv)("ExtHostCommands"),ExtHostConfiguration:(0,y.$uv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,y.$uv)("ExtHostDiagnostics"),ExtHostDebugService:(0,y.$uv)("ExtHostDebugService"),ExtHostDecorations:(0,y.$uv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,y.$uv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,y.$uv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,y.$uv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,y.$uv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,y.$uv)("ExtHostEditors"),ExtHostTreeViews:(0,y.$uv)("ExtHostTreeViews"),ExtHostFileSystem:(0,y.$uv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,y.$uv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,y.$uv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,y.$uv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,y.$uv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,y.$uv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,y.$uv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,y.$uv)("ExtHostStatusBar"),ExtHostShare:(0,y.$uv)("ExtHostShare"),ExtHostExtensionService:(0,y.$uv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,y.$uv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,y.$uv)("ExtHostTerminalService"),ExtHostSCM:(0,y.$uv)("ExtHostSCM"),ExtHostSearch:(0,y.$uv)("ExtHostSearch"),ExtHostTask:(0,y.$uv)("ExtHostTask"),ExtHostWorkspace:(0,y.$uv)("ExtHostWorkspace"),ExtHostWindow:(0,y.$uv)("ExtHostWindow"),ExtHostWebviews:(0,y.$uv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,y.$uv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,y.$uv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,y.$uv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,y.$uv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,y.$uv)("ExtHostEditorTabs"),ExtHostProgress:(0,y.$uv)("ExtHostProgress"),ExtHostComments:(0,y.$uv)("ExtHostComments"),ExtHostSecretState:(0,y.$uv)("ExtHostSecretState"),ExtHostStorage:(0,y.$uv)("ExtHostStorage"),ExtHostUrls:(0,y.$uv)("ExtHostUrls"),ExtHostUriOpeners:(0,y.$uv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,y.$uv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,y.$uv)("ExtHostOutputService"),ExtHosLabelService:(0,y.$uv)("ExtHostLabelService"),ExtHostNotebook:(0,y.$uv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,y.$uv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,y.$uv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,y.$uv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,y.$uv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,y.$uv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,y.$uv)("ExtHostInteractive"),ExtHostInlineChat:(0,y.$uv)("ExtHostInlineChatShape"),ExtHostChat:(0,y.$uv)("ExtHostChat"),ExtHostChatAgents2:(0,y.$uv)("ExtHostChatAgents"),ExtHostChatVariables:(0,y.$uv)("ExtHostChatVariables"),ExtHostChatProvider:(0,y.$uv)("ExtHostChatProvider"),ExtHostSpeech:(0,y.$uv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,y.$uv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,y.$uv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,y.$uv)("ExtHostTheming"),ExtHostTunnelService:(0,y.$uv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,y.$uv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,y.$uv)("ExtHostAuthentication"),ExtHostTimeline:(0,y.$uv)("ExtHostTimeline"),ExtHostTesting:(0,y.$uv)("ExtHostTesting"),ExtHostTelemetry:(0,y.$uv)("ExtHostTelemetry"),ExtHostLocalization:(0,y.$uv)("ExtHostLocalization"),ExtHostIssueReporter:(0,y.$uv)("ExtHostIssueReporter")}}),define(Pe[231],Ae([1,0,3,7]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sdc=void 0;class P{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(y.$yK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,$,E){if(this.a.size===0)throw new Error("No related information providers registered");const f=this.a.get(A);if(!f)throw new Error("related information provider not found");return await f.provideRelatedInformation($,E)??[]}getRelatedInformation(A,$,E){return this.c.$getAiRelatedInformation($,E)}registerRelatedInformationProvider(A,$,E){const f=this.b;return this.b++,this.a.set(f,E),this.c.$registerAiRelatedInformationProvider(f,$),new T.$AK(()=>{this.c.$unregisterAiRelatedInformationProvider(f),this.a.delete(f)})}}e.$Sdc=P}),define(Pe[81],Ae([1,0,4,15,3,17]),function(we,e,y,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1dc=e.$Zdc=e.$Ydc=void 0,e.$Ydc=(0,y.$Vh)("IExtHostApiDeprecationService");let A=class{constructor(E,f){this.c=f,this.a=new Set,this.b=E.getProxy(P.$yK.MainThreadTelemetry)}report(E,f,C){const D=this.d(E,f);this.a.has(D)||(this.a.add(D),f.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${E}' is deprecated. ${C}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:f.identifier.value,apiId:E}))}d(E,f){return`${E}-${f.identifier.value}`}};e.$Zdc=A,e.$Zdc=A=Ke([Ve(0,M.$AM),Ve(1,T.$dj)],A),e.$1dc=Object.freeze(new class{report($,E,f){}})}),define(Pe[232],Ae([1,0,5,3,7,22]),function(we,e,y,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4dc=void 0;class A{constructor(f){this.b=new Map,this.c=[],this.d=new y.$Rd,this.onDidChangeSessions=this.d.event,this.f=new $,this.g=new $,this.a=f.getProxy(T.$yK.MainThreadAuthentication)}$setProviders(f){return this.c=f,Promise.resolve()}async getSession(f,C,D,u={}){const b=M.$_l.toKey(f.identifier),v=[...D].sort().join(" ");return await this.f.getOrCreate(`${b} ${C} ${v}`,async()=>{await this.a.$ensureProvider(C);const g=f.displayName||f.name;return this.a.$getSession(C,D,b,g,u)})}async getSessions(f,C,D){const u=M.$_l.toKey(f.identifier),b=[...D].sort().join(" ");return await this.g.getOrCreate(`${u} ${b}`,async()=>{await this.a.$ensureProvider(C);const v=f.displayName||f.name;return this.a.$getSessions(C,D,u,v)})}async removeSession(f,C){const D=this.b.get(f);return D?D.provider.removeSession(C):this.a.$removeSession(f,C)}registerAuthenticationProvider(f,C,D,u){if(this.b.get(f))throw new Error(`An authentication provider with id '${f}' is already registered.`);this.b.set(f,{label:C,provider:D,options:u??{supportsMultipleAccounts:!1}}),this.c.find(v=>v.id===f)||this.c.push({id:f,label:C});const b=D.onDidChangeSessions(v=>{this.a.$sendDidChangeSessions(f,{added:v.added??[],changed:v.changed??[],removed:v.removed??[]})});return this.a.$registerAuthenticationProvider(f,C,u?.supportsMultipleAccounts??!1),new P.$AK(()=>{b.dispose(),this.b.delete(f);const v=this.c.findIndex(g=>g.id===f);v>-1&&this.c.splice(v),this.a.$unregisterAuthenticationProvider(f)})}$createSession(f,C,D){const u=this.b.get(f);if(u)return Promise.resolve(u.provider.createSession(C,D));throw new Error(`Unable to find authentication provider with handle: ${f}`)}$removeSession(f,C){const D=this.b.get(f);if(D)return Promise.resolve(D.provider.removeSession(C));throw new Error(`Unable to find authentication provider with handle: ${f}`)}$getSessions(f,C){const D=this.b.get(f);if(D)return Promise.resolve(D.provider.getSessions(C));throw new Error(`Unable to find authentication provider with handle: ${f}`)}$onDidChangeAuthenticationSessions(f,C){return this.d.fire({provider:{id:f,label:C}}),Promise.resolve()}}e.$4dc=A;class ${constructor(){this.a=new Map}getOrCreate(f,C){const D=this.a.get(f);if(D)return D;const u=C().finally(()=>this.a.delete(f));return this.a.set(f,u),u}}}),define(Pe[233],Ae([1,0,3,17,8]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5dc=void 0;let M=class{constructor($,E){this.a=$.getProxy(y.$yK.MainThreadBulkEdits),this.b={getTextDocumentVersion:f=>E.getDocument(f)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,E,f){const C=P.WorkspaceEdit.from($,this.b);return this.a.$tryApplyWorkspaceEdit(C,void 0,f?.isRefactoring??!1)}};e.$5dc=M,e.$5dc=M=Ke([Ve(0,T.$AM)],M)}),define(Pe[234],Ae([1,0,5,67,6,3,8]),function(we,e,y,T,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6dc=void 0;class ${static{this.a=0}constructor(C,D){this.extension=C,this.provider=D,this.handle=$.a++}}class E{static{this.a=0}constructor(C){this.b=new Map,this.c=new Map,this.d=new y.$Rd,this.onDidPerformUserAction=this.d.event,this.e=C.getProxy(M.$yK.MainThreadChat)}registerChatProvider(C,D,u){const b=new $(C,u);return this.b.set(b.handle,b),this.e.$registerChatProvider(b.handle,D),(0,P.$Pc)(()=>{this.e.$unregisterChatProvider(b.handle),this.b.delete(b.handle)})}transferChatSession(C,D){const u=T.Iterable.find(this.c.keys(),b=>this.c.get(b)===C)??0;typeof u=="number"&&this.e.$transferChatSession(u,D)}sendInteractiveRequestToProvider(C,D){this.e.$sendRequestToProvider(C,D)}async $prepareChat(C,D){const u=this.b.get(C);if(!u)return;const b=await u.provider.prepareSession(D);if(!b)return;const v=E.a++;return this.c.set(v,b),{id:v,requesterUsername:b.requester?.name,requesterAvatarIconUri:b.requester?.icon,responderUsername:b.responder?.name,responderAvatarIconUri:b.responder?.icon,inputPlaceholder:b.inputPlaceholder}}async $provideWelcomeMessage(C,D){const u=this.b.get(C);if(!u||!u.provider.provideWelcomeMessage)return;const b=await u.provider.provideWelcomeMessage(D);if(b)return b.map(v=>typeof v=="string"?v:Array.isArray(v)?v.map(g=>A.ChatReplyFollowup.from(g)):A.MarkdownString.from(v))}async $provideSampleQuestions(C,D){const u=this.b.get(C);if(!u||!u.provider.provideSampleQuestions)return;const b=await u.provider.provideSampleQuestions(D);if(b)return b?.map(v=>A.ChatReplyFollowup.from(v))}$releaseSession(C){this.c.delete(C)}async $onDidPerformUserAction(C){this.d.fire(C)}}e.$6dc=E}),define(Pe[235],Ae([1,0,14,19,39,5,60,16,2,157,72,3,8,7,206,23]),function(we,e,y,T,P,M,A,$,E,f,C,D,u,b,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8dc=void 0;class t{static{this.a=0}constructor(c,o,l){this.i=o,this.j=l,this.b=new Map,this.g=new Map,this.h=new Map,this.d=c.getProxy(D.$yK.MainThreadChatAgents2)}createChatAgent(c,o,l){const n=t.a++,s=new i(c,o,this.d,n,l);return this.b.set(n,s),this.d.$registerAgent(n,o,{}),s.apiAgent}async $invokeAgent(c,o,l,n,s,a){this.g.delete(o);const d=this.b.get(c);if(!d)throw new Error(`[CHAT](${c}) CANNOT invoke agent because the agent is not registered`);let p=!1;function m(){if(p)throw new Error("Only valid while executing the command")}const S=new y.$ih;a.onCancellationRequested(()=>S.complete()),setTimeout(()=>S.complete(),10*1e3),this.i.allowListExtensionWhile(d.extension.identifier,S.p);const k=n.command?await d.validateSlashCommand(n.command):void 0,h=A.$Nd.create(!1);let w;try{const I=d.invoke({prompt:n.message,variables:u.ChatVariable.objectTo(n.variables),slashCommand:k},{history:s.history.map(u.ChatMessage.to)},new C.$$u(F=>{m(),typeof w>"u"&&"content"in F&&(w=h.elapsed());const V=u.ChatResponseProgress.from(d.extension,F);if("placeholder"in F&&"resolvedContent"in F){const Z=Promise.all([this.d.$handleProgressChunk(l,V),F.resolvedContent]);(0,y.$Mg)(Z,a).then(N=>{if(!N)return;const[R,L]=N,O=u.ChatResponseProgress.from(d.extension,L);this.d.$handleProgressChunk(l,O,R??void 0)})}else this.d.$handleProgressChunk(l,V)}),a);return await(0,y.$Mg)(Promise.resolve(I).then(F=>{if(F){this.g.set(o,F);let V=this.h.get(o);V||(V=new Map,this.h.set(o,V)),V.set(l,F);const Z={firstProgress:w,totalElapsed:h.elapsed()};return{errorDetails:F.errorDetails,timings:Z}}else this.g.delete(o)}),a)}catch(I){return this.j.error(I,d.extension),{errorDetails:{message:(0,f.localize)(0,null,(0,P.$Gi)(I)),responseIsIncomplete:!0}}}finally{p=!0,S.complete()}}$releaseSession(c){this.g.delete(c),this.h.delete(c)}async $provideSlashCommands(c,o){const l=this.b.get(c);return l?l.provideSlashCommand(o):[]}$provideFollowups(c,o,l){const n=this.b.get(c);if(!n)return Promise.resolve([]);const s=this.g.get(o);return s?n.provideFollowups(s,l):Promise.resolve([])}$acceptFeedback(c,o,l,n,s){const a=this.b.get(c);if(!a)return;const d=this.h.get(o)?.get(l);if(!d)return;let p;switch(n){case v.InteractiveSessionVoteDirection.Down:p=b.ChatAgentResultFeedbackKind.Unhelpful;break;case v.InteractiveSessionVoteDirection.Up:p=b.ChatAgentResultFeedbackKind.Helpful;break}a.acceptFeedback(Object.freeze(s?{result:d,kind:p,reportIssue:s}:{result:d,kind:p}))}$acceptAction(c,o,l,n){const s=this.b.get(c);if(!s)return;const a=this.h.get(o)?.get(l);a&&n.action.kind!=="vote"&&s.acceptAction(Object.freeze({action:n.action,result:a}))}}e.$8dc=t;class i{constructor(c,o,l,n,s){this.extension=c,this.s=o,this.t=l,this.u=n,this.w=s,this.o=new M.$Rd,this.q=new M.$Rd}acceptFeedback(c){this.o.fire(c)}acceptAction(c){this.q.fire(c)}async validateSlashCommand(c){this.b||(await this.provideSlashCommand(T.CancellationToken.None),(0,$.$Mf)(this.b));const o=this.b.find(l=>l.name===c);if(!o)throw new Error(`Unknown slashCommand: ${c}`);return o}async provideSlashCommand(c){if(!this.a)return[];const o=await this.a.provideSlashCommands(c);return o?(this.b=o,o.map(l=>({name:l.name,description:l.description,followupPlaceholder:l.followupPlaceholder,shouldRepopulate:l.shouldRepopulate,sampleRequest:l.sampleRequest}))):[]}async provideFollowups(c,o){if(!this.d)return[];const l=await this.d.provideFollowups(c,o);return l?l.map(n=>u.ChatFollowup.from(n)):[]}get apiAgent(){let c=!1,o=!1;const l=()=>{c||o||(o=!0,queueMicrotask(()=>{this.t.$updateAgent(this.u,{description:this.g??"",fullName:this.h,icon:this.i?this.i instanceof E.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof b.$uL?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.d!==void 0,isDefault:this.j,isSecondary:this.n,helpTextPrefix:!this.k||typeof this.k=="string"?this.k:u.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:u.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.r}),o=!1}))},n=this;return{get name(){return n.s},get description(){return n.g??""},set description(s){n.g=s,l()},get fullName(){return n.h??n.extension.displayName??n.extension.name},set fullName(s){n.h=s,l()},get iconPath(){return n.i},set iconPath(s){n.i=s,l()},get slashCommandProvider(){return n.a},set slashCommandProvider(s){n.a=s,l()},get followupProvider(){return n.d},set followupProvider(s){n.d=s,l()},get isDefault(){return(0,g.$MF)(n.extension,"defaultChatAgent"),n.j},set isDefault(s){(0,g.$MF)(n.extension,"defaultChatAgent"),n.j=s,l()},get helpTextPrefix(){return(0,g.$MF)(n.extension,"defaultChatAgent"),n.k},set helpTextPrefix(s){if((0,g.$MF)(n.extension,"defaultChatAgent"),!n.j)throw new Error("helpTextPrefix is only available on the default chat agent");n.k=s,l()},get helpTextPostfix(){return(0,g.$MF)(n.extension,"defaultChatAgent"),n.l},set helpTextPostfix(s){if((0,g.$MF)(n.extension,"defaultChatAgent"),!n.j)throw new Error("helpTextPostfix is only available on the default chat agent");n.l=s,l()},get isSecondary(){return(0,g.$MF)(n.extension,"defaultChatAgent"),n.n},set isSecondary(s){(0,g.$MF)(n.extension,"defaultChatAgent"),n.n=s,l()},get sampleRequest(){return n.m},set sampleRequest(s){n.m=s,l()},get supportIssueReporting(){return(0,g.$MF)(n.extension,"chatAgents2Additions"),n.r},set supportIssueReporting(s){(0,g.$MF)(n.extension,"chatAgents2Additions"),n.r=s,l()},get onDidReceiveFeedback(){return n.o.event},onDidPerformAction:(0,g.$LF)(this.extension,"chatAgents2Additions")?this.q.event:void 0,dispose(){c=!0,n.a=void 0,n.d=void 0,n.o.dispose(),n.t.$unregisterAgent(n.u)}}}invoke(c,o,l,n){return this.w(c,o,l,n)}}}),define(Pe[236],Ae([1,0,19,6,3,8,72,22,14,5]),function(we,e,y,T,P,M,A,$,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7dc=void 0;class C{constructor(v,g){this.stream=new E.$mh,this.stream=g??new E.$mh;const t=this;this.apiObj={option:v,response:t.stream.asyncIterable}}}class D{constructor(v,g){this.a=new f.$Rd,this.b=new Map,this.c=new E.$mh,this.d=!1;const t=this;this.apiObject={result:v,response:t.c.asyncIterable,onDidStartResponseStream:t.a.event,cancel(){g.cancel()}},v.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,i]of this.b)i.stream.resolve();else this.c.resolve()})}handleFragment(v){if(this.d)return;let g=this.b.get(v.index);g||(this.b.size===0?g=new C(v.index,this.c):g=new C(v.index),this.b.set(v.index,g),this.a.fire(g.apiObj)),g.stream.emitOne(v.part)}}class u{static{this.a=1}constructor(v,g){this.d=g,this.c=new Map,this.e=new Map,this.f=new $.$bm,this.b=v.getProxy(P.$yK.MainThreadChatProvider)}registerProvider(v,g,t,i){const r=u.a++;return this.c.set(r,{extension:v,provider:t}),this.b.$registerProvider(r,g,{extension:v,displayName:i.name??v.value}),(0,T.$Pc)(()=>{this.b.$unregisterProvider(r),this.c.delete(r)})}async $provideChatResponse(v,g,t,i,r){const c=this.c.get(v);if(!c)return;const o=new A.$$u(async l=>{if(r.isCancellationRequested){this.d.warn(`[CHAT](${c.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(g,{index:l.index,part:l.part})});return c.provider.provideChatResponse(t.map(M.ChatMessage.to),i,o,r)}allowListExtensionWhile(v,g){this.f.set(v,g),g.finally(()=>this.f.delete(v))}async requestChatResponseProvider(v,g){if(!this.f.has(v))throw new Error("Extension is NOT allowed to make chat requests");const t=this;return{get isRevoked(){return!t.f.has(v)},makeRequest(i,r,c){if(!t.f.has(v))throw new Error("Access to chat has been revoked");const o=new y.$2d(c),l=Math.random()*1e6|0,n=t.b.$fetchResponse(v,g,l,i.map(M.ChatMessage.from),r??{},o.token),s=new D(n,o);return t.e.set(l,{res:s}),n.finally(()=>{t.e.delete(l)}),s.apiObject}}}async $handleResponseFragment(v,g){const t=this.e.get(v);t&&t.res.handleFragment(g)}}e.$7dc=u}),define(Pe[237],Ae([1,0,6,3,11,8]),function(we,e,y,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9dc=void 0;class A{static{this.a=0}constructor(E){this.b=new Map,this.c=E.getProxy(T.$yK.MainThreadChatVariables)}async $resolveVariable(E,f,C){const D=this.b.get(E);if(D)try{const u=await D.resolver.resolve(D.data.name,{message:f},C);if(u)return u.map(M.ChatVariable.from)}catch(u){(0,P.$1)(u)}}registerVariableResolver(E,f,C,D){const u=A.a++;return this.b.set(u,{extension:E.identifier,data:{name:f,description:C},resolver:D}),this.c.$registerVariable(u,{name:f,description:C}),(0,y.$Pc)(()=>{this.b.delete(u),this.c.$unregisterVariable(u)})}}e.$9dc=A}),define(Pe[238],Ae([1,0,3]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0dc=void 0;class T{constructor(M){const A=M.getProxy(y.$yK.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText($){return A.$writeText($)}})}}e.$0dc=T}),define(Pe[32],Ae([1,0,16,7,8,26,3,18,15,51,29,131,2,6,4,17,108,24,49,39,60,56,59]),function(we,e,y,T,P,M,A,$,E,f,C,D,u,b,v,g,t,i,r,c,o,l,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1M=e.$ZM=e.$YM=e.$XM=e.$WM=e.$VM=void 0;let s=class{#e;#t;#i;constructor(k,h,w){this.b=new Map,this.c=new Map,this.#e=k.getProxy(A.$yK.MainThreadCommands),this.d=h,this.#i=w,this.#t=k.getProxy(A.$yK.MainThreadTelemetry),this.converter=new a(this,I=>{const F=this.c.get(I);return F?.result===p.Void?F:void 0},h),this.f=[{processArgument(I){return(0,f.$sh)(I)}},{processArgument(I){return(0,M.$cn)(I,function(F){if(C.$zs.isIRange(F))return P.Range.to(F);if(D.$ys.isIPosition(F))return P.Position.to(F);if(C.$zs.isIRange(F.range)&&u.URI.isUri(F.uri))return P.location.to(F);if(F instanceof i.$fe)return F.buffer.buffer;if(!Array.isArray(F))return F})}}]}registerArgumentProcessor(k){this.f.push(k)}registerApiCommand(k){const h=this.registerCommand(!1,k.id,async(...w)=>{const I=k.args.map((V,Z)=>{if(!V.validate(w[Z]))throw new Error(`Invalid argument '${V.name}' when running '${k.id}', received: ${typeof w[Z]=="object"?JSON.stringify(w[Z],null,"	"):w[Z]} `);return V.convert(w[Z])}),F=await this.executeCommand(k.internalId,...I);return k.result.convert(F,w,this.converter)},void 0,{description:k.description,args:k.args,returns:k.result.description});return this.c.set(k.id,k),new T.$AK(()=>{h.dispose(),this.c.delete(k.id)})}registerCommand(k,h,w,I,F,V){if(this.d.trace("ExtHostCommands#registerCommand",h),!h.trim().length)throw new Error("invalid id");if(this.b.has(h))throw new Error(`command '${h}' already exists`);return this.b.set(h,{callback:w,thisArg:I,metadata:F,extension:V}),k&&this.#e.$registerCommand(h),new T.$AK(()=>{this.b.delete(h)&&k&&this.#e.$unregisterCommand(h)})}executeCommand(k,...h){return this.d.trace("ExtHostCommands#executeCommand",k),this.g(k,h,!0)}async g(k,h,w){if(this.b.has(k))return this.#e.$fireCommandActivationEvent(k),this.h(k,h,!1);{let I=!1;const F=(0,M.$cn)(h,function(V){if(V instanceof T.$BK)return P.Position.from(V);if(V instanceof T.$CK)return P.Range.from(V);if(V instanceof T.$MK)return P.location.from(V);if(T.$XL.isNotebookRange(V))return P.NotebookRange.from(V);if(V instanceof ArrayBuffer)return I=!0,i.$fe.wrap(new Uint8Array(V));if(V instanceof Uint8Array)return I=!0,i.$fe.wrap(V);if(V instanceof i.$fe)return I=!0,V;if(!Array.isArray(V))return V});try{const V=await this.#e.$executeCommand(k,I?new r.$wv(F):F,w);return(0,f.$sh)(V)}catch(V){if(V instanceof Error&&V.message==="$executeCommand:retry")return this.g(k,h,!1);throw V}}}async h(k,h,w){const I=this.b.get(k);if(!I)throw new Error("Unknown command");const{callback:F,thisArg:V,metadata:Z}=I;if(Z?.args)for(let R=0;R<Z.args.length;R++)try{(0,y.$Tf)(h[R],Z.args[R].constraint)}catch{throw new Error(`Running the contributed command: '${k}' failed. Illegal argument '${Z.args[R].name}' - ${Z.args[R].description}`)}const N=o.$Nd.create();try{return await F.apply(V,h)}catch(R){if(k===this.converter.delegatingCommandId){const L=this.converter.getActualCommand(...h);L&&(k=L.command)}if(this.d.error(R,k,I.extension?.identifier),!w)throw R;if(I.extension?.identifier){const L=this.#i.onExtensionError(I.extension.identifier,R);this.d.trace("forwarded error to extension?",L,I.extension?.identifier)}throw new class extends Error{constructor(){super((0,c.$Gi)(R)),this.id=k,this.source=I.extension?.displayName??I.extension?.name}}}finally{this.j(I,k,N.elapsed())}}j(k,h,w){k.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:k.extension.identifier.value,id:new l.$po(h),duration:w})}$executeContributedCommand(k,...h){this.d.trace("ExtHostCommands#$executeContributedCommand",k);const w=this.b.get(k);return w?(h=h.map(I=>this.f.reduce((F,V)=>V.processArgument(F,w.extension?.identifier),I)),this.h(k,h,!0)):Promise.reject(new Error(`Contributed command '${k}' does not exist.`))}getCommands(k=!1){return this.d.trace("ExtHostCommands#getCommands",k),this.#e.$getCommands().then(h=>(k&&(h=h.filter(w=>w[0]!=="_")),h))}$getContributedCommandMetadata(){const k=Object.create(null);for(const[h,w]of this.b){const{metadata:I}=w;I&&(k[h]=I)}return Promise.resolve(k)}};e.$VM=s,e.$VM=s=Ke([Ve(0,g.$AM),Ve(1,E.$dj),Ve(2,n.$UM)],s),e.$WM=(0,v.$Vh)("IExtHostCommands");class a{constructor(k,h,w){this.d=k,this.f=h,this.g=w,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(k,h){if(!k)return;const w={$ident:void 0,id:k.command,title:k.title,tooltip:k.tooltip};if(!k.command)return w;const I=this.f(k.command);if(I)w.id=I.internalId,w.arguments=I.args.map((F,V)=>F.convert(k.arguments&&k.arguments[V]));else if((0,$.$Kb)(k.arguments)){const F=`${k.command} /${++this.c}`;this.b.set(F,k),h.add((0,b.$Pc)(()=>{this.b.delete(F),this.g.trace("CommandsConverter#DISPOSE",F)})),w.$ident=F,w.id=this.delegatingCommandId,w.arguments=[F],this.g.trace("CommandsConverter#CREATE",k.command,F)}return w}fromInternal(k){return typeof k.$ident=="string"?this.b.get(k.$ident):{command:k.id,title:k.title,arguments:k.arguments}}getActualCommand(...k){return this.b.get(k[0])}h(...k){const h=this.getActualCommand(...k);return this.g.trace("CommandsConverter#EXECUTE",k[0],h?h.command:"MISSING"),h?this.d.executeCommand(h.command,...h.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${k[0]}`)}}e.$XM=a;class d{static{this.Uri=new d("uri","Uri of a text document",k=>u.URI.isUri(k),k=>k)}static{this.Position=new d("position","A position in a text document",k=>T.$BK.isPosition(k),P.Position.from)}static{this.Range=new d("range","A range in a text document",k=>T.$CK.isRange(k),P.Range.from)}static{this.Selection=new d("selection","A selection in a text document",k=>T.$DK.isSelection(k),P.Selection.from)}static{this.Number=new d("number","",k=>typeof k=="number",k=>k)}static{this.String=new d("string","",k=>typeof k=="string",k=>k)}static{this.StringArray=d.Arr(d.String)}static Arr(k){return new d(`${k.name}_array`,`Array of ${k.name}, ${k.description}`,h=>Array.isArray(h)&&h.every(w=>k.validate(w)),h=>h.map(w=>k.convert(w)))}static{this.CallHierarchyItem=new d("item","A call hierarchy item",k=>k instanceof T.$WK,P.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new d("item","A type hierarchy item",k=>k instanceof T.$eM,P.TypeHierarchyItem.from)}static{this.TestItem=new d("testItem","A VS Code TestItem",k=>k instanceof t.$NM,P.TestItem.from)}constructor(k,h,w,I){this.name=k,this.description=h,this.validate=w,this.convert=I}optional(){return new d(this.name,`(optional) ${this.description}`,k=>k==null||this.validate(k),k=>k===void 0?void 0:k===null?null:this.convert(k))}with(k,h){return new d(k??this.name,h??this.description,this.validate,this.convert)}}e.$YM=d;class p{static{this.Void=new p("no result",k=>k)}constructor(k,h){this.description=k,this.convert=h}}e.$ZM=p;class m{constructor(k,h,w,I,F){this.id=k,this.internalId=h,this.description=w,this.args=I,this.result=F}}e.$1M=m}),define(Pe[239],Ae([1,0,18,13,2,80,95,34,99,32,8,7]),function(we,e,y,T,P,M,A,$,E,f,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3dc=void 0;const u=[new f.$1M("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[f.$YM.Uri,f.$YM.Position],new f.$ZM("A promise that resolves to an array of DocumentHighlight-instances.",v(C.DocumentHighlight.to))),new f.$1M("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[f.$YM.Uri],new f.$ZM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,i)=>{if((0,y.$Jb)(t))return;class r extends D.$RK{static to(o){const l=new r(o.name,C.SymbolKind.to(o.kind),o.containerName||"",new D.$MK(i[0],C.Range.to(o.range)));return l.detail=o.detail,l.range=l.location.range,l.selectionRange=C.Range.to(o.selectionRange),l.children=o.children?o.children.map(r.to):[],l}}return t.map(r.to)})),new f.$1M("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[f.$YM.Uri,new f.$YM("options","Formatting options",t=>!0,t=>t)],new f.$ZM("A promise that resolves to an array of TextEdits.",v(C.TextEdit.to))),new f.$1M("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[f.$YM.Uri,f.$YM.Range,new f.$YM("options","Formatting options",t=>!0,t=>t)],new f.$ZM("A promise that resolves to an array of TextEdits.",v(C.TextEdit.to))),new f.$1M("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[f.$YM.Uri,f.$YM.Position,new f.$YM("ch","Trigger character",t=>typeof t=="string",t=>t),new f.$YM("options","Formatting options",t=>!0,t=>t)],new f.$ZM("A promise that resolves to an array of TextEdits.",v(C.TextEdit.to))),new f.$1M("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[f.$YM.Uri,f.$YM.Position],new f.$ZM("A promise that resolves to an array of Location or LocationLink instances.",g)),new f.$1M("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[f.$YM.Uri,f.$YM.Position],new f.$ZM("A promise that resolves to an array of Location or LocationLink instances.",g)),new f.$1M("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[f.$YM.Uri,f.$YM.Position],new f.$ZM("A promise that resolves to an array of Location or LocationLink instances.",g)),new f.$1M("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[f.$YM.Uri,f.$YM.Position],new f.$ZM("A promise that resolves to an array of Location or LocationLink instances.",g)),new f.$1M("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[f.$YM.Uri,f.$YM.Position],new f.$ZM("A promise that resolves to an array of Location-instances.",v(C.location.to))),new f.$1M("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[f.$YM.Uri,f.$YM.Position],new f.$ZM("A promise that resolves to an array of Hover-instances.",v(C.Hover.to))),new f.$1M("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[f.$YM.Uri,new f.$YM("position","A position in a text document",t=>Array.isArray(t)&&t.every(i=>D.$BK.isPosition(i)),t=>t.map(C.Position.from))],new f.$ZM("A promise that resolves to an array of ranges.",t=>t.map(i=>{let r;for(const c of i.reverse())r=new D.$VK(C.Range.to(c),r);return r}))),new f.$1M("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[f.$YM.String.with("query","Search string")],new f.$ZM("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(C.WorkspaceSymbol.to))),new f.$1M("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[f.$YM.Uri,f.$YM.Position],new f.$ZM("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(C.CallHierarchyItem.to))),new f.$1M("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[f.$YM.CallHierarchyItem],new f.$ZM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(C.CallHierarchyIncomingCall.to))),new f.$1M("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[f.$YM.CallHierarchyItem],new f.$ZM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(C.CallHierarchyOutgoingCall.to))),new f.$1M("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[f.$YM.Uri,f.$YM.Position],new f.$ZM("A promise that resolves to a range and placeholder text.",t=>{if(t)return{range:C.Range.to(t.range),placeholder:t.text}})),new f.$1M("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[f.$YM.Uri,f.$YM.Position,f.$YM.String.with("newName","The new symbol name")],new f.$ZM("A promise that resolves to a WorkspaceEdit.",t=>{if(t){if(t.rejectReason)throw new Error(t.rejectReason);return C.WorkspaceEdit.to(t)}})),new f.$1M("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[f.$YM.Uri,f.$YM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new f.$ZM("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(C.DocumentLink.to))),new f.$1M("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[f.$YM.Uri],new f.$ZM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new D.$PL(t.tokenTypes,t.tokenModifiers)})),new f.$1M("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[f.$YM.Uri],new f.$ZM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,A.$30)(t);if(i.type==="full")return new D.$RL(i.data,void 0)})),new f.$1M("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[f.$YM.Uri,f.$YM.Range.optional()],new f.$ZM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new D.$PL(t.tokenTypes,t.tokenModifiers)})),new f.$1M("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[f.$YM.Uri,f.$YM.Range],new f.$ZM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,A.$30)(t);if(i.type==="full")return new D.$RL(i.data,void 0)})),new f.$1M("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[f.$YM.Uri,f.$YM.Position,f.$YM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),f.$YM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new f.$ZM("A promise that resolves to a CompletionList-instance.",(t,i,r)=>{if(!t)return new D.$8K([]);const c=t.suggestions.map(o=>C.CompletionItem.to(o,r));return new D.$8K(c,t.incomplete)})),new f.$1M("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[f.$YM.Uri,f.$YM.Position,f.$YM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new f.$ZM("A promise that resolves to SignatureHelp.",t=>{if(t)return C.SignatureHelp.to(t)})),new f.$1M("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[f.$YM.Uri,f.$YM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new f.$ZM("A promise that resolves to an array of CodeLens-instances.",(t,i,r)=>v(c=>new D.$ZK(C.Range.to(c.range),c.command&&r.fromInternal(c.command)))(t))),new f.$1M("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[f.$YM.Uri,new f.$YM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>D.$CK.isRange(t),t=>D.$DK.isSelection(t)?C.Selection.from(t):C.Range.from(t)),f.$YM.String.with("kind","Code action kind to return code actions for").optional(),f.$YM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new f.$ZM("A promise that resolves to an array of Command-instances.",(t,i,r)=>v(c=>{if(c._isSynthetic){if(!c.command)throw new Error("Synthetic code actions must have a command");return r.fromInternal(c.command)}else{const o=new D.$TK(c.title,c.kind?new D.$UK(c.kind):void 0);return c.edit&&(o.edit=C.WorkspaceEdit.to(c.edit)),c.command&&(o.command=r.fromInternal(c.command)),o.isPreferred=c.isPreferred,o}})(t))),new f.$1M("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[f.$YM.Uri],new f.$ZM("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(i=>new D.$bL(C.Range.to(i.range),C.Color.to(i.color))):[])),new f.$1M("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new f.$YM("color","The color to show and insert",t=>t instanceof D.$aL,C.Color.from),new f.$YM("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:C.Range.from(t.range)}))],new f.$ZM("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(C.ColorPresentation.to):[])),new f.$1M("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[f.$YM.Uri,f.$YM.Range],new f.$ZM("A promise that resolves to an array of Inlay objects",(t,i,r)=>t.map(C.InlayHint.to.bind(void 0,r)))),new f.$1M("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[f.$YM.Uri],new f.$ZM("A promise that resolves to an array of FoldingRange objects",(t,i)=>{if(t)return t.map(C.FoldingRange.to)})),new f.$1M("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new f.$ZM("A promise that resolves to an array of NotebookContentProvider static info objects.",v(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(i=>C.NotebookExclusiveDocumentPattern.to(i))})))),new f.$1M("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[f.$YM.Uri,f.$YM.Range,new f.$YM("context","An InlineValueContext",t=>t&&typeof t.frameId=="number"&&t.stoppedLocation instanceof D.$CK,t=>C.InlineValueContext.from(t))],new f.$ZM("A promise that resolves to an array of InlineValue objects",t=>t.map(C.InlineValue.to))),new f.$1M("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new f.$YM("uriOrString","Uri-instance or string (only http/https)",t=>P.URI.isUri(t)||typeof t=="string"&&(0,E.$SU)(t,T.Schemas.http,T.Schemas.https),t=>t),new f.$YM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[C.ViewColumn.from(t),void 0]:[C.ViewColumn.from(t.viewColumn),C.TextEditorOpenOptions.from(t)])).optional(),f.$YM.String.with("label","").optional()],f.$ZM.Void),new f.$1M("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[f.$YM.Uri.with("resource","Resource to open"),f.$YM.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new f.$YM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[C.ViewColumn.from(t),void 0]:[C.ViewColumn.from(t.viewColumn),C.TextEditorOpenOptions.from(t)])).optional()],f.$ZM.Void),new f.$1M("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[f.$YM.Uri.with("left","Left-hand side resource of the diff editor"),f.$YM.Uri.with("right","Right-hand side resource of the diff editor"),f.$YM.String.with("title","Human readable title for the diff editor").optional(),new f.$YM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[C.ViewColumn.from(t.viewColumn),C.TextEditorOpenOptions.from(t)]).optional()],f.$ZM.Void),new f.$1M("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[f.$YM.String.with("title","Human readable title for the changes editor"),new f.$YM("resourceList","List of resources to compare",t=>{for(const i of t){if(i.length!==3)return!1;const[r,c,o]=i;if(!P.URI.isUri(r)||!P.URI.isUri(c)&&c!==void 0&&c!==null||!P.URI.isUri(o)&&o!==void 0&&o!==null)return!1}return!0},t=>t)],f.$ZM.Void),new f.$1M("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[f.$YM.Uri,f.$YM.Position],new f.$ZM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(C.TypeHierarchyItem.to))),new f.$1M("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[f.$YM.TypeHierarchyItem],new f.$ZM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(C.TypeHierarchyItem.to))),new f.$1M("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[f.$YM.TypeHierarchyItem],new f.$ZM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(C.TypeHierarchyItem.to))),new f.$1M("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[f.$YM.TestItem],f.$ZM.Void),new f.$1M("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[f.$YM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],f.$ZM.Void),new f.$1M("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[f.$YM.String.with("name","The context key name"),new f.$YM("value","The context key value",()=>!0,t=>t)],f.$ZM.Void),new f.$1M("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[f.$YM.Uri,f.$YM.StringArray,new f.$YM("MappedEditsContext","Mapped Edits Context",t=>C.MappedEditsContext.is(t),t=>C.MappedEditsContext.from(t))],new f.$ZM("A promise that resolves to a workspace edit or null",t=>t?C.WorkspaceEdit.to(t):null))];class b{static register(i){u.forEach(i.registerApiCommand,i),this.a(i)}static a(i){i.registerCommand(!1,"_validateWhenClauses",$.$Ui)}}e.$3dc=b;function v(t){return i=>{if(Array.isArray(i))return i.map(t)}}function g(t){if(!Array.isArray(t))return;const i=[];for(const r of t)M.$kt(r)?i.push(C.DefinitionLink.to(r)):i.push(C.location.to(r));return i}}),define(Pe[240],Ae([1,0,14,66,5,6,2,80,22,8,7,3,23]),function(we,e,y,T,P,M,A,$,E,f,C,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aec=void 0;function b(v,g,t){const i=v.getProxy(D.$yK.MainThreadComments);class r{static{this.a=0}constructor(){this.b=new Map,this.c=new E.$bm,g.registerArgumentProcessor({processArgument:m=>{if(m&&m.$mid===6){const S=this.b.get(m.handle);return S?S.value:m}else if(m&&m.$mid===7){const S=this.b.get(m.commentControlHandle);if(!S)return m;const k=S.getCommentThread(m.commentThreadHandle);return k?k.value:m}else if(m&&(m.$mid===9||m.$mid===8)){const S=this.b.get(m.thread.commentControlHandle);if(!S)return m;const k=S.getCommentThread(m.thread.commentThreadHandle);return k?m.$mid===8?k.value:{thread:k.value,text:m.text}:m}else if(m&&m.$mid===10){const S=this.b.get(m.thread.commentControlHandle);if(!S)return m;const k=S.getCommentThread(m.thread.commentThreadHandle);if(!k)return m;const h=m.commentUniqueId,w=k.getCommentByUniqueId(h);return w||m}else if(m&&m.$mid===11){const S=this.b.get(m.thread.commentControlHandle);if(!S)return m;const k=S.getCommentThread(m.thread.commentThreadHandle);if(!k)return m;const h=m.text,w=m.commentUniqueId,I=k.getCommentByUniqueId(w);return I?(typeof I.body=="string"?I.body=h:I.body=new C.$1K(h),I):m}return m}})}createCommentController(m,S,k){const h=r.a++,w=new o(m,h,S,k);this.b.set(w.handle,w);const I=this.c.get(m.identifier)||[];return I.push(w),this.c.set(m.identifier,I),w.value}async $createCommentThreadTemplate(m,S,k){const h=this.b.get(m);h&&h.$createCommentThreadTemplate(S,k)}async $updateCommentThreadTemplate(m,S,k){const h=this.b.get(m);h&&h.$updateCommentThreadTemplate(S,k)}$deleteCommentThread(m,S){this.b.get(m)?.$deleteCommentThread(S)}$provideCommentingRanges(m,S,k){const h=this.b.get(m);if(!h||!h.commentingRangeProvider)return Promise.resolve(void 0);const w=t.getDocument(A.URI.revive(S));return(0,y.$Qg)(async()=>{const I=await h.commentingRangeProvider.provideCommentingRanges(w,k);let F;return Array.isArray(I)?F={ranges:I,fileComments:!1}:I?F={ranges:I.ranges||[],fileComments:I.fileComments||!1}:F=I??void 0,F}).then(I=>{let F;return I&&(F={ranges:I.ranges.map(V=>f.Range.from(V)),fileComments:I.fileComments}),F})}$toggleReaction(m,S,k,h,w){const I=this.b.get(m);return!I||!I.reactionHandler?Promise.resolve(void 0):(0,y.$Qg)(()=>{const F=I.getCommentThread(S);if(F){const V=F.getCommentByUniqueId(h.uniqueIdInThread);if(I!==void 0&&V&&I.reactionHandler)return I.reactionHandler(V,s(w))}return Promise.resolve(void 0)})}}class c{static{this.a=0}set threadId(m){this.n=m}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(m){(m===void 0!=(this.p===void 0)||!m||!this.p||!m.isEqual(this.p))&&(this.p=m,this.b.range=m,this.c.fire())}get range(){return this.p}set canReply(m){this.d!==m&&(this.d=m,this.b.canReply=m,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(m){this.e=m,this.b.label=m,this.c.fire()}get contextValue(){return this.f}set contextValue(m){this.f=m,this.b.contextValue=m,this.c.fire()}get comments(){return this.q}set comments(m){this.q=m,this.b.comments=m,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(m){this.g=m,this.b.collapsibleState=m,this.c.fire()}get state(){return this.h}set state(m){this.h=m,this.b.state=m,this.c.fire()}get isDisposed(){return this.j}constructor(m,S,k,h,w,I,F,V){this.m=S,this.n=k,this.o=h,this.p=w,this.q=I,this.extensionDescription=F,this.r=V,this.handle=c.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new P.$Rd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new M.$Sc,this.l.value=new M.$Qc,this.n===void 0&&(this.n=`${m}.${this.handle}`),i.$createCommentThread(S,this.handle,this.n,this.o,f.Range.from(this.p),F.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=I,this.i.push({dispose:()=>{i.$deleteCommentThread(S,this.handle)}});const Z=this;this.value={get uri(){return Z.uri},get range(){return Z.range},set range(N){Z.range=N},get comments(){return Z.comments},set comments(N){Z.comments=N},get collapsibleState(){return Z.collapsibleState},set collapsibleState(N){Z.collapsibleState=N},get canReply(){return Z.canReply},set canReply(N){Z.canReply=N},get contextValue(){return Z.contextValue},set contextValue(N){Z.contextValue=N},get label(){return Z.label},set label(N){Z.label=N},get state(){return Z.state},set state(N){Z.state=N},dispose:()=>{Z.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new M.$Qc);const m=k=>Object.prototype.hasOwnProperty.call(this.b,k),S={};m("range")&&(S.range=f.Range.from(this.p)),m("label")&&(S.label=this.label),m("contextValue")&&(S.contextValue=this.contextValue??null),m("comments")&&(S.comments=this.q.map(k=>l(this,k,this.k,this.extensionDescription))),m("collapsibleState")&&(S.collapseState=a(this.g)),m("canReply")&&(S.canReply=this.canReply),m("state")&&(S.state=d(this.h)),m("isTemplate")&&(S.isTemplate=this.r),this.b={},i.$updateCommentThread(this.m,this.handle,this.n,this.o,S)}getCommentByUniqueId(m){for(const S of this.k){const k=S[0],h=S[1];if(m===h)return k}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(m=>m.dispose())}}Ke([(0,T.$oh)(100)],c.prototype,"eventuallyUpdateCommentThread",null);class o{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(m){this.b=m,i.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(m){this.c=m,i.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!m})}get options(){return this.d}set options(m){this.d=m,i.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(m,S,k,h){this.f=m,this.g=S,this.h=k,this.i=h,this.a=new Map,i.$registerCommentController(this.handle,k,h,this.f.identifier.value);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(I){w.options=I},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(I){w.commentingRangeProvider=I},get reactionHandler(){return w.reactionHandler},set reactionHandler(I){w.reactionHandler=I},createCommentThread(I,F,V){return w.createCommentThread(I,F,V).value},dispose:()=>{w.dispose()}}),this.e=[],this.e.push({dispose:()=>{i.$unregisterCommentController(this.handle)}})}createCommentThread(m,S,k){S===void 0&&(0,u.$MF)(this.f,"fileComments");const h=new c(this.id,this.handle,void 0,m,S,k,this.f,!1);return this.a.set(h.handle,h),h}$createCommentThreadTemplate(m,S){const k=new c(this.id,this.handle,void 0,A.URI.revive(m),f.Range.to(S),[],this.f,!0);return k.collapsibleState=$.CommentThreadCollapsibleState.Expanded,this.a.set(k.handle,k),k}$updateCommentThreadTemplate(m,S){const k=this.a.get(m);k&&(k.range=f.Range.to(S))}$deleteCommentThread(m){this.a.get(m)?.dispose(),this.a.delete(m)}getCommentThread(m){return this.a.get(m)}dispose(){this.a.forEach(m=>{m.dispose()}),this.e.forEach(m=>m.dispose())}}function l(p,m,S,k){let h=S.get(m);return h||(h=++p.commentHandle,S.set(m,h)),m.state!==void 0&&(0,u.$MF)(k,"commentsDraftState"),{mode:m.mode,contextValue:m.contextValue,uniqueIdInThread:h,body:typeof m.body=="string"?m.body:f.MarkdownString.from(m.body),userName:m.author.name,userIconPath:m.author.iconPath,label:m.label,commentReactions:m.reactions?m.reactions.map(w=>n(w)):void 0,state:m.state,timestamp:m.timestamp?.toJSON()}}function n(p){return{label:p.label,iconPath:p.iconPath?f.$zM(p.iconPath):void 0,count:p.count,hasReacted:p.authorHasReacted}}function s(p){return{label:p.label||"",count:p.count||0,iconPath:p.iconPath?A.URI.revive(p.iconPath):"",authorHasReacted:p.hasReacted||!1}}function a(p){if(p!==void 0)switch(p){case C.CommentThreadCollapsibleState.Expanded:return $.CommentThreadCollapsibleState.Expanded;case C.CommentThreadCollapsibleState.Collapsed:return $.CommentThreadCollapsibleState.Collapsed}return $.CommentThreadCollapsibleState.Collapsed}function d(p){if(p!==void 0)switch(p){case C.CommentThreadState.Unresolved:return $.CommentThreadState.Unresolved;case C.CommentThreadState.Resolved:return $.CommentThreadState.Resolved}return $.CommentThreadState.Unresolved}return new r}e.$aec=b}),define(Pe[241],Ae([1,0,26,3,27,17]),function(we,e,y,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1fc=void 0;let A=class{constructor(C,D){this.a=C.getProxy(T.$yK.MainThreadConsole),this.b=D.consoleForward.includeStack,this.c=D.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(C,D){const u=this,b=console[C];Object.defineProperty(console,C,{set:()=>{},get:()=>function(){u.e(C,D,b,arguments)}})}e(C,D,u,b){this.a.$logExtensionHostMessage({type:"__$console",severity:D,arguments:E(b,this.b)}),this.c&&this.f(C,u,b)}};e.$1fc=A,e.$1fc=A=Ke([Ve(0,M.$AM),Ve(1,P.$QM)],A);const $=1e5;function E(f,C){const D=[];if(f.length)for(let u=0;u<f.length;u++){let b=f[u];if(typeof b>"u")b="undefined";else if(b instanceof Error){const v=b;v.stack?b=v.stack:b=v.toString()}D.push(b)}if(C){const u=new Error().stack;u&&D.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,y.$fn)(D);return u.length>$?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(Pe[110],Ae([1,0,2,3,7,4,17,15,18,12,20,23]),function(we,e,y,T,P,M,A,$,E,f,C,D){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$4ec=e.$3ec=void 0;let b=class{static{u=this}static{this.c=0}static{this.d=250}constructor(g,t){this.h=t,this.f=new Map,this.g=g.getProxy(T.$yK.MainThreadDecorations)}registerFileDecorationProvider(g,t){const i=u.c++;this.f.set(i,{provider:g,extensionDescription:t}),this.g.$registerDecorationProvider(i,t.identifier.value);const r=g.onDidChangeFileDecorations&&g.onDidChangeFileDecorations(c=>{if(!c){this.g.$onDidChange(i,null);return}const o=(0,E.$2b)(c);if(o.length<=u.d){this.g.$onDidChange(i,o);return}this.h.warn("[Decorations] CAPPING events from decorations provider",t.identifier.value,o.length);const l=o.map(a=>({uri:a,rank:(0,f.$Ke)(a.path,"/")})),n=(0,E.$yb)(l,(a,d)=>a.rank-d.rank||(0,f.$Ye)(a.uri.path,d.uri.path)),s=[];e:for(const a of n){let d;for(const p of a){const m=(0,C.$lc)(p.uri.path);if(d!==m&&(d=m,s.push(p.uri)>=u.d))break e}}this.g.$onDidChange(i,s)});return new P.$AK(()=>{r?.dispose(),this.g.$unregisterDecorationProvider(i),this.f.delete(i)})}async $provideDecorations(g,t,i){if(!this.f.has(g))return Object.create(null);const r=Object.create(null),{provider:c,extensionDescription:o}=this.f.get(g);return await Promise.all(t.map(async l=>{try{const{uri:n,id:s}=l,a=await Promise.resolve(c.provideFileDecoration(y.URI.revive(n),i));if(!a)return;try{P.$VL.validate(a),a.badge&&typeof a.badge!="string"&&(0,D.$MF)(o,"codiconDecoration"),r[s]=[a.propagate,a.tooltip,a.badge,a.color]}catch(d){this.h.warn(`INVALID decoration from extension '${o.identifier.value}': ${d}`)}}catch(n){this.h.error(n)}})),r}};e.$3ec=b,e.$3ec=b=u=Ke([Ve(0,A.$AM),Ve(1,$.$dj)],b),e.$4ec=(0,M.$Vh)("IExtHostDecorations")}),define(Pe[242],Ae([1,0,158,98,2,3,7,8,5,15,28,42]),function(we,e,y,T,P,M,A,$,E,f,C,D){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Xdc=e.$Wdc=void 0;class b{#e;#t;#i;constructor(t,i,r,c,o,l,n,s){this.d=t,this.e=i,this.f=r,this.g=c,this.h=o,this.c=!1,this.f=Math.max(c,r),this.#i=new C.$zc(a=>l.getComparisonKey(a)),this.#e=n,this.#t=s}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(t,i){if(!t){this.clear();return}this.j();let r=[];if(P.URI.isUri(t)){if(!i){this.delete(t);return}this.#i.set(t,i.slice()),r=[t]}else if(Array.isArray(t)){r=[];let l;t=[...t].sort(b.k);for(const n of t){const[s,a]=n;if((!l||s.toString()!==l.toString())&&(l&&this.#i.get(l).length===0&&this.#i.delete(l),l=s,r.push(s),this.#i.set(s,[])),a)this.#i.get(s)?.push(...a);else{const d=this.#i.get(s);d&&(d.length=0)}}}if(this.#t.fire(r),!this.#e)return;const c=[];let o=0;for(const l of r){let n=[];const s=this.#i.get(l);if(s)if(s.length>this.g){n=[];const a=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let d=0;d<4;d++)for(const p of s)if(p.severity===a[d]&&n.push({...$.Diagnostic.from(p),modelVersionId:this.h(l)})===this.g)break e;n.push({severity:T.MarkerSeverity.Info,message:(0,y.localize)(0,null,s.length-this.g),startLineNumber:n[n.length-1].startLineNumber,startColumn:n[n.length-1].startColumn,endLineNumber:n[n.length-1].endLineNumber,endColumn:n[n.length-1].endColumn})}else n=s.map(a=>({...$.Diagnostic.from(a),modelVersionId:this.h(l)}));if(c.push([l,n]),o+=n.length,o>this.f)break}this.#e.$changeMany(this.e,c)}delete(t){this.j(),this.#t.fire([t]),this.#i.delete(t),this.#e?.$changeMany(this.e,[[t,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(t,i){this.j();for(const[r,c]of this)t.call(i,r,c,this)}*[Symbol.iterator](){this.j();for(const t of this.#i.keys())yield[t,this.get(t)]}get(t){this.j();const i=this.#i.get(t);return Array.isArray(i)?Object.freeze(i.slice(0)):[]}has(t){return this.j(),Array.isArray(this.#i.get(t))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(t,i){return t[0].toString()<i[0].toString()?-1:t[0].toString()>i[0].toString()?1:0}}e.$Wdc=b;let v=class{static{u=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*u.d}static _mapper(t){const i=new C.$zc;for(const r of t)i.set(r,r);return{uris:Object.freeze(Array.from(i.values()))}}constructor(t,i,r,c){this.j=i,this.k=r,this.l=c,this.g=new Map,this.h=new E.$Vd({merge:o=>o.flat(),delay:50}),this.onDidChangeDiagnostics=E.Event.map(this.h.event,u._mapper),this.f=t.getProxy(M.$yK.MainThreadDiagnostics)}createDiagnosticCollection(t,i){const{g:r,f:c,h:o,j:l,k:n,l:s}=this,a=new class{$changeMany(m,S){c.$changeMany(m,S),l.trace("[DiagnosticCollection] change many (extension, owner, uris)",t.value,m,S.length===0?"CLEARING":S)}$clear(m){c.$clear(m),l.trace("[DiagnosticCollection] remove all (extension, owner)",t.value,m)}dispose(){c.dispose()}};let d;if(!i)i="_generated_diagnostic_collection_name_#"+u.c++,d=i;else if(!r.has(i))d=i;else{this.j.warn(`DiagnosticCollection with name '${i}' does already exist.`);do d=i+u.c++;while(r.has(d))}return new class extends b{constructor(){super(i,d,u.e,u.d,m=>s.getDocument(m)?.version,n.extUri,a,o),r.set(d,this)}dispose(){super.dispose(),r.delete(d)}}}getDiagnostics(t){if(t)return this.m(t);{const i=new Map,r=[];for(const c of this.g.values())c.forEach((o,l)=>{let n=i.get(o.toString());typeof n>"u"&&(n=r.length,i.set(o.toString(),n),r.push([o,[]])),r[n][1]=r[n][1].concat(...l)});return r}}m(t){let i=[];for(const r of this.g.values())r.has(t)&&(i=i.concat(r.get(t)));return i}$acceptMarkersChange(t){if(!this.n){const i="_generated_mirror",r=new b(i,i,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,c=>{},this.k.extUri,void 0,this.h);this.g.set(i,r),this.n=r}for(const[i,r]of t)this.n.set(P.URI.revive(i),r.map($.Diagnostic.to))}};e.$Xdc=v,e.$Xdc=v=u=Ke([Ve(1,f.$dj),Ve(2,D.$Vdc)],v)}),define(Pe[243],Ae([1,0,2,3,23]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ec=void 0;class M{constructor($){this.a=$.getProxy(T.$yK.MainThreadDialogs)}showOpenDialog($,E){return E?.allowUIResources&&(0,P.$MF)($,"showLocal"),this.a.$showOpenDialog(E).then(f=>f?f.map(C=>y.URI.revive(C)):void 0)}showSaveDialog($){return this.a.$showSaveDialog($).then(E=>E?y.URI.revive(E):void 0)}}e.$5ec=M}),define(Pe[244],Ae([1,0,11,2,7,3,13,19,12]),function(we,e,y,T,P,M,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ec=void 0;class f{static{this.a=0}constructor(D,u,b){this.d=u,this.e=b,this.b=new Map,this.c=D.getProxy(M.$yK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,u){if(Object.keys(A.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const b=f.a++;this.b.set(b,u),this.c.$registerTextContentProvider(b,D);let v;return typeof u.onDidChange=="function"&&(v=u.onDidChange(g=>{if(g.scheme!==D){this.e.warn(`Provider for scheme '${D}' is firing event for schema '${g.scheme}' which will be IGNORED`);return}this.d.getDocument(g)&&this.$provideTextDocumentContent(b,g).then(t=>{if(!t&&typeof t!="string")return;const i=this.d.getDocument(g);if(!i)return;const r=(0,E.$Te)(t);if(!i.equalLines(r))return this.c.$onVirtualDocumentChange(g,t)},y.$Z)})),new P.$AK(()=>{this.b.delete(b)&&this.c.$unregisterTextContentProvider(b),v&&(v.dispose(),v=void 0)})}$provideTextDocumentContent(D,u){const b=this.b.get(D);return b?Promise.resolve(b.provideTextDocumentContent(T.URI.revive(u),$.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$6ec=f}),define(Pe[245],Ae([1,0,5,6,2,3,103,8,16,26,7,11]),function(we,e,y,T,P,M,A,$,E,f,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tdc=void 0;class u{constructor(v,g){this.a=new y.$Rd({onListenerError:D.$1}),this.b=new y.$Rd({onListenerError:D.$1}),this.c=new y.$Rd({onListenerError:D.$1}),this.d=new y.$Rd({onListenerError:D.$1}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new T.$Qc,this.h=new Map,this.f=v.getProxy(M.$yK.MainThreadDocuments),this.g=g,this.g.onDidRemoveDocuments(t=>{for(const i of t)this.b.fire(i.document)},void 0,this.e),this.g.onDidAddDocuments(t=>{for(const i of t)this.a.fire(i.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(v){if(!v)return;const g=this.g.getDocument(v);if(g)return g}getDocument(v){const g=this.getDocumentData(v);if(!g?.document)throw new Error(`Unable to retrieve document from URI '${v}'`);return g.document}ensureDocumentData(v){const g=this.g.getDocument(v);if(g)return Promise.resolve(g);let t=this.h.get(v.toString());return t||(t=this.f.$tryOpenDocument(v).then(i=>{this.h.delete(v.toString());const r=P.URI.revive(i);return(0,E.$Nf)(this.g.getDocument(r))},i=>(this.h.delete(v.toString()),Promise.reject(i))),this.h.set(v.toString(),t)),t}createDocumentData(v){return this.f.$tryCreateDocument(v).then(g=>P.URI.revive(g))}$acceptModelLanguageChanged(v,g){const t=P.URI.revive(v),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");this.b.fire(i.document),i._acceptLanguageId(g),this.a.fire(i.document)}$acceptModelSaved(v){const g=P.URI.revive(v),t=this.g.getDocument(g);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged(v,!1),this.d.fire(t.document)}$acceptDirtyStateChanged(v,g){const t=P.URI.revive(v),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");i._acceptIsDirty(g),this.c.fire({document:i.document,contentChanges:[],reason:void 0})}$acceptModelChanged(v,g,t){const i=P.URI.revive(v),r=this.g.getDocument(i);if(!r)throw new Error("unknown document");r._acceptIsDirty(t),r.onEvents(g);let c;g.isUndoing?c=C.TextDocumentChangeReason.Undo:g.isRedoing&&(c=C.TextDocumentChangeReason.Redo),this.c.fire((0,f.$bn)({document:r.document,contentChanges:g.changes.map(o=>({range:$.Range.to(o.range),rangeOffset:o.rangeOffset,rangeLength:o.rangeLength,text:o.text})),reason:c}))}setWordDefinitionFor(v,g){(0,A.$CM)(v,g)}}e.$Tdc=u}),define(Pe[61],Ae([1,0,53,5,6,2,4,3,103,17,109,8,15,28,13,67,44]),function(we,e,y,T,P,M,A,$,E,f,C,D,u,b,v,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LM=e.$KM=void 0;class i{constructor(o){this.value=o,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let r=class{constructor(o,l){this.h=o,this.i=l,this.a=null,this.b=new Map,this.c=new b.$zc,this.d=new T.$Rd,this.e=new T.$Rd,this.f=new T.$Rd,this.g=new T.$Rd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(o){this.acceptDocumentsAndEditorsDelta(o)}acceptDocumentsAndEditorsDelta(o){const l=[],n=[],s=[];if(o.removedDocuments)for(const a of o.removedDocuments){const d=M.URI.revive(a),p=this.c.get(d);p?.unref()&&(this.c.delete(d),l.push(p.value))}if(o.addedDocuments)for(const a of o.addedDocuments){const d=M.URI.revive(a.uri);let p=this.c.get(d);if(p&&d.scheme!==v.Schemas.vscodeNotebookCell&&d.scheme!==v.Schemas.vscodeInteractiveInput)throw new Error(`document '${d} already exists!'`);p||(p=new i(new E.$DM(this.h.getProxy($.$yK.MainThreadDocuments),d,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty,a.notebook)),this.c.set(d,p),n.push(p.value)),p.ref()}if(o.removedEditors)for(const a of o.removedEditors){const d=this.b.get(a);this.b.delete(a),d&&s.push(d)}if(o.addedEditors)for(const a of o.addedEditors){const d=M.URI.revive(a.documentUri);y.ok(this.c.has(d),`document '${d}' does not exist`),y.ok(!this.b.has(a.id),`editor '${a.id}' already exists!`);const p=this.c.get(d).value,m=new C.$JM(a.id,this.h.getProxy($.$yK.MainThreadTextEditors),this.i,new t.$U(()=>p.document),a.selections.map(D.Selection.to),a.options,a.visibleRanges.map(S=>D.Range.to(S)),typeof a.editorPosition=="number"?D.ViewColumn.to(a.editorPosition):void 0);this.b.set(a.id,m)}o.newActiveEditor!==void 0&&(y.ok(o.newActiveEditor===null||this.b.has(o.newActiveEditor),`active editor '${o.newActiveEditor}' does not exist`),this.a=o.newActiveEditor),(0,P.$Mc)(l),(0,P.$Mc)(s),o.removedDocuments&&this.e.fire(l),o.addedDocuments&&this.d.fire(n),(o.removedEditors||o.addedEditors)&&this.f.fire(this.allEditors().map(a=>a.value)),o.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(o){return this.c.get(o)?.value}allDocuments(){return g.Iterable.map(this.c.values(),o=>o.value)}getEditor(o){return this.b.get(o)}activeEditor(o){if(!this.a)return;const l=this.b.get(this.a);return o?l:l?.value}allEditors(){return[...this.b.values()]}};e.$KM=r,e.$KM=r=Ke([Ve(0,f.$AM),Ve(1,u.$dj)],r),e.$LM=(0,A.$Vh)("IExtHostDocumentsAndEditors")}),define(Pe[62],Ae([1,0,246,5,16,2,4,3,17,8,7]),function(we,e,y,T,P,M,A,$,E,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uec=e.$tec=void 0,e.$tec=(0,A.$Vh)("IExtHostEditorTabs");class D{constructor(t,i,r){this.e=r,this.d=i,this.acceptDtoUpdate(t)}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.id===t.e()},get label(){return t.b.label},get input(){return t.c},get isDirty(){return t.b.isDirty},get isPinned(){return t.b.isPinned},get isPreview(){return t.b.isPreview},get group(){return t.d.apiObject}};this.a=Object.freeze(i)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(t){this.b=t,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new C.$fM(M.URI.revive(this.b.input.uri));case 2:return new C.$gM(M.URI.revive(this.b.input.original),M.URI.revive(this.b.input.modified));case 3:return new C.$hM(M.URI.revive(this.b.input.base),M.URI.revive(this.b.input.input1),M.URI.revive(this.b.input.input2),M.URI.revive(this.b.input.result));case 6:return new C.$iM(M.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new C.$jM(this.b.input.viewType);case 4:return new C.$kM(M.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new C.$lM(M.URI.revive(this.b.input.original),M.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new C.$mM;case 9:return new C.$nM(M.URI.revive(this.b.input.uri),M.URI.revive(this.b.input.inputBoxUri));case 10:return new C.$oM(this.b.input.providerId);default:return}}}class u{constructor(t,i){this.c=[],this.d="",this.b=t,this.e=i;for(const r of t.tabs)r.isActive&&(this.d=r.id),this.c.push(new D(r,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.groupId===t.e()},get viewColumn(){return f.ViewColumn.to(t.b.viewColumn)},get activeTab(){return t.c.find(r=>r.tabId===t.d)?.apiObject},get tabs(){return Object.freeze(t.c.map(r=>r.apiObject))}};this.a=Object.freeze(i)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(t){this.b=t}acceptTabOperation(t){if(t.kind===0){const r=new D(t.tabDto,this,()=>this.activeTabId());return this.c.splice(t.index,0,r),t.tabDto.isActive&&(this.d=r.tabId),r}else if(t.kind===1){const r=this.c.splice(t.index,1)[0];if(!r)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return r.tabId===this.d&&(this.d=""),r}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const r=this.c.splice(t.oldIndex,1)[0];if(!r)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this.c.splice(t.index,0,r),r}const i=this.c.find(r=>r.tabId===t.tabDto.id);if(!i)throw new Error("INVALID tab");return t.tabDto.isActive?this.d=t.tabDto.id:this.d===t.tabDto.id&&!t.tabDto.isActive&&(this.d=""),i.acceptDtoUpdate(t.tabDto),i}activeTabId(){return this.d}}let b=class{constructor(t){this.b=new T.$Rd,this.c=new T.$Rd,this.e=[],this.a=t.getProxy($.$yK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const t=this,i={onDidChangeTabGroups:t.c.event,onDidChangeTabs:t.b.event,get all(){return Object.freeze(t.e.map(r=>r.apiObject))},get activeTabGroup(){const r=t.d;return(0,P.$Nf)(t.e.find(o=>o.groupId===r)?.apiObject)},close:async(r,c)=>{const o=Array.isArray(r)?r:[r];return o.length?v(o[0])?this.j(o,c):this.i(o,c):!0}};this.f=Object.freeze(i)}return this.f}$acceptEditorTabModel(t){const i=new Set(this.e.map(a=>a.groupId)),r=new Set(t.map(a=>a.groupId)),c=(0,y.$K)(i,r),o=this.e.filter(a=>c.removed.includes(a.groupId)).map(a=>a.apiObject),l=[],n=[];this.e=t.map(a=>{const d=new u(a,()=>this.d);return c.added.includes(d.groupId)?l.push(d.apiObject):n.push(d.apiObject),d});const s=(0,P.$Nf)(t.find(a=>a.isActive===!0)?.groupId);s!==void 0&&this.d!==s&&(this.d=s),this.c.fire(Object.freeze({opened:l,closed:o,changed:n}))}$acceptTabGroupUpdate(t){const i=this.e.find(r=>r.groupId===t.groupId);if(!i)throw new Error("Update Group IPC call received before group creation.");i.acceptGroupDtoUpdate(t),t.isActive&&(this.d=t.groupId),this.c.fire(Object.freeze({changed:[i.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const i=this.e.find(c=>c.groupId===t.groupId);if(!i)throw new Error("Update Tabs IPC call received before group creation.");const r=i.acceptTabOperation(t);switch(t.kind){case 0:this.b.fire(Object.freeze({opened:[r.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[r.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[r.apiObject]}));return}}g(t){for(const i of this.e)for(const r of i.tabs)if(r.apiObject===t)return r}h(t){return this.e.find(i=>i.apiObject===t)}async i(t,i){const r=[];for(const c of t){const o=this.g(c);if(!o)throw new Error("Tab close: Invalid tab not found!");r.push(o.tabId)}return this.a.$closeTab(r,i)}async j(t,i){const r=[];for(const c of t){const o=this.h(c);if(!o)throw new Error("Group close: Invalid group not found!");r.push(o.groupId)}return this.a.$closeGroup(r,i)}};e.$uec=b,e.$uec=b=Ke([Ve(0,E.$AM)],b);function v(g){return g.tabs!==void 0}}),define(Pe[247],Ae([1,0,3,7]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ec=void 0;class P{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(y.$yK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,$,E){if(this.a.size===0)throw new Error("No embedding vector providers registered");const f=this.a.get(A);if(!f)throw new Error("Embedding vector provider not found");const C=await f.provideEmbeddingVector($,E);if(!C)throw new Error("Embedding vector provider returned undefined");return C}registerEmbeddingVectorProvider(A,$,E){const f=this.b;return this.b++,this.a.set(f,E),this.c.$registerAiEmbeddingVectorProvider($,f),new T.$AK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(f),this.a.delete(f)})}}e.$8ec=P}),define(Pe[248],Ae([1,0,2,3,6,7,8,296,12,24,23,52]),function(we,e,y,T,P,M,A,$,E,f,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ec=void 0;class u{constructor(){this.a=[]}add(g){this.b=void 0,this.a.push(g)}delete(g){const t=this.a.indexOf(g);t>=0&&(this.a.splice(t,1),this.b=void 0)}c(){if(!this.b){const g=this.a.sort(),t=[];let i,r,c=14,o=14;for(const l of g){let n=i?(0,E.$8e)(i,l):0;for(n===0?r=1:r=o;n<l.length;n++)n+1===l.length?(c=o,o=9):o+=1,t.push([r,l.toUpperCase().charCodeAt(n),o]),t.push([r,l.toLowerCase().charCodeAt(n),o]),r=o;i=l,o=c}t.push([9,58,10]),t.push([10,47,12]),this.b=new $.$4Y(t)}}provideDocumentLinks(g){this.c();const t=[],i=$.$5Y.computeLinks({getLineContent(r){return g.lineAt(r-1).text},getLineCount(){return g.lineCount}},this.b);for(const r of i){const c=A.DocumentLink.to(r);c.target&&t.push(c)}return t}}class b{constructor(g,t){this.i=t,this.b=new u,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=g.getProxy(T.$yK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(g,t,i,r={}){if(b.j(i),this.d.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(g,"*",this.b));const c=this.h++;this.b.add(t),this.d.add(t),this.c.set(c,i);let o=2;r.isCaseSensitive&&(o+=1024),r.isReadonly&&(o+=2048),typeof i.copy=="function"&&(o+=8),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,C.$MF)(g,"fsChunks"),o+=4);let l;r.isReadonly&&(0,D.$$j)(r.isReadonly)&&((0,C.$MF)(g,"readonlyMessage"),l={value:r.isReadonly.value,isTrusted:r.isReadonly.isTrusted,supportThemeIcons:r.isReadonly.supportThemeIcons,supportHtml:r.isReadonly.supportHtml,baseUri:r.isReadonly.baseUri,uris:r.isReadonly.uris}),this.a.$registerFileSystemProvider(c,t,o,l).catch(s=>{console.error(`FAILED to register filesystem provider of ${g.identifier.value}-extension for the scheme ${t}`),console.error(s)});const n=i.onDidChangeFile(s=>{const a=[];for(const d of s){const{uri:p,type:m}=d;if(p.scheme!==t)continue;let S;switch(m){case M.FileChangeType.Changed:S=0;break;case M.FileChangeType.Created:S=1;break;case M.FileChangeType.Deleted:S=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:p,type:S})}this.a.$onFileSystemChange(c,a)});return(0,P.$Pc)(()=>{n.dispose(),this.b.delete(t),this.d.delete(t),this.c.delete(c),this.a.$unregisterProvider(c)})}static j(g){if(!g)throw new Error("MISSING provider");if(typeof g.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof g.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof g.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof g.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof g.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof g.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof g.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof g.rename!="function")throw new Error("Provider does NOT implement rename")}static k(g){const{type:t,ctime:i,mtime:r,size:c,permissions:o}=g;return{type:t,ctime:i,mtime:r,size:c,permissions:o}}$stat(g,t){return Promise.resolve(this.l(g).stat(y.URI.revive(t))).then(i=>b.k(i))}$readdir(g,t){return Promise.resolve(this.l(g).readDirectory(y.URI.revive(t)))}$readFile(g,t){return Promise.resolve(this.l(g).readFile(y.URI.revive(t))).then(i=>f.$fe.wrap(i))}$writeFile(g,t,i,r){return Promise.resolve(this.l(g).writeFile(y.URI.revive(t),i.buffer,r))}$delete(g,t,i){return Promise.resolve(this.l(g).delete(y.URI.revive(t),i))}$rename(g,t,i,r){return Promise.resolve(this.l(g).rename(y.URI.revive(t),y.URI.revive(i),r))}$copy(g,t,i,r){const c=this.l(g);if(!c.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(c.copy(y.URI.revive(t),y.URI.revive(i),r))}$mkdir(g,t){return Promise.resolve(this.l(g).createDirectory(y.URI.revive(t)))}$watch(g,t,i,r){const c=this.l(g).watch(y.URI.revive(i),r);this.f.set(t,c)}$unwatch(g,t){const i=this.f.get(t);i&&(i.dispose(),this.f.delete(t))}$open(g,t,i){const r=this.l(g);if(!r.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(r.open(y.URI.revive(t),i))}$close(g,t){const i=this.l(g);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(t))}$read(g,t,i,r){const c=this.l(g);if(!c.read)throw new Error('FileSystemProvider does not implement "read"');const o=f.$fe.alloc(r);return Promise.resolve(c.read(t,i,o.buffer,0,r)).then(l=>o.slice(0,l))}$write(g,t,i,r){const c=this.l(g);if(!c.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(c.write(t,i,r.buffer,0,r.byteLength))}l(g){const t=this.c.get(g);if(!t){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return t}}e.$9ec=b}),define(Pe[63],Ae([1,0,3,41,7,24,4,17,42,6,14,25,13]),function(we,e,y,T,P,M,A,$,E,f,C,D,u){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$jec=e.$iec=void 0;let v=b=class{constructor(t,i){this.b=new Map,this.c=new C.$7g,this.a=t.getProxy(y.$yK.MainThreadFileSystem);const r=this;this.value=Object.freeze({async stat(c){try{let o;const l=r.b.get(c.scheme);return l?(await r.a.$ensureActivation(c.scheme),o=await l.impl.stat(c)):o=await r.a.$stat(c),{type:o.type,ctime:o.ctime,mtime:o.mtime,size:o.size,permissions:o.permissions===T.FilePermission.Readonly?1:void 0}}catch(o){b.e(o)}},async readDirectory(c){try{const o=r.b.get(c.scheme);return o?(await r.a.$ensureActivation(c.scheme),(await o.impl.readDirectory(c)).slice()):await r.a.$readdir(c)}catch(o){return b.e(o)}},async createDirectory(c){try{const o=r.b.get(c.scheme);return o&&!o.isReadonly?(await r.a.$ensureActivation(c.scheme),await r.d(o.impl,o.extUri,c)):await r.a.$mkdir(c)}catch(o){return b.e(o)}},async readFile(c){try{const o=r.b.get(c.scheme);return o?(await r.a.$ensureActivation(c.scheme),(await o.impl.readFile(c)).slice()):(await r.a.$readFile(c)).buffer}catch(o){return b.e(o)}},async writeFile(c,o){try{const l=r.b.get(c.scheme);return l&&!l.isReadonly?(await r.a.$ensureActivation(c.scheme),await r.d(l.impl,l.extUri,l.extUri.dirname(c)),await r.c.queueFor(c).queue(()=>Promise.resolve(l.impl.writeFile(c,o,{create:!0,overwrite:!0})))):await r.a.$writeFile(c,M.$fe.wrap(o))}catch(l){return b.e(l)}},async delete(c,o){try{const l=r.b.get(c.scheme);return l&&!l.isReadonly?(await r.a.$ensureActivation(c.scheme),await l.impl.delete(c,{recursive:!1,...o})):await r.a.$delete(c,{recursive:!1,useTrash:!1,atomic:!1,...o})}catch(l){return b.e(l)}},async rename(c,o,l){try{return await r.a.$rename(c,o,{overwrite:!1,...l})}catch(n){return b.e(n)}},async copy(c,o,l){try{return await r.a.$copy(c,o,{overwrite:!1,...l})}catch(n){return b.e(n)}},isWritableFileSystem(c){const o=i.getCapabilities(c);if(typeof o=="number")return!(o&2048)}})}async d(t,i,r){const c=[];for(;!i.isEqual(r,i.dirname(r));)try{if(!((await t.stat(r)).type&T.FileType.Directory))throw P.$NL.FileExists(`Unable to create folder '${r.scheme===u.Schemas.file?r.fsPath:r.toString(!0)}' that already exists but is not a directory`);break}catch(o){if(T.$uk(o)!==T.FileSystemProviderErrorCode.FileNotFound)throw o;c.push(i.basename(r)),r=i.dirname(r)}for(let o=c.length-1;o>=0;o--){r=i.joinPath(r,c[o]);try{await t.createDirectory(r)}catch(l){if(T.$uk(l)!==T.FileSystemProviderErrorCode.FileExists)throw l}}}static e(t){if(t instanceof P.$NL)throw t;if(t instanceof T.$qk)switch(t.code){case T.FileSystemProviderErrorCode.FileExists:throw P.$NL.FileExists(t.message);case T.FileSystemProviderErrorCode.FileNotFound:throw P.$NL.FileNotFound(t.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw P.$NL.FileNotADirectory(t.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw P.$NL.FileIsADirectory(t.message);case T.FileSystemProviderErrorCode.NoPermissions:throw P.$NL.NoPermissions(t.message);case T.FileSystemProviderErrorCode.Unavailable:throw P.$NL.Unavailable(t.message);default:throw new P.$NL(t.message,t.name)}if(!(t instanceof Error))throw new P.$NL(String(t));if(t.name==="ENOPRO"||t.message.includes("ENOPRO"))throw P.$NL.Unavailable(t.message);switch(t.name){case T.FileSystemProviderErrorCode.FileExists:throw P.$NL.FileExists(t.message);case T.FileSystemProviderErrorCode.FileNotFound:throw P.$NL.FileNotFound(t.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw P.$NL.FileNotADirectory(t.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw P.$NL.FileIsADirectory(t.message);case T.FileSystemProviderErrorCode.NoPermissions:throw P.$NL.NoPermissions(t.message);case T.FileSystemProviderErrorCode.Unavailable:throw P.$NL.Unavailable(t.message);default:throw new P.$NL(t.message,t.name)}}addFileSystemProvider(t,i,r){return this.b.set(t,{impl:i,extUri:r?.isCaseSensitive?D.$pg:D.$rg,isReadonly:!!r?.isReadonly}),(0,f.$Pc)(()=>this.b.delete(t))}getFileSystemProviderExtUri(t){return this.b.get(t)?.extUri??D.$pg}};e.$iec=v,e.$iec=v=b=Ke([Ve(0,$.$AM),Ve(1,E.$Vdc)],v),e.$jec=(0,A.$Vh)("IExtHostConsumerFileSystem")}),define(Pe[249],Ae([1,0,5,33,2,3,8,7,44]),function(we,e,y,T,P,M,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0ec=void 0;class f{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(b,v,g,t,i,r){this.a=Math.random(),this.b=new y.$Rd,this.c=new y.$Rd,this.d=new y.$Rd,this.h=0,r?.ignoreCreateEvents&&(this.h+=1),r?.ignoreChangeEvents&&(this.h+=2),r?.ignoreDeleteEvents&&(this.h+=4);const c=(0,T.$Cj)(i),o=typeof i=="string",l=r?.correlate,n=t(s=>{if(!(typeof s.session=="number"&&s.session!==this.a)&&!(l&&typeof s.session>"u")){if(!r?.ignoreCreateEvents)for(const a of s.created){const d=P.URI.revive(a);c(d.fsPath)&&(!o||v.getWorkspaceFolder(d))&&this.b.fire(d)}if(!r?.ignoreChangeEvents)for(const a of s.changed){const d=P.URI.revive(a);c(d.fsPath)&&(!o||v.getWorkspaceFolder(d))&&this.c.fire(d)}if(!r?.ignoreDeleteEvents)for(const a of s.deleted){const d=P.URI.revive(a);c(d.fsPath)&&(!o||v.getWorkspaceFolder(d))&&this.d.fire(d)}}});this.g=$.$AK.from(this.i(b,g,i,r,r?.correlate),this.b,this.c,this.d,n)}i(b,v,g,t,i){const r=$.$AK.from();if(typeof g=="string")return r;const c=b.getProxy(M.$yK.MainThreadFileSystemEventService);let o=!1;return(g.pattern.includes(T.$yj)||g.pattern.includes(T.$zj))&&(o=!0),c.$watch(v.identifier.value,this.a,g.baseUri,{recursive:o,excludes:t?.excludes??[]},!!i),$.$AK.from({dispose:()=>c.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class C{constructor(b){this.a=b,this.session=this.a.session,this.b=new E.$U(()=>this.a.created.map(P.URI.revive)),this.c=new E.$U(()=>this.a.changed.map(P.URI.revive)),this.d=new E.$U(()=>this.a.deleted.map(P.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class D{constructor(b,v,g){this.j=b,this.k=v,this.l=g,this.a=new y.$Rd,this.b=new y.$Rd,this.c=new y.$Rd,this.d=new y.$Rd,this.g=new y.$Td,this.h=new y.$Td,this.i=new y.$Td,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(b,v,g,t){return new f(this.j,b,v,this.a.event,A.GlobPattern.from(g),t)}$onFileEvent(b){this.a.fire(new C(b))}$onDidRunFileOperation(b,v){switch(b){case 2:this.b.fire(Object.freeze({files:v.map(g=>({oldUri:P.URI.revive(g.source),newUri:P.URI.revive(g.target)}))}));break;case 1:this.d.fire(Object.freeze({files:v.map(g=>P.URI.revive(g.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:v.map(g=>P.URI.revive(g.target))}));break;default:}}getOnWillRenameFileEvent(b){return this.m(b,this.g)}getOnWillCreateFileEvent(b){return this.m(b,this.h)}getOnWillDeleteFileEvent(b){return this.m(b,this.i)}m(b,v){return(g,t,i)=>{const r=function(o){g.call(t,o)};return r.extension=b,v.event(r,void 0,i)}}async $onWillRunFileOperation(b,v,g,t){switch(b){case 2:return await this.n(this.g,{files:v.map(i=>({oldUri:P.URI.revive(i.source),newUri:P.URI.revive(i.target)}))},g,t);case 1:return await this.n(this.i,{files:v.map(i=>P.URI.revive(i.target))},g,t);case 0:case 3:return await this.n(this.h,{files:v.map(i=>P.URI.revive(i.target))},g,t)}}async n(b,v,g,t){const i=new Set,r=[];if(await b.fireAsync(v,t,async(o,l)=>{const n=Date.now(),s=await Promise.resolve(o);s instanceof $.$KK&&(r.push([l.extension,s]),i.add(l.extension.displayName??l.extension.identifier.value)),Date.now()-n>g&&this.k.warn("SLOW file-participant",l.extension.identifier)}),t.isCancellationRequested||r.length===0)return;const c={edits:[]};for(const[,o]of r){const{edits:l}=A.WorkspaceEdit.from(o,{getTextDocumentVersion:n=>this.l.getDocument(n)?.version,getNotebookDocumentVersion:()=>{}});c.edits=c.edits.concat(l)}return{edit:c,extensionNames:Array.from(i)}}}e.$0ec=D}),define(Pe[250],Ae([1,0,6,2,3,8,7,32,14]),function(we,e,y,T,P,M,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ec=void 0;class f{static{this.a=0}constructor(b,v){this.extension=b,this.provider=v,this.handle=f.a++}}class C{constructor(b){this.session=b,this.responses=[]}}class D{static{this.a=0}constructor(b,v,g,t){this.f=g,this.g=t,this.b=new Map,this.d=new Map,this.e=b.getProxy(P.$yK.MainThreadInlineChat),v.registerApiCommand(new $.$1M("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new $.$YM("Run arguments","",i=>!0,i=>{if(i)return{initialRange:i.initialRange?M.Range.from(i.initialRange):void 0,initialSelection:i.initialSelection?M.Selection.from(i.initialSelection):void 0,message:i.message,autoSend:i.autoSend,position:i.position?M.Position.from(i.position):void 0}})],$.$ZM.Void))}registerProvider(b,v,g){const t=new f(b,v);return this.b.set(t.handle,t),this.e.$registerInteractiveEditorProvider(t.handle,g?.label??b.displayName??b.name,b.identifier.value,typeof v.handleInteractiveEditorResponseFeedback=="function",g?.supportReportIssue??!1),(0,y.$Pc)(()=>{this.e.$unregisterInteractiveEditorProvider(t.handle),this.b.delete(t.handle)})}async $prepareSession(b,v,g,t){const i=this.b.get(b);if(!i){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const r=this.f.getDocument(T.URI.revive(v)),c=M.Selection.to(g),o=await i.provider.prepareInteractiveEditorSession({document:r,selection:c},t);if(!o)return;if(o.wholeRange&&!o.wholeRange.contains(c))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const l=D.a++;return this.d.set(l,new C(o)),{id:l,placeholder:o.placeholder,input:o.input,slashCommands:o.slashCommands?.map(n=>({command:n.command,detail:n.detail,refer:n.refer,executeImmediately:n.executeImmediately})),wholeRange:M.Range.from(o.wholeRange),message:o.message}}async $provideResponse(b,v,g,t){const i=this.b.get(b);if(!i)return;const r=this.d.get(v.id);if(!r)return;const c={prompt:g.prompt,selection:M.Selection.to(g.selection),wholeRange:M.Range.to(g.wholeRange),attempt:g.attempt,live:g.live};let o=!1;const l={report:async p=>{if(!g.live&&p.edits?.length)throw new Error("Progress reporting is only supported for live sessions");o||t.isCancellationRequested||await this.e.$handleProgressChunk(g.requestId,{message:p.message,edits:p.edits?.map(M.TextEdit.from),editsShouldBeInstant:p.editsShouldBeInstant,slashCommand:p.slashCommand?.command,markdownFragment:A.$1K.isMarkdownString(p.content)?p.content.value:p.content})}},n=Promise.resolve(i.provider.provideInteractiveEditorResponse(r.session,c,l,t));let s;try{s=await(0,E.$Mg)(n,t)}finally{o=!0}if(!s)return;const a=r.responses.push(s)-1,d={wholeRange:M.Range.from(s.wholeRange),placeholder:s.placeholder};if(D.h(s)){const{edits:p,contents:m}=s,S=m!==void 0?M.MarkdownString.from(m):void 0;return p instanceof A.$KK?{...d,id:a,type:"bulkEdit",edits:M.WorkspaceEdit.from(p),message:S}:{...d,id:a,type:"editorEdit",edits:p.map(M.TextEdit.from),message:S}}return{...d,id:a,type:"message",message:M.MarkdownString.from(s.contents)}}$handleFeedback(b,v,g,t){const i=this.b.get(b),r=this.d.get(v),c=r?.responses[g];if(i&&c){const o=M.InteractiveEditorResponseFeedbackKind.to(t);i.provider.handleInteractiveEditorResponseFeedback?.(r.session,c,o)}}$releaseSession(b,v){}static h(b){return typeof b=="object"&&typeof b.edits=="object"}}e.$$ec=D}),define(Pe[251],Ae([1,0,2,32]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lfc=void 0;class P{constructor(A,$,E,f,C){this.a=$,this.b=E,this.c=f;const D=new T.$1M("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new T.$YM("showOptions","Show Options",u=>!0,u=>u),new T.$YM("resource","Interactive resource Uri",u=>!0,u=>u),new T.$YM("controllerId","Notebook controller Id",u=>!0,u=>u),new T.$YM("title","Interactive editor title",u=>!0,u=>u)],new T.$ZM("Notebook and input URI",u=>{if(C.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const b=this.a.getEditorById(u.notebookEditorId);return C.debug("[ExtHostInteractive] notebook editor found",b.id),{notebookUri:y.URI.revive(u.notebookUri),inputUri:y.URI.revive(u.inputUri),notebookEditor:b.apiEditor}}return C.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:y.URI.revive(u.notebookUri),inputUri:y.URI.revive(u.inputUri)}}));this.c.registerApiCommand(D)}$willAddInteractiveDocument(A,$,E,f){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:$,lines:[""],languageId:E,uri:A,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(y.URI.revive(f))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,$){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$lfc=P}),define(Pe[252],Ae([1,0,3,7]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mfc=void 0;class P{constructor(A){this.a=new Map,this.b=new Map,this.c=A.getProxy(y.$yK.MainThreadIssueReporter)}async $getIssueReporterUri(A,$){if(this.a.size===0)throw new Error("No issue request handlers registered");const E=this.a.get(A);if(!E)throw new Error("Issue request handler not found");const f=await E.handleIssueUrlRequest();if(!f)throw new Error("Issue request handler returned no result");return f}async $getIssueReporterData(A,$){if(this.b.size===0)throw new Error("No issue request handlers registered");const E=this.b.get(A);if(!E)throw new Error("Issue data provider not found");const f=await E.provideIssueData($);if(!f)throw new Error("Issue data provider returned no result");return f}async $getIssueReporterTemplate(A,$){if(this.b.size===0)throw new Error("No issue request handlers registered");const E=this.b.get(A);if(!E)throw new Error("Issue data provider not found");const f=await E.provideIssueTemplate($);if(!f)throw new Error("Issue template provider returned no result");return f}registerIssueUriRequestHandler(A,$){const E=A.identifier.value;return this.a.set(E,$),this.c.$registerIssueUriRequestHandler(E),new T.$AK(()=>{this.c.$unregisterIssueUriRequestHandler(E),this.a.delete(E)})}registerIssueDataProvider(A,$){const E=A.identifier.value;return this.b.set(E,$),this.c.$registerIssueDataProvider(E),new T.$AK(()=>{this.c.$unregisterIssueDataProvider(E),this.b.delete(E)})}}e.$mfc=P}),define(Pe[253],Ae([1,0,6,3]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nfc=void 0;class P{constructor(A){this.b=0,this.a=A.getProxy(T.$yK.MainThreadLabelService)}$registerResourceLabelFormatter(A){const $=this.b++;return this.a.$registerResourceLabelFormatter($,A),(0,y.$Pc)(()=>{this.a.$unregisterResourceLabelFormatter($)})}}e.$nfc=P}),define(Pe[254],Ae([1,0,2,26,8,7,80,3,12,29,18,16,297,19,22,6,95,89,75,60,11,14,23,160]),function(we,e,y,T,P,M,A,$,E,f,C,D,u,b,v,g,t,i,r,c,o,l,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2dc=void 0;class a{constructor(z,W){this.d=z,this.e=W}async provideDocumentSymbols(z,W){const H=this.d.getDocument(z),G=await this.e.provideDocumentSymbols(H,W);if(!(0,C.$Jb)(G))return G[0]instanceof M.$SK?G.map(P.DocumentSymbol.from):a.f(G)}static f(z){z=z.slice(0).sort((G,q)=>{let x=G.location.range.start.compareTo(q.location.range.start);return x===0&&(x=q.location.range.end.compareTo(G.location.range.end)),x});const W=[],H=[];for(const G of z){const q={name:G.name||"!!MISSING: name!!",kind:P.SymbolKind.from(G.kind),tags:G.tags?.map(P.SymbolTag.from)||[],detail:"",containerName:G.containerName,range:P.Range.from(G.location.range),selectionRange:P.Range.from(G.location.range),children:[]};for(;;){if(H.length===0){H.push(q),W.push(q);break}const x=H[H.length-1];if(f.$zs.containsRange(x.range,q.range)&&!f.$zs.equalsRange(x.range,q.range)){x.children?.push(q),H.push(q);break}H.pop()}}return W}}class d{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(z,W,H){this.g=z,this.h=W,this.j=H,this.e=new r.$Rdc("CodeLens"),this.f=new Map}async provideCodeLenses(z,W){const H=this.g.getDocument(z),G=await this.j.provideCodeLenses(H,W);if(!G||W.isCancellationRequested)return;const q=this.e.add(G),x=new g.$Qc;this.f.set(q,x);const ue={cacheId:q,lenses:[]};for(let Oe=0;Oe<G.length;Oe++)ue.lenses.push({cacheId:[q,Oe],range:P.Range.from(G[Oe].range),command:this.h.toInternal(G[Oe].command,x)});return ue}async resolveCodeLens(z,W){const H=z.cacheId&&this.e.get(...z.cacheId);if(!H)return;let G;if(typeof this.j.resolveCodeLens!="function"||H.isResolved?G=H:G=await this.j.resolveCodeLens(H,W),G||(G=H),W.isCancellationRequested)return;const q=z.cacheId&&this.f.get(z.cacheId[0]);if(q)return z.command=this.h.toInternal(G.command??d.d,q),z}releaseCodeLenses(z){this.f.get(z)?.dispose(),this.f.delete(z),this.e.delete(z)}}function p(Ie){return Array.isArray(Ie)?Ie.map(P.DefinitionLink.from):Ie?[P.DefinitionLink.from(Ie)]:[]}class m{constructor(z,W){this.d=z,this.e=W}async provideDefinition(z,W,H){const G=this.d.getDocument(z),q=P.Position.to(W),x=await this.e.provideDefinition(G,q,H);return p(x)}}class S{constructor(z,W){this.d=z,this.e=W}async provideDeclaration(z,W,H){const G=this.d.getDocument(z),q=P.Position.to(W),x=await this.e.provideDeclaration(G,q,H);return p(x)}}class k{constructor(z,W){this.d=z,this.e=W}async provideImplementation(z,W,H){const G=this.d.getDocument(z),q=P.Position.to(W),x=await this.e.provideImplementation(G,q,H);return p(x)}}class h{constructor(z,W){this.d=z,this.e=W}async provideTypeDefinition(z,W,H){const G=this.d.getDocument(z),q=P.Position.to(W),x=await this.e.provideTypeDefinition(G,q,H);return p(x)}}class w{constructor(z,W){this.d=z,this.e=W}async provideHover(z,W,H){const G=this.d.getDocument(z),q=P.Position.to(W),x=await this.e.provideHover(G,q,H);if(!(!x||(0,C.$Jb)(x.contents)))return x.range||(x.range=G.getWordRangeAtPosition(q)),x.range||(x.range=new M.$CK(q,q)),P.Hover.from(x)}}class I{constructor(z,W){this.d=z,this.e=W}async provideEvaluatableExpression(z,W,H){const G=this.d.getDocument(z),q=P.Position.to(W),x=await this.e.provideEvaluatableExpression(G,q,H);if(x)return P.EvaluatableExpression.from(x)}}class F{constructor(z,W){this.d=z,this.e=W}async provideInlineValues(z,W,H,G){const q=this.d.getDocument(z),x=await this.e.provideInlineValues(q,P.Range.to(W),P.InlineValueContext.to(H),G);if(Array.isArray(x))return x.map(ue=>P.InlineValue.from(ue))}}class V{constructor(z,W){this.d=z,this.e=W}async provideDocumentHighlights(z,W,H){const G=this.d.getDocument(z),q=P.Position.to(W),x=await this.e.provideDocumentHighlights(G,q,H);if(Array.isArray(x))return x.map(P.DocumentHighlight.from)}}class Z{constructor(z,W){this.d=z,this.e=W}async provideLinkedEditingRanges(z,W,H){const G=this.d.getDocument(z),q=P.Position.to(W),x=await this.e.provideLinkedEditingRanges(G,q,H);if(x&&Array.isArray(x.ranges))return{ranges:(0,C.$Gb)(x.ranges.map(P.Range.from)),wordPattern:x.wordPattern}}}class N{constructor(z,W){this.d=z,this.e=W}async provideReferences(z,W,H,G){const q=this.d.getDocument(z),x=P.Position.to(W),ue=await this.e.provideReferences(q,x,H,G);if(Array.isArray(ue))return ue.map(P.location.from)}}class R{static{this.d=1e3}constructor(z,W,H,G,q,x,ue){this.g=z,this.h=W,this.j=H,this.k=G,this.l=q,this.m=x,this.n=ue,this.e=new r.$Rdc("CodeAction"),this.f=new Map}async provideCodeActions(z,W,H,G){const q=this.g.getDocument(z),x=u.$Bs.isISelection(W)?P.Selection.to(W):P.Range.to(W),ue=[];for(const _e of this.j.getDiagnostics(z))if(x.intersection(_e.range)&&ue.push(_e)>R.d)break;const Oe={diagnostics:ue,only:H.only?new M.$UK(H.only):void 0,triggerKind:P.CodeActionTriggerKind.to(H.trigger)},Ue=await this.k.provideCodeActions(q,x,Oe,G);if(!(0,C.$Kb)(Ue)||G.isCancellationRequested)return;const Ze=this.e.add(Ue),Je=new g.$Qc;this.f.set(Ze,Je);const tt=[];for(let _e=0;_e<Ue.length;_e++){const et=Ue[_e];et&&(R.o(et)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),tt.push({_isSynthetic:!0,title:et.title,command:this.h.toInternal(et,Je)})):(Oe.only&&(et.kind?Oe.only.contains(et.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Oe.only.value} 'requested but returned code action is of kind '${et.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Oe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),tt.push({cacheId:[Ze,_e],title:et.title,command:et.command&&this.h.toInternal(et.command,Je),diagnostics:et.diagnostics&&et.diagnostics.map(P.Diagnostic.from),edit:et.edit&&P.WorkspaceEdit.from(et.edit,void 0),kind:et.kind&&et.kind.value,isPreferred:et.isPreferred,isAI:(0,n.$LF)(this.m,"codeActionAI")?et.isAI:!1,disabled:et.disabled?.reason})))}return{cacheId:Ze,actions:tt}}async resolveCodeAction(z,W){const[H,G]=z,q=this.e.get(H,G);if(!q||R.o(q))return{};if(!this.k.resolveCodeAction)return{};const x=await this.k.resolveCodeAction(q,W)??q;let ue;x.edit&&(ue=P.WorkspaceEdit.from(x.edit,void 0));let Oe;if(x.command){const Ue=this.f.get(H);Ue&&(Oe=this.h.toInternal(x.command,Ue))}return{edit:ue,command:Oe}}releaseCodeActions(z){this.f.get(z)?.dispose(),this.f.delete(z),this.e.delete(z)}static o(z){return typeof z.command=="string"&&typeof z.title=="string"}}class L{static toInternalProviderId(z,W){return z+"."+W}constructor(z,W,H,G,q){this.d=z,this.e=W,this.f=H,this.g=G,this.h=q}async prepareDocumentPaste(z,W,H,G){if(!this.f.prepareDocumentPaste)return;const q=this.e.getDocument(z),x=W.map(Ue=>P.Range.to(Ue)),ue=P.DataTransfer.toDataTransfer(H,()=>{throw new o.$0});if(await this.f.prepareDocumentPaste(q,x,ue,G),G.isCancellationRequested)return;const Oe=Array.from(ue).filter(([,Ue])=>!(Ue instanceof M.$oL));return P.DataTransfer.from(Oe)}async providePasteEdits(z,W,H,G,q){if(!this.f.provideDocumentPasteEdits)return;const x=this.e.getDocument(W),ue=H.map(Ze=>P.Range.to(Ze)),Oe=P.DataTransfer.toDataTransfer(G,async Ze=>(await this.d.$resolvePasteFileData(this.g,z,Ze)).buffer),Ue=await this.f.provideDocumentPasteEdits(x,ue,Oe,q);if(Ue)return{label:Ue.label??(0,s.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:Ue.yieldTo?.map(Ze=>"mimeType"in Ze?Ze:{providerId:L.toInternalProviderId(Ze.extensionId,Ze.providerId)}),insertText:typeof Ue.insertText=="string"?Ue.insertText:{snippet:Ue.insertText.value},additionalEdit:Ue.additionalEdit?P.WorkspaceEdit.from(Ue.additionalEdit,void 0):void 0}}}class O{constructor(z,W){this.d=z,this.e=W}async provideDocumentFormattingEdits(z,W,H){const G=this.d.getDocument(z),q=await this.e.provideDocumentFormattingEdits(G,W,H);if(Array.isArray(q))return q.map(P.TextEdit.from)}}class Y{constructor(z,W){this.d=z,this.e=W}async provideDocumentRangeFormattingEdits(z,W,H,G){const q=this.d.getDocument(z),x=P.Range.to(W),ue=await this.e.provideDocumentRangeFormattingEdits(q,x,H,G);if(Array.isArray(ue))return ue.map(P.TextEdit.from)}async provideDocumentRangesFormattingEdits(z,W,H,G){(0,D.$Mf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const q=this.d.getDocument(z),x=W.map(P.Range.to),ue=await this.e.provideDocumentRangesFormattingEdits(q,x,H,G);if(Array.isArray(ue))return ue.map(P.TextEdit.from)}}class he{constructor(z,W){this.d=z,this.e=W,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(z,W,H,G,q){const x=this.d.getDocument(z),ue=P.Position.to(W),Oe=await this.e.provideOnTypeFormattingEdits(x,ue,H,G,q);if(Array.isArray(Oe))return Oe.map(P.TextEdit.from)}}class $e{constructor(z,W){this.e=z,this.f=W,this.d=new r.$Rdc("WorkspaceSymbols")}async provideWorkspaceSymbols(z,W){const H=await this.e.provideWorkspaceSymbols(z,W);if(!(0,C.$Kb)(H))return{symbols:[]};const G=this.d.add(H),q={cacheId:G,symbols:[]};for(let x=0;x<H.length;x++){const ue=H[x];if(!ue||!ue.name){this.f.warn("INVALID SymbolInformation",ue);continue}q.symbols.push({...P.WorkspaceSymbol.from(ue),cacheId:[G,x]})}return q}async resolveWorkspaceSymbol(z,W){if(typeof this.e.resolveWorkspaceSymbol!="function"||!z.cacheId)return z;const H=this.d.get(...z.cacheId);if(H){const G=await this.e.resolveWorkspaceSymbol(H,W);return G&&(0,T.$dn)(z,P.WorkspaceSymbol.from(G),!0)}}releaseWorkspaceSymbols(z){this.d.delete(z)}}class De{static supportsResolving(z){return typeof z.prepareRename=="function"}constructor(z,W,H){this.d=z,this.e=W,this.f=H}async provideRenameEdits(z,W,H,G){const q=this.d.getDocument(z),x=P.Position.to(W);try{const ue=await this.e.provideRenameEdits(q,x,H,G);return ue?P.WorkspaceEdit.from(ue):void 0}catch(ue){const Oe=De.g(ue);return Oe?{rejectReason:Oe,edits:void 0}:Promise.reject(ue)}}async resolveRenameLocation(z,W,H){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const G=this.d.getDocument(z),q=P.Position.to(W);try{const x=await this.e.prepareRename(G,q,H);let ue,Oe;if(M.$CK.isRange(x)?(ue=x,Oe=G.getText(x)):(0,D.$Ef)(x)&&(ue=x.range,Oe=x.placeholder),!ue||!Oe)return;if(ue.start.line>q.line||ue.end.line<q.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:P.Range.from(ue),text:Oe}}catch(x){const ue=De.g(x);return ue?{rejectReason:ue,range:void 0,text:void 0}:Promise.reject(x)}}static g(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class ke{constructor(z,W){this.resultId=z,this.tokens=W}}class fe{constructor(z,W){this.f=z,this.g=W,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(z,W,H){const G=this.f.getDocument(z),q=W!==0?this.d.get(W):null;let x=typeof q?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(G,q.resultId,H):await this.g.provideDocumentSemanticTokens(G,H);return q&&this.d.delete(W),x?(x=fe.h(x),this.o(fe.n(q,x),x)):null}async releaseDocumentSemanticColoring(z){this.d.delete(z)}static h(z){return fe.j(z)?fe.k(z)?z:new M.$RL(new Uint32Array(z.data),z.resultId):fe.l(z)?fe.m(z)?z:new M.$TL(z.edits.map(W=>new M.$SL(W.start,W.deleteCount,W.data?new Uint32Array(W.data):W.data)),z.resultId):z}static j(z){return z&&!!z.data}static k(z){return z.data instanceof Uint32Array}static l(z){return z&&Array.isArray(z.edits)}static m(z){for(const W of z.edits)if(!(W.data instanceof Uint32Array))return!1;return!0}static n(z,W){if(!fe.j(W)||!z||!z.tokens)return W;const H=z.tokens,G=H.length,q=W.data,x=q.length;let ue=0;const Oe=Math.min(G,x);for(;ue<Oe&&H[ue]===q[ue];)ue++;if(ue===G&&ue===x)return new M.$TL([],W.resultId);let Ue=0;const Ze=Oe-ue;for(;Ue<Ze&&H[G-Ue-1]===q[x-Ue-1];)Ue++;return new M.$TL([{start:ue,deleteCount:G-ue-Ue,data:q.subarray(ue,x-Ue)}],W.resultId)}o(z,W){if(fe.j(z)){const H=this.e++;return this.d.set(H,new ke(z.resultId,z.data)),(0,t.$20)({id:H,type:"full",data:z.data})}if(fe.l(z)){const H=this.e++;return fe.j(W)?this.d.set(H,new ke(W.resultId,W.data)):this.d.set(H,new ke(z.resultId)),(0,t.$20)({id:H,type:"delta",deltas:(z.edits||[]).map(G=>({start:G.start,deleteCount:G.deleteCount,data:G.data}))})}return null}}class ve{constructor(z,W){this.d=z,this.e=W}async provideDocumentRangeSemanticTokens(z,W,H){const G=this.d.getDocument(z),q=await this.e.provideDocumentRangeSemanticTokens(G,P.Range.to(W),H);return q?this.f(q):null}f(z){return(0,t.$20)({id:0,type:"full",data:z.data})}}class te{static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}constructor(z,W,H,G,q){this.f=z,this.g=W,this.h=H,this.j=G,this.k=q,this.d=new r.$Rdc("CompletionItem"),this.e=new Map}async provideCompletionItems(z,W,H,G){const q=this.f.getDocument(z),x=P.Position.to(W),ue=q.getWordRangeAtPosition(x)||new M.$CK(x,x),Oe=ue.with({end:x}),Ue=new c.$Nd,Ze=await this.h.provideCompletionItems(q,x,G,P.CompletionContext.to(H));if(!Ze||G.isCancellationRequested)return;const Je=Array.isArray(Ze)?new M.$8K(Ze):Ze,tt=te.supportsResolving(this.h)?this.d.add(Je.items):this.d.add([]),_e=new g.$Qc;this.e.set(tt,_e);const et=[],rt={x:tt,b:et,a:{replace:P.Range.from(ue),insert:P.Range.from(Oe)},c:Je.isIncomplete||void 0,d:Ue.elapsed()};for(let nt=0;nt<Je.items.length;nt++){const ze=Je.items[nt],dt=this.l(ze,[tt,nt],Oe,ue);et.push(dt)}return rt}async resolveCompletionItem(z,W){if(typeof this.h.resolveCompletionItem!="function")return;const H=this.d.get(...z);if(!H)return;const G=this.l(H,z),q=await this.h.resolveCompletionItem(H,W);if(!q)return;const x=this.l(q,z);return(G.h!==x.h||G.i!==x.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(G.n!==x.n||G.o!==x.o||!(0,T.$en)(G.p,x.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...G,d:x.d,c:x.c,l:x.l,h:x.h,i:x.i,n:x.n,o:x.o,p:x.p}}releaseCompletionItems(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,W,H,G){const q=this.e.get(W[0]);if(!q)throw Error("DisposableStore is missing...");const x=this.g.toInternal(z.command,q),ue={x:W,a:z.label,b:z.kind!==void 0?P.CompletionItemKind.from(z.kind):void 0,m:z.tags&&z.tags.map(P.CompletionItemTag.from),c:z.detail,d:typeof z.documentation>"u"?void 0:P.MarkdownString.fromStrict(z.documentation),e:z.sortText!==z.label?z.sortText:void 0,f:z.filterText!==z.label?z.filterText:void 0,g:z.preselect||void 0,i:z.keepWhitespace?1:0,k:z.commitCharacters?.join(""),l:z.additionalTextEdits&&z.additionalTextEdits.map(P.TextEdit.from),n:x?.$ident,o:x?.id,p:x?.$ident?void 0:x?.arguments};z.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ue.h=z.textEdit.newText):typeof z.insertText=="string"?ue.h=z.insertText:z.insertText instanceof M.$LK&&(ue.h=z.insertText.value,ue.i|=4);let Oe;return z.textEdit?Oe=z.textEdit.range:z.range&&(Oe=z.range),M.$CK.isRange(Oe)?ue.j=P.Range.from(Oe):Oe&&(!H?.isEqual(Oe.inserting)||!G?.isEqual(Oe.replacing))&&(ue.j={insert:P.Range.from(Oe.inserting),replace:P.Range.from(Oe.replacing)}),ue}}class Re{async provideInlineCompletions(z,W,H,G){}disposeCompletions(z){}handleDidShowCompletionItem(z,W,H){}handlePartialAccept(z,W,H){}}class se extends Re{constructor(z,W,H,G){super(),this.f=z,this.g=W,this.h=H,this.j=G,this.d=new Q,this.e=(0,n.$LF)(this.f,"inlineCompletionsAdditions"),this.k={[A.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,n.$LF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(z,W,H,G){const q=this.g.getDocument(z),x=P.Position.to(W),ue=await this.h.provideInlineCompletionItems(q,x,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:P.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind]},G);if(!ue||G.isCancellationRequested)return;const Oe=Array.isArray(ue)?ue:ue.items,Ue=this.e?Array.isArray(ue)?[]:ue.commands||[]:[],Ze=this.e&&!Array.isArray(ue)?ue.enableForwardStability:void 0;let Je;return{pid:this.d.createReferenceId({dispose(){Je?.dispose()},items:Oe}),items:Oe.map((_e,et)=>{let rt;_e.command&&(Je||(Je=new g.$Qc),rt=this.j.toInternal(_e.command,Je));const nt=_e.insertText;return{insertText:typeof nt=="string"?nt:{snippet:nt.value},filterText:_e.filterText,range:_e.range?P.Range.from(_e.range):void 0,command:rt,idx:et,completeBracketPairs:this.e?_e.completeBracketPairs:!1}}),commands:Ue.map(_e=>(Je||(Je=new g.$Qc),this.j.toInternal(_e,Je))),suppressSuggestions:!1,enableForwardStability:Ze}}disposeCompletions(z){this.d.disposeReferenceId(z)?.dispose()}handleDidShowCompletionItem(z,W,H){const G=this.d.get(z)?.items[W];G&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(G,H)}handlePartialAccept(z,W,H){const G=this.d.get(z)?.items[W];G&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(G,H)}}class Q{constructor(){this.d=new Map,this.e=1}createReferenceId(z){const W=this.e++;return this.d.set(W,z),W}disposeReferenceId(z){const W=this.d.get(z);return this.d.delete(z),W}get(z){return this.d.get(z)}}class B{constructor(z,W){this.e=z,this.f=W,this.d=new r.$Rdc("SignatureHelp")}async provideSignatureHelp(z,W,H,G){const q=this.e.getDocument(z),x=P.Position.to(W),ue=this.g(H),Oe=await this.f.provideSignatureHelp(q,x,G,ue);if(Oe){const Ue=this.d.add([Oe]);return{...P.SignatureHelp.from(Oe),id:Ue}}}g(z){let W;if(z.activeSignatureHelp){const H=P.SignatureHelp.to(z.activeSignatureHelp),G=this.d.get(z.activeSignatureHelp.id,0);G?(W=G,W.activeSignature=H.activeSignature,W.activeParameter=H.activeParameter):W=H}return{...z,activeSignatureHelp:W}}releaseSignatureHelp(z){this.d.delete(z)}}class ne{constructor(z,W,H,G,q){this.f=z,this.g=W,this.h=H,this.j=G,this.k=q,this.d=new r.$Rdc("InlayHints"),this.e=new Map}async provideInlayHints(z,W,H){const G=this.f.getDocument(z),q=P.Range.to(W),x=await this.h.provideInlayHints(G,q,H);if(!Array.isArray(x)||x.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${W}`);return}if(H.isCancellationRequested)return;const ue=this.d.add(x);this.e.set(ue,new g.$Qc);const Oe={hints:[],cacheId:ue};for(let Ue=0;Ue<x.length;Ue++)this.l(x[Ue],q)&&Oe.hints.push(this.m(x[Ue],[ue,Ue]));return this.j.trace(`[InlayHints] ${Oe.hints.length} inlay hints from '${this.k.identifier.value}' for ${W}`),Oe}async resolveInlayHint(z,W){if(typeof this.h.resolveInlayHint!="function")return;const H=this.d.get(...z);if(!H)return;const G=await this.h.resolveInlayHint(H,W);if(G&&this.l(G))return this.m(G,z)}releaseHints(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,W){return z.label.length===0||Array.isArray(z.label)&&z.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",z),!1):!(W&&!W.contains(z.position))}m(z,W){const H=this.e.get(W[0]);if(!H)throw Error("DisposableStore is missing...");const G={label:"",cacheId:W,tooltip:P.MarkdownString.fromStrict(z.tooltip),position:P.Position.from(z.position),textEdits:z.textEdits&&z.textEdits.map(P.TextEdit.from),kind:z.kind&&P.InlayHintKind.from(z.kind),paddingLeft:z.paddingLeft,paddingRight:z.paddingRight};return typeof z.label=="string"?G.label=z.label:G.label=z.label.map(q=>{const x={label:q.value};return x.tooltip=P.MarkdownString.fromStrict(q.tooltip),M.$MK.isLocation(q.location)&&(x.location=P.location.from(q.location)),q.command&&(x.command=this.g.toInternal(q.command,H)),x}),G}}class pe{constructor(z,W){this.e=z,this.f=W,this.d=new r.$Rdc("DocumentLink")}async provideLinks(z,W){const H=this.e.getDocument(z),G=await this.f.provideDocumentLinks(H,W);if(!(!Array.isArray(G)||G.length===0)&&!W.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:G.filter(pe.g).map(P.DocumentLink.from)};{const q=this.d.add(G),x={links:[],cacheId:q};for(let ue=0;ue<G.length;ue++){if(!pe.g(G[ue]))continue;const Oe=P.DocumentLink.from(G[ue]);Oe.cacheId=[q,ue],x.links.push(Oe)}return x}}}static g(z){return z.target&&z.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(z,W){if(typeof this.f.resolveDocumentLink!="function")return;const H=this.d.get(...z);if(!H)return;const G=await this.f.resolveDocumentLink(H,W);if(!(!G||!pe.g(G)))return P.DocumentLink.from(G)}releaseLinks(z){this.d.delete(z)}}class re{constructor(z,W){this.d=z,this.e=W}async provideColors(z,W){const H=this.d.getDocument(z),G=await this.e.provideDocumentColors(H,W);return Array.isArray(G)?G.map(x=>({color:P.Color.from(x.color),range:P.Range.from(x.range)})):[]}async provideColorPresentations(z,W,H){const G=this.d.getDocument(z),q=P.Range.to(W.range),x=P.Color.to(W.color),ue=await this.e.provideColorPresentations(x,{document:G,range:q},H);if(Array.isArray(ue))return ue.map(P.ColorPresentation.from)}}class le{constructor(z,W){this.d=z,this.e=W}async provideFoldingRanges(z,W,H){const G=this.d.getDocument(z),q=await this.e.provideFoldingRanges(G,W,H);if(Array.isArray(q))return q.map(P.FoldingRange.from)}}class ce{constructor(z,W,H){this.d=z,this.e=W,this.f=H}async provideSelectionRanges(z,W,H){const G=this.d.getDocument(z),q=W.map(P.Position.to),x=await this.e.provideSelectionRanges(G,q,H);if(!(0,C.$Kb)(x))return[];if(x.length!==q.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ue=[];for(let Oe=0;Oe<q.length;Oe++){const Ue=[];ue.push(Ue);let Ze=q[Oe],Je=x[Oe];for(;;){if(!Je.range.contains(Ze))throw new Error("INVALID selection range, must contain the previous range");if(Ue.push(P.SelectionRange.from(Je)),!Je.parent)break;Ze=Je.range,Je=Je.parent}}return ue}}class ye{constructor(z,W){this.f=z,this.g=W,this.d=new i.$FM(""),this.e=new Map}async prepareSession(z,W,H){const G=this.f.getDocument(z),q=P.Position.to(W),x=await this.g.prepareCallHierarchy(G,q,H);if(!x)return;const ue=this.d.nextId();return this.e.set(ue,new Map),Array.isArray(x)?x.map(Oe=>this.h(ue,Oe)):[this.h(ue,x)]}async provideCallsTo(z,W,H){const G=this.j(z,W);if(!G)throw new Error("missing call hierarchy item");const q=await this.g.provideCallHierarchyIncomingCalls(G,H);if(q)return q.map(x=>({from:this.h(z,x.from),fromRanges:x.fromRanges.map(ue=>P.Range.from(ue))}))}async provideCallsFrom(z,W,H){const G=this.j(z,W);if(!G)throw new Error("missing call hierarchy item");const q=await this.g.provideCallHierarchyOutgoingCalls(G,H);if(q)return q.map(x=>({to:this.h(z,x.to),fromRanges:x.fromRanges.map(ue=>P.Range.from(ue))}))}releaseSession(z){this.e.delete(z)}h(z,W){const H=this.e.get(z),G=P.CallHierarchyItem.from(W,z,H.size.toString(36));return H.set(G._itemId,W),G}j(z,W){return this.e.get(z)?.get(W)}}class _{constructor(z,W){this.f=z,this.g=W,this.d=new i.$FM(""),this.e=new Map}async prepareSession(z,W,H){const G=this.f.getDocument(z),q=P.Position.to(W),x=await this.g.prepareTypeHierarchy(G,q,H);if(!x)return;const ue=this.d.nextId();return this.e.set(ue,new Map),Array.isArray(x)?x.map(Oe=>this.h(ue,Oe)):[this.h(ue,x)]}async provideSupertypes(z,W,H){const G=this.j(z,W);if(!G)throw new Error("missing type hierarchy item");const q=await this.g.provideTypeHierarchySupertypes(G,H);if(q)return q.map(x=>this.h(z,x))}async provideSubtypes(z,W,H){const G=this.j(z,W);if(!G)throw new Error("missing type hierarchy item");const q=await this.g.provideTypeHierarchySubtypes(G,H);if(q)return q.map(x=>this.h(z,x))}releaseSession(z){this.e.delete(z)}h(z,W){const H=this.e.get(z),G=P.TypeHierarchyItem.from(W,z,H.size.toString(36));return H.set(G._itemId,W),G}j(z,W){return this.e.get(z)?.get(W)}}class de{static toInternalProviderId(z,W){return z+"."+W}constructor(z,W,H,G,q){this.d=z,this.e=W,this.f=H,this.g=G,this.h=q}async provideDocumentOnDropEdits(z,W,H,G,q){const x=this.e.getDocument(W),ue=P.Position.to(H),Oe=P.DataTransfer.toDataTransfer(G,async Ze=>(await this.d.$resolveDocumentOnDropFileData(this.g,z,Ze)).buffer),Ue=await this.f.provideDocumentDropEdits(x,ue,Oe,q);if(Ue)return{label:Ue.label??(0,s.localize)(1,null,this.h.displayName||this.h.name),yieldTo:Ue.yieldTo?.map(Ze=>"mimeType"in Ze?Ze:{providerId:de.toInternalProviderId(Ze.extensionId,Ze.providerId)}),insertText:typeof Ue.insertText=="string"?Ue.insertText:{snippet:Ue.insertText.value},additionalEdit:Ue.additionalEdit?P.WorkspaceEdit.from(Ue.additionalEdit,void 0):void 0}}}class ie{constructor(z,W){this.d=z,this.e=W}async provideMappedEdits(z,W,H,G){const q=y.URI.revive(z),x=this.d.getDocument(q),ue=H.documents.map(Ze=>Ze.map(Je=>({uri:y.URI.revive(Je.uri),version:Je.version,ranges:Je.ranges.map(tt=>P.Range.to(tt))}))),Oe={documents:ue,selections:ue[0]?.[0]?.ranges??[]},Ue=await this.e.provideMappedEdits(x,W,Oe,G);return Ue?P.WorkspaceEdit.from(Ue):null}}class ae{constructor(z,W){this.adapter=z,this.extension=W}}class me{static{this.d=0}constructor(z,W,H,G,q,x,ue,Oe){this.g=W,this.h=H,this.j=G,this.k=q,this.l=x,this.m=ue,this.n=Oe,this.f=new Map,this.e=z.getProxy($.$yK.MainThreadLanguageFeatures)}o(z,W){return P.DocumentSelector.from(z,this.g,W)}p(z){return new M.$AK(()=>{this.f.delete(z),this.e.$unregister(z)})}q(){return me.d++}async s(z,W,H,G,q,x=!1){const ue=this.f.get(z);if(!ue||!(ue.adapter instanceof W))return G;const Oe=Date.now();x||this.l.trace(`[${ue.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const Ue=H(ue.adapter,ue.extension);return Promise.resolve(Ue).catch(Ze=>{(0,o.$3)(Ze)||(this.l.error(`[${ue.extension.identifier.value}] provider FAILED`),this.l.error(Ze),this.n.onExtensionError(ue.extension.identifier,Ze))}).finally(()=>{x||this.l.trace(`[${ue.extension.identifier.value}] provider DONE after ${Date.now()-Oe}ms`)}),b.CancellationToken.isCancellationToken(q)?(0,l.$Ng)(Ue,q):Ue}t(z,W){const H=this.q();return this.f.set(H,new ae(z,W)),H}static u(z){return z.displayName||z.name}registerDocumentSymbolProvider(z,W,H,G){const q=this.t(new a(this.h,H),z),x=G&&G.label||me.u(z);return this.e.$registerDocumentSymbolProvider(q,this.o(W,z),x),this.p(q)}$provideDocumentSymbols(z,W,H){return this.s(z,a,G=>G.provideDocumentSymbols(y.URI.revive(W),H),void 0,H)}registerCodeLensProvider(z,W,H){const G=this.q(),q=typeof H.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(G,new ae(new d(this.h,this.j.converter,H),z)),this.e.$registerCodeLensSupport(G,this.o(W,z),q);let x=this.p(G);if(q!==void 0){const ue=H.onDidChangeCodeLenses(Oe=>this.e.$emitCodeLensEvent(q));x=M.$AK.from(x,ue)}return x}$provideCodeLenses(z,W,H){return this.s(z,d,G=>G.provideCodeLenses(y.URI.revive(W),H),void 0,H)}$resolveCodeLens(z,W,H){return this.s(z,d,G=>G.resolveCodeLens(W,H),void 0,void 0)}$releaseCodeLenses(z,W){this.s(z,d,H=>Promise.resolve(H.releaseCodeLenses(W)),void 0,void 0)}registerDefinitionProvider(z,W,H){const G=this.t(new m(this.h,H),z);return this.e.$registerDefinitionSupport(G,this.o(W,z)),this.p(G)}$provideDefinition(z,W,H,G){return this.s(z,m,q=>q.provideDefinition(y.URI.revive(W),H,G),[],G)}registerDeclarationProvider(z,W,H){const G=this.t(new S(this.h,H),z);return this.e.$registerDeclarationSupport(G,this.o(W,z)),this.p(G)}$provideDeclaration(z,W,H,G){return this.s(z,S,q=>q.provideDeclaration(y.URI.revive(W),H,G),[],G)}registerImplementationProvider(z,W,H){const G=this.t(new k(this.h,H),z);return this.e.$registerImplementationSupport(G,this.o(W,z)),this.p(G)}$provideImplementation(z,W,H,G){return this.s(z,k,q=>q.provideImplementation(y.URI.revive(W),H,G),[],G)}registerTypeDefinitionProvider(z,W,H){const G=this.t(new h(this.h,H),z);return this.e.$registerTypeDefinitionSupport(G,this.o(W,z)),this.p(G)}$provideTypeDefinition(z,W,H,G){return this.s(z,h,q=>q.provideTypeDefinition(y.URI.revive(W),H,G),[],G)}registerHoverProvider(z,W,H,G){const q=this.t(new w(this.h,H),z);return this.e.$registerHoverProvider(q,this.o(W,z)),this.p(q)}$provideHover(z,W,H,G){return this.s(z,w,q=>q.provideHover(y.URI.revive(W),H,G),void 0,G)}registerEvaluatableExpressionProvider(z,W,H,G){const q=this.t(new I(this.h,H),z);return this.e.$registerEvaluatableExpressionProvider(q,this.o(W,z)),this.p(q)}$provideEvaluatableExpression(z,W,H,G){return this.s(z,I,q=>q.provideEvaluatableExpression(y.URI.revive(W),H,G),void 0,G)}registerInlineValuesProvider(z,W,H,G){const q=typeof H.onDidChangeInlineValues=="function"?this.q():void 0,x=this.t(new F(this.h,H),z);this.e.$registerInlineValuesProvider(x,this.o(W,z),q);let ue=this.p(x);if(q!==void 0){const Oe=H.onDidChangeInlineValues(Ue=>this.e.$emitInlineValuesEvent(q));ue=M.$AK.from(ue,Oe)}return ue}$provideInlineValues(z,W,H,G,q){return this.s(z,F,x=>x.provideInlineValues(y.URI.revive(W),H,G,q),void 0,q)}registerDocumentHighlightProvider(z,W,H){const G=this.t(new V(this.h,H),z);return this.e.$registerDocumentHighlightProvider(G,this.o(W,z)),this.p(G)}$provideDocumentHighlights(z,W,H,G){return this.s(z,V,q=>q.provideDocumentHighlights(y.URI.revive(W),H,G),void 0,G)}registerLinkedEditingRangeProvider(z,W,H){const G=this.t(new Z(this.h,H),z);return this.e.$registerLinkedEditingRangeProvider(G,this.o(W,z)),this.p(G)}$provideLinkedEditingRanges(z,W,H,G){return this.s(z,Z,async q=>{const x=await q.provideLinkedEditingRanges(y.URI.revive(W),H,G);if(x)return{ranges:x.ranges,wordPattern:x.wordPattern?me.w(x.wordPattern):void 0}},void 0,G)}registerReferenceProvider(z,W,H){const G=this.t(new N(this.h,H),z);return this.e.$registerReferenceSupport(G,this.o(W,z)),this.p(G)}$provideReferences(z,W,H,G,q){return this.s(z,N,x=>x.provideReferences(y.URI.revive(W),H,G,q),void 0,q)}registerCodeActionProvider(z,W,H,G){const q=new g.$Qc,x=this.t(new R(this.h,this.j.converter,this.k,H,this.l,z,this.m),z);return this.e.$registerQuickFixSupport(x,this.o(W,z),{providedKinds:G?.providedCodeActionKinds?.map(ue=>ue.value),documentation:G?.documentation?.map(ue=>({kind:ue.kind.value,command:this.j.converter.toInternal(ue.command,q)}))},me.u(z),!!H.resolveCodeAction),q.add(this.p(x)),q}$provideCodeActions(z,W,H,G,q){return this.s(z,R,x=>x.provideCodeActions(y.URI.revive(W),H,G,q),void 0,q)}$resolveCodeAction(z,W,H){return this.s(z,R,G=>G.resolveCodeAction(W,H),{},void 0)}$releaseCodeActions(z,W){this.s(z,R,H=>Promise.resolve(H.releaseCodeActions(W)),void 0,void 0)}registerDocumentFormattingEditProvider(z,W,H){const G=this.t(new O(this.h,H),z);return this.e.$registerDocumentFormattingSupport(G,this.o(W,z),z.identifier,z.displayName||z.name),this.p(G)}$provideDocumentFormattingEdits(z,W,H,G){return this.s(z,O,q=>q.provideDocumentFormattingEdits(y.URI.revive(W),H,G),void 0,G)}registerDocumentRangeFormattingEditProvider(z,W,H){const G=typeof H.provideDocumentRangesFormattingEdits=="function",q=this.t(new Y(this.h,H),z);return this.e.$registerRangeFormattingSupport(q,this.o(W,z),z.identifier,z.displayName||z.name,G),this.p(q)}$provideDocumentRangeFormattingEdits(z,W,H,G,q){return this.s(z,Y,x=>x.provideDocumentRangeFormattingEdits(y.URI.revive(W),H,G,q),void 0,q)}$provideDocumentRangesFormattingEdits(z,W,H,G,q){return this.s(z,Y,x=>x.provideDocumentRangesFormattingEdits(y.URI.revive(W),H,G,q),void 0,q)}registerOnTypeFormattingEditProvider(z,W,H,G){const q=this.t(new he(this.h,H),z);return this.e.$registerOnTypeFormattingSupport(q,this.o(W,z),G,z.identifier),this.p(q)}$provideOnTypeFormattingEdits(z,W,H,G,q,x){return this.s(z,he,ue=>ue.provideOnTypeFormattingEdits(y.URI.revive(W),H,G,q,x),void 0,x)}registerWorkspaceSymbolProvider(z,W){const H=this.t(new $e(W,this.l),z);return this.e.$registerNavigateTypeSupport(H,typeof W.resolveWorkspaceSymbol=="function"),this.p(H)}$provideWorkspaceSymbols(z,W,H){return this.s(z,$e,G=>G.provideWorkspaceSymbols(W,H),{symbols:[]},H)}$resolveWorkspaceSymbol(z,W,H){return this.s(z,$e,G=>G.resolveWorkspaceSymbol(W,H),void 0,void 0)}$releaseWorkspaceSymbols(z,W){this.s(z,$e,H=>H.releaseWorkspaceSymbols(W),void 0,void 0)}registerRenameProvider(z,W,H){const G=this.t(new De(this.h,H,this.l),z);return this.e.$registerRenameSupport(G,this.o(W,z),De.supportsResolving(H)),this.p(G)}$provideRenameEdits(z,W,H,G,q){return this.s(z,De,x=>x.provideRenameEdits(y.URI.revive(W),H,G,q),void 0,q)}$resolveRenameLocation(z,W,H,G){return this.s(z,De,q=>q.resolveRenameLocation(y.URI.revive(W),H,G),void 0,G)}registerDocumentSemanticTokensProvider(z,W,H,G){const q=this.t(new fe(this.h,H),z),x=typeof H.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(q,this.o(W,z),G,x);let ue=this.p(q);if(x){const Oe=H.onDidChangeSemanticTokens(Ue=>this.e.$emitDocumentSemanticTokensEvent(x));ue=M.$AK.from(ue,Oe)}return ue}$provideDocumentSemanticTokens(z,W,H,G){return this.s(z,fe,q=>q.provideDocumentSemanticTokens(y.URI.revive(W),H,G),null,G)}$releaseDocumentSemanticTokens(z,W){this.s(z,fe,H=>H.releaseDocumentSemanticColoring(W),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(z,W,H,G){const q=this.t(new ve(this.h,H),z);return this.e.$registerDocumentRangeSemanticTokensProvider(q,this.o(W,z),G),this.p(q)}$provideDocumentRangeSemanticTokens(z,W,H,G){return this.s(z,ve,q=>q.provideDocumentRangeSemanticTokens(y.URI.revive(W),H,G),null,G)}registerCompletionItemProvider(z,W,H,G){const q=this.t(new te(this.h,this.j.converter,H,this.m,z),z);return this.e.$registerCompletionsProvider(q,this.o(W,z),G,te.supportsResolving(H),z.identifier),this.p(q)}$provideCompletionItems(z,W,H,G,q){return this.s(z,te,x=>x.provideCompletionItems(y.URI.revive(W),H,G,q),void 0,q)}$resolveCompletionItem(z,W,H){return this.s(z,te,G=>G.resolveCompletionItem(W,H),void 0,H)}$releaseCompletionItems(z,W){this.s(z,te,H=>H.releaseCompletionItems(W),void 0,void 0)}registerInlineCompletionsProvider(z,W,H,G){const q=new se(z,this.h,H,this.j.converter),x=this.t(q,z);return this.e.$registerInlineCompletionsSupport(x,this.o(W,z),q.supportsHandleEvents,v.$_l.toKey(z.identifier.value),G?.yieldTo?.map(ue=>v.$_l.toKey(ue))||[]),this.p(x)}$provideInlineCompletions(z,W,H,G,q){return this.s(z,Re,x=>x.provideInlineCompletions(y.URI.revive(W),H,G,q),void 0,q)}$handleInlineCompletionDidShow(z,W,H,G){this.s(z,Re,async q=>{q.handleDidShowCompletionItem(W,H,G)},void 0,void 0)}$handleInlineCompletionPartialAccept(z,W,H,G){this.s(z,Re,async q=>{q.handlePartialAccept(W,H,G)},void 0,void 0)}$freeInlineCompletionsList(z,W){this.s(z,Re,async H=>{H.disposeCompletions(W)},void 0,void 0)}registerSignatureHelpProvider(z,W,H,G){const q=Array.isArray(G)?{triggerCharacters:G,retriggerCharacters:[]}:G,x=this.t(new B(this.h,H),z);return this.e.$registerSignatureHelpProvider(x,this.o(W,z),q),this.p(x)}$provideSignatureHelp(z,W,H,G,q){return this.s(z,B,x=>x.provideSignatureHelp(y.URI.revive(W),H,G,q),void 0,q)}$releaseSignatureHelp(z,W){this.s(z,B,H=>H.releaseSignatureHelp(W),void 0,void 0)}registerInlayHintsProvider(z,W,H){const G=typeof H.onDidChangeInlayHints=="function"?this.q():void 0,q=this.t(new ne(this.h,this.j.converter,H,this.l,z),z);this.e.$registerInlayHintsProvider(q,this.o(W,z),typeof H.resolveInlayHint=="function",G,me.u(z));let x=this.p(q);if(G!==void 0){const ue=H.onDidChangeInlayHints(Oe=>this.e.$emitInlayHintsEvent(G));x=M.$AK.from(x,ue)}return x}$provideInlayHints(z,W,H,G){return this.s(z,ne,q=>q.provideInlayHints(y.URI.revive(W),H,G),void 0,G)}$resolveInlayHint(z,W,H){return this.s(z,ne,G=>G.resolveInlayHint(W,H),void 0,H)}$releaseInlayHints(z,W){this.s(z,ne,H=>H.releaseHints(W),void 0,void 0)}registerDocumentLinkProvider(z,W,H){const G=this.t(new pe(this.h,H),z);return this.e.$registerDocumentLinkProvider(G,this.o(W,z),typeof H.resolveDocumentLink=="function"),this.p(G)}$provideDocumentLinks(z,W,H){return this.s(z,pe,G=>G.provideLinks(y.URI.revive(W),H),void 0,H,W.scheme==="output")}$resolveDocumentLink(z,W,H){return this.s(z,pe,G=>G.resolveLink(W,H),void 0,void 0,!0)}$releaseDocumentLinks(z,W){this.s(z,pe,H=>H.releaseLinks(W),void 0,void 0,!0)}registerColorProvider(z,W,H){const G=this.t(new re(this.h,H),z);return this.e.$registerDocumentColorProvider(G,this.o(W,z)),this.p(G)}$provideDocumentColors(z,W,H){return this.s(z,re,G=>G.provideColors(y.URI.revive(W),H),[],H)}$provideColorPresentations(z,W,H,G){return this.s(z,re,q=>q.provideColorPresentations(y.URI.revive(W),H,G),void 0,G)}registerFoldingRangeProvider(z,W,H){const G=this.q(),q=typeof H.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(G,new ae(new le(this.h,H),z)),this.e.$registerFoldingRangeProvider(G,this.o(W,z),z.identifier,q);let x=this.p(G);if(q!==void 0){const ue=H.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(q));x=M.$AK.from(x,ue)}return x}$provideFoldingRanges(z,W,H,G){return this.s(z,le,q=>q.provideFoldingRanges(y.URI.revive(W),H,G),void 0,G)}registerSelectionRangeProvider(z,W,H){const G=this.t(new ce(this.h,H,this.l),z);return this.e.$registerSelectionRangeProvider(G,this.o(W,z)),this.p(G)}$provideSelectionRanges(z,W,H,G){return this.s(z,ce,q=>q.provideSelectionRanges(y.URI.revive(W),H,G),[],G)}registerCallHierarchyProvider(z,W,H){const G=this.t(new ye(this.h,H),z);return this.e.$registerCallHierarchyProvider(G,this.o(W,z)),this.p(G)}$prepareCallHierarchy(z,W,H,G){return this.s(z,ye,q=>Promise.resolve(q.prepareSession(y.URI.revive(W),H,G)),void 0,G)}$provideCallHierarchyIncomingCalls(z,W,H,G){return this.s(z,ye,q=>q.provideCallsTo(W,H,G),void 0,G)}$provideCallHierarchyOutgoingCalls(z,W,H,G){return this.s(z,ye,q=>q.provideCallsFrom(W,H,G),void 0,G)}$releaseCallHierarchy(z,W){this.s(z,ye,H=>Promise.resolve(H.releaseSession(W)),void 0,void 0)}registerTypeHierarchyProvider(z,W,H){const G=this.t(new _(this.h,H),z);return this.e.$registerTypeHierarchyProvider(G,this.o(W,z)),this.p(G)}$prepareTypeHierarchy(z,W,H,G){return this.s(z,_,q=>Promise.resolve(q.prepareSession(y.URI.revive(W),H,G)),void 0,G)}$provideTypeHierarchySupertypes(z,W,H,G){return this.s(z,_,q=>q.provideSupertypes(W,H,G),void 0,G)}$provideTypeHierarchySubtypes(z,W,H,G){return this.s(z,_,q=>q.provideSubtypes(W,H,G),void 0,G)}$releaseTypeHierarchy(z,W){this.s(z,_,H=>Promise.resolve(H.releaseSession(W)),void 0,void 0)}registerDocumentOnDropEditProvider(z,W,H,G){const q=this.q();this.f.set(q,new ae(new de(this.e,this.h,H,q,z),z));const x=(0,n.$LF)(z,"dropMetadata")&&G?de.toInternalProviderId(z.identifier.value,G.id):void 0;return this.e.$registerDocumentOnDropEditProvider(q,this.o(W,z),x,(0,n.$LF)(z,"dropMetadata")?G:void 0),this.p(q)}$provideDocumentOnDropEdits(z,W,H,G,q,x){return this.s(z,de,ue=>Promise.resolve(ue.provideDocumentOnDropEdits(W,y.URI.revive(H),G,q,x)),void 0,void 0)}registerMappedEditsProvider(z,W,H){const G=this.t(new ie(this.h,H),z);return this.e.$registerMappedEditsProvider(G,this.o(W,z)),this.p(G)}$provideMappedEdits(z,W,H,G,q){return this.s(z,ie,x=>Promise.resolve(x.provideMappedEdits(W,H,G,q)),null,q)}registerDocumentPasteEditProvider(z,W,H,G){const q=this.q();this.f.set(q,new ae(new L(this.e,this.h,H,q,z),z));const x=L.toInternalProviderId(z.identifier.value,G.id);return this.e.$registerPasteEditProvider(q,this.o(W,z),x,{supportsCopy:!!H.prepareDocumentPaste,supportsPaste:!!H.provideDocumentPasteEdits,copyMimeTypes:G.copyMimeTypes,pasteMimeTypes:G.pasteMimeTypes}),this.p(q)}$prepareDocumentPaste(z,W,H,G,q){return this.s(z,L,x=>x.prepareDocumentPaste(y.URI.revive(W),H,G,q),void 0,q)}$providePasteEdits(z,W,H,G,q,x){return this.s(z,L,ue=>ue.providePasteEdits(W,y.URI.revive(H),G,q,x),void 0,x)}static w(z){return{pattern:z.source,flags:z.flags}}static y(z){return{decreaseIndentPattern:me.w(z.decreaseIndentPattern),increaseIndentPattern:me.w(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?me.w(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?me.w(z.unIndentedLinePattern):void 0}}static z(z){return{beforeText:me.w(z.beforeText),afterText:z.afterText?me.w(z.afterText):void 0,previousLineText:z.previousLineText?me.w(z.previousLineText):void 0,action:z.action}}static B(z){return z.map(me.z)}static C(z){return{open:z.open,close:z.close,notIn:z.notIn?z.notIn.map(W=>M.SyntaxTokenType.toString(W)):void 0}}static D(z){return z.map(me.C)}setLanguageConfiguration(z,W,H){const{wordPattern:G}=H;if(G&&(0,E.$Se)(G))throw new Error(`Invalid language configuration: wordPattern '${G}' is not allowed to match the empty string.`);G?this.h.setWordDefinitionFor(W,G):this.h.setWordDefinitionFor(W,void 0),H.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),H.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const q=this.q(),x={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?me.w(H.wordPattern):void 0,indentationRules:H.indentationRules?me.y(H.indentationRules):void 0,onEnterRules:H.onEnterRules?me.B(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport,autoClosingPairs:H.autoClosingPairs?me.D(H.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(q,W,x),this.p(q)}$setWordDefinitions(z){for(const W of z)this.h.setWordDefinitionFor(W.languageId,new RegExp(W.regexSource,W.regexFlags))}}e.$2dc=me}),define(Pe[255],Ae([1,0,3,8,7,31,14,6,23]),function(we,e,y,T,P,M,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ofc=void 0;class f{constructor(D,u,b,v){this.c=u,this.d=b,this.e=v,this.b=[],this.f=0,this.g=new Set,this.a=D.getProxy(y.$yK.MainThreadLanguages)}$acceptLanguageIds(D){this.b=D}async getLanguages(){return this.b.slice(0)}async changeLanguage(D,u){await this.a.$changeLanguage(D,u);const b=this.c.getDocumentData(D);if(!b)throw new Error(`document '${D.toString()}' NOT found`);return b.document}async tokenAtPosition(D,u){const b=D.version,v=T.Position.from(u),g=await this.a.$tokensAtPosition(D.uri,v),t={type:P.StandardTokenType.Other,range:D.getWordRangeAtPosition(u)??new P.$CK(u.line,u.character,u.line,u.character)};if(!g)return t;const i={range:T.Range.to(g.range),type:T.TokenType.to(g.type)};return!i.range.contains(u)||b!==D.version?t:i}createLanguageStatusItem(D,u,b){const v=this.f++,g=this.a,t=this.g,i=`${D.identifier.value}/${u}`;if(t.has(i))throw new Error(`LanguageStatusItem with id '${u}' ALREADY exists`);t.add(i);const r={selector:b,id:u,name:D.displayName??D.name,severity:P.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let c;const o=new $.$Qc,l=()=>{if(c?.dispose(),!t.has(i)){console.warn(`LanguageStatusItem (${u}) from ${D.identifier.value} has been disposed and CANNOT be updated anymore`);return}c=(0,A.$Zg)(()=>{o.clear(),this.a.$setLanguageStatus(v,{id:i,name:r.name??D.displayName??D.name,source:D.displayName??D.name,selector:T.DocumentSelector.from(r.selector,this.e),label:r.text,detail:r.detail??"",severity:r.severity===P.LanguageStatusSeverity.Error?M.default.Error:r.severity===P.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:r.command&&this.d.toInternal(r.command,o),accessibilityInfo:r.accessibilityInformation,busy:r.busy})},0)},n={dispose(){o.dispose(),c?.dispose(),g.$removeLanguageStatus(v),t.delete(i)},get id(){return r.id},get name(){return r.name},set name(s){r.name=s,l()},get selector(){return r.selector},set selector(s){r.selector=s,l()},get text(){return r.text},set text(s){r.text=s,l()},set text2(s){(0,E.$MF)(D,"languageStatusText"),r.text=s,l()},get text2(){return(0,E.$MF)(D,"languageStatusText"),r.text},get detail(){return r.detail},set detail(s){r.detail=s,l()},get severity(){return r.severity},set severity(s){r.severity=s,l()},get accessibilityInformation(){return r.accessibilityInformation},set accessibilityInformation(s){r.accessibilityInformation=s,l()},get command(){return r.command},set command(s){r.command=s,l()},get busy(){return r.busy},set busy(s){r.busy=s,l()}};return l(),n}}e.$ofc=f}),define(Pe[82],Ae([1,0,21,12,2,4,15,3,27,17]),function(we,e,y,T,P,M,A,$,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nec=e.$Mec=void 0;let C=class{constructor(u,b,v){this.f=v,this.d=new Map,this.a=b.getProxy($.$yK.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===y.$g}getMessage(u,b){const{message:v,args:g,comment:t}=b;if(this.c)return(0,T.$He)(v,g??{});let i=v;t&&t.length>0&&(i+=`/${Array.isArray(t)?t.join(""):t}`);const r=this.d.get(u)?.contents[i];return r||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${i}`),(0,T.$He)(r??v,g??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let b;const v=await this.g(u);if(!v){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const g=await this.a.$fetchBundleContents(v),t=JSON.parse(g);b=u.isBuiltin?t.contents?.bundle:t}catch(g){this.f.error(`Failed to load translations for ${u.identifier.value} from ${v}: ${g.message}`);return}b&&this.d.set(u.identifier.value,{contents:b,uri:v})}async g(u){if(u.isBuiltin){const b=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return P.URI.revive(b)}return u.l10n?P.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Mec=C,e.$Mec=C=Ke([Ve(0,E.$QM),Ve(1,f.$AM),Ve(2,A.$dj)],C),e.$Nec=(0,M.$Vh)("IExtHostLocalizationService")}),define(Pe[256],Ae([1,0,15,3,27,17,2,51]),function(we,e,y,T,P,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zfc=void 0;let E=class extends y.$oj{constructor(D,u){super(u.logLevel,u.logsLocation,u.loggers.map(b=>(0,$.$sh)(b))),this.r=D.getProxy(T.$yK.MainThreadLogger)}$setLogLevel(D,u){u?this.setLogLevel(A.URI.revive(u),D):this.setLogLevel(D)}setVisibility(D,u){super.setVisibility(D,u),this.r.$setVisibility(D,u)}s(D,u,b){return new f(this.r,D,u,b)}};e.$Zfc=E,e.$Zfc=E=Ke([Ve(0,M.$AM),Ve(1,P.$QM)],E);class f extends y.$jj{constructor(D,u,b,v){super(v?.logLevel==="always"),this.r=D,this.s=u,this.m=!1,this.n=[],this.setLevel(b),this.r.$createLogger(u,v).then(()=>{this.u(this.n),this.m=!0})}g(D,u){const b=[[D,u]];this.m?this.u(b):this.n.push(...b)}u(D){this.r.$log(this.s,D)}flush(){this.r.$flush(this.s)}}}),define(Pe[83],Ae([1,0,3,4,6,17,24]),function(we,e,y,T,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pec=e.$Oec=void 0,e.$Oec=(0,T.$Vh)("IExtHostManagedSockets");let $=class{constructor(D){this.b=0,this.c=null,this.d=new Map,this.a=D.getProxy(y.$yK.MainThreadManagedSockets)}setFactory(D,u){for(const b of this.d.values())b.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new E(D,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(D){if(!this.c||this.c.socketFactoryId!==D)throw new Error(`No socket factory with id ${D}`);const u=++this.b,b=await this.c.makeConnection(),v=new P.$Qc;return this.d.set(u,new f(u,b,v)),v.add((0,P.$Pc)(()=>this.d.delete(u))),v.add(b.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),v.dispose()})),v.add(b.onDidClose(g=>{this.a.$onDidManagedSocketClose(u,g?.stack??g?.message),v.dispose()})),v.add(b.onDidReceiveMessage(g=>this.a.$onDidManagedSocketHaveData(u,A.$fe.wrap(g)))),u}$remoteSocketWrite(D,u){this.d.get(D)?.actual.send(u.buffer)}$remoteSocketEnd(D){const u=this.d.get(D);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(D){await this.d.get(D)?.actual.drain?.()}};e.$Pec=$,e.$Pec=$=Ke([Ve(0,M.$AM)],$);class E{constructor(D,u){this.socketFactoryId=D,this.makeConnection=u}}class f extends P.$Rc{constructor(D,u,b){super(),this.socketId=D,this.actual=u,this.B(b)}}}),define(Pe[257],Ae([1,0,3,15,23]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pfc=void 0;function M($){return $&&$.title}let A=class{constructor(E,f){this.b=f,this.a=E.getProxy(y.$yK.MainThreadMessageService)}showMessage(E,f,C,D,u){const b={source:{identifier:E.identifier,label:E.displayName||E.name}};let v;typeof D=="string"||M(D)?v=[D,...u]:(b.modal=D?.modal,b.useCustom=D?.useCustom,b.detail=D?.detail,v=u),b.useCustom&&(0,P.$MF)(E,"resolvers");const g=[];for(let t=0;t<v.length;t++){const i=v[t];if(typeof i=="string")g.push({title:i,handle:t,isCloseAffordance:!1});else if(typeof i=="object"){const{title:r,isCloseAffordance:c}=i;g.push({title:r,isCloseAffordance:!!c,handle:t})}else this.b.warn("Invalid message item:",i)}return this.a.$showMessage(f,C,b,g).then(t=>{if(typeof t=="number")return v[t]})}};e.$pfc=A,e.$pfc=A=Ke([Ve(1,T.$dj)],A)}),define(Pe[258],Ae([1,0,18,14,19,5,6,28,2,22,15,3,32,8,7,78,211,23,49]),function(we,e,y,T,P,M,A,$,E,f,C,D,u,b,v,g,t,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ufc=e.$tfc=void 0;let c=class{constructor(m,S,k,h,w){this.l=S,this.m=k,this.n=h,this.o=w,this.b=new $.$zc,this.c=new $.$zc,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new Map,this.j=0,this.k=new M.$Rd,this.onDidChangeNotebookCellExecutionState=this.k.event,this.a=m.getProxy(D.$yK.MainThreadNotebookKernels);const I=new u.$1M("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.$YM("options","Select kernel options",F=>!0,F=>{if(F&&"notebookEditor"in F&&"id"in F){const V=this.m.getIdByEditor(F.notebookEditor);return{id:F.id,extension:F.extension,notebookEditorId:V}}else if(F&&"notebookEditor"in F){const V=this.m.getIdByEditor(F.notebookEditor);if(V===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${F.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:V}}return F})],u.$ZM.Void);this.n.registerApiCommand(I)}createNotebookController(m,S,k,h,w,I){for(const ve of this.i.values())if(ve.controller.id===S&&f.$_l.equals(m.identifier,ve.extensionId))throw new Error(`notebook controller with id '${S}' ALREADY exist`);const F=this.j++,V=this;this.o.trace(`NotebookController[${F}], CREATED by ${m.identifier.value}, ${S}`);const Z=()=>console.warn(`NO execute handler from notebook controller '${O.id}' of extension: '${m.identifier}'`);let N=!1;const R=new M.$Rd,L=new M.$Rd,O={id:d(m.identifier,S),notebookType:k,extensionId:m.identifier,extensionLocation:m.extensionLocation,label:h||m.identifier.value,preloads:I?I.map(b.NotebookRendererScript.from):[]};let Y=w??Z,he;this.a.$addKernel(F,O).catch(ve=>{console.log(ve),N=!0});let $e=0;const De=()=>{if(N)return;const ve=++$e;Promise.resolve().then(()=>{ve===$e&&this.a.$updateKernel(F,O)})},ke=new $.$zc,fe={get id(){return S},get notebookType(){return O.notebookType},onDidChangeSelectedNotebooks:R.event,get label(){return O.label},set label(ve){O.label=ve??m.displayName??m.name,De()},get detail(){return O.detail??""},set detail(ve){O.detail=ve,De()},get description(){return O.description??""},set description(ve){O.description=ve,De()},get supportedLanguages(){return O.supportedLanguages},set supportedLanguages(ve){O.supportedLanguages=ve,De()},get supportsExecutionOrder(){return O.supportsExecutionOrder??!1},set supportsExecutionOrder(ve){O.supportsExecutionOrder=ve,De()},get rendererScripts(){return O.preloads?O.preloads.map(b.NotebookRendererScript.to):[]},get executeHandler(){return Y},set executeHandler(ve){Y=ve??Z},get interruptHandler(){return he},set interruptHandler(ve){he=ve,O.supportsInterrupt=!!ve,De()},createNotebookCellExecution(ve){if(N)throw new Error("notebook controller is DISPOSED");if(!ke.has(ve.notebook.uri))throw V.o.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ke.keys()).map(te=>te.toString())),new Error(`notebook controller is NOT associated to notebook: ${ve.notebook.uri.toString()}`);return V._createNotebookCellExecution(ve,d(m.identifier,this.id))},createNotebookExecution(ve){if((0,i.$MF)(m,"notebookExecution"),N)throw new Error("notebook controller is DISPOSED");if(!ke.has(ve.uri))throw V.o.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ke.keys()).map(te=>te.toString())),new Error(`notebook controller is NOT associated to notebook: ${ve.uri.toString()}`);return V._createNotebookExecution(ve,d(m.identifier,this.id))},dispose:()=>{N||(this.o.trace(`NotebookController[${F}], DISPOSED`),N=!0,this.i.delete(F),R.dispose(),L.dispose(),this.a.$removeKernel(F))},updateNotebookAffinity(ve,te){te===v.NotebookControllerAffinity2.Hidden&&(0,i.$MF)(m,"notebookControllerAffinityHidden"),V.a.$updateNotebookPriority(F,ve.uri,te)},onDidReceiveMessage:L.event,postMessage(ve,te){return(0,i.$MF)(m,"notebookMessaging"),V.a.$postMessage(F,te&&V.m.getIdByEditor(te),ve)},asWebviewUri(ve){return(0,i.$MF)(m,"notebookMessaging"),(0,g.$$tb)(ve,V.l.remote)}};return this.i.set(F,{extensionId:m.identifier,controller:fe,onDidReceiveMessage:L,onDidChangeSelection:R,associatedNotebooks:ke}),fe}getIdByController(m){for(const[S,k]of this.i)if(k.controller===m)return d(k.extensionId,m.id);return null}createNotebookControllerDetectionTask(m,S){const k=this.f++,h=this;this.o.trace(`NotebookControllerDetectionTask[${k}], CREATED by ${m.identifier.value}`),this.a.$addKernelDetectionTask(k,S);const w={dispose:()=>{this.e.delete(k),h.a.$removeKernelDetectionTask(k)}};return this.e.set(k,w),w}registerKernelSourceActionProvider(m,S,k){const h=this.h++,w=typeof k.onDidChangeNotebookKernelSourceActions=="function"?h:void 0,I=this;this.g.set(h,k),this.o.trace(`NotebookKernelSourceActionProvider[${h}], CREATED by ${m.identifier.value}`),this.a.$addKernelSourceActionProvider(h,h,S);let F;return w!==void 0&&(F=k.onDidChangeNotebookKernelSourceActions(V=>this.a.$emitNotebookKernelSourceActionsChangeEvent(w))),{dispose:()=>{this.g.delete(h),I.a.$removeKernelSourceActionProvider(h,h),F?.dispose()}}}async $provideKernelSourceActions(m,S){const k=this.g.get(m);if(k){const h=new A.$Qc;return(await k.provideNotebookKernelSourceActions(S)??[]).map(I=>b.NotebookKernelSourceAction.from(I,this.n.converter,h))}return[]}$acceptNotebookAssociation(m,S,k){const h=this.i.get(m);if(h){const w=this.m.getNotebookDocument(E.URI.revive(S));k?h.associatedNotebooks.set(w.uri,!0):h.associatedNotebooks.delete(w.uri),this.o.trace(`NotebookController[${m}] ASSOCIATE notebook`,w.uri.toString(),k),h.onDidChangeSelection.fire({selected:k,notebook:w.apiNotebook})}}async $executeCells(m,S,k){const h=this.i.get(m);if(!h)return;const w=this.m.getNotebookDocument(E.URI.revive(S)),I=[];for(const F of k){const V=w.getCell(F);V&&I.push(V.apiCell)}try{this.o.trace(`NotebookController[${m}] EXECUTE cells`,w.uri.toString(),I.length),await h.controller.executeHandler.call(h.controller,I,w.apiNotebook,h.controller)}catch(F){this.o.error(`NotebookController[${m}] execute cells FAILED`,F),console.error(F)}}async $cancelCells(m,S,k){const h=this.i.get(m);if(!h)return;const w=this.m.getNotebookDocument(E.URI.revive(S));if(h.controller.interruptHandler)await h.controller.interruptHandler.call(h.controller,w.apiNotebook);else for(const I of k){const F=w.getCell(I);F&&this.b.get(F.uri)?.cancel()}if(h.controller.interruptHandler){const I=this.c.get(w.uri);k.length&&Array.isArray(I)&&I.length&&I.forEach(F=>F.dispose())}}$acceptKernelMessageFromRenderer(m,S,k){const h=this.i.get(m);if(!h)return;const w=this.m.getEditorById(S);h.onDidReceiveMessage.fire(Object.freeze({editor:w.apiEditor,message:k}))}$cellExecutionChanged(m,S,k){const w=this.m.getNotebookDocument(E.URI.revive(m)).getCell(S);if(w){const I=k?b.NotebookCellExecutionState.to(k):v.NotebookCellExecutionState.Idle;I!==void 0&&this.k.fire({cell:w.apiCell,state:I})}}_createNotebookCellExecution(m,S){if(m.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const h=this.m.getNotebookDocument(m.notebook.uri).getCellFromApiCell(m);if(!h)throw new Error("invalid cell");if(this.b.has(h.uri))throw new Error(`duplicate execution for ${h.uri}`);const w=new l(S,h,this.a);this.b.set(h.uri,w);const I=w.onDidChangeState(()=>{w.state===o.Resolved&&(w.dispose(),I.dispose(),this.b.delete(h.uri))});return w.asApiObject()}_createNotebookExecution(m,S){const k=this.m.getNotebookDocument(m.uri),h=m.getCells().find(F=>{const V=k.getCellFromApiCell(F);return V&&this.b.has(V.uri)});if(h)throw new Error(`duplicate cell execution for ${h.document.uri}`);if(this.c.has(k.uri))throw new Error(`duplicate notebook execution for ${k.uri}`);const w=new s(S,k,this.a),I=w.onDidChangeState(()=>{w.state===n.Resolved&&(w.dispose(),I.dispose(),this.c.delete(k.uri))});return this.c.set(k.uri,[w,I]),w.asApiObject()}};e.$tfc=c,e.$tfc=c=Ke([Ve(4,C.$dj)],c);var o;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})(o||(o={}));class l extends A.$Rc{static{this.a=0}get state(){return this.f}constructor(m,S,k){super(),this.m=S,this.n=k,this.b=l.a++,this.c=new M.$Rd,this.onDidChangeState=this.c.event,this.f=o.Init,this.g=this.B(new P.$2d),this.h=new a(10,h=>this.s(h)),this.j=S.internalMetadata.executionOrder,this.n.$createExecution(this.b,m,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(m){await this.h.addItem(m)}async s(m){const S=Array.isArray(m)?m:[m];return this.n.$updateExecution(this.b,new r.$wv(S))}t(){if(this.f===o.Init)throw new Error("Must call start before modifying cell output");if(this.f===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(m){let S=this.m;if(m&&(S=this.m.notebook.getCellFromApiCell(m)),!S)throw new Error("INVALID cell");return S.handle}y(m){return m.map(S=>{const k=v.$2L.ensureUniqueMimeTypes(S.items,!0);return k===S.items?b.NotebookCellOutput.from(S):b.NotebookCellOutput.from({items:k,id:S.id,metadata:S.metadata})})}async z(m,S,k){const h=this.w(S),w=this.y((0,y.$2b)(m));return this.r({editType:t.CellExecutionUpdateType.Output,cellHandle:h,append:k,outputs:w})}async C(m,S,k){return m=v.$2L.ensureUniqueMimeTypes((0,y.$2b)(m),!0),this.r({editType:t.CellExecutionUpdateType.OutputItems,items:m.map(b.NotebookCellOutputItem.from),outputId:S.id,append:k})}asApiObject(){const m=this;return Object.freeze({get token(){return m.g.token},get cell(){return m.m.apiCell},get executionOrder(){return m.j},set executionOrder(k){m.j=k,m.s([{editType:t.CellExecutionUpdateType.ExecutionState,executionOrder:m.j}])},start(k){if(m.f===o.Resolved||m.f===o.Started)throw new Error("Cannot call start again");m.f=o.Started,m.c.fire(),m.s({editType:t.CellExecutionUpdateType.ExecutionState,runStartTime:k})},end(k,h){if(m.f===o.Resolved)throw new Error("Cannot call resolve twice");m.f=o.Resolved,m.c.fire(),m.h.flush(),m.n.$completeExecution(m.b,new r.$wv({runEndTime:h,lastRunSuccess:k}))},clearOutput(k){return m.t(),m.z([],k,!1)},appendOutput(k,h){return m.t(),m.z(k,h,!0)},replaceOutput(k,h){return m.t(),m.z(k,h,!1)},appendOutputItems(k,h){return m.t(),m.C(k,h,!0)},replaceOutputItems(k,h){return m.t(),m.C(k,h,!1)}})}}var n;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})(n||(n={}));class s extends A.$Rc{static{this.a=0}get state(){return this.f}constructor(m,S,k){super(),this.h=S,this.j=k,this.b=s.a++,this.c=new M.$Rd,this.onDidChangeState=this.c.event,this.f=n.Init,this.g=this.B(new P.$2d),this.j.$createNotebookExecution(this.b,m,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===n.Resolved||this.f===n.Started)throw new Error("Cannot call start again");this.f=n.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===n.Resolved)throw new Error("Cannot call resolve twice");this.f=n.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class a{constructor(m,S){this.e=m,this.f=S,this.a=[],this.b=Date.now()}addItem(m){return this.a.push(m),this.c||(this.c=new T.$ih,this.b=Date.now(),(0,T.$Yg)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const m=this.c;this.c=void 0;const S=this.a;return this.a=[],this.f(S).finally(()=>m.complete())}}function d(p,m){return`${p.value}/${m}`}e.$ufc=d}),define(Pe[259],Ae([1,0,5,3,107]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vfc=void 0;class M{constructor($,E){this.c=E,this.a=new Map,this.b=$.getProxy(T.$yK.MainThreadNotebookRenderers)}$postRendererMessage($,E,f){const C=this.c.getEditorById($);this.a.get(E)?.fire({editor:C.apiEditor,message:f})}createRendererMessaging($,E){if(!$.contributes?.notebookRenderer?.some(C=>C.id===E))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${E})`);return{onDidReceiveMessage:(C,D,u)=>this.d(E).event(C,D,u),postMessage:(C,D)=>{P.$bfc.apiEditorsToExtHost.has(C)&&([C,D]=[D,C]);const u=D&&P.$bfc.apiEditorsToExtHost.get(D);return this.b.$postMessage(u?.id,E,C)}}}d($){let E=this.a.get($);return E||(E=new y.$Rd({onDidRemoveLastListener:()=>{E?.dispose(),this.a.delete($)}}),this.a.set($,E),E)}}e.$vfc=M}),define(Pe[260],Ae([1,0,6,16,2,23,3]),function(we,e,y,T,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yfc=void 0;class ${constructor(f){this.b=new Map,this.a=f.getProxy(A.$yK.MainThreadProfileContentHandlers)}registrProfileContentHandler(f,C,D){if((0,M.$MF)(f,"profileContentHandlers"),this.b.has(C))throw new Error(`Handler with id '${C}' already registered`);return this.b.set(C,D),this.a.$registerProfileContentHandler(C,D.name,D.description,f.identifier.value),(0,y.$Pc)(()=>{this.b.delete(C),this.a.$unregisterProfileContentHandler(C)})}async $saveProfile(f,C,D,u){const b=this.b.get(f);if(!b)throw new Error(`Unknown handler with id: ${f}`);return b.saveProfile(C,D,u)}async $readProfile(f,C,D){const u=this.b.get(f);if(!u)throw new Error(`Unknown handler with id: ${f}`);return u.readProfile((0,T.$Cf)(C)?C:P.URI.revive(C),D)}}e.$yfc=$}),define(Pe[261],Ae([1,0,2,3,14,8]),function(we,e,y,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Afc=void 0;class A{static{this.a=0}constructor(E,f){this.d=f,this.c=new Map,this.b=E.getProxy(T.$yK.MainThreadQuickDiff)}$provideOriginalResource(E,f,C){const D=y.URI.revive(f),u=this.c.get(E);return u?(0,P.$Qg)(()=>u.provideOriginalResource(D,C)).then(b=>b||null):Promise.resolve(null)}registerQuickDiffProvider(E,f,C,D){const u=A.a++;return this.c.set(u,f),this.b.$registerQuickDiffProvider(u,M.DocumentSelector.from(E,this.d),C,D),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$Afc=A}),define(Pe[262],Ae([1,0,19,5,6,3,2,7,11,18,31,45,23,8]),function(we,e,y,T,P,M,A,$,E,f,C,D,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bfc=void 0;function v(g,t,i){const r=g.getProxy(M.$yK.MainThreadQuickOpen);class c{constructor(S,k){this.e=new Map,this.f=0,this.a=S,this.b=k}showQuickPick(S,k,h,w=y.CancellationToken.None){this.c=void 0;const I=Promise.resolve(k),F=++this.f,V=r.$show(F,{title:h?.title,placeHolder:h?.placeHolder,matchOnDescription:h?.matchOnDescription,matchOnDetail:h?.matchOnDetail,ignoreFocusLost:h?.ignoreFocusOut,canPickMany:h?.canPickMany},w),Z={},N=V.then(()=>Z);return Promise.race([N,I]).then(R=>{if(R===Z)return;const L=(0,u.$LF)(S,"quickPickItemTooltip");return I.then(O=>{const Y=[];for(let he=0;he<O.length;he++){const $e=O[he];if(typeof $e=="string")Y.push({label:$e,handle:he});else if($e.kind===$.QuickPickItemKind.Separator)Y.push({type:"separator",label:$e.label});else{$e.tooltip&&!L&&console.warn(`Extension '${S.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${S.identifier.value}`);const De=$e.iconPath?a($e.iconPath):void 0;Y.push({label:$e.label,iconPath:De?.iconPath,iconClass:De?.iconClass,description:$e.description,detail:$e.detail,picked:$e.picked,alwaysShow:$e.alwaysShow,tooltip:L?b.MarkdownString.fromStrict($e.tooltip):void 0,handle:he})}}return h&&typeof h.onDidSelectItem=="function"&&(this.c=he=>{h.onDidSelectItem(O[he])}),r.$setItems(F,Y),V.then(he=>{if(typeof he=="number")return O[he];if(Array.isArray(he))return he.map($e=>O[$e])})})}).then(void 0,R=>{if(!(0,E.$3)(R))return r.$setError(F,R),Promise.reject(R)})}$onItemSelected(S){this.c?.(S)}showInput(S,k=y.CancellationToken.None){return this.d=S?.validateInput,r.$input(S,typeof this.d=="function",k).then(void 0,h=>{if(!(0,E.$3)(h))return Promise.reject(h)})}async $validateInput(S){if(!this.d)return;const k=await this.d(S);if(!k||typeof k=="string")return k;let h;switch(k.severity){case $.InputBoxValidationSeverity.Info:h=C.default.Info;break;case $.InputBoxValidationSeverity.Warning:h=C.default.Warning;break;case $.InputBoxValidationSeverity.Error:h=C.default.Error;break;default:h=k.message?C.default.Error:C.default.Ignore;break}return{content:k.message,severity:h}}async showWorkspaceFolderPick(S,k=y.CancellationToken.None){const h=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[S]);if(!h)return;const w=await this.a.getWorkspaceFolders2();if(w)return w.find(I=>I.uri.toString()===h.uri.toString())}createQuickPick(S){const k=new d(S,()=>this.e.delete(k._id));return this.e.set(k._id,k),k}createInputBox(S){const k=new p(S,()=>this.e.delete(k._id));return this.e.set(k._id,k),k}$onDidChangeValue(S,k){this.e.get(S)?._fireDidChangeValue(k)}$onDidAccept(S){this.e.get(S)?._fireDidAccept()}$onDidChangeActive(S,k){const h=this.e.get(S);h instanceof d&&h._fireDidChangeActive(k)}$onDidChangeSelection(S,k){const h=this.e.get(S);h instanceof d&&h._fireDidChangeSelection(k)}$onDidTriggerButton(S,k){this.e.get(S)?._fireDidTriggerButton(k)}$onDidTriggerItemButton(S,k,h){const w=this.e.get(S);w instanceof d&&w._fireDidTriggerItemButton(k,h)}$onDidHide(S){this.e.get(S)?._fireDidHide()}}class o{static{this.a=1}constructor(S,k){this.x=S,this.y=k,this._id=d.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new T.$Rd,this.q=new T.$Rd,this.r=new T.$Rd,this.s=new T.$Rd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(S){this.b=S,this.z({title:S})}get step(){return this.c}set step(S){this.c=S,this.z({step:S})}get totalSteps(){return this.d}set totalSteps(S){this.d=S,this.z({totalSteps:S})}get enabled(){return this.g}set enabled(S){this.g=S,this.z({enabled:S})}get busy(){return this.j}set busy(S){this.j=S,this.z({busy:S})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(S){this.k=S,this.z({ignoreFocusOut:S})}get value(){return this.l}set value(S){this.l=S,this.z({value:S})}get placeholder(){return this.m}set placeholder(S){this.m=S,this.z({placeholder:S})}get buttons(){return this.n}set buttons(S){this.n=S.slice(),this.o.clear(),S.forEach((k,h)=>{const w=k===$.$UL.Back?-1:h;this.o.set(w,k)}),this.z({buttons:S.map((k,h)=>({...a(k.iconPath),tooltip:k.tooltip,handle:k===$.$UL.Back?-1:h}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(S){this.l=S,this.q.fire(S)}_fireDidTriggerButton(S){const k=this.o.get(S);k&&this.r.fire(k)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,P.$Mc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),r.$dispose(this._id))}z(S){if(!this.v){for(const k of Object.keys(S)){const h=S[k];this.u[k]=h===void 0?null:h}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){r.$createOrUpdate(this.u),this.u={id:this._id}}}function l(m){if(m instanceof $.$uL)return{id:m.id};const S=s(m),k=n(m);return{dark:typeof S=="string"?A.URI.file(S):S,light:typeof k=="string"?A.URI.file(k):k}}function n(m){return typeof m=="object"&&"light"in m?m.light:m}function s(m){return typeof m=="object"&&"dark"in m?m.dark:m}function a(m){const S=l(m);let k,h;return"id"in S?h=D.ThemeIcon.asClassName(S):k=S,{iconPath:k,iconClass:h}}class d extends o{constructor(S,k){super(S.identifier,k),this.O=S,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new T.$Rd,this.L=[],this.M=new T.$Rd,this.N=new T.$Rd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(S){this.B=S.slice(),this.C.clear(),this.D.clear(),S.forEach((w,I)=>{this.C.set(I,w),this.D.set(w,I)});const k=(0,u.$LF)(this.O,"quickPickItemTooltip"),h=[];for(let w=0;w<S.length;w++){const I=S[w];if(I.kind===$.QuickPickItemKind.Separator)h.push({type:"separator",label:I.label});else{I.tooltip&&!k&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const F=I.iconPath?a(I.iconPath):void 0;h.push({handle:w,label:I.label,iconPath:F?.iconPath,iconClass:F?.iconClass,description:I.description,detail:I.detail,picked:I.picked,alwaysShow:I.alwaysShow,tooltip:k?b.MarkdownString.fromStrict(I.tooltip):void 0,buttons:I.buttons?.map((V,Z)=>({...a(V.iconPath),tooltip:V.tooltip,handle:Z}))})}}this.z({items:h})}get canSelectMany(){return this.E}set canSelectMany(S){this.E=S,this.z({canSelectMany:S})}get matchOnDescription(){return this.F}set matchOnDescription(S){this.F=S,this.z({matchOnDescription:S})}get matchOnDetail(){return this.G}set matchOnDetail(S){this.G=S,this.z({matchOnDetail:S})}get sortByLabel(){return this.H}set sortByLabel(S){this.H=S,this.z({sortByLabel:S})}get keepScrollPosition(){return this.I}set keepScrollPosition(S){this.I=S,this.z({keepScrollPosition:S})}get activeItems(){return this.J}set activeItems(S){this.J=S.filter(k=>this.D.has(k)),this.z({activeItems:this.J.map(k=>this.D.get(k))})}get selectedItems(){return this.L}set selectedItems(S){this.L=S.filter(k=>this.D.has(k)),this.z({selectedItems:this.L.map(k=>this.D.get(k))})}_fireDidChangeActive(S){const k=(0,f.$Gb)(S.map(h=>this.C.get(h)));this.J=k,this.K.fire(k)}_fireDidChangeSelection(S){const k=(0,f.$Gb)(S.map(h=>this.C.get(h)));this.L=k,this.M.fire(k)}_fireDidTriggerItemButton(S,k){const h=this.C.get(S);if(!h||!h.buttons||!h.buttons.length)return;const w=h.buttons[k];w&&this.N.fire({button:w,item:h})}}class p extends o{constructor(S,k){super(S.identifier,k),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(S){this.B=S,this.z({password:S})}get prompt(){return this.C}set prompt(S){this.C=S,this.z({prompt:S})}get valueSelection(){return this.D}set valueSelection(S){this.D=S,this.z({valueSelection:S})}get validationMessage(){return this.E}set validationMessage(S){this.E=S,S?typeof S=="string"?this.z({validationMessage:S,severity:C.default.Error}):this.z({validationMessage:S.message,severity:S.severity??C.default.Error}):this.z({validationMessage:void 0,severity:C.default.Ignore})}}return new c(t,i)}e.$Bfc=v}),define(Pe[263],Ae([1,0,2,5,66,6,14,3,18,138,15,19,22,45,8,23,13,21]),function(we,e,y,T,P,M,A,$,E,f,C,D,u,b,v,g,t,i){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$Dfc=e.$Cfc=void 0;function c(N){return N instanceof y.URI}function o(N,R){return N.scheme===t.Schemas.file&&R.scheme===t.Schemas.file&&i.$k?N.toString()===R.toString():N.toString().toLowerCase()===R.toString().toLowerCase()}function l(N){if(N)return typeof N.iconPath=="string"?y.URI.file(N.iconPath):y.URI.isUri(N.iconPath)||b.ThemeIcon.isThemeIcon(N.iconPath)?N.iconPath:void 0}function n(N){if(N?.icon){if(y.URI.isUri(N.icon))return N.icon;if(b.ThemeIcon.isThemeIcon(N.icon))return N.icon;{const R=N.icon;return{light:R.light,dark:R.dark}}}else return}function s(N){if(N.icon){if(y.URI.isUri(N.icon))return N.icon;if(b.ThemeIcon.isThemeIcon(N.icon))return N.icon;{const R=N.icon;return{light:R.light,dark:R.dark}}}else return}function a(N){if(N.icon){if(y.URI.isUri(N.icon))return N.icon;if(b.ThemeIcon.isThemeIcon(N.icon))return N.icon;{const R=N.icon;return{light:R.light,dark:R.dark}}}else return}function d(N,R){if(!N.iconPath&&!R.iconPath)return 0;if(N.iconPath){if(!R.iconPath)return 1}else return-1;const L=typeof N.iconPath=="string"?N.iconPath:y.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id,O=typeof R.iconPath=="string"?R.iconPath:y.URI.isUri(R.iconPath)?R.iconPath.fsPath:R.iconPath.id;return(0,f.$xq)(L,O)}function p(N,R){let L=0;if(N.strikeThrough!==R.strikeThrough)return N.strikeThrough?1:-1;if(N.faded!==R.faded)return N.faded?1:-1;if(N.tooltip!==R.tooltip)return(N.tooltip||"").localeCompare(R.tooltip||"");if(L=d(N,R),L!==0)return L;if(N.light&&R.light)L=d(N.light,R.light);else{if(N.light)return 1;if(R.light)return-1}if(L!==0)return L;if(N.dark&&R.dark)L=d(N.dark,R.dark);else{if(N.dark)return 1;if(R.dark)return-1}return L}function m(N,R){if(N.command!==R.command)return N.command<R.command?-1:1;if(N.title!==R.title)return N.title<R.title?-1:1;if(N.tooltip!==R.tooltip){if(N.tooltip!==void 0&&R.tooltip!==void 0)return N.tooltip<R.tooltip?-1:1;if(N.tooltip!==void 0)return 1;if(R.tooltip!==void 0)return-1}if(N.arguments===R.arguments)return 0;if(N.arguments)if(R.arguments){if(N.arguments.length!==R.arguments.length)return N.arguments.length-R.arguments.length}else return 1;else return-1;for(let L=0;L<N.arguments.length;L++){const O=N.arguments[L],Y=R.arguments[L];if(O!==Y&&!(c(O)&&c(Y)&&o(O,Y)))return O<Y?-1:1}return 0}function S(N,R){let L=(0,f.$xq)(N.resourceUri.fsPath,R.resourceUri.fsPath,!0);if(L!==0)return L;if(N.command&&R.command)L=m(N.command,R.command);else{if(N.command)return 1;if(R.command)return-1}if(L!==0)return L;if(N.decorations&&R.decorations)L=p(N.decorations,R.decorations);else{if(N.decorations)return 1;if(R.decorations)return-1}return L}function k(N,R){for(let L=0;L<N.length;L++)if(N[L]!==R[L])return!1;return!0}function h(N,R){return N.command===R.command&&N.title===R.title&&N.tooltip===R.tooltip&&(N.arguments&&R.arguments?k(N.arguments,R.arguments):N.arguments===R.arguments)}function w(N,R){return(0,E.$tb)(N,R,h)}class I{#e;#t;get value(){return this.d}set value(R){R=R??"",this.#e.$setInputBoxValue(this.o,R),this.q(R)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(R){this.#e.$setInputBoxPlaceholder(this.o,R),this.f=R}get validateInput(){return(0,g.$MF)(this.m,"scmValidation"),this.g}set validateInput(R){if((0,g.$MF)(this.m,"scmValidation"),R&&typeof R!="function")throw new Error(`[${this.m.identifier.value}]: Invalid SCM input box validation function`);this.g=R,this.#e.$setValidationProviderIsEnabled(this.o,!!R)}get enabled(){return this.h}set enabled(R){R=!!R,this.h!==R&&(this.h=R,this.#e.$setInputBoxEnablement(this.o,R))}get visible(){return this.j}set visible(R){R=!!R,this.j!==R&&(this.j=R,this.#e.$setInputBoxVisibility(this.o,R))}get actionButton(){return(0,g.$MF)(this.m,"scmInputBoxActionButton"),this.k}set actionButton(R){(0,g.$MF)(this.m,"scmInputBoxActionButton"),this.l.value=new M.$Qc,this.k=R;const L=R!==void 0?{command:this.n.converter.toInternal(R.command,this.l.value),icon:n(R),enabled:R.enabled}:void 0;this.#e.$setInputBoxActionButton(this.o,L??null)}get document(){return(0,g.$MF)(this.m,"scmTextDocument"),this.#t.getDocument(this.p)}constructor(R,L,O,Y,he,$e){this.m=R,this.n=L,this.o=he,this.p=$e,this.d="",this.e=new T.$Rd,this.f="",this.h=!0,this.j=!0,this.l=new M.$Sc,this.#t=O,this.#e=Y}showValidationMessage(R,L){(0,g.$MF)(this.m,"scmValidation"),this.#e.$showValidationMessage(this.o,R,L)}$onInputBoxValueChange(R){this.q(R)}q(R){this.d=R,this.e.fire(R)}}e.$Cfc=I;class F{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(R){this.v=R,this.q.$updateGroupLabel(this.t,this.handle,R)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(R){this.p=R,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(R){this.f=[...R],this.k.fire()}constructor(R,L,O,Y,he){this.q=R,this.s=L,this.t=O,this.u=Y,this.v=he,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new T.$Rd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new T.$Rd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=F.d++}getResourceState(R){return this.g.get(R)}$executeResourceCommand(R,L){const O=this.h.get(R);return O?(0,A.$Qg)(()=>this.s.executeCommand(O.command,...O.arguments||[],L)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const R=[...this.f].sort(S),O=(0,E.$Cb)(this.o,R,S).map($e=>{const De=$e.toInsert.map(ke=>{const fe=this.e++;this.g.set(fe,ke);const ve=ke.resourceUri;let te;if(ke.command)if(ke.command.command==="vscode.open"||ke.command.command==="vscode.diff"||ke.command.command==="vscode.changes"){const ye=new M.$Qc;te=this.s.converter.toInternal(ke.command,ye),this.j.set(fe,ye)}else this.h.set(fe,ke.command);const Re=l(ke.decorations),se=ke.decorations&&l(ke.decorations.light)||Re,Q=ke.decorations&&l(ke.decorations.dark)||Re,B=[se,Q],ne=ke.decorations&&ke.decorations.tooltip||"",pe=ke.decorations&&!!ke.decorations.strikeThrough,re=ke.decorations&&!!ke.decorations.faded,le=ke.contextValue||"";return{rawResource:[fe,ve,B,ne,pe,re,le,te],handle:fe}});return{start:$e.start,deleteCount:$e.deleteCount,toInsert:De}}),Y=O.map(({start:$e,deleteCount:De,toInsert:ke})=>[$e,De,ke.map(fe=>fe.rawResource)]),he=O.reverse();for(const{start:$e,deleteCount:De,toInsert:ke}of he){const fe=ke.map(te=>te.handle),ve=this.n.splice($e,De,...fe);for(const te of ve)this.g.delete(te),this.h.delete(te),this.j.get(te)?.dispose(),this.j.delete(te)}return this.o=R,Y}dispose(){this.l=!0,this.m.fire()}}class V{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(R){this.g!==R&&(this.g=R,this.#e.$updateSourceControl(this.x,{count:R}))}get quickDiffProvider(){return this.h}set quickDiffProvider(R){this.h=R;let L;(0,g.$LF)(this.y,"quickDiffProvider")&&(L=R?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!R,quickDiffLabel:L})}get historyProvider(){return(0,g.$MF)(this.y,"scmHistoryProvider"),this.j}set historyProvider(R){(0,g.$MF)(this.y,"scmHistoryProvider"),this.j=R,this.k.value=new M.$Qc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!R}),R&&(this.k.value.add(R.onDidChangeCurrentHistoryItemGroup(()=>{this.l=R?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l)})),this.k.value.add(R.onDidChangeActionButton(()=>{(0,g.$MF)(this.y,"scmActionButton"),this.m.value=new M.$Qc;const L=R.actionButton!==void 0?{command:this.z.converter.toInternal(R.actionButton.command,this.m.value),description:R.actionButton.description,enabled:R.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,L??null)})))}get commitTemplate(){return this.n}set commitTemplate(R){R!==this.n&&(this.n=R,this.#e.$updateSourceControl(this.x,{commitTemplate:R}))}get acceptInputCommand(){return this.p}set acceptInputCommand(R){this.o.value=new M.$Qc,this.p=R;const L=this.z.converter.toInternal(R,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:L})}get actionButton(){return(0,g.$MF)(this.y,"scmActionButton"),this.s}set actionButton(R){(0,g.$MF)(this.y,"scmActionButton"),this.q.value=new M.$Qc,this.s=R;const L=R!==void 0?{command:this.z.converter.toInternal(R.command,this.q.value),secondaryCommands:R.secondaryCommands?.map(O=>O.map(Y=>this.z.converter.toInternal(Y,this.q.value))),description:R.description,enabled:R.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:L??null})}get statusBarCommands(){return this.u}set statusBarCommands(R){if(this.u&&R&&w(this.u,R))return;this.t.value=new M.$Qc,this.u=R;const L=(R||[]).map(O=>this.z.converter.toInternal(O,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:L})}get selected(){return this.v}constructor(R,L,O,Y,he,$e,De){this.y=R,this.z=Y,this.A=he,this.B=$e,this.C=De,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new M.$Sc,this.m=new M.$Sc,this.n=void 0,this.o=new M.$Sc,this.p=void 0,this.q=new M.$Sc,this.t=new M.$Sc,this.u=void 0,this.v=!1,this.w=new T.$Rd,this.onDidChangeSelection=this.w.event,this.x=V.d++,this.D=new Map,this.E=new Set,this.#e=O;const ke=y.URI.from({scheme:t.Schemas.vscodeSourceControl,path:`${he}/scm${this.x}/input`,query:De?`rootUri=${encodeURIComponent(De.toString())}`:void 0});this.f=new I(R,Y,L,this.#e,this.x,ke),this.#e.$registerSourceControl(this.x,he,$e,De,ke)}createResourceGroup(R,L){const O=new F(this.#e,this.z,this.x,R,L),Y=T.Event.once(O.onDidDispose)(()=>this.D.delete(O));return this.D.set(O,Y),this.eventuallyAddResourceGroups(),O}eventuallyAddResourceGroups(){const R=[],L=[];for(const[O,Y]of this.D){Y.dispose();const he=O.onDidUpdateResourceStates(()=>{this.E.add(O),this.eventuallyUpdateResourceStates()});T.Event.once(O.onDidDispose)(()=>{this.E.delete(O),he.dispose(),this.e.delete(O.handle),this.#e.$unregisterGroup(this.x,O.handle)}),R.push([O.handle,O.id,O.label,O.features]);const $e=O._takeResourceStateSnapshot();$e.length>0&&L.push([O.handle,$e]),this.e.set(O.handle,O)}this.#e.$registerGroups(this.x,R,L),this.D.clear()}eventuallyUpdateResourceStates(){const R=[];this.E.forEach(L=>{const O=L._takeResourceStateSnapshot();O.length!==0&&R.push([L.handle,O])}),R.length>0&&this.#e.$spliceResourceStates(this.x,R),this.E.clear()}getResourceGroup(R){return this.e.get(R)}setSelectionState(R){this.v=R,this.w.fire(R)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(R=>R.dispose()),this.#e.$unregisterSourceControl(this.x)}}Ke([(0,P.$oh)(100)],V.prototype,"eventuallyAddResourceGroups",null),Ke([(0,P.$oh)(100)],V.prototype,"eventuallyUpdateResourceStates",null);let Z=class{static{r=this}static{this.d=0}static{this.e=0}get onDidChangeActiveProvider(){return this.k.event}constructor(R,L,O,Y){this.n=L,this.o=O,this.p=Y,this.h=new Map,this.j=new u.$bm,this.k=new T.$Rd,this.l=new Map,this.f=R.getProxy($.$yK.MainThreadSCM),this.g=R.getProxy($.$yK.MainThreadTelemetry),L.registerArgumentProcessor({processArgument:he=>{if(he&&he.$mid===3){const $e=this.h.get(he.sourceControlHandle);if(!$e)return he;const De=$e.getResourceGroup(he.groupHandle);return De?De.getResourceState(he.handle):he}else if(he&&he.$mid===4){const $e=this.h.get(he.sourceControlHandle);return $e?$e.getResourceGroup(he.groupHandle):he}else if(he&&he.$mid===5){const $e=this.h.get(he.handle);return $e||he}return he}})}createSourceControl(R,L,O,Y){this.p.trace("ExtHostSCM#createSourceControl",R.identifier.value,L,O,Y),this.g.$publicLog2("api/scm/createSourceControl",{extensionId:R.identifier.value});const he=r.d++,$e=new V(R,this.o,this.f,this.n,L,O,Y);this.h.set(he,$e);const De=this.j.get(R.identifier)||[];return De.push($e),this.j.set(R.identifier,De),$e}registerSourceControlInputBoxValueProvider(R,L){this.p.trace("ExtHostSCM#registerSourceControlInputBoxValueProvider",R.identifier.value,L.label);const O=r.e++;return this.l.set(O,L),this.f.$registerSourceControlInputBoxValueProvider(O,L.label,a(L)),(0,M.$Pc)(()=>{this.f.$unregisterSourceControlInputBoxValueProvider(O),this.l.delete(O)})}async $provideInputBoxValue(R,L,O){const Y=this.l.get(R);if(Y)return await Y.provideValue(L,O,D.CancellationToken.None)??void 0}getLastInputBox(R){this.p.trace("ExtHostSCM#getLastInputBox",R.identifier.value);const L=this.j.get(R.identifier),O=L&&L[L.length-1];return O&&O.inputBox}$provideOriginalResource(R,L,O){const Y=y.URI.revive(L);this.p.trace("ExtHostSCM#$provideOriginalResource",R,Y.toString());const he=this.h.get(R);return!he||!he.quickDiffProvider||!he.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$Qg)(()=>he.quickDiffProvider.provideOriginalResource(Y,O)).then($e=>$e||null)}$onInputBoxValueChange(R,L){this.p.trace("ExtHostSCM#$onInputBoxValueChange",R);const O=this.h.get(R);return O&&O.inputBox.$onInputBoxValueChange(L),Promise.resolve(void 0)}$executeResourceCommand(R,L,O,Y){this.p.trace("ExtHostSCM#$executeResourceCommand",R,L,O);const he=this.h.get(R);if(!he)return Promise.resolve(void 0);const $e=he.getResourceGroup(L);return $e?$e.$executeResourceCommand(O,Y):Promise.resolve(void 0)}$validateInput(R,L,O){this.p.trace("ExtHostSCM#$validateInput",R);const Y=this.h.get(R);return!Y||!Y.inputBox.validateInput?Promise.resolve(void 0):(0,A.$Qg)(()=>Y.inputBox.validateInput(L,O)).then(he=>{if(!he)return Promise.resolve(void 0);const $e=v.MarkdownString.fromStrict(he.message);return $e?Promise.resolve([$e,he.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(R){return this.p.trace("ExtHostSCM#$setSelectedSourceControl",R),R!==void 0&&this.h.get(R)?.setSelectionState(!0),this.m!==void 0&&this.h.get(this.m)?.setSelectionState(!1),this.m=R,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(R,L,O){return await this.h.get(R)?.historyProvider?.resolveHistoryItemGroupBase(L,O)??void 0}async $resolveHistoryItemGroupCommonAncestor(R,L,O,Y){return await this.h.get(R)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(L,O,Y)??void 0}async $provideHistoryItems(R,L,O,Y){return(await this.h.get(R)?.historyProvider?.provideHistoryItems(L,O,Y))?.map(De=>({...De,icon:s(De)}))??void 0}async $provideHistoryItemChanges(R,L,O){return await this.h.get(R)?.historyProvider?.provideHistoryItemChanges(L,O)??void 0}};e.$Dfc=Z,e.$Dfc=Z=r=Ke([Ve(3,C.$dj)],Z)}),define(Pe[84],Ae([1,0,3,5,4]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kec=e.$Jec=void 0;class M{constructor($){this.b=new T.$Rd,this.onDidChangePassword=this.b.event,this.a=$.getProxy(y.$yK.MainThreadSecretState)}async $onDidChangePassword($){this.b.fire($)}get($,E){return this.a.$getPassword($,E)}store($,E,f){return this.a.$setPassword($,E,f)}delete($,E){return this.a.$deletePassword($,E)}}e.$Jec=M,e.$Kec=(0,P.$Vh)("IExtHostSecretState")}),define(Pe[264],Ae([1,0,3,8,2]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Efc=void 0;class M{static{this.a=0}constructor($,E){this.d=E,this.c=new Map,this.b=$.getProxy(y.$yK.MainThreadShare)}async $provideShare($,E,f){return await this.c.get($)?.provideShare({selection:T.Range.to(E.selection),resourceUri:P.URI.revive(E.resourceUri)},f)??void 0}registerShareProvider($,E){const f=M.a++;return this.c.set(f,E),this.b.$registerShareProvider(f,T.DocumentSelector.from($,this.d),E.id,E.label,E.priority),{dispose:()=>{this.b.$unregisterShareProvider(f),this.c.delete(f)}}}}e.$Efc=M}),define(Pe[265],Ae([1,0,19,6,3]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ffc=void 0;class M{static{this.a=1}constructor($){this.c=new Map,this.d=new Map,this.b=$.getProxy(P.$yK.MainThreadSpeech)}async $createSpeechToTextSession($,E){const f=this.c.get($);if(!f)return;const C=new T.$Qc,D=new y.$2d;this.d.set(E,D);const u=C.add(f.provideSpeechToTextSession(D.token));C.add(u.onDidChange(b=>{D.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(E,b)})),C.add(D.token.onCancellationRequested(()=>C.dispose()))}async $cancelSpeechToTextSession($){this.d.get($)?.dispose(!0),this.d.delete($)}registerProvider($,E,f){const C=M.a++;return this.c.set(C,f),this.b.$registerProvider(C,E,{extension:$,displayName:$.value}),(0,T.$Pc)(()=>{this.b.$unregisterProvider(C),this.c.delete(C)})}}e.$Ffc=M}),define(Pe[266],Ae([1,0,7,3,164,6,8,16]),function(we,e,y,T,P,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hfc=e.$Gfc=void 0;class E{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new y.$vL("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new y.$vL("statusBarItem.warningForeground")]])}#e;#t;constructor(u,b,v,g,t,i=y.StatusBarAlignment.Left,r){if(this.i=!1,this.k="",this.q=new M.$Qc,this.#e=u,this.#t=b,t&&g){this.c=(0,y.$$K)(g.identifier,t);const c=v.get(this.c);c&&(i=c.alignLeft?y.StatusBarAlignment.Left:y.StatusBarAlignment.Right,r=c.priority,this.j=!0,this.name=c.name,this.text=c.text,this.tooltip=c.tooltip,this.command=c.command,this.accessibilityInformation=c.accessibilityInformation)}else this.c=String(E.a++);this.e=g,this.f=t,this.g=i,this.h=this.u(r)}u(u){if((0,$.$Gf)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(u){this.k=u,this.v()}set name(u){this.m=u,this.v()}set tooltip(u){this.l=u,this.v()}set color(u){this.n=u,this.v()}set backgroundColor(u){u&&!E.b.has(u.id)&&(u=void 0),this.o=u,this.v()}set command(u){this.r?.fromApi!==u&&(this.p&&this.q.add(this.p),this.p=new M.$Qc,typeof u=="string"?this.r={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this.p)}:u?this.r={fromApi:u,internal:this.#t.toInternal(u,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(u){this.t=u,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let u;this.e?this.f?u=`${this.e.identifier.value}.${this.f}`:u=this.e.identifier.value:u=this.f;let b;this.m?b=this.m:b=(0,P.localize)(0,null,this.e.displayName||this.e.name);let v=this.n;this.o&&(v=E.b.get(this.o.id));const g=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,u,this.e?.identifier.value,b,this.k,g,this.r?.internal,v,this.o,this.g===y.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Gfc=E;class f{constructor(u){this.b=[],this.a=u.createStatusBarEntry(void 0,"status.extensionMessage",y.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,P.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(u){const b={message:u};return this.b.unshift(b),this.c(),new y.$AK(()=>{const v=this.b.indexOf(b);v>=0&&(this.b.splice(v,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class C{constructor(u,b){this.e=new Map,this.a=u.getProxy(T.$yK.MainThreadStatusBar),this.b=b,this.c=new f(this)}$acceptStaticEntries(u){for(const b of u)this.e.set(b.entryId,b)}createStatusBarEntry(u,b,v,g){return new E(this.a,this.b,this.e,u,b,v,g)}setStatusBarMessage(u,b){const v=this.c.setMessage(u);let g;return typeof b=="number"?g=setTimeout(()=>v.dispose(),b):typeof b<"u"&&b.then(()=>v.dispose(),()=>v.dispose()),new y.$AK(()=>{v.dispose(),clearTimeout(g)})}}e.$Hfc=C}),define(Pe[85],Ae([1,0,3,5,4]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cec=e.$Bec=void 0;class M{constructor($,E){this.c=E,this.b=new T.$Rd,this.onDidChangeStorage=this.b.event,this.a=$.getProxy(y.$yK.MainThreadStorage)}registerExtensionStorageKeysToSync($,E){this.a.$registerExtensionStorageKeysToSync($,E)}async initializeExtensionStorage($,E,f){const C=await this.a.$initializeExtensionStorage($,E);let D;return C&&(D=this.d($,E,C)),D||f}setValue($,E,f){return this.a.$setValue($,E,f)}$acceptValue($,E,f){const C=this.d($,E,f);C&&this.b.fire({shared:$,key:E,value:C})}d($,E,f){try{return JSON.parse(f)}catch(C){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${E}, global: ${$}): ${C}`)}}}e.$Bec=M,e.$Cec=(0,P.$Vh)("IExtHostStorage")}),define(Pe[86],Ae([1,0,4,27,15,63,2]),function(we,e,y,T,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lec=e.$kec=void 0,e.$kec=(0,y.$Vh)("IExtensionStoragePaths");let $=class{constructor(f,C,D){this.d=C,this.f=D,this.a=f.workspace??void 0,this.b=f.environment,this.whenReady=this.h().then(u=>this.c=u)}async g(f){return A.URI.joinPath(this.b.workspaceStorageHome,f)}async h(){if(!this.a)return Promise.resolve(void 0);const f=this.a.id,C=await this.g(f);try{return await this.f.value.stat(C),this.d.trace("[ExtHostStorage] storage dir already exists",C),C}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",C),await this.f.value.createDirectory(C),await this.f.value.writeFile(A.URI.joinPath(C,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),C}catch(D){this.d.error("[ExtHostStorage]",D);return}}workspaceValue(f){if(this.c)return A.URI.joinPath(this.c,f.identifier.value)}globalValue(f){return A.URI.joinPath(this.b.globalStorageHome,f.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$lec=$,e.$lec=$=Ke([Ve(0,T.$QM),Ve(1,P.$dj),Ve(2,M.$jec)],$)}),define(Pe[64],Ae([1,0,5,3,4,2,17,6,7,166,11,194,19,38,195,45,14,8,32]),function(we,e,y,T,P,M,A,$,E,f,C,D,u,b,v,g,t,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iec=e.$Hec=e.$Gec=e.$Fec=void 0,e.$Fec=(0,P.$Vh)("IExtHostTerminalService");class c{constructor(h,w,I,F){this.l=h,this._id=w,this.m=I,this.n=F,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(Z=>this.f=Z);const V=this;this.value={get name(){return V.n||""},get processId(){return V.b},get creationOptions(){return V.m},get exitStatus(){return V.h},get state(){return V.j},get selection(){return V.k},sendText(Z,N=!0){V.q(),V.l.$sendText(V._id,Z,N)},show(Z){V.q(),V.l.$show(V._id,Z)},hide(){V.q(),V.l.$hide(V._id)},dispose(){V.a||(V.a=!0,V.l.$dispose(V._id))},get dimensions(){if(!(V.d===void 0||V.g===void 0))return{columns:V.d,rows:V.g}}}}async create(h,w){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:h.name,shellPath:h.shellPath??void 0,shellArgs:h.shellArgs??void 0,cwd:h.cwd??w?.cwd??void 0,env:h.env??void 0,icon:p(h.iconPath)??void 0,color:g.ThemeColor.isThemeColor(h.color)?h.color.id:void 0,initialText:h.message??void 0,strictEnv:h.strictEnv??void 0,hideFromUser:h.hideFromUser??void 0,isFeatureTerminal:w?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:w?.useShellEnvironment??void 0,location:w?.location||this.o(h.location,w?.resolvedExtHostIdentifier),isTransient:h.isTransient??void 0})}async createExtensionTerminal(h,w,I,F){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:I,color:g.ThemeColor.isThemeColor(F)?F.id:void 0,location:this.o(h,w),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(h,w){return typeof h=="object"?"parentTerminal"in h&&h.parentTerminal&&w?{parentTerminal:w}:"viewColumn"in h?{viewColumn:i.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus}:void 0:h}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(h){this.n=h}setExitStatus(h,w){this.h=Object.freeze({code:h,reason:w})}setDimensions(h,w){return h===this.d&&w===this.g||h===0||w===0?!1:(this.d=h,this.g=w,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(h){this.k=h}_setProcessId(h){this.f?(this.f(h),this.f=void 0):this.b.then(w=>{w!==h&&(this.b=Promise.resolve(h))})}}e.$Gec=c;class o{get onProcessReady(){return this.b.event}constructor(h){this.g=h,this.id=0,this.shouldPersist=!1,this.a=new y.$Rd,this.onProcessData=this.a.event,this.b=new y.$Rd,this.d=new y.$Rd,this.onDidChangeProperty=this.d.event,this.f=new y.$Rd,this.onProcessExit=this.f.event}refreshProperty(h){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${h}`)}updateProperty(h,w){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${h}, value: ${w}`)}async start(){}shutdown(){this.g.close()}input(h){this.g.handleInput?.(h)}resize(h,w){this.g.setDimensions?.({columns:h,rows:w})}clearBuffer(){}async processBinary(h){}acknowledgeDataEvent(h){}async setUnicodeVersion(h){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(h){this.g.onDidWrite(w=>this.a.fire(w)),this.g.onDidClose?.((w=void 0)=>{this.f.fire(w===void 0?void 0:w)}),this.g.onDidOverrideDimensions?.(w=>{w&&this.d.fire({type:"overrideDimensions",value:{cols:w.columns,rows:w.rows}})}),this.g.onDidChangeName?.(w=>{this.d.fire({type:"title",value:w})}),this.g.open(h||void 0),h&&this.g.setDimensions?.(h),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let l=1,n=class extends $.$Rc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(h=>h.value)}constructor(h,w,I){super(),this.Q=w,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new $.$Sc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new y.$Rd,this.onDidCloseTerminal=this.H.event,this.I=new y.$Rd,this.onDidOpenTerminal=this.I.event,this.J=new y.$Rd,this.onDidChangeActiveTerminal=this.J.event,this.L=new y.$Rd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new y.$Rd,this.onDidChangeTerminalState=this.M.event,this.N=new y.$Rd,this.onDidChangeShell=this.N.event,this.O=new y.$Rd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new y.$Rd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=I.getProxy(T.$yK.MainThreadTerminalService),this.y=new v.$nqb(this.a.$sendProcessData),this.a.$registerProcessSupport(h),this.Q.registerArgumentProcessor({processArgument:F=>{const V=Z=>{const N=Z;return this.W(N.instanceId)?.value};switch(F?.$mid){case 15:return V(F);default:{if(Array.isArray(F))for(let Z=0;Z<F.length&&F[Z].$mid===15;Z++)F[Z]=V(F[Z]);return F}}}}),this.B({dispose:()=>{for(const[F,V]of this.g)V.shutdown(!0)}})}getDefaultShell(h){return(h?this.u:this.s)?.path||""}getDefaultShellArgs(h){return(h?this.u:this.s)?.args||[]}createExtensionTerminal(h,w){const I=new c(this.a,(0,b.$ig)(),h,h.name),F=new o(h.pty);return I.createExtensionTerminal(h.location,this.R(h,w).resolvedExtHostIdentifier,p(h.iconPath),m(h.color)).then(V=>{const Z=this.S(V,F);this.h[V]=Z}),this.f.push(I),I.value}R(h,w){if(w=w||{},h.location&&typeof h.location=="object"&&"parentTerminal"in h.location){const I=h.location.parentTerminal;if(I){const F=this.f.find(V=>V.value===I);F&&(w.resolvedExtHostIdentifier=F._id)}}else h.location&&typeof h.location!="object"?w.location=h.location:w.location&&typeof w.location=="object"&&"splitActiveTerminal"in w.location&&(w.location={splitActiveTerminal:!0});return w}attachPtyToTerminal(h,w){if(!this.W(h))throw new Error(`Cannot resolve terminal with id ${h} for virtual process`);const F=new o(w),V=this.S(h,F);this.h[h]=V}async $acceptActiveTerminalChanged(h){const w=this.b;if(h===null){this.b=void 0,w!==this.b&&this.J.fire(this.b);return}const I=this.W(h);I&&(this.b=I,w!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(h,w){const I=this.W(h);I&&this.O.fire({terminal:I.value,data:w})}async $acceptTerminalDimensions(h,w,I){const F=this.W(h);F&&F.setDimensions(w,I)&&this.L.fire({terminal:F.value,dimensions:F.value.dimensions})}async $acceptDidExecuteCommand(h,w){const I=this.W(h);I&&this.P.fire({terminal:I.value,...w})}async $acceptTerminalMaximumDimensions(h,w,I){this.g.get(h)?.resize(w,I)}async $acceptTerminalTitleChange(h,w){const I=this.W(h);I&&(I.name=w)}async $acceptTerminalClosed(h,w,I){const F=this.Y(this.f,h);if(F!==null){const V=this.f.splice(F,1)[0];V.setExitStatus(w,I),this.H.fire(V.value)}}$acceptTerminalOpened(h,w,I,F){if(w){const N=this.Y(this.f,w);if(N!==null){this.f[N]._id=h,this.I.fire(this.terminals[N]),this.f[N].isOpen=!0;return}}const V={name:F.name,shellPath:F.executable,shellArgs:F.args,cwd:typeof F.cwd=="string"?F.cwd:M.URI.revive(F.cwd),env:F.env,hideFromUser:F.hideFromUser},Z=new c(this.a,h,V,I);this.f.push(Z),this.I.fire(Z.value),Z.isOpen=!0}async $acceptTerminalProcessId(h,w){this.W(h)?._setProcessId(w)}async $startExtensionTerminal(h,w){const I=this.W(h);if(!I)return{message:(0,f.localize)(0,null,h)};I.isOpen||await new Promise(V=>{const Z=this.onDidOpenTerminal(async N=>{N===I.value&&(Z.dispose(),V())})});const F=this.g.get(h);F?F.startSendingEvents(w):this.j[h]={initialDimensions:w}}S(h,w){const I=new $.$Qc;I.add(w.onProcessReady(V=>this.a.$sendProcessReady(h,V.pid,V.cwd,V.windowsPty))),I.add(w.onDidChangeProperty(V=>this.a.$sendProcessProperty(h,V))),this.y.startBuffering(h,w.onProcessData),I.add(w.onProcessExit(V=>this.U(h,V))),this.g.set(h,w);const F=this.j[h];return F&&w instanceof o&&(w.startSendingEvents(F.initialDimensions),delete this.j[h]),I}$acceptProcessAckDataEvent(h,w){this.g.get(h)?.acknowledgeDataEvent(w)}$acceptProcessInput(h,w){this.g.get(h)?.input(w)}$acceptTerminalInteraction(h){const w=this.W(h);w?.setInteractedWith()&&this.M.fire(w.value)}$acceptTerminalSelection(h,w){this.W(h)?.setSelection(w)}$acceptProcessResize(h,w,I){try{this.g.get(h)?.resize(w,I)}catch(F){if(F.code!=="EPIPE"&&F.code!=="ERR_IPC_CHANNEL_CLOSED")throw F}}$acceptProcessShutdown(h,w){this.g.get(h)?.shutdown(w)}$acceptProcessRequestInitialCwd(h){this.g.get(h)?.getInitialCwd().then(w=>this.a.$sendProcessProperty(h,{type:"initialCwd",value:w}))}$acceptProcessRequestCwd(h){this.g.get(h)?.getCwd().then(w=>this.a.$sendProcessProperty(h,{type:"cwd",value:w}))}$acceptProcessRequestLatency(h){return Promise.resolve(h)}registerLinkProvider(h){return this.z.add(h),this.z.size===1&&this.a.$startLinkProvider(),new E.$AK(()=>{this.z.delete(h),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(h,w,I){if(this.C.has(w))throw new Error(`Terminal profile provider "${w}" already registered`);return this.C.set(w,I),this.a.$registerProfileProvider(w,h.identifier.value),new E.$AK(()=>{this.C.delete(w),this.a.$unregisterProfileProvider(w)})}registerTerminalQuickFixProvider(h,w,I){if(this.D.has(h))throw new Error(`Terminal quick fix provider "${h}" is already registered`);return this.D.set(h,I),this.a.$registerQuickFixProvider(h,w),new E.$AK(()=>{this.D.delete(h),this.a.$unregisterQuickFixProvider(h)})}async $provideTerminalQuickFixes(h,w){const I=new u.$2d().token;if(I.isCancellationRequested)return;const F=this.D.get(h);if(!F)return;const V=await F.provideTerminalQuickFixes(w,I);if(V===null||Array.isArray(V)&&V.length===0)return;const Z=new $.$Qc;if(this.w.value=Z,!Array.isArray(V))return V?i.TerminalQuickFix.from(V,this.Q.converter,Z):void 0;const N=[];for(const R of V){const L=i.TerminalQuickFix.from(R,this.Q.converter,Z);L&&N.push(L)}return N}async $createContributedProfileTerminal(h,w){const I=new u.$2d().token;let F=await this.C.get(h)?.provideTerminalProfile(I);if(!I.isCancellationRequested){if(F&&!("options"in F)&&(F={options:F}),!F||!("options"in F))throw new Error(`No terminal profile options provided for id "${h}"`);if("pty"in F.options){this.createExtensionTerminal(F.options,w);return}this.createTerminalFromOptions(F.options,w)}}async $provideLinks(h,w){const I=this.W(h);if(!I)return[];this.F.delete(h),this.G.get(h)?.dispose(!0);const V=new u.$2d;this.G.set(h,V);const Z=[],N={terminal:I.value,line:w},R=[];for(const Y of this.z)R.push(t.Promises.withAsyncBody(async he=>{V.token.onCancellationRequested(()=>he({provider:Y,links:[]}));const $e=await Y.provideTerminalLinks(N,V.token)||[];V.token.isCancellationRequested||he({provider:Y,links:$e})}));const L=await Promise.all(R);if(V.token.isCancellationRequested)return[];const O=new Map;for(const Y of L)Y&&Y.links.length>0&&Z.push(...Y.links.map(he=>{const $e={id:l++,startIndex:he.startIndex,length:he.length,label:he.tooltip};return O.set($e.id,{provider:Y.provider,link:he}),$e}));return this.F.set(h,O),Z}$activateLink(h,w){const I=this.F.get(h)?.get(w);I&&I.provider.handleTerminalLink(I.link)}U(h,w){this.y.stopBuffering(h),this.g.delete(h),delete this.j[h];const I=this.h[h];I&&(I.dispose(),delete this.h[h]),this.a.$sendProcessExit(h,w)}W(h){return this.X(this.f,h)}X(h,w){const I=this.Y(h,w);return I!==null?h[I]:null}Y(h,w){const I=h.findIndex(F=>F._id===w);return I===-1?null:I}getEnvironmentVariableCollection(h){let w=this.n.get(h.identifier.value);return w||(w=new s,this.$(h.identifier.value,w)),w.getScopedEnvironmentVariableCollection(void 0)}Z(h,w){const I=(0,D.$qr)(w.map),F=(0,D.$rr)(w.descriptionMap);this.a.$setEnvironmentVariableCollection(h,w.persistent,I.length===0?void 0:I,F)}$initEnvironmentVariableCollections(h){h.forEach(w=>{const I=w[0],F=new s(w[1]);this.$(I,F)})}$acceptDefaultProfile(h,w){const I=this.s;this.s=h,this.u=w,I?.path!==h.path&&this.N.fire(h.path)}$(h,w){this.n.set(h,w),w.onDidChangeCollection(()=>{this.Z(h,w)})}};e.$Hec=n,e.$Hec=n=Ke([Ve(1,r.$WM),Ve(2,A.$AM)],n);class s{get persistent(){return this.b}set persistent(h){this.b=h,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(h){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new y.$Rd,this.map=new Map(h)}getScopedEnvironmentVariableCollection(h){const w=this.h(h);let I=this.a.get(w);return I||(I=new a(this,h),this.a.set(w,I),I.onDidChangeCollection(()=>this.d.fire())),I}replace(h,w,I,F){this.f(h,{value:w,type:E.EnvironmentVariableMutatorType.Replace,options:I??{applyAtProcessCreation:!0},scope:F})}append(h,w,I,F){this.f(h,{value:w,type:E.EnvironmentVariableMutatorType.Append,options:I??{applyAtProcessCreation:!0},scope:F})}prepend(h,w,I,F){this.f(h,{value:w,type:E.EnvironmentVariableMutatorType.Prepend,options:I??{applyAtProcessCreation:!0},scope:F})}f(h,w){if(w.options&&w.options.applyAtProcessCreation===!1&&!w.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const I=this.g(h,w.scope),F=this.map.get(I),V=w.options?{applyAtProcessCreation:w.options.applyAtProcessCreation??!1,applyAtShellIntegration:w.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!F||F.value!==w.value||F.type!==w.type||F.options?.applyAtProcessCreation!==V.applyAtProcessCreation||F.options?.applyAtShellIntegration!==V.applyAtShellIntegration||F.scope?.workspaceFolder?.index!==w.scope?.workspaceFolder?.index){const Z=this.g(h,w.scope),N={variable:h,...w,options:V};this.map.set(Z,N),this.d.fire()}}get(h,w){const I=this.g(h,w),F=this.map.get(I);return F?S(F):void 0}g(h,w){const I=this.h(w);return I.length?`${h}:::${I}`:h}h(h){return this.j(h?.workspaceFolder)??""}j(h){return h?h.uri.toString():void 0}getVariableMap(h){const w=new Map;for(const[I,F]of this.map)this.h(F.scope)===this.h(h)&&w.set(F.variable,S(F));return w}delete(h,w){const I=this.g(h,w);this.map.delete(I),this.d.fire()}clear(h){if(h?.workspaceFolder){for(const[w,I]of this.map)I.scope?.workspaceFolder?.index===h.workspaceFolder.index&&this.map.delete(w);this.k(h)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(h,w){const I=this.h(w),F=this.descriptionMap.get(I);if(!F||F.description!==h){let V;typeof h=="string"?V=h:V=h?.value.split(`

`)[0];const Z={description:V,scope:w};this.descriptionMap.set(I,Z),this.d.fire()}}getDescription(h){const w=this.h(h);return this.descriptionMap.get(w)?.description}k(h){const w=this.h(h);this.descriptionMap.delete(w)}}class a{get persistent(){return this.b.persistent}set persistent(h){this.b.persistent=h}get onDidChangeCollection(){return this.a&&this.a.event}constructor(h,w){this.b=h,this.d=w,this.a=new y.$Rd}getScoped(h){return this.b.getScopedEnvironmentVariableCollection(h)}replace(h,w,I){this.b.replace(h,w,I,this.d)}append(h,w,I){this.b.append(h,w,I,this.d)}prepend(h,w,I){this.b.prepend(h,w,I,this.d)}get(h){return this.b.get(h,this.d)}forEach(h,w){this.b.getVariableMap(this.d).forEach((I,F)=>h.call(w,F,I,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(h){this.b.delete(h,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(h){this.b.setDescription(h,this.d)}get description(){return this.b.getDescription(this.d)}}let d=class extends n{constructor(h,w){super(!1,h,w)}createTerminal(h,w,I){throw new C.$$}createTerminalFromOptions(h,w){throw new C.$$}};e.$Iec=d,e.$Iec=d=Ke([Ve(0,r.$WM),Ve(1,A.$AM)],d);function p(k){if(!(!k||typeof k=="string"))return"id"in k?{id:k.id,color:k.color}:k}function m(k){return g.ThemeColor.isThemeColor(k)?k:void 0}function S(k){const h={...k};return delete h.scope,h.options=h.options??void 0,delete h.variable,h}}),define(Pe[267],Ae([1,0,298,14,24,19,5,219,97,6,26,16,38,3,17,108,8,7,48,77,58,23]),function(we,e,y,T,P,M,A,$,E,f,C,D,u,b,v,g,t,i,r,c,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ofc=e.$Nfc=e.$Mfc=e.$Lfc=void 0;let n=class extends f.$Rc{constructor(N,R,L){super(),this.u=L,this.f=this.B(new A.$Rd),this.g=new Map,this.s=this.B(new A.$Rd),this.onResultsChanged=this.f.event,this.results=[],this.h=N.getProxy(b.$yK.MainThreadTesting),this.m=new I(this.h),this.j=new p(this.h),R.registerArgumentProcessor({processArgument:O=>{switch(O?.$mid){case 16:{const Y=O,he=Y.tests[Y.tests.length-1].item.extId;return this.g.get(r.$rJ.root(he))?.collection.tree.get(he)?.actual??(0,g.$MM)(O)}case 18:{const{extId:Y,message:he}=O;return{test:this.g.get(r.$rJ.root(Y))?.collection.tree.get(Y)?.actual,message:t.TestMessage.to(he)}}default:return O}}}),R.registerCommand(!1,"testing.getExplorerSelection",async()=>{const O=await R.executeCommand("_testing.getExplorerSelection"),Y=he=>{const $e=this.g.get(r.$rJ.root(he));if($e)return r.$rJ.isRoot(he)?$e.controller:$e.collection.tree.get(he)?.actual};return{include:O?.include.map(Y).filter(D.$Kf)||[],exclude:O?.exclude.map(Y).filter(D.$Kf)||[]}})}createTestController(N,R,L,O){if(this.g.has(R))throw new Error(`Attempt to insert a duplicate controller with ID "${R}"`);const Y=new f.$Qc,he=Y.add(new g.$PM(R,L,this.u));he.root.label=L;const $e=new Map,De=new Set,ke=this.h,fe={items:he.root.children,get label(){return L},set label(te){L=te,he.root.label=te,ke.$updateController(R,{label:L})},get refreshHandler(){return O},set refreshHandler(te){O=te,ke.$updateController(R,{canRefresh:!!te})},get id(){return R},createRunProfile:(te,Re,se,Q,B,ne)=>{let pe=(0,E.$Ji)(te);for(;$e.has(pe);)pe++;return new F(this.h,$e,N,De,this.s.event,R,pe,te,Re,se,Q,B,ne)},createTestItem(te,Re,se){return new g.$NM(R,te,Re,se)},createTestRun:(te,Re,se=!0)=>this.j.createTestRun(N,R,he,te,Re,se),invalidateTestResults:te=>{if(te===void 0)this.h.$markTestRetired(void 0);else{const Re=te instanceof Array?te:[te];this.h.$markTestRetired(Re.map(se=>r.$rJ.fromExtHostTestItem(se,R).toString()))}},set resolveHandler(te){he.resolveHandler=te},get resolveHandler(){return he.resolveHandler},dispose:()=>{Y.dispose()}};ke.$registerTestController(R,L,!!O),Y.add((0,f.$Pc)(()=>ke.$unregisterTestController(R)));const ve={controller:fe,collection:he,profiles:$e,extension:N,activeProfiles:De};return this.g.set(R,ve),Y.add((0,f.$Pc)(()=>this.g.delete(R))),Y.add(he.onDidGenerateDiff(te=>ke.$publishDiff(R,te.map(o.TestsDiffOp.serialize)))),fe}createTestObserver(){return this.m.checkout()}async runTests(N,R=M.CancellationToken.None){const L=m(N);if(!L)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const O=this.g.get(L.controllerId);if(!O)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:N.include?.map(Y=>r.$rJ.fromExtHostTestItem(Y,O.collection.root.id).toString())??[O.collection.root.id],profileGroup:V[L.kind],profileId:L.profileId,controllerId:L.controllerId}],exclude:N.exclude?.map(Y=>Y.id)},R)}$syncTests(){for(const{collection:N}of this.g.values())N.flushDiff();return Promise.resolve()}$provideFileCoverage(N,R,L){return(0,y.$qb)(this.j.trackers,Y=>Y.id===N?Y.getCoverage(R):void 0)?.provideFileCoverage(L)??Promise.resolve([])}$resolveFileCoverage(N,R,L,O){return(0,y.$qb)(this.j.trackers,he=>he.id===N?he.getCoverage(R):void 0)?.resolveFileCoverage(L,O)??Promise.resolve([])}$configureRunProfile(N,R){this.g.get(N)?.profiles.get(R)?.configureHandler?.()}$setActiveRunProfiles(N){const R=new Map;for(const[L,O]of Object.entries(N)){const Y=this.g.get(L);if(!Y)continue;const he=new Map,$e=O.filter(ke=>!Y.activeProfiles.has(ke)),De=[...Y.activeProfiles].filter(ke=>!O.includes(ke));for(const ke of $e)he.set(ke,!0),Y.activeProfiles.add(ke);for(const ke of De)he.set(ke,!1),Y.activeProfiles.delete(ke);he.size&&R.set(L,he)}this.s.fire(R)}async $refreshTests(N,R){await this.g.get(N)?.controller.refreshHandler?.(R)}$publishTestResults(N){this.results=Object.freeze(N.map(R=>(0,C.$bn)(t.TestResults.to(R))).concat(this.results).sort((R,L)=>L.completedAt-R.completedAt).slice(0,32)),this.f.fire()}async $expandTest(N,R){const L=this.g.get(r.$rJ.fromString(N).controllerId)?.collection;L&&(await L.expand(N,R<0?1/0:R),L.flushDiff())}$acceptDiff(N){this.m.applyDiff(N.map(o.TestsDiffOp.deserialize))}async $runControllerTests(N,R){return Promise.all(N.map(L=>this.w(L,!1,R)))}async $startContinuousRun(N,R){const L=new M.$2d(R),O=await Promise.all(N.map(Y=>this.w(Y,!0,L.token)));return!R.isCancellationRequested&&!O.some(Y=>Y.error)&&await new Promise(Y=>R.onCancellationRequested(Y)),L.dispose(!0),O}async w(N,R,L){const O=this.g.get(N.controllerId);if(!O)return{};const{collection:Y,profiles:he,extension:$e}=O,De=he.get(N.profileId);if(!De)return{};const ke=N.testIds.map(Re=>Y.tree.get(Re)).filter(D.$Kf),fe=N.excludeExtIds.map(Re=>O.collection.tree.get(Re)).filter(D.$Kf).filter(Re=>ke.some(se=>se.fullId.compare(Re.fullId)===2));if(!ke.length)return{};const ve=new i.$9L(ke.some(Re=>Re.actual instanceof g.$OM)?void 0:ke.map(Re=>Re.actual),fe.map(Re=>Re.actual),De,R),te=(0,o.$tJ)(N)&&this.j.prepareForMainThreadTestRun(ve,S.fromInternal(N,O.collection),$e,L);try{return await De.runHandler(ve,L),{}}catch(Re){return{error:String(Re)}}finally{te&&(te.hasRunningTasks&&!L.isCancellationRequested&&await A.Event.toPromise(te.onEnd),te.dispose())}}$cancelExtensionTestRun(N){N===void 0?this.j.cancelAllRuns():this.j.cancelRunById(N)}};e.$Lfc=n,e.$Lfc=n=Ke([Ve(0,v.$AM)],n);const s=1e4;var a;(function(Z){Z[Z.Running=0]="Running",Z[Z.Cancelling=1]="Cancelling",Z[Z.Ended=2]="Ended"})(a||(a={}));class d extends f.$Rc{get hasRunningTasks(){return this.f.size>0}get id(){return this.m.id}constructor(N,R,L){super(),this.m=N,this.s=R,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new A.$Rd),this.onEnd=this.j.event,this.h=this.B(new M.$2d(L));const O=this.B(new T.$0g(()=>this.u(),s));this.B(this.h.token.onCancellationRequested(()=>O.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.u()}getCoverage(N){return this.f.get(N)?.coverage}createRun(N){const R=this.m.id,L=this.m.controllerId,O=(0,u.$ig)(),Y=new k(this.s,R,O),he=fe=>(ve,...te)=>{if(De){console.warn(`Setting the state of test "${ve.id}" is a no-op after the run ends.`);return}this.m.isIncluded(ve)&&(this.y(ve),fe(ve,...te))},$e=(fe,ve)=>{const te=ve instanceof Array?ve.map(t.TestMessage.from):[t.TestMessage.from(ve)];if(fe.uri&&fe.range){const Re={range:t.Range.from(fe.range),uri:fe.uri};for(const se of te)se.location=se.location||Re}this.s.$appendTestMessagesInRun(R,O,r.$rJ.fromExtHostTestItem(fe,L).toString(),te)};let De=!1;const ke={isPersisted:this.m.isPersisted,token:this.h.token,name:N,get coverageProvider(){return Y.coverageProvider},set coverageProvider(fe){Y.coverageProvider=fe},enqueued:he(fe=>{this.s.$updateTestStateInRun(R,O,r.$rJ.fromExtHostTestItem(fe,L).toString(),1)}),skipped:he(fe=>{this.s.$updateTestStateInRun(R,O,r.$rJ.fromExtHostTestItem(fe,L).toString(),5)}),started:he(fe=>{this.s.$updateTestStateInRun(R,O,r.$rJ.fromExtHostTestItem(fe,L).toString(),2)}),errored:he((fe,ve,te)=>{$e(fe,ve),this.s.$updateTestStateInRun(R,O,r.$rJ.fromExtHostTestItem(fe,L).toString(),6,te)}),failed:he((fe,ve,te)=>{$e(fe,ve),this.s.$updateTestStateInRun(R,O,r.$rJ.fromExtHostTestItem(fe,L).toString(),4,te)}),passed:he((fe,ve)=>{this.s.$updateTestStateInRun(R,O,r.$rJ.fromExtHostTestItem(fe,this.m.controllerId).toString(),3,ve)}),appendOutput:(fe,ve,te)=>{De||(te&&(this.m.isIncluded(te)?this.y(te):te=void 0),this.s.$appendOutputToRun(R,O,P.$fe.fromString(fe),ve&&t.location.from(ve),te&&r.$rJ.fromExtHostTestItem(te,L).toString()))},end:()=>{De||(De=!0,this.s.$finishedTestRunTask(R,O),this.f.delete(O),this.f.size||this.w())}};return this.f.set(O,{run:ke,coverage:Y}),this.s.$startedTestRunTask(R,{id:O,name:N,running:!0}),ke}u(){for(const{run:N}of this.f.values())N.end()}w(){this.c!==2&&(this.c=2,this.j.fire())}y(N){if(!(N instanceof g.$NM))throw new c.$sM(N.id);if(this.g.has(r.$rJ.fromExtHostTestItem(N,this.m.controllerId).toString()))return;const R=[],L=this.m.colllection.root;for(;;){const O=t.TestItem.from(N);if(R.unshift(O),this.g.has(O.extId)||(this.g.add(O.extId),N===L))break;N=N.parent||L}this.s.$addTestsToRun(this.m.controllerId,this.m.id,R)}dispose(){this.w(),super.dispose()}}class p{get trackers(){return this.c.values()}constructor(N){this.d=N,this.c=new Map}prepareForMainThreadTestRun(N,R,L,O){return this.f(N,R,L,O)}cancelRunById(N){for(const R of this.c.values())if(R.id===N){R.cancel();return}}cancelAllRuns(){for(const N of this.c.values())N.cancel()}createTestRun(N,R,L,O,Y,he){const $e=this.c.get(O);if($e)return $e.createRun(Y);const De=S.fromPublic(R,L,O,he),ke=m(O);this.d.$startedExtensionTestRun({controllerId:R,continuous:!!O.continuous,profile:ke&&{group:V[ke.kind],id:ke.profileId},exclude:O.exclude?.map(ve=>r.$rJ.fromExtHostTestItem(ve,L.root.id).toString())??[],id:De.id,include:O.include?.map(ve=>r.$rJ.fromExtHostTestItem(ve,L.root.id).toString())??[L.root.id],persist:he});const fe=this.f(O,De,N);return A.Event.once(fe.onEnd)(()=>{this.d.$finishedExtensionTestRun(De.id),fe.dispose()}),fe.createRun(Y)}f(N,R,L,O){const Y=new d(R,this.d,O);return this.c.set(N,Y),A.Event.once(Y.onEnd)(()=>this.c.delete(N)),Y}}e.$Mfc=p;const m=Z=>{if(Z.profile){if(!(Z.profile instanceof F))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return Z.profile}};class S{static fromPublic(N,R,L,O){return new S(N,(0,u.$ig)(),L.include?.map(Y=>r.$rJ.fromExtHostTestItem(Y,N).toString())??[N],L.exclude?.map(Y=>r.$rJ.fromExtHostTestItem(Y,N).toString())??[],O,R)}static fromInternal(N,R){return new S(N.controllerId,N.runId,N.testIds,N.excludeExtIds,!0,R)}constructor(N,R,L,O,Y,he){this.controllerId=N,this.id=R,this.isPersisted=Y,this.colllection=he,this.c=L.map($e=>$e+"\0"),this.d=O.map($e=>$e+"\0")}isIncluded(N){const R=r.$rJ.fromExtHostTestItem(N,this.controllerId).toString()+"\0";for(const L of this.d)if(R===L||R.startsWith(L))return!1;for(const L of this.c)if(R===L||R.startsWith(L))return!0;return!1}}e.$Nfc=S;class k{set coverageProvider(N){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");N&&(this.c=N,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(N,R,L){this.f=N,this.g=R,this.h=L}async provideFileCoverage(N){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(N))());try{return(await this.d)?.map(t.TestCoverage.fromFile)??[]}catch(R){throw this.d=void 0,R}}async resolveFileCoverage(N,R){const L=await this.d;let O=L?.[N];return!this.c||!L||!O?[]:(O.detailedCoverage||(O=L[N]=await this.c.resolveFileCoverage?.(O,R)??O),O.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class h{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(N){this.h=N,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(N){this.c.add(N)}update(N){Object.assign(N.revived,t.TestItem.toPlain(N.item)),this.c.has(N)||this.d.add(N)}remove(N){if(this.c.has(N)){this.c.delete(N);return}this.d.delete(N);const R=r.$rJ.parentId(N.item.extId);if(R&&this.g.has(R.toString())){this.g.add(N.item.extId);return}this.f.add(N)}getChangeEvent(){const{c:N,d:R,f:L}=this;return{get added(){return[...N].map(O=>O.revived)},get updated(){return[...R].map(O=>O.revived)},get removed(){return[...L].map(O=>O.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class w extends o.$yJ{constructor(){super(...arguments),this.q=new A.$Rd,this.onDidChangeTests=this.q.event}get rootTests(){return this.f}getMirroredTestDataById(N){return this.d.get(N)}getMirroredTestDataByReference(N){return this.d.get(N.id)}p(N,R){return{...N,revived:t.TestItem.toPlain(N.item),depth:R?R.depth+1:0,children:new Set}}o(){return new h(this.q)}}class I{constructor(N){this.d=N}checkout(){this.c||(this.c=this.f());const N=this.c;return N.observers++,{onDidChangeTest:N.tests.onDidChangeTests,get tests(){return[...N.tests.rootTests].map(R=>R.revived)},dispose:(0,$.$cb)(()=>{--N.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(N){return this.c?.tests.getMirroredTestDataByReference(N)}applyDiff(N){this.c?.tests.apply(N)}f(){const N=new w;return this.d.$subscribeToDiffs(),{observers:0,tests:N}}}class F{#e;#t;#i;#o;#r;get label(){return this.d}set label(N){N!==this.d&&(this.d=N,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:N}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(N){N!==this.g&&(this.g=N,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:N}))}get isDefault(){return this.f}set isDefault(N){N!==this.f&&(this.f=N,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:N}))}get tag(){return this._tag}set tag(N){N?.id!==this._tag?.id&&(this._tag=N,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:N?t.TestTag.namespace(this.controllerId,N.id):null}))}get configureHandler(){return this.c}set configureHandler(N){N!==this.c&&(this.c=N,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!N}))}get isSelected(){return(0,l.$MF)(this.#t,"testingActiveProfile"),this.#i.has(this.profileId)}get onDidChangeSelected(){return(0,l.$MF)(this.#t,"testingActiveProfile"),A.Event.chain(this.#o,N=>N.map(R=>R.get(this.controllerId)?.get(this.profileId)).filter(D.$Kf))}constructor(N,R,L,O,Y,he,$e,De,ke,fe,ve=!1,te=void 0,Re=!1){this.controllerId=he,this.profileId=$e,this.d=De,this.kind=ke,this.runHandler=fe,this.f=ve,this._tag=te,this.g=Re,this.#e=N,this.#r=R,this.#t=L,this.#i=O,this.#o=Y,R.set($e,this);const se=V[ke];if(typeof se!="number")throw new Error(`Unknown TestRunProfile.group ${ke}`);this.#e.$publishTestRunProfile({profileId:$e,controllerId:he,tag:te?t.TestTag.namespace(this.controllerId,te.id):null,label:De,group:se,isDefault:ve,hasConfigurationHandler:!1,supportsContinuousRun:Re})}dispose(){this.#r?.delete(this.profileId)&&(this.#r=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$Ofc=F;const V={[i.TestRunProfileKind.Coverage]:8,[i.TestRunProfileKind.Debug]:4,[i.TestRunProfileKind.Run]:2}}),define(Pe[268],Ae([1,0,18,11,5,3,109,8,7]),function(we,e,y,T,P,M,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$dc=void 0;class f{constructor(D,u){this.i=u,this.a=new P.$Rd({onListenerError:T.$1}),this.b=new P.$Rd({onListenerError:T.$1}),this.c=new P.$Rd({onListenerError:T.$1}),this.d=new P.$Rd({onListenerError:T.$1}),this.f=new P.$Rd({onListenerError:T.$1}),this.g=new P.$Rd({onListenerError:T.$1}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=D.getProxy(M.$yK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(b=>this.g.fire(b)),this.i.onDidChangeActiveTextEditor(b=>this.f.fire(b))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(D){const u=this.i.allEditors();return D?u:u.map(b=>b.value)}async showTextDocument(D,u,b){let v;typeof u=="number"?v={position:$.ViewColumn.from(u),preserveFocus:b}:typeof u=="object"?v={position:$.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selection:typeof u.selection=="object"?$.Range.from(u.selection):void 0,pinned:typeof u.preview=="boolean"?!u.preview:void 0}:v={preserveFocus:!1};const g=await this.h.$tryShowTextDocument(D.uri,v),t=g&&this.i.getEditor(g);if(t)return t.value;throw g?new Error(`Could NOT open editor for "${D.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${D.uri.toString()}".`)}createTextEditorDecorationType(D,u){return new A.$HM(this.h,D,u).value}$acceptEditorPropertiesChanged(D,u){const b=this.i.getEditor(D);if(!b)throw new Error("unknown text editor");if(u.options&&b._acceptOptions(u.options),u.selections){const v=u.selections.selections.map($.Selection.to);b._acceptSelections(v)}if(u.visibleRanges){const v=y.$Gb(u.visibleRanges.map($.Range.to));b._acceptVisibleRanges(v)}if(u.options&&this.b.fire({textEditor:b.value,options:{...u.options,lineNumbers:$.TextEditorLineNumbersStyle.to(u.options.lineNumbers)}}),u.selections){const v=E.TextEditorSelectionChangeKind.fromValue(u.selections.source),g=u.selections.selections.map($.Selection.to);this.a.fire({textEditor:b.value,selections:g,kind:v})}if(u.visibleRanges){const v=y.$Gb(u.visibleRanges.map($.Range.to));this.c.fire({textEditor:b.value,visibleRanges:v})}}$acceptEditorPositionData(D){for(const u in D){const b=this.i.getEditor(u);if(!b)throw new Error("Unknown text editor");const v=$.ViewColumn.to(D[u]);b.value.viewColumn!==v&&(b._acceptViewColumn(v),this.d.fire({textEditor:b.value,viewColumn:v}))}}getDiffInformation(D){return Promise.resolve(this.h.$getDiffInformation(D))}}e.$$dc=f}),define(Pe[269],Ae([1,0,2,4,3,6,7,8,22,16]),function(we,e,y,T,P,M,A,$,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rfc=e.$Qfc=void 0,e.$Qfc=(0,T.$Vh)("IExtHostTimeline");class C{constructor(b,v){this.b=new Map,this.c=new Map,this.a=b.getProxy(P.$yK.MainThreadTimeline),v.registerArgumentProcessor({processArgument:(g,t)=>{if(g&&g.$mid===12)if(this.b.get(g.source)&&E.$_l.equals(t,this.b.get(g.source)?.extension)){const i=g.uri===void 0?void 0:y.URI.revive(g.uri);return this.c.get(g.source)?.get(D(i))?.get(g.handle)}else return;return g}})}async $getTimeline(b,v,g,t){return this.b.get(b)?.provider.provideTimeline(y.URI.revive(v),g,t)}registerTimelineProvider(b,v,g,t){const i=new M.$Qc,r=this.d(v.id,t,i).bind(this);let c;v.onDidChange&&(c=v.onDidChange(l=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...l,id:v.id}),this));const o=this.c;return this.f({...v,scheme:b,onDidChange:void 0,async provideTimeline(l,n,s){n?.resetCache&&(i.clear(),o.get(v.id)?.clear());const a=await v.provideTimeline(l,n,s);if(a==null)return;const d=r(l,n);return{...a,source:v.id,items:a.items.map(d)}},dispose(){for(const l of o.values())l.get(v.id)?.clear();c?.dispose(),i.dispose()}},g)}d(b,v,g){return(t,i)=>{let r;if(i?.cacheResults){let c=this.c.get(b);c===void 0&&(c=new Map,this.c.set(b,c));const o=D(t);r=c.get(o),r===void 0&&(r=new Map,c.set(o,r))}return c=>{const{iconPath:o,...l}=c,n=`${b}|${c.id??c.timestamp}`;r?.set(n,c);let s,a,d;c.iconPath&&(o instanceof A.$uL?d={id:o.id,color:o.color}:y.URI.isUri(o)?(s=o,a=o):{light:s,dark:a}=o);let p;return A.$1K.isMarkdownString(l.tooltip)?p=$.MarkdownString.from(l.tooltip):(0,f.$Cf)(l.tooltip)?p=l.tooltip:A.$1K.isMarkdownString(l.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),p=$.MarkdownString.from(l.detail)):(0,f.$Cf)(l.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),p=l.detail),{...l,id:l.id??void 0,handle:n,source:b,command:c.command?v.toInternal(c.command,g):void 0,icon:s,iconDark:a,themeIcon:d,tooltip:p,accessibilityInformation:c.accessibilityInformation}}}}f(b,v){if(this.b.get(b.id))throw new Error(`Timeline Provider ${b.id} already exists.`);return this.a.$registerTimelineProvider({id:b.id,label:b.label,scheme:b.scheme}),this.b.set(b.id,{provider:b,extension:v}),(0,M.$Pc)(()=>{for(const t of this.c.values())t.get(b.id)?.clear();this.b.delete(b.id),this.a.$unregisterTimelineProvider(b.id),b.dispose()})}}e.$Rfc=C;function D(u){return u?.toString()}}),define(Pe[87],Ae([1,0,19,5,6,168,4,15,197,3,27,17,7]),function(we,e,y,T,P,M,A,$,E,f,C,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zwb=e.$Ywb=e.TunnelDtoConverter=void 0;class b extends E.$mv{}var v;(function(t){function i(c){return{remoteAddress:c.remoteAddress,localAddress:c.localAddress,public:!!c.public,privacy:c.privacy??(c.public?E.TunnelPrivacyId.Public:E.TunnelPrivacyId.Private),protocol:c.protocol}}t.fromApiTunnel=i;function r(c){return{remoteAddress:{host:c.tunnelRemoteHost,port:c.tunnelRemotePort},localAddress:c.localAddress,public:c.privacy!==E.TunnelPrivacyId.ConstantPrivate&&c.privacy!==E.TunnelPrivacyId.ConstantPrivate,privacy:c.privacy,protocol:c.protocol}}t.fromServiceTunnel=r})(v||(e.TunnelDtoConverter=v={})),e.$Ywb=(0,A.$Vh)("IExtHostTunnelService");let g=class extends P.$Rc{constructor(i,r,c){super(),this.s=c,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new T.$Rd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=i.getProxy(f.$yK.MainThreadTunnelService)}async openTunnel(i,r){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${i.identifier.value} called openTunnel API for ${r.remoteAddress.host}:${r.remoteAddress.port}.`);const c=await this.a.$openTunnel(r,i.displayName);if(c){const o=new b(c.remoteAddress,c.localAddress,()=>this.a.$closeTunnel(c.remoteAddress));return this.B(o),o}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(i,r){const c=this.u();return this.r.set(c,{selector:i,provider:r}),this.a.$registerPortsAttributesProvider(i,c),new u.$AK(()=>{this.r.delete(c),this.a.$unregisterPortsAttributesProvider(c)})}async $providePortAttributes(i,r,c,o,l){const n=[];for(const a of i){const d=this.r.get(a);if(!d)return[];n.push(...await Promise.all(r.map(async p=>{let m;try{m=await d.provider.providePortAttributes({port:p,pid:c,commandLine:o},l)}catch{m=await d.provider.providePortAttributes(p,c,o,l)}return{providedAttributes:m,port:p}})))}const s=n.filter(a=>!!a.providedAttributes);return s.length>0?s.map(a=>({autoForwardAction:a.providedAttributes.autoForwardAction,port:a.port})):[]}async $registerCandidateFinder(i){}registerTunnelProvider(i,r){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(o,l)=>await i.provideTunnel(o,l,new y.$2d().token)??void 0;const c=r.tunnelFeatures?{elevation:!!r.tunnelFeatures?.elevation,privacyOptions:r.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(c),Promise.resolve((0,P.$Pc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(i,r){if(i){i.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(i.candidatePortSource),i.showCandidatePort&&(this.f=i.showCandidatePort,this.a.$setCandidateFilter());const c=i.tunnelFactory??(r?this.w(r):void 0);if(c){this.b=c;let o=i.tunnelFeatures?.privacyOptions??[];i.tunnelFeatures?.public&&o.length===0&&(o=[{id:"private",label:M.localize(0,null),themeIcon:"lock"},{id:"public",label:M.localize(1,null),themeIcon:"eye"}]);const l=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,public:!!i.tunnelFeatures?.public,privacyOptions:o}:void 0;this.a.$setTunnelProvider(l)}}else this.b=void 0;return(0,P.$Pc)(()=>{this.b=void 0})}w(i){}async $closeTunnel(i,r){if(this.g.has(i.host)){const c=this.g.get(i.host);c.has(i.port)&&(r&&c.get(i.port).disposeListener.dispose(),await c.get(i.port).tunnel.dispose(),c.delete(i.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(i,r){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const c=this.b(i,r);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),c!==void 0){const o=await c;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),o===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(i.remoteAddress.host)||this.g.set(i.remoteAddress.host,new Map);const l=this.B(o.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(o.remoteAddress))));return this.g.get(i.remoteAddress.host).set(i.remoteAddress.port,{tunnel:o,disposeListener:l}),v.fromApiTunnel(o)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(c){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),c instanceof Error)return c.message}}async $applyCandidateFilter(i){const r=await Promise.all(i.map(o=>this.f(o.host,o.port,o.detail??""))),c=i.filter((o,l)=>r[l]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${i.map(o=>o.port).join(", ")} to ${c.map(o=>o.port).join(", ")}`),c}};e.$Zwb=g,e.$Zwb=g=Ke([Ve(0,D.$AM),Ve(1,C.$QM),Ve(2,$.$dj)],g)}),define(Pe[270],Ae([1,0,6,13,2,3]),function(we,e,y,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tfc=void 0;class A{static{this.a=new Set([T.Schemas.http,T.Schemas.https])}constructor(E){this.c=new Map,this.b=E.getProxy(M.$yK.MainThreadUriOpeners)}registerExternalUriOpener(E,f,C,D){if(this.c.has(f))throw new Error(`Opener with id '${f}' already registered`);const u=D.schemes.find(b=>!A.a.has(b));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set(f,C),this.b.$registerUriOpener(f,D.schemes,E,D.label),(0,y.$Pc)(()=>{this.c.delete(f),this.b.$unregisterUriOpener(f)})}async $canOpenUri(E,f,C){const D=this.c.get(E);if(!D)throw new Error(`Unknown opener with id: ${E}`);const u=P.URI.revive(f);return D.canOpenExternalUri(u,C)}async $openUri(E,f,C){const D=this.c.get(E);if(!D)throw new Error(`Unknown opener id: '${E}'`);return D.openExternalUri(P.URI.revive(f.resolvedUri),{sourceUri:P.URI.revive(f.sourceUri)},C)}}e.$Tfc=A}),define(Pe[271],Ae([1,0,3,2,6,11,22]),function(we,e,y,T,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ufc=void 0;class ${static{this.a=0}constructor(f){this.c=new A.$am,this.d=new Map,this.b=f.getProxy(y.$yK.MainThreadUrls)}registerUriHandler(f,C){const D=f.identifier;if(this.c.has(D))throw new Error(`Protocol handler already registered for extension ${D}`);const u=$.a++;return this.c.add(D),this.d.set(u,C),this.b.$registerUriHandler(u,D,f.displayName||f.name),(0,P.$Pc)(()=>{this.c.delete(D),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri(f,C){const D=this.d.get(f);if(!D)return Promise.resolve(void 0);try{D.handleUri(T.URI.revive(C))}catch(u){(0,M.$Z)(u)}return Promise.resolve(void 0)}async createAppUri(f){return T.URI.revive(await this.b.$createAppUri(f))}}e.$Ufc=$}),define(Pe[65],Ae([1,0,5,6,13,26,2,182,204,78,3]),function(we,e,y,T,P,M,A,$,E,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qec=e.$pec=e.$oec=e.$nec=e.$mec=void 0;class D{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;constructor(o,l,n,s,a,d,p){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new y.$Rd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new y.$Rd,this._onDidDispose=this.#h.event,this.#e=o,this.#t=l,this.#s=n,this.#o=s,this.#r=a,this.#n=d,this.#l=u(d),this.#d=b(d),this.#i=p}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(o){return this.#u=!0,(0,f.$$tb)(o,this.#o)}get cspSource(){const o=this.#n.extensionLocation;if(o.scheme===P.Schemas.https||o.scheme===P.Schemas.http){let l=o.toString();return l.endsWith("/")||(l+="/"),l+" "+f.$0tb}return f.$0tb}get html(){return this.a(),this.#a}set html(o){this.a(),this.#a!==o&&(this.#a=o,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(o)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(o)))}get options(){return this.a(),this.#s}set options(o){this.a(),M.$en(this.#s,o)||this.#t.$setOptions(this.#e,t(this.#n,this.#r,o)),this.#s=o}async postMessage(o){if(this.#c)return!1;const l=(0,E.$Fcb)(o,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,l.message,...l.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(o){if(!this.#d)return o;const l=this.#n.extensionLocation?.scheme===P.Schemas.vscodeRemote,n=this.#n.extensionLocation.scheme===P.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return o.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,a,d,p,m,S)=>{const k=A.URI.from({scheme:p||"file",path:decodeURIComponent(m)}),h=(0,f.$$tb)(k,{isRemote:l,authority:n}).toString();return`${a}${h}${S}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,a,d,p,m,S)=>{const k=A.URI.from({scheme:p||"file",path:decodeURIComponent(m)}),h=(0,f.$$tb)(k,{isRemote:l,authority:n}).toString();return`${a}${h}${S}`})}}e.$mec=D;function u(c){try{const o=(0,$.$To)((0,$.$So)(c.engines.vscode));return!!o&&o.majorBase>=1&&o.minorBase>=57}catch{return!1}}e.$nec=u;function b(c){try{const o=(0,$.$To)((0,$.$So)(c.engines.vscode));return o?o.majorBase<1||o.majorBase===1&&o.minorBase<60:!1}catch{return!1}}class v extends T.$Rc{constructor(o,l,n,s,a){super(),this.c=l,this.f=n,this.g=s,this.h=a,this.b=new Map,this.a=o.getProxy(C.$yK.MainThreadWebviews)}dispose(){super.dispose();for(const o of this.b.values())o.dispose();this.b.clear()}$onMessage(o,l,n){const s=this.j(o);if(s){const{message:a}=(0,E.$Gcb)(l,n.value);s._onMessageEmitter.fire(a)}}$onMissingCsp(o,l){this.g.warn(`${l} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(o,l,n){const s=new D(o,this.a,i(l),this.c,this.f,n,this.h);this.b.set(o,s);const a=s._onDidDispose(()=>{a.dispose(),this.deleteWebview(o)});return s}deleteWebview(o){this.b.delete(o)}j(o){return this.b.get(o)}}e.$oec=v;function g(c){return{id:c.identifier,location:c.extensionLocation}}e.$pec=g;function t(c,o,l){return{enableCommandUris:l.enableCommandUris,enableScripts:l.enableScripts,enableForms:l.enableForms,portMapping:l.portMapping,localResourceRoots:l.localResourceRoots||r(c,o)}}e.$qec=t;function i(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(o=>A.URI.from(o))}}function r(c,o){return[...(o?.getWorkspaceFolders()||[]).map(l=>l.uri),c.extensionLocation]}}),define(Pe[272],Ae([1,0,19,97,6,13,25,2,8,65,75,3,7]),function(we,e,y,T,P,M,A,$,E,f,C,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sec=void 0;class b{constructor(s,a){this.document=s,this.b=a,this.a=1,this.c=new C.$Rdc("custom documents")}addEdit(s){return this.c.add([s])}async undo(s,a){await this.f(s).undo(),a||this.disposeBackup()}async redo(s,a){await this.f(s).redo(),a||this.disposeBackup()}disposeEdits(s){for(const a of s)this.c.delete(a)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const s=l(this.document.uri)+this.a++;return(0,A.$zg)(this.b,s)}updateBackup(s){this.d?.delete(),this.d=s}disposeBackup(){this.d?.delete(),this.d=void 0}f(s){const a=this.c.get(s,0);if(!a)throw new Error("No edit found");return a}}class v{constructor(){this.a=new Map}get(s,a){return this.a.get(this.b(s,a))}add(s,a,d){const p=this.b(s,a.uri);if(this.a.has(p))throw new Error(`Document already exists for viewType:${s} resource:${a.uri}`);const m=new b(a,d);return this.a.set(p,m),m}delete(s,a){const d=this.b(s,a.uri);this.a.delete(d)}b(s,a){return`${s}@@@${a}`}}var g;(function(n){n[n.Text=0]="Text",n[n.Custom=1]="Custom"})(g||(g={}));class t{constructor(){this.a=new Map}addTextProvider(s,a,d){return this.b(0,s,a,d)}addCustomProvider(s,a,d){return this.b(1,s,a,d)}get(s){return this.a.get(s)}b(s,a,d,p){if(this.a.has(a))throw new Error(`Provider for viewType:${a} already registered`);return this.a.set(a,{type:s,extension:d,provider:p}),new u.$AK(()=>this.a.delete(a))}}class i{constructor(s,a,d,p,m){this.d=a,this.f=d,this.g=p,this.h=m,this.b=new t,this.c=new v,this.a=s.getProxy(D.$yK.MainThreadCustomEditors)}registerCustomEditorProvider(s,a,d,p){const m=new P.$Qc;return c(d)?(m.add(this.b.addTextProvider(a,s,d)),this.a.$registerTextEditorProvider((0,f.$pec)(s),a,p.webviewOptions||{},{supportsMove:!!d.moveCustomTextEditor},(0,f.$nec)(s))):(m.add(this.b.addCustomProvider(a,s,d)),r(d)&&m.add(d.onDidChangeCustomDocument(S=>{const k=this.i(a,S.document.uri);if(o(S)){const h=k.addEdit(S);this.a.$onDidEdit(S.document.uri,a,h,S.label)}else this.a.$onContentChange(S.document.uri,a)})),this.a.$registerCustomEditorProvider((0,f.$pec)(s),a,p.webviewOptions||{},!!p.supportsMultipleEditorsPerDocument,(0,f.$nec)(s))),u.$AK.from(m,new u.$AK(()=>{this.a.$unregisterEditorProvider(a)}))}async $createCustomDocument(s,a,d,p,m){const S=this.b.get(a);if(!S)throw new Error(`No provider found for '${a}'`);if(S.type!==1)throw new Error(`Invalid provide type for '${a}'`);const k=$.URI.revive(s),h=await S.provider.openCustomDocument(k,{backupId:d,untitledDocumentData:p?.buffer},m);let w;return r(S.provider)&&this.f&&(w=this.f.workspaceValue(S.extension)??this.f.globalValue(S.extension)),this.c.add(a,h,w),{editable:r(S.provider)}}async $disposeCustomDocument(s,a){const d=this.b.get(a);if(!d)throw new Error(`No provider found for '${a}'`);if(d.type!==1)throw new Error(`Invalid provider type for '${a}'`);const p=$.URI.revive(s),{document:m}=this.i(a,p);this.c.delete(a,m),m.dispose()}async $resolveCustomEditor(s,a,d,p,m,S){const k=this.b.get(d);if(!k)throw new Error(`No provider found for '${d}'`);const h=E.ViewColumn.to(m),w=this.g.createNewWebview(a,p.contentOptions,k.extension),I=this.h.createNewWebviewPanel(a,d,p.title,h,p.options,w,p.active),F=$.URI.revive(s);switch(k.type){case 1:{const{document:V}=this.i(d,F);return k.provider.resolveCustomEditor(V,I,S)}case 0:{const V=this.d.getDocument(F);return k.provider.resolveCustomTextEditor(V,I,S)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,a,d){this.i(a,s).disposeEdits(d)}async $onMoveCustomEditor(s,a,d){const p=this.b.get(d);if(!p)throw new Error(`No provider found for '${d}'`);if(!p.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${d}'`);const m=this.h.getWebviewPanel(s);if(!m)throw new Error("No webview found");const S=$.URI.revive(a),k=this.d.getDocument(S);await p.provider.moveCustomTextEditor(k,m,y.CancellationToken.None)}async $undo(s,a,d,p){return this.i(a,s).undo(d,p)}async $redo(s,a,d,p){return this.i(a,s).redo(d,p)}async $revert(s,a,d){const p=this.i(a,s);await this.j(a).revertCustomDocument(p.document,d),p.disposeBackup()}async $onSave(s,a,d){const p=this.i(a,s);await this.j(a).saveCustomDocument(p.document,d),p.disposeBackup()}async $onSaveAs(s,a,d,p){const m=this.i(a,s);return this.j(a).saveCustomDocumentAs(m.document,$.URI.revive(d),p)}async $backup(s,a,d){const p=this.i(a,s),S=await this.j(a).backupCustomDocument(p.document,{destination:p.getNewBackupUri()},d);return p.updateBackup(S),S.id}i(s,a){const d=this.c.get(s,$.URI.revive(a));if(!d)throw new Error("No custom document found");return d}j(s){const d=this.b.get(s)?.provider;if(!d||!r(d))throw new Error("Custom document is not editable");return d}}e.$sec=i;function r(n){return!!n.onDidChangeCustomDocument}function c(n){return typeof n.resolveCustomTextEditor=="function"}function o(n){return typeof n.undo=="function"&&typeof n.redo=="function"}function l(n){const s=n.scheme===M.Schemas.file||n.scheme===M.Schemas.untitled?n.fsPath:n.toString();return(0,T.$Ji)(s)+""}}),define(Pe[273],Ae([1,0,5,6,2,38,8,65,3,7]),function(we,e,y,T,P,M,A,$,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rec=void 0;class C extends T.$Rc{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;#h;constructor(v,g,t,i){super(),this.#s=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new y.$Rd),this.onDidDispose=this.#d.event,this.#h=this.B(new y.$Rd),this.onDidChangeViewState=this.#h.event,this.#e=v,this.#t=g,this.#o=t,this.#i=i.viewType,this.#r=i.panelOptions,this.#s=i.viewColumn,this.#n=i.title,this.#u=i.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#o.dispose(),super.dispose())}get webview(){return this.c(),this.#o}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(v){this.c(),this.#n!==v&&(this.#n=v,this.#t.$setTitle(this.#e,v))}get iconPath(){return this.c(),this.#a}set iconPath(v){this.c(),this.#a!==v&&(this.#a=v,this.#t.$setIconPath(this.#e,P.URI.isUri(v)?{light:v,dark:v}:v))}get options(){return this.#r}get viewColumn(){if(this.c(),!(typeof this.#s=="number"&&this.#s<0))return this.#s}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(v){this.#l||(this.active!==v.active||this.visible!==v.visible||this.viewColumn!==v.viewColumn)&&(this.#u=v.active,this.#c=v.visible,this.#s=v.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(v,g){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof v>"u"?void 0:A.ViewColumn.from(v),preserveFocus:!!g})}c(){if(this.#l)throw new Error("Webview is disposed")}}class D extends T.$Rc{static c(){return(0,M.$ig)()}constructor(v,g,t){super(),this.j=g,this.m=t,this.g=new Map,this.h=new Map,this.f=v.getProxy(E.$yK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(v=>v.dispose()),this.g.clear()}createWebviewPanel(v,g,t,i,r={}){const c=typeof i=="object"?i.viewColumn:i,o={viewColumn:A.ViewColumn.from(c),preserveFocus:typeof i=="object"&&!!i.preserveFocus},l=(0,$.$nec)(v),n=D.c();this.f.$createWebviewPanel((0,$.$pec)(v),n,g,{title:t,panelOptions:u(r),webviewOptions:(0,$.$qec)(v,this.m,r),serializeBuffersForPostMessage:l},o);const s=this.j.createNewWebview(n,r,v);return this.createNewWebviewPanel(n,g,t,c,r,s,!0)}$onDidChangeWebviewPanelViewStates(v){const g=Object.keys(v);g.sort((t,i)=>{const r=v[t],c=v[i];return r.active?1:c.active?-1:+r.visible-+c.visible});for(const t of g){const i=this.getWebviewPanel(t);if(!i)continue;const r=v[t];i._updateViewState({active:r.active,visible:r.visible,viewColumn:A.ViewColumn.to(r.position)})}}async $onDidDisposeWebviewPanel(v){this.getWebviewPanel(v)?.dispose(),this.g.delete(v),this.j.deleteWebview(v)}registerWebviewPanelSerializer(v,g,t){if(this.h.has(g))throw new Error(`Serializer for '${g}' already registered`);return this.h.set(g,{serializer:t,extension:v}),this.f.$registerSerializer(g,{serializeBuffersForPostMessage:(0,$.$nec)(v)}),new f.$AK(()=>{this.h.delete(g),this.f.$unregisterSerializer(g)})}async $deserializeWebviewPanel(v,g,t,i){const r=this.h.get(g);if(!r)throw new Error(`No serializer found for '${g}'`);const{serializer:c,extension:o}=r,l=this.j.createNewWebview(v,t.webviewOptions,o),n=this.createNewWebviewPanel(v,g,t.title,i,t.panelOptions,l,t.active);await c.deserializeWebviewPanel(n,t.state)}createNewWebviewPanel(v,g,t,i,r,c,o){const l=new C(v,this.f,c,{viewType:g,title:t,viewColumn:i,panelOptions:r,active:o});return this.g.set(v,l),l}getWebviewPanel(v){return this.g.get(v)}}e.$rec=D;function u(b){return{enableFindWidget:b.enableFindWidget,retainContextWhenHidden:b.retainContextWhenHidden}}}),define(Pe[274],Ae([1,0,5,6,65,8,3,7]),function(we,e,y,T,P,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vfc=void 0;class E extends T.$Rc{#e;#t;#i;#o;#r;#n;#a;#s;#c;constructor(D,u,b,v,g,t){super(),this.#r=!1,this.#u=this.B(new y.$Rd),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new y.$Rd),this.onDidDispose=this.#l.event,this.#i=b,this.#a=v,this.#e=D,this.#t=u,this.#o=g,this.#n=t}dispose(){this.#r||(this.#r=!0,this.#l.fire(),this.#o.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(D){this.a(),this.#a!==D&&(this.#a=D,this.#t.$setWebviewViewTitle(this.#e,D))}get description(){return this.a(),this.#s}set description(D){this.a(),this.#s!==D&&(this.#s=D,this.#t.$setWebviewViewDescription(this.#e,D))}get visible(){return this.#n}get webview(){return this.#o}get viewType(){return this.#i}_setVisible(D){D===this.#n||this.#r||(this.#n=D,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(D){this.a(),!(D?.value===this.#c?.value&&D?.tooltip===this.#c?.tooltip)&&(this.#c=M.ViewBadge.from(D),this.#t.$setWebviewViewBadge(this.#e,D))}show(D){this.a(),this.#t.$show(this.#e,!!D)}a(){if(this.#r)throw new Error("Webview is disposed")}}class f{constructor(D,u){this.d=u,this.b=new Map,this.c=new Map,this.a=D.getProxy(A.$yK.MainThreadWebviewViews)}registerWebviewViewProvider(D,u,b,v){if(this.b.has(u))throw new Error(`View provider for '${u}' already registered`);return this.b.set(u,{provider:b,extension:D}),this.a.$registerWebviewViewProvider((0,P.$pec)(D),u,{retainContextWhenHidden:v?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,P.$nec)(D)}),new $.$AK(()=>{this.b.delete(u),this.a.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(D,u,b,v,g){const t=this.b.get(u);if(!t)throw new Error(`No view provider found for '${u}'`);const{provider:i,extension:r}=t,c=this.d.createNewWebview(D,{},r),o=new E(D,this.a,u,b,c,!0);this.c.set(D,o),await i.resolveWebviewView(o,{state:v},g)}async $onDidChangeWebviewViewVisibility(D,u){this.e(D)._setVisible(u)}async $disposeWebviewView(D){const u=this.e(D);this.c.delete(D),u.dispose(),this.d.deleteWebview(D)}e(D){const u=this.c.get(D);if(!u)throw new Error("No webview found");return u}}e.$Vfc=f}),define(Pe[111],Ae([1,0,5,3,2,13,12,4,17,23]),function(we,e,y,T,P,M,A,$,E,f){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$Xfc=e.$Wfc=void 0;let D=class{static{C=this}static{this.a={focused:!0,active:!0}}getState(b){const v=this.d;return{get focused(){return v.focused},get active(){return(0,f.$MF)(b,"windowActivity"),v.active}}}constructor(b){this.c=new y.$Rd,this.onDidChangeWindowState=this.c.event,this.d=C.a,this.b=b.getProxy(T.$yK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:v,isActive:g})=>{this.onDidChangeWindowProperty("focused",v),this.onDidChangeWindowProperty("active",g)})}$onDidChangeWindowFocus(b){this.onDidChangeWindowProperty("focused",b)}$onDidChangeWindowActive(b){this.onDidChangeWindowProperty("active",b)}onDidChangeWindowProperty(b,v){v!==this.d[b]&&(this.d={...this.d,[b]:v},this.c.fire(this.d))}openUri(b,v){let g;if(typeof b=="string"){g=b;try{b=P.URI.parse(b)}catch{return Promise.reject(`Invalid uri - '${b}'`)}}return(0,A.$Fe)(b.scheme)?Promise.reject("Invalid scheme - cannot be empty"):b.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${b.scheme}'`):this.b.$openUri(b,g,v)}async asExternalUri(b,v){if((0,A.$Fe)(b.scheme))return Promise.reject("Invalid scheme - cannot be empty");const g=await this.b.$asExternalUri(b,v);return P.URI.from(g)}};e.$Wfc=D,e.$Wfc=D=C=Ke([Ve(0,E.$AM)],D),e.$Xfc=(0,$.$Vh)("IExtHostWindow")}),define(Pe[275],Ae([1,0,241,27,17]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9hc=void 0;let M=class extends y.$1fc{constructor($,E){super($,E)}f($,E,f){E.apply(console,f)}};e.$9hc=M,e.$9hc=M=Ke([Ve(0,P.$AM),Ve(1,T.$QM)],M)}),define(Pe[276],Ae([1,0,14,24,19,11,5,6,139,230,49]),function(we,e,y,T,P,M,A,$,E,f,C){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$c6b=e.ResponsiveState=e.RequestInitiator=e.$b6b=e.$a6b=void 0;function u(I,F){try{return JSON.stringify(I,F)}catch{return"null"}}const b="$$ref$$",v={[b]:-1};class g{constructor(F,V){this.jsonString=F,this.referencedBuffers=V}}function t(I,F=null,V=!1){const Z=[];return{jsonString:(V?u:JSON.stringify)(I,(R,L)=>{if(typeof L>"u")return v;if(typeof L=="object"){if(L instanceof T.$fe){const O=Z.push(L)-1;return{[b]:O}}if(F)return F(R,L)}return L}),referencedBuffers:Z}}e.$a6b=t;function i(I,F,V){return JSON.parse(I,(Z,N)=>{if(N){const R=N[b];if(typeof R=="number")return F[R];if(V&&N.$mid===1)return V.transformIncoming(N)}return N})}e.$b6b=i;function r(I,F){return JSON.stringify(I,F)}function c(I){return I?(F,V)=>V&&V.$mid===1?I.transformOutgoing(V):V:null}var o;(function(I){I[I.LocalSide=0]="LocalSide",I[I.OtherSide=1]="OtherSide"})(o||(e.RequestInitiator=o={}));var l;(function(I){I[I.Responsive=0]="Responsive",I[I.Unresponsive=1]="Unresponsive"})(l||(e.ResponsiveState=l={}));const n=()=>{},s=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class d extends $.$Rc{static{D=s}static{this.a=3*1e3}constructor(F,V=null,Z=null){super(),this[D]=!0,this.b=this.B(new A.$Rd),this.onDidChangeResponsiveState=this.b.event,this.c=F,this.f=V,this.g=Z,this.h=c(this.g),this.j=!1,this.m=[],this.s=[];for(let N=0,R=C.$tv.count;N<R;N++)this.m[N]=null,this.s[N]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new y.$0g(()=>this.H(),1e3)),this.c.onMessage(N=>this.L(N))}dispose(){this.j=!0,Object.keys(this.w).forEach(F=>{const V=this.w[F];delete this.w[F],V.resolveErr(M.$5())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(F){this.z===0&&(this.C=Date.now()+d.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(F){this.C=Date.now()+d.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(F){this.y!==F&&(this.y=F,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(F){return this.g?(0,E.$Um)(F,this.g):F}getProxy(F){const{nid:V,sid:Z}=F;return this.s[V]||(this.s[V]=this.J(V,Z)),this.s[V]}J(F,V){const Z={get:(N,R)=>(typeof R=="string"&&!N[R]&&R.charCodeAt(0)===36&&(N[R]=(...L)=>this.U(F,R,L)),R===a?V:N[R])};return new Proxy(Object.create(null),Z)}set(F,V){return this.m[F.nid]=V,V}assertRegistered(F){for(let V=0,Z=F.length;V<Z;V++){const N=F[V];if(!this.m[N.nid])throw new Error(`Missing proxy instance ${N.sid}`)}}L(F){if(this.j)return;const V=F.byteLength,Z=m.read(F,0),N=Z.readUInt8(),R=Z.readUInt32();switch(N){case 1:case 2:{let{rpcId:L,method:O,args:Y}=k.deserializeRequestJSONArgs(Z);this.g&&(Y=(0,E.$Um)(Y,this.g)),this.M(V,R,L,O,Y,N===2);break}case 3:case 4:{let{rpcId:L,method:O,args:Y}=k.deserializeRequestMixedArgs(Z);this.g&&(Y=(0,E.$Um)(Y,this.g)),this.M(V,R,L,O,Y,N===4);break}case 5:{this.f?.logIncoming(V,R,0,"ack"),this.G(R);break}case 6:{this.N(V,R);break}case 7:{this.O(V,R,void 0);break}case 9:{let L=k.deserializeReplyOKJSON(Z);this.g&&(L=(0,E.$Um)(L,this.g)),this.O(V,R,L);break}case 10:{const L=k.deserializeReplyOKJSONWithBuffers(Z,this.g);this.O(V,R,L);break}case 8:{const L=k.deserializeReplyOKVSBuffer(Z);this.O(V,R,L);break}case 11:{let L=k.deserializeReplyErrError(Z);this.g&&(L=(0,E.$Um)(L,this.g)),this.P(V,R,L);break}case 12:{this.P(V,R,void 0);break}default:console.error("received unexpected message"),console.error(F)}}M(F,V,Z,N,R,L){this.f?.logIncoming(F,V,1,`receiveRequest ${(0,C.$vv)(Z)}.${N}(`,R);const O=String(V);let Y,he;if(L){const De=new P.$2d;R.push(De.token),Y=this.Q(Z,N,R),he=()=>De.cancel()}else Y=this.Q(Z,N,R),he=n;this.u[O]=he;const $e=k.serializeAcknowledged(V);this.f?.logOutgoing($e.byteLength,V,1,"ack"),this.c.send($e),Y.then(De=>{delete this.u[O];const ke=k.serializeReplyOK(V,De,this.h);this.f?.logOutgoing(ke.byteLength,V,1,"reply:",De),this.c.send(ke)},De=>{delete this.u[O];const ke=k.serializeReplyErr(V,De);this.f?.logOutgoing(ke.byteLength,V,1,"replyErr:",De),this.c.send(ke)})}N(F,V){this.f?.logIncoming(F,V,1,"receiveCancel");const Z=String(V);this.u[Z]?.()}O(F,V,Z){this.f?.logIncoming(F,V,0,"receiveReply:",Z);const N=String(V);if(!this.w.hasOwnProperty(N))return;const R=this.w[N];delete this.w[N],R.resolveOk(Z)}P(F,V,Z){this.f?.logIncoming(F,V,0,"receiveReplyErr:",Z);const N=String(V);if(!this.w.hasOwnProperty(N))return;const R=this.w[N];delete this.w[N];let L;Z&&(Z.$isError?(L=new Error,L.name=Z.name,L.message=Z.message,L.stack=Z.stack):L=Z),R.resolveErr(L)}Q(F,V,Z){try{return Promise.resolve(this.S(F,V,Z))}catch(N){return Promise.reject(N)}}S(F,V,Z){const N=this.m[F];if(!N)throw new Error("Unknown actor "+(0,C.$vv)(F));const R=N[V];if(typeof R!="function")throw new Error("Unknown method "+V+" on actor "+(0,C.$vv)(F));return R.apply(N,Z)}U(F,V,Z){if(this.j)return new f.$_5b;let N=null;if(Z.length>0&&P.CancellationToken.isCancellationToken(Z[Z.length-1])&&(N=Z.pop()),N&&N.isCancellationRequested)return Promise.reject(M.$5());const R=k.serializeRequestArguments(Z,this.h),L=++this.t,O=String(L),Y=new f.$$5b,he=new $.$Qc;N&&he.add(N.onCancellationRequested(()=>{const De=k.serializeCancel(L);this.f?.logOutgoing(De.byteLength,L,0,"cancel"),this.c.send(k.serializeCancel(L))})),this.w[O]=new p(Y,he),this.F(L);const $e=k.serializeRequest(L,F,V,R,!!N);return this.f?.logOutgoing($e.byteLength,L,0,`request: ${(0,C.$vv)(F)}.${V}(`,Z),this.c.send($e),Y}}e.$c6b=d;class p{constructor(F,V){this.a=F,this.b=V}resolveOk(F){this.a.resolveOk(F),this.b.dispose()}resolveErr(F){this.a.resolveErr(F),this.b.dispose()}}class m{static alloc(F,V,Z){const N=new m(T.$fe.alloc(Z+1+4),0);return N.writeUInt8(F),N.writeUInt32(V),N}static read(F,V){return new m(F,V)}get buffer(){return this.a}constructor(F,V){this.a=F,this.b=V}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(F){this.a.writeUInt8(F,this.b),this.b+=1}readUInt8(){const F=this.a.readUInt8(this.b);return this.b+=1,F}writeUInt32(F){this.a.writeUInt32BE(F,this.b),this.b+=4}readUInt32(){const F=this.a.readUInt32BE(this.b);return this.b+=4,F}static sizeShortString(F){return 1+F.byteLength}writeShortString(F){this.a.writeUInt8(F.byteLength,this.b),this.b+=1,this.a.set(F,this.b),this.b+=F.byteLength}readShortString(){const F=this.a.readUInt8(this.b);this.b+=1;const Z=this.a.slice(this.b,this.b+F).toString();return this.b+=F,Z}static sizeLongString(F){return 4+F.byteLength}writeLongString(F){this.a.writeUInt32BE(F.byteLength,this.b),this.b+=4,this.a.set(F,this.b),this.b+=F.byteLength}readLongString(){const F=this.a.readUInt32BE(this.b);this.b+=4;const Z=this.a.slice(this.b,this.b+F).toString();return this.b+=F,Z}writeBuffer(F){this.a.writeUInt32BE(F.byteLength,this.b),this.b+=4,this.a.set(F,this.b),this.b+=F.byteLength}static sizeVSBuffer(F){return 4+F.byteLength}writeVSBuffer(F){this.a.writeUInt32BE(F.byteLength,this.b),this.b+=4,this.a.set(F,this.b),this.b+=F.byteLength}readVSBuffer(){const F=this.a.readUInt32BE(this.b);this.b+=4;const V=this.a.slice(this.b,this.b+F);return this.b+=F,V}static sizeMixedArray(F){let V=0;V+=1;for(let Z=0,N=F.length;Z<N;Z++){const R=F[Z];switch(V+=1,R.type){case 1:V+=this.sizeLongString(R.value);break;case 2:V+=this.sizeVSBuffer(R.value);break;case 3:V+=this.sizeUInt32,V+=this.sizeLongString(R.value);for(let L=0;L<R.buffers.length;++L)V+=this.sizeVSBuffer(R.buffers[L]);break;case 4:break}}return V}writeMixedArray(F){this.a.writeUInt8(F.length,this.b),this.b+=1;for(let V=0,Z=F.length;V<Z;V++){const N=F[V];switch(N.type){case 1:this.writeUInt8(1),this.writeLongString(N.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(N.value);break;case 3:this.writeUInt8(3),this.writeUInt32(N.buffers.length),this.writeLongString(N.value);for(let R=0;R<N.buffers.length;++R)this.writeBuffer(N.buffers[R]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const F=this.a.readUInt8(this.b);this.b+=1;const V=new Array(F);for(let Z=0;Z<F;Z++)switch(this.readUInt8()){case 1:V[Z]=this.readLongString();break;case 2:V[Z]=this.readVSBuffer();break;case 3:{const R=this.readUInt32(),L=this.readLongString(),O=[];for(let Y=0;Y<R;++Y)O.push(this.readVSBuffer());V[Z]=new C.$wv(i(L,O,null));break}case 4:V[Z]=void 0;break}return V}}var S;(function(I){I[I.Simple=0]="Simple",I[I.Mixed=1]="Mixed"})(S||(S={}));class k{static a(F){for(let V=0,Z=F.length;V<Z;V++)if(F[V]instanceof T.$fe||F[V]instanceof C.$wv||typeof F[V]>"u")return!0;return!1}static serializeRequestArguments(F,V){if(this.a(F)){const Z=[];for(let N=0,R=F.length;N<R;N++){const L=F[N];if(L instanceof T.$fe)Z[N]={type:2,value:L};else if(typeof L>"u")Z[N]={type:4};else if(L instanceof C.$wv){const{jsonString:O,referencedBuffers:Y}=t(L.value,V);Z[N]={type:3,value:T.$fe.fromString(O),buffers:Y}}else Z[N]={type:1,value:T.$fe.fromString(r(L,V))}}return{type:1,args:Z}}return{type:0,args:r(F,V)}}static serializeRequest(F,V,Z,N,R){switch(N.type){case 0:return this.b(F,V,Z,N.args,R);case 1:return this.c(F,V,Z,N.args,R)}}static b(F,V,Z,N,R){const L=T.$fe.fromString(Z),O=T.$fe.fromString(N);let Y=0;Y+=m.sizeUInt8(),Y+=m.sizeShortString(L),Y+=m.sizeLongString(O);const he=m.alloc(R?2:1,F,Y);return he.writeUInt8(V),he.writeShortString(L),he.writeLongString(O),he.buffer}static deserializeRequestJSONArgs(F){const V=F.readUInt8(),Z=F.readShortString(),N=F.readLongString();return{rpcId:V,method:Z,args:JSON.parse(N)}}static c(F,V,Z,N,R){const L=T.$fe.fromString(Z);let O=0;O+=m.sizeUInt8(),O+=m.sizeShortString(L),O+=m.sizeMixedArray(N);const Y=m.alloc(R?4:3,F,O);return Y.writeUInt8(V),Y.writeShortString(L),Y.writeMixedArray(N),Y.buffer}static deserializeRequestMixedArgs(F){const V=F.readUInt8(),Z=F.readShortString(),N=F.readMixedArray(),R=new Array(N.length);for(let L=0,O=N.length;L<O;L++){const Y=N[L];typeof Y=="string"?R[L]=JSON.parse(Y):R[L]=Y}return{rpcId:V,method:Z,args:R}}static serializeAcknowledged(F){return m.alloc(5,F,0).buffer}static serializeCancel(F){return m.alloc(6,F,0).buffer}static serializeReplyOK(F,V,Z){if(typeof V>"u")return this.d(F);if(V instanceof T.$fe)return this.e(F,V);if(V instanceof C.$wv){const{jsonString:N,referencedBuffers:R}=t(V.value,Z,!0);return this.g(F,N,R)}else return this.f(F,u(V,Z))}static d(F){return m.alloc(7,F,0).buffer}static e(F,V){let Z=0;Z+=m.sizeVSBuffer(V);const N=m.alloc(8,F,Z);return N.writeVSBuffer(V),N.buffer}static deserializeReplyOKVSBuffer(F){return F.readVSBuffer()}static f(F,V){const Z=T.$fe.fromString(V);let N=0;N+=m.sizeLongString(Z);const R=m.alloc(9,F,N);return R.writeLongString(Z),R.buffer}static g(F,V,Z){const N=T.$fe.fromString(V);let R=0;R+=m.sizeUInt32,R+=m.sizeLongString(N);for(const O of Z)R+=m.sizeVSBuffer(O);const L=m.alloc(10,F,R);L.writeUInt32(Z.length),L.writeLongString(N);for(const O of Z)L.writeBuffer(O);return L.buffer}static deserializeReplyOKJSON(F){const V=F.readLongString();return JSON.parse(V)}static deserializeReplyOKJSONWithBuffers(F,V){const Z=F.readUInt32(),N=F.readLongString(),R=[];for(let L=0;L<Z;++L)R.push(F.readVSBuffer());return new C.$wv(i(N,R,V))}static serializeReplyErr(F,V){const Z=V?u(M.$2(V),null):void 0;if(typeof Z!="string")return this.h(F);const N=T.$fe.fromString(Z);let R=0;R+=m.sizeLongString(N);const L=m.alloc(11,F,R);return L.writeLongString(N),L.buffer}static deserializeReplyErrError(F){const V=F.readLongString();return JSON.parse(V)}static h(F){return m.alloc(12,F,0).buffer}}var h;(function(I){I[I.RequestJSONArgs=1]="RequestJSONArgs",I[I.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",I[I.RequestMixedArgs=3]="RequestMixedArgs",I[I.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",I[I.Acknowledged=5]="Acknowledged",I[I.Cancel=6]="Cancel",I[I.ReplyOKEmpty=7]="ReplyOKEmpty",I[I.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",I[I.ReplyOKJSON=9]="ReplyOKJSON",I[I.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",I[I.ReplyErrError=11]="ReplyErrError",I[I.ReplyErrEmpty=12]="ReplyErrEmpty"})(h||(h={}));var w;(function(I){I[I.String=1]="String",I[I.VSBuffer=2]="VSBuffer",I[I.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",I[I.Undefined=4]="Undefined"})(w||(w={}))}),define(Pe[277],Ae([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$hc=void 0;const y=function(M){const A=$=>{globalThis.removeEventListener("message",A);const E=$.data;Object.defineProperties(globalThis,{postMessage:{value(f,C){E.postMessage(f,C)}},onmessage:{get(){return E.onmessage},set(f){E.onmessage=f}}}),E.addEventListener("message",f=>{globalThis.dispatchEvent(new MessageEvent("message",{data:f.data,ports:f.ports?[...f.ports]:void 0}))}),E.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(M)};globalThis.addEventListener("message",A)}.toString();class T extends EventTarget{constructor(M,A,$){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const E=`((${y})('${A}'))`,f=new Blob([E],{type:"application/javascript"}),C=URL.createObjectURL(f),D=new MessageChannel,u=C,b={type:"_newWorker",id:u,port:D.port2,url:C,options:$};M(b,[D.port2]),this.postMessage=D.port1.postMessage.bind(D.port1),this.terminate=()=>{M({type:"_terminateWorker",id:u}),URL.revokeObjectURL(C),D.port1.close(),D.port2.close()},Object.defineProperties(this,{onmessage:{get(){return D.port1.onmessage},set(v){D.port1.onmessage=v}},onmessageerror:{get(){return D.port1.onmessageerror},set(v){D.port1.onmessageerror=v}}}),D.port1.addEventListener("messageerror",v=>{const g=new MessageEvent("messageerror",{data:v.data});this.dispatchEvent(g)}),D.port1.addEventListener("message",v=>{const g=new MessageEvent("message",{data:v.data});this.dispatchEvent(g)}),D.port1.start()}}e.$$hc=T}),define(Pe[278],Ae([1,0,5,30,34,4]),function(we,e,y,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UJ=e.$TJ=e.OutputChannelUpdateMode=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=void 0,e.$JJ="text/x-code-output",e.$KJ="output",e.$LJ="Log",e.$MJ="text/x-code-log-output",e.$NJ="log",e.$OJ="workbench.panel.output",e.$PJ=new P.$aj("inOutput",!1),e.$QJ=new P.$aj("activeLogOutput",!1),e.$RJ=new P.$aj("outputView.scrollLock",!1),e.$SJ=(0,M.$Vh)("outputService");var A;(function(E){E[E.Append=1]="Append",E[E.Replace=2]="Replace",E[E.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$TJ={OutputChannels:"workbench.contributions.outputChannels"};class ${constructor(){this.a=new Map,this.b=new y.$Rd,this.onDidRegisterChannel=this.b.event,this.c=new y.$Rd,this.onDidRemoveChannel=this.c.event}registerChannel(f){this.a.has(f.id)||(this.a.set(f.id,f),this.b.fire(f.id))}getChannels(){const f=[];return this.a.forEach(C=>f.push(C)),f}getChannel(f){return this.a.get(f)}removeChannel(f){this.a.delete(f),this.c.fire(f)}}T.$mn.add(e.$TJ.OutputChannels,new $),e.$UJ=new P.$aj("activeOutputChannel","")}),define(Pe[112],Ae([1,0,3,4,17,22,15,278,63,27,42,136,24,16,41,5,6]),function(we,e,y,T,P,M,A,$,E,f,C,D,u,b,v,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xfc=e.$wfc=void 0;class i extends A.$jj{get disposed(){return this.n}constructor(l,n,s,a,d){super(),this.id=l,this.name=n,this.r=s,this.s=a,this.extension=d,this.m=0,this.n=!1,this.visible=!1,this.setLevel(s.getLevel()),this.B(s.onDidChangeLogLevel(p=>this.setLevel(p)))}get logLevel(){return this.getLevel()}appendLine(l){this.append(l+`
`)}append(l){this.info(l)}clear(){const l=this.m;this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Clear,l)}replace(l){const n=this.m;this.info(l),this.s.$update(this.id,$.OutputChannelUpdateMode.Replace,n),this.visible&&this.r.flush()}show(l,n){this.r.flush(),this.s.$reveal(this.id,!!(typeof l=="boolean"?l:n))}hide(){this.s.$close(this.id)}g(l,n){this.m+=u.$fe.fromString(n).byteLength,(0,A.log)(this.r,l,n),this.visible&&(this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class r extends i{appendLine(l){this.append(l)}}let c=class{constructor(l,n,s,a,d,p){this.i=n,this.j=s,this.k=a,this.l=d,this.m=p,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=l.getProxy(y.$yK.MainThreadOutputService),this.b=this.k.extUri.joinPath(n.logsLocation,`output_logging_${(0,D.$km)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(l){this.h=l;for(const[n,s]of this.g)s.visible=n===this.h}createOutputChannel(l,n,s){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");const a=typeof n=="object"&&n.log,d=(0,b.$Cf)(n)?n:void 0;if((0,b.$Cf)(d)&&!d.trim())throw new Error("illegal argument `languageId`. must not be empty");let p;const m=this.i.environment.extensionLogLevel?.find(([k])=>M.$_l.equals(s.identifier,k))?.[1];m&&(p=(0,A.$tj)(m));const S=a?this.o(l,p,s):this.n(l,d,s);return S.then(k=>{this.g.set(k.id,k),k.visible=k.id===this.h}),a?this.r(l,p??this.m.getLevel(),S):this.q(l,S)}async n(l,n,s){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const a=await this.c,d=this.k.extUri.joinPath(a,`${this.f++}-${l.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),p=this.l.createLogger(d,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),m=await this.a.$register(l,d,n,s.identifier.value);return new i(m,l,p,this.a,s)}async o(l,n,s){const a=await this.p(s),d=l.replace(/[\\/:\*\?"<>\|]/g,""),p=this.k.extUri.joinPath(a,`${d}.log`),m=`${s.identifier.value}.${d}`,S=this.l.createLogger(p,{id:m,name:l,logLevel:n,extensionId:s.identifier.value});return new r(m,l,S,this.a,s)}p(l){let n=this.d.get(l.identifier.value);if(!n){const s=this.k.extUri.joinPath(this.i.logsLocation,l.identifier.value);this.d.set(l.identifier.value,n=(async()=>{try{await this.j.value.createDirectory(s)}catch(a){if((0,v.$uk)(a)!==v.FileSystemProviderErrorCode.FileExists)throw a}return s})())}return n}q(l,n){let s=!1;const a=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return l},append(d){a(),n.then(p=>p.append(d))},appendLine(d){a(),n.then(p=>p.appendLine(d))},clear(){a(),n.then(d=>d.clear())},replace(d){a(),n.then(p=>p.replace(d))},show(d,p){a(),n.then(m=>m.show(d,p))},hide(){a(),n.then(d=>d.hide())},dispose(){s=!0,n.then(d=>d.dispose())}}}r(l,n,s){const a=new t.$Qc,d=()=>{if(a.isDisposed)throw new Error("Channel has been closed")},p=a.add(new g.$Rd);function m(S){n=S,p.fire(S)}return s.then(S=>{a.add(S),S.logLevel!==n&&m(S.logLevel),a.add(S.onDidChangeLogLevel(k=>m(k)))}),{...this.q(l,s),get logLevel(){return n},onDidChangeLogLevel:p.event,trace(S,...k){d(),s.then(h=>h.trace(S,...k))},debug(S,...k){d(),s.then(h=>h.debug(S,...k))},info(S,...k){d(),s.then(h=>h.info(S,...k))},warn(S,...k){d(),s.then(h=>h.warn(S,...k))},error(S,...k){d(),s.then(h=>h.error(S,...k))},dispose(){a.dispose()}}}};e.$wfc=c,e.$wfc=c=Ke([Ve(0,P.$AM),Ve(1,f.$QM),Ve(2,E.$jec),Ve(3,C.$Vdc),Ve(4,A.$ej),Ve(5,A.$dj)],c),e.$xfc=(0,T.$Vh)("IExtHostOutputService")}),define(Pe[113],Ae([1,0,4,14]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Am=e.$zm=void 0,e.$zm=(0,y.$Vh)("remoteAgentService"),e.$Am=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(P){let M=1/0;for(let $=0;$<this.maxSampleCount;$++){const E=await P.getRoundTripTime();if(E===void 0)return;M=Math.min(M,E/2),await(0,T.$Yg)(this.sampleDelay)}this.average.push(M),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(M):A=this.initial.reduce(($,E)=>$+E,0)/this.initial.length,this.lastMeasurement={initial:A,current:M,average:this.average.reduce(($,E)=>$+E,0)/this.average.length,high:(()=>typeof A>"u"?!1:M>this.highLatencyMaxThreshold||M>this.highLatencyMinThreshold&&M>A*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Pe[279],Ae([1,0,170,54,30,47,40,6,5,113,21,26]),function(we,e,y,T,P,M,A,$,E,f,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tH=e.$sH=e.$rH=e.$qH=e.$pH=e.$oH=void 0,e.$oH=Object.freeze({id:"application",order:100,title:(0,y.localize)(0,null),type:"object"}),e.$pH=Object.freeze({id:"workbench",order:7,title:(0,y.localize)(1,null),type:"object"}),e.$qH=Object.freeze({id:"security",scope:1,title:(0,y.localize)(2,null),type:"object",order:7}),e.$rH={ConfigurationMigration:"base.contributions.configuration.migration"};class u{constructor(){this.migrations=[],this.a=new E.$Rd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(i){this.migrations.push(...i)}}const b=new u;P.$mn.add(e.$rH.ConfigurationMigration,b);let v=class extends $.$Rc{constructor(i,r){super(),this.a=i,this.b=r,this.B(this.b.onDidChangeWorkspaceFolders(async c=>{for(const o of c.added)await this.f(o,b.migrations)})),this.c(b.migrations),this.B(b.onDidRegisterConfigurationMigration(c=>this.c(c)))}async c(i){await this.f(void 0,i);for(const r of this.b.getWorkspace().folders)await this.f(r,i)}async f(i,r){await Promise.all([r.map(c=>this.g(c,i?.uri))])}async g(i,r){const c=this.a.inspect(i.key,{resource:r}),o=[["userValue",2],["userLocalValue",3],["userRemoteValue",4],["workspaceValue",5],["workspaceFolderValue",6]];for(const[l,n]of o){const s=[];for(const d of c.overrideIdentifiers??[]){const p=await this.h(i,{resource:r,overrideIdentifier:d},l);for(const m of p??[]){let S=s.find(([[k,h]])=>k===m[0]&&(0,D.$en)(h.value,m[1].value));S||s.push(S=[m,[]]),S[1].push(d)}}const a=await this.h(i,{resource:r},l,c);for(const d of a??[])s.push([d,[]]);s.length&&await Promise.allSettled(s.map(async([[d,p],m])=>this.a.updateValue(d,p.value,{resource:r,overrideIdentifiers:m},n)))}}async h(i,r,c,o){const l=(o??this.a.inspect(i.key,r))[c];if(l===void 0)return;const n=a=>this.a.inspect(a,r)[c],s=await i.migrateFn(l,n);return Array.isArray(s)?s:[[i.key,s]]}};e.$sH=v,e.$sH=v=Ke([Ve(0,A.$pi),Ve(1,M.$5h)],v);let g=class extends $.$Rc{constructor(i){super(),(async()=>{if(!C.$i&&(await i.getEnvironment())?.os!==1)return;P.$mn.as(T.$rn.Configuration).registerConfiguration({...e.$qH,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,y.localize)(3,null)},default:[],markdownDescription:(0,y.localize)(4,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,y.localize)(5,null),scope:2}}})})()}};e.$tH=g,e.$tH=g=Ke([Ve(0,f.$zm)],g)}),define(Pe[280],Ae([1,0,33,13,20,25,178,279,54,4,30]),function(we,e,y,T,P,M,A,$,E,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zbb=e.$Ybb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$Xbb=e.$Wbb=void 0,e.$Wbb=(0,f.$Vh)("editorResolverService"),e.$Xbb="workbench.editorAssociations";const D=C.$mn.as(E.$rn.Configuration),u={...$.$pH,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,A.localize)(0,null),additionalProperties:{type:"string"}}}};D.registerConfiguration(u);var b;(function(i){i.builtin="builtin",i.option="option",i.exclusive="exclusive",i.default="default"})(b||(e.RegisteredEditorPriority=b={}));var v;(function(i){i[i.ABORT=1]="ABORT",i[i.NONE=2]="NONE"})(v||(e.ResolvedStatus=v={}));function g(i){switch(i){case b.exclusive:return 5;case b.default:return 4;case b.builtin:return 3;case b.option:default:return 1}}e.$Ybb=g;function t(i,r){if(new Set([T.Schemas.extension,T.Schemas.webviewPanel,T.Schemas.vscodeWorkspaceTrust,T.Schemas.vscodeSettings]).has(r.scheme))return!1;const l=typeof i=="string"&&i.indexOf(P.$fc.sep)>=0?`${r.scheme}:${r.path}`:(0,M.$wg)(r);return y.$Bj(typeof i=="string"?i.toLowerCase():i,l.toLowerCase())}e.$Zbb=t}),define(Pe[281],Ae([1,0,46,13,20,21,25,2,4,199,47,217,113]),function(we,e,y,T,P,M,A,$,E,f,C,D,u){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$bK=e.$aK=void 0,e.$aK=(0,E.$Vh)("pathService");let v=b=class{constructor(t,i,r,c){this.d=t,this.e=i,this.f=r,this.g=c,this.a=(async()=>(await this.e.getEnvironment())?.os||M.OS)(),this.b=(async()=>{const o=await this.e.getEnvironment();return this.c=o?.userHome??t})()}hasValidBasename(t,i,r){return typeof i=="string"||typeof i>"u"?this.a.then(c=>this.h(t,c,i)):this.h(t,i,r)}h(t,i,r){return t.scheme===T.Schemas.file||t.scheme===T.Schemas.vscodeRemote?(0,y.$Zf)(r??(0,A.$wg)(t),i===1):!0}get defaultUriScheme(){return b.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(t,i){if(t.remoteAuthority)return T.Schemas.vscodeRemote;const r=(0,f.$0J)(i.getWorkspace());if(r)return r;const c=i.getWorkspace().folders[0];if(c)return c.uri.scheme;const o=i.getWorkspace().configuration;return o?o.scheme:T.Schemas.file}userHome(t){return t?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(t=>t===1?P.$ec:P.$fc)}async fileURI(t){let i="";if(await this.a===1&&(t=t.replace(/\\/g,"/")),t[0]==="/"&&t[1]==="/"){const c=t.indexOf("/",2);c===-1?(i=t.substring(2),t="/"):(i=t.substring(2,c),t=t.substring(c)||"/")}return $.URI.from({scheme:T.Schemas.file,authority:i,path:t,query:"",fragment:""})}};e.$bK=v,e.$bK=v=b=Ke([Ve(1,u.$zm),Ve(2,D.$VJ),Ve(3,C.$5h)],v)}),define(Pe[114],Ae([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$QI=e.$PI=void 0;class y{constructor(A,$){this.line=A,this.character=$}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,$){return new y(0,0)}with(A){return new y(0,0)}}e.$PI=y;class T{constructor(A,$,E,f){this.isEmpty=!1,this.isSingleLine=!1,this.start=new y(A,$),this.end=new y(E,f)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new T(0,0,0,0)}with(A){return new T(0,0,0,0)}}e.$QI=T;var P;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(P||(e.TextSearchCompleteMessageType=P={}))}),define(Pe[43],Ae([1,0,18,33,26,46,12,4,20,11,114,14]),function(we,e,y,T,P,M,A,$,E,f,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.SearchErrorCode=e.$6I=e.$5I=e.SearchSortOrder=e.ViewMode=e.$4I=e.$3I=e.$2I=e.$1I=e.SearchCompletionExitCode=e.$ZI=e.$YI=e.$XI=e.QueryType=e.SearchProviderType=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return C.TextSearchCompleteMessageType}}),e.$RI="workbench.view.search",e.$SI="workbench.panel.search",e.$TI="workbench.view.search",e.$UI="search-result",e.$VI="search.exclude";const u="\u27EA ",b=" characters skipped \u27EB",v=(u.length+b.length+5)*2;e.$WI=(0,$.$Vh)("searchService");var g;(function(fe){fe[fe.file=0]="file",fe[fe.text=1]="text"})(g||(e.SearchProviderType=g={}));var t;(function(fe){fe[fe.File=1]="File",fe[fe.Text=2]="Text"})(t||(e.QueryType=t={}));function i(fe){return!!fe.preview}e.$XI=i;function r(fe){return!!fe.resource}e.$YI=r;function c(fe){return!!fe.message}e.$ZI=c;var o;(function(fe){fe[fe.Normal=0]="Normal",fe[fe.NewSearchStarted=1]="NewSearchStarted"})(o||(e.SearchCompletionExitCode=o={}));class l{constructor(ve){this.resource=ve,this.results=[]}}e.$1I=l;class n{constructor(ve,te,Re,se){this.ranges=te,this.webviewIndex=se;const Q=Array.isArray(te)?te:[te];if(Re&&Re.matchLines===1&&s(Q)){ve=(0,A.$vf)(ve,Re.matchLines);let B="",ne=0,pe=0;const re=Math.floor(Re.charsPerLine/5),le=[];for(const ce of Q){const ye=Math.max(ce.startColumn-re,0),_=ce.startColumn+Re.charsPerLine;if(ye>pe+re+v){const de=u+(ye-pe)+b;B+=de+ve.slice(ye,_),ne+=ye-(pe+de.length)}else B+=ve.slice(pe,_);le.push(new d(0,ce.startColumn-ne,ce.endColumn-ne)),pe=_}this.preview={text:B,matches:Array.isArray(this.ranges)?le:le[0]}}else{const B=Array.isArray(te)?te[0].startLineNumber:te.startLineNumber;this.preview={text:ve,matches:(0,y.$1b)(te,ne=>new a(ne.startLineNumber-B,ne.startColumn,ne.endLineNumber-B,ne.endColumn))}}}}e.$2I=n;function s(fe){const ve=fe[0].startLineNumber;for(const te of fe)if(te.startLineNumber!==ve||te.endLineNumber!==ve)return!1;return!0}class a{constructor(ve,te,Re,se){this.startLineNumber=ve,this.startColumn=te,this.endLineNumber=Re,this.endColumn=se}}e.$3I=a;class d extends a{constructor(ve,te,Re){super(ve,te,ve,Re)}}e.$4I=d;var p;(function(fe){fe.List="list",fe.Tree="tree"})(p||(e.ViewMode=p={}));var m;(function(fe){fe.Default="default",fe.FileNames="fileNames",fe.Type="type",fe.Modified="modified",fe.CountDescending="countDescending",fe.CountAscending="countAscending"})(m||(e.SearchSortOrder=m={}));function S(fe,ve=!0){const te=fe&&fe.files&&fe.files.exclude,Re=ve&&fe&&fe.search&&fe.search.exclude;if(!te&&!Re)return;if(!te||!Re)return te||Re;let se=Object.create(null);return se=P.$dn(se,P.$an(te)),se=P.$dn(se,P.$an(Re),!0),se}e.$5I=S;function k(fe,ve){return fe.excludePattern&&T.$Bj(fe.excludePattern,ve)?!1:fe.includePattern||fe.usingSearchPaths?fe.includePattern&&T.$Bj(fe.includePattern,ve)?!0:fe.usingSearchPaths?!!fe.folderQueries&&fe.folderQueries.some(te=>{const Re=te.folder.fsPath;if(M.$2f(ve,Re)){const se=E.$kc(Re,ve);return!te.includePattern||!!T.$Bj(te.includePattern,se)}else return!1}):!1:!0}e.$6I=k;var h;(function(fe){fe[fe.unknownEncoding=1]="unknownEncoding",fe[fe.regexParseError=2]="regexParseError",fe[fe.globParseError=3]="globParseError",fe[fe.invalidLiteral=4]="invalidLiteral",fe[fe.rgProcessError=5]="rgProcessError",fe[fe.other=6]="other",fe[fe.canceled=7]="canceled"})(h||(e.SearchErrorCode=h={}));class w extends Error{constructor(ve,te){super(ve),this.code=te}}e.$7I=w;function I(fe){const ve=fe.message;if((0,f.$3)(fe))return new w(ve,h.canceled);try{const te=JSON.parse(ve);return new w(te.message,te.code)}catch{return new w(ve,h.other)}}e.$8I=I;function F(fe){const ve={message:fe.message,code:fe.code};return new Error(JSON.stringify(ve))}e.$9I=F;function V(fe){return fe.type==="error"?!0:fe.type==="success"}e.$0I=V;function Z(fe){return fe.type==="success"}e.$$I=Z;function N(fe){return!!fe.path}e.$_I=N;function R(fe,ve){const te=fe.searchPath?fe.searchPath:fe.relativePath;return(0,A.$sf)(te,ve)}e.$aJ=R;class L{constructor(ve){this.path=ve,this.results=[]}addMatch(ve){this.results.push(ve)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$bJ=L;function O(fe,ve){const te={...fe||{},...ve||{}};return Object.keys(te).filter(Re=>{const se=te[Re];return typeof se=="boolean"&&se})}e.$cJ=O;class Y{constructor(ve,te){this.c=null,this.a={...ve.excludePattern||{},...te.excludePattern||{}},this.b=T.$Cj(this.a);let Re=ve.includePattern;te.includePattern&&(Re?Re={...Re,...te.includePattern}:Re=te.includePattern),Re&&(this.c=T.$Cj(Re))}matchesExcludesSync(ve,te,Re){return!!(this.b&&this.b(ve,te,Re))}includedInQuerySync(ve,te,Re){return!(this.b&&this.b(ve,te,Re)||this.c&&!this.c(ve,te,Re))}includedInQuery(ve,te,Re){const se=this.b(ve,te,Re),Q=()=>this.c?!!this.c(ve,te,Re):!0;return(0,D.$Kg)(se)?se.then(B=>B?!1:Q()):Q()}hasSiblingExcludeClauses(){return he(this.a)}}e.$dJ=Y;function he(fe){for(const ve in fe)if(typeof fe[ve]!="boolean")return!0;return!1}function $e(fe){if(!fe)return;let ve;return te=>(ve||(ve=(fe()||Promise.resolve([])).then(Re=>Re?ke(Re):{})),ve.then(Re=>!!Re[te]))}e.$eJ=$e;function De(fe){if(!fe)return;let ve;return te=>{if(!ve){const Re=fe();ve=Re?ke(Re):{}}return!!ve[te]}}e.$fJ=De;function ke(fe){const ve={};for(const te of fe)ve[te]=!0;return ve}}),define(Pe[35],Ae([1,0,18,14,19,5,6,50,13,121,25,12,2,169,4,15,188,47,42,27,17,8,7,57,43,3,51]),function(we,e,y,T,P,M,A,$,E,f,C,D,u,b,v,g,t,i,r,c,o,l,n,s,a,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eec=e.$dec=void 0;function m(Z,N,R){return new C.$og(L=>w(L,R)).isEqual(Z,N)}function S(Z,N,R){return m(Z.uri,N.uri,R)?0:(0,D.$Ye)(Z.uri.toString(),N.uri.toString())}function k(Z,N,R){return Z.index!==N.index?Z.index<N.index?-1:1:m(Z.uri,N.uri,R)?(0,D.$Ye)(Z.name,N.name):(0,D.$Ye)(Z.uri.toString(),N.uri.toString())}function h(Z,N,R,L){const O=Z.slice(0).sort((he,$e)=>R(he,$e,L)),Y=N.slice(0).sort((he,$e)=>R(he,$e,L));return(0,y.$Db)(O,Y,(he,$e)=>R(he,$e,L))}function w(Z,N){const R=N.getCapabilities(Z.scheme);return!(R&&R&1024)}class I extends i.$ci{static toExtHostWorkspace(N,R,L,O){if(!N)return{workspace:null,added:[],removed:[]};const{id:Y,name:he,folders:$e,configuration:De,transient:ke,isUntitled:fe}=N,ve=[],te=R;R?$e.forEach((B,ne)=>{const pe=u.URI.revive(B.uri),re=I.o(L||R,pe,O);re?(re.name=B.name,re.index=B.index,ve.push(re)):ve.push({uri:pe,name:B.name,index:ne})}):ve.push(...$e.map(({uri:B,name:ne,index:pe})=>({uri:u.URI.revive(B),name:ne,index:pe}))),ve.sort((B,ne)=>B.index<ne.index?-1:1);const Re=new I(Y,he,ve,!!ke,De?u.URI.revive(De):null,!!fe,B=>w(B,O)),{added:se,removed:Q}=h(te?te.workspaceFolders:[],Re.workspaceFolders,S,O);return{workspace:Re,added:se,removed:Q}}static o(N,R,L){for(let O=0;O<N.folders.length;O++){const Y=N.workspaceFolders[O];if(m(Y.uri,R,L))return Y}}constructor(N,R,L,O,Y,he,$e){super(N,L.map(De=>new i.$di(De)),O,Y,$e),this.t=R,this.u=he,this.q=[],this.s=$.$2h.forUris($e),L.forEach(De=>{this.q.push(De),this.s.set(De.uri,De)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(N,R){return R&&this.s.get(N)&&(N=(0,C.$yg)(N)),this.s.findSubstr(N)}resolveWorkspaceFolder(N){return this.s.get(N)}}let F=class{constructor(N,R,L,O,Y){this.c=new M.$Rd,this.onDidChangeWorkspace=this.c.event,this.g=new M.$Rd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new M.$Td,this.B=new Map,this.h=O,this.s=L,this.t=Y,this.j=new f.$Wl,this.k=new T.$Wg,this.o=N.getProxy(d.$yK.MainThreadWorkspace),this.q=N.getProxy(d.$yK.MainThreadMessageService);const he=R.workspace;this.l=he?new I(he.id,he.name,[],!!he.transient,he.configuration?u.URI.revive(he.configuration):null,!!he.isUntitled,$e=>w($e,L)):void 0}$initializeWorkspace(N,R){this.v=R,this.$acceptWorkspaceData(N),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:E.Schemas.untitled,path:(0,C.$wg)((0,C.$yg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(N,R,L,...O){const Y=[];if(Array.isArray(O)&&O.forEach(fe=>{u.URI.isUri(fe.uri)&&!Y.some(ve=>m(ve.uri,fe.uri,this.s))&&Y.push({uri:fe.uri,name:fe.name||(0,C.$vg)(fe.uri)})}),this.n||[R,L].some(fe=>typeof fe!="number"||fe<0)||L===0&&Y.length===0)return!1;const he=this.x?this.x.workspaceFolders:[];if(R+L>he.length)return!1;const $e=he.slice(0);$e.splice(R,L,...Y.map(fe=>({uri:fe.uri,name:fe.name||(0,C.$vg)(fe.uri),index:void 0})));for(let fe=0;fe<$e.length;fe++){const ve=$e[fe];if($e.some((te,Re)=>Re!==fe&&m(ve.uri,te.uri,this.s)))return!1}$e.forEach((fe,ve)=>fe.index=ve);const{added:De,removed:ke}=h(he,$e,k,this.s);if(De.length===0&&ke.length===0)return!1;if(this.o){const fe=N.displayName||N.name;this.o.$updateWorkspaceFolders(fe,R,L,Y).then(void 0,ve=>{this.n=void 0;const te={source:{identifier:N.identifier,label:N.displayName||N.name}};this.q.$showMessage(t.Severity.Error,(0,b.localize)(0,null,fe,ve.toString()),te,[])})}return this.y($e),!0}getWorkspaceFolder(N,R){if(this.x)return this.x.getWorkspaceFolder(N,R)}async getWorkspaceFolder2(N,R){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(N,R)}async resolveWorkspaceFolder(N){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(N)}getPath(){if(!this.x)return;const{folders:N}=this.x;if(N.length!==0)return N[0].uri.fsPath}getRelativePath(N,R){let L,O="";if(typeof N=="string"?(L=u.URI.file(N),O=N):typeof N<"u"&&(L=N,O=N.fsPath),!L)return O;const Y=this.getWorkspaceFolder(L,!0);if(!Y)return O;typeof R>"u"&&this.x&&(R=this.x.folders.length>1);let he=(0,C.$Bg)(Y.uri,L);return R&&Y.name&&(he=`${Y.name}/${he}`),he}y(N){this.x&&(this.n=I.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:N,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(N){const{workspace:R,added:L,removed:O}=I.toExtHostWorkspace(N,this.l,this.n,this.s);this.l=R||void 0,this.n=void 0,this.c.fire(Object.freeze({added:L,removed:O}))}findFiles(N,R,L,O,Y=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${O.value}, entryPoint: findFiles`);let he;if(R===null?he=!1:R&&(typeof R=="string"?he=R:he=R.pattern),Y&&Y.isCancellationRequested)return Promise.resolve([]);const{includePattern:$e,folder:De}=V(l.GlobPattern.from(N));return this.o.$startFileSearch($e??null,De??null,he??null,L??null,Y).then(ke=>Array.isArray(ke)?ke.map(fe=>u.URI.revive(fe)):[])}async findTextInFiles(N,R,L,O,Y=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${O.value}, entryPoint: findTextInFiles`);const he=this.j.getNext(),$e=typeof R.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:R.previewOptions,{includePattern:De,folder:ke}=V(l.GlobPattern.from(R.include)),fe=typeof R.exclude=="string"?R.exclude:R.exclude?R.exclude.pattern:void 0,ve={ignoreSymlinks:typeof R.followSymlinks=="boolean"?!R.followSymlinks:void 0,disregardIgnoreFiles:typeof R.useIgnoreFiles=="boolean"?!R.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof R.useGlobalIgnoreFiles=="boolean"?!R.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof R.useParentIgnoreFiles=="boolean"?!R.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof R.useDefaultExcludes=="boolean"?!R.useDefaultExcludes:!0,fileEncoding:R.encoding,maxResults:R.maxResults,previewOptions:$e,afterContext:R.afterContext,beforeContext:R.beforeContext,includePattern:De,excludePattern:fe},te=!1;if(this.u[he]=Re=>{if(te)return;const se=u.URI.revive(Re.resource);Re.results.forEach(Q=>{const B=(0,p.$sh)(Q);(0,a.$XI)(B)?L({uri:se,preview:{text:B.preview.text,matches:(0,y.$1b)(B.preview.matches,ne=>new n.$CK(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))},ranges:(0,y.$1b)(B.ranges,ne=>new n.$CK(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))}):L({uri:se,text:B.text,lineNumber:B.lineNumber})})},Y.isCancellationRequested)return{};try{const Re=await this.o.$startTextSearch(N,ke??null,ve,he,Y);return delete this.u[he],Re||{}}catch(Re){throw delete this.u[he],Re}}$handleTextSearchResult(N,R){this.u[R]?.(N)}async save(N){const R=await this.o.$save(N,{saveAs:!1});return u.URI.revive(R)}async saveAs(N){const R=await this.o.$save(N,{saveAs:!0});return u.URI.revive(R)}saveAll(N){return this.o.$saveAll(N)}resolveProxy(N){return this.o.$resolveProxy(N)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(N){return this.o.$requestWorkspaceTrust(N)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(N,R){if(this.w.has(N))throw new Error(`A provider has already been registered for scheme ${N}`);this.w.set(N,R);const L=this.t.transformOutgoingScheme(N),O=this.z++;return this.o.$registerEditSessionIdentityProvider(O,L),(0,A.$Pc)(()=>{this.w.delete(N),this.o.$unregisterEditSessionIdentityProvider(O)})}async $getEditSessionIdentifier(N,R){this.h.info("Getting edit session identifier for workspaceFolder",N);const L=await this.resolveWorkspaceFolder(u.URI.revive(N));if(!L){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",L);const O=this.w.get(L.uri.scheme);if(this.h.info(`Provider for scheme ${L.uri.scheme} is defined: `,!!O),!O)return;const Y=await O.provideEditSessionIdentity(L,R);if(this.h.info("Provider returned edit session identifier: ",Y),!!Y)return Y}async $provideEditSessionIdentityMatch(N,R,L,O){this.h.info("Getting edit session identifier for workspaceFolder",N);const Y=await this.resolveWorkspaceFolder(u.URI.revive(N));if(!Y){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",Y);const he=this.w.get(Y.uri.scheme);if(this.h.info(`Provider for scheme ${Y.uri.scheme} is defined: `,!!he),!he)return;const $e=await he.provideEditSessionIdentityMatch?.(R,L,O);if(this.h.info("Provider returned edit session identifier match result: ",$e),!!$e)return $e}getOnWillCreateEditSessionIdentityEvent(N){return(R,L,O)=>{const Y=function($e){R.call(L,$e)};return Y.extension=N,this.A.event(Y,void 0,O)}}async $onWillCreateEditSessionIdentity(N,R,L){const O=await this.resolveWorkspaceFolder(u.URI.revive(N));if(O===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:O},R,async(Y,he)=>{const $e=Date.now();await Promise.resolve(Y),Date.now()-$e>L&&this.h.warn("SLOW edit session create-participant",he.extension.identifier)}),R.isCancellationRequested}registerCanonicalUriProvider(N,R){if(this.B.has(N))throw new Error(`A provider has already been registered for scheme ${N}`);this.B.set(N,R);const L=this.t.transformOutgoingScheme(N),O=this.z++;return this.o.$registerCanonicalUriProvider(O,L),(0,A.$Pc)(()=>{this.B.delete(N),this.o.$unregisterCanonicalUriProvider(O)})}async provideCanonicalUri(N,R,L){const O=this.B.get(N.scheme);if(!O)return;const Y=await O.provideCanonicalUri?.(u.URI.revive(N),R,L);if(Y)return Y}async $provideCanonicalUri(N,R,L){return this.provideCanonicalUri(u.URI.revive(N),{targetScheme:R},L)}};e.$dec=F,e.$dec=F=Ke([Ve(0,o.$AM),Ve(1,c.$QM),Ve(2,r.$Vdc),Ve(3,g.$dj),Ve(4,s.$bec)],F),e.$eec=(0,v.$Vh)("IExtHostWorkspace");function V(Z){let N,R;return Z&&(typeof Z=="string"?N=Z:(N=Z.pattern,R=u.URI.revive(Z.baseUri))),{includePattern:N,folder:R}}}),define(Pe[36],Ae([1,0,26,5,35,3,7,190,54,16,14,4,17,15,2]),function(we,e,y,T,P,M,A,$,E,f,C,D,u,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hec=e.$gec=e.$fec=void 0;function g(s,a){if(a){const d=a.split(".");let p=s;for(let m=0;p&&m<d.length;m++)p=p[d[m]];return p}}function t(s){return s instanceof v.URI}function i(s){return s&&s.uri instanceof v.URI&&s.languageId&&typeof s.languageId=="string"}function r(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function c(s){return s&&s.uri instanceof v.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function o(s){if(t(s))return{resource:s};if(i(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(r(s))return{overrideIdentifier:s.languageId};if(c(s))return{resource:s.uri};if(s===null)return{resource:null}}let l=class{constructor(a,d,p){this.a=a.getProxy(M.$yK.MainThreadConfiguration),this.c=d,this.b=p,this.d=new C.$Wg,this.e=null}getConfigProvider(){return this.d.wait().then(a=>this.e)}$initializeConfiguration(a){this.e=new n(this.a,this.c,a,this.b),this.d.open()}$acceptConfigurationChanged(a,d){this.getConfigProvider().then(p=>p.$acceptConfigurationChanged(a,d))}};e.$fec=l,e.$fec=l=Ke([Ve(0,u.$AM),Ve(1,P.$eec),Ve(2,b.$dj)],l);class n{constructor(a,d,p,m){this.a=new T.$Rd,this.b=a,this.f=m,this.c=d,this.e=$.$Kn.parse(p),this.d=this.k(p.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(a,d){const p={data:this.e.toData(),workspace:this.c.workspace};this.e=$.$Kn.parse(a),this.d=this.k(a.configurationScopes),this.a.fire(this.j(d,p))}getConfiguration(a,d,p){const m=o(d)||{},S=this.g(a?g(this.e.getValue(void 0,m,this.c.workspace),a):this.e.getValue(void 0,m,this.c.workspace));a&&this.h(a,m,p?.identifier);function k(w){if(w==null)return null;if(typeof w=="boolean")return w?2:5;switch(w){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const h={has(w){return typeof g(S,w)<"u"},get:(w,I)=>{this.h(a?`${a}.${w}`:w,m,p?.identifier);let F=g(S,w);if(typeof F>"u")F=I;else{let V;const Z=(N,R)=>{if((0,f.$Ef)(N)){let L;const O=()=>{V=V||(0,y.$an)(S),L=L||g(V,R)};return new Proxy(N,{get:(Y,he)=>{if(typeof he=="string"&&he.toLowerCase()==="tojson")return O(),()=>L;if(V)return L=L||g(V,R),L[he];const $e=Y[he];return typeof he=="string"?Z($e,`${R}.${he}`):$e},set:(Y,he,$e)=>(O(),L&&(L[he]=$e),!0),deleteProperty:(Y,he)=>(O(),L&&delete L[he],!0),defineProperty:(Y,he,$e)=>(O(),L&&Object.defineProperty(L,he,$e),!0)})}return Array.isArray(N)?(0,y.$an)(N):N};F=Z(F,w)}return F},update:(w,I,F,V)=>{w=a?`${a}.${w}`:w;const Z=k(F);return I!==void 0?this.b.$updateConfigurationOption(Z,w,I,m,V):this.b.$removeConfigurationOption(Z,w,m,V)},inspect:w=>{w=a?`${a}.${w}`:w;const I=this.e.inspect(w,m,this.c.workspace);if(I)return{key:w,defaultValue:(0,y.$an)(I.policy?.value??I.default?.value),globalValue:(0,y.$an)(I.user?.value??I.application?.value),workspaceValue:(0,y.$an)(I.workspace?.value),workspaceFolderValue:(0,y.$an)(I.workspaceFolder?.value),defaultLanguageValue:(0,y.$an)(I.default?.override),globalLanguageValue:(0,y.$an)(I.user?.override??I.application?.override),workspaceLanguageValue:(0,y.$an)(I.workspace?.override),workspaceFolderLanguageValue:(0,y.$an)(I.workspaceFolder?.override),languageIds:(0,y.$an)(I.overrideIdentifiers)}}};return typeof S=="object"&&(0,y.$dn)(h,S,!1),Object.freeze(h)}g(a){const d=p=>(0,f.$Ef)(p)?new Proxy(p,{get:(m,S)=>d(m[S]),set:(m,S,k)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(S)}' of object`)},deleteProperty:(m,S)=>{throw new Error(`TypeError: Cannot delete read only property '${String(S)}' of object`)},defineProperty:(m,S)=>{throw new Error(`TypeError: Cannot define property '${String(S)}' for a readonly object`)},setPrototypeOf:m=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):p;return d(a)}h(a,d,p){const m=E.$Bn.test(a)?4:this.d.get(a),S=p?`[${p.value}] `:"";if(m===4){typeof d?.resource>"u"&&this.f.warn(`${S}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(m===3){d?.resource&&this.f.warn(`${S}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(a,d){const p=new $.$Mn(a,d,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(m,S)=>p.affectsConfiguration(m,o(S))})}k(a){return a.reduce((d,p)=>(d.set(p[0],p[1]),d),new Map)}}e.$gec=n,e.$hec=(0,D.$Vh)("IExtHostConfiguration")}),define(Pe[115],Ae([1,0,2,14,5,3,7,35,61,36,19,64,17,27,4,13,21,15,81,229,11]),function(we,e,y,T,P,M,A,$,E,f,C,D,u,b,v,g,t,i,r,c,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kfc=e.$Jfc=e.$Ifc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var l;(function(Z){function N(L){if(L!=null)return L}Z.from=N;function R(L){if(L!=null)return L}Z.to=R})(l||(l={}));var n;(function(Z){function N(L){if(L!=null)return L}Z.from=N;function R(L){if(L!=null)return L}Z.to=R})(n||(n={}));var s;(function(Z){function N(L){if(L!=null)return L}Z.from=N;function R(L){if(L!=null)return L}Z.to=R})(s||(s={}));var a;(function(Z){function N(O){if(O){const Y=O;return Y&&!!Y.process}else return!1}Z.is=N;function R(O){if(O==null)return;const Y={process:O.process,args:O.args};return O.options&&(Y.options=s.from(O.options)),Y}Z.from=R;function L(O){if(O!=null)return new A.$iL(O.process,O.args,O.options)}Z.to=L})(a||(a={}));var d;(function(Z){function N(L){if(L!=null)return L}Z.from=N;function R(L){if(L!=null)return L}Z.to=R})(d||(d={}));var p;(function(Z){function N(O){if(O){const Y=O;return Y&&(!!Y.commandLine||!!Y.command)}else return!1}Z.is=N;function R(O){if(O==null)return;const Y={};return O.commandLine!==void 0?Y.commandLine=O.commandLine:(Y.command=O.command,Y.args=O.args),O.options&&(Y.options=d.from(O.options)),Y}Z.from=R;function L(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new A.$jL(O.commandLine,O.options):new A.$jL(O.command,O.args?O.args:[],O.options)}Z.to=L})(p||(p={}));var m;(function(Z){function N(O){if(O){const Y=O;return Y&&Y.customExecution==="customExecution"}else return!1}Z.is=N;function R(O){return{customExecution:"customExecution"}}Z.from=R;function L(O,Y){return Y.get(O)}Z.to=L})(m||(e.CustomExecutionDTO=m={}));var S;(function(Z){function N(R,L){let O;return R.scope!==void 0&&typeof R.scope!="number"?O=R.scope.uri:R.scope!==void 0&&typeof R.scope=="number"&&(R.scope===A.TaskScope.Workspace&&L&&L.workspaceFile?O=L.workspaceFile:O=c.$8F),{id:R._id,workspaceFolder:O}}Z.from=N})(S||(e.TaskHandleDTO=S={}));var k;(function(Z){function N(R){if(R!=null)return{_id:R.id,isDefault:R.isDefault}}Z.from=N})(k||(k={}));var h;(function(Z){function N(O,Y){if(O==null)return[];const he=[];for(const $e of O){const De=R($e,Y);De&&he.push(De)}return he}Z.fromMany=N;function R(O,Y){if(O==null)return;let he;O.execution instanceof A.$iL?he=a.from(O.execution):O.execution instanceof A.$jL?he=p.from(O.execution):O.execution&&O.execution instanceof A.$kL&&(he=m.from(O.execution));const $e=l.from(O.definition);let De;return O.scope?typeof O.scope=="number"?De=O.scope:De=O.scope.uri:De=A.TaskScope.Workspace,!$e||!De?void 0:{_id:O._id,definition:$e,name:O.name,source:{extensionId:Y.identifier.value,label:O.source,scope:De},execution:he,isBackground:O.isBackground,group:k.from(O.group),presentationOptions:n.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}Z.from=R;async function L(O,Y,he){if(O==null)return;let $e;a.is(O.execution)?$e=a.to(O.execution):p.is(O.execution)?$e=p.to(O.execution):m.is(O.execution)&&($e=m.to(O._id,he));const De=l.to(O.definition);let ke;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?ke=O.source.scope:ke=await Y.resolveWorkspaceFolder(y.URI.revive(O.source.scope)):ke=A.TaskScope.Workspace),!De||!ke)return;const fe=new A.$lL(De,ke,O.name,O.source.label,$e,O.problemMatchers);return O.isBackground!==void 0&&(fe.isBackground=O.isBackground),O.group!==void 0&&(fe.group=A.$hL.from(O.group._id),fe.group&&O.group.isDefault&&(fe.group=new A.$hL(fe.group.id,fe.group.label),O.group.isDefault===!0&&(fe.group.isDefault=O.group.isDefault))),O.presentationOptions&&(fe.presentationOptions=n.to(O.presentationOptions)),O._id&&(fe._id=O._id),O.detail&&(fe.detail=O.detail),fe}Z.to=L})(h||(e.TaskDTO=h={}));var w;(function(Z){function N(L){return L}Z.from=N;function R(L){if(L)return Object.assign(Object.create(null),L)}Z.to=R})(w||(w={}));class I{#e;constructor(N,R,L){this._id=R,this.a=L,this.#e=N}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(N){}fireDidEndProcess(N){}}let F=class{constructor(N,R,L,O,Y,he,$e,De){this.q=new P.$Rd,this.r=new P.$Rd,this.s=new P.$Rd,this.t=new P.$Rd,this.a=N.getProxy(M.$yK.MainThreadTask),this.b=L,this.c=O,this.d=Y,this.e=he,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=$e,this.g=De,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(N,R,L){if(!L)return new A.$AK(()=>{});const O=this.w();return this.j.set(O,{type:R,provider:L,extension:N}),this.a.$registerTaskProvider(O,R),new A.$AK(()=>{this.j.delete(O),this.a.$unregisterTaskProvider(O)})}registerTaskSystem(N,R){this.a.$registerTaskSystem(N,R)}fetchTasks(N){return this.a.$fetchTasks(w.from(N)).then(async R=>{const L=[];for(const O of R){const Y=await h.to(O,this.b,this.m);Y&&L.push(Y)}return L})}get taskExecutions(){const N=[];return this.k.forEach(R=>N.push(R)),N}terminateTask(N){if(!(N instanceof I))throw new Error("No valid task execution provided");return this.a.$terminateTask(N._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(N,R,L){const O=this.m.get(N.id);O&&(this.o.set(N.id,O),this.e.attachPtyToTerminal(R,await O.callback(L))),this.p=N.id,this.q.fire({execution:await this.y(N)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(N){const R=await this.y(N);this.l.delete(N.id),this.k.delete(N.id),this.A(N),this.r.fire({execution:R})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(N){const R=await this.y(N.id);this.s.fire({execution:R,processId:N.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(N){const R=await this.y(N.id);this.t.fire({execution:R,exitCode:N.exitCode})}$provideTasks(N,R){const L=this.j.get(N);if(!L)return Promise.reject(new Error("no handler found"));const O=[],Y=(0,T.$Qg)(()=>L.provider.provideTasks(C.CancellationToken.None)).then(he=>this.u(R,O,L,he));return new Promise(he=>{Y.then($e=>{Promise.all(O).then(()=>{he($e)})})})}async $resolveTask(N,R){const L=this.j.get(N);if(!L)return Promise.reject(new Error("no handler found"));if(R.definition.type!==L.type)throw new Error(`Unexpected: Task of type [${R.definition.type}] cannot be resolved by provider of type [${L.type}].`);const O=await h.to(R,this.b,this.m);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const Y=await L.provider.resolveTask(O,C.CancellationToken.None);if(!Y)return;this.z(Y,L);const he=h.from(Y,L.extension);if(!he)throw new Error("Unexpected: Task cannot be resolved.");if(Y.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return m.is(he.execution)&&await this.x(he,Y,!0),await this.v(he)}w(){return this.h++}async x(N,R,L){const O=await this.a.$createTaskId(N);!L&&!this.m.has(O)&&(this.n.add(O),this.o.set(O,R.execution)),this.m.set(O,R.execution)}async y(N,R){if(typeof N=="string"){const Y=this.l.get(N);if(!Y)throw new o.$ab("Unexpected: The specified task is missing an execution");return Y}const L=this.l.get(N.id);if(L)return L;const O=new Promise((Y,he)=>{function $e(De,ke,fe){fe?Y(new I(De,ke.id,fe)):he("Unexpected: Task does not exist.")}R?$e(this,N,R):h.to(N.task,this.b,this.m).then(De=>$e(this,N,De))});return this.l.set(N.id,O),O.then(Y=>(this.k.set(N.id,Y),Y),Y=>Promise.reject(Y))}z(N,R){N._deprecated&&this.g.report("Task.constructor",R.extension,"Use the Task constructor that takes a `scope` instead.")}A(N){this.o.get(N.id)&&this.o.delete(N.id),this.n.has(N.id)&&this.p!==N.id&&(this.m.delete(N.id),this.n.delete(N.id));const L=this.n.values();let O=L.next();for(;!O.done;)!this.o.has(O.value)&&this.p!==O.value&&(this.m.delete(O.value),this.n.delete(O.value)),O=L.next()}};e.$Ifc=F,e.$Ifc=F=Ke([Ve(0,u.$AM),Ve(1,b.$QM),Ve(2,$.$eec),Ve(3,E.$LM),Ve(4,f.$hec),Ve(5,D.$Fec),Ve(6,i.$dj),Ve(7,r.$Ydc)],F);let V=class extends F{constructor(N,R,L,O,Y,he,$e,De){super(N,R,L,O,Y,he,$e,De),this.registerTaskSystem(g.Schemas.vscodeRemote,{scheme:g.Schemas.vscodeRemote,authority:"",platform:t.$h(0)})}async executeTask(N,R){if(!R.execution)throw new Error("Tasks to execute must include an execution");const L=h.from(R,N);if(L===void 0)throw new Error("Task is not valid");if(m.is(L.execution))await this.x(L,R,!1);else throw new o.$$;const O=await this.y(await this.a.$getTaskExecution(L),R);return this.a.$executeTask(L).catch(Y=>{throw new Error(Y)}),O}u(N,R,L,O){const Y=[];if(O)for(const he of O){if(this.z(he,L),!he.definition||!N[he.definition.type]){const De=he.source?he.source:"No task source";this.f.warn(`The task [${De}, ${he.name}] uses an undefined task type. The task will be ignored in the future.`)}const $e=h.from(he,L.extension);$e&&m.is($e.execution)?(Y.push($e),R.push(this.x($e,he,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:Y,extension:L.extension}}async v(N){if(m.is(N.execution))return N;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(N,R){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(N,R,L){}};e.$Jfc=V,e.$Jfc=V=Ke([Ve(0,u.$AM),Ve(1,b.$QM),Ve(2,$.$eec),Ve(3,E.$LM),Ve(4,f.$hec),Ve(5,D.$Fec),Ve(6,i.$dj),Ve(7,r.$Ydc)],V),e.$Kfc=(0,v.$Vh)("IExtHostTask")}),define(Pe[282],Ae([1,0,43,29]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nJ=e.$mJ=e.$lJ=void 0;function P(A){return"cellResults"in A}e.$lJ=P,e.$mJ="rawCell#";function M(A,$){let E=-1;const f=[];let C=[];return A.forEach(u=>{u.range.startLineNumber!==E&&C.length>0&&(f.push([...C]),C=[]),C.push(u),E=u.range.endLineNumber}),C.length>0&&f.push([...C]),f.map(u=>{const b=[],v=u[0].range.startLineNumber,g=u[u.length-1].range.endLineNumber;for(let t=v;t<=g;t++)b.push($.getLineContent(t));return new y.$2I(b.join(`
`)+`
`,u.map(t=>new T.$zs(t.range.startLineNumber-1,t.range.startColumn-1,t.range.endLineNumber-1,t.range.endColumn-1)))})}e.$nJ=M}),define(Pe[283],Ae([1,0,162,24,5,6,28,12,16,2,41,75,3,32,8,7,49,221,107,11,26,13,212,282,280]),function(we,e,y,T,P,M,A,$,E,f,C,D,u,b,v,g,t,i,r,c,o,l,n,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kfc=void 0;class d{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(m=>m.apiEditor)}constructor(m,S,k,h,w,I){this.q=k,this.r=h,this.s=w,this.t=I,this.f=new Map,this.g=new A.$zc,this.h=new Map,this.j=new P.$Rd({onListenerError:c.$1}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new P.$Rd({onListenerError:c.$1}),this.onDidOpenNotebookDocument=this.m.event,this.n=new P.$Rd({onListenerError:c.$1}),this.onDidCloseNotebookDocument=this.n.event,this.o=new P.$Rd({onListenerError:c.$1}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new D.$Rdc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=m.getProxy(u.$yK.MainThreadNotebook),this.c=m.getProxy(u.$yK.MainThreadNotebookDocuments),this.d=m.getProxy(u.$yK.MainThreadNotebookEditors),this.i=S.converter,S.registerArgumentProcessor({processArgument:F=>{if(F&&F.$mid===13){const V=F.notebookEditor?.notebookUri,Z=F.cell.handle,R=this.g.get(V)?.getCell(Z);if(R)return R.apiCell}if(F&&F.$mid===14){const V=F.uri,Z=this.g.get(V);if(Z)return Z.apiNotebook}return F}}),d.B(S)}getEditorById(m){const S=this.h.get(m);if(!S)throw new Error(`unknown text editor: ${m}. known editors: ${[...this.h.keys()]} `);return S}getIdByEditor(m){for(const[S,k]of this.h)if(k.apiEditor===m)return S}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(m,S){const k=this.g.get(m);if(!k&&!S)throw new Error(`NO notebook document for '${m}'`);return k}static u(m,S){if(!S)return;const k=S.filenamePattern.map(h=>v.NotebookExclusiveDocumentPattern.from(h)).filter(h=>h!==void 0);if(S.filenamePattern&&!k){console.warn(`Notebook content provider view options file name pattern is invalid ${S.filenamePattern}`);return}return{extension:m.identifier,providerDisplayName:m.displayName||m.name,displayName:S.displayName,filenamePattern:k,exclusive:S.exclusive||!1}}registerNotebookCellStatusBarItemProvider(m,S,k){const h=d.a++,w=typeof k.onDidChangeCellStatusBarItems=="function"?d.a++:void 0;this.f.set(h,k),this.b.$registerNotebookCellStatusBarItemProvider(h,w,S);let I;return w!==void 0&&(I=k.onDidChangeCellStatusBarItems(F=>this.b.$emitCellStatusBarEvent(w))),new g.$AK(()=>{this.f.delete(h),this.b.$unregisterNotebookCellStatusBarItemProvider(h,w),I?.dispose()})}async createNotebookDocument(m){const S=await this.c.$tryCreateNotebook({viewType:m.viewType,content:m.content&&v.NotebookData.from(m.content)});return f.URI.revive(S)}async openNotebookDocument(m){const S=this.g.get(m);if(S)return S.apiNotebook;const k=await this.c.$tryOpenNotebook(m),h=this.g.get(f.URI.revive(k));return(0,E.$Nf)(h?.apiNotebook)}async showNotebookDocument(m,S){f.URI.isUri(m)&&(m=await this.openNotebookDocument(m));let k;typeof S=="object"?k={position:v.ViewColumn.from(S.viewColumn),preserveFocus:S.preserveFocus,selections:S.selections&&S.selections.map(v.NotebookRange.from),pinned:typeof S.preview=="boolean"?!S.preview:void 0}:k={preserveFocus:!1};const h=await this.d.$tryShowNotebookDocument(m.uri,m.notebookType,k),w=h&&this.h.get(h)?.apiEditor;if(w)return w;throw h?new Error(`Could NOT open editor for "${m.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${m.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(m,S,k,h){const w=this.f.get(m),I=f.URI.revive(S),F=this.g.get(I);if(!F||!w)return;const V=F.getCellFromIndex(k);if(!V)return;const Z=await w.provideCellStatusBarItems(V.apiCell,h);if(!Z)return;const N=new M.$Qc,R=this.p.add([N]),O=(Array.isArray(Z)?Z:[Z]).map(Y=>v.NotebookStatusBarItem.from(Y,this.i,N));return{cacheId:R,items:O}}$releaseNotebookCellStatusBarItems(m){this.p.delete(m)}registerNotebookSerializer(m,S,k,h,w){if((0,$.$Fe)(S))throw new Error("viewType cannot be empty or just whitespace");const I=this.w++;return this.x.set(I,{viewType:S,serializer:k,options:h}),this.b.$registerNotebookSerializer(I,{id:m.identifier,location:m.extensionLocation},S,v.NotebookDocumentContentOptions.from(h),d.u(m,w)),(0,M.$Pc)(()=>{this.b.$unregisterNotebookSerializer(I)})}async $dataToNotebook(m,S,k){const h=this.x.get(m);if(!h)throw new Error("NO serializer found");const w=await h.serializer.deserializeNotebook(S.buffer,k);return new t.$wv(v.NotebookData.from(w))}async $notebookToData(m,S,k){const h=this.x.get(m);if(!h)throw new Error("NO serializer found");const w=await h.serializer.serializeNotebook(v.NotebookData.to(S.value),k);return T.$fe.wrap(w)}async $saveNotebook(m,S,k,h,w){const I=f.URI.revive(S),F=this.x.get(m);if(!F)throw new Error("NO serializer found");const V=this.g.get(I);if(!V)throw new Error("Document NOT found");if(V.versionId!==k)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(I.scheme))throw new C.$zk((0,y.localize)(0,null,this.z(I)),6);await this.y(I,h);const Z={metadata:(0,o.$in)(V.apiNotebook.metadata,Y=>!(F.options?.transientDocumentMetadata??{})[Y]),cells:[]};for(const Y of V.apiNotebook.getCells()){const he=new g.$YL(Y.kind,Y.document.getText(),Y.document.languageId,Y.mime,F.options?.transientOutputs?[]:[...Y.outputs],Y.metadata,Y.executionSummary);he.metadata=(0,o.$in)(Y.metadata,$e=>!(F.options?.transientCellMetadata??{})[$e]),Z.cells.push(he)}const N=await F.serializer.serializeNotebook(Z,w);await this.s.value.writeFile(I,N);const R=this.s.getFileSystemProviderExtUri(I.scheme),L=await this.s.value.stat(I);return{name:R.basename(I),isFile:(L.type&C.FileType.File)!==0,isDirectory:(L.type&C.FileType.Directory)!==0,isSymbolicLink:(L.type&C.FileType.SymbolicLink)!==0,mtime:L.mtime,ctime:L.ctime,size:L.size,readonly:!!((L.permissions??0)&C.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(I.scheme),locked:!!((L.permissions??0)&C.FilePermission.Locked),etag:C.$Kk({mtime:L.mtime,size:L.size}),children:void 0}}async $searchInNotebooks(m,S,k,h,w){const I=this.x.get(m)?.serializer;if(!I)return{limitHit:!1,results:[]};const F=new A.$Ac;await(async(L,O,Y)=>{await Promise.all(L.map(async he=>await Promise.all(he.filenamePatterns.map($e=>{const De={...Y,type:1,filePattern:$e};return this.t.doInternalFileSearchWithCustomCallback(De,O,ke=>{ke.forEach(fe=>{F.has(fe)||h.some(te=>he.isFromSettings&&!te.isFromSettings?!1:te.filenamePatterns.some(Re=>(0,a.$Zbb)(Re,fe)))||F.add(fe)})})}))))})(k,w,S);const Z=new A.$zc;let N=!1;const R=Array.from(F).map(async L=>{const O=[];try{if(w.isCancellationRequested)return;if(S.maxResults&&[...Z.values()].reduce((De,ke)=>De+ke.cellResults.length,0)>S.maxResults){N=!0;return}const Y=[],he=this.g.get(L);if(he)he.apiNotebook.getCells().forEach(ke=>Y.push({input:ke.document.getText(),outputs:ke.outputs.flatMap(fe=>fe.items.map(ve=>ve.data.toString()))}));else{const De=await this.s.value.readFile(L),ke=T.$fe.fromString(De.toString()),fe=await I.deserializeNotebook(ke.buffer,w);if(w.isCancellationRequested)return;v.NotebookData.from(fe).cells.forEach(te=>Y.push({input:te.source,outputs:te.outputs.flatMap(Re=>Re.items.map(se=>se.valueBytes.toString()))}))}if(w.isCancellationRequested)return;Y.forEach((De,ke)=>{const fe=S.contentPattern.pattern,ve=new n.$1Ob(De.input,void 0,De.outputs),te=ve.findInInputs(fe),Re=ve.findInOutputs(fe),se=Re.flatMap(Q=>(0,s.$nJ)(Q.matches,Q.textBuffer)).map((Q,B)=>(Q.webviewIndex=B,Q));if(te.length>0||Re.length>0){const Q={index:ke,contentResults:(0,s.$nJ)(te,ve.inputTextBuffer),webviewResults:se};O.push(Q)}});const $e={resource:L,cellResults:O};Z.set(L,$e);return}catch{return}});return await Promise.all(R),{limitHit:N,results:[...Z.values()]}}async y(m,S){const k=await this.s.value.stat(m);if(typeof S?.mtime=="number"&&typeof S.etag=="string"&&S.etag!==C.$Jk&&typeof k.mtime=="number"&&typeof k.size=="number"&&S.mtime<k.mtime&&S.etag!==C.$Kk({mtime:S.mtime,size:k.size}))throw new C.$zk((0,y.localize)(1,null),3,S)}z(m){return m.scheme===l.Schemas.file?m.fsPath:m.toString()}A(m,S,k){if(this.h.has(S))throw new Error(`editor with id ALREADY EXSIST: ${S}`);const h=new r.$bfc(S,this.d,m,k.visibleRanges.map(v.NotebookRange.to),k.selections.map(v.NotebookRange.to),typeof k.viewColumn=="number"?v.ViewColumn.to(k.viewColumn):void 0);this.h.set(S,h)}$acceptDocumentAndEditorsDelta(m){if(m.value.removedDocuments)for(const k of m.value.removedDocuments){const h=f.URI.revive(k),w=this.g.get(h);w&&(w.dispose(),this.g.delete(h),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:w.apiNotebook.getCells().map(I=>I.document.uri)}),this.n.fire(w.apiNotebook));for(const I of this.h.values())I.notebookData.uri.toString()===h.toString()&&this.h.delete(I.id)}if(m.value.addedDocuments){const k=[];for(const h of m.value.addedDocuments){const w=f.URI.revive(h.uri);if(this.g.has(w))throw new Error(`adding EXISTING notebook ${w} `);const I=new i.$afc(this.c,this.q,this.r,w,h);k.push(...h.cells.map(F=>i.$_ec.asModelAddData(I.apiNotebook,F))),this.g.get(w)?.dispose(),this.g.set(w,I),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:k}),this.m.fire(I.apiNotebook)}}if(m.value.addedEditors)for(const k of m.value.addedEditors){if(this.h.has(k.id))return;const h=f.URI.revive(k.documentUri),w=this.g.get(h);w&&this.A(w,k.id,k)}const S=[];if(m.value.removedEditors)for(const k of m.value.removedEditors){const h=this.h.get(k);h&&(this.h.delete(k),this.k?.id===h.id&&(this.k=void 0),S.push(h))}if(m.value.visibleEditors){this.l=m.value.visibleEditors.map(h=>this.h.get(h)).filter(h=>!!h);const k=new Set;this.l.forEach(h=>k.add(h.id));for(const h of this.h.values()){const w=k.has(h.id);h._acceptVisibility(w)}this.l=[...this.h.values()].map(h=>h).filter(h=>h.visible),this.o.fire(this.visibleNotebookEditors)}m.value.newActiveEditor===null?this.k=void 0:m.value.newActiveEditor&&(this.h.get(m.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${m.value.newActiveEditor}`),this.k=this.h.get(m.value.newActiveEditor)),m.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(m){const S=b.$YM.String.with("notebookType","A notebook type"),k=new b.$1M("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[S,new b.$YM("data","Bytes to convert to data",w=>w instanceof Uint8Array,w=>T.$fe.wrap(w))],new b.$ZM("Notebook Data",w=>v.NotebookData.to(w.value))),h=new b.$1M("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[S,new b.$YM("NotebookData","Notebook data to convert to bytes",w=>!0,w=>new t.$wv(v.NotebookData.from(w)))],new b.$ZM("Bytes",w=>w.buffer));m.registerApiCommand(k),m.registerApiCommand(h)}}e.$kfc=d}),define(Pe[284],Ae([1,0,20,19,39,33,25,60,43]),function(we,e,y,T,P,M,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cfc=void 0;class f{constructor(u,b,v){this.k=u,this.l=b,this.o=v,this.e=!1,this.f=0,this.g=!1,this.a=u.filePattern,this.b=u.includePattern&&M.$Cj(u.includePattern),this.c=u.maxResults||void 0,this.d=u.exists,this.h=new Set,this.j=u.excludePattern&&M.$Cj(u.excludePattern)}cancel(){this.g=!0,this.h.forEach(u=>u.cancel()),this.h=new Set}search(u){const b=this.k.folderQueries||[];return new Promise((v,g)=>{const t=i=>{this.f++,u(i)};if(this.g)return v({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(i=>{const r=i.toString(),c=y.$mc(r);this.j&&this.j(r,c)||this.v(t,{base:i,basename:c})}),Promise.all(b.map(i=>this.p(i,t))).then(i=>{v({limitHit:this.e,stats:i[0]||void 0})},i=>{g(new Error((0,P.$Gi)(i)))})})}async p(u,b){const v=new T.$2d,g=this.q(u),t=this.r(),i=new E.$dJ(this.k,u),r=!i.hasSiblingExcludeClauses();let c;try{this.h.add(v),c=$.$Nd.create();const o=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},g,v.token),l=c.elapsed(),n=$.$Nd.create();return this.g&&!this.e||(o&&o.forEach(s=>{const a=y.$fc.relative(u.folder.path,s.path);if(r){const d=y.$mc(s.path);this.v(b,{base:u.folder,relativePath:a,basename:d});return}this.s(t,u.folder,a,b)}),this.g&&!this.e)?null:(this.u(t,i,b),{providerTime:l,postProcessTime:n.elapsed()})}finally{v.dispose(),this.h.delete(v)}}q(u){const b=(0,E.$cJ)(this.k.includePattern,u.includePattern),v=(0,E.$cJ)(this.k.excludePattern,u.excludePattern);return{folder:u.folder,excludes:v,includes:b,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}s({pathToEntries:u},b,v,g){if(v===this.a){const i=y.$mc(this.a);this.v(g,{base:b,relativePath:this.a,basename:i})}function t(i){const r=y.$mc(i),c=y.$lc(i);let o=u[c];o||(o=u[c]=[],t(c)),o.push({base:b,relativePath:i,basename:r})}t(v)}u({rootEntries:u,pathToEntries:b},v,g){const t=this,i=this.a;function r(c){const o=(0,E.$fJ)(()=>c.map(l=>l.basename));for(let l=0,n=c.length;l<n;l++){const s=c[l],{relativePath:a,basename:d}=s;if(v.matchesExcludesSync(a,d,i!==d?o:void 0))continue;const p=b[a];if(p)r(p);else{if(a===i)continue;t.v(g,s)}if(t.e)break}}r(u)}v(u,b){(!this.b||b.relativePath&&this.b(b.relativePath,b.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||u(b))}}class C{constructor(){this.b=new Map}static{this.a=512}fileSearch(u,b,v,g){const t=this.c(u.cacheKey),i=new f(u,b,t&&t.token);let r=0;const c=o=>{r+=o.length,v(o.map(l=>this.d(l)))};return this.e(i,C.a,c,g).then(o=>({limitHit:o.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:r,detailStats:o.stats}}))}clearCache(u){this.c(u)?.cancel()}c(u){if(u)return this.b.has(u)||this.b.set(u,new T.$2d),this.b.get(u)}d(u){return u.relativePath?{resource:A.$zg(u.base,u.relativePath)}:{resource:u.base}}e(u,b,v,g){const t=g.onCancellationRequested(()=>{u.cancel()}),i=c=>{c&&(r.push(c),b>0&&r.length>=b&&(v(r),r=[]))};let r=[];return u.search(i).then(c=>(r.length&&v(r),t.dispose(),c),c=>(r.length&&v(r),t.dispose(),Promise.reject(c)))}}e.$cfc=C}),define(Pe[285],Ae([1,0,18,246,33,94,28,13,20,25,12,16,2,93,180,40,15,47,105,281,43]),function(we,e,y,T,P,M,A,$,E,f,C,D,u,b,v,g,t,i,r,c,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dK=e.$cK=void 0;let l=class{constructor(w,I,F,V,Z){this.a=w,this.b=I,this.c=F,this.d=V,this.e=Z}text(w,I,F={}){w=this.f(w,F);const V=this.a.getValue(),Z=I&&I.some(R=>!this.a.getValue({resource:R}).search.useRipgrep);return{...this.h(I?.map(i.$ei),F),type:2,contentPattern:w,previewOptions:F.previewOptions,maxFileSize:F.maxFileSize,usePCRE2:V.search.usePCRE2||Z||!1,beforeContext:F.beforeContext,afterContext:F.afterContext,userDisabledExcludesAndIgnoreFiles:F.disregardExcludeSettings&&F.disregardIgnoreFiles}}f(w,I){const F=this.a.getValue();w.isRegExp&&(w.pattern=w.pattern.replace(/\r?\n/g,"\\n"));const V={...w,wordSeparators:F.editor.wordSeparators};return this.j(w,I)&&(V.isCaseSensitive=!0),this.k(w)&&(V.isMultiline=!0),I.notebookSearchConfig?.includeMarkupInput&&(V.notebookInfo||(V.notebookInfo={}),V.notebookInfo.isInNotebookMarkdownInput=I.notebookSearchConfig.includeMarkupInput),I.notebookSearchConfig?.includeMarkupPreview&&(V.notebookInfo||(V.notebookInfo={}),V.notebookInfo.isInNotebookMarkdownPreview=I.notebookSearchConfig.includeMarkupPreview),I.notebookSearchConfig?.includeCodeInput&&(V.notebookInfo||(V.notebookInfo={}),V.notebookInfo.isInNotebookCellInput=I.notebookSearchConfig.includeCodeInput),I.notebookSearchConfig?.includeOutput&&(V.notebookInfo||(V.notebookInfo={}),V.notebookInfo.isInNotebookCellOutput=I.notebookSearchConfig.includeOutput),V}file(w,I={}){return{...this.h(w,I),type:1,filePattern:I.filePattern?I.filePattern.trim():I.filePattern,exists:I.exists,sortByScore:I.sortByScore,cacheKey:I.cacheKey}}g(w,I){return w?(w=Array.isArray(w)?w.map(p):p(w),I?this.parseSearchPaths(w):{pattern:s(...Array.isArray(w)?w:[w])}):{}}h(w=[],I={}){const F=this.g(I.includePattern,I.expandPatterns),V=this.g(I.excludePattern,I.expandPatterns),Z=w.length>1,N=(F.searchPaths&&F.searchPaths.length?F.searchPaths.map(O=>this.q(O,I,V)):w.map(O=>this.r(O,I,V,Z))).filter(O=>!!O),R={_reason:I._reason,folderQueries:N,usingSearchPaths:!!(F.searchPaths&&F.searchPaths.length),extraFileResources:I.extraFileResources,excludePattern:V.pattern,includePattern:F.pattern,onlyOpenEditors:I.onlyOpenEditors,maxResults:I.maxResults};if(I.onlyOpenEditors){const O=y.$Gb(y.$Qb(this.c.groups.map($e=>$e.editors.map(De=>De.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(O));const Y=O.filter($e=>(0,o.$6I)(R,$e.fsPath)),he=this.i(Y);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(he)),{...R,...he}}const L=I.extraFileResources&&I.extraFileResources.filter(O=>(0,o.$6I)(R,O.fsPath));return R.extraFileResources=L&&L.length?L:void 0,R}i(w){const I=[],F=new A.$zc,V={};let Z=!1;return w.forEach(N=>{if(N.scheme===$.Schemas.walkThrough)return;if((0,f.$Dg)(N)){const L=this.b.getWorkspaceFolder(N)?.uri??N.with({path:E.$lc(N.fsPath)});let O=F.get(L);O||(Z=!0,O={folder:L,includePattern:{}},I.push(O),F.set(L,O));const Y=E.$kc(L.fsPath,N.fsPath);(0,D.$Nf)(O.includePattern)[Y.replace(/\\/g,"/")]=!0}else N.fsPath&&(Z=!0,V[N.fsPath]=!0)}),{folderQueries:I,includePattern:V,usingSearchPaths:!0,excludePattern:Z?void 0:{"**/*":!0}}}j(w,I){if(I.isSmartCase){if(w.isRegExp){if(C.$tf(w.pattern,!0))return!0}else if(C.$tf(w.pattern))return!0}return!!w.isCaseSensitive}k(w){return w.isMultiline||w.isRegExp&&(0,b.$CB)(w.pattern)||w.pattern.indexOf(`
`)>=0?!0:!!w.isMultiline}parseSearchPaths(w){const I=he=>E.$hc(he)||/^\.\.?([\/\\]|$)/.test(he),V=(Array.isArray(w)?w:a(w)).map(he=>{const $e=this.e.resolvedUserHome;return $e?(0,M.$Bv)(he,$e.scheme===$.Schemas.file?$e.fsPath:$e.path):he}),Z=T.$J(V,he=>I(he)?"searchPaths":"exprSegments"),N=(Z.exprSegments||[]).map(he=>C.$Oe(he,"/")).map(he=>C.$Oe(he,"\\")).map(he=>(he[0]==="."&&(he="*"+he),d(he))),R={},L=this.m(Z.searchPaths||[]);L&&L.length&&(R.searchPaths=L);const O=y.$Qb(N),Y=s(...O);return Y&&(R.pattern=Y),R}l(w,I){return I.disregardExcludeSettings?void 0:(0,o.$5I)(w,!I.disregardSearchExcludeSettings)}m(w){if(!w||!w.length)return[];const I=w.flatMap(V=>{let{pathPortion:Z,globPortion:N}=n(V);return N&&(N=m(N)),this.n(Z).flatMap(L=>this.o(L,N))}),F=new Map;return I.forEach(V=>{const Z=V.searchPath.toString(),N=F.get(Z);N?V.pattern&&(N.pattern=N.pattern||{},N.pattern[V.pattern]=!0):F.set(Z,{searchPath:V.searchPath,pattern:V.pattern?s(V.pattern):void 0})}),Array.from(F.values())}n(w){if(E.$hc(w)){const I=this.b.getWorkspace().folders;return I[0]&&I[0].uri.scheme!==$.Schemas.file?[{searchPath:I[0].uri.with({path:w})}]:[{searchPath:u.URI.file(E.$gc(w))}]}if(this.b.getWorkbenchState()===2){const I=this.b.getWorkspace().folders[0].uri;if(w=p(w),w.startsWith("../")||w===".."){const V=E.$fc.resolve(I.path,w);return[{searchPath:I.with({path:V})}]}const F=m(w);return[{searchPath:I,pattern:F}]}else{if(w==="./"||w===".\\")return[];{const I=w.replace(/^\.[\/\\]/,""),V=this.b.getWorkspace().folders.map(Z=>{const N=I.match(new RegExp(`^${C.$Je(Z.name)}(?:/(.*)|$)`));return N?{match:N,folder:Z}:null}).filter(D.$Kf);if(V.length)return V.map(Z=>{const N=Z.match[1];return{searchPath:Z.folder.uri,pattern:N&&m(N)}});{const Z=w.match(/\.[\/\\](.+)[\/\\]?/),N=Z?Z[1]:w,R=v.localize(0,null,N);throw new Error(R)}}}}o(w,I){const F=w.pattern&&I?`${w.pattern}/${I}`:w.pattern||I,V=[{searchPath:w.searchPath,pattern:F}];return F&&!F.endsWith("**")&&V.push({searchPath:w.searchPath,pattern:F+"/**"}),V}q(w,I,F){const V=this.r((0,i.$ei)(w.searchPath),I,F,!1);return V?{...V,includePattern:w.pattern}:null}r(w,I,F,V){let Z;const N=u.URI.isUri(w)?w:w.uri;if(F.searchPaths){const he=F.searchPaths.filter($e=>(0,f.$sg)($e.searchPath,N))[0];if(he&&!he.pattern)return null;he&&(Z=he.pattern)}const R=this.a.getValue({resource:N}),O={...this.l(R,I)||{},...Z||{}},Y=u.URI.isUri(w)?(0,f.$wg)(w):w.name;return{folder:N,folderName:V?Y:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:R.files&&R.files.encoding,disregardIgnoreFiles:typeof I.disregardIgnoreFiles=="boolean"?I.disregardIgnoreFiles:!R.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof I.disregardGlobalIgnoreFiles=="boolean"?I.disregardGlobalIgnoreFiles:!R.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof I.disregardParentIgnoreFiles=="boolean"?I.disregardParentIgnoreFiles:!R.search.useParentIgnoreFiles,ignoreSymlinks:typeof I.ignoreSymlinks=="boolean"?I.ignoreSymlinks:!R.search.followSymlinks}}};e.$cK=l,e.$cK=l=Ke([Ve(0,g.$pi),Ve(1,i.$5h),Ve(2,r.$GC),Ve(3,t.$dj),Ve(4,c.$aK)],l);function n(h){const w=h.match(/[\*\{\}\(\)\[\]\?]/);if(w){const I=w.index,F=h.substr(0,I).match(/[/|\\][^/\\]*$/);if(F){let V=h.substr(0,F.index);return V.match(/[/\\]/)||(V+="/"),{pathPortion:V,globPortion:h.substr((F.index||0)+1)}}}return{pathPortion:h}}function s(...h){return h.length?h.reduce((w,I)=>(w[I]=!0,w),Object.create(null)):void 0}function a(h){return P.$Aj(h,",").map(w=>w.trim()).filter(w=>!!w.length)}function d(h){return[`**/${h}/**`,`**/${h}`].map(I=>I.replace(/\*\*\/\*\*/g,"**"))}function p(h){return h.replace(/\\/g,"/")}function m(h){return p(h).replace(/^\.\//,"").replace(/\/+$/g,"")}function S(h){return h.replace(/([?*[\]])/g,"[$1]")}function k(h,w){h=y.$Lb(h,V=>V.toString());const I=[],F=w.getWorkspace();return h&&h.forEach(V=>{let Z;if(w.getWorkbenchState()===2)Z=(0,f.$Bg)(F.folders[0].uri,V),Z&&Z!=="."&&(Z="./"+Z);else{const N=w.getWorkspaceFolder(V);if(N){const R=N.name;if(F.folders.filter(O=>O.name===R).length===1){const O=(0,f.$Bg)(N.uri,V);O===""?Z=`./${N.name}`:Z=`./${N.name}/${O}`}else Z=V.fsPath}}Z&&I.push(S(Z))}),I}e.$dK=k}),define(Pe[286],Ae([1,0,25,2,19,11,4,285,43,47]),function(we,e,y,T,P,M,A,$,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7qb=e.$6qb=void 0;const C=7e3;function D(g,t){const i=t.activationEvents;if(!i)return Promise.resolve(void 0);const r=[],c=[];for(const d of i)if(/^workspaceContains:/.test(d)){const p=d.substr(18);p.indexOf("*")>=0||p.indexOf("?")>=0||g.forceUsingSearch?c.push(p):r.push(p)}if(r.length===0&&c.length===0)return Promise.resolve(void 0);let o;const l=new Promise((d,p)=>{o=d}),n=d=>o({activationEvent:d}),s=Promise.all(r.map(d=>u(g,d,n))).then(()=>{}),a=b(g,t.identifier,c,n);return Promise.all([s,a]).then(()=>{o(void 0)}),l}e.$6qb=D;async function u(g,t,i){for(const r of g.folders)if(await g.exists(y.$zg(T.URI.revive(r),t))){i(`workspaceContains:${t}`);return}}async function b(g,t,i,r){if(i.length===0)return Promise.resolve(void 0);const c=new P.$2d,o=g.checkExists(g.folders,i,c.token),l=setTimeout(async()=>{c.cancel(),g.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},C);let n=!1;try{n=await o}catch(s){M.$3(s)||M.$Z(s)}c.dispose(),clearTimeout(l),n&&r(`workspaceContains:${i.join(",")}`)}function v(g,t,i,r){const c=g.get(A.$Uh),o=g.get(E.$WI),n=c.createInstance($.$cK).file(t.map(s=>(0,f.$ei)(T.URI.revive(s))),{_reason:"checkExists",includePattern:i,exists:!0});return o.fileSearch(n,r).then(s=>!!s.limitHit,s=>M.$3(s)?!1:Promise.reject(s))}e.$7qb=v}),define(Pe[37],Ae([1,0,159,20,88,25,14,6,50,2,15,3,36,218,85,35,23,106,11,22,24,201,7,100,4,27,86,17,71,87,64,5,286,84,203,13,82,60,21,83]),function(we,e,y,T,P,M,A,$,E,f,C,D,u,b,v,g,t,i,r,c,o,l,n,s,a,d,p,m,S,k,h,w,I,F,V,Z,N,R,L,O){"use strict";var Y;Object.defineProperty(e,"__esModule",{value:!0}),e.$Uec=e.$Tec=e.$Sec=e.$Rec=e.$Qec=void 0,e.$Qec=(0,a.$Vh)("IHostUtils");let he=Y=class extends $.$Rc{constructor(Q,B,ne,pe,re,le,ce,ye,_,de,ie,ae){super(),this.X=ae,this.a=this.B(new w.$Rd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=B,this.g=ne,this.f=ce,this.j=pe,this.m=re,this.s=le,this.t=_,this.u=de,this.w=ie,this.y=this.g.getProxy(D.$yK.MainThreadWorkspace),this.z=this.g.getProxy(D.$yK.MainThreadTelemetry),this.C=this.g.getProxy(D.$yK.MainThreadExtensionService),this.D=new A.$Wg,this.F=new A.$Wg,this.G=new A.$Wg,this.H=new A.$Wg,this.I=new Re(this.f.extensions.activationEvents),this.L=new i.$75b(this.I,this.f.extensions.allExtensions);const me=new c.$am(this.f.extensions.myExtensions);this.J=new i.$75b(this.I,ve(this.L,me)),L.$t&&(this.s.info(`Creating extension host with the following global extensions: ${ke(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${ke(this.J)}`)),this.M=new v.$Bec(this.g,this.s),this.N=new F.$Jec(this.g),this.O=ye,this.h=Q.createChild(new S.$Th([v.$Cec,this.M],[F.$Kec,this.N])),this.P=this.B(new b.$Aec(this.J,this.L,{onExtensionActivationError:(Ie,z,W)=>{this.C.$onExtensionActivationError(Ie,r.$2(z),W)},actualActivateExtension:async(Ie,z)=>{if(i.$75b.isHostExtension(Ie,this.J,this.L))return await this.C.$activateExtension(Ie,z),new b.$zec;const W=this.J.getExtensionDescription(Ie);return this.db(W,z)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),P.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(Q){r.$Z(Q)}}async Y(){this.O.onWillDeactivateAll();let Q=[];try{Q=this.J.getAllExtensionDescriptions().map(re=>re.identifier).filter(re=>this.isActivated(re)).map(re=>this.cb(re))}catch{}await Promise.all(Q)}terminate(Q,B=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${Q}`),this.s.flush(),this.u.dispose(),this.P.dispose(),r.setUnexpectedErrorHandler(pe=>{this.s.error(pe)}),this.g.dispose();const ne=this.Y();Promise.race([(0,A.$Yg)(5e3),ne]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${B}`):this.s.info(`Extension host exiting with code ${B}`),this.s.flush(),this.s.dispose(),this.c.exit(B)})}isActivated(Q){return this.G.isOpen()?this.P.isActivated(Q):!1}async getExtension(Q){const B=await this.C.$getExtension(Q);return B&&{...B,identifier:new c.$_l(B.identifier.value),extensionLocation:f.URI.revive(B.extensionLocation)}}Z(Q,B){return this.P.activateByEvent(Q,B)}$(Q,B){return this.P.activateById(Q,B)}activateByIdWithErrors(Q,B){return this.$(Q,B).then(()=>{const ne=this.P.getActivatedExtension(Q);if(ne.activationFailed)return Promise.reject(ne.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(Q=>this.J)}getExtensionExports(Q){if(this.G.isOpen())return this.P.getActivatedExtension(Q).exports;try{return this.P.getActivatedExtension(Q).exports}catch{return null}}async ab(Q){if(Q.scheme===Z.Schemas.file&&this.c.fsRealpath){const B=await this.c.fsRealpath(Q.fsPath);return f.URI.file(B)}return Q}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(Q=>new te(Q))),this.Q}async bb(Q){const B=E.$2h.forUris(ne=>M.$qg.ignorePathCasing(ne));return await Promise.all(Q.map(async ne=>{if(this.ub(ne)){const pe=await this.ab(ne.extensionLocation);B.set(pe,ne)}})),B}cb(Q){let B=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(Q))return B;const ne=this.P.getActivatedExtension(Q);if(!ne)return B;try{typeof ne.module.deactivate=="function"&&(B=Promise.resolve(ne.module.deactivate()).then(void 0,pe=>(this.s.error(pe),Promise.resolve(void 0))))}catch(pe){this.s.error(`An error occurred when deactivating the extension '${Q.value}':`),this.s.error(pe)}try{(0,$.$Mc)(ne.subscriptions)}catch(pe){this.s.error(`An error occurred when deactivating the subscriptions for extension '${Q.value}':`),this.s.error(pe)}return B}async db(Q,B){return this.f.remote.isRemote?this.C.$onWillActivateExtension(Q.identifier):await this.C.$onWillActivateExtension(Q.identifier),this.fb(Q,B).then(ne=>{const pe=ne.activationTimes;return this.C.$onDidActivateExtension(Q.identifier,pe.codeLoadingTime,pe.activateCallTime,pe.activateResolvedTime,B),this.eb(Q,B,"success",pe),ne},ne=>{throw this.eb(Q,B,"failure"),ne})}eb(Q,B,ne,pe){const re=De(Q,B);this.z.$publicLog2("extensionActivationTimes",{...re,...pe||{},outcome:ne})}fb(Q,B){const ne=De(Q,B);this.z.$publicLog2("activatePlugin",ne);const pe=this.ub(Q);if(!pe)return Promise.resolve(new b.$yec(b.$vec.NONE));this.s.info(`ExtensionService#_doActivateExtension ${Q.identifier.value}, startup: ${B.startup}, activationEvent: '${B.activationEvent}'${Q.identifier.value!==B.extensionId.value?`, root cause: ${B.extensionId.value}`:""}`),this.s.flush();const re=new b.$wec(B.startup);return Promise.all([this.vb(Q,(0,M.$zg)(Q.extensionLocation,pe),re),this.gb(Q)]).then(le=>(P.mark(`code/extHost/willActivateExtension/${Q.identifier.value}`),Y.hb(this.s,Q.identifier,le[0],le[1],re))).then(le=>(P.mark(`code/extHost/didActivateExtension/${Q.identifier.value}`),le))}gb(Q){const B=new l.$Eec(Q,this.M),ne=new l.$Dec(Q.identifier.value,!1,this.M),pe=new V.$Lec(Q,this.N),re=Q.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,le=this.f.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${Q.identifier.value}`),Promise.all([B.whenReady,ne.whenReady,this.O.whenReady]).then(()=>{const ce=this;let ye,_;const de=(0,t.$LF)(Q,"ipc")?this.f.messagePorts?.get(c.$_l.toKey(Q.identifier)):void 0;return Object.freeze({globalState:B,workspaceState:ne,secrets:pe,subscriptions:[],get extensionUri(){return Q.extensionLocation},get extensionPath(){return Q.extensionLocation.fsPath},asAbsolutePath(ie){return T.$ic(Q.extensionLocation.fsPath,ie)},get storagePath(){return ce.O.workspaceValue(Q)?.fsPath},get globalStoragePath(){return ce.O.globalValue(Q).fsPath},get logPath(){return T.$ic(ce.f.logsLocation.fsPath,Q.identifier.value)},get logUri(){return f.URI.joinPath(ce.f.logsLocation,Q.identifier.value)},get storageUri(){return ce.O.workspaceValue(Q)},get globalStorageUri(){return ce.O.globalValue(Q)},get extensionMode(){return re},get extension(){return ye===void 0&&(ye=new fe(ce,Q.identifier,Q,le,!1)),ye},get extensionRuntime(){return(0,t.$MF)(Q,"extensionRuntime"),ce.extensionRuntime},get environmentVariableCollection(){return ce.u.getEnvironmentVariableCollection(Q)},get messagePassingProtocol(){if(!_){if(!de)return;const ie=w.Event.buffer(w.Event.fromDOMEventEmitter(de,"message",ae=>ae.data));de.start(),_={onDidReceiveMessage:ie,postMessage:de.postMessage.bind(de)}}return _}})})}static hb(Q,B,ne,pe,re){return ne=ne||{activate:void 0,deactivate:void 0},this.ib(Q,B,ne,pe,re).then(le=>new b.$xec(!1,null,re.build(),ne,le,pe.subscriptions))}static ib(Q,B,ne,pe,re){if(typeof ne.activate=="function")try{re.activateCallStart(),Q.trace(`ExtensionService#_callActivateOptional ${B.value}`);const le=typeof global=="object"?global:self,ce=ne.activate.apply(le,[pe]);return re.activateCallStop(),re.activateResolveStart(),Promise.resolve(ce).then(ye=>(re.activateResolveStop(),ye))}catch(le){return Promise.reject(le)}else return Promise.resolve(ne)}jb(Q,B){this.$(Q.identifier,{startup:!1,extensionId:Q.identifier,activationEvent:B}).then(void 0,ne=>{this.s.error(ne)})}kb(Q,B=0){const pe=Date.now();(0,L.$B)(()=>{for(let re=B;re<Q.length;re+=1){const le=Q[re];for(const ce of le.activationEvents??[])if(ce==="onStartupFinished")if(Date.now()-pe>50){this.kb(Q,re);break}else this.jb(le,ce)}})}lb(){this.C.$setPerformanceMarks(P.getMarks()),this.m.getConfigProvider().then(Q=>{const B=Q.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ne=this.J.getAllExtensionDescriptions();if(B)this.kb(ne);else for(const pe of ne)if(pe.activationEvents)for(const re of pe.activationEvents)re==="onStartupFinished"&&this.jb(pe,re)})}mb(){const Q=this.Z("*",!0).then(void 0,le=>{this.s.error(le)});this.B(this.j.onDidChangeWorkspace(le=>this.nb(le.added)));const B=this.j.workspace?this.j.workspace.folders:[],ne=this.nb(B),pe=this.pb(),re=Promise.all([pe,Q,ne]).then(()=>{});return Promise.race([re,(0,A.$Yg)(1e4)]).then(()=>{this.lb()}),re}nb(Q){return Q.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(B=>this.ob(Q,B))).then(()=>{})}async ob(Q,B){if(this.isActivated(B.identifier))return;const ne=!this.f.remote.isRemote&&!!this.f.remote.authority,pe={logService:this.s,folders:Q.map(le=>le.uri),forceUsingSearch:ne||!this.c.fsExists,exists:le=>this.c.fsExists(le.fsPath),checkExists:(le,ce,ye)=>this.y.$checkExists(le,ce,ye)},re=await(0,I.$6qb)(pe,B);if(re)return this.$(B.identifier,{startup:!0,extensionId:B.identifier,activationEvent:re.activationEvent}).then(void 0,le=>this.s.error(le))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(Q){throw console.error(Q),Q}}async qb(){const{extensionDevelopmentLocationURI:Q,extensionTestsLocationURI:B}=this.f.environment;if(!Q||!B)throw new Error(y.localize(0,null));const ne=await this.vb(null,B,new b.$wec(!1));if(!ne||typeof ne.run!="function")throw new Error(y.localize(1,null,B.toString()));return new Promise((pe,re)=>{const le=(_,de)=>{_?(L.$t&&this.s.error("Test runner called back with error",_),re(_)):(L.$t&&(de?this.s.info(`Test runner called back with ${de} failures.`):this.s.info("Test runner called back with successful outcome.")),pe(typeof de=="number"&&de>0?1:0))},ce=(0,M.$ng)(B),ye=ne.run(ce,le);ye&&ye.then&&ye.then(()=>{L.$t&&this.s.info("Test runner finished successfully."),pe(0)}).catch(_=>{L.$t&&this.s.error("Test runner finished with error",_),re(_ instanceof Error&&_.stack?_.stack:String(_))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$Yg)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Q,B){return this.R[Q]=B,(0,$.$Pc)(()=>{delete this.R[Q]})}async getRemoteExecServer(Q){const{resolver:B}=await this.sb(Q);return B?.resolveExecServer?.(Q,{resolveAttempt:0})}async sb(Q){const B=Q.indexOf("+");if(B===-1)throw new n.$GK("Not an authority that can be resolved!",s.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ne=Q.substr(0,B);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ne}`,!1),{authorityPrefix:ne,resolver:this.R[ne]}}async $resolveAuthority(Q,B){const ne=R.$Nd.create(!1),pe=()=>`[resolveAuthority(${(0,s.$Zk)(Q)},${B})][${ne.elapsed()}ms] `,re=G=>this.s.info(`${pe()}${G}`),le=G=>this.s.warn(`${pe()}${G}`),ce=(G,q=void 0)=>this.s.error(`${pe()}${G}`,q),ye=G=>{if(G instanceof n.$GK)return{type:"error",error:{code:G._code,message:G._message,detail:G._detail}};throw G},_=async G=>{re(`activating resolver for ${G}...`);const{resolver:q,authorityPrefix:x}=await this.sb(G);if(!q)throw ce(`no resolver for ${x}`),new n.$GK(`No remote extension installed to resolve ${x}.`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:q,authorityPrefix:x,remoteAuthority:G}},de=Q.split(/@|%40/g).reverse();re(`activating remote resolvers ${de.join(" -> ")}`);let ie;try{ie=await Promise.all(de.map(_)).catch(async G=>{if(!(G instanceof n.$GK)||G._code!==s.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw G;return le(`resolving nested authorities failed: ${G.message}`),[await _(Q)]})}catch(G){return ye(G)}const ae=new A.$9g;ae.cancelAndSet(()=>re("waiting..."),1e3);let me,Ie;for(const[G,{authorityPrefix:q,resolver:x,remoteAuthority:ue}]of ie.entries())try{if(G===ie.length-1)re("invoking final resolve()..."),P.mark(`code/extHost/willResolveAuthority/${q}`),me=await x.resolve(ue,{resolveAttempt:B,execServer:Ie}),P.mark(`code/extHost/didResolveAuthorityOK/${q}`),re("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(x,n.$FK.isManagedResolvedAuthority(me)?me:void 0));else{if(re(`invoking resolveExecServer() for ${ue}`),P.mark(`code/extHost/willResolveExecServer/${q}`),Ie=await x.resolveExecServer?.(ue,{resolveAttempt:B,execServer:Ie}),!Ie)throw new n.$GK(`Exec server was not available for ${ue}`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);P.mark(`code/extHost/didResolveExecServerOK/${q}`)}}catch(Oe){return P.mark(`code/extHost/didResolveAuthorityError/${q}`),ce("returned an error",Oe),ae.dispose(),ye(Oe)}ae.dispose();const z={environmentTunnels:me.environmentTunnels,features:me.tunnelFeatures},W={extensionHostEnv:me.extensionHostEnv,isTrusted:me.isTrusted,authenticationSession:me.authenticationSessionForInitializingExtensions?{id:me.authenticationSessionForInitializingExtensions.id,providerId:me.authenticationSessionForInitializingExtensions.providerId}:void 0};re(`returned ${n.$FK.isManagedResolvedAuthority(me)?"managed authority":`${me.host}:${me.port}`}`);let H;if(n.$FK.isManagedResolvedAuthority(me)){const G=B;this.X.setFactory(G,me.makeConnection),H={authority:Q,connectTo:new s.$Wk(G),connectionToken:me.connectionToken}}else H={authority:Q,connectTo:new s.$Xk(me.host,me.port),connectionToken:me.connectionToken};return{type:"ok",value:{authority:H,options:W,tunnelInformation:z}}}async $getCanonicalURI(Q,B){this.s.info(`$getCanonicalURI invoked for authority (${(0,s.$Zk)(Q)})`);const{resolver:ne}=await this.sb(Q);if(!ne)return null;const pe=f.URI.revive(B);if(typeof ne.getCanonicalURI>"u")return pe;const re=await(0,A.$Qg)(()=>ne.getCanonicalURI(pe));return re||pe}$startExtensionHost(Q){Q.toAdd.forEach(pe=>pe.extensionLocation=f.URI.revive(pe.extensionLocation));const{globalRegistry:B,myExtensions:ne}=$e(this.I,this.L,this.J,Q);return this.L.set(B.getAllExtensionDescriptions()),this.J.set(ne),L.$t&&(this.s.info(`$startExtensionHost: global extensions: ${ke(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${ke(this.J)}`)),this.rb()}$activateByEvent(Q,B){return B===1?this.D.wait().then(ne=>this.Z(Q,!1)):this.G.wait().then(ne=>this.Z(Q,!1))}async $activate(Q,B){return await this.G.wait(),this.J.getExtensionDescription(Q)?(await this.$(Q,B),!0):!1}async $deltaExtensions(Q){Q.toAdd.forEach(le=>le.extensionLocation=f.URI.revive(le.extensionLocation));const{globalRegistry:B,myExtensions:ne}=$e(this.I,this.L,this.J,Q),pe=await this.bb(ne);return(await this.getExtensionPathIndex()).setSearchTree(pe),this.L.set(B.getAllExtensionDescriptions()),this.J.set(ne),L.$t&&(this.s.info(`$deltaExtensions: global extensions: ${ke(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${ke(this.J)}`)),Promise.resolve(void 0)}async $test_latency(Q){return Q}async $test_up(Q){return Q.byteLength}async $test_down(Q){const B=o.$fe.alloc(Q),ne=Math.random()%256;for(let pe=0;pe<Q;pe++)B.writeUInt8(ne,pe);return B}async $updateRemoteConnectionData(Q){this.W=Q,this.a.fire()}};e.$Rec=he,e.$Rec=he=Y=Ke([Ve(0,a.$Uh),Ve(1,e.$Qec),Ve(2,m.$AM),Ve(3,g.$eec),Ve(4,u.$hec),Ve(5,C.$dj),Ve(6,d.$QM),Ve(7,p.$kec),Ve(8,k.$Ywb),Ve(9,h.$Fec),Ve(10,N.$Nec),Ve(11,O.$Oec)],he);function $e(se,Q,B,ne){se.addActivationEvents(ne.addActivationEvents);const pe=new i.$75b(se,Q.getAllExtensionDescriptions());pe.deltaExtensions(ne.toAdd,ne.toRemove);const re=new c.$am(B.getAllExtensionDescriptions().map(ce=>ce.identifier));for(const ce of ne.myToRemove)re.delete(ce);for(const ce of ne.myToAdd)re.add(ce);const le=ve(pe,re);return{globalRegistry:pe,myExtensions:le}}function De(se,Q){return{id:se.identifier.value,name:se.name,extensionVersion:se.version,publisherDisplayName:se.publisher,activationEvents:se.activationEvents?se.activationEvents.join(","):null,isBuiltin:se.isBuiltin,reason:Q.activationEvent,reasonId:Q.extensionId.value}}function ke(se){return se.getAllExtensionDescriptions().map(Q=>Q.identifier.value).join(",")}e.$Sec=(0,a.$Vh)("IExtHostExtensionService");class fe{#e;#t;#i;constructor(Q,B,ne,pe,re){this.#e=Q,this.#t=B,this.#i=ne.identifier,this.id=ne.identifier.value,this.extensionUri=ne.extensionLocation,this.extensionPath=T.$gc((0,M.$ng)(ne.extensionLocation)),this.packageJSON=ne,this.extensionKind=pe,this.isFromDifferentExtensionHost=re}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Tec=fe;function ve(se,Q){return se.getAllExtensionDescriptions().filter(B=>Q.has(B.identifier))}class te{constructor(Q){this.a=Q}setSearchTree(Q){this.a=Q}findSubstr(Q){return this.a.findSubstr(Q)}forEach(Q){return this.a.forEach(Q)}}e.$Uec=te;class Re{constructor(Q){this.a=new c.$bm,this.addActivationEvents(Q)}readActivationEvents(Q){return this.a.get(Q.identifier)??[]}addActivationEvents(Q){for(const B of Object.keys(Q))this.a.set(B,Q[B])}}}),define(Pe[287],Ae([1,0,88,2,3,36,23,22,17,27,4,37,15,12]),function(we,e,y,T,P,M,A,$,E,f,C,D,u,b){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$3fc=void 0;let g=class{constructor(o,l,n,s,a,d,p){this.c=o,this.d=l,this.e=n,this.f=s,this.g=a,this.h=d,this.i=p,this.a=new Map,this.b=[]}async install(){this.j(),y.mark("code/extHost/willWaitForConfig");const o=await this.f.getConfigProvider();y.mark("code/extHost/didWaitForConfig");const l=await this.g.getExtensionPathIndex();this.register(new i(this.c,l,this.d,o,this.i)),this.register(this.e.createInstance(t)),this.h.remote.isRemote&&this.register(this.e.createInstance(r,l,this.h.environment.appUriScheme))}register(o){if("nodeModuleName"in o)if(Array.isArray(o.nodeModuleName))for(const l of o.nodeModuleName)this.a.set(l,o);else this.a.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this.b.push(l=>o.alternativeModuleName(l))}};e.$3fc=g,e.$3fc=g=Ke([Ve(2,C.$Uh),Ve(3,M.$hec),Ve(4,D.$Sec),Ve(5,f.$QM),Ve(6,u.$dj)],g);let t=class{static{v=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(o){if(o.environment.appRoot&&v.a.size){const l=(0,b.$Je)(this.c(o.environment.appRoot.fsPath)),n="[a-z0-9_.-]",s=`@${n}+\\/${n}+|${n}+`,a="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${l}/${a}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(o){if(!this.b)return;const l=this.b.exec(this.c(o));if(!l)return;const[,n,s,a]=l,d=v.a.get(s);if(d!==void 0)return console.warn(`${s} as been renamed to ${d}, please update your imports`),n+d+a}c(o){return o.replace(/\\/g,"/")}};t=v=Ke([Ve(0,f.$QM)],t);class i{constructor(o,l,n,s,a){this.c=o,this.d=l,this.e=n,this.f=s,this.g=a,this.nodeModuleName="vscode",this.a=new $.$bm}load(o,l){const n=this.d.findSubstr(l);if(n){let s=this.a.get(n.identifier);return s||(s=this.c(n,this.e,this.f),this.a.set(n.identifier,s)),s}if(!this.b){let s="";this.d.forEach((a,d)=>s+=`	${d} -> ${a.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${l}. These are the extension path mappings: 
${s}`),this.b=this.c(A.$GF,this.e,this.f)}return this.b}}let r=class{constructor(o,l,n){this.e=o,this.f=l,this.nodeModuleName=["open","opn"],this.d=n.getProxy(P.$yK.MainThreadTelemetry);const s=n.getProxy(P.$yK.MainThreadWindow);this.c=(a,d)=>{const p=T.URI.parse(a);return d?this.g(a,d):p.scheme==="http"||p.scheme==="https"?s.$openUri(p,a,{allowTunneling:!0}):p.scheme==="mailto"||p.scheme===this.f?s.$openUri(p,a,{}):this.g(a,d)}}load(o,l,n){const s=this.e.findSubstr(l);return s&&(this.a=s.identifier.value,this.h()),this.b=n(o),this.c}g(o,l){return this.i(),this.b(o,l)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};r=Ke([Ve(2,E.$AM)],r)}),define(Pe[116],Ae([1,0,44,6,20,74,4,61,62,37,7,35,215,36]),function(we,e,y,T,P,M,A,$,E,f,C,D,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wec=e.$Vec=void 0,e.$Vec=(0,A.$Vh)("IExtHostVariableResolverProvider");class v extends u.$BN{constructor(i,r,c,o,l,n,s){function a(){if(c){const d=c.activeEditor();if(d)return d.document.uri;const p=o.tabGroups.all.find(m=>m.isActive)?.activeTab;if(p!==void 0){if(p.input instanceof C.$gM||p.input instanceof C.$lM)return p.input.modified;if(p.input instanceof C.$fM||p.input instanceof C.$kM||p.input instanceof C.$iM)return p.input.uri}}}super({getFolderUri:d=>{const p=n.folders.filter(m=>m.name===d);if(p&&p.length>0)return p[0].uri},getWorkspaceFolderCount:()=>n.folders.length,getConfigurationValue:(d,p)=>l.getConfiguration(void 0,d).get(p),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const d=a();if(d)return P.$gc(d.fsPath)},getWorkspaceFolderPathForFile:()=>{if(r){const d=a();if(d){const p=r.getWorkspaceFolder(d);if(p)return P.$gc(p.uri.fsPath)}}},getSelectedText:()=>{if(c){const d=c.activeEditor();if(d&&!d.selection.isEmpty)return d.document.getText(d.selection)}},getLineNumber:()=>{if(c){const d=c.activeEditor();if(d)return String(d.selection.end.line+1)}},getExtension:d=>i.getExtension(d)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(M.env))}}let g=class extends T.$Rc{constructor(i,r,c,o,l){super(),this.b=i,this.c=r,this.g=c,this.h=o,this.j=l,this.a=new y.$U(async()=>{const n=await this.h.getConfigProvider(),a={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async d=>{a.folders=await this.c.getWorkspaceFolders2()||[]})),new v(this.b,this.c,this.g,this.j,n,a,this.m())})}getResolver(){return this.a.value}m(){}};e.$Wec=g,e.$Wec=g=Ke([Ve(0,f.$Sec),Ve(1,D.$eec),Ve(2,$.$LM),Ve(3,b.$hec),Ve(4,E.$tec)],g)}),define(Pe[117],Ae([1,0,14,5,2,4,3,62,37,17,7,35,207,209,36,116]),function(we,e,y,T,P,M,A,$,E,f,C,D,u,b,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ec=e.$1ec=e.$Zec=e.$Yec=e.$Xec=void 0,e.$Xec=(0,M.$Vh)("IExtHostDebugService");let t=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(s,a,d,p,m,S){this.E=a,this.F=d,this.G=p,this.H=m,this.I=S,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new T.$Rd,this.n=new T.$Rd,this.o=new T.$Rd,this.u=new T.$Rd,this.k=s.getProxy(A.$yK.MainThreadDebugService),this.y=new T.$Rd,this.A=new T.$Rd,this.v=new r(this.k),this.w=new Map,this.F.getExtensionRegistry().then(k=>{k.onDidChange(h=>{this.J(k)}),this.J(k)})}asDebugSourceUri(s,a){const d=s;if(typeof d.sourceReference=="number"&&d.sourceReference>0){let p=`debug:${encodeURIComponent(d.path||"")}`,m="?";return a&&(p+=`${m}session=${encodeURIComponent(a.id)}`,m="&"),p+=`${m}ref=${d.sourceReference}`,P.URI.parse(p)}else{if(d.path)return P.URI.file(d.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(s){const a=[];for(const d of s.getAllExtensionDescriptions())if(d.contributes){const p=d.contributes.debuggers;if(p&&p.length>0)for(const m of p)(0,b.$iF)(m)&&a.push(m.type)}this.k.$registerDebugTypes(a)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const s=[];return this.w.forEach(a=>s.push(a)),s}addBreakpoints(s){const a=s.filter(m=>{const S=m.id;return this.w.has(S)?!1:(this.w.set(S,m),!0)});this.U(a,[],[]);const d=[],p=new Map;for(const m of a)if(m instanceof C.$zL){let S=p.get(m.location.uri.toString());S||(S={type:"sourceMulti",uri:m.location.uri,lines:[]},p.set(m.location.uri.toString(),S),d.push(S)),S.lines.push({id:m.id,enabled:m.enabled,condition:m.condition,hitCondition:m.hitCondition,logMessage:m.logMessage,line:m.location.range.start.line,character:m.location.range.start.character})}else m instanceof C.$AL&&d.push({type:"function",id:m.id,enabled:m.enabled,hitCondition:m.hitCondition,logMessage:m.logMessage,condition:m.condition,functionName:m.functionName});return this.k.$registerBreakpoints(d)}removeBreakpoints(s){const a=s.filter(S=>this.w.delete(S.id));this.U([],a,[]);const d=a.filter(S=>S instanceof C.$zL).map(S=>S.id),p=a.filter(S=>S instanceof C.$AL).map(S=>S.id),m=a.filter(S=>S instanceof C.$BL).map(S=>S.id);return this.k.$unregisterBreakpoints(d,p,m)}startDebugging(s,a,d){return this.k.$startDebugging(s?s.uri:void 0,a,{parentSessionID:d.parentSession?d.parentSession.id:void 0,lifecycleManagedByParent:d.lifecycleManagedByParent,repl:d.consoleMode===C.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:d.noDebug,compact:d.compact,suppressSaveBeforeStart:d.suppressSaveBeforeStart,suppressDebugStatusbar:d.suppressDebugStatusbar??d.debugUI?.simple,suppressDebugToolbar:d.suppressDebugToolbar??d.debugUI?.simple,suppressDebugView:d.suppressDebugView??d.debugUI?.simple})}stopDebugging(s){return this.k.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,a,d){if(!a)return new C.$AK(()=>{});const p=this.d++;return this.f.push({type:s,handle:p,provider:a}),this.k.$registerDebugConfigurationProvider(s,d,!!a.provideDebugConfigurations,!!a.resolveDebugConfiguration,!!a.resolveDebugConfigurationWithSubstitutedVariables,p),new C.$AK(()=>{this.f=this.f.filter(m=>m.provider!==a),this.k.$unregisterDebugConfigurationProvider(p)})}registerDebugAdapterDescriptorFactory(s,a,d){if(!d)return new C.$AK(()=>{});if(!this.Q(s,a))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${a}' debugger.`);if(this.N(a))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const p=this.g++;return this.h.push({type:a,handle:p,factory:d}),this.k.$registerDebugAdapterDescriptorFactory(a,p),new C.$AK(()=>{this.h=this.h.filter(m=>m.factory!==d),this.k.$unregisterDebugAdapterDescriptorFactory(p)})}registerDebugAdapterTrackerFactory(s,a){if(!a)return new C.$AK(()=>{});const d=this.i++;return this.j.push({type:s,handle:d,factory:a}),new C.$AK(()=>{this.j=this.j.filter(p=>p.factory!==a)})}async $runInTerminal(s,a){return Promise.resolve(void 0)}async $substituteVariables(s,a){let d;const p=await this.W(s);return p&&(d={uri:p.uri,name:p.name,index:p.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(d,a)}K(s,a){if(s.type==="implementation")return new o(s.implementation)}L(){}async $startDASession(s,a){const d=this,p=await this.V(a);return this.S(this.N(p.type),p).then(m=>{if(!m)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${p.type}' (extension might have failed to activate)`);const S=this.M(m),k=this.K(S,p);if(!k)throw new Error(`Couldn't create a debug adapter for type '${p.type}'.`);const h=k;return this.B.set(s,h),this.R(p).then(w=>(w&&this.C.set(s,w),h.onMessage(async I=>{if(I.type==="request"&&I.command==="handshake"){const F=I,V={type:"response",seq:0,command:F.command,request_seq:F.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const Z=await this.D.sign(F.arguments.value);V.body={signature:Z},h.sendResponse(V)}else throw new Error("no signer")}catch(Z){V.success=!1,V.message=Z.message,h.sendResponse(V)}}else w&&w.onDidSendMessage&&w.onDidSendMessage(I),I=(0,b.$nF)(I,!0),d.k.$acceptDAMessage(s,I)}),h.onError(I=>{w&&w.onError&&w.onError(I),this.k.$acceptDAError(s,I.name,I.message,I.stack)}),h.onExit(I=>{w&&w.onExit&&w.onExit(I??void 0,void 0),this.k.$acceptDAExit(s,I??void 0,void 0)}),w&&w.onWillStartSession&&w.onWillStartSession(),h.startSession()))})}$sendDAMessage(s,a){a=(0,b.$mF)(a,!1);const d=this.C.get(s);d&&d.onWillReceiveMessage&&d.onWillReceiveMessage(a),this.B.get(s)?.sendMessage(a)}$stopDASession(s){const a=this.C.get(s);this.C.delete(s),a&&a.onWillStopSession&&a.onWillStopSession();const d=this.B.get(s);return this.B.delete(s),d?d.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const a=[],d=[],p=[];if(s.added)for(const m of s.added){const S=m.id;if(S&&!this.w.has(S)){let k;if(m.type==="function")k=new C.$AL(m.functionName,m.enabled,m.condition,m.hitCondition,m.logMessage);else if(m.type==="data")k=new C.$BL(m.label,m.dataId,m.canPersist,m.enabled,m.hitCondition,m.condition,m.logMessage);else{const h=P.URI.revive(m.uri);k=new C.$zL(new C.$MK(h,new C.$BK(m.line,m.character)),m.enabled,m.condition,m.hitCondition,m.logMessage)}(0,C.$xL)(k,S),this.w.set(S,k),a.push(k)}}if(s.removed)for(const m of s.removed){const S=this.w.get(m);S&&(this.w.delete(m),d.push(S))}if(s.changed){for(const m of s.changed)if(m.id){const S=this.w.get(m.id);if(S){if(S instanceof C.$AL&&m.type==="function"){const k=S;k.enabled=m.enabled,k.condition=m.condition,k.hitCondition=m.hitCondition,k.logMessage=m.logMessage,k.functionName=m.functionName}else if(S instanceof C.$zL&&m.type==="source"){const k=S;k.enabled=m.enabled,k.condition=m.condition,k.hitCondition=m.hitCondition,k.logMessage=m.logMessage,k.location=new C.$MK(P.URI.revive(m.uri),new C.$BK(m.line,m.character))}p.push(S)}}}this.U(a,d,p)}async $acceptStackFrameFocus(s){let a;const d=s.sessionId?await this.V(s.sessionId):void 0;if(!d)throw new Error("no DebugSession found for debug focus context");s.kind==="thread"?a=new C.$HL(d,s.threadId):a=new C.$GL(d,s.threadId,s.frameId),this.z=a,this.A.fire(this.z)}$provideDebugConfigurations(s,a,d){return(0,y.$Qg)(async()=>{const p=this.P(s);if(!p)throw new Error("no DebugConfigurationProvider found");if(!p.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const m=await this.W(a);return p.provideDebugConfigurations(m,d)}).then(p=>{if(!p)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return p})}$resolveDebugConfiguration(s,a,d,p){return(0,y.$Qg)(async()=>{const m=this.P(s);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const S=await this.W(a);return m.resolveDebugConfiguration(S,d,p)})}$resolveDebugConfigurationWithSubstitutedVariables(s,a,d,p){return(0,y.$Qg)(async()=>{const m=this.P(s);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const S=await this.W(a);return m.resolveDebugConfigurationWithSubstitutedVariables(S,d,p)})}async $provideDebugAdapter(s,a){const d=this.O(s);if(!d)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const p=await this.V(a);return this.S(d,p).then(m=>{if(!m)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${p.type}'`);return this.M(m)})}async $acceptDebugSessionStarted(s){const a=await this.V(s);this.m.fire(a)}async $acceptDebugSessionTerminated(s){const a=await this.V(s);a&&(this.n.fire(a),this.l.delete(a.id))}async $acceptDebugSessionActiveChanged(s){this.q=s?await this.V(s):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(s,a){(await this.V(s))?._acceptNameChanged(a)}async $acceptDebugSessionCustomEvent(s,a){const p={session:await this.V(s),event:a.event,body:a.body};this.u.fire(p)}M(s){if(s instanceof C.$CL)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof C.$DL)return{type:"server",port:s.port,host:s.host};if(s instanceof C.$EL)return{type:"pipeServer",path:s.path};if(s instanceof C.$FL)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}N(s){const a=this.h.filter(d=>d.type===s);if(a.length>0)return a[0].factory}O(s){const a=this.h.filter(d=>d.handle===s);if(a.length>0)return a[0].factory}P(s){const a=this.f.filter(d=>d.handle===s);if(a.length>0)return a[0].provider}Q(s,a){if(s.contributes){const d=s.contributes.debuggers;if(d&&d.length>0){for(const p of d)if(p.label&&p.type&&p.type===a)return!0}}return!1}R(s){const d=s.configuration.type,p=this.j.filter(m=>m.type===d||m.type==="*").map(m=>(0,y.$Qg)(()=>m.factory.createDebugAdapterTracker(s)).then(S=>S,S=>null));return Promise.race([Promise.all(p).then(m=>{const S=m.filter(k=>!!k);if(S.length>0)return new c(S)}),new Promise(m=>setTimeout(()=>m(void 0),1e3))]).catch(m=>{})}async S(s,a){const d=a.configuration.debugServer;if(typeof d=="number")return Promise.resolve(new C.$DL(d));if(s){const m=await this.F.getExtensionRegistry();return(0,y.$Qg)(()=>s.createDebugAdapterDescriptor(a,this.T(a,m))).then(S=>{if(S)return S})}const p=await this.F.getExtensionRegistry();return Promise.resolve(this.T(a,p))}T(s,a){}U(s,a,d){(s.length>0||a.length>0||d.length>0)&&this.y.fire(Object.freeze({added:s,removed:a,changed:d}))}async V(s){if(s)if(typeof s=="string"){const a=this.l.get(s);if(a)return a}else{let a=this.l.get(s.id);if(!a){const d=await this.W(s.folderUri),p=s.parent?this.l.get(s.parent):void 0;a=new i(this.k,s.id,s.type,s.name,d,s.configuration,p),this.l.set(a.id,a),this.k.$sessionCached(a.id)}return a}throw new Error("cannot find session")}W(s){if(s){const a=P.URI.revive(s);return this.E.resolveWorkspaceFolder(a)}return Promise.resolve(void 0)}};e.$Yec=t,e.$Yec=t=Ke([Ve(0,f.$AM),Ve(1,D.$eec),Ve(2,E.$Sec),Ve(3,v.$hec),Ve(4,$.$tec),Ve(5,g.$Vec)],t);class i{constructor(s,a,d,p,m,S,k){this.d=s,this.f=a,this.g=d,this.h=p,this.i=m,this.j=S,this.k=k}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(s){this.h=s,this.d.$setDebugSessionName(this.f,s)}get parentSession(){return this.k}_acceptNameChanged(s){this.h=s}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(s,a){return this.d.$customDebugAdapterRequest(this.f,s,a)}getDebugProtocolBreakpoint(s){return this.d.$getDebugProtocolBreakpoint(this.f,s.id)}}e.$Zec=i;class r{constructor(s){this.value=Object.freeze({append(a){s.$appendDebugConsole(a)},appendLine(a){this.append(a+`
`)}})}}e.$1ec=r;class c{constructor(s){this.d=s}onWillStartSession(){this.d.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.d.forEach(a=>a.onWillReceiveMessage?a.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.d.forEach(a=>a.onDidSendMessage?a.onDidSendMessage(s):void 0)}onWillStopSession(){this.d.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.d.forEach(a=>a.onError?a.onError(s):void 0)}onExit(s,a){this.d.forEach(d=>d.onExit?d.onExit(s,a):void 0)}}class o extends u.$_cb{constructor(s){super(),this.h=s,s.onDidSendMessage(a=>{this.acceptMessage(a)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.h.handleMessage(s)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let l=class extends t{constructor(s,a,d,p,m,S){super(s,a,d,p,m,S)}};e.$2ec=l,e.$2ec=l=Ke([Ve(0,f.$AM),Ve(1,D.$eec),Ve(2,E.$Sec),Ve(3,v.$hec),Ve(4,$.$tec),Ve(5,g.$Vec)],l)}),define(Pe[288],Ae([1,0,11,88,2,3,276,15,70,71,27,185,17,57,37,59]),function(we,e,y,T,P,M,A,$,E,f,C,D,u,b,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5fc=e.$4fc=void 0;class t{static async installEarlyHandler(c){Error.stackTraceLimit=100;const o=c.get($.$dj),n=c.get(u.$AM).getProxy(M.$yK.MainThreadErrors);y.setUnexpectedErrorHandler(s=>{o.error(s);const a=y.$2(s);n.$onUnexpectedError(a)})}static async installFullHandler(c){const o=c.get($.$dj),l=c.get(u.$AM),n=c.get(v.$Sec),s=c.get(g.$UM),a=l.getProxy(M.$yK.MainThreadExtensionService),d=l.getProxy(M.$yK.MainThreadErrors),p=await n.getExtensionPathIndex(),m=new WeakMap;function S(w,I){if(m.has(w))return m.get(w).stack;let F="",V,Z;for(const R of I)F+=`
	at ${R.toString()}`,Z=R.getFileName(),!V&&Z&&(V=p.findSubstr(P.URI.file(Z)));const N=`${w.name||"Error"}: ${w.message||""}${F}`;return m.set(w,{extensionIdentifier:V?.identifier,stack:N}),N}const k=Symbol("prepareStackTrace wrapped");let h=S;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return h},set(w){if(w===S||!w||w[k]){h=w||S;return}h=function(I,F){return S(I,F),w.call(Error,I,F)},Object.assign(h,{[k]:!0})}}),y.setUnexpectedErrorHandler(w=>{o.error(w);const I=y.$2(w),F=m.get(w);if(!F?.extensionIdentifier){d.$onUnexpectedError(I);return}a.$onExtensionRuntimeError(F.extensionIdentifier,I);const V=s.onExtensionError(F.extensionIdentifier,w);o.trace("forwarded error to extension?",V,F)})}}e.$4fc=t;class i{constructor(c,o,l,n,s){this.a=l,this.b=new A.$c6b(c,null,n),o=i.e(o,this.b);const a=new f.$Th(...(0,E.$Dr)());a.set(C.$QM,{_serviceBrand:void 0,...o,messagePorts:s}),a.set(u.$AM,new u.$BM(this.b)),a.set(b.$bec,new b.$cec(n)),a.set(v.$Qec,l);const d=new D.$jq(a,!0);d.invokeFunction(t.installEarlyHandler),this.d=d.invokeFunction(p=>p.get($.$dj)),T.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",o),this.c=d.invokeFunction(p=>p.get(v.$Sec)),this.c.initialize(),d.invokeFunction(t.installFullHandler)}async asBrowserUri(c){const o=this.b.getProxy(M.$yK.MainThreadExtensionService);return P.URI.revive(await o.$asBrowserUri(c))}terminate(c){this.c.terminate(c)}static e(c,o){c.extensions.allExtensions.forEach(n=>{n.extensionLocation=P.URI.revive(o.transformIncomingURIs(n.extensionLocation))}),c.environment.appRoot=P.URI.revive(o.transformIncomingURIs(c.environment.appRoot));const l=c.environment.extensionDevelopmentLocationURI;return l&&(c.environment.extensionDevelopmentLocationURI=l.map(n=>P.URI.revive(o.transformIncomingURIs(n)))),c.environment.extensionTestsLocationURI=P.URI.revive(o.transformIncomingURIs(c.environment.extensionTestsLocationURI)),c.environment.globalStorageHome=P.URI.revive(o.transformIncomingURIs(c.environment.globalStorageHome)),c.environment.workspaceStorageHome=P.URI.revive(o.transformIncomingURIs(c.environment.workspaceStorageHome)),c.environment.extensionTelemetryLogResource=P.URI.revive(o.transformIncomingURIs(c.environment.extensionTelemetryLogResource)),c.nlsBaseUrl=P.URI.revive(o.transformIncomingURIs(c.nlsBaseUrl)),c.logsLocation=P.URI.revive(o.transformIncomingURIs(c.logsLocation)),c.workspace=o.transformIncomingURIs(c.workspace),c}}e.$5fc=i}),define(Pe[289],Ae([1,0,18,14,19,39,13,20,25,2,43]),function(we,e,y,T,P,M,A,$,E,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gfc=e.$ffc=e.$efc=e.$dfc=void 0;class D{constructor(r,c,o,l){this.d=r,this.e=c,this.f=o,this.g=l,this.a=null,this.b=!1,this.c=0}search(r,c){const o=this.d.folderQueries||[],l=new P.$2d(c);return new Promise((n,s)=>{this.a=new b(r);let a=!1;const d=(p,m)=>{if(!a&&!this.b){const S=this.h(p);g(p)&&typeof this.d.maxResults=="number"&&this.c+S>this.d.maxResults&&(this.b=!0,a=!0,l.cancel(),p=this.j(p,this.d.maxResults-this.c));const k=this.h(p);this.c+=k,(k>0||!g(p))&&this.a.add(p,m)}};Promise.all(o.map((p,m)=>this.k(p,S=>d(S,m),l.token))).then(p=>{l.dispose(),this.a.flush();const m=p.some(S=>!!S&&!!S.limitHit);n({limitHit:this.b||m,messages:(0,y.$Qb)(p.map(S=>S?.message?Array.isArray(S.message)?S.message:[S.message]:[])),stats:{type:this.g}})},p=>{l.dispose();const m=(0,M.$Gi)(p);s(new Error(m))})})}h(r){return g(r)?Array.isArray(r.ranges)?r.ranges.length:1:0}j(r,c){const o=Array.isArray(r.ranges)?r.ranges:[r.ranges],l=Array.isArray(r.preview.matches)?r.preview.matches:[r.preview.matches];return{ranges:o.slice(0,c),preview:{matches:l.slice(0,c),text:r.preview.text},uri:r.uri}}async k(r,c,o){const l=new C.$dJ(this.d,r),n=[],s={report:p=>{if(!this.l(p))return;const m=r.folder.scheme===A.Schemas.file?(0,C.$eJ)(()=>this.f.readdir(E.$yg(p.uri))):void 0,S=E.$Bg(r.folder,p.uri);if(S){const k=l.includedInQuery(S,$.$mc(S),m);(0,T.$Kg)(k)?n.push(k.then(h=>{h&&c(p)})):k&&c(p)}}},a=this.n(r),d=await this.e.provideTextSearchResults(u(this.d.contentPattern),a,s,o);return n.length&&await Promise.all(n),d}l(r){if(g(r)){if(Array.isArray(r.ranges)){if(!Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(r.preview.matches.length!==r.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(r){const c=(0,C.$cJ)(this.d.includePattern,r.includePattern),o=(0,C.$cJ)(this.d.excludePattern,r.excludePattern),l={folder:f.URI.from(r.folder),excludes:o,includes:c,useIgnoreFiles:!r.disregardIgnoreFiles,useGlobalIgnoreFiles:!r.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!r.disregardParentIgnoreFiles,followSymlinks:!r.ignoreSymlinks,encoding:r.fileEncoding&&this.f.toCanonicalName(r.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return l.usePCRE2=this.d.usePCRE2,l}}e.$dfc=D;function u(i){return{isCaseSensitive:i.isCaseSensitive||!1,isRegExp:i.isRegExp||!1,isWordMatch:i.isWordMatch||!1,isMultiline:i.isMultiline||!1,pattern:i.pattern}}class b{constructor(r){this.e=r,this.b=-1,this.d=null,this.a=new t(512,c=>this.g(c))}add(r,c){this.d&&(this.b!==c||!E.$sg(this.c,r.uri))&&(this.f(),this.d=null),this.d||(this.b=c,this.d={resource:r.uri,results:[]}),this.d.results.push(v(r))}f(){const r=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,r)}flush(){this.f(),this.a.flush()}g(r){this.e(r)}}e.$efc=b;function v(i){return g(i)?{preview:{matches:(0,y.$1b)(i.preview.matches,r=>({startLineNumber:r.start.line,startColumn:r.start.character,endLineNumber:r.end.line,endColumn:r.end.character})),text:i.preview.text},ranges:(0,y.$1b)(i.ranges,r=>({startLineNumber:r.start.line,startColumn:r.start.character,endLineNumber:r.end.line,endColumn:r.end.character}))}:{text:i.text,lineNumber:i.lineNumber}}function g(i){return!!i.preview}e.$ffc=g;class t{static{this.a=4e3}static{this.b=50}constructor(r,c){this.g=r,this.h=c,this.c=0,this.d=[],this.e=0}addItem(r,c){r&&this.j(r,c)}addItems(r,c){r&&this.k(r,c)}j(r,c){this.d.push(r),this.e+=c,this.l()}k(r,c){this.d=this.d.concat(r),this.e+=c,this.l()}l(){this.c<t.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},t.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$gfc=t}),define(Pe[118],Ae([1,0,6,3,4,284,17,57,15,2,289]),function(we,e,y,T,P,M,A,$,E,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jfc=e.$ifc=e.$hfc=void 0,e.$hfc=(0,P.$Vh)("IExtHostSearch");let D=class{constructor(g,t,i){this.k=g,this.l=t,this.n=i,this.c=this.k.getProxy(T.$yK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new M.$cfc}o(g){return this.l.transformOutgoingScheme(g)}registerTextSearchProvider(g,t){if(this.g.has(g))throw new Error(`a text search provider for the scheme '${g}' is already registered`);this.g.add(g);const i=this.d++;return this.e.set(i,t),this.c.$registerTextSearchProvider(i,this.o(g)),(0,y.$Pc)(()=>{this.g.delete(g),this.e.delete(i),this.c.$unregisterProvider(i)})}registerFileSearchProvider(g,t){if(this.i.has(g))throw new Error(`a file search provider for the scheme '${g}' is already registered`);this.i.add(g);const i=this.d++;return this.h.set(i,t),this.c.$registerFileSearchProvider(i,this.o(g)),(0,y.$Pc)(()=>{this.i.delete(g),this.h.delete(i),this.c.$unregisterProvider(i)})}$provideFileSearchResults(g,t,i,r){const c=u(i),o=this.h.get(g);if(o)return this.j.fileSearch(c,o,l=>{this.c.$handleFileMatch(g,t,l.map(n=>n.resource))},r);throw new Error("unknown provider: "+g)}async doInternalFileSearchWithCustomCallback(g,t,i){return{messages:[]}}$clearCache(g){return this.j.clearCache(g),Promise.resolve(void 0)}$provideTextSearchResults(g,t,i,r){const c=this.e.get(g);if(!c||!c.provideTextSearchResults)throw new Error(`Unknown provider ${g}`);const o=u(i);return this.q(o,c).search(n=>this.c.$handleTextMatch(g,t,n),r)}$enableExtensionHostSearch(){}q(g,t){return new C.$dfc(g,t,{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"textSearchProvider")}};e.$ifc=D,e.$ifc=D=Ke([Ve(0,A.$AM),Ve(1,$.$bec),Ve(2,E.$dj)],D);function u(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(b),extraFileResources:v.extraFileResources&&v.extraFileResources.map(g=>f.URI.revive(g))}}e.$jfc=u;function b(v){return{...v,folder:f.URI.revive(v.folder)}}}),define(Pe[290],Ae([1,0,19,11,5,6,13,31,2,146,142,129,92,22,41,15,99,55,56,198,3,231,239,81,232,233,234,235,236,237,238,213,32,240,36,272,117,110,242,243,244,220,245,61,62,247,37,248,63,249,42,27,250,251,252,253,254,255,82,83,257,283,222,202,223,258,259,112,260,224,261,262,17,263,118,84,264,265,266,85,86,115,59,64,267,268,210,269,225,87,8,7,270,57,271,65,273,274,111,35,208,79,23,114]),function(we,e,y,T,P,M,A,$,E,f,C,D,u,b,v,g,t,i,r,c,o,l,n,s,a,d,p,m,S,k,h,w,I,F,V,Z,N,R,L,O,Y,he,$e,De,ke,fe,ve,te,Re,se,Q,B,ne,pe,re,le,ce,ye,_,de,ie,ae,me,Ie,z,W,H,G,q,x,ue,Oe,Ue,Ze,Je,tt,_e,et,rt,nt,ze,dt,X,J,Ee,Be,He,Xe,st,vt,Dt,Ne,Kt,Ht,yt,jt,Nt,Gt,Bt,St,Lt,Vt,Ye,Wt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yfc=void 0;function qt(ct){const gt=ct.get(B.$QM),Ot=ct.get(Q.$Vdc),Pt=ct.get(Re.$jec),At=ct.get(ve.$Sec),ft=ct.get(St.$eec),kt=ct.get(X.$UM),Rt=ct.get(V.$hec),Ct=ct.get(Ht.$bec),We=ct.get(Ue.$AM),zt=ct.get(nt.$Cec),Jt=ct.get(ze.$kec),Ce=ct.get(g.$ej),Me=ct.get(g.$dj),be=ct.get(vt.$Ywb),K=ct.get(s.$Ydc),Le=ct.get(Bt.$Xfc),je=ct.get(tt.$Kec),Qe=ct.get(ke.$tec),qe=ct.get(de.$Oec);We.set(o.$zK.ExtHostFileSystemInfo,Ot),We.set(o.$zK.ExtHostLogLevelServiceShape,Ce),We.set(o.$zK.ExtHostWorkspace,ft),We.set(o.$zK.ExtHostConfiguration,Rt),We.set(o.$zK.ExtHostExtensionService,At),We.set(o.$zK.ExtHostStorage,zt),We.set(o.$zK.ExtHostTunnelService,be),We.set(o.$zK.ExtHostWindow,Le),We.set(o.$zK.ExtHostSecretState,je),We.set(o.$zK.ExtHostTelemetry,kt),We.set(o.$zK.ExtHostEditorTabs,Qe),We.set(o.$zK.ExtHostManagedSockets,qe);const it=We.set(o.$zK.ExtHostDecorations,ct.get(R.$4ec)),pt=We.set(o.$zK.ExtHostDocumentsAndEditors,ct.get(De.$LM)),$t=We.set(o.$zK.ExtHostCommands,ct.get(I.$WM)),bt=We.set(o.$zK.ExtHostTerminalService,ct.get(J.$Fec)),ut=We.set(o.$zK.ExtHostDebugService,ct.get(N.$Xec)),Mt=We.set(o.$zK.ExtHostSearch,ct.get(Je.$hfc)),Qt=We.set(o.$zK.ExtHostTask,ct.get(dt.$Kfc)),Xt=We.set(o.$zK.ExtHostOutputService,ct.get(G.$xfc)),si=We.set(o.$zK.ExtHostLocalization,ct.get(_.$Nec)),ki=We.set(o.$zK.ExtHostUrls,new yt.$Ufc(We)),It=We.set(o.$zK.ExtHostDocuments,new $e.$Tdc(We,pt)),Zi=We.set(o.$zK.ExtHostDocumentContentProviders,new Y.$6ec(We,pt,Me)),ln=We.set(o.$zK.ExtHostDocumentSaveParticipant,new he.$7ec(Me,It,We.getProxy(o.$yK.MainThreadBulkEdits))),Et=We.set(o.$zK.ExtHostNotebook,new ae.$kfc(We,$t,pt,It,Pt,Mt)),mi=We.set(o.$zK.ExtHostNotebookDocuments,new Ie.$rfc(Et)),$i=We.set(o.$zK.ExtHostNotebookEditors,new z.$sfc(Me,Et)),oi=We.set(o.$zK.ExtHostNotebookKernels,new W.$tfc(We,gt,Et,$t,Me)),Si=We.set(o.$zK.ExtHostNotebookRenderers,new H.$vfc(We,Et)),Ii=We.set(o.$zK.ExtHostNotebookDocumentSaveParticipant,new me.$qfc(Me,Et,We.getProxy(o.$yK.MainThreadBulkEdits))),Ft=We.set(o.$zK.ExtHostEditors,new Be.$$dc(We,pt)),pi=We.set(o.$zK.ExtHostTreeViews,new st.$Sfc(We.getProxy(o.$yK.MainThreadTreeViews),$t,Me)),Ci=We.set(o.$zK.ExtHostEditorInsets,new w.$_dc(We.getProxy(o.$yK.MainThreadEditorInsets),Ft,gt.remote)),ai=We.set(o.$zK.ExtHostDiagnostics,new L.$Xdc(We,Me,Ot,pt)),ci=We.set(o.$zK.ExtHostLanguages,new ye.$ofc(We,It,$t.converter,Ct)),lt=We.set(o.$zK.ExtHostLanguageFeatures,new ce.$2dc(We,Ct,It,$t,ai,Me,K,kt)),Pi=We.set(o.$zK.ExtHostFileSystem,new te.$9ec(We,lt)),xt=We.set(o.$zK.ExtHostFileSystemEventService,new se.$0ec(We,Me,pt)),ni=We.set(o.$zK.ExtHostQuickOpen,(0,Oe.$Bfc)(We,ft,$t)),hi=We.set(o.$zK.ExtHostSCM,new Ze.$Dfc(We,$t,It,Me)),Xi=We.set(o.$zK.ExtHostQuickDiff,new ue.$Afc(We,Ct)),Ai=We.set(o.$zK.ExtHostShare,new _e.$Efc(We,Ct)),Ri=We.set(o.$zK.ExtHostComments,(0,F.$aec)(We,$t,It)),Mi=We.set(o.$zK.ExtHostProgress,new x.$zfc(We.getProxy(o.$yK.MainThreadProgress))),xi=We.set(o.$zK.ExtHosLabelService,new le.$nfc(We)),Li=We.set(o.$zK.ExtHostTheming,new He.$Pfc(We)),ui=We.set(o.$zK.ExtHostAuthentication,new a.$4dc(We)),_i=We.set(o.$zK.ExtHostTimeline,new Xe.$Rfc(We,$t)),Fi=We.set(o.$zK.ExtHostWebviews,new jt.$oec(We,gt.remote,ft,Me,K)),Ti=We.set(o.$zK.ExtHostWebviewPanels,new Nt.$rec(We,Fi,ft)),Oi=We.set(o.$zK.ExtHostCustomEditors,new Z.$sec(We,It,Jt,Fi,Ti)),Ni=We.set(o.$zK.ExtHostWebviewViews,new Gt.$Vfc(We,Fi)),di=We.set(o.$zK.ExtHostTesting,new Ee.$Lfc(We,$t,pt)),hn=We.set(o.$zK.ExtHostUriOpeners,new Kt.$Tfc(We)),en=We.set(o.$zK.ExtHostProfileContentHandlers,new q.$yfc(We));We.set(o.$zK.ExtHostInteractive,new pe.$lfc(We,Et,pt,$t,Me));const zi=We.set(o.$zK.ExtHostInlineChat,new ne.$$ec(We,$t,It,Me)),vi=We.set(o.$zK.ExtHostChatProvider,new S.$7dc(We,Me)),tn=We.set(o.$zK.ExtHostChatAgents2,new m.$8dc(We,vi,Me)),nn=We.set(o.$zK.ExtHostChatVariables,new k.$9dc(We)),bi=We.set(o.$zK.ExtHostChat,new p.$6dc(We)),wi=We.set(o.$zK.ExtHostAiRelatedInformation,new l.$Sdc(We)),rn=We.set(o.$zK.ExtHostAiEmbeddingVector,new fe.$8ec(We)),_t=We.set(o.$zK.ExtHostIssueReporter,new re.$mfc(We)),fi=We.set(o.$zK.ExtHostStatusBar,new rt.$Hfc(We,$t.converter)),dn=We.set(o.$zK.ExtHostSpeech,new et.$Ffc(We)),Yt=Object.values(o.$zK);We.assertRegistered(Yt);const yi=new d.$5dc(We,pt),sn=new h.$0dc(We),Ei=new ie.$pfc(We,Me),Ui=new O.$5ec(We);return n.$3dc.register($t),function(Te,ti,ji){const mt=function(){let ee=!Te.isUnderDevelopment;function ge(){ee||(Me.info(`Extension '${Te.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ee=!0)}return function Fe(ot){if(Array.isArray(ot))ot.forEach(Fe);else if(typeof ot=="string")ge();else{const wt=ot;typeof wt.scheme>"u"&&ge(),typeof wt.exclusive=="boolean"&&(0,Ye.$MF)(Te,"documentFiltersExclusive")}return ot}}(),fn={getSession(ee,ge,Fe){return ui.getSession(Te,ee,ge,Fe)},getSessions(ee,ge){return(0,Ye.$MF)(Te,"authGetSessions"),ui.getSessions(Te,ee,ge)},async hasSession(ee,ge){return(0,Ye.$MF)(Te,"authSession"),!!await ui.getSession(Te,ee,ge,{silent:!0})},get onDidChangeSessions(){return ui.onDidChangeSessions},registerAuthenticationProvider(ee,ge,Fe,ot){return ui.registerAuthenticationProvider(ee,ge,Fe,ot)}},gn={registerCommand(ee,ge,Fe){return $t.registerCommand(!0,ee,ge,Fe,void 0,Te)},registerTextEditorCommand(ee,ge,Fe){return $t.registerCommand(!0,ee,(...ot)=>{const wt=Ft.getActiveTextEditor();if(!wt){Me.warn("Cannot execute "+ee+" because there is no active text editor.");return}return wt.edit(Tt=>{ge.apply(Fe,[wt,Tt,...ot])}).then(Tt=>{Tt||Me.warn("Edits from command "+ee+" were not applied.")},Tt=>{Me.warn("An error occurred while running command "+ee,Tt)})},void 0,void 0,Te)},registerDiffInformationCommand:(ee,ge,Fe)=>((0,Ye.$MF)(Te,"diffCommand"),$t.registerCommand(!0,ee,async(...ot)=>{const wt=pt.activeEditor(!0);if(!wt){Me.warn("Cannot execute "+ee+" because there is no active text editor.");return}const Tt=await Ft.getDiffInformation(wt.id);ge.apply(Fe,[Tt,...ot])},void 0,void 0,Te)),executeCommand(ee,...ge){return $t.executeCommand(ee,...ge)},getCommands(ee=!1){return $t.getCommands(ee)}},Di={get machineId(){return gt.telemetryInfo.machineId},get sessionId(){return gt.telemetryInfo.sessionId},get language(){return gt.environment.appLanguage},get appName(){return gt.environment.appName},get appRoot(){return gt.environment.appRoot?.fsPath??""},get appHost(){return gt.environment.appHost},get uriScheme(){return gt.environment.appUriScheme},get clipboard(){return sn.value},get shell(){return bt.getDefaultShell(!1)},get onDidChangeShell(){return bt.onDidChangeShell},get isTelemetryEnabled(){return kt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return kt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ye.$MF)(Te,"telemetry"),kt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ye.$MF)(Te,"telemetry"),kt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,X.$TM)(gt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ee,ge){return X.$SM.validateSender(ee),kt.instantiateLogger(Te,ee,ge)},openExternal(ee,ge){return Le.openUri(ee,{allowTunneling:!!gt.remote.authority,allowContributedOpeners:ge?.allowContributedOpeners})},async asExternalUri(ee){if(ee.scheme===gt.environment.appUriScheme)return ki.createAppUri(ee);try{return await Le.asExternalUri(ee,{allowTunneling:!!gt.remote.authority})}catch(ge){if((0,t.$RU)(ee,A.Schemas.http)||(0,t.$RU)(ee,A.Schemas.https))return ee;throw ge}},get remoteName(){return(0,i.$2k)(gt.remote.authority)},get remoteAuthority(){return(0,Ye.$MF)(Te,"resolvers"),gt.remote.authority},get uiKind(){return gt.uiKind},get logLevel(){return Me.getLevel()},get onDidChangeLogLevel(){return Me.onDidChangeLogLevel},registerIssueUriRequestHandler(ee){return(0,Ye.$MF)(Te,"handleIssueUri"),_t.registerIssueUriRequestHandler(Te,ee)},registerIssueDataProvider(ee){return(0,Ye.$MF)(Te,"handleIssueUri"),_t.registerIssueDataProvider(Te,ee)},get appQuality(){return(0,Ye.$MF)(Te,"resolvers"),gt.quality},get appCommit(){return(0,Ye.$MF)(Te,"resolvers"),gt.commit}};gt.environment.extensionTestsLocationURI||Object.freeze(Di);const on={createTestController(ee,ge,Fe){return di.createTestController(Te,ee,ge,Fe)},createTestObserver(){return(0,Ye.$MF)(Te,"testObserver"),di.createTestObserver()},runTests(ee){return(0,Ye.$MF)(Te,"testObserver"),di.runTests(ee)},get onDidChangeTestResults(){return(0,Ye.$MF)(Te,"testObserver"),di.onResultsChanged},get testResults(){return(0,Ye.$MF)(Te,"testObserver"),di.results}},gi=gt.remote.isRemote?Ne.ExtensionKind.Workspace:Ne.ExtensionKind.UI,an={getExtension(ee,ge){(0,Ye.$LF)(Te,"extensionsAny")||(ge=!1);const Fe=ti.mine.getExtensionDescription(ee);if(Fe)return new ve.$Tec(At,Te.identifier,Fe,gi,!1);if(ge){const ot=ti.all.getExtensionDescription(ee);if(ot)return new ve.$Tec(At,Te.identifier,ot,gi,!0)}},get all(){const ee=[];for(const ge of ti.mine.getAllExtensionDescriptions())ee.push(new ve.$Tec(At,Te.identifier,ge,gi,!1));return ee},get allAcrossExtensionHosts(){(0,Ye.$MF)(Te,"extensionsAny");const ee=new b.$am(ti.mine.getAllExtensionDescriptions().map(Fe=>Fe.identifier)),ge=[];for(const Fe of ti.all.getAllExtensionDescriptions()){const ot=!ee.has(Fe.identifier);ge.push(new ve.$Tec(At,Te.identifier,Fe,gi,ot))}return ge},get onDidChange(){return(0,Ye.$LF)(Te,"extensionsAny")?P.Event.any(ti.mine.onDidChange,ti.all.onDidChange):ti.mine.onDidChange}},mn={createDiagnosticCollection(ee){return ai.createDiagnosticCollection(Te.identifier,ee)},get onDidChangeDiagnostics(){return ai.onDidChangeDiagnostics},getDiagnostics:ee=>ai.getDiagnostics(ee),getLanguages(){return ci.getLanguages()},setTextDocumentLanguage(ee,ge){return ci.changeLanguage(ee.uri,ge)},match(ee,ge){const Fe=It.getDocumentData(ge.uri)?.notebook;return(0,C.$LE)(Dt.LanguageSelector.from(ee),ge.uri,ge.languageId,!0,Fe?.uri,Fe?.notebookType)},registerCodeActionsProvider(ee,ge,Fe){return lt.registerCodeActionProvider(Te,mt(ee),ge,Fe)},registerDocumentPasteEditProvider(ee,ge,Fe){return(0,Ye.$MF)(Te,"documentPaste"),lt.registerDocumentPasteEditProvider(Te,mt(ee),ge,Fe)},registerCodeLensProvider(ee,ge){return lt.registerCodeLensProvider(Te,mt(ee),ge)},registerDefinitionProvider(ee,ge){return lt.registerDefinitionProvider(Te,mt(ee),ge)},registerDeclarationProvider(ee,ge){return lt.registerDeclarationProvider(Te,mt(ee),ge)},registerImplementationProvider(ee,ge){return lt.registerImplementationProvider(Te,mt(ee),ge)},registerTypeDefinitionProvider(ee,ge){return lt.registerTypeDefinitionProvider(Te,mt(ee),ge)},registerHoverProvider(ee,ge){return lt.registerHoverProvider(Te,mt(ee),ge,Te.identifier)},registerEvaluatableExpressionProvider(ee,ge){return lt.registerEvaluatableExpressionProvider(Te,mt(ee),ge,Te.identifier)},registerInlineValuesProvider(ee,ge){return lt.registerInlineValuesProvider(Te,mt(ee),ge,Te.identifier)},registerDocumentHighlightProvider(ee,ge){return lt.registerDocumentHighlightProvider(Te,mt(ee),ge)},registerLinkedEditingRangeProvider(ee,ge){return lt.registerLinkedEditingRangeProvider(Te,mt(ee),ge)},registerReferenceProvider(ee,ge){return lt.registerReferenceProvider(Te,mt(ee),ge)},registerRenameProvider(ee,ge){return lt.registerRenameProvider(Te,mt(ee),ge)},registerDocumentSymbolProvider(ee,ge,Fe){return lt.registerDocumentSymbolProvider(Te,mt(ee),ge,Fe)},registerWorkspaceSymbolProvider(ee){return lt.registerWorkspaceSymbolProvider(Te,ee)},registerDocumentFormattingEditProvider(ee,ge){return lt.registerDocumentFormattingEditProvider(Te,mt(ee),ge)},registerDocumentRangeFormattingEditProvider(ee,ge){return lt.registerDocumentRangeFormattingEditProvider(Te,mt(ee),ge)},registerOnTypeFormattingEditProvider(ee,ge,Fe,...ot){return lt.registerOnTypeFormattingEditProvider(Te,mt(ee),ge,[Fe].concat(ot))},registerDocumentSemanticTokensProvider(ee,ge,Fe){return lt.registerDocumentSemanticTokensProvider(Te,mt(ee),ge,Fe)},registerDocumentRangeSemanticTokensProvider(ee,ge,Fe){return lt.registerDocumentRangeSemanticTokensProvider(Te,mt(ee),ge,Fe)},registerSignatureHelpProvider(ee,ge,Fe,...ot){return typeof Fe=="object"?lt.registerSignatureHelpProvider(Te,mt(ee),ge,Fe):lt.registerSignatureHelpProvider(Te,mt(ee),ge,typeof Fe>"u"?[]:[Fe,...ot])},registerCompletionItemProvider(ee,ge,...Fe){return lt.registerCompletionItemProvider(Te,mt(ee),ge,Fe)},registerInlineCompletionItemProvider(ee,ge,Fe){return ge.handleDidShowCompletionItem&&(0,Ye.$MF)(Te,"inlineCompletionsAdditions"),ge.handleDidPartiallyAcceptCompletionItem&&(0,Ye.$MF)(Te,"inlineCompletionsAdditions"),Fe&&(0,Ye.$MF)(Te,"inlineCompletionsAdditions"),lt.registerInlineCompletionsProvider(Te,mt(ee),ge,Fe)},registerDocumentLinkProvider(ee,ge){return lt.registerDocumentLinkProvider(Te,mt(ee),ge)},registerColorProvider(ee,ge){return lt.registerColorProvider(Te,mt(ee),ge)},registerFoldingRangeProvider(ee,ge){return lt.registerFoldingRangeProvider(Te,mt(ee),ge)},registerSelectionRangeProvider(ee,ge){return lt.registerSelectionRangeProvider(Te,ee,ge)},registerCallHierarchyProvider(ee,ge){return lt.registerCallHierarchyProvider(Te,ee,ge)},registerTypeHierarchyProvider(ee,ge){return lt.registerTypeHierarchyProvider(Te,ee,ge)},setLanguageConfiguration:(ee,ge)=>lt.setLanguageConfiguration(Te,ee,ge),getTokenInformationAtPosition(ee,ge){return(0,Ye.$MF)(Te,"tokenInformation"),ci.tokenAtPosition(ee,ge)},registerInlayHintsProvider(ee,ge){return lt.registerInlayHintsProvider(Te,ee,ge)},createLanguageStatusItem(ee,ge){return ci.createLanguageStatusItem(Te,ee,ge)},registerDocumentDropEditProvider(ee,ge,Fe){return lt.registerDocumentOnDropEditProvider(Te,ee,ge,(0,Ye.$LF)(Te,"dropMetadata")?Fe:void 0)}},$n={get activeTextEditor(){return Ft.getActiveTextEditor()},get visibleTextEditors(){return Ft.getVisibleTextEditors()},get activeTerminal(){return bt.activeTerminal},get terminals(){return bt.terminals},async showTextDocument(ee,ge,Fe){const ot=await(E.URI.isUri(ee)?Promise.resolve(Bi.openTextDocument(ee)):Promise.resolve(ee));return Ft.showTextDocument(ot,ge,Fe)},createTextEditorDecorationType(ee){return Ft.createTextEditorDecorationType(Te,ee)},onDidChangeActiveTextEditor(ee,ge,Fe){return Ft.onDidChangeActiveTextEditor(ee,ge,Fe)},onDidChangeVisibleTextEditors(ee,ge,Fe){return Ft.onDidChangeVisibleTextEditors(ee,ge,Fe)},onDidChangeTextEditorSelection(ee,ge,Fe){return Ft.onDidChangeTextEditorSelection(ee,ge,Fe)},onDidChangeTextEditorOptions(ee,ge,Fe){return Ft.onDidChangeTextEditorOptions(ee,ge,Fe)},onDidChangeTextEditorVisibleRanges(ee,ge,Fe){return Ft.onDidChangeTextEditorVisibleRanges(ee,ge,Fe)},onDidChangeTextEditorViewColumn(ee,ge,Fe){return Ft.onDidChangeTextEditorViewColumn(ee,ge,Fe)},onDidCloseTerminal(ee,ge,Fe){return bt.onDidCloseTerminal(ee,ge,Fe)},onDidOpenTerminal(ee,ge,Fe){return bt.onDidOpenTerminal(ee,ge,Fe)},onDidChangeActiveTerminal(ee,ge,Fe){return bt.onDidChangeActiveTerminal(ee,ge,Fe)},onDidChangeTerminalDimensions(ee,ge,Fe){return(0,Ye.$MF)(Te,"terminalDimensions"),bt.onDidChangeTerminalDimensions(ee,ge,Fe)},onDidChangeTerminalState(ee,ge,Fe){return bt.onDidChangeTerminalState(ee,ge,Fe)},onDidWriteTerminalData(ee,ge,Fe){return(0,Ye.$MF)(Te,"terminalDataWriteEvent"),bt.onDidWriteTerminalData(ee,ge,Fe)},onDidExecuteTerminalCommand(ee,ge,Fe){return(0,Ye.$MF)(Te,"terminalExecuteCommandEvent"),bt.onDidExecuteTerminalCommand(ee,ge,Fe)},get state(){return Le.getState(Te)},onDidChangeWindowState(ee,ge,Fe){return Le.onDidChangeWindowState(ee,ge,Fe)},showInformationMessage(ee,...ge){return Ei.showMessage(Te,$.default.Info,ee,ge[0],ge.slice(1))},showWarningMessage(ee,...ge){return Ei.showMessage(Te,$.default.Warning,ee,ge[0],ge.slice(1))},showErrorMessage(ee,...ge){return Ei.showMessage(Te,$.default.Error,ee,ge[0],ge.slice(1))},showQuickPick(ee,ge,Fe){return ni.showQuickPick(Te,ee,ge,Fe)},showWorkspaceFolderPick(ee){return ni.showWorkspaceFolderPick(ee)},showInputBox(ee,ge){return ni.showInput(ee,ge)},showOpenDialog(ee){return Ui.showOpenDialog(Te,ee)},showSaveDialog(ee){return Ui.showSaveDialog(ee)},createStatusBarItem(ee,ge,Fe){let ot,wt,Tt;return typeof ee=="string"?(ot=ee,wt=ge,Tt=Fe):(wt=ee,Tt=ge),fi.createStatusBarEntry(Te,ot,wt,Tt)},setStatusBarMessage(ee,ge){return fi.setStatusBarMessage(ee,ge)},withScmProgress(ee){return K.report("window.withScmProgress",Te,"Use 'withProgress' instead."),Mi.withProgress(Te,{location:Ne.ProgressLocation.SourceControl},(ge,Fe)=>ee({report(ot){}}))},withProgress(ee,ge){return Mi.withProgress(Te,ee,ge)},createOutputChannel(ee,ge){return Xt.createOutputChannel(ee,ge,Te)},createWebviewPanel(ee,ge,Fe,ot){return Ti.createWebviewPanel(Te,ee,ge,Fe,ot)},createWebviewTextEditorInset(ee,ge,Fe,ot){return(0,Ye.$MF)(Te,"editorInsets"),Ci.createWebviewEditorInset(ee,ge,Fe,ot,Te)},createTerminal(ee,ge,Fe){return typeof ee=="object"?"pty"in ee?bt.createExtensionTerminal(ee):bt.createTerminalFromOptions(ee):bt.createTerminal(ee,ge,Fe)},registerTerminalLinkProvider(ee){return bt.registerLinkProvider(ee)},registerTerminalProfileProvider(ee,ge){return bt.registerProfileProvider(Te,ee,ge)},registerTerminalQuickFixProvider(ee,ge){return(0,Ye.$MF)(Te,"terminalQuickFixProvider"),bt.registerTerminalQuickFixProvider(ee,Te.identifier.value,ge)},registerTreeDataProvider(ee,ge){return pi.registerTreeDataProvider(ee,ge,Te)},createTreeView(ee,ge){return pi.createTreeView(ee,ge,Te)},registerWebviewPanelSerializer:(ee,ge)=>Ti.registerWebviewPanelSerializer(Te,ee,ge),registerCustomEditorProvider:(ee,ge,Fe={})=>Oi.registerCustomEditorProvider(Te,ee,ge,Fe),registerFileDecorationProvider(ee){return it.registerFileDecorationProvider(ee,Te)},registerUriHandler(ee){return ki.registerUriHandler(Te,ee)},createQuickPick(){return ni.createQuickPick(Te)},createInputBox(){return ni.createInputBox(Te)},get activeColorTheme(){return Li.activeColorTheme},onDidChangeActiveColorTheme(ee,ge,Fe){return Li.onDidChangeActiveColorTheme(ee,ge,Fe)},registerWebviewViewProvider(ee,ge,Fe){return Ni.registerWebviewViewProvider(Te,ee,ge,Fe?.webviewOptions)},get activeNotebookEditor(){return Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(ee,ge,Fe){return Et.onDidChangeActiveNotebookEditor(ee,ge,Fe)},get visibleNotebookEditors(){return Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ee,ge,Fe){return $i.onDidChangeNotebookEditorSelection(ee,ge,Fe)},onDidChangeNotebookEditorVisibleRanges(ee,ge,Fe){return $i.onDidChangeNotebookEditorVisibleRanges(ee,ge,Fe)},showNotebookDocument(ee,ge){return Et.showNotebookDocument(ee,ge)},registerExternalUriOpener(ee,ge,Fe){return(0,Ye.$MF)(Te,"externalUriOpener"),hn.registerExternalUriOpener(Te.identifier,ee,ge,Fe)},registerProfileContentHandler(ee,ge){return(0,Ye.$MF)(Te,"profileContentHandlers"),en.registrProfileContentHandler(Te,ee,ge)},registerQuickDiffProvider(ee,ge,Fe,ot){return(0,Ye.$MF)(Te,"quickDiffProvider"),Xi.registerQuickDiffProvider(mt(ee),ge,Fe,ot)},get tabGroups(){return Qe.tabGroups},registerShareProvider(ee,ge){return(0,Ye.$MF)(Te,"shareProvider"),Ai.registerShareProvider(mt(ee),ge)}},Bi={get rootPath(){return K.report("workspace.rootPath",Te,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(ee){throw new T.$8("rootPath")},getWorkspaceFolder(ee){return ft.getWorkspaceFolder(ee)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(ee){throw new T.$8("name")},get workspaceFile(){return ft.workspaceFile},set workspaceFile(ee){throw new T.$8("workspaceFile")},updateWorkspaceFolders:(ee,ge,...Fe)=>ft.updateWorkspaceFolders(Te,ee,ge||0,...Fe),onDidChangeWorkspaceFolders:function(ee,ge,Fe){return ft.onDidChangeWorkspace(ee,ge,Fe)},asRelativePath:(ee,ge)=>ft.getRelativePath(ee,ge),findFiles:(ee,ge,Fe,ot)=>ft.findFiles(ee,ge,Fe,Te.identifier,ot),findTextInFiles:(ee,ge,Fe,ot)=>{(0,Ye.$MF)(Te,"findTextInFiles");let wt,Tt;return typeof ge=="object"?(wt=ge,Tt=Fe):(wt={},Tt=ge,ot=Fe),ft.findTextInFiles(ee,wt||{},Tt,Te.identifier,ot)},save:ee=>((0,Ye.$MF)(Te,"saveEditor"),ft.save(ee)),saveAs:ee=>((0,Ye.$MF)(Te,"saveEditor"),ft.saveAs(ee)),saveAll:ee=>ft.saveAll(ee),applyEdit(ee,ge){return yi.applyWorkspaceEdit(ee,Te,ge)},createFileSystemWatcher:(ee,ge,Fe,ot)=>{let wt;return typeof ge=="boolean"?wt={ignoreCreateEvents:!!ge,ignoreChangeEvents:!!Fe,ignoreDeleteEvents:!!ot,correlate:!1}:ge&&((0,Ye.$MF)(Te,"createFileSystemWatcher"),wt={...ge,correlate:!0}),xt.createFileSystemWatcher(ft,Te,ee,wt)},get textDocuments(){return It.getAllDocumentData().map(ee=>ee.document)},set textDocuments(ee){throw new T.$8("textDocuments")},openTextDocument(ee){let ge;const Fe=ee;if(typeof ee=="string")ge=Promise.resolve(E.URI.file(ee));else if(E.URI.isUri(ee))ge=Promise.resolve(ee);else if(!Fe||typeof Fe=="object")ge=It.createDocumentData(Fe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ge.then(ot=>It.ensureDocumentData(ot).then(wt=>wt.document))},onDidOpenTextDocument:(ee,ge,Fe)=>It.onDidAddDocument(ee,ge,Fe),onDidCloseTextDocument:(ee,ge,Fe)=>It.onDidRemoveDocument(ee,ge,Fe),onDidChangeTextDocument:(ee,ge,Fe)=>It.onDidChangeDocument(ee,ge,Fe),onDidSaveTextDocument:(ee,ge,Fe)=>It.onDidSaveDocument(ee,ge,Fe),onWillSaveTextDocument:(ee,ge,Fe)=>ln.getOnWillSaveTextDocumentEvent(Te)(ee,ge,Fe),get notebookDocuments(){return Et.notebookDocuments.map(ee=>ee.apiNotebook)},async openNotebookDocument(ee,ge){let Fe;if(E.URI.isUri(ee))Fe=ee,await Et.openNotebookDocument(ee);else if(typeof ee=="string")Fe=E.URI.revive(await Et.createNotebookDocument({viewType:ee,content:ge}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(Fe).apiNotebook},onDidSaveNotebookDocument(ee,ge,Fe){return mi.onDidSaveNotebookDocument(ee,ge,Fe)},onDidChangeNotebookDocument(ee,ge,Fe){return mi.onDidChangeNotebookDocument(ee,ge,Fe)},onWillSaveNotebookDocument(ee,ge,Fe){return Ii.getOnWillSaveNotebookDocumentEvent(Te)(ee,ge,Fe)},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(ee,ge,Fe,ot){return Et.registerNotebookSerializer(Te,ee,ge,Fe,(0,Ye.$LF)(Te,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:(ee,ge,Fe)=>ji.onDidChangeConfiguration(ee,ge,Fe),getConfiguration(ee,ge){return ge=arguments.length===1?void 0:ge,ji.getConfiguration(ee,ge,Te)},registerTextDocumentContentProvider(ee,ge){return Zi.registerTextDocumentContentProvider(ee,ge)},registerTaskProvider:(ee,ge)=>(K.report("window.registerTaskProvider",Te,"Use the corresponding function on the 'tasks' namespace instead"),Qt.registerTaskProvider(Te,ee,ge)),registerFileSystemProvider(ee,ge,Fe){return(0,M.$Oc)(Pi.registerFileSystemProvider(Te,ee,ge,Fe),Pt.addFileSystemProvider(ee,ge,Fe))},get fs(){return Pt.value},registerFileSearchProvider:(ee,ge)=>((0,Ye.$MF)(Te,"fileSearchProvider"),Mt.registerFileSearchProvider(ee,ge)),registerTextSearchProvider:(ee,ge)=>((0,Ye.$MF)(Te,"textSearchProvider"),Mt.registerTextSearchProvider(ee,ge)),registerRemoteAuthorityResolver:(ee,ge)=>((0,Ye.$MF)(Te,"resolvers"),At.registerRemoteAuthorityResolver(ee,ge)),registerResourceLabelFormatter:ee=>((0,Ye.$MF)(Te,"resolvers"),xi.$registerResourceLabelFormatter(ee)),getRemoteExecServer:ee=>((0,Ye.$MF)(Te,"resolvers"),At.getRemoteExecServer(ee)),onDidCreateFiles:(ee,ge,Fe)=>xt.onDidCreateFile(ee,ge,Fe),onDidDeleteFiles:(ee,ge,Fe)=>xt.onDidDeleteFile(ee,ge,Fe),onDidRenameFiles:(ee,ge,Fe)=>xt.onDidRenameFile(ee,ge,Fe),onWillCreateFiles:(ee,ge,Fe)=>xt.getOnWillCreateFileEvent(Te)(ee,ge,Fe),onWillDeleteFiles:(ee,ge,Fe)=>xt.getOnWillDeleteFileEvent(Te)(ee,ge,Fe),onWillRenameFiles:(ee,ge,Fe)=>xt.getOnWillRenameFileEvent(Te)(ee,ge,Fe),openTunnel:ee=>((0,Ye.$MF)(Te,"tunnels"),be.openTunnel(Te,ee).then(ge=>{if(!ge)throw new Error("cannot open tunnel");return ge})),get tunnels(){return(0,Ye.$MF)(Te,"tunnels"),be.getTunnels()},onDidChangeTunnels:(ee,ge,Fe)=>((0,Ye.$MF)(Te,"tunnels"),be.onDidChangeTunnels(ee,ge,Fe)),registerPortAttributesProvider:(ee,ge)=>((0,Ye.$MF)(Te,"portsAttributes"),be.registerPortsAttributesProvider(ee,ge)),registerTunnelProvider:(ee,ge)=>((0,Ye.$MF)(Te,"tunnelFactory"),be.registerTunnelProvider(ee,ge)),registerTimelineProvider:(ee,ge)=>((0,Ye.$MF)(Te,"timeline"),_i.registerTimelineProvider(ee,ge,Te.identifier,$t.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:ee=>((0,Ye.$MF)(Te,"workspaceTrust"),ft.requestWorkspaceTrust(ee)),onDidGrantWorkspaceTrust:(ee,ge,Fe)=>ft.onDidGrantWorkspaceTrust(ee,ge,Fe),registerEditSessionIdentityProvider:(ee,ge)=>((0,Ye.$MF)(Te,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(ee,ge)),onWillCreateEditSessionIdentity:(ee,ge,Fe)=>((0,Ye.$MF)(Te,"editSessionIdentityProvider"),ft.getOnWillCreateEditSessionIdentityEvent(Te)(ee,ge,Fe)),registerCanonicalUriProvider:(ee,ge)=>((0,Ye.$MF)(Te,"canonicalUriProvider"),ft.registerCanonicalUriProvider(ee,ge)),getCanonicalUri:(ee,ge,Fe)=>((0,Ye.$MF)(Te,"canonicalUriProvider"),ft.provideCanonicalUri(ee,ge,Fe))},cn={get inputBox(){return K.report("scm.inputBox",Te,"Use 'SourceControl.inputBox' instead"),hi.getLastInputBox(Te)},createSourceControl(ee,ge,Fe){return hi.createSourceControl(Te,ee,ge,Fe)},registerSourceControlInputBoxValueProvider(ee){return(0,Ye.$MF)(Te,"scmInputBoxValueProvider"),hi.registerSourceControlInputBoxValueProvider(Te,ee)}},Vi={createCommentController(ee,ge){return Ri.createCommentController(Te,ee,ge)}},Wi={get activeDebugSession(){return ut.activeDebugSession},get activeDebugConsole(){return ut.activeDebugConsole},get breakpoints(){return ut.breakpoints},get stackFrameFocus(){return ut.stackFrameFocus},onDidStartDebugSession(ee,ge,Fe){return ut.onDidStartDebugSession(ee,ge,Fe)},onDidTerminateDebugSession(ee,ge,Fe){return ut.onDidTerminateDebugSession(ee,ge,Fe)},onDidChangeActiveDebugSession(ee,ge,Fe){return ut.onDidChangeActiveDebugSession(ee,ge,Fe)},onDidReceiveDebugSessionCustomEvent(ee,ge,Fe){return ut.onDidReceiveDebugSessionCustomEvent(ee,ge,Fe)},onDidChangeBreakpoints(ee,ge,Fe){return ut.onDidChangeBreakpoints(ee,ge,Fe)},onDidChangeStackFrameFocus(ee,ge,Fe){return(0,Ye.$MF)(Te,"debugFocus"),ut.onDidChangeStackFrameFocus(ee,ge,Fe)},registerDebugConfigurationProvider(ee,ge,Fe){return ut.registerDebugConfigurationProvider(ee,ge,Fe||Lt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ee,ge){return ut.registerDebugAdapterDescriptorFactory(Te,ee,ge)},registerDebugAdapterTrackerFactory(ee,ge){return ut.registerDebugAdapterTrackerFactory(ee,ge)},startDebugging(ee,ge,Fe){return!Fe||typeof Fe=="object"&&"configuration"in Fe?ut.startDebugging(ee,ge,{parentSession:Fe}):ut.startDebugging(ee,ge,Fe||{})},stopDebugging(ee){return ut.stopDebugging(ee)},addBreakpoints(ee){return ut.addBreakpoints(ee)},removeBreakpoints(ee){return ut.removeBreakpoints(ee)},asDebugSourceUri(ee,ge){return ut.asDebugSourceUri(ee,ge)}},qi={registerTaskProvider:(ee,ge)=>Qt.registerTaskProvider(Te,ee,ge),fetchTasks:ee=>Qt.fetchTasks(ee),executeTask:ee=>Qt.executeTask(Te,ee),get taskExecutions(){return Qt.taskExecutions},onDidStartTask:(ee,ge,Fe)=>Qt.onDidStartTask(ee,ge,Fe),onDidEndTask:(ee,ge,Fe)=>Qt.onDidEndTask(ee,ge,Fe),onDidStartTaskProcess:(ee,ge,Fe)=>Qt.onDidStartTaskProcess(ee,ge,Fe),onDidEndTaskProcess:(ee,ge,Fe)=>Qt.onDidEndTaskProcess(ee,ge,Fe)},li={createNotebookController(ee,ge,Fe,ot,wt){return oi.createNotebookController(Te,ee,ge,Fe,ot,(0,Ye.$LF)(Te,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(ee,ge)=>Et.registerNotebookCellStatusBarItemProvider(Te,ee,ge),createRendererMessaging(ee){return Si.createRendererMessaging(Te,ee)},createNotebookControllerDetectionTask(ee){return(0,Ye.$MF)(Te,"notebookKernelSource"),oi.createNotebookControllerDetectionTask(Te,ee)},registerKernelSourceActionProvider(ee,ge){return(0,Ye.$MF)(Te,"notebookKernelSource"),oi.registerKernelSourceActionProvider(Te,ee,ge)},onDidChangeNotebookCellExecutionState(ee,ge,Fe){return(0,Ye.$MF)(Te,"notebookCellExecutionState"),oi.onDidChangeNotebookCellExecutionState(ee,ge,Fe)}},Ki={t(...ee){if(typeof ee[0]=="string"){const ge=ee.shift(),Fe=!ee||typeof ee[0]!="object"?ee:ee[0];return si.getMessage(Te.identifier.value,{message:ge,args:Fe})}return si.getMessage(Te.identifier.value,ee[0])},get bundle(){return si.getBundle(Te.identifier.value)},get uri(){return si.getBundleUri(Te.identifier.value)}},Hi={_version:1,registerInteractiveEditorSessionProvider(ee,ge){return(0,Ye.$MF)(Te,"interactive"),zi.registerProvider(Te,ee,ge)},registerInteractiveSessionProvider(ee,ge){return(0,Ye.$MF)(Te,"interactive"),bi.registerChatProvider(Te,ee,ge)},sendInteractiveRequestToProvider(ee,ge){return(0,Ye.$MF)(Te,"interactive"),bi.sendInteractiveRequestToProvider(ee,ge)},get onDidPerformUserAction(){return(0,Ye.$MF)(Te,"interactiveUserActions"),bi.onDidPerformUserAction},transferChatSession(ee,ge){return(0,Ye.$MF)(Te,"interactive"),bi.transferChatSession(ee,ge)}},Gi={getRelatedInformation(ee,ge){return(0,Ye.$MF)(Te,"aiRelatedInformation"),wi.getRelatedInformation(Te,ee,ge)},registerRelatedInformationProvider(ee,ge){return(0,Ye.$MF)(Te,"aiRelatedInformation"),wi.registerRelatedInformationProvider(Te,ee,ge)},registerEmbeddingVectorProvider(ee,ge){return(0,Ye.$MF)(Te,"aiRelatedInformation"),rn.registerEmbeddingVectorProvider(Te,ee,ge)}},Ji={registerChatResponseProvider(ee,ge,Fe){return(0,Ye.$MF)(Te,"chatProvider"),vi.registerProvider(Te.identifier,ee,ge,Fe)},requestChatAccess(ee){return(0,Ye.$MF)(Te,"chatRequestAccess"),vi.requestChatResponseProvider(Te.identifier,ee)},registerVariable(ee,ge,Fe){return(0,Ye.$MF)(Te,"chatVariables"),nn.registerVariableResolver(Te,ee,ge,Fe)},registerMappedEditsProvider(ee,ge){return(0,Ye.$MF)(Te,"mappedEditsProvider"),lt.registerMappedEditsProvider(Te,ee,ge)},createChatAgent(ee,ge){return(0,Ye.$MF)(Te,"chatAgents2"),tn.createChatAgent(Te,ee,ge)}},un={registerSpeechProvider(ee,ge){return(0,Ye.$MF)(Te,"speech"),dn.registerProvider(Te.identifier,ee,ge)}};return{version:gt.version,ai:Gi,authentication:fn,commands:gn,comments:Vi,chat:Ji,debug:Wi,env:Di,extensions:an,interactive:Hi,l10n:Ki,languages:mn,notebooks:li,scm:cn,speech:un,tasks:qi,tests:on,window:$n,workspace:Bi,Breakpoint:Ne.$yL,TerminalOutputAnchor:Ne.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Ne.ChatAgentResultFeedbackKind,ChatMessage:Ne.$pM,ChatMessageRole:Ne.ChatMessageRole,ChatVariableLevel:Ne.ChatVariableLevel,CallHierarchyIncomingCall:Ne.$XK,CallHierarchyItem:Ne.$WK,CallHierarchyOutgoingCall:Ne.$YK,CancellationError:T.$4,CancellationTokenSource:y.$2d,CandidatePortSource:o.CandidatePortSource,CodeAction:Ne.$TK,CodeActionKind:Ne.$UK,CodeActionTriggerKind:Ne.CodeActionTriggerKind,CodeLens:Ne.$ZK,Color:Ne.$aL,ColorInformation:Ne.$bL,ColorPresentation:Ne.$cL,ColorThemeKind:Ne.ColorThemeKind,CommentMode:Ne.CommentMode,CommentState:Ne.CommentState,CommentThreadCollapsibleState:Ne.CommentThreadCollapsibleState,CommentThreadState:Ne.CommentThreadState,CompletionItem:Ne.$7K,CompletionItemKind:Ne.CompletionItemKind,CompletionItemTag:Ne.CompletionItemTag,CompletionList:Ne.$8K,CompletionTriggerKind:Ne.CompletionTriggerKind,ConfigurationTarget:Ne.ConfigurationTarget,CustomExecution:Ne.$kL,DebugAdapterExecutable:Ne.$CL,DebugAdapterInlineImplementation:Ne.$FL,DebugAdapterNamedPipeServer:Ne.$EL,DebugAdapterServer:Ne.$DL,DebugConfigurationProviderTriggerKind:Lt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Ne.DebugConsoleMode,DecorationRangeBehavior:Ne.DecorationRangeBehavior,Diagnostic:Ne.$OK,DiagnosticRelatedInformation:Ne.$NK,DiagnosticSeverity:Ne.DiagnosticSeverity,DiagnosticTag:Ne.DiagnosticTag,Disposable:Ne.$AK,DocumentHighlight:Ne.$QK,DocumentHighlightKind:Ne.DocumentHighlightKind,DocumentLink:Ne.$_K,DocumentSymbol:Ne.$SK,EndOfLine:Ne.EndOfLine,EnvironmentVariableMutatorType:Ne.EnvironmentVariableMutatorType,EvaluatableExpression:Ne.$IL,InlineValueText:Ne.$JL,InlineValueVariableLookup:Ne.$KL,InlineValueEvaluatableExpression:Ne.$LL,InlineCompletionTriggerKind:Ne.InlineCompletionTriggerKind,EventEmitter:P.$Rd,ExtensionKind:Ne.ExtensionKind,ExtensionMode:Ne.ExtensionMode,ExternalUriOpenerPriority:Ne.ExternalUriOpenerPriority,FileChangeType:Ne.FileChangeType,FileDecoration:Ne.$VL,FileDecoration2:Ne.$VL,FileSystemError:Ne.$NL,FileType:v.FileType,FilePermission:v.FilePermission,FoldingRange:Ne.$OL,FoldingRangeKind:Ne.FoldingRangeKind,FunctionBreakpoint:Ne.$AL,InlineCompletionItem:Ne.$9K,InlineCompletionList:Ne.$0K,Hover:Ne.$PK,IndentAction:D.IndentAction,Location:Ne.$MK,MarkdownString:Ne.$1K,OverviewRulerLane:u.OverviewRulerLane,ParameterInformation:Ne.$2K,PortAutoForwardAction:Ne.PortAutoForwardAction,Position:Ne.$BK,ProcessExecution:Ne.$iL,ProgressLocation:Ne.ProgressLocation,QuickInputButtons:Ne.$UL,Range:Ne.$CK,RelativePattern:Ne.$wL,Selection:Ne.$DK,SelectionRange:Ne.$VK,SemanticTokens:Ne.$RL,SemanticTokensBuilder:Ne.$QL,SemanticTokensEdit:Ne.$SL,SemanticTokensEdits:Ne.$TL,SemanticTokensLegend:Ne.$PL,ShellExecution:Ne.$jL,ShellQuoting:Ne.ShellQuoting,SignatureHelp:Ne.$4K,SignatureHelpTriggerKind:Ne.SignatureHelpTriggerKind,SignatureInformation:Ne.$3K,SnippetString:Ne.$LK,SourceBreakpoint:Ne.$zL,StandardTokenType:Ne.StandardTokenType,StatusBarAlignment:Ne.StatusBarAlignment,SymbolInformation:Ne.$RK,SymbolKind:Ne.SymbolKind,SymbolTag:Ne.SymbolTag,Task:Ne.$lL,TaskGroup:Ne.$hL,TaskPanelKind:Ne.TaskPanelKind,TaskRevealKind:Ne.TaskRevealKind,TaskScope:Ne.TaskScope,TerminalLink:Ne.$dL,TerminalQuickFixExecuteTerminalCommand:Ne.$fL,TerminalQuickFixOpener:Ne.$eL,TerminalLocation:Ne.TerminalLocation,TerminalProfile:Ne.$gL,TerminalExitReason:Ne.TerminalExitReason,TextDocumentSaveReason:Ne.TextDocumentSaveReason,TextEdit:Ne.$HK,SnippetTextEdit:Ne.$JK,TextEditorCursorStyle:f.TextEditorCursorStyle,TextEditorLineNumbersStyle:Ne.TextEditorLineNumbersStyle,TextEditorRevealType:Ne.TextEditorRevealType,TextEditorSelectionChangeKind:Ne.TextEditorSelectionChangeKind,SyntaxTokenType:Ne.SyntaxTokenType,TextDocumentChangeReason:Ne.TextDocumentChangeReason,ThemeColor:Ne.$vL,ThemeIcon:Ne.$uL,TreeItem:Ne.$mL,TreeItemCheckboxState:Ne.TreeItemCheckboxState,TreeItemCollapsibleState:Ne.TreeItemCollapsibleState,TypeHierarchyItem:Ne.$eM,UIKind:Vt.UIKind,Uri:E.URI,ViewColumn:Ne.ViewColumn,WorkspaceEdit:Ne.$KK,DocumentDropEdit:Ne.$sL,DocumentPasteEdit:Ne.$tL,InlayHint:Ne.$6K,InlayHintLabelPart:Ne.$5K,InlayHintKind:Ne.InlayHintKind,RemoteAuthorityResolverError:Ne.$GK,ResolvedAuthority:Ne.$EK,ManagedResolvedAuthority:Ne.$FK,SourceControlInputBoxValidationType:Ne.SourceControlInputBoxValidationType,ExtensionRuntime:Ne.ExtensionRuntime,TimelineItem:Ne.$6L,NotebookRange:Ne.$XL,NotebookCellKind:Ne.NotebookCellKind,NotebookCellExecutionState:Ne.NotebookCellExecutionState,NotebookCellData:Ne.$YL,NotebookData:Ne.$ZL,NotebookRendererScript:Ne.$4L,NotebookCellStatusBarAlignment:Ne.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Ne.NotebookEditorRevealType,NotebookCellOutput:Ne.$2L,NotebookCellOutputItem:Ne.$1L,NotebookCellStatusBarItem:Ne.$3L,NotebookControllerAffinity:Ne.NotebookControllerAffinity,NotebookControllerAffinity2:Ne.NotebookControllerAffinity2,NotebookEdit:Ne.$IK,NotebookKernelSourceAction:Ne.$5L,PortAttributes:Ne.$8L,LinkedEditingRanges:Ne.$7L,TestResultState:Ne.TestResultState,TestRunRequest:Ne.$9L,TestMessage:Ne.$0L,TestMessage2:Ne.$0L,TestTag:Ne.$$L,TestRunProfileKind:Ne.TestRunProfileKind,TextSearchCompleteMessageType:Wt.TextSearchCompleteMessageType,DataTransfer:Ne.$rL,DataTransferItem:Ne.$nL,CoveredCount:Ne.$_L,FileCoverage:Ne.$aM,StatementCoverage:Ne.$bM,BranchCoverage:Ne.$cM,FunctionCoverage:Ne.$dM,WorkspaceTrustState:Ne.WorkspaceTrustState,LanguageStatusSeverity:Ne.LanguageStatusSeverity,QuickPickItemKind:Ne.QuickPickItemKind,InputBoxValidationSeverity:Ne.InputBoxValidationSeverity,TabInputText:Ne.$fM,TabInputTextDiff:Ne.$gM,TabInputTextMerge:Ne.$hM,TabInputCustom:Ne.$iM,TabInputNotebook:Ne.$kM,TabInputNotebookDiff:Ne.$lM,TabInputWebview:Ne.$jM,TabInputTerminal:Ne.$mM,TabInputInteractiveWindow:Ne.$nM,TabInputChat:Ne.$oM,TelemetryTrustedValue:r.$po,LogLevel:g.LogLevel,EditSessionIdentityMatch:c.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Ne.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:Ne.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:Ne.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Ne.$GL,ThreadFocus:Ne.$HL,RelatedInformationType:Ne.RelatedInformationType,SpeechToTextStatus:Ne.SpeechToTextStatus}}}e.$Yfc=qt}),define(Pe[291],Ae([1,0,70,112,35,110,36,32,61,64,115,117,118,85,87,81,111,63,42,84,59,62,256,15,116,82,83]),function(we,e,y,T,P,M,A,$,E,f,C,D,u,b,v,g,t,i,r,c,o,l,n,s,a,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,y.$Cr)(d.$Nec,d.$Mec,1),(0,y.$Cr)(s.$ej,n.$Zfc,1),(0,y.$Cr)(g.$Ydc,g.$Zdc,1),(0,y.$Cr)($.$WM,$.$VM,0),(0,y.$Cr)(A.$hec,A.$fec,0),(0,y.$Cr)(i.$jec,i.$iec,0),(0,y.$Cr)(D.$Xec,D.$2ec,0),(0,y.$Cr)(M.$4ec,M.$3ec,0),(0,y.$Cr)(E.$LM,E.$KM,0),(0,y.$Cr)(p.$Oec,p.$Pec,0),(0,y.$Cr)(r.$Vdc,r.$Udc,0),(0,y.$Cr)(T.$xfc,T.$wfc,1),(0,y.$Cr)(u.$hfc,u.$ifc,0),(0,y.$Cr)(b.$Cec,b.$Bec,0),(0,y.$Cr)(C.$Kfc,C.$Jfc,0),(0,y.$Cr)(f.$Fec,f.$Iec,0),(0,y.$Cr)(v.$Ywb,v.$Zwb,0),(0,y.$Cr)(t.$Xfc,t.$Wfc,0),(0,y.$Cr)(P.$eec,P.$dec,0),(0,y.$Cr)(c.$Kec,c.$Jec,0),(0,y.$Cr)(o.$UM,o.$RM,0),(0,y.$Cr)(l.$tec,l.$uec,0),(0,y.$Cr)(a.$Vec,a.$Wec,0)}),define(Pe[292],Ae([1,0,290,37,2,287,7,14,275]),function(we,e,y,T,P,M,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0hc=void 0;class f extends M.$3fc{j(){}getModule(b,v){for(const g of this.b){const t=g(b);if(t){b=t;break}}if(this.a.has(b))return this.a.get(b).load(b,v,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class C extends T.$Rec{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(E.$9hc);const b=this.h.invokeFunction(y.$Yfc);this.r=this.h.createInstance(f,b,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub(b){return b.browser}async vb(b,v,g){v=v.with({path:D(v.path,".js")});const t=b?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const i=P.URI.revive(await this.C.$asBrowserUri(v)),r=await fetch(i.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),r.status!==200)throw new Error(r.statusText);const c=await r.text(),o=`${v.toString(!0)}#vscode-extension`,l=`${c}
//# sourceURL=${o}`;let n;try{n=new Function("module","exports","require",l)}catch(p){throw console.error(t?`Loading code for extension ${t} failed: ${p.message}`:`Loading code failed: ${p.message}`),console.error(`${v.toString(!0)}${typeof p.line=="number"?` line ${p.line}`:""}${typeof p.column=="number"?` column ${p.column}`:""}`),console.error(p),p}b&&await this.w.initializeLocalizedMessages(b);const s={},a={exports:s},d=p=>{const m=this.r.getModule(p,v);if(m===void 0)throw new Error(`Cannot load module '${p}'`);return m};try{return g.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),n(a,s,d),a.exports!==s?a.exports:s}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),g.codeLoadingStop()}}async $setRemoteEnvironment(b){}async zb(b=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const v=Date.now()+b;for(;Date.now()<v&&!("__jsDebugIsReady"in globalThis);)await(0,$.$Yg)(10)}}e.$0hc=C;function D(u,b){return u.endsWith(b)?u:u+b}}),define(Pe[293],Ae([1,0,69,70,15,37,200,86,292]),function(we,e,y,T,P,M,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,T.$Cr)(P.$dj,new y.$Sh(A.$2fc,[!0],!0)),(0,T.$Cr)(M.$Sec,E.$0hc,0),(0,T.$Cr)($.$kec,$.$lec,0)}),define(Pe[299],Ae([1,0,24,5,79,288,277,20,88,13,2,291,293]),function(we,e,y,T,P,M,A,$,E,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const D=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const u=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function b(n){return/^(file|vscode-remote):/i.test(n)}const v=fetch.bind(self);function g(n){self.fetch=async function(s,a){return s instanceof Request||b(String(s))&&(s=(await n(C.URI.parse(String(s)))).toString(!0)),v(s,a)},self.XMLHttpRequest=class extends XMLHttpRequest{open(s,a,d,p,m){(async()=>(b(a.toString())&&(a=(await n(C.URI.parse(a.toString()))).toString(!0)),super.open(s,a,d??!0,p,m)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const n=self.Worker;Worker=function(s,a){if(/^file:/i.test(s.toString()))s=f.$gg.uriToBrowserUri(C.URI.parse(s.toString())).toString(!0);else if(/^vscode-remote:/i.test(s.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const p=`(${function(h){function w(V){return typeof V=="string"||V instanceof URL?String(V).replace(/^file:\/\//i,"vscode-file://vscode-app"):V}const I=fetch.bind(self);self.fetch=function(V,Z){return V instanceof Request?I(V,Z):I(w(V),Z)},self.XMLHttpRequest=class extends XMLHttpRequest{open(V,Z,N,R,L){return super.open(V,w(Z),N??!0,R,L)}};const F=importScripts.bind(self);self.importScripts=(...V)=>{F(...V.map(w))},F(h)}.toString()}('${s}'))`;a=a||{},a.name=a.name||$.$mc(s.toString());const m=new Blob([p],{type:"application/javascript"}),S=URL.createObjectURL(m);return new n(S,a)}}else self.Worker=class extends A.$$hc{constructor(n,s){super(u,n,{name:$.$mc(n.toString()),...s})}};const t=new class{constructor(){this.pid=void 0}exit(n){D()}};class i{constructor(){const s=new MessageChannel,a=new T.$Rd;let d=!1;u(s.port2,[s.port2]),s.port1.onmessage=p=>{const{data:m}=p;if(!(m instanceof ArrayBuffer)){console.warn("UNKNOWN data received",m);return}const S=y.$fe.wrap(new Uint8Array(m,0,m.byteLength));if((0,P.$im)(S,2)){d=!0,c("received terminate message from renderer");return}a.fire(S)},this.protocol={onMessage:a.event,send:p=>{if(!d){const m=p.buffer.buffer.slice(p.buffer.byteOffset,p.buffer.byteOffset+p.buffer.byteLength);s.port1.postMessage(m,[m])}}}}}function r(n){return new Promise(s=>{const a=n.onMessage(d=>{a.dispose();const p=JSON.parse(d.toString());n.send((0,P.$hm)(0)),s({protocol:n,initData:p})});n.send((0,P.$hm)(1))})}let c=n=>D();function o(n){return!!n&&typeof n=="object"&&n.type==="vscode.init"&&n.data instanceof Map}function l(){E.mark("code/extHost/willConnectToRenderer");const n=new i;return{onmessage(s){o(s)&&r(n.protocol).then(a=>{E.mark("code/extHost/didWaitForInitData");const d=new M.$5fc(a.protocol,a.initData,t,null,s.data);g(p=>d.asBrowserUri(p)),c=p=>d.terminate(p)})}}}e.create=l})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/444e73750b99b11c3597a5f5d210d2b52257e377/core/vs/workbench/api/worker/extensionHostWorker.js.map
